/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],L=0,R=G.length;L<R;L++)e[L]=te[G[L]];return e};define(te[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const j=new Map,A=new Map,N=new Map,E=new Map;function h(f,S){f.has(S.detail)||f.set(S.detail,-S.timestamp)}function c(f,S){const v=f.get(S.detail);v&&(v>=0||f.set(S.detail,v+S.timestamp))}let P=[];typeof G=="function"&&typeof G.getStats=="function"&&(P=G.getStats().slice(0).sort((f,S)=>f.timestamp-S.timestamp));for(const f of P)switch(f.type){case 10:h(j,f);break;case 11:case 12:c(j,f);break;case 21:h(A,f);break;case 22:c(A,f);break;case 33:h(N,f);break;case 34:c(N,f);break;case 31:h(E,f);break;case 32:c(E,f);break}let I=0;N.forEach(f=>I+=f);function d(f){const S=[];return f.forEach((v,$)=>S.push([$,v])),S}return{amdLoad:d(j),amdInvoke:d(A),nodeRequire:d(N),nodeEval:d(E),nodeRequireTotal:I}}static toMarkdownTable(j,A){let N="";const E=[];return j.forEach((h,c)=>{E[c]=h.length}),A.forEach(h=>{h.forEach((c,P)=>{typeof c>"u"&&(c=h[P]="-");const I=c.toString().length;E[P]=Math.max(I,E[P])})}),j.forEach((h,c)=>{N+=`| ${h+" ".repeat(E[c]-h.toString().length)} `}),N+=`|
`,j.forEach((h,c)=>{N+=`| ${"-".repeat(E[c])} `}),N+=`|
`,A.forEach(h=>{h.forEach((c,P)=>{typeof c<"u"&&(N+=`| ${c+" ".repeat(E[P]-c.toString().length)} `)}),N+=`|
`}),N}}e.$U=L}),define(te[52],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function L(N){return(E,h,c)=>{let P=null,I=null;if(typeof c.value=="function"?(P="value",I=c.value):typeof c.get=="function"&&(P="get",I=c.get),!I)throw new Error("not supported");c[P]=N(I,h)}}function R(N,E,h){let c=null,P=null;if(typeof h.value=="function"?(c="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",P=h.get),!P)throw new Error("not supported");const I=`$memoize$${E}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[I]}}e.$th=R;function j(N,E,h){return L((c,P)=>{const I=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),E&&(this[d]=E(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},N)}})}e.$uh=j;function A(N,E,h){return L((c,P)=>{const I=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,S=`$throttle$pending$${P}`;return function(...v){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),E&&(this[d]=E(this[d],...v)),this[S])return;const $=this[f]+N;$<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},$-Date.now()))}})}e.$vh=A}),define(te[71],ne([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function R(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function j(h,c="Unreachable"){throw new Error(c)}e.$5c=j;function A(h){if(!h)throw new L.$cb("Assertion Failed")}e.$6c=A;function N(h){if(!h()){debugger;h(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$7c=N;function E(h,c){let P=0;for(;P<h.length-1;){const I=h[P],d=h[P+1];if(!c(I,d))return!1;P++}return!0}e.$8c=E}),define(te[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var R;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var j;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(s,o=!1){let t=0;const i=s.length;let n="",r=0,u=16,k=0;function b(se){let ue=0,ce=0;for(;ue<se;){const oe=s.charCodeAt(t);if(oe>=48&&oe<=57)ce=ce*16+oe-48;else if(oe>=65&&oe<=70)ce=ce*16+oe-65+10;else if(oe>=97&&oe<=102)ce=ce*16+oe-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,u=16,k=0}function D(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function H(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=b(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function ee(){if(n="",k=0,r=t,t>=i)return r=i,u=17;let se=s.charCodeAt(t);if(E(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(E(se));return u=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),u=14;switch(se){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,n=H(),u=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),u=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let oe=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,k=1),n=s.substring(ue,t),u=13}return n+=String.fromCharCode(se),t++,u=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),u=11;default:for(;t<i&&_(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return n+=String.fromCharCode(se),t++,u=16}}function _(se){if(E(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=ee();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?re:ee,getToken:()=>u,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$8m=N;function E(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function k(b,w,D,H){r.value=b,r.offset=w,r.length=D,r.type=H,r.colonOffset=void 0,n=r}try{O(s,{onObjectBegin:(b,w)=>{if(o<=b)throw i;n=void 0,u=o>b,t.push("")},onObjectProperty:(b,w,D)=>{if(o<w||(k(b,w,D,"property"),t[t.length-1]=b,o<=w+D))throw i},onObjectEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onArrayBegin:(b,w)=>{if(o<=b)throw i;n=void 0,t.push(0)},onArrayEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onLiteralValue:(b,w,D)=>{if(o<w||(k(b,w,D,y(b)),o<=w+D))throw i},onSeparator:(b,w,D)=>{if(o<=w)throw i;if(b===":"&&n&&n.type==="property")n.colonOffset=w,u=!1,n=void 0;else if(b===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(u=!0,t[t.length-1]=""),n=void 0}}})}catch(b){if(b!==i)throw b}return{path:t,previousNode:n,isAtPropertyKey:u,matches:b=>{let w=0;for(let D=0;w<b.length&&D<t.length;D++)if(b[w]===t[D]||b[w]==="*")w++;else if(b[w]!=="**")return!1;return w===b.length}}}e.$9m=I;function d(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function u(b){Array.isArray(n)?n.push(b):i!==null&&(n[i]=b)}return O(s,{onObjectBegin:()=>{const b={};u(b),r.push(n),n=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const b=[];u(b),r.push(n),n=b,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:u,onError:(b,w,D)=>{o.push({error:b,offset:w,length:D})}},t),n[0]}e.$0m=d;function f(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function r(b){return i.children.push(b),b}O(s,{onObjectBegin:b=>{i=r({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,w,D)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:w,length:D,parent:i})},onObjectEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onArrayBegin:(b,w)=>{i=r({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onLiteralValue:(b,w,D)=>{r({type:y(b),offset:w,length:D,parent:i,value:b}),n(w+D)},onSeparator:(b,w,D)=>{i.type==="property"&&(b===":"?i.colonOffset=w:b===","&&n(w))},onError:(b,w,D)=>{o.push({error:b,offset:w,length:D})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$$m=f;function S(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$_m=S;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$an=v;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$bn=$;function l(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$cn=l;function p(s,o,t=!1){if(l(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=p(i[n],o,t);if(r)return r}return s}}e.$dn=p;function O(s,o,t=A.DEFAULT){const i=N(s,!1);function n(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Y){return Y?K=>Y(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=n(o.onObjectBegin),k=r(o.onObjectProperty),b=n(o.onObjectEnd),w=n(o.onArrayBegin),D=n(o.onArrayEnd),H=r(o.onLiteralValue),ee=r(o.onSeparator),_=n(o.onComment),re=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:se||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Y){case 12:case 13:se?oe(10):_();break;case 16:oe(1);break;case 15:case 14:break;default:return Y}}}function oe(Y,K=[],F=[]){if(re(Y),K.length+F.length>0){let M=i.getToken();for(;M!==17;){if(K.indexOf(M)!==-1){ce();break}else if(F.indexOf(M)!==-1)break;M=ce()}}}function q(Y){const K=i.getTokenValue();return Y?H(K):k(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(oe(2),Y=0)}catch{oe(2)}H(Y);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(ee(":"),ce(),J()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function C(){u(),ce();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),ee(","),ce(),i.getToken()===2&&ue)break}else Y&&oe(6,[],[]);T()||oe(4,[],[2,5]),Y=!0}return b(),i.getToken()!==2?oe(7,[2],[]):ce(),!0}function V(){w(),ce();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),ee(","),ce(),i.getToken()===4&&ue)break}else Y&&oe(6,[],[]);J()||oe(4,[],[4,5]),Y=!0}return D(),i.getToken()!==4?oe(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return V();case 1:return C();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):J()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$en=O;function g(s,o){const t=N(s),i=[];let n,r=0,u;do switch(u=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==u&&i.push(s.substring(r,u)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$fn=g;function y(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$gn=y}),define(te[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.rot=e.$2l=void 0;function L(E,h,c){return Math.min(Math.max(E,h),c)}e.$2l=L;function R(E,h){return(h+E%h)%h}e.rot=R;class j{constructor(){this.a=0}getNext(){return this.a++}}e.$4l=j;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$5l=A;class N{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$6l=N}),function(){function G(j){const A=[];typeof j=="number"&&A.push("code/timeOrigin",j);function N(h){A.push(h,Date.now())}function E(){const h=[];for(let c=0;c<A.length;c+=2)h.push({name:A[c],startTime:A[c+1]});return h}return{mark:N,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(j+N.startTime)});return A}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=L(R))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var R in L)(typeof exports=="object"?exports:G)[R]=L[R]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(R){if(e[R])return e[R].exports;var j=e[R]={i:R,l:!1,exports:{}};return G[R].call(j.exports,j,j.exports,L),j.l=!0,j.exports}return L.m=G,L.c=e,L.d=function(R,j,A){L.o(R,j)||Object.defineProperty(R,j,{enumerable:!0,get:A})},L.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},L.t=function(R,j){if(1&j&&(R=L(R)),8&j||4&j&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&j&&typeof R!="string")for(var N in R)L.d(A,N,function(E){return R[E]}.bind(null,N));return A},L.n=function(R){var j=R&&R.__esModule?function(){return R.default}:function(){return R};return L.d(j,"a",j),j},L.o=function(R,j){return Object.prototype.hasOwnProperty.call(R,j)},L.p="",L(L.s=0)}([function(G,e,L){(function(R){var j;e=G.exports=F,j=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,P=c++;h[P]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[P]+")\\.("+h[P]+")\\.("+h[P]+")";var S=c++;h[S]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var v=c++;h[v]="(?:"+h[P]+"|"+h[d]+")";var $=c++;h[$]="(?:"+h[I]+"|"+h[d]+")";var l=c++;h[l]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var p=c++;h[p]="(?:-?("+h[$]+"(?:\\."+h[$]+")*))";var O=c++;h[O]="[0-9A-Za-z-]+";var g=c++;h[g]="(?:\\+("+h[O]+"(?:\\."+h[O]+")*))";var y=c++,s="v?"+h[f]+h[l]+"?"+h[g]+"?";h[y]="^"+s+"$";var o="[v=\\s]*"+h[S]+h[p]+"?"+h[g]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[P]+"|x|X|\\*";var u=c++;h[u]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[l]+")?"+h[g]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[p]+")?"+h[g]+"?)?)?";var b=c++;h[b]="^"+h[i]+"\\s*"+h[u]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[k]+"$";var D=c++;h[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;h[H]="(?:~>?)";var ee=c++;h[ee]="(\\s*)"+h[H]+"\\s+",E[ee]=new RegExp(h[ee],"g");var _=c++;h[_]="^"+h[H]+h[u]+"$";var re=c++;h[re]="^"+h[H]+h[k]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",E[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[u]+"$";var oe=c++;h[oe]="^"+h[se]+h[k]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[u]+")",E[T]=new RegExp(h[T],"g");var C=c++;h[C]="^\\s*("+h[u]+")\\s+-\\s+("+h[u]+")\\s*$";var V=c++;h[V]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var J=c++;h[J]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)j(Y,h[Y]),E[Y]||(E[Y]=new RegExp(h[Y]));function K(B,Z){if(B instanceof F)return B;if(typeof B!="string"||B.length>A||!(Z?E[t]:E[y]).test(B))return null;try{return new F(B,Z)}catch{return null}}function F(B,Z){if(B instanceof F){if(B.loose===Z)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(B,Z);j("SemVer",B,Z),this.loose=Z;var x=B.trim().match(Z?E[t]:E[y]);if(!x)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<N)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(B,Z){var x=K(B,Z);return x?x.version:null},e.clean=function(B,Z){var x=K(B.trim().replace(/^[=v]+/,""),Z);return x?x.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(B){return j("SemVer.compare",this.version,this.loose,B),B instanceof F||(B=new F(B,this.loose)),this.compareMain(B)||this.comparePre(B)},F.prototype.compareMain=function(B){return B instanceof F||(B=new F(B,this.loose)),a(this.major,B.major)||a(this.minor,B.minor)||a(this.patch,B.patch)},F.prototype.comparePre=function(B){if(B instanceof F||(B=new F(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Z=0;do{var x=this.prerelease[Z],$e=B.prerelease[Z];if(j("prerelease compare",Z,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Z)},F.prototype.inc=function(B,Z){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Z,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new F(B,x).inc(Z,$e).version}catch{return null}},e.diff=function(B,Z){if(Q(B,Z))return null;var x=K(B),$e=K(Z);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var M=/^[0-9]+$/;function a(B,Z){var x=M.test(B),$e=M.test(Z);return x&&$e&&(B=+B,Z=+Z),x&&!$e?-1:$e&&!x?1:B<Z?-1:B>Z?1:0}function m(B,Z,x){return new F(B,x).compare(new F(Z,x))}function z(B,Z,x){return m(B,Z,x)>0}function U(B,Z,x){return m(B,Z,x)<0}function Q(B,Z,x){return m(B,Z,x)===0}function W(B,Z,x){return m(B,Z,x)!==0}function le(B,Z,x){return m(B,Z,x)>=0}function ae(B,Z,x){return m(B,Z,x)<=0}function me(B,Z,x,$e){var ye;switch(Z){case"===":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B===x;break;case"!==":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B!==x;break;case"":case"=":case"==":ye=Q(B,x,$e);break;case"!=":ye=W(B,x,$e);break;case">":ye=z(B,x,$e);break;case">=":ye=le(B,x,$e);break;case"<":ye=U(B,x,$e);break;case"<=":ye=ae(B,x,$e);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function de(B,Z){if(B instanceof de){if(B.loose===Z)return B;B=B.value}if(!(this instanceof de))return new de(B,Z);j("comparator",B,Z),this.loose=Z,this.parse(B),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(B,Z){return a(Z,B)},e.major=function(B,Z){return new F(B,Z).major},e.minor=function(B,Z){return new F(B,Z).minor},e.patch=function(B,Z){return new F(B,Z).patch},e.compare=m,e.compareLoose=function(B,Z){return m(B,Z,!0)},e.rcompare=function(B,Z,x){return m(Z,B,x)},e.sort=function(B,Z){return B.sort(function(x,$e){return e.compare(x,$e,Z)})},e.rsort=function(B,Z){return B.sort(function(x,$e){return e.rcompare(x,$e,Z)})},e.gt=z,e.lt=U,e.eq=Q,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(B,Z){if(B instanceof fe)return B.loose===Z?B:new fe(B.raw,Z);if(B instanceof de)return new fe(B.value,Z);if(!(this instanceof fe))return new fe(B,Z);if(this.loose=Z,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function he(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,Z,x,$e,ye,je,Se,Le,Ie,Ne,Ce,Oe,Re){return((Z=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Z)+" "+(Le=he(Ie)?"":he(Ne)?"<"+(+Ie+1)+".0.0":he(Ce)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Ce+"-"+Oe:"<="+Le)).trim()}function be(B,Z){for(var x=0;x<B.length;x++)if(!B[x].test(Z))return!1;if(Z.prerelease.length){for(x=0;x<B.length;x++)if(j(B[x].semver),B[x].semver!==ge&&B[x].semver.prerelease.length>0){var $e=B[x].semver;if($e.major===Z.major&&$e.minor===Z.minor&&$e.patch===Z.patch)return!0}return!1}return!0}function ke(B,Z,x){try{Z=new fe(Z,x)}catch{return!1}return Z.test(B)}function Fe(B,Z,x,$e){var ye,je,Se,Le,Ie;switch(B=new F(B,$e),Z=new fe(Z,$e),x){case">":ye=z,je=ae,Se=U,Le=">",Ie=">=";break;case"<":ye=U,je=le,Se=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(B,Z,$e))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var Ce=Z.set[Ne],Oe=null,Re=null;if(Ce.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Oe=Oe||ze,Re=Re||ze,ye(ze.semver,Oe.semver,$e)?Oe=ze:Se(ze.semver,Re.semver,$e)&&(Re=ze)}),Oe.operator===Le||Oe.operator===Ie||(!Re.operator||Re.operator===Le)&&je(B,Re.semver)||Re.operator===Ie&&Se(B,Re.semver))return!1}return!0}de.prototype.parse=function(B){var Z=this.loose?E[q]:E[X],x=B.match(Z);if(!x)throw new TypeError("Invalid comparator: "+B);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new F(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(B){return j("Comparator.test",B,this.loose),this.semver===ge||(typeof B=="string"&&(B=new F(B,this.loose)),me(B,this.operator,this.semver,this.loose))},de.prototype.intersects=function(B,Z){if(!(B instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(B.value,Z),ke(this.value,x,Z);if(B.operator==="")return x=new fe(this.value,Z),ke(B.semver,x,Z);var $e=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),je=this.semver.version===B.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Le=me(this.semver,"<",B.semver,Z)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ie=me(this.semver,">",B.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return $e||ye||je&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(B){var Z=this.loose;B=B.trim(),j("range",B,Z);var x=Z?E[V]:E[C];B=B.replace(x,we),j("hyphen replace",B),B=B.replace(E[T],"$1$2$3"),j("comparator trim",B,E[T]),B=(B=(B=B.replace(E[ee],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var $e=Z?E[q]:E[X],ye=B.split(" ").map(function(je){return function(Se,Le){return j("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Re){j("caret",Oe,Re);var ze=Re?E[oe]:E[ce];return Oe.replace(ze,function(Ae,ve,Ee,Pe,De){var Me;return j("caret",Oe,Ae,ve,Ee,Pe,De),he(ve)?Me="":he(Ee)?Me=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Me=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":De?(j("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+De+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+De+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+De+" <"+(+ve+1)+".0.0"):(j("no pr"),Me=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),j("caret return",Me),Me})}(Ce,Ne)}).join(" ")}(Se,Le),j("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Re){var ze=Re?E[re]:E[_];return Oe.replace(ze,function(Ae,ve,Ee,Pe,De){var Me;return j("tilde",Oe,Ae,ve,Ee,Pe,De),he(ve)?Me="":he(Ee)?Me=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Me=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":De?(j("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Me=">="+ve+"."+Ee+"."+Pe+De+" <"+ve+"."+(+Ee+1)+".0"):Me=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",j("tilde return",Me),Me})}(Ce,Ne)}).join(" ")}(Se,Le),j("tildes",Se),Se=function(Ie,Ne){return j("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Ce){return function(Oe,Re){Oe=Oe.trim();var ze=Re?E[w]:E[b];return Oe.replace(ze,function(Ae,ve,Ee,Pe,De,Me){j("xRange",Oe,Ae,ve,Ee,Pe,De,Me);var qe=he(Ee),Ue=qe||he(Pe),Te=Ue||he(De);return ve==="="&&Te&&(ve=""),qe?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ue&&(Pe=0),Te&&(De=0),ve===">"?(ve=">=",Ue?(Ee=+Ee+1,Pe=0,De=0):Te&&(Pe=+Pe+1,De=0)):ve==="<="&&(ve="<",Ue?Ee=+Ee+1:Pe=+Pe+1),Ae=ve+Ee+"."+Pe+"."+De):Ue?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),j("xRange return",Ae),Ae})}(Ce,Ne)}).join(" ")}(Se,Le),j("xrange",Se),Se=function(Ie,Ne){return j("replaceStars",Ie,Ne),Ie.trim().replace(E[J],"")}(Se,Le),j("stars",Se),Se}(je,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(je){return!!je.match($e)})),ye=ye.map(function(je){return new de(je,Z)})},fe.prototype.intersects=function(B,Z){if(!(B instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return B.set.some(function(ye){return ye.every(function(je){return $e.intersects(je,Z)})})})})},e.toComparators=function(B,Z){return new fe(B,Z).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new F(B,this.loose));for(var Z=0;Z<this.set.length;Z++)if(be(this.set[Z],B))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(B,Z,x){var $e=null,ye=null;try{var je=new fe(Z,x)}catch{return null}return B.forEach(function(Se){je.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new F($e=Se,x)))}),$e},e.minSatisfying=function(B,Z,x){var $e=null,ye=null;try{var je=new fe(Z,x)}catch{return null}return B.forEach(function(Se){je.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new F($e=Se,x)))}),$e},e.validRange=function(B,Z){try{return new fe(B,Z).range||"*"}catch{return null}},e.ltr=function(B,Z,x){return Fe(B,Z,"<",x)},e.gtr=function(B,Z,x){return Fe(B,Z,">",x)},e.outside=Fe,e.prerelease=function(B,Z){var x=K(B,Z);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(B,Z,x){return B=new fe(B,x),Z=new fe(Z,x),B.intersects(Z)},e.coerce=function(B){if(B instanceof F)return B;if(typeof B!="string")return null;var Z=B.match(E[D]);return Z==null?null:K((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(G,e){var L,R,j=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function E($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{R=typeof clearTimeout=="function"?clearTimeout:N}catch{R=N}})();var h,c=[],P=!1,I=-1;function d(){P&&h&&(P=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!P){var $=E(d);P=!0;for(var l=c.length;l;){for(h=c,c=[];++I<l;)h&&h[I].run();I=-1,l=c.length}h=null,P=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===N||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}($)}}function S($,l){this.fun=$,this.array=l}function v(){}j.nextTick=function($){var l=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)l[p-1]=arguments[p];c.push(new S($,l)),c.length!==1||P||E(f)},S.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=v,j.addListener=v,j.once=v,j.off=v,j.removeListener=v,j.removeAllListeners=v,j.emit=v,j.prependListener=v,j.prependOnceListener=v,j.listeners=function($){return[]},j.binding=function($){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function($){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class R{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const j=void 0;class A{constructor(E,h=2**16){this.comparator=E,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new R(this.c,j,j)}get size(){return this.f}clear(){this.e=new R(this.c,j,j),this.f=0}has(E){return!!A.g(this,E,this.comparator)}get(E){return A.g(this,E,this.comparator)?.value}set(E,h){return A.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=A.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let P=E.e;for(let I=E.d-1;I>=0;I--)for(;P.forward[I]&&c(P.forward[I].key,h)<0;)P=P.forward[I];if(P=P.forward[0],P&&c(P.key,h)===0)return P}static h(E,h,c,P){const I=[];let d=E.e;for(let f=E.d-1;f>=0;f--){for(;d.forward[f]&&P(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&P(d.key,h)===0)return d.value=c,!1;{const f=A.j(E);if(f>E.d){for(let S=E.d;S<f;S++)I[S]=E.e;E.d=f}d=new R(f,h,c);for(let S=0;S<f;S++)d.forward[S]=I[S].forward[S],I[S].forward[S]=d;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const P=[];let I=E.e;for(let d=E.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];P[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<E.d&&P[d].forward[d]===I;d++)P[d].forward[d]=I.forward[d];for(;E.d>0&&E.e.forward[E.d-1]===j;)E.d-=1;return!0}}e.$Lr=A}),define(te[45],ne([0,1,9,2]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function j(g){const y=g;return y?typeof y.read=="function":!1}e.$4d=j;function A(g){const y=g;return y?[y.on,y.pause,y.resume,y.destroy].every(s=>typeof s=="function"):!1}e.$5d=A;function N(g){const y=g;return y?A(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$6d=N;function E(g,y){return new h(g,y)}e.$7d=E;class h{constructor(y,s){this.e=y,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(s=>s(y))}h(y){this.c.error.length===0?(0,L.$1)(y):this.c.error.slice(0).forEach(s=>s(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,s){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(y,s){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,y){const s=[];let o;for(;(o=g.read())!==null;)s.push(o);return y(s)}e.$8d=c;function P(g,y,s){const o=[];let t;for(;(t=g.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.$9d=P;function I(g,y){return new Promise((s,o)=>{const t=[];d(g,{onData:i=>{y&&t.push(i)},onError:i=>{y?o(i):s(void 0)},onEnd:()=>{s(y?y(t):void 0)}})})}e.$0d=I;function d(g,y,s){g.on("error",o=>{s?.isCancellationRequested||y.onError(o)}),g.on("end",()=>{s?.isCancellationRequested||y.onEnd()}),g.on("data",o=>{s?.isCancellationRequested||y.onData(o)})}e.$$d=d;function f(g,y){return new Promise((s,o)=>{const t=new R.$Rc,i=[],n=k=>{if(i.push(k),i.length>y)return t.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),u=()=>(t.dispose(),s({stream:g,buffer:i,ended:!0}));t.add((0,R.$Qc)(()=>g.removeListener("error",r))),g.on("error",r),t.add((0,R.$Qc)(()=>g.removeListener("end",u))),g.on("end",u),t.add((0,R.$Qc)(()=>g.removeListener("data",n))),g.on("data",n)})}e.$_d=f;function S(g,y){const s=E(y);return s.end(g),s}e.$ae=S;function v(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.$be=v;function $(g){let y=!1;return{read:()=>y?null:(y=!0,g)}}e.$ce=$;function l(g,y,s){const o=E(s);return d(g,{onData:t=>o.write(y.data(t)),onError:t=>o.error(y.error?y.error(t):t),onEnd:()=>o.end()}),o}e.$de=l;function p(g,y,s){let o=!1;return{read:()=>{const t=y.read();return o?t:(o=!0,t!==null?s([g,t]):g)}}}e.$ee=p;function O(g,y,s){let o=!1;const t=E(s);return d(y,{onData:i=>o?t.write(i):(o=!0,t.write(s([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.$fe=O}),define(te[14],ne([0,1,164,45]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const j=typeof Buffer<"u",A=new L.$V(()=>new Uint8Array(256));let N,E;class h{static alloc(D){return j?new h(Buffer.allocUnsafe(D)):new h(new Uint8Array(D))}static wrap(D){return j&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new h(D)}static fromString(D,H){return!(H?.dontUseNodeBuffer||!1)&&j?new h(Buffer.from(D)):(N||(N=new TextEncoder),new h(N.encode(D)))}static fromByteArray(D){const H=h.alloc(D.length);for(let ee=0,_=D.length;ee<_;ee++)H.buffer[ee]=D[ee];return H}static concat(D,H){if(typeof H>"u"){H=0;for(let re=0,se=D.length;re<se;re++)H+=D[re].byteLength}const ee=h.alloc(H);let _=0;for(let re=0,se=D.length;re<se;re++){const ue=D[re];ee.set(ue,_),_+=ue.byteLength}return ee}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=h.alloc(this.byteLength);return D.set(this),D}toString(){return j?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(D,H){return new h(this.buffer.subarray(D,H))}set(D,H){if(D instanceof h)this.buffer.set(D.buffer,H);else if(D instanceof Uint8Array)this.buffer.set(D,H);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),H);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return d(this.buffer,D)}writeUInt32BE(D,H){f(this.buffer,D,H)}readUInt32LE(D){return S(this.buffer,D)}writeUInt32LE(D,H){v(this.buffer,D,H)}readUInt8(D){return $(this.buffer,D)}writeUInt8(D,H){l(this.buffer,D,H)}indexOf(D,H=0){return c(this.buffer,D instanceof h?D.buffer:D,H)}}e.$ge=h;function c(w,D,H=0){const ee=D.byteLength,_=w.byteLength;if(ee===0)return 0;if(ee===1)return w.indexOf(D[0]);if(ee>_-H)return-1;const re=A.value;re.fill(D.length);for(let oe=0;oe<D.length;oe++)re[D[oe]]=D.length-oe-1;let se=H+D.length-1,ue=se,ce=-1;for(;se<_;)if(w[se]===D[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(D.length-ue,re[w[se]]),ue=D.length-1;return ce}e.$he=c;function P(w,D){return w[D+0]<<0>>>0|w[D+1]<<8>>>0}e.$ie=P;function I(w,D,H){w[H+0]=D&255,D=D>>>8,w[H+1]=D&255}e.$je=I;function d(w,D){return w[D]*2**24+w[D+1]*2**16+w[D+2]*2**8+w[D+3]}e.$ke=d;function f(w,D,H){w[H+3]=D,D=D>>>8,w[H+2]=D,D=D>>>8,w[H+1]=D,D=D>>>8,w[H]=D}e.$le=f;function S(w,D){return w[D+0]<<0>>>0|w[D+1]<<8>>>0|w[D+2]<<16>>>0|w[D+3]<<24>>>0}e.$me=S;function v(w,D,H){w[H+0]=D&255,D=D>>>8,w[H+1]=D&255,D=D>>>8,w[H+2]=D&255,D=D>>>8,w[H+3]=D&255}e.$ne=v;function $(w,D){return w[D]}e.$oe=$;function l(w,D,H){w[H]=D}e.$pe=l;function p(w){return R.$8d(w,D=>h.concat(D))}e.$qe=p;function O(w){return R.$ce(w)}e.$re=O;function g(w){return R.$0d(w,D=>h.concat(D))}e.$se=g;async function y(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await g(w.stream)])}e.$te=y;function s(w){return R.$ae(w,D=>h.concat(D))}e.$ue=s;function o(w){return R.$de(w,{data:D=>typeof D=="string"?h.fromString(D):h.wrap(D)},D=>h.concat(D))}e.$ve=o;function t(w){return R.$7d(D=>h.concat(D),w)}e.$we=t;function i(w,D){return R.$ee(w,D,H=>h.concat(H))}e.$xe=i;function n(w,D){return R.$fe(w,D,H=>h.concat(H))}e.$ye=n;function r(w){let D=0,H=0,ee=0;const _=new Uint8Array(Math.floor(w.length/4*3)),re=ue=>{switch(H){case 3:_[ee++]=D|ue,H=0;break;case 2:_[ee++]=D|ue>>>2,D=ue<<6,H=3;break;case 1:_[ee++]=D|ue>>>4,D=ue<<4,H=2;break;default:D=ue<<2,H=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)re(ce-65);else if(ce>=97&&ce<=122)re(ce-97+26);else if(ce>=48&&ce<=57)re(ce-48+52);else if(ce===43||ce===45)re(62);else if(ce===47||ce===95)re(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=ee;for(;H>0;)re(0);return h.wrap(_).slice(0,se)}e.$ze=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:w},D=!0,H=!1){const ee=H?k:u;let _="";const re=w.byteLength%3;let se=0;for(;se<w.byteLength-re;se+=3){const ue=w[se+0],ce=w[se+1],oe=w[se+2];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[(ce<<2|oe>>>6)&63],_+=ee[oe&63]}if(re===1){const ue=w[se+0];_+=ee[ue>>>2],_+=ee[ue<<4&63],D&&(_+="==")}else if(re===2){const ue=w[se+0],ce=w[se+1];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[ce<<2&63],D&&(_+="=")}return _}e.$Ae=b}),define(te[41],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function R(l){return j(l,0)}e.$Pi=R;function j(l,p){switch(typeof l){case"object":return l===null?A(349,p):Array.isArray(l)?h(l,p):c(l,p);case"string":return E(l,p);case"boolean":return N(l,p);case"number":return A(l,p);case"undefined":return A(937,p);default:return A(617,p)}}e.$Qi=j;function A(l,p){return(p<<5)-p+l|0}e.$Ri=A;function N(l,p){return A(l?433:863,p)}function E(l,p){p=A(149417,p);for(let O=0,g=l.length;O<g;O++)p=A(l.charCodeAt(O),p);return p}e.$Si=E;function h(l,p){return p=A(104579,p),l.reduce((O,g)=>j(g,O),p)}function c(l,p){return p=A(181387,p),Object.keys(l).sort().reduce((O,g)=>(O=E(g,O),j(l[g],O)),p)}class P{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=j(p,this.g),this.g}}e.$Ti=P;var I;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(l,p,O=32){const g=O-p,y=~((1<<g)-1);return(l<<p|(y&l)>>>g)>>>0}function f(l,p=0,O=l.byteLength,g=0){for(let y=0;y<O;y++)l[p+y]=g}function S(l,p,O="0"){for(;l.length<p;)l=O+l;return l}function v(l,p=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(O=>O.toString(16).padStart(2,"0")).join(""):S((l>>>0).toString(16),p/4)}e.$Ui=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const O=p.length;if(O===0)return;const g=this.p;let y=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=p.charCodeAt(0),t=0);;){let i=o;if(L.$_e(o))if(t+1<O){const n=p.charCodeAt(t+1);L.$af(n)?(t++,i=L.$bf(o,n)):i=65533}else{s=o;break}else L.$af(o)&&(i=65533);if(y=this.w(g,y,i),t++,t<O)o=p.charCodeAt(t);else break}this.r=y,this.u=s}w(p,O,g){return g<128?p[O++]=g:g<2048?(p[O++]=192|(g&1984)>>>6,p[O++]=128|(g&63)>>>0):g<65536?(p[O++]=224|(g&61440)>>>12,p[O++]=128|(g&4032)>>>6,p[O++]=128|(g&63)>>>0):(p[O++]=240|(g&1835008)>>>18,p[O++]=128|(g&258048)>>>12,p[O++]=128|(g&4032)>>>6,p[O++]=128|(g&63)>>>0),O>=64&&(this.y(),O-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=$.g,O=this.q;for(let u=0;u<64;u+=4)p.setUint32(u,O.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,d(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let g=this.h,y=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let u=0;u<80;u++)u<20?(i=y&s|~y&o,n=1518500249):u<40?(i=y^s^o,n=1859775393):u<60?(i=y&s|y&o|s&o,n=2400959708):(i=y^s^o,n=3395469782),r=d(g,5)+i+t+n+p.getUint32(u*4,!1)&4294967295,t=o,o=s,s=d(y,30),y=g,g=r;this.h=this.h+g&4294967295,this.l=this.l+y&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Vi=$}),define(te[54],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(R||(R={})),function(j){const A="error",N="warning",E="warn",h="info",c="ignore";function P(d){return d?L.$8e(A,d)?j.Error:L.$8e(N,d)||L.$8e(E,d)?j.Warning:L.$8e(h,d)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function I(d){switch(d){case j.Error:return A;case j.Warning:return N;case j.Info:return h;default:return c}}j.toString=I}(R||(R={})),e.default=R}),define(te[30],ne([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const p=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([O,g])=>{p[O]=g&&typeof g=="object"?R(g):g}),p}e.$hn=R;function j(l){if(!l||typeof l!="object")return l;const p=[l];for(;p.length>0;){const O=p.shift();Object.freeze(O);for(const g in O)if(A.call(O,g)){const y=O[g];typeof y=="object"&&!Object.isFrozen(y)&&!(0,L.$Hf)(y)&&p.push(y)}}return l}e.$in=j;const A=Object.prototype.hasOwnProperty;function N(l,p){return E(l,p,new Set)}e.$jn=N;function E(l,p,O){if((0,L.$Nf)(l))return l;const g=p(l);if(typeof g<"u")return g;if(Array.isArray(l)){const y=[];for(const s of l)y.push(E(s,p,O));return y}if((0,L.$Gf)(l)){if(O.has(l))throw new Error("Cannot clone recursive data-structure");O.add(l);const y={};for(const s in l)A.call(l,s)&&(y[s]=E(l[s],p,O));return O.delete(l),y}return l}function h(l,p,O=!0){return(0,L.$Gf)(l)?((0,L.$Gf)(p)&&Object.keys(p).forEach(g=>{g in l?O&&((0,L.$Gf)(l[g])&&(0,L.$Gf)(p[g])?h(l[g],p[g],O):l[g]=p[g]):l[g]=p[g]}),l):p}e.$kn=h;function c(l,p){if(l===p)return!0;if(l==null||p===null||p===void 0||typeof l!=typeof p||typeof l!="object"||Array.isArray(l)!==Array.isArray(p))return!1;let O,g;if(Array.isArray(l)){if(l.length!==p.length)return!1;for(O=0;O<l.length;O++)if(!c(l[O],p[O]))return!1}else{const y=[];for(g in l)y.push(g);y.sort();const s=[];for(g in p)s.push(g);if(s.sort(),!c(y,s))return!1;for(O=0;O<y.length;O++)if(!c(l[y[O]],p[y[O]]))return!1}return!0}e.$ln=c;function P(l){const p=new Set;return JSON.stringify(l,(O,g)=>{if((0,L.$Gf)(g)||Array.isArray(g)){if(p.has(g))return"[Circular]";p.add(g)}return g})}e.$mn=P;function I(l,p){const O=Object.create(null);return!l||!p||Object.keys(p).forEach(y=>{const s=l[y],o=p[y];c(s,o)||(O[y]=o)}),O}e.$nn=I;function d(l,p){const O=p.toLowerCase(),g=Object.keys(l).find(y=>y.toLowerCase()===O);return g?l[g]:l[p]}e.$on=d;function f(l,p){const O=Object.create(null);for(const[g,y]of Object.entries(l))p(g,y)&&(O[g]=y);return O}e.$pn=f;function S(l){let p=[];for(;Object.prototype!==l;)p=p.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return p}e.$qn=S;function v(l){const p=[];for(const O of S(l))typeof l[O]=="function"&&p.push(O);return p}e.$rn=v;function $(l,p){const O=y=>function(){const s=Array.prototype.slice.call(arguments,0);return p(y,s)},g={};for(const y of l)g[y]=O(y);return g}e.$sn=$}),define(te[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(j){return L.test(j)}e.$lg=R,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),N=[];for(let E=0;E<256;E++)N.push(E.toString(16).padStart(2,"0"));return function(){j(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,c="";return c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c}}()}),define(te[74],ne([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(N){const E=N.replace(/\-/g,":").toLowerCase();return!R.has(E)}function A(){const N=(0,L.networkInterfaces)();for(const E in N){const h=N[E];if(h){for(const{mac:c}of h)if(j(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$4m=A}),define(te[75],ne([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0;const R=60,j=R*60,A=j*24,N=A*7,E=A*30,h=A*365;function c(I,d,f,S){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!S&&v<30)return(0,L.localize)(1,null);let $;return v<R?($=v,d?$===1?f?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):f?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?f?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):f?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<j?($=Math.floor(v/R),d?$===1?f?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):f?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?f?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):f?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<A?($=Math.floor(v/j),d?$===1?f?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):f?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?f?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):f?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<N?($=Math.floor(v/A),d?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<E?($=Math.floor(v/N),d?$===1?f?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):f?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?f?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):f?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<h?($=Math.floor(v/E),d?$===1?f?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):f?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?f?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):f?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/h),d?$===1?f?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):f?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?f?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):f?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$qm=c;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$rm=P}),define(te[77],ne([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function A(I,d){return d&&(I.stack||I.stacktrace)?j.localize(0,null,E(I),N(I.stack)||N(I.stacktrace)):E(I)}function N(I){return Array.isArray(I)?I.join(`
`):I}function E(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?j.localize(1,null,I.message):I.message||j.localize(2,null)}function h(I=null,d=!1){if(!I)return j.localize(3,null);if(Array.isArray(I)){const f=L.$Hb(I),S=h(f[0],d);return f.length>1?j.localize(4,null,S,f.length):S}if(R.$Ef(I))return I;if(I.detail){const f=I.detail;if(f.error)return A(f.error,d);if(f.exception)return A(f.exception,d)}return I.stack?A(I,d):I.message?I.message:j.localize(5,null)}e.$Mi=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Ni=c;function P(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Oi=P}),define(te[78],ne([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function R(j){switch(j){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Jp=R}),define(te[55],ne([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var j;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function A(E,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<P.length;f++)if(d.search(P[f])!==-1){delete E[d];break}})}e.$Ml=A;function N(E){E&&(delete E.DEBUG,L.$j&&delete E.DYLD_LIBRARY_PATH,L.$k&&delete E.LD_PRELOAD)}e.$Nl=N}),define(te[80],ne([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$aq=e.$_p=e.$$p=void 0;function R(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$$p=R;function j(c){const P=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:I}}e.$_p=j;function A(c){if(typeof c!="string")return A(j(c).stack);const P=c;if(P){const I=N(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$aq=A;function N(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function E(c,P){const{args:I,stack:d}=j(c),f=typeof I[0]=="string"&&I.length===1;let S=N(d);S&&(S=`(${S.trim()})`);let v=[];if(typeof I[0]=="string"?S&&f?v=[`%c[${P}] %c${I[0]} %c${S}`,h("blue"),h(""),h("grey")]:v=[`%c[${P}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:v=[`%c[${P}]%`,h("blue"),...I],S&&!f&&v.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=E;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function j(h){return JSON.stringify(h,N)}e.$wh=j;function A(h){let c=JSON.parse(h);return c=E(c),c}e.$xh=A;function N(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return R.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$ge||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=E(h[P],c+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=E(h[P],c+1))}return h}e.$yh=E}),define(te[81],ne([0,1,70,15,13,11]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=void 0;class N{constructor(d,f,S){this.id=d,this.dependencies=f,this.callback=S}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,S)=>{typeof d!="string"&&(S=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(S=f,f=null),this.c.push(new N(d,f,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,S)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",l),v.removeEventListener("error",p)},l=O=>{$(),f(this.c.pop())},p=O=>{$(),S(O)};v.addEventListener("load",l),v.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),v.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(v)})}i(d){return new Promise((f,S)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(v){S(v)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(d).fsPath,l=f.readFileSync($).toString(),p=v.wrap(l.replace(/^#!.*/,""));return new S.Script(p).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function P(I,d,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const S=`${I}/${d}`;if(h.has(S))return h.get(S);let v;if(/^\w[\w\d+.-]*:\/\//.test(S))v=S;else{const O=`${f&&!j.$o?R.$hg:R.$gg}/${S}`;v=R.$kg.asBrowserUri(O).toString(!0)}const $=E.INSTANCE.load(v);return h.set(S,$),$}else return await new Promise((S,v)=>{G([I],S,v)})}e.$YC=P}),define(te[82],ne([0,1,33,47,28,74,13]),function(G,e,L,R,j,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=void 0,e.$5m=new class{c(d){return this.a||(this.a=R.$8h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const S=(0,L.networkInterfaces)();for(const v in S){const $=S[v];if($)for(const{mac:l,internal:p}of $)p||(f+=1,this.c(l.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let E;async function h(d){return E||(E=(async()=>await c(d)||j.$mg())()),E}e.$6m=h;async function c(d){try{const f=await new Promise((v,$)=>{G(["crypto"],v,$)}),S=(0,A.$4m)();return f.createHash("sha256").update(S,"utf8").digest("hex")}catch(f){d(f);return}}const P="Software\\Microsoft\\SQMClient";async function I(d){if(N.$i){const f=await new Promise((S,v)=>{G(["@vscode/windows-registry"],S,v)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(S){return d(S),""}}return""}e.$7m=I}),define(te[83],ne([0,1,33,16,24]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class I{constructor(y,s,o){this.exePath=y,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await j.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:g=!1,findPreview:y=!1}={}){const s=d({useAlternateBitness:g});if(!s)return null;const o=R.$jc(s,"PowerShell");if(!await j.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const u of await j.Promises.readdir(o)){let k=-1;if(y){const w=u.indexOf("-");if(w<0)continue;const D=u.substring(0,w);if(!A.test(D)||u.substring(w+1)!=="preview")continue;k=parseInt(D,10)}else{if(!A.test(u))continue;k=parseInt(u,10)}if(k<=t)continue;const b=R.$jc(o,u,"pwsh.exe");await j.SymlinkSupport.existsFile(b)&&(i=b,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=y?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function S({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const y=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await j.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await j.Promises.readdir(y))if(s.test(t)){const i=R.$jc(y,t,"pwsh.exe");return new I(i,o)}return null}function v(){const g=R.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new I(g,".NET Core PowerShell Global Tool")}function $(){const g=R.$jc(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(g,"Windows PowerShell",!0)}async function*l(){let g=await f();g&&(yield g),g=await f({useAlternateBitness:!0}),g&&(yield g),g=await S(),g&&(yield g),g=v(),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await S({findPreview:!0}),g&&(yield g),g=await f({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=$(),g&&(yield g)}async function*p(){for await(const g of l())await g.exists()&&(yield g)}e.$Kl=p;async function O(){for await(const g of p())return g;return null}e.$Ll=O}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(G,e,L,R,j,A,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(I=j.env){return I.comspec||"cmd.exe"}e.$Ol=h;function c(I){let d=[],f=!1;const S=function(v){if(f){d.push(v);return}(!I.send(v,l=>{if(l&&console.error(l),f=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(O=>S(O))}})||R.$i)&&(f=!0)};return{send:S}}e.$Pl=c;var P;(function(I){async function d(f,S,v){if(L.$ic(f))return f;if(S===void 0&&(S=j.cwd()),L.$mc(f)!=="."||(v===void 0&&N.$Ef(j.env.PATH)&&(v=j.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(S,f);async function l(p){if(await E.Promises.exists(p)){let O;try{O=await E.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(O=await E.Promises.lstat(p))}return O?!O.isDirectory():!1}return!1}for(const p of v){let O;if(L.$ic(p)?O=L.$jc(p,f):O=L.$jc(S,p,f),await l(O))return O;let g=O+".com";if(await l(g)||(g=O+".exe",await l(g)))return g}return L.$jc(S,f)}I.findExecutable=d})(P||(e.win32=P={}))}),define(te[84],ne([0,1,33,13,83,56]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=void 0;async function N(I,d){return I===1?R.$i?P():A.$Ol(d):h(I,d)}e.$Ql=N;let E=null;function h(I,d){if(R.$k&&I===2||R.$j&&I===3)return"/bin/bash";if(!E){let f;if(R.$i)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}E=f}return E}let c=null;async function P(){return c||(c=(await(0,j.$Ll)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,R){var j=arguments.length,A=j<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,L):R,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,L,R);else for(var E=G.length-1;E>=0;E--)(N=G[E])&&(A=(j<3?N(A):j>3?N(e,L,A):N(e,L))||A);return j>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,R,j,A,N,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(l||(l={}));function p(T){let C=0;for(let V=0;;V+=7){const J=T.read(1);if(C|=(J.buffer[0]&127)<<V,!(J.buffer[0]&128))return C}}const O=t(0);function g(T,C){if(C===0){T.write(O);return}let V=0;for(let Y=C;Y!==0;Y=Y>>>7)V++;const J=j.$ge.alloc(V);for(let Y=0;C!==0;Y++)J.buffer[Y]=C&127,C=C>>>7,C>0&&(J.buffer[Y]|=128);T.write(J)}class y{constructor(C){this.b=C,this.a=0}read(C){const V=this.b.slice(this.a,this.a+C);return this.a+=V.byteLength,V}}e.$zh=y;class s{constructor(){this.a=[]}get buffer(){return j.$ge.concat(this.a)}write(C){this.a.push(C)}}e.$Ah=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const C=j.$ge.alloc(1);return C.writeUInt8(T,0),C}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,C){if(typeof C>"u")T.write(i.Undefined);else if(typeof C=="string"){const V=j.$ge.fromString(C);T.write(i.String),g(T,V.byteLength),T.write(V)}else if(n&&Buffer.isBuffer(C)){const V=j.$ge.wrap(C);T.write(i.Buffer),g(T,V.byteLength),T.write(V)}else if(C instanceof j.$ge)T.write(i.VSBuffer),g(T,C.byteLength),T.write(C);else if(Array.isArray(C)){T.write(i.Array),g(T,C.length);for(const V of C)r(T,V)}else if(typeof C=="number"&&(C|0)===C)T.write(i.Uint),g(T,C);else{const V=j.$ge.fromString(JSON.stringify(C));T.write(i.Object),g(T,V.byteLength),T.write(V)}}e.$Bh=r;function u(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(p(T)).toString();case o.Buffer:return T.read(p(T)).buffer;case o.VSBuffer:return T.read(p(T));case o.Array:{const V=p(T),J=[];for(let Y=0;Y<V;Y++)J.push(u(T));return J}case o.Object:return JSON.parse(T.read(p(T)).toString());case o.Int:return p(T)}}e.$Ch=u;class k{constructor(C,V,J=null,Y=1e3){this.h=C,this.j=V,this.k=J,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(C,V){this.b.set(C,V),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const V=this.o([C.type]);this.k?.logOutgoing(V,0,1,$(C.type));return}case 201:case 202:case 204:case 203:{const V=this.o([C.type,C.id],C.data);this.k?.logOutgoing(V,C.id,1,$(C.type),C.data);return}}}o(C,V=void 0){const J=new s;return r(J,C),r(J,V),this.p(J.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const V=new y(C),J=u(V),Y=u(V),K=J[0];switch(K){case 100:return this.k?.logIncoming(C.byteLength,J[1],1,`${S(K)}: ${J[2]}.${J[3]}`,Y),this.s({type:K,id:J[1],channelName:J[2],name:J[3],arg:Y});case 102:return this.k?.logIncoming(C.byteLength,J[1],1,`${S(K)}: ${J[2]}.${J[3]}`,Y),this.t({type:K,id:J[1],channelName:J[2],name:J[3],arg:Y});case 101:return this.k?.logIncoming(C.byteLength,J[1],1,`${S(K)}`),this.u({type:K,id:J[1]});case 103:return this.k?.logIncoming(C.byteLength,J[1],1,`${S(K)}`),this.u({type:K,id:J[1]})}}s(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const J=new A.$3d;let Y;try{Y=V.call(this.j,C.name,C.arg,J.token)}catch(M){Y=Promise.reject(M)}const K=C.id;Y.then(M=>{this.m({id:K,data:M,type:201})},M=>{M instanceof Error?this.m({id:K,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:K,data:M,type:203})}).finally(()=>{F.dispose(),this.d.delete(C.id)});const F=(0,c.$Qc)(()=>J.cancel());this.d.set(C.id,F)}t(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const J=C.id,K=V.listen(this.j,C.name,C.arg)(F=>this.m({id:J,data:F,type:204}));this.d.set(C.id,K)}u(C){const V=this.d.get(C.id);V&&(V.dispose(),this.d.delete(C.id))}v(C){let V=this.g.get(C.channelName);V||(V=[],this.g.set(C.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:C,timeoutTimer:J})}w(C){const V=this.g.get(C);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=k;var b;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class w{constructor(C,V=null){this.l=C,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=V}getChannel(C){const V=this;return{call(J,Y,K){return V.a?Promise.reject(new E.$5):V.m(C,J,Y,K)},listen(J,Y){return V.a?h.Event.None:V.o(C,J,Y)}}}m(C,V,J,Y=A.CancellationToken.None){const K=this.g++,M={id:K,type:100,channelName:C,name:V,arg:J};if(Y.isCancellationRequested)return Promise.reject(new E.$5);let a;return new Promise((z,U)=>{if(Y.isCancellationRequested)return U(new E.$5);const Q=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),z(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.f.delete(K),U(de.data);break}};this.f.set(K,me),this.p(M)};let W=null;this.b===l.Idle?Q():(W=(0,R.$Pg)(me=>this.u()),W.then(()=>{W=null,Q()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),U(new E.$5)},ae=Y.onCancellationRequested(le);a=(0,c.$Pc)((0,c.$Qc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(C,V,J){const Y=this.g++,F={id:Y,type:102,channelName:C,name:V,arg:J};let M=null;const a=new h.$Sd({onWillAddFirstListener:()=>{M=(0,R.$Pg)(z=>this.u()),M.then(()=>{M=null,this.d.add(a),this.p(F)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(a),this.p({id:Y,type:103}))}}),m=z=>a.fire(z.data);return this.f.set(Y,m),a.event}p(C){switch(C.type){case 100:case 102:{const V=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(V,C.id,0,`${S(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const V=this.q([C.type,C.id]);this.j?.logOutgoing(V,C.id,0,S(C.type));return}}}q(C,V=void 0){const J=new s;return r(J,C),r(J,V),this.r(J.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const V=new y(C),J=u(V),Y=u(V),K=J[0];switch(K){case 200:return this.j?.logIncoming(C.byteLength,0,0,$(K)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,J[1],0,$(K),Y),this.t({type:J[0],id:J[1],data:Y})}}t(C){if(C.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=w,pe([N.$th],w.prototype,"onDidInitializePromise",null);class D{get connections(){const C=[];return this.f.forEach(V=>C.push(V)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new h.$Sd,this.onDidAddConnection=this.g.event,this.h=new h.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(C(({protocol:V,onDidClientDisconnect:J})=>{const Y=h.Event.once(V.onMessage);this.j.add(Y(K=>{const F=new y(K),M=u(F),a=new k(V,M),m=new w(V);this.a.forEach((U,Q)=>a.registerChannel(Q,U));const z={channelServer:a,channelClient:m,ctx:M};this.f.add(z),this.g.fire(z),this.j.add(J(()=>{a.dispose(),m.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(C,V){const J=this;return{call(Y,K,F){let M;if((0,d.$Sf)(V)){const m=(0,L.$4b)(J.connections.filter(V));M=m?Promise.resolve(m):h.Event.toPromise(h.Event.filter(J.onDidAddConnection,V))}else M=V.routeCall(J,Y,K);const a=M.then(m=>m.channelClient.getChannel(C));return ee(a).call(Y,K,F)},listen(Y,K){if((0,d.$Sf)(V))return J.k(C,V,Y,K);const F=V.routeEvent(J,Y,K).then(M=>M.channelClient.getChannel(C));return ee(F).listen(Y,K)}}}k(C,V,J,Y){const K=this;let F;const M=new h.$Sd({onWillAddFirstListener:()=>{F=new c.$Rc;const a=new h.$Yd,m=new Map,z=Q=>{const le=Q.channelClient.getChannel(C).listen(J,Y),ae=a.add(le);m.set(Q,ae)},U=Q=>{const W=m.get(Q);W&&(W.dispose(),m.delete(Q))};K.connections.filter(V).forEach(z),h.Event.filter(K.onDidAddConnection,V)(z,void 0,F),K.onDidRemoveConnection(U,void 0,F),a.event(M.fire,M,F),F.add(a)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return M.event}registerChannel(C,V){this.a.set(C,V);for(const J of this.f)J.channelServer.registerChannel(C,V)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=D;class H{constructor(C,V,J=null){const Y=new s;r(Y,V),C.send(Y.buffer),this.a=new w(C,J),this.d=new k(C,V,J)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,V){this.d.registerChannel(C,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=H;function ee(T){return{call(C,V,J){return T.then(Y=>Y.call(C,V,J))},listen(C,V){const J=new h.$2d;return T.then(Y=>J.input=Y.listen(C,V)),J.event}}}e.$Hh=ee;function _(T){let C=!1;return{call(V,J,Y){return C?T.call(V,J,Y):(0,R.$3g)(0).then(()=>C=!0).then(()=>T.call(V,J,Y))},listen(V,J){if(C)return T.listen(V,J);const Y=new h.$2d;return(0,R.$3g)(0).then(()=>C=!0).then(()=>Y.input=T.listen(V,J)),Y.event}}}e.$Ih=_;class re{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const V of C.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await h.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$Jh=re;var se;(function(T){function C(K,F,M){const a=K,m=M&&M.disableMarshalling,z=new Map;for(const U in a)J(U)&&z.set(U,h.Event.buffer(a[U],!0,void 0,F));return new class{listen(U,Q,W){const le=z.get(Q);if(le)return le;if(Y(Q)){const ae=a[Q];if(typeof ae=="function")return ae.call(a,W)}throw new E.$bb(`Event not found: ${Q}`)}call(U,Q,W){const le=a[Q];if(typeof le=="function"){if(!m&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,P.$yh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${Q}`)}}}T.fromService=C;function V(K,F){const M=F&&F.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):Y(m)?function(z){return K.listen(m,z)}:J(m)?K.listen(m):async function(...z){let U;F&&!(0,d.$Nf)(F.context)?U=[F.context,...z]:U=z;const Q=await K.call(m,U);return M?Q:(0,P.$yh)(Q)};throw new E.$bb(`Property not found: ${String(m)}`)}})}T.toService=V;function J(K){return K[0]==="o"&&K[1]==="n"&&I.$7e(K.charCodeAt(2))}function Y(K){return/^onDynamic/.test(K)&&I.$7e(K.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const C=T.toString();if(C!=="[object Object]")return C}return T}function oe(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,C,V,J,Y,K,F){F=oe(F);const M=ue[Y],a=M[J%M.length];let m=[`%c[${T}]%c[${String(C).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class X{constructor(C,V){this.d=C,this.f=V,this.a=0,this.b=0}logOutgoing(C,V,J,Y,K){this.b+=C,q(this.d,this.b,C,V,J,Y,K)}logIncoming(C,V,J,Y,K){this.a+=C,q(this.f,this.a,C,V,J,Y,K)}}e.$Kh=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class S extends f.$Dh{constructor(l){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>j.$ge.wrap(Buffer.from(p,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$cq=S;class v{constructor(l,p){this.i=l,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$Sd,this.onDidProcessExit=this.h.event;const O=p&&p.timeout?p.timeout:6e4;this.b=new R.$Yg(O),this.d=null,this.f=null}getChannel(l){const p=this;return{call(O,g,y){return p.k(l,O,g,y)},listen(O,g){return p.l(l,O,g)}}}k(l,p,O,g=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const y=this.n(l),s=(0,R.$Pg)(i=>y.call(p,O,i)),o=g.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,p,O){if(!this.b)return h.Event.None;this.b.cancel();let g;const y=new h.$Sd({onWillAddFirstListener:()=>{g=this.n(l).listen(p,O)(y.fire,y),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,P.$hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$Nl)(p.env),this.d=(0,L.fork)(this.i,l,p);const O=new h.$Sd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$$p)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}O.fire(j.$ge.wrap(Buffer.from(n,"base64")))});const y=this.j.useQueue?(0,I.$Pl)(this.d):this.d,s=n=>this.d&&this.d.connected&&y.send(n.buffer.toString("base64")),o=O.event,t={send:s,onMessage:o};this.f=new f.$Eh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(u=>(0,c.$Nc)(u)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(l){let p=this.g.get(l);return p||(p=this.m.getChannel(l),this.g.set(l,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$dq=v}),define(te[86],ne([0,1,8,4,2,46,3]),function(G,e,L,R,j,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.StorageState=e.$bp=e.StorageHint=void 0;var E;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$bp=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class P extends j.$Sc{static{this.a=100}constructor(f,S=Object.create(null)){super(),this.r=f,this.s=S,this.b=this.B(new R.$Vd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Zg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((S,v)=>this.w(v,S)),f.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(f,S){if(this.c===c.Closed)return;let v=!1;(0,N.$Nf)(S)?v=this.f.delete(f):this.f.get(f)!==S&&(this.f.set(f,S),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,S){const v=this.f.get(f);return(0,N.$Nf)(v)?S:v}getBoolean(f,S){const v=this.get(f);return(0,N.$Nf)(v)?S:v==="true"}getNumber(f,S){const v=this.get(f);return(0,N.$Nf)(v)?S:parseInt(v,10)}getObject(f,S){const v=this.get(f);return(0,N.$Nf)(v)?S:(0,A.$xh)(v)}async set(f,S,v=!1){if(this.c===c.Closed)return;if((0,N.$Nf)(S))return this.delete(f,v);const $=(0,N.$Gf)(S)||Array.isArray(S)?(0,A.$wh)(S):String(S);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:v}),this.D()}async delete(f,S=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$cp=P;class I{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((S,v)=>this.a.set(v,S)),f.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$dp=I}),define(te[87],ne([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(te[48],ne([0,1,88,8,16,3,24,87]),function(G,e,L,R,j,A,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.zip=e.$yp=e.$xp=void 0,e.$xp="end of central directory record signature not found";const h=new RegExp(e.$xp);class c extends Error{constructor(y,s){let o=s.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=s}}e.$yp=c;function P(g){const y=g.externalFileAttributes>>16||33188;return[448,56,7].map(s=>y&s).reduce((s,o)=>s+o,y&61440)}function I(g){if(g instanceof c)return g;let y;return h.test(g.message)&&(y="CorruptZip"),new c(y,g)}function d(g,y,s,o,t,i){const n=j.$mc(y),r=j.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(E.localize(0,null,y)));const u=j.$jc(o,y);let k;return i.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(N.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((b,w)=>{if(!i.isCancellationRequested)try{k=(0,L.createWriteStream)(u,{mode:s}),k.once("close",()=>b()),k.once("error",w),g.once("error",w),g.pipe(k)}catch(D){w(D)}}))}function f(g,y,s,o){let t=(0,R.$Pg)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((r,u)=>{const k=new R.$Wg,b=w=>{w.isCancellationRequested||(i++,g.readEntry())};g.once("error",u),g.once("close",()=>t.then(()=>{o.isCancellationRequested||g.entryCount===i?r():u(new c("Incomplete",new Error(E.localize(1,null,i,g.entryCount))))},u)),g.readEntry(),g.on("entry",w=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){b(o);return}const D=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(D)){const _=j.$jc(y,D);t=(0,R.$Pg)(re=>N.Promises.mkdir(_,{recursive:!0}).then(()=>b(re)).then(void 0,u));return}const H=v(g,w),ee=P(w);t=(0,R.$Pg)(_=>k.queue(()=>H.then(re=>d(re,D,ee,y,s,_).then(()=>b(_)))).then(null,u))})}).finally(()=>n.dispose())}async function S(g,y=!1){const{open:s}=await new Promise((o,t)=>{G(["yauzl"],o,t)});return new Promise((o,t)=>{s(g,y?{lazyEntries:!0}:void 0,(i,n)=>{i?t(I(i)):o((0,A.$Pf)(n))})})}function v(g,y){return new Promise((s,o)=>{g.openReadStream(y,(t,i)=>{t?o(I(t)):s((0,A.$Pf)(i))})})}async function $(g,y){const{ZipFile:s}=await new Promise((o,t)=>{G(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;y.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(g))})}e.zip=$;function l(g,y,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=S(g,!0);return s.overwrite&&(i=i.then(n=>N.Promises.rm(y).then(()=>n))),i.then(n=>f(n,y,{sourcePathRegex:t},o))}e.$Ap=l;function p(g,y){return S(g).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===y&&v(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(E.localize(2,null,y))))}))}function O(g,y){return p(g,y).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Bp=O}),define(te[89],ne([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[90],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[91],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[92],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[93],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[94],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[95],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[96],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[97],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[98],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[99],ne([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[100],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[101],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[102],ne([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[103],ne([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[104],ne([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[105],ne([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[106],ne([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[107],ne([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[108],ne([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[109],ne([0,1,9,91]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var j;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(j||(e.TokenType=j={}));function A(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const N=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,d=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(E);return}const S=this.c.charCodeAt(P);if(I)I=!1;else if(S===47&&!d){P++;break}else S===91?d=!0:S===92?I=!0:S===93&&(d=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=h}),define(te[110],ne([0,1,76,52,15,16,35,17,11]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=e.$sm=void 0,e.$sm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$mc)(j.$kg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Dg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Dg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$rm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Dg)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Dg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Dg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Dg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=N.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"argv.json")):(0,E.$Dg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$kc)(f):(0,A.$hc)((0,A.$jc)(j.$kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,A.$kc)(f)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$kc)(f);const S=N.env.VSCODE_EXTENSIONS;if(S)return S;const v=N.env.VSCODE_PORTABLE;return v?(0,A.$jc)(v,"extensions"):(0,E.$Dg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(S=>/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,A.$hc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,A.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$sm.test(f))}get extensionLogLevel(){const f=[];for(const S of this.args.log||[]){const v=e.$sm.exec(S);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,E.$Dg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=N.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"policy.json")):(0,E.$Dg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,S,v){this.a=f,this.b=S,this.c=v,this.editSessionId=this.args.editSessionId}}e.$tm=c,pe([R.$th],c.prototype,"appRoot",null),pe([R.$th],c.prototype,"userHome",null),pe([R.$th],c.prototype,"userDataPath",null),pe([R.$th],c.prototype,"appSettingsHome",null),pe([R.$th],c.prototype,"tmpDir",null),pe([R.$th],c.prototype,"cacheHome",null),pe([R.$th],c.prototype,"stateResource",null),pe([R.$th],c.prototype,"userRoamingDataHome",null),pe([R.$th],c.prototype,"userDataSyncHome",null),pe([R.$th],c.prototype,"sync",null),pe([R.$th],c.prototype,"machineSettingsResource",null),pe([R.$th],c.prototype,"workspaceStorageHome",null),pe([R.$th],c.prototype,"localHistoryHome",null),pe([R.$th],c.prototype,"keyboardLayoutResource",null),pe([R.$th],c.prototype,"argvResource",null),pe([R.$th],c.prototype,"isExtensionDevelopment",null),pe([R.$th],c.prototype,"untitledWorkspacesHome",null),pe([R.$th],c.prototype,"builtinExtensionsPath",null),pe([R.$th],c.prototype,"extensionsPath",null),pe([R.$th],c.prototype,"extensionDevelopmentLocationURI",null),pe([R.$th],c.prototype,"extensionDevelopmentKind",null),pe([R.$th],c.prototype,"extensionTestsLocationURI",null),pe([R.$th],c.prototype,"debugExtensionHost",null),pe([R.$th],c.prototype,"logLevel",null),pe([R.$th],c.prototype,"extensionLogLevel",null),pe([R.$th],c.prototype,"serviceMachineIdResource",null),pe([R.$th],c.prototype,"disableTelemetry",null),pe([R.$th],c.prototype,"disableWorkspaceTrust",null),pe([R.$th],c.prototype,"useInMemorySecretStorage",null),pe([R.$th],c.prototype,"policyFile",null);function P(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$um=P;function I(d,f,S,v,$,l){const O=Number(f||d)||(v?null:S),g=O?!!f:!1;let y;if(l)try{y=JSON.parse(l)}catch{}return{port:O,break:g,debugId:$,env:y}}e.$vm=I}),function(){"use strict";function G(e,L,R){function j(N,E){const h=A(N,E),c=[h];return e.isAbsolute(h)||c.unshift(R),e.resolve(...c)}function A(N,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const P=N["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:j}}if(typeof define=="function")define(te[111],ne([165,33,35]),function(e,L,R){return G(e,L,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[112],ne([0,1,33,110,111]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=void 0;class A extends R.$tm{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,j.getUserDataPath)(c,P.nameShort)},P)}}e.$wm=A;function N(h,c){return(0,R.$vm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$xm=N;function E(h,c){return(0,R.$vm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$ym=E}),define(te[113],ne([0,1,3,95]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;function j(N,E,h,c){try{A(N,E,h,c)}catch(P){N.error(P?.message??P)}return E}e.$Kp=j;function A(N,E,h,c){const P=(I,d,f)=>{const S=I[d];if((0,L.$Ef)(S)){const v=S,$=v.length;if($>1&&v[0]==="%"&&v[$-1]==="%"){const l=v.substr(1,$-2);let p=h[l];p===void 0&&c&&(p=c[l]);const O=typeof p=="string"?p:p?.message,g=c?.[l],y=typeof g=="string"?g:g?.message;if(!O){y||N.warn(`[${E.name}]: ${(0,R.localize)(0,null,l)}`);return}if(f&&(d==="title"||d==="category")&&y&&y!==O){const s={value:O,original:y};I[d]=s}else I[d]=O}}else if((0,L.$Gf)(S))for(const v in S)S.hasOwnProperty(v)&&(v==="commands"?P(S,v,!0):P(S,v,f));else if(Array.isArray(S))for(let v=0;v<S.length;v++)P(S,v,f)};for(const I in E)E.hasOwnProperty(I)&&P(E,I)}}),define(te[114],ne([0,1,48,98]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;function j(A){return(0,L.$Bp)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Sp=j}),define(te[49],ne([0,1,17,54,99,42]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h(l){return l=l.trim(),l==="*"||N.test(l)}e.$Yo=h;function c(l){if(!h(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=l.match(N);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$Zo=c;function P(l){if(!l)return null;const p=l.majorBase,O=l.majorMustEqual,g=l.minorBase;let y=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(p===0||(y=!1),o=!1);let t=0;if(l.preRelease){const i=E.exec(l.preRelease);if(i){const[,n,r,u]=i;t=Date.UTC(Number(n),Number(r)-1,Number(u))}}return{majorBase:p,majorMustEqual:O,minorBase:g,minorMustEqual:y,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:t}}e.$1o=P;function I(l,p,O){let g;typeof l=="string"?g=P(c(l)):g=l;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let s;if(typeof O=="string"?s=P(c(O)):s=O,!g||!s)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let n=s.majorBase,r=s.minorBase,u=s.patchBase;const k=s.notBefore;let b=s.majorMustEqual,w=s.minorMustEqual,D=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||y&&y<k?!1:i>=u:(o===1&&n===0&&(!b||!w||!D)&&(n=1,r=0,u=0,b=!0,w=!1,D=!1),o<n?!1:o>n?!b:t<r?!1:t>r?!w:i<u?!1:i>u?!D:!(y&&y<k))}e.$2o=I;function d(l,p,O,g,y){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([R.default.Error,j.localize(0,null)]),s;if(typeof g.name!="string")return s.push([R.default.Error,j.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([R.default.Error,j.localize(2,null,"version")]),s;if(!g.engines)return s.push([R.default.Error,j.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([R.default.Error,j.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!$(g.extensionDependencies))return s.push([R.default.Error,j.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!$(g.activationEvents))return s.push([R.default.Error,j.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([R.default.Error,j.localize(7,null,"activationEvents","main","browser")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([R.default.Warning,j.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([R.default.Error,j.localize(9,null,"main")]),s;{const i=(0,L.$Dg)(O,g.main);(0,L.$xg)(i,O)||s.push([R.default.Warning,j.localize(10,null,i.path,O.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([R.default.Error,j.localize(11,null,"browser")]),s;{const i=(0,L.$Dg)(O,g.browser);(0,L.$xg)(i,O)||s.push([R.default.Warning,j.localize(12,null,i.path,O.path)])}}if(!A.valid(g.version))return s.push([R.default.Error,j.localize(13,null)]),s;const o=[];if(!f(l,p,g,y,o))for(const i of o)s.push([R.default.Error,i]);return s}e.$3o=d;function f(l,p,O,g,y){return g||typeof O.main>"u"&&typeof O.browser>"u"?!0:v(l,p,O.engines.vscode,y)}e.$4o=f;function S(l,p,O){return l==="*"||v(p,O,l)}e.$5o=S;function v(l,p,O,g=[]){const y=P(c(O));if(!y)return g.push(j.localize(14,null,O)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(j.localize(15,null,O)),!1}else if(!y.majorMustEqual)return g.push(j.localize(16,null,O)),!1;return I(l,p,y)?!0:(g.push(j.localize(17,null,l,O)),!1)}function $(l){if(!Array.isArray(l))return!1;for(let p=0,O=l.length;p<O;p++)if(typeof l[p]!="string")return!1;return!0}}),define(te[115],ne([0,1,14,28]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;async function j(A,N,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const P=(await N.readFile(A.serviceMachineIdResource)).value.toString();h=(0,R.$lg)(P)?P:null}catch{h=null}if(!h){h=(0,R.$mg)();try{await N.writeFile(A.serviceMachineIdResource,L.$ge.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}e.$mp=j}),define(te[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class L{constructor(j,A=[],N=!1){this.ctor=j,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$Yh=L}),define(te[116],ne([0,1,50]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.InstantiationType=void 0;const R=[];var j;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function A(E,h,c){h instanceof L.$Yh||(h=new L.$Yh(h,[],!!c)),R.push([E,h])}e.$Jr=A;function N(){return R}e.$Kr=N}),define(te[117],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$oq=L;class R{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const E=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(N);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const E of this.a.values())E.outgoing.delete(N),E.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let E=this.a.get(N);return E||(E=new L(N,A),this.a.set(N,E)),E}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,E]of this.a)A.push(`${N}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const E=new Set([A]),h=this.c(N,E);if(h)return h}}c(A,N){for(const[E,h]of A.outgoing){if(N.has(E))return[...N,E].join(" -> ");N.add(E);const c=this.c(h,N);if(c)return c;N.delete(E)}}}e.$pq=R}),define(te[25],ne([0,1,3,11,10]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,j.$2h)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}e.$wi=A;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}e.$xi=N;var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=h;function c(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$zi=c;function P(l,p){const O=Object.create(null);for(const g in l)I(O,g,l[g],p);return O}e.$Ai=P;function I(l,p,O,g){const y=p.split("."),s=y.pop();let o=l;for(let t=0;t<y.length;t++){const i=y[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${p} as ${y.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=O}catch{g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Bi=I;function d(l,p){const O=p.split(".");f(l,O)}e.$Ci=d;function f(l,p){const O=p.shift();if(p.length===0){delete l[O];return}if(Object.keys(l).indexOf(O)!==-1){const g=l[O];typeof g=="object"&&!Array.isArray(g)&&(f(g,p),Object.keys(g).length===0&&delete l[O])}}function S(l,p,O){function g(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=p.split("."),s=g(l,y);return typeof s>"u"?O:s}e.$Di=S;function v(l,p,O){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in l?L.$Gf(l[g])&&L.$Gf(p[g])?v(l[g],p[g],O):O&&(l[g]=p[g]):l[g]=p[g])})}e.$Ei=v;function $(l){return l.replace(/[\[\]]/g,"")}e.$Fi=$}),define(te[118],ne([0,1,13,29,109,10,90,9]),function(G,e,L,R,j,A,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(M,a){if(h.get(M)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(M,a)}e.$Xi=c;const P=Object.prototype.hasOwnProperty;var I;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,N.localize)(0,null),S=(0,N.localize)(1,null),v=(0,N.localize)(2,null),$=(0,N.localize)(3,null),l=(0,N.localize)(4,null),p=(0,N.localize)(5,null),O=(0,N.localize)(6,null),g=(0,N.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new j.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const z=this.D(),U=z.type===17?p:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:j.$Wi.getLexeme(z),additionalInfo:U}),y.c}return m}catch(m){if(m!==y.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Q=U.lexeme,W=Q.lastIndexOf("/"),le=W===Q.length-1?void 0:this.w(Q.substring(W+1));let ae;try{ae=new RegExp(Q.substring(1,W),le)}catch{throw this.B("REGEX",U)}return ce.create(m,ae)}switch(U.type){case 10:case 19:{const Q=[U.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Q.push(j.$Wi.getLexeme(W)),this.z(),W=this.D()}const ae=Q.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",U)}return s.regex(m,ge)}case 18:{const Q=U.lexeme;this.z();let W=null;if(!(0,R.$Ge)(Q)){const le=Q.indexOf("/"),ae=Q.lastIndexOf("/");if(le!==ae&&le>=0){const me=Q.slice(le+1,ae),de=Q[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",U)}}}if(W===null)throw this.B("REGEX",U);return ce.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const U=this.u();return s.notIn(m,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals(m,U);switch(U){case"true":return s.has(m);case"false":return s.not(m);default:return s.equals(m,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals(m,U);switch(U){case"true":return s.not(m);case"false":return s.has(m);default:return s.notEquals(m,U)}}case 5:return this.z(),se.create(m,this.u());case 6:return this.z(),ue.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),re.create(m,this.u());case 13:return this.z(),s.in(m,this.u());default:return s.has(m)}}case 20:throw this.h.push({message:O,offset:a.offset,lexeme:"",additionalInfo:g}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,z){const U=(0,N.localize)(8,null,a,j.$Wi.getLexeme(m)),Q=m.offset,W=j.$Wi.getLexeme(m);return this.h.push({message:U,offset:Q,lexeme:W,additionalInfo:z}),y.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=y;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return u.create(a)}static equals(a,m){return k.create(a,m)}static notEquals(a,m){return D.create(a,m)}static regex(a,m){return ce.create(a,m)}static in(a,m){return b.create(a,m)}static notIn(a,m){return w.create(a,m)}static not(a){return H.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,m){return _.create(a,m)}static greaterEquals(a,m){return re.create(a,m)}static smaller(a,m){return se.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Zi=s;function o(M){const a=new y({regexParsingWithErrorRecovery:!1});return M.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,N.localize)(9,null,z.additionalInfo):(0,N.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$1i=o;function t(M,a){const m=M?M.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!m&&!z?!0:!m||!z?!1:m.equals(z)}e.$2i=t;function i(M,a){return M.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$3i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$4i=r;class u{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new u(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:V(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$5i=u;class k{static create(a,m,z=null){if(typeof m=="boolean")return m?u.create(a,z):H.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$6i=k;class b{static create(a,m){return new b(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:J(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(m)?m.includes(z):typeof z=="string"&&typeof m=="object"&&m!==null?P.call(m,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$7i=b;class w{static create(a,m){return new w(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=b.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=w;class D{static create(a,m,z=null){if(typeof m=="boolean")return m?H.create(a,z):u.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:r.INSTANCE:new D(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$9i=D;class H{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new H(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:V(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$0i=H;function ee(M,a){if(typeof M=="string"){const m=parseFloat(M);isNaN(m)||(M=m)}return typeof M=="string"||typeof M=="number"?a(M):n.INSTANCE}class _{static create(a,m,z=null){return ee(m,U=>new _(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$$i=_;class re{static create(a,m,z=null){return ee(m,U=>new re(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$_i=re;class se{static create(a,m,z=null){return ee(m,U=>new se(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$aj=se;class ue{static create(a,m,z=null){return ee(m,U=>new ue(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$bj=ue;class ce{static create(a,m){return new ce(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return m<z?-1:m>z?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&m===z}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$cj=ce;class oe{static create(a){return new oe(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new oe(this.c.map(a))}negate(){return this.c}}e.$dj=oe;function q(M){let a=null;for(let m=0,z=M.length;m<z;m++){const U=M[m].substituteConstants();if(M[m]!==U&&a===null){a=[];for(let Q=0;Q<m;Q++)a[Q]=M[Q]}a!==null&&(a[m]=U)}return a===null?M:a}class X{static create(a,m,z){return X.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,z){const U=[];let Q=!1;for(const W of a)if(W){if(W.type===1){Q=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&Q)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const le=U.pop(),ae=U.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return n.INSTANCE;if(U.length===1)return U[0]}return new X(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new X(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=T.create(a,this,!0)}return this.c}}e.$ej=X;class T{static create(a,m,z){return T.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,z){let U=[],Q=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Q=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&Q)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return r.INSTANCE;if(U.length===1)return U[0]}return new T(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new T(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),z=a.shift(),U=[];for(const Q of F(m))for(const W of F(z))U.push(X.create([Q,W],null,!1));a.unshift(T.create(U,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$fj=T;class C extends u{static{this.d=[]}static all(){return C.d.values()}constructor(a,m,z){super(a,null),this.f=m,typeof z=="object"?C.d.push({...z,key:a}):z!==!0&&C.d.push({key:a,description:z,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return D.create(this.key,a)}}e.$gj=C,e.$hj=(0,A.$2h)("contextKeyService");function V(M,a){return M<a?-1:M>a?1:0}function J(M,a,m,z){return M<m?-1:M>m?1:a<z?-1:a>z?1:0}function Y(M,a){if(M.type===0||a.type===1)return!0;if(M.type===9)return a.type===9?K(M.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(Y(M,m))return!0;return!1}if(M.type===6){if(a.type===6)return K(a.expr,M.expr);for(const m of M.expr)if(Y(m,a))return!0;return!1}return M.equals(a)}e.$ij=Y;function K(M,a){let m=0,z=0;for(;m<M.length&&z<a.length;){const U=M[m].cmp(a[z]);if(U<0)return!1;U===0&&m++,z++}return m===M.length}function F(M){return M.type===9?M.expr:[M]}}),define(te[59],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n=(0,L.$2h)("downloadService")}),define(te[18],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,L.$2h)("environmentService"),e.$0h=(0,L.$3h)(e.$9h)}),define(te[21],ne([0,1,93,10]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0,e.$$n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_n=new RegExp(e.$$n),e.$ao="__web_extension",e.$bo="skipWalkthrough",e.$co="extensionsSync",e.$do="dependecyOrPackExtensionInstall";function j(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$eo=j;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$fo=A;function N(l,p){switch(l){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$go=N;function E(l,p){return p==="web"&&!l.includes("web")}e.$ho=E;function h(l,p,O){return E(p,O)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===O}e.$io=h;function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$jo=c;var P;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var I;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(l){l.Install="install",l.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$ko=(0,R.$2h)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class $ extends Error{constructor(p,O){super(p),this.code=O,this.name=O}}e.$lo=$,e.$mo=(0,R.$2h)("extensionManagementService"),e.$no="extensionsIdentifiers/disabled",e.$oo="extensionsIdentifiers/enabled",e.$po=(0,R.$2h)("IGlobalExtensionEnablementService"),e.$qo=(0,R.$2h)("IExtensionTipsService"),e.$ro=(0,L.localize)(0,null),e.$so={value:e.$ro,original:"Extensions"},e.$to={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=void 0,e.$rp=(0,L.$2h)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((A,N)=>G(["node-vsce-sign"],async E=>A(E),N))),this.a}async verify(A,N,E){let h;try{h=await this.b()}catch{return!1}return h.verify(A,N,E)}}e.$sp=R}),define(te[61],ne([0,1,14,9,101,12]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;async function N(P,I,d,f,S,v){let $;try{await E(P,I,d,f,S,v)}catch(l){$=l}finally{$&&S.errorTransformer&&($=S.errorTransformer($)),typeof $<"u"&&d.error($),d.end()}}e.$Zp=N;async function E(P,I,d,f,S,v){h(v);const $=await P.open(I,{create:!1});try{h(v);let l=0,p=0,O=S&&typeof S.length=="number"?S.length:void 0,g=L.$ge.alloc(Math.min(S.bufferSize,typeof O=="number"?O:S.bufferSize)),y=S&&typeof S.position=="number"?S.position:0,s=0;do p=await P.read($,y,g.buffer,s,g.byteLength-s),y+=p,s+=p,l+=p,typeof O=="number"&&(O-=p),s===g.byteLength&&(await d.write(f(g)),g=L.$ge.alloc(Math.min(S.bufferSize,typeof O=="number"?O:S.bufferSize)),s=0);while(p>0&&(typeof O!="number"||O>0)&&h(v)&&c(l,S));if(s>0){let o=s;typeof O=="number"&&(o=Math.min(s,O)),d.write(f(g.slice(0,o)))}}catch(l){throw(0,A.$zk)(l)}finally{await P.close($)}}function h(P){if(P.isCancellationRequested)throw(0,R.$6)();return!0}function c(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,A.$yk)((0,j.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[119],ne([0,1,4,166,2,13,167]),function(G,e,L,R,j,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class E extends j.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.j(c),I=P.filter(f=>{const S=this.c.get(f.path);return S?!(0,R.$Mj)(S.request.excludes,f.excludes)||!(0,R.$Mj)(S.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!P.find(S=>S.path===f.path&&(0,R.$Mj)(S.excludes,f.excludes)&&(0,R.$Mj)(S.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const P=new N.$jq(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:P};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}j(c){const P=new Map;for(const I of c){const d=A.$k?I.path:I.path.toLowerCase();let f=P.get(I.correlationId);f||(f=new Map,P.set(I.correlationId,f)),f.set(d,I)}return Array.from(P.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$lq=E}),define(te[120],ne([0,1,62,119]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class j extends L.$4p{constructor(N,E,h){super(N,E,h),this.s()}r(N){return N.add(new R.$lq)}}e.$mq=j}),define(te[121],ne([0,1,15,57,85,62]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class N extends A.$5p{constructor(h,c,P){super(h,c,P),this.s()}r(h){const c=h.add(new j.$dq(L.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),R.ProxyChannel.toService((0,R.$Ih)(c.getChannel("watcher")))}}e.$eq=N}),define(te[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class L{constructor(...j){this.a=new Map;for(const[A,N]of j)this.set(A,N)}set(j,A){const N=this.a.get(j);return this.a.set(j,A),N}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$Zh=L}),define(te[122],ne([0,1,8,9,2,50,117,10,63,168]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;const P=!1;class I extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class d{constructor($=new h.$Zh,l=!1,p,O=P){this.f=$,this.g=l,this.h=p,this.i=O,this.o=new Set,this.f.set(E.$1h,this),this._globalGraph=O?p?._globalGraph??new N.$pq(g=>g):void 0}createChild($){return new d($,this.g,this,this.i)}invokeFunction($,...l){const p=S.traceInvocation(this.i,$);let O=!1;try{return $({get:y=>{if(O)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(y,p);if(!s)throw new Error(`[invokeFunction] unknown service '${y}'`);return s}},...l)}finally{O=!0,p.stop()}}createInstance($,...l){let p,O;return $ instanceof A.$Yh?(p=S.traceCreation(this.i,$.ctor),O=this.j($.ctor,$.staticArguments.concat(l),p)):(p=S.traceCreation(this.i,$),O=this.j($,l,p)),p.stop(),O}j($,l=[],p){const O=E._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),g=[];for(const s of O){const o=this.m(s.id,p);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(o)}const y=O.length>0?O[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${$.name} at position ${y+1} conflicts with ${l.length} static arguments`);const s=y-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,y)}return Reflect.construct($,l.concat(g))}k($,l){if(this.f.get($)instanceof A.$Yh)this.f.set($,l);else if(this.h)this.h.k($,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const l=this.f.get($);return!l&&this.h?this.h.l($):l}m($,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const p=this.l($);return p instanceof A.$Yh?this.q($,p,l.branch($,!0)):(l.branch($,!1),p)}q($,l,p){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,l,p)}finally{this.o.delete($)}}r($,l,p){const O=new N.$pq(s=>s.id.toString());let g=0;const y=[{id:$,desc:l,_trace:p}];for(;y.length;){const s=y.pop();if(O.lookupOrInsertNode(s),g++>1e3)throw new I(O);for(const o of E._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Yh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};O.insertEdge(s,i),y.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new I(O);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Yh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}O.removeNode(o)}}return this.l($)}s($,l,p=[],O,g){if(this.f.get($)instanceof A.$Yh)return this.t($,l,p,O,g);if(this.h)return this.h.s($,l,p,O,g);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t($,l,p=[],O,g){if(O){const y=new d(void 0,this.g,this,this.i);y.c=String($);const s=new Map,o=new L.$ih(()=>{const t=y.j(l,p,g);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const u of n)r.apply(t,u)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let u=s.get(i);return u||(u=new c.$3c,s.set(i,u)),(b,w,D)=>{const H=u.push([b,w,D]);return(0,j.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,p,g)}u($,l){if(l&&console.warn($),this.g)throw new Error($)}}e.$qq=d;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,l){return $?new S(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation($,l){return $?new S(1,l.name):S.c}static{this.f=0}constructor($,l){this.type=$,this.name=l,this.g=Date.now(),this.h=[]}branch($,l){const p=new S(3,$.toString());return this.h.push([$,l,p]),p}stop(){const $=Date.now()-this.g;S.f+=$;let l=!1;function p(g,y){const s=[],o=new Array(g+1).join("	");for(const[t,i,n]of y.h)if(i&&n){l=!0,s.push(`${o}CREATES -> ${t}`);const r=p(g+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const O=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];($>2||l)&&S.all.add(O.join(`
`))}}e.$rq=S});var ie=this&&this.__param||function(G,e){return function(L,R){e(L,R,G)}};define(te[64],ne([0,1,20,2,13,103,21,10]),function(G,e,L,R,j,A,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0;function h(P){return P.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$5q=h,e.$6q=(0,E.$2h)("languagePackService");let c=class extends R.$Sc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$3d;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const S=d.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],l=h(v);return{...this.f(l,$,v),extensionId:v.identifier.id,galleryExtension:v}});return S.push(this.f("en","English")),S}f(I,d,f){const S=d??I;let v;if(S!==I&&(v=`(${I})`),I.toLowerCase()===j.$w.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),f?.installCount){v??="";const $=f.installCount;let l;$>1e6?l=`${Math.floor($/1e5)/10}M`:$>1e3?l=`${Math.floor($/1e3)}K`:l=String($),v+=` $(cloud-download) ${l}`}return{id:I,label:S,description:v}}};e.$7q=c,e.$7q=c=pe([ie(0,N.$ko)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(G,e,L,R,j,A,N,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,d.$2h)("logService"),e.$kj=(0,d.$2h)("loggerService");function f(){return new Date().toISOString()}function S(b){return(0,c.$If)(b)}e.$lj=S;var v;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$mj=v.Info;function $(b,w,D){switch(w){case v.Trace:b.trace(D);break;case v.Debug:b.debug(D);break;case v.Info:b.info(D);break;case v.Warning:b.warn(D);break;case v.Error:b.error(D);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=$;function l(b,w=!1){let D="";for(let H=0;H<b.length;H++){let ee=b[H];if(ee instanceof Error&&(ee=(0,L.$Mi)(ee,w)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}D+=(H>0?" ":"")+ee}return D}class p extends A.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new R.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$oj=p;class O extends p{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...D){this.f(v.Trace)&&this.g(v.Trace,l([w,...D],!0))}debug(w,...D){this.f(v.Debug)&&this.g(v.Debug,l([w,...D]))}info(w,...D){this.f(v.Info)&&this.g(v.Info,l([w,...D]))}warn(w,...D){this.f(v.Warning)&&this.g(v.Warning,l([w,...D]))}error(w,...D){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,l(H))}else this.g(v.Error,l([w,...D]))}flush(){}}e.$pj=O;class g extends p{constructor(w=e.$mj){super(),this.setLevel(w),this.g=!E.$i}trace(w,...D){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...D):console.log(`[main ${f()}]`,w,...D))}debug(w,...D){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...D):console.log(`[main ${f()}]`,w,...D))}info(w,...D){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...D):console.log(`[main ${f()}]`,w,...D))}warn(w,...D){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...D):console.warn(`[main ${f()}]`,w,...D))}error(w,...D){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...D):console.error(`[main ${f()}]`,w,...D))}dispose(){}flush(){}}e.$qj=g;class y extends p{constructor(w=e.$mj,D=!0){super(),this.g=D,this.setLevel(w)}trace(w,...D){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...D):console.log(w,...D))}debug(w,...D){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...D):console.log(w,...D))}info(w,...D){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...D):console.log(w,...D))}warn(w,...D){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...D):console.log(w,...D))}error(w,...D){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...D):console.error(w,...D))}dispose(){}flush(){}}e.$rj=y;class s extends p{constructor(w,D=e.$mj){super(),this.g=w,this.setLevel(D)}trace(w,...D){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...D])}debug(w,...D){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...D])}info(w,...D){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...D])}warn(w,...D){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...D])}error(w,...D){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...D])}h(w){return typeof w=="string"?w:(0,L.$Mi)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$sj=s;class o extends p{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const D of this.g)D.setLevel(w);super.setLevel(w)}trace(w,...D){for(const H of this.g)H.trace(w,...D)}debug(w,...D){for(const H of this.g)H.debug(w,...D)}info(w,...D){for(const H of this.g)H.info(w,...D)}warn(w,...D){for(const H of this.g)H.warn(w,...D)}error(w,...D){for(const H of this.g)H.error(w,...D)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$tj=o;class t extends A.$Sc{constructor(w,D,H){if(super(),this.h=w,this.j=D,this.b=new N.$Ac,this.c=this.B(new R.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Sd),this.onDidChangeVisibility=this.g.event,H)for(const ee of H)this.b.set(ee.resource,{logger:void 0,info:ee})}m(w){return(0,c.$Ef)(w)?[...this.b.values()].find(D=>D.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,D){const H=this.n(w),ee=(0,c.$Ef)(w)?w:D?.id??(0,j.$Pi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const re=D?.logLevel==="always"?v.Trace:D?.logLevel;_||(_=this.s(H,re??this.getLogLevel(H)??this.h,{...D,id:ee}));const se={logger:_,info:{resource:H,id:ee,logLevel:re,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(se.info),this.b.set(H,se),_}n(w){return(0,c.$Ef)(w)?(0,h.$Dg)(this.j,`${w}.log`):w}setLogLevel(w,D){if(P.URI.isUri(w)){const H=w,ee=D,_=this.b.get(H);_&&ee!==_.info.logLevel&&(_.info.logLevel=ee===this.h?void 0:ee,_.logger?.setLevel(ee),this.b.set(_.info.resource,_),this.f.fire([H,ee]))}else{this.h=w;for(const[H,ee]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,D){const H=this.m(w);H&&D!==!H.info.hidden&&(H.info.hidden=!D,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,D]))}getLogLevel(w){let D;return w&&(D=this.b.get(w)?.info.logLevel),D??this.h}registerLogger(w){const D=this.b.get(w.resource);D?D.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const D=this.b.get(w);D&&(D.logger&&D.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=t;class i{constructor(){this.onDidChangeLogLevel=new R.$Sd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...D){}debug(w,...D){}info(w,...D){}warn(w,...D){}error(w,...D){}critical(w,...D){}dispose(){}flush(){}}e.$vj=i;class n extends i{}e.$wj=n;function r(b){if(b.verbose)return v.Trace;if(typeof b.logLevel=="string"){const w=k(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.$mj}e.$xj=r;function u(b){switch(b){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$yj=u;function k(b){switch(b){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$zj=k,e.$Aj=new I.$gj("logLevel",u(v.Info))}),define(te[123],ne([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class P extends N.$Sc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new A.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Zg(0)),this.w=[],this.y=this.B(new R.$Zg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},v=(0,L.$Ub)(this.j,S);return this.r(),(0,N.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,j.$1)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$6p)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$2p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$2p)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const S={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},v=(0,L.$Ub)(this.w,S);return this.C(),(0,N.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,j.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$6p)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,E.$hc)(d.fsPath)}}e.$0p=P}),define(te[124],ne([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;let y=class extends c.$Sc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new N.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$Sd),this.Y=this.B(new N.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$$g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new $.$Ek(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Hg)(o))throw new $.$Gk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new O.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,$.$rk)(t)||(0,$.$ok)(t)||(0,$.$sk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$rk)(t)||(0,$.$ok)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,$.$Bk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Gk((0,v.localize)(2,null,this.sb(o)),1):(0,$.$zk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,u=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,b=await i.stat(o);let w;return this.t(i,o,b,void 0,!!k,(D,H)=>(w||(w=P.$8h.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(D.resource)||w.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&u?H===1:!1))}async t(o,t,i,n,r,u){const{providerExtUri:k}=this.R(o),b={resource:t,name:k.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Rk)({mtime:i.mtime,size:i.size}),children:void 0};if(b.isDirectory&&u(b,n)){try{const w=await o.readdir(t),D=await R.Promises.settled(w.map(async([H,ee])=>{try{const _=k.joinPath(t,H),re=r?await o.stat(_):{type:ee};return await this.t(o,_,re,w.length,r,u)}catch(_){return this.b.trace(_),null}}));b.children=(0,L.$Hb)(D)}catch(w){this.b.trace(w),b.children=[]}return b}return b}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$Gk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=j.$ge.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new $.$Dk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let u=i;if((0,$.$uk)(n)&&!u?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(u={...i,atomic:k})}try{await this.w(n,o,u)||await this.U(n,r.dirname(o));let b;if((0,$.$ok)(n)&&!(t instanceof j.$ge))if((0,S.$5d)(t)){const w=await(0,S.$_d)(t,3);w.ended?b=j.$ge.concat(w.buffer):b=w}else b=(0,S.$9d)(t,w=>j.$ge.concat(w),3);else b=t;!(0,$.$rk)(n)||(0,$.$ok)(n)&&b instanceof j.$ge||(0,$.$ok)(n)&&(0,$.$uk)(n)&&u?.atomic?await this.hb(n,o,u,b):await this.db(n,o,u,b instanceof j.$ge?(0,j.$re)(b):b),this.r.fire(new $.$Dk(o,4))}catch(k){throw new $.$Gk((0,v.localize)(4,null,this.sb(o),(0,$.$zk)(k).toString()),(0,$.$Ck)(k),u)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let u;try{u=await o.stat(t)}catch{return}if(u.type&$.FileType.Directory)throw new $.$Gk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,u),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Qk&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==(0,$.$Rk)({mtime:i.mtime,size:u.size}))throw new $.$Gk((0,v.localize)(10,null),3,i);return u}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,u)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){u(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,j.$se)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$3d(n);let u=i;(0,$.$tk)(o)&&o.enforceAtomicReadFile?.(t)&&(u={...i,atomic:!0});const k=this.J(t,u).then(w=>w,w=>{throw r.dispose(!0),w});let b;try{return typeof u?.etag=="string"&&u.etag!==$.$Qk&&await k,u?.atomic&&(0,$.$tk)(o)||!((0,$.$rk)(o)||(0,$.$sk)(o))||(0,$.$ok)(o)&&u?.preferUnbuffered?b=this.I(o,t,u):(0,$.$sk)(o)?b=this.G(o,t,r.token,u):b=this.H(o,t,r.token,u),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await k,value:b}}catch(w){throw b&&await(0,S.$0d)(b),this.F(w,t,u)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,$.$zk)(o).toString());return o instanceof $.$Ik?new $.$Ik(n,o.stat,i):o instanceof $.$Hk?new $.$Hk(n,o.fileOperationResult,o.size,o.options):new $.$Gk(n,(0,$.$Ck)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,S.$de)(r,{data:u=>u instanceof j.$ge?u:j.$ge.wrap(u),error:u=>this.F(u,t,n)},u=>j.$ge.concat(u))}H(o,t,i,n=Object.create(null)){const r=(0,j.$we)();return(0,l.$Zp)(o,t,r,u=>u,{...n,bufferSize:this.a,errorTransformer:u=>this.F(u,t,n)},i),r}I(o,t,i){const n=(0,S.$7d)(r=>j.$ge.concat(r));return(async()=>{try{let r;i?.atomic&&(0,$.$tk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(j.$ge.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$Gk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Qk&&t.etag===i.etag)throw new $.$Ik((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$Hk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),u=this.qb(await this.n(t),t);await this.Q(r,o,u,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),u=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Dk(o,u==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),u=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Dk(o,u==="copy"?3:2,k)),k}async N(o,t,i,n,r,u){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:b}=await this.Q(o,t,i,n,r,u);if(k&&!b&&u&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,$.$pk)(o))await o.copy(t,n,{overwrite:u});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:u}),r):(await this.N(o,t,i,n,"copy",u),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,$.$rk)(o)&&(0,$.$rk)(i))return this.jb(o,t,i,n);if((0,$.$rk)(o)&&(0,$.$ok)(i))return this.pb(o,t,i,n);if((0,$.$ok)(o)&&(0,$.$rk)(i))return this.nb(o,t,i,n);if((0,$.$ok)(o)&&(0,$.$ok)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async r=>{const u=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,u):this.O(o,r.resource,i,u)}))}async Q(o,t,i,n,r,u){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:D}=this.R(o);if(D||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const b=await this.exists(n);if(b&&!k){if(!u)throw new $.$Gk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:b,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$tg:f.$vg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Dk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$Bk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(u){if((0,$.$Bk)(u)!==$.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let u;try{u=await i.stat(o)}catch{}if(u)this.rb(o,u);else throw new $.$Gk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,$.$vk)(i)&&!n?.atomic){const b=i.enforceAtomicDelete?.(o);b&&(n={...t,atomic:b})}const r=!!n?.useTrash,u=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:u,useTrash:r,atomic:k}),this.r.fire(new $.$Dk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,$.$qk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$pk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:g.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Nc)(k):r=()=>(0,c.$Nc)(k)}catch(k){this.b.error(k)}})();const u=t.correlationId;if(typeof u=="number"){const k=i.add(new N.$Sd);return i.add(this.X.event(w=>{w.correlates(u)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,E.$Pi)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,S.$5d)(n)||(0,S.$6d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(u){throw(0,$.$zk)(u)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,S.$6d)(i)){if(i.buffer.length>0){const u=j.$ge.concat(i.buffer);await this.gb(o,t,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((u,k)=>{(0,S.$$d)(r,{onData:async b=>{r.pause();try{await this.gb(o,t,b,b.byteLength,n,0)}catch(w){return k(w)}n+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>k(b),onEnd:()=>u()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,u){let k=0;for(;k<n;){const b=await o.write(t,r+k,i.buffer,u+k,n-k);k+=b}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof j.$ge?r=n:(0,S.$5d)(n)?r=await(0,j.$se)(n):(0,S.$6d)(n)?r=await(0,j.$te)(n):r=(0,j.$qe)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,u;try{r=await o.open(t,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const k=j.$ge.alloc(this.a);let b=0,w=0,D=0;do D=await o.read(r,b,k.buffer,w,k.byteLength-w),await this.gb(i,u,k,D,b,w),b+=D,w+=D,w===k.byteLength&&(w=0);while(D>0)}catch(k){throw(0,$.$zk)(k)}finally{await R.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const u=await o.readFile(t);await this.gb(i,r,j.$ge.wrap(u),u.byteLength,0,0)}catch(u){throw(0,$.$zk)(u)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,j.$se)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$Gk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$Gk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$1p=y,e.$1p=y=g=pe([ie(0,p.$jj)],y)}),define(te[126],ne([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0,(()=>{try{(0,R.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,O.$Mi)(o)}`)}})();class s extends p.$0p{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.N=new A.$Ac(n=>d.$ug.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await S.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await S.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let u;r.isSymbolicLink()?u=(await this.stat((0,d.$Dg)(t,r.name))).type:u=this.M(r),n.push([r.name,u])}catch(u){this.a.trace(u)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new j.$1g;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await S.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$7d)(u=>N.$ge.concat(u.map(k=>N.$ge.wrap(k))).buffer);return(0,l.$Zp)(this,t,r,u=>u.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Dg)((0,d.$Cg)(t),`${(0,d.$Ag)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await S.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const u=new c.$Rc;try{u.add(await this.O(t)),u.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{u.dispose()}}async S(t,i,n,r){let u;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await S.Promises.exists(k)){if(!n.overwrite)throw(0,$.$yk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$yk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(u,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof u=="number"&&await this.close(u)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let u;(0,$.$mk)(i)&&!n&&(u=await this.O(t));let k;try{if((0,$.$mk)(i)&&i.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(r);w.mode&128||await S.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let b;if((0,$.$mk)(i)){if(I.$i)try{await S.Promises.truncate(r,0),b="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}b||(b="w")}else b="r";k=await S.Promises.open(r,b)}catch(b){throw u?.dispose(),(0,$.$mk)(i)?await this.gb(t,b):this.fb(b)}if(this.U.set(k,0),(0,$.$mk)(i)&&this.X.set(k,t),u){const b=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,u),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),b.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await S.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await S.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,u){const k=this.Z(t,i);let b=null;try{b=(await S.Promises.read(t,n,r,u,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,b)}return b}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,u){return(0,j.$jh)(()=>this.ab(t,i,n,r,u),100,3)}async ab(t,i,n,r,u){const k=this.Z(t,i);let b=null;try{b=(await S.Promises.write(t,n,r,u,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,b)}return b}async mkdir(t){try{await S.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(n),`${(0,P.$nc)(n)}${i.atomic.postfix}`)),await S.Promises.rm(n,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let u=!1;try{const{stat:k,symbolicLink:b}=await S.SymlinkSupport.stat(n);u=k.isDirectory()&&!b}catch{}if(u)await S.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),u=this.H(i);if(r!==u)try{await this.bb(t,i,"move",n.overwrite),await S.Promises.rename(r,u)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(u)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),u=this.H(i);if(r!==u)try{await this.bb(t,i,"copy",n.overwrite),await S.Promises.copy(r,u,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(u)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const u=this.H(t),k=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,h.$3f)(u,k,!0)),b){if(n==="copy")throw(0,$.$yk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.L(t);if(!D)throw(0,$.$yk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,$.$yk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);D.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),u=this.H(i),k=!!(this.capabilities&1024);if((0,h.$3f)(r,u,!k))return;const b=new c.$Rc;try{b.add(await this.O(t)),b.add(await this.O(i)),n&&await S.Promises.mkdir((0,P.$mc)(u),{recursive:!0}),await S.Promises.copyFile(r,u)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{b.dispose()}}t(t,i,n){return new g.$eq(r=>t(r),r=>i(r),n)}F(t,i,n){return new y.$mq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof $.$xk)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$yk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,$.$yk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$nq=s}),define(te[127],ne([0,1,2,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;class j extends L.$Sc{constructor(N,E=[]){super(),this.a=new R.$tj([N,...E]),this.B(N.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...E){this.a.trace(N,...E)}debug(N,...E){this.a.debug(N,...E)}info(N,...E){this.a.info(N,...E)}warn(N,...E){this.a.warn(N,...E)}error(N,...E){this.a.error(N,...E)}flush(){this.a.flush()}}e.$bO=j}),define(te[128],ne([0,1,12,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;var j;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(j||(j={}));async function A(c,P,I,d,f){try{const S=await new Promise(($,l)=>{G(["@vscode/spdlog"],$,l)});S.setFlushOn(j.Trace);const v=await S.createAsyncRotatingLogger(c,P,I,d);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(S){console.error(S)}return null}function N(c,P,I){switch(P){case R.LogLevel.Trace:c.trace(I);break;case R.LogLevel.Debug:c.debug(I);break;case R.LogLevel.Info:c.info(I);break;case R.LogLevel.Warning:c.warn(I);break;case R.LogLevel.Error:c.error(I);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(c,P){switch(P){case R.LogLevel.Trace:c.setLevel(j.Trace);break;case R.LogLevel.Debug:c.setLevel(j.Debug);break;case R.LogLevel.Info:c.setLevel(j.Info);break;case R.LogLevel.Warning:c.setLevel(j.Warning);break;case R.LogLevel.Error:c.setLevel(j.Error);break;case R.LogLevel.Off:c.setLevel(j.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends R.$pj{constructor(P,I,d,f,S){super(),this.m=[],this.setLevel(S),this.n=this.s(P,I,d,f),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(P,I,d,f){const S=d?6:1,v=30/S*L.$Tk.MB,$=await A(P,I,v,S,f);if($){this.r=$,E(this.r,this.getLevel());for(const{level:l,message:p}of this.m)N(this.r,l,p);this.m=[]}}g(P,I){this.r?N(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3N=h}),define(te[129],ne([0,1,28,6,128]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=void 0;class A extends R.$uj{s(E,h,c){return new j.$3N((0,L.$mg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$4N=A}),define(te[38],ne([0,1,4,65,2,10]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0,e.$vn=(0,A.$2h)("policy");class N extends j.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[P,I])=>({...c,[P]:{definition:I,value:this.g.get(P)}}),{})}}e.$wn=N;class E{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$xn=E}),define(te[130],ne([0,1,8,4,65,3,12,6,38]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=void 0;function c(I,d){const f=[];for(const S of new Set(j.Iterable.concat(I.keys(),d.keys())))I.get(S)!==d.get(S)&&f.push(S);return f}let P=class extends h.$wn{constructor(d,f,S){super(),this.m=d,this.n=f,this.s=S,this.c=this.B(new L.$Zg(500));const v=R.Event.filter(f.onDidFilesChange,$=>$.affects(d));this.B(f.watch(d)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),S=JSON.parse(f.value.toString());if(!(0,A.$Gf)(S))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(S))this.f[v]&&d.set(v,S[v])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$b$b=P,e.$b$b=P=pe([ie(1,N.$lk),ie(2,E.$jj)],P)}),define(te[131],ne([0,1,38,8,2,6]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=void 0;let N=class extends L.$wn{constructor(h,c){super(),this.m=h,this.n=c,this.a=new R.$Vg,this.b=this.B(new j.$Tc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((P,I)=>{G(["@vscode/policy-watcher"],P,I)});await this.a.queue(()=>new Promise((P,I)=>{try{this.b.value=c(this.n,h,d=>{this.t(d),P()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const P=h[c];P===void 0?this.g.delete(c):this.g.set(c,P)}this.h.fire(Object.keys(h))}};e.$a$b=N,e.$a$b=N=pe([ie(0,A.$jj)],N)}),define(te[32],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,L.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0;class j{constructor(){this.a=new Map}add(N,E){L.ok(R.$Ef(N)),L.ok(R.$Gf(E)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,E)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$tn=new j}),define(te[132],ne([0,1,4,36]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un={JSONContribution:"base.contributions.json"};function j(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class A{constructor(){this.b=new L.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[j(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;R.$tn.add(e.$un.JSONContribution,N)}),define(te[43],ne([0,1,19,4,3,89,25,132,36]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.ConfigurationScope=e.$yn=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$yn={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn="vscode://schemas/settings/resourceLanguage",e.$Gn="vscode://schemas/settings/configurationDefaults";const I=h.$tn.as(E.$un.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.$Sd,this.onDidSchemaChange=this.i.event,this.j=new R.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$Fn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$In.test(r)){const u=this.a.get(r),k=u?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))k.set(H,n);const b={...u?.value||{},...i[r]};this.a.set(r,{source:n,value:b,valuesSources:k});const w=(0,N.$Fi)(r),D={type:"object",default:b,description:A.localize(1,null,w),$ref:e.$Fn,defaultDefaultValue:b,source:j.$Ef(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=D,this.b.properties[r]=D}else{this.a.set(r,{value:i[r],source:n});const u=this.d[r];u&&(this.w(r,u),this.r(r,u))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),u=j.$Ef(i)?i:i?.id,k=j.$Ef(r?.source)?r?.source:r?.source?.id;if(u===k)if(o.add(n),this.a.delete(n),e.$In.test(n))delete this.d[n],delete this.b.properties[n];else{const b=this.d[n];b&&(this.w(n,b),this.r(n,b))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=j.$Nf(s.scope)?n:s.scope;const u=s.properties;if(u)for(const b in u){const w=u[b];if(o&&O(b,w)){delete u[b];continue}if(w.source=t,w.defaultDefaultValue=u[b].default,this.w(b,w),e.$In.test(b)?w.scope=void 0:(w.scope=j.$Nf(w.scope)?n:w.scope,w.restricted=j.$Nf(w.restricted)?!!i?.includes(b):w.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.f[b]=u[b],delete u[b];continue}else this.d[b]=u[b],u[b].policy?.name&&this.e.set(u[b].policy.name,b);!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),r.add(b)}const k=s.allOf;if(k)for(const b of k)this.p(b,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$zn.properties[s]=o,o.scope){case 1:e.$An.properties[s]=o;break;case 2:e.$Bn.properties[s]=o;break;case 6:e.$Cn.properties[s]=o;break;case 3:e.$Dn.properties[s]=o;break;case 4:e.$En.properties[s]=o;break;case 5:e.$En.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$zn.properties[s],o.scope){case 1:delete e.$An.properties[s];break;case 2:delete e.$Bn.properties[s];break;case 6:delete e.$Cn.properties[s];break;case 3:delete e.$Dn.properties[s];break;case 4:case 5:delete e.$En.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Fn};this.w(o,t),e.$zn.properties[o]=t,e.$An.properties[o]=t,e.$Bn.properties[o]=t,e.$Cn.properties[o]=t,e.$Dn.properties[o]=t,e.$En.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Fn};e.$zn.patternProperties[e.$Hn]=s,e.$An.patternProperties[e.$Hn]=s,e.$Bn.patternProperties[e.$Hn]=s,e.$Cn.patternProperties[e.$Hn]=s,e.$Dn.patternProperties[e.$Hn]=s,e.$En.patternProperties[e.$Hn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;j.$Lf(i)&&(i=o.defaultDefaultValue,n=void 0),j.$Lf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.$Hn=`^(${f})+$`,e.$In=new RegExp(e.$Hn);function v(y){const s=[];if(e.$In.test(y)){let o=S.exec(y);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=S.exec(y)}}return(0,L.$Mb)(s)}e.$Jn=v;function $(y){return y.reduce((s,o)=>`${s}[${o}]`,"")}e.$Kn=$;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Ln=l;const p=new d;h.$tn.add(e.$yn.Configuration,p);function O(y,s){return y.trim()?e.$In.test(y)?A.localize(7,null,y):p.getConfigurationProperties()[y]!==void 0?A.localize(8,null,y):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,y,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Mn=O;function g(){const y=[],s=p.getConfigurationProperties();for(const o of Object.keys(s))y.push([o,s[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$Nn=g}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,R,j,A,N,E,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0;function f(o){return Object.isFrozen(o)?o:E.$in(o)}class S{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof S)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$Di)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,u=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:u}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$Di)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=E.$hn(this.contents),n=E.$hn(this.overrides),r=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const k of t)if(u.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const b of k.overrides){const[w]=n.filter(D=>L.$ub(D.identifiers,b.identifiers));w?(this.h(w.contents,b.contents),w.keys.push(...b.keys),w.keys=L.$Mb(w.keys)):n.push(E.$hn(b))}for(const b of k.keys)r.indexOf(b)===-1&&r.push(b)}return new S(i,r,n,u.every(k=>k instanceof S)?void 0:u)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[r];const k=i[r];k&&(typeof u=="object"&&typeof k=="object"?(u=E.$hn(u),this.h(u,k)):u=k),n[r]=u}return new S(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Gf(t[n])&&h.$Gf(i[n])){this.h(t[n],i[n]);continue}t[n]=E.$hn(i[n])}}i(t){let i=null,n=null;const r=u=>{u&&(n?this.h(n,u):n=E.$hn(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?i=u.contents:u.identifiers.includes(t)&&r(u.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$Ci)(this.contents,t),I.$In.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,I.$Jn)(t))),1))}j(t,i,n){(0,P.$Bi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$In.test(t)&&this.overrides.push({identifiers:(0,I.$Jn)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$Ai)(this.contents[t],r=>console.error(r))})}}e.$On=S;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Nf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:u,restricted:k,hasExcludedProperties:b}=this.h(t,i);this.b=new S(n,r,u,b?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const u=[],k=[];function b(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}const w={onObjectBegin:()=>{const D={};b(D),u.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const D=[];b(D),u.push(r),r=D,n=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:b,onError:(D,H,ee)=>{k.push({error:D,offset:H,length:ee})}};if(t)try{j.$en(t,w),i=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return i}h(t,i){const n=d.$tn.as(I.$yn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const u=(0,P.$Ai)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),b=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:u,keys:k,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let u=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const k={},b=[];for(const w in t)if(I.$In.test(w)&&n){const D=this.i(t[w],i,!1,r);k[w]=D.raw,u=u||D.hasExcludedProperties,b.push(...D.restricted)}else{const D=i[w],H=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&b.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&D?.restricted))?k[w]=t[w]:u=!0}return{raw:k,restricted:b,hasExcludedProperties:u}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$In.test(r)){const u={};for(const k in t[r])u[k]=t[r][k];n.push({identifiers:(0,I.$Jn)(r),keys:Object.keys(u),contents:(0,P.$Ai)(u,i)})}return n}}e.$Pn=v;class $ extends A.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new R.$Sd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&n.isEqual(u.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qn=$;class l{constructor(t,i,n,r,u,k,b,w,D,H,ee,_,re){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=u,this.f=k,this.g=b,this.h=w,this.i=D,this.j=H,this.k=ee,this.l=_,this.m=re}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(t,i,n,r,u=new S,k=new S,b=new N.$Ac,w=new S,D=new N.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=u,this.i=k,this.j=b,this.l=w,this.m=D,this.a=null,this.b=new N.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new S,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),u=this.t(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const w of r.overrides)for(const D of w.identifiers)r.getOverrideValue(t,D)!==void 0&&b.add(D);return new l(t,i,r.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,u||void 0,k)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:u,removed:k}=y(this.c,t);i=[...r,...u,...k]}for(const r of i)for(const u of(0,I.$Jn)(r)){const k=this.c.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),w=[...b.filter(D=>k.indexOf(D)===-1),...k.filter(D=>b.indexOf(D)===-1),...k.filter(D=>!E.$ln(this.c.override(u).getValue(D),t.override(u).getValue(D)))];n.push([u,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=y(this.d,t),u=[...i,...n,...r];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:u,removed:k,overrides:b}=y(n,i),w=[...r,...u,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:u,overrides:k}=y(i,void 0);return{keys:[...n,...r,...u],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const u=this.m.get(t);u&&(n=n.merge(u))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:u}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),u=this.w(t.user),k=this.w(t.workspace),b=t.folders.reduce((w,D)=>(w.set(c.URI.revive(D[0]),this.w(D[1])),w),new N.$Ac);return new p(i,n,r,u,new S,k,b,new S,new N.$Ac)}static w(t){return new S(t.contents,t.keys,t.overrides)}}e.$Rn=p;function O(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(u=>t.add(u)),r.overrides.forEach(([u,k])=>{const b=(0,N.$xc)(i,u,new Set);k.forEach(w=>b.add(w))});const n=[];return i.forEach((r,u)=>n.push([u,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Sn=O;class g{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const u of t.keys)this.affectedKeys.add(u);for(const[,u]of t.overrides)for(const k of u)this.affectedKeys.add(k);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const u=r+n.length;if(u>=this.d.length)return!1;const k=this.d.charCodeAt(u);if(k!==this.b&&k!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!E.$ln(b,w)}return!0}}e.$Tn=g;function y(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),u=[],k=o?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const w=b.filter(D=>!k.includes(D));for(const D of w)u.push([D,t.getKeysForOverrideIdentifier(D)])}if(o){const w=k.filter(D=>!b.includes(D));for(const D of w)u.push([D,o.getKeysForOverrideIdentifier(D)])}if(t&&o){for(const w of k)if(b.includes(w)){const D=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});u.push([w,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:n,updated:r,overrides:u}}function s(o,t){const i=o?t?o.keys.filter(u=>t.keys.indexOf(u)===-1):[...o.keys]:[],n=t?o?t.keys.filter(u=>o.keys.indexOf(u)===-1):[...t.keys]:[],r=[];if(o&&t){for(const u of t.keys)if(o.keys.indexOf(u)!==-1){const k=(0,P.$Di)(t.contents,u),b=(0,P.$Di)(o.contents,u);E.$ln(k,b)||r.push(u)}}return{added:i,removed:n,updated:r}}}),define(te[133],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,R,j,A,N,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=void 0;class d extends j.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$On}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$tn.as(h.$yn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:l})=>this.c(Array.from($),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,l){this.h($,I.$tn.as(h.$yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new E.$On;const $=I.$tn.as(h.$yn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,l){const p=this.f();for(const O of $){const g=p[O],y=l[O];g!==void 0?this.b.addValue(O,g):y?this.b.addValue(O,y.default):this.b.removeValue(O)}}}e.$Un=d;class f{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$On}async initialize(){return this.configurationModel}}e.$Vn=f;let S=class extends j.$Sc{get configurationModel(){return this.b}constructor($,l,p){super(),this.c=$,this.f=l,this.g=p,this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new E.$On}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const l={},p=[],O=I.$tn.as(h.$yn.Configuration).getConfigurationProperties();for(const g of $){const y=O[g];if(!y){p.push(g);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}p.push(g),l[y.policy.name]={type:y.type}}}return(0,N.$Rf)(l)||await this.f.updatePolicyDefinitions(l),p}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const l=I.$tn.as(h.$yn.Configuration).getPolicyConfigurations(),p=(0,L.$Hb)($.map(O=>l.get(O)));this.m(p,!0)}m($,l){this.g.trace("PolicyConfiguration#update",$);const p=I.$tn.as(h.$yn.Configuration).getConfigurationProperties(),O=[],g=this.b.isEmpty();for(const y of $){const s=p[y]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(g?o!==void 0:!(0,A.$ln)(this.b.getValue(y),o))&&O.push([y,o])}else this.b.getValue(y)!==void 0&&O.push([y,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const y=this.b;this.b=new E.$On;for(const s of y.keys)this.b.setValue(s,y.getValue(s));for(const[s,o]of O)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Wn=S,e.$Wn=S=pe([ie(1,P.$vn),ie(2,c.$jj)],S)}),define(te[134],ne([0,1,8,4,2,17,25,66,133,38]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class P extends j.$Sc{constructor(d,f,S,v){super(),this.j=d,this.h=this.B(new R.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Un),this.c=S instanceof c.$xn?new h.$Vn:this.B(new h.$Wn(this.b,S,v)),this.f=this.B(new E.$Qn(this.j,{},A.$ug,f)),this.a=new E.$Rn(this.b.configurationModel,this.c.configurationModel,new E.$On,new E.$On),this.g=this.B(new L.$bh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:l})=>this.n($,l))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new E.$Rn(d,f,new E.$On,S)}getConfigurationData(){return this.a.toData()}getValue(d,f){const S=typeof d=="string"?d:void 0,v=(0,N.$wi)(d)?d:(0,N.$wi)(f)?f:{};return this.a.getValue(S,v,void 0)}updateValue(d,f,S,v){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(S,f,2)}n(d,f){const S=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(v,S,7)}r(d){const f=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(d);this.s(S,f,7)}s(d,f,S){const v=new E.$Tn(d,{data:f},this.a);v.source=S,v.sourceConfig=this.t(S),this.h.fire(v)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Xn=P}),define(te[67],ne([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function R(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$8k=R;function j(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.$9k=j;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$0k=A;function N(c){const{host:P,port:I}=h(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$$k=N;function E(c,P){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=P),{host:I,port:d}}e.$_k=E;function h(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.TargetPlatform=e.ExtensionType=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am="extensions.user.cache",e.$bm="extensions.builtin.cache",e.$cm="undefined_publisher",e.$dm=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$em=A,e.$fm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(N||(e.ExtensionType=N={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,l){if(typeof $>"u"||$===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof $=="string"||typeof l=="string"){const p=typeof $=="string"?$:$.value,O=typeof l=="string"?l:l.value;return L.$8e(p,O)}return $._lower===l._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$gm=h;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const l of $)this.add(l)}add($){this.c.add(h.toKey($))}delete($){return this.c.delete(h.toKey($))}has($){return this.c.has(h.toKey($))}}e.$hm=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(h.toKey($))}get($){return this.c.get(h.toKey($))}has($){return this.c.has(h.toKey($))}set($,l){this.c.set(h.toKey($),l)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$im=P;function I(v){return d(v)}e.$jm=I;function d(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$km=d;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$lm=f;function S(v,$){if($){const l=`onResolveRemoteAuthority:${(0,j.$9k)($)}`;return!!v.activationEvents?.includes(l)}return!1}e.$mm=S,e.$nm=(0,R.$2h)("IBuiltinExtensionsScannerService")}),define(te[135],ne([0,1,2,37,12]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class A extends L.$Sc{constructor(E,h,c,P,I){super(),this.a=E,this.b=h,this.c=c,this.f=I,this.B(P.onDidInstallExtensions(d=>this.g(d))),this.B(P.onDidUninstallExtension(d=>this.h(d)))}g(E){for(const h of E)h.local&&this.invalidate(h.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,E)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,R.$am))}catch(h){(0,j.$Ck)(h)!==1&&this.f.error(h)}}}e.$Tp=A}),define(te[44],ne([0,1,14,9,2,104,43,10,6,36]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$6o=(0,E.$2h)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?y[s]="*****":y[s]=this.b[s];this.a=y}return this.a}}class I extends j.$Sc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,A.localize)(0,null),when:h.$Aj.isEqualTo((0,h.$yj)(h.LogLevel.Trace)).serialize()})}async c(y,s,o){const t=`${y} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,R.$0)(i)),i}}}e.$7o=I;function d(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$8o=d;function f(g){return g.res.statusCode===204}e.$9o=f;async function S(g){return f(g)?null:(await(0,L.$se)(g.stream)).toString()}e.$0o=S;async function v(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.$$o=v;async function $(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);if(f(g))return null;const s=(await(0,L.$se)(g.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$_o=$;function l(g){O(g)}e.$ap=l;let p;function O(g){const y=c.$tn.as(N.$yn.Configuration),s=p;p={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:s?[s]:[]})}O(1)}),define(te[136],ne([0,1,20,15,12,44]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;let N=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,P=L.CancellationToken.None){if(h.scheme===R.Schemas.file||h.scheme===R.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,P);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,A.$$o)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$qO=N,e.$qO=N=pe([ie(0,A.$6o),ie(1,j.$lk)],N)}),define(te[137],ne([0,1,138,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;function j(N,E){return N.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:N.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function A(N,E,h={}){const c=(0,L.parse)(N),P=h.proxyUrl||j(c,E);if(!P)return null;const I=(0,L.parse)(P);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,R.$Kf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,S)=>{G(["http-proxy-agent"],f,S)})).HttpProxyAgent(P,d):new(await new Promise((f,S)=>{G(["https-proxy-agent"],f,S)})).HttpsProxyAgent(P,d)}e.$$q=A}),define(te[139],ne([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;let S;async function v(l,p,O,g){return O["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$1l)(g)&&!O["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$1l)(g)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=d.Promises.withAsyncBody(async(y,s)=>{const o=new A.$3d;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$2l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,j.localize)(0,null)))},t);try{y(await $(p,o.token))}catch(r){!(0,E.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,j.localize)(1,null,(0,N.$Mi)(r)))):y({})}finally{clearTimeout(n),o.dispose()}})),S)}e.$7l=v;async function $(l,p){const O=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",O);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",g);const y=(0,c.$mg)().replace(/-/g,"").substr(0,12),s=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$Ql)(h.OS,o);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(p.isCancellationRequested)return n(new E.$5);const r=(0,R.$nc)(t);let u,k;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(u=`& '${process.execPath}' ${b} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,k=["-Login","-Command"]):r==="nu"?(u=`^'${process.execPath}' ${b} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,k=["-i","-l","-c"]):(u=`'${process.execPath}' ${b} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),u);const w=(0,L.spawn)(t,[...k,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(w.kill(),n(new E.$5))),w.on("error",ee=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.$Mi)(ee)),n(ee)});const D=[];w.stdout.on("data",ee=>D.push(ee));const H=[];w.stderr.on("data",ee=>H.push(ee)),w.on("close",(ee,_)=>{const re=Buffer.concat(D).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(H).toString("utf8");if(se.trim()&&l.trace("getUnixShellEnvironment#stderr",se),ee||_)return n(new Error((0,j.localize)(2,null,ee,_)));const ue=s.exec(re),ce=ue?ue[1]:"{}";try{const oe=JSON.parse(ce);O?oe.ELECTRON_RUN_AS_NODE=O:delete oe.ELECTRON_RUN_AS_NODE,g?oe.ELECTRON_NO_ATTACH_CONSOLE=g:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){l.error("getUnixShellEnvironment#errorCaught",(0,N.$Mi)(oe)),n(oe)}})})}}),define(te[140],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0,e.$5N=(0,L.$2h)("stateReadService"),e.$6N=(0,L.$2h)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=e.$8N=e.$7N=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class P extends j.$Sc{constructor(S,v,$,l){super(),this.h=S,this.j=v,this.m=$,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new L.$Zg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.m.error(S)}}getItem(S,v){const $=this.a[S];return(0,A.$Nf)($)?v:$}setItem(S,v){this.setItems([{key:S,data:v}])}setItems(S){let v=!1;for(const{key:$,data:l}of S)this.a[$]!==l&&((0,A.$Nf)(l)?(0,A.$Lf)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=l,v=!0));v&&this.s()}removeItem(S){(0,A.$Lf)(this.a[S])||(this.a[S]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.n.writeFile(this.h,R.$ge.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7N=P;let I=class extends j.$Sc{constructor(S,v,$,l){super(),this.a=this.B(new P(v.stateResource,S,$,l))}async init(){await this.a.init()}getItem(S,v){return this.a.getItem(S,v)}};e.$8N=I,e.$8N=I=pe([ie(1,N.$9h),ie(2,h.$jj),ie(3,E.$lk)],I);class d extends I{setItem(S,v){this.a.setItem(S,v)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$9N=d}),define(te[69],ne([0,1,13,35,28]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;function A(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function N(h,c,P,I,d,f,S,v,$){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=S,l.sessionID=(0,j.$mg)()+Date.now(),l.commitHash=I,l.version=d,l["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,L.$h)(L.$u),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=P,l["common.product"]=$||"desktop",v&&(l["common.msftInternal"]=v);let p=0;const O=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-O,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),L.$l&&(l["common.snap"]="true");const g=A(c);return g&&(l["common.platformDetail"]=g),l}e.$uo=N;function E(h){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return h.some(I=>P===I)}e.$vo=E}),define(te[26],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,L.$2h)("telemetryService"),e.$ql=(0,L.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var R;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var j;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$wo=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xo=P,e.$yo=new P;class I{async publicLog(n,r,u){}async publicLogError(n,r,u){}}e.$zo=I,e.$Ao="telemetry",e.$Bo="extensionTelemetryLog",e.$Co={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return j.Event.debounce(n.onDidChangeConfiguration,(u,k)=>{const b=u?new Set([...u.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:b}},1e3,!0)(u=>{u.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$yi)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.$Do=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Eo=f;function S(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Fo=S;function v(i){const n=i.getValue(h.$xl),r=i.getValue(h.$yl);if(i.getValue(h.$zl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Go=v;function $(i){const n={},r={},u={};O(i,u);for(let k in u){k=k.length>150?k.substr(k.length-149):k;const b=u[k];typeof b=="number"?r[k]=b:typeof b=="boolean"?r[k]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${b.length}`),n[k]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(n[k]=b)}return{properties:n,measurements:r}}e.$Ho=$;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const n=(0,N.$9k)(i);return l.has(n)?n:"other"}e.$Io=p;function O(i,n,r=0,u){if(i)for(const k of Object.getOwnPropertyNames(i)){const b=i[k],w=u?u+k:k;Array.isArray(b)?n[w]=(0,L.$mn)(b):b instanceof Date?n[w]=b.toISOString():(0,R.$Gf)(b)?r<2?O(b,n,r+1,w+"."):n[w]=(0,L.$mn)(b):n[w]=b}}function g(i,n){const r=i.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,E.$vo)(r)||u}e.$Jo=g;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ko=y;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const u=[];for(const D of n)for(;;){const H=D.exec(i);if(!H)break;u.push([H.index,D.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const D=b.exec(i);if(!D)break;const H=u.some(([ee,_])=>D.index<_&&ee<b.lastIndex);!k.test(D[0])&&!H&&(r+=i.substring(w,D.index)+"<REDACTED: user-file-path>",w=b.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$jn)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let u=r.replaceAll("%20"," ");u=s(u,n);for(const k of n)u=u.replace(k,"");return u=o(u),u}})}e.$Lo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$3e)(t.id,i.id)===0}e.$Mo=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$No=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(t){const i=f.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$Oo=S;function v(t,i){return`${t}.${i}`}e.$Po=v;function $(t){return t.toLowerCase()}e.$Qo=$;function l(t,i){return $(v(t??j.$cm,i))}e.$Ro=l;function p(t,i){const n=[],r=u=>{for(const k of n)if(k.some(b=>P(i(b),i(u))))return k;return null};for(const u of t){const k=r(u);k?k.push(u):n.push([u])}return n}e.$So=p;function O(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$To=O;function g(t){return{id:new c.$wo(t.identifier.id),name:new c.$wo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Uo=g,e.$Vo=new j.$gm("pprice.better-merge");function y(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const u=r.shift();if(u&&n.every(k=>!P(k.identifier,{id:u}))){const k=t.filter(b=>P(b.identifier,{id:u}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Wo=y;async function s(t,i){if(!A.$k)return!1;let n;try{n=(await t.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,E.$0)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,R.$go)(n?"alpine":A.$u,h.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Xo=o}),define(te[141],ne([0,1,20,9,15,17,42,11,94,21,27,37]),function(G,e,L,R,j,A,N,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;const d=$=>(0,h.localize)(0,null,$),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function S($,l){return l?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(l,p,O){this.a=l,this.b=p,this.d=O}get f(){}async listExtensions(l,p,O){let g=await this.b.getInstalled(1,O);const y=I.$fm.map(o=>o.toLowerCase());if(p&&p!==""){if(y.indexOf(p.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){this.a.info("Possible Categories: "),y.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),g=g.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of g)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(S(o.manifest,l)))}async installExtensions(l,p,O,g){const y=[];try{const s=[];l.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,u,k)=>{t.push({id:r,version:u!=="prerelease"?u:void 0,installOptions:{...O,isBuiltin:k,installPreReleaseVersion:u==="prerelease"||O.installPreReleaseVersion}})};for(const r of l)if(r instanceof E.URI)o.push({vsix:r,installOptions:O});else{const[u,k]=(0,P.$Oo)(r);i(u,k,!1)}for(const r of p)if(r instanceof E.URI)o.push({vsix:r,installOptions:{...O,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[u,k]=(0,P.$Oo)(r);i(u,k,!0)}const n=await this.b.getInstalled(1,O.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:u})=>{try{const k=await this.g(r,u,g,n);k&&s.push(k)}catch(k){this.a.error(k),y.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:u})=>{const k=n.find(b=>(0,P.$Mo)(b.identifier,{id:r}));if(k){if(!g&&(!u||u==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(u&&k.manifest.version===u)return this.a.info((0,h.localize)(6,null,`${r}@${u}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async u=>{const k=r.get(u.id.toLowerCase());if(k)try{const b=await this.j(u,k,n);b&&s.push(b)}catch(b){this.a.error(b.message||b.stack||b),y.push(u.id)}else this.a.error(`${d(u.version?`${u.id}@${u.version}`:u.id)}
${f}`),y.push(u.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,R.$0)(s))),s}if(y.length)throw new Error((0,h.localize)(8,null,y.join(", ")))}async g(l,p,O,g){const y=await this.b.getManifest(l);if(!y)throw new Error("Invalid vsix");if(await this.l(y,O,p.profileLocation,g))try{return await this.b.install(l,p),this.a.info((0,h.localize)(9,null,(0,A.$Ag)(l))),y}catch(o){if((0,R.$4)(o))return this.a.info((0,h.localize)(10,null,(0,A.$Ag)(l))),null;throw o}return null}async h(l){const p=new Map,O=l.some(s=>s.installOptions.installPreReleaseVersion),g=await this.b.getTargetPlatform(),y=[];for(const s of l)c.$_n.test(s.id)&&y.push({...s,preRelease:O});if(y.length){const s=await this.d.getExtensions(y,{targetPlatform:g},L.CancellationToken.None);for(const o of s)p.set(o.identifier.id.toLowerCase(),o)}return p}async j({id:l,version:p,installOptions:O},g,y){const s=await this.d.getManifest(g,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=y.find(t=>(0,P.$Mo)(t.identifier,g.identifier));if(o){if(g.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,p?`${l}@${p}`:l)),null;this.a.info((0,h.localize)(12,null,l,g.version))}try{O.isBuiltin?this.a.info(p?(0,h.localize)(13,null,l,p):(0,h.localize)(14,null,l)):this.a.info(p?(0,h.localize)(15,null,l,p):(0,h.localize)(16,null,l));const t=await this.b.installFromGallery(g,{...O,installGivenVersion:!!p});return this.a.info((0,h.localize)(17,null,l,t.manifest.version)),s}catch(t){if((0,R.$4)(t))return this.a.info((0,h.localize)(18,null,l)),null;throw t}}k(l){return!0}async l(l,p,O,g){if(!p){const y={id:(0,P.$Ro)(l.publisher,l.name)},s=g.find(o=>(0,P.$Mo)(y,o.identifier)&&(0,N.gt)(o.manifest.version,l.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,l.version)),!1}return this.k(l)}async uninstallExtensions(l,p,O){const g=async s=>{if(s instanceof E.URI){const o=await this.b.getManifest(s);return S(o)}return s},y=[];for(const s of l){const o=await g(s),i=(await this.b.getInstalled(void 0,O)).filter(n=>(0,P.$Mo)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!p&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:O}),y.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(l){const p=await this.b.getInstalled();l.forEach(O=>{p.forEach(g=>{if(g.identifier.id===O&&g.location.scheme===j.Schemas.file){this.a.info(g.location.fsPath);return}})})}m(l){return this.f?(0,h.localize)(25,null,l,this.f):(0,h.localize)(26,null,l)}};e.$tp=v,e.$tp=v=pe([ie(1,c.$mo),ie(2,c.$ko)],v)}),define(te[142],ne([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let g=class extends j.$Sc{static{O=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,N.$Dg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new S.$lo(r.message,S.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(u){const k=u;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(b){this.r.error(b)}throw new S.$lo(I.$xp,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(u){this.r.error(u)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Kf)(o)?o:!0}async u(s){await this.g;const o=(0,N.$Dg)(this.extensionsDownloadDir,`${this.z(s)}${O.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,N.$Dg)(this.extensionsDownloadDir,`.${(0,c.$mg)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const u of s.children)if(u.name.endsWith(O.c))i.push(u.resource);else{const k=v.$No.parse(u.name);k&&t.push([k,u])}const n=(0,v.$So)(t,([u])=>u),r=[];for(const u of n)u.sort((k,b)=>E.rcompare(k[0].version,b[0].version)),o.push(...u.slice(1).map(k=>k[1].resource)),r.push(u[0][1]);r.sort((u,k)=>u.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(u=>u.resource)),o.push(...i),await L.Promises.settled(o.map(u=>(this.r.trace("Deleting from cache",u.path),this.h.del(u))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$No.create(s).toString().toLowerCase():(0,c.$mg)()}};e.$Qp=g,e.$Qp=g=O=pe([ie(0,f.$0h),ie(1,l.$lk),ie(2,S.$ko),ie(3,d.$vi),ie(4,$.$rp),ie(5,p.$jj)],g)}),define(te[143],ne([0,1,4,2,31,27,37]),function(G,e,L,R,j,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class E extends R.$Sc{constructor(c,P,I,d,f,S,v){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=S,this.r=v,this.a=this.B(new L.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$2c),this.s().then(null,$=>v.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(P=>(this.c.set(P.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(c){for(const P of c.extensions)this.I(this.L(P.identifier,P.version),c.profileLocation)}async y(c){for(const P of c.extensions){const I=this.L(P.identifier,P.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const P of c.extensions)this.J(this.L(P.identifier,P.version),c.profileLocation)}async C(c){const P=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(S=>{S?P.push(S):this.r.info("Extension not found at the location",d.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(I),P.length&&await this.H(P)}catch(d){this.r.error(d)}}D(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(c){const P=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,S=new Set;for(const[v,$]of this.b)$.has(c)&&S.add(v);for(const v of d){const $=this.L(v.identifier,v.version);f.add($),S.has($)||(P.push(v.identifier),this.I($,c))}for(const v of S)if(!f.has(v)){const $=this.M(v);$&&(I.push($.identifier),this.J(v,c))}(P.length||I.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const P=await this.j.scanProfileExtensions(c);for(const I of P)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,P){let I=this.b.get(c);I||this.b.set(c,I=new j.$Bc(d=>this.m.extUri.getComparisonKey(d))),I.add(P)}J(c,P){const I=this.b.get(c);I&&I.delete(P),I?.size||this.b.delete(c)}L(c,P){return`${N.$gm.toKey(c.id)}@${P}`}M(c){const[P,I]=(0,A.$Oo)(c);return I?{identifier:{id:P},version:I}:void 0}}e.$Up=E}),define(te[144],ne([0,1,115,39]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function j(A,N,E,h,c,P,I){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,R.$Eo)(N,E)&&(0,R.$Go)(h)===3){const f=await(0,L.$mp)(E,c,P);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$np=j}),define(te[145],ne([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let v=class extends f.$7q{constructor(O,g,y,s){super(y),this.h=O,this.j=s,this.g=this.B(new $(g,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(O,g){const s=(await this.g.getLanguagePacks())[g];if(!s){this.j.warn(`No language pack found for ${g}`);return}const o=s.translations[O];return o?S.URI.file(o):void 0}async getInstalledLanguages(){const O=await this.g.getLanguagePacks(),g=Object.keys(O).map(y=>{const s=O[y];return{...this.f(y,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((y,s)=>y.label.localeCompare(s.label)),g}async m(O){O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",O.identifier.id),await this.update())}async n(O){const g=await this.g.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(s=>(0,I.$Mo)(s.extensionIdentifier,O.identifier)))&&(this.j.info("Removing language packs from the extension",O.identifier.id),await this.update())}async update(){const[O,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(g);return!(0,R.$ub)(Object.keys(O),Object.keys(y))}};e.$8q=v,e.$8q=v=pe([ie(0,P.$mo),ie(1,c.$0h),ie(2,P.$ko),ie(3,d.$jj)],v);let $=class extends A.$Sc{constructor(O,g){super(),this.j=g,this.c={},this.f=(0,E.$jc)(O.userDataPath,"languagepacks.json"),this.g=new j.$9g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(O){return this.s(g=>{Object.keys(g).forEach(y=>delete g[y]),this.m(g,...O)}).then(()=>this.c)}m(O,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(O,y);Object.keys(O).forEach(y=>this.r(O[y]))}n(O,g){const y=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of s)if(g.location.scheme===N.Schemas.file&&l(o)){let t=O[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},O[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Mo)(n.extensionIdentifier,y))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,E.$jc)(g.location.fsPath,n.path)}}r(O){if(O){const g=(0,L.createHash)("md5");for(const y of O.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);O.hash=g.digest("hex")}}s(O=()=>null){return this.g.queue(()=>{let g=null;return h.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(g=O(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>g,y=>this.j.error(y))})}};$=pe([ie(0,c.$0h),ie(1,d.$jj)],$);function l(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const O of p.translations)if(typeof O.id!="string"||typeof O.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(te[146],ne([0,1,81,9,30,39]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function h(P,I,d){const f=await(0,L.$YC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,L.$YC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new f.AppInsightsCore,$=new S.PostChannel,l={instrumentationKey:P,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(d){l.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:d};l.extensionConfig[$.identifier]=p}return v.initialize(l,[]),v.addTelemetryInitializer(p=>{I&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),v}class c{constructor(I,d,f,S,v){this.e=I,this.f=d,this.g=f,this.h=v,this.c=N,this.d=E,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,R.$1)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,j.$kn)(d,this.g),d=(0,A.$Ho)(d);const f=this.f+"/"+I;try{this.i(S=>{S.pluginVersionString=d?.properties.version??"Unknown",S.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$1N=c}),define(te[147],ne([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,p,O){this.k=p,this.l=O,this.d={},this.i=new L.$Rc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,A.$Ke)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ke)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(d.$xl)||g.affectsConfiguration(d.$zl)||g.affectsConfiguration(d.$yl))&&this.m()}))}setExperimentProperty(l,p){this.d[l]=p}m(){let l=(0,f.$Go)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const O=p.usage?3:p.error?2:0;l=Math.min(l,O)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,p,O){this.g<p||(O=(0,R.$kn)(O,this.d),O=(0,f.$Lo)(O,this.j),O=(0,R.$kn)(O,this.c),this.b.forEach(g=>g.log(l,O)))}publicLog(l,p){this.n(l,3,p)}publicLog2(l,p){this.publicLog(l,p)}publicLogError(l,p){this.h&&this.n(l,2,p)}publicLogError2(l,p){this.publicLogError(l,p)}};e.$br=S,e.$br=S=pe([ie(1,E.$vi),ie(2,P.$Bj)],S);function v(){const $=(0,N.localize)(0,null,c.default.nameLong),l=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=j.$o?"":(0,N.localize)(3,null),O=(0,N.localize)(4,null),g=(0,N.localize)(5,null),y=(0,N.localize)(6,null),s=(0,N.localize)(7,null),o=`
|       | ${O} | ${g} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${$} ${l} ${p}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$tn.as(h.$yn.Configuration).registerConfiguration({id:d.$wl,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[d.$xl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$tn.as(h.$yn.Configuration).registerConfiguration({id:d.$wl,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[d.$zl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${d.$xl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[149],ne([0,1,14,20,173,146]),function(G,e,L,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;async function N(P,I){const d=await I.request(P,R.CancellationToken.None),f=(await(0,L.$se)(d.stream)).toString(),S=d.res.statusCode??200;return{headers:d.res.headers,statusCode:S,responseData:f}}async function E(P){const I={method:P.type,headers:P.headers};return new Promise((f,S)=>{const v=j.request(P.url??"",I,$=>{$.on("data",function(l){f({headers:$.headers,statusCode:$.statusCode??200,responseData:l.toString()})}),$.on("error",function(l){S(l)})});v.write(P.data,$=>{$&&S($)}),v.end()})}async function h(P,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),S={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const v=P?await N(S,P):await E(S);d(v.statusCode,v.headers,v.responseData)}catch{d(0,{})}}class c extends A.$1N{constructor(I,d,f,S,v){const $={sendPOST:(l,p)=>{h(I,l,p)}};super(d,f,S,v,$)}}e.$2N=c}),define(te[150],ne([0,1,16,24]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=void 0;async function j(A,N){const E=Object.create(null),h=(P,I)=>{const d=JSON.parse(P);E[I]=d};if(N){const P=[],I=await R.Promises.readdir(N);for(const f of I)try{(await R.Promises.stat((0,L.$jc)(N,f))).isDirectory()&&P.push(f)}catch{}const d=[];for(const f of P)(await R.Promises.readdir((0,L.$jc)(N,f))).filter(v=>v==="telemetry.json").length===1&&d.push(f);for(const f of d){const S=(await R.Promises.readFile((0,L.$jc)(N,f,"telemetry.json"))).toString();h(S,f)}}let c=(await R.Promises.readFile((0,L.$jc)(A,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await R.Promises.readFile((0,L.$jc)(A,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(E,null,4)}e.$y$b=j}),define(te[151],ne([0,1,13,82,26]),function(G,e,L,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=void 0;async function A(E,h){let c=E.getItem(j.$ul);return(typeof c!="string"||L.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$6m)(h.error.bind(h))),c}e.$Q0b=A;async function N(E,h){let c=E.getItem(j.$vl);return typeof c!="string"&&(c=await(0,R.$7m)(h.error.bind(h))),c}e.$R0b=N}),define(te[22],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,L.$2h)("IUriIdentityService")}),define(te[152],ne([0,1,22,116,12,17,73,4,2]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let P=class{constructor(d){this.g=d,this.c=new h.$Rc,this.f=2**16;const f=new Map,S=v=>{let $=f.get(v.scheme);return $===void 0&&($=d.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,$)),$};this.c.add(E.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new A.$sg(S),this.d=new N.$Lr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Eg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((S,v)=>S[1].time<v[1].time?1:S[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let S=0;S<f;S++)this.d.set(d[S][0],d[S][1].touch())}};e.$Mr=P,e.$Mr=P=pe([ie(0,j.$lk)],P),(0,R.$Jr)(L.$Vk,P,1)}),define(te[153],ne([0,1,4,2,12,47,31]),function(G,e,L,R,j,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;class E extends R.$Sc{constructor(c,P,I,d,f,S){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=A.$8h.forUris(()=>!(this.capabilities&1024)),this.c=new N.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,P){return this.g.open(this.t(c),P)}close(c){return this.g.close(c)}read(c,P,I,d,f){return this.g.read(c,P,I,d,f)}write(c,P,I,d,f){return this.g.write(c,P,I,d,f)}watch(c,P){this.b.set(c,c);const I=this.g.watch(this.t(c),P);return(0,R.$Qc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,P,I){return this.g.rename(this.t(c),this.t(P),I)}readFile(c,P){return this.g.readFile(this.t(c),P)}readFileStream(c,P,I){return this.g.readFileStream(this.t(c),P,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,P,I){return this.g.writeFile(this.t(c),P,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,P){return this.g.delete(this.t(c),P)}copy(c,P,I){if((0,j.$pk)(this.g))return this.g.copy(this.t(c),this.t(P),I);throw new Error("copy not supported")}cloneFile(c,P){if((0,j.$qk)(this.g))return this.g.cloneFile(this.t(c),this.t(P));throw new Error("clone not supported")}s(c){const P=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&P.push({resource:d,type:I.type,cId:I.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$c$b=E}),define(te[154],ne([0,1,108,16,47,17,11,10,15]),function(G,e,L,R,j,A,N,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,E.$2h)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$_h=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$ai=P,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$bi:e.$ci;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$di=I;function d(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$ei=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$fi=f;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$gi=v;function $(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$hi=$;class l{constructor(n,r,u,k,b){this.h=n,this.j=u,this.k=k,this.l=b,this.c=j.$8h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=j.$8h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=l;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$Dg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=p;function O(i){return new p({uri:i,index:0,name:(0,A.$zg)(i)},{uri:i.toString()})}e.$ki=O,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,L.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function g(i,n){return A.$ug.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$pi=g;function y(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$qi=y,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ri}e.$si=s;function o(i,n){return!g(i,n)&&!y(i)}e.$ti=o;function t(i){return(typeof i=="string"?(0,R.$oc)(i):(0,A.$Bg)(i))===e.$mi}e.$ui=t}),define(te[23],ne([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var O;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Wk=g,e.$Xk=(0,P.$2h)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Yk=y;function s(i,n,r,u,k,b){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:b&&k?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$Dg)(r,"globalStorage"),settingsResource:b&&k?.useDefaultFlags?.settings?b.settingsResource:(0,A.$Dg)(r,"settings.json"),keybindingsResource:b&&k?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$Dg)(r,"keybindings.json"),tasksResource:b&&k?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$Dg)(r,"tasks.json"),snippetsHome:b&&k?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$Dg)(r,"snippets"),extensionsResource:b&&k?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$Dg)(r,"extensions.json"),cacheHome:(0,A.$Dg)(u,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Zk=s;let o=class extends j.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,u,k){super(),this.t=n,this.u=r,this.w=u,this.y=k,this.f=!0,this.h=this.B(new R.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,p.$Ef)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(s((0,A.$Ag)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},n))}}catch(b){this.y.error(b)}const u=new f.$Ac,k=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[w,D]of Object.entries(b.workspaces)){const H=N.URI.parse(w),ee=r.find(_=>_.id===D);ee&&u.set(H,ee)}if(b.emptyWindows)for(const[w,D]of Object.entries(b.emptyWindows)){const H=r.find(ee=>ee.id===D);H&&k.set(w,H)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:u,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",u=new RegExp(`${(0,l.$Ke)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const D=u.exec(w.name),H=D?parseInt(D[1]):0;k=H>k?H:k}const b=`${r} ${k+1}`;return this.createProfile((0,L.$Pi)((0,$.$mg)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,r,u){return this.createProfile((0,L.$Pi)((0,$.$mg)()).toString(16),n,r,u)}async createProfile(n,r,u,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(n,r,u);return k&&await this.setProfileForWorkspace(k,b),b}async F(n,r,u){if(!(0,p.$Ef)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const b=this.profiles.find(H=>H.name===r||H.id===n);if(b)return b;const w=s(n,r,(0,A.$Dg)(this.profilesHome,n),this.g,u,this.defaultProfile);await this.u.createFolder(w.location);const D=[];return this.j.fire({profile:w,join(H){D.push(H)}}),await v.Promises.settled(D),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(k=>k.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=s(u.id,r.name??u.name,u.location,this.g,{shortName:r.shortName??u.shortName,icon:r.icon===null?void 0:r.icon??u.icon,transient:r.transient??u.isTransient,useDefaultFlags:r.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this.m.fire({profile:r,join(k){u.push(k)}});try{await Promise.allSettled(u)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$Ck)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(k=>k.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,u)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return N.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$_h)(n)?n.uri:(0,d.$ei)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,u){const k=[...this.profiles,...n],b=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(D=>w.id===D.id)||(w=u.find(D=>w.id===D.id)??w,w.isTransient?this.s.profiles.push(w):b.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(b),this.z=void 0,this.J(n,r,u)}J(n,r,u){this.h.fire({added:n,removed:r,updated:u,all:this.profiles})}L(n,r,u){u=r?.isTransient?!0:u,u||this.L(n,void 0,!0);const k=this.G(n),b=u?this.s:this.C;N.URI.isUri(k)?(b.workspaces.delete(k),r&&b.workspaces.set(k,r)):(b.emptyWindows.delete(k),r&&b.emptyWindows.set(k,r)),u||this.M()}M(){const n={};for(const[u,k]of this.C.workspaces.entries())n[u.toString()]=k.id;const r={};for(const[u,k]of this.C.emptyWindows.entries())r[u.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},u=this.D();if(n.workspaces)for(const[b,w]of Object.entries(n.workspaces)){const D=N.URI.parse(w);r[b]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}const k={};if(n.emptyWindows)for(const[b,w]of Object.entries(n.emptyWindows)){const D=N.URI.parse(w);k[b]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$1k=o,e.$1k=o=pe([ie(0,h.$9h),ie(1,c.$lk),ie(2,S.$Vk),ie(3,I.$jj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$2k=t}),define(te[155],ne([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;let g=class extends E.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,u,k,b,w){super(),this.z=n,this.C=r,this.D=u,this.F=k,this.G=b,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$Sd),this.s=this.B(new N.$Sd),this.t=this.B(new N.$Sd),this.u=this.B(new N.$Sd),this.w=this.B(new N.$Sd),this.y=[],this.B((0,E.$Qc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(u=>(0,d.$io)(u,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:b})=>(0,f.$Mo)(b,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(u){throw s(u)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$lo(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],u=[];await Promise.allSettled(n.map(async({extension:k,options:b})=>{try{const w=await this.O(k,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);u.push({...w,options:b})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),u.length&&r.push(...await this.I(u));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!P.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Uo)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,S.$jm)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let u=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(u=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const b=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$Mo)(w.identifier,n.identifier));b?this.w.fire(b):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:2,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async u=>{try{const k=await this.J(u,(b,w)=>n.some(D=>(0,f.$Qo)(w.identifier.id)===(0,f.$Ro)(D.manifest.publisher,D.manifest.name))?!1:this.L(b,w));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$Ro)(u.manifest.publisher,u.manifest.name)},operation:2,source:u.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:u},k){const b=u.isApplicationScoped||u.isBuiltin||(0,S.$jm)(n),w={...u,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?u.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.H.defaultProfile.extensionsResource:u.profileLocation??this.Y()},D=ue=>`${f.$No.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const ue=this.j.get(D(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const H=[],ee=[],_=[],re=this.Z(n,r,w);P.URI.isUri(r)||this.j.set(D(r),{task:re,waitingTasks:[]}),this.n.fire({identifier:re.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",re.identifier.id),H.push({task:re,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",re.identifier.id);else try{const ce=await this.N(re.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),oe=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[d.$do]:!0}};for(const{gallery:X,manifest:T}of(0,L.$Mb)(ce,({gallery:C})=>C.identifier.id)){se=se||!!T.extensionDependencies?.some(J=>(0,f.$Mo)({id:J},re.identifier));const C=D(X),V=this.j.get(C);if(V){if(k(re,V.task)){const J=V.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,re.identifier.id),V.waitingTasks.push(re),ee.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,Y=>Y.some(K=>(0,f.$Mo)(K.identifier,J)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,re.identifier.id),!Y.find(F=>(0,f.$Mo)(F.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!oe.some(({identifier:J})=>(0,f.$Mo)(J,X.identifier))){const J=this.Z(T,X,q);this.j.set(C,{task:J,waitingTasks:[re]}),this.n.fire({identifier:J.identifier,source:X,profileLocation:w.profileLocation}),this.F.info("Installing extension:",J.identifier.id,re.identifier.id),H.push({task:J,manifest:T})}}}catch(ce){if(P.URI.isUri(re.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",re.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",re.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",re.identifier.id),ce}const ue=H.reduce((ce,{task:oe,manifest:q})=>(ce.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:q}),ce),new Map);for(;ue.size;){let ce;const oe=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));oe.length?ce=ue.size===1?oe:oe.filter(({task:q})=>!(q===re&&!se)):(this.F.info("Found extensions with circular dependencies",oe.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const X=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(C=>C.postInstall(T,q.source,w,j.CancellationToken.None))),!P.URI.isUri(q.source)){const C=q.operation===3,V=C?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,C?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Uo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:V}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}_.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw P.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Uo)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return ee.length&&await this.M(ee),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(ue){if(H.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:oe})=>this.$(oe,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let oe=0;oe<ce.length;oe++){const q=ce[oe],{identifier:X}=_[oe];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,A.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,A.$0)(ce),_.map(({identifier:oe})=>oe.id))}return H.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of H)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(D(ue.source))}}L(n,r){for(const[,{task:u,waitingTasks:k}]of this.j.entries())if(u===n&&(k.includes(r)||k.some(b=>this.L(b,r)))||u===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],u=[],k=await Promise.allSettled(n);for(const b of k)b.status==="fulfilled"?r.push(b.value):u.push(b.reason);if(u.length)throw y(u);return r}async N(n,r,u,k,b){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,b),D=[],H=[],ee=async(_,re)=>{D.push(_);const se=re.extensionDependencies||[],ue=[...se];if(re.extensionPack){const ce=u?w.find(oe=>(0,f.$Mo)(oe.identifier,_)):void 0;for(const oe of re.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Mo)({id:q},{id:oe}))||ue.every(q=>!(0,f.$Mo)({id:q},{id:oe}))&&ue.push(oe)}if(ue.length){const ce=ue.filter(oe=>D.every(q=>!(0,f.$Mo)(q,{id:oe})));if(ce.length){const oe=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),j.CancellationToken.None);for(const q of oe){if(D.find(C=>(0,f.$Mo)(C,q.identifier)))continue;const X=se.some(C=>(0,f.$Mo)({id:C},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(C){if(X)throw C;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$0)(C));continue}H.push({gallery:T.extension,manifest:T.manifest}),await ee(T.extension.identifier,T.manifest)}}}};return await ee(n,r),H}async O(n,r,u){let k;const b=await this.getExtensionsControlManifest();if(b.malicious.some(H=>(0,f.$Mo)(n.identifier,H)))throw new d.$lo(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=b.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!k)throw new d.$lo(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new d.$lo(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$eo)(H)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,u),!k)throw!u&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],j.CancellationToken.None))[0]?new d.$lo(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$lo(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const D=await this.z.getManifest(k,j.CancellationToken.None);if(D===null)throw new d.$lo(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(D.version!==k.version)throw new d.$lo(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:D}}async P(n,r,u){const k=await this.getTargetPlatform();let b=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==u&&(b=(await this.z.getExtensions([{...n.identifier,preRelease:u}],{targetPlatform:k,compatible:!0},j.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(n,u,k)&&(b=n),b||(r?b=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},j.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(n,u,k)),b}async Q(n,r){const u={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=_=>`${_.id.toLowerCase()}${u.versionOnly?`-${n.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,b=this.m.get(k(n.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),b.waitUntilTaskIsFinished();const w=_=>{const re=this.$(_,u);return this.m.set(k(re.extension.identifier),re),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:u.profileLocation,applicationScoped:_.isApplicationScoped}),re},D=(_,re)=>{re?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString(),re.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,re.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$To)(_),error:re}),this.u.fire({identifier:_.identifier,error:re?.code,profileLocation:u.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],ee=[];try{H.push(w(n));const _=await this.getInstalled(1,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.U(n,_);for(const se of re)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):H.push(w(se))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(re=>re.extension),_,n),await this.M(H.map(async re=>{try{if(await re.run(),await this.M(this.y.map(se=>se.postUninstall(re.extension,u,j.CancellationToken.None))),re.extension.identifier.uuid)try{await this.z.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}D(re.extension)}catch(se){const ue=se instanceof d.$lo?se:new d.$lo((0,A.$0)(se),d.ExtensionManagementErrorCode.Internal);throw D(re.extension,ue),ue}finally{ee.push(re)}}))}catch(_){const re=_ instanceof d.$lo?_:new d.$lo((0,A.$0)(_),d.ExtensionManagementErrorCode.Internal);for(const se of H){try{se.cancel()}catch{}ee.includes(se)||D(se.extension,re)}throw re}finally{for(const _ of H)this.m.delete(k(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,u){for(const k of n){const b=this.W(k,r);if(b.length){const w=b.filter(D=>!n.some(H=>(0,f.$Mo)(H.identifier,D.identifier)));if(w.length)throw new Error(this.S(k,w,u))}}}S(n,r,u){return u===n?r.length===1?I.localize(6,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,u=[]){if(u.indexOf(n)!==-1)return[];u.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const b=r.filter(D=>!D.isBuiltin&&k.some(H=>(0,f.$Mo)({id:H},D.identifier))),w=[];for(const D of b)w.push(...this.U(D,r,u));return[...b,...w]}return[]}W(n,r){return r.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(k=>(0,f.$Mo)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Cp=g,e.$Cp=g=pe([ie(0,d.$ko),ie(1,l.$pl),ie(2,p.$Vk),ie(3,v.$jj),ie(4,$.$Bj),ie(5,O.$Xk)],g);function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,u)=>new Error(`${r.message}${r.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}e.$Dp=y;function s(i){if(i instanceof d.$lo)return i;const n=new d.$lo(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Ep=s;function o(i,n,{extensionData:r,verificationStatus:u,duration:k,error:b,durationSinceUpdate:w}){let D,H;(0,c.$Mf)(u)&&(u===!0?u="Verified":(u===!1||(D=d.ExtensionManagementErrorCode.Signature,H=u),u="Unverified")),b&&(b instanceof d.$lo?(D=b.code,b.code===d.ExtensionManagementErrorCode.Signature&&(H=b.message)):D=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:u,success:!b,duration:k,errorcode:D,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new R.$1g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Pg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Pg)(n=>new Promise((r,u)=>{const k=n.onCancellationRequested(()=>{k.dispose(),u(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$Fp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class O extends Error{constructor(t,i){super(t),this.code=i}}e.$Gp=O,e.$Hp=(0,I.$2h)("IExtensionsProfileScannerService");let g=class extends j.$Sc{constructor(t,i,n,r,u,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=u,this.t=k,this.b=this.B(new A.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new N.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,u=>{const k=[];for(const b of u)t.some(([w])=>(0,c.$Mo)(w.identifier,b.identifier)&&w.manifest.version!==b.version)?n.push(b):k.push(b);for(const[b,w]of t){const D=k.findIndex(ee=>(0,c.$Mo)(ee.identifier,b.identifier)&&ee.version===b.manifest.version),H={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:w};D===-1?(r.push(H),k.push(H)):k.splice(D,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(u){throw r.length&&this.c.fire({extensions:r,error:u,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:u,profileLocation:i}),u}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const u=[];for(const k of r){const b=t.find(([w])=>(0,c.$Mo)(w.identifier,k.identifier)&&w.manifest.version===k.version);b&&(k.metadata={...k.metadata,...b[1]},n.push(k)),u.push(k)}return u}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const u=[];for(const k of r)(0,c.$Mo)(k.identifier,t.identifier)?n.push(k):u.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),u}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],u;try{const k=await this.m.readFile(t);u=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,P.$Ck)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&n?.bailOutWhenFileNotFound)throw new O((0,$.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.w(t);let k=!1;for(const b of u){y(b)||this.w(t);let w;if((0,v.$Ef)(b.relativeLocation)&&b.relativeLocation)w=this.z(b.relativeLocation);else if((0,v.$Ef)(b.location))w=this.z(b.location),k=!0,b.relativeLocation=b.location,b.location=w.toJSON();else{w=E.URI.revive(b.location);const D=this.y(w);D&&(k=!0,b.relativeLocation=D)}r.push({identifier:b.identifier,location:w,version:b.version,metadata:b.metadata})}k&&await this.m.writeFile(t,R.$ge.fromString(JSON.stringify(u)))}if(i){r=i(r);const k=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(t,R.$ge.fromString(JSON.stringify(k)))}return r})}w(t){const i=new O(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(u){if((0,P.$Ck)(u)===1)return;throw u}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const u=JSON.parse(n);Array.isArray(u)&&u.every(k=>y(k))?r=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ge.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,P.$Ck)(u)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(t)}catch(u){(0,P.$Ck)(u)!==1&&this.t.error(u)}try{await this.m.del(i)}catch(u){(0,P.$Ck)(u)!==1&&this.t.error(u)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$9g,this.h.set(t,i)),i}};e.$Ip=g,e.$Ip=g=pe([ie(1,P.$lk),ie(2,f.$Xk),ie(3,S.$Vk),ie(4,l.$pl),ie(5,d.$jj)],g);function y(o){return(0,v.$Gf)(o)&&(0,h.$jo)(o.identifier)&&(s(o.location)||(0,v.$Ef)(o.location)&&o.location)&&((0,v.$Lf)(o.relativeLocation)||(0,v.$Ef)(o.relativeLocation))&&o.version&&(0,v.$Ef)(o.version)}function s(o){return o?(0,v.$Ef)(o.path)&&(0,v.$Ef)(o.scheme):!1}}),define(te[51],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O,g,y,s,o,t,i,n,r,u,k,b,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.Translations=void 0;var H;(function(oe){function q(X,T){if(X===T)return!0;const C=Object.keys(X),V=new Set;for(const J of Object.keys(T))V.add(J);if(C.length!==V.size)return!1;for(const J of C){if(X[J]!==T[J])return!1;V.delete(J)}return V.size===0}oe.equals=q})(H||(e.Translations=H={})),e.$Lp=(0,t.$2h)("IExtensionsScannerService");let ee=class extends c.$Sc{constructor(q,X,T,C,V,J,Y,K,F,M,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=C,this.t=V,this.u=J,this.w=Y,this.y=K,this.z=F,this.C=M,this.D=a,this.F=m,this.g=this.B(new r.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Dg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Xo)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[C,V]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),J=T?await this.scanExtensionsUnderDevelopment(q,[...C,...V]):[];return this.L(C,V,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,C]=await Promise.all(X);return this.J([...T,...C],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),V=q.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let J;try{J=await V.scanExtensions(C)}catch(Y){if(Y instanceof k.$Gp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await V.scanExtensions(C);else throw Y}return J=await this.J(J,1,q,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===P.Schemas.file).map(async C=>{const V=await this.P(C,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(Y=>(Y.type=X.find(K=>(0,g.$Mo)(K.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,V)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const C=await this.P(q,!1,X,!0,T.language,!0,void 0),V=await this.n.scanExtension(C);return!V||!T.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(q,X,T){const C=await this.P(q,!1,X,!0,T.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(C);return this.J(V,X,T,!0)}async scanMetadata(q){const X=(0,f.$Dg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$Dg)(q,"package.json"),C=(await this.w.readFile(T)).value.toString(),V=JSON.parse(C);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,V.__metadata={...V.__metadata,...X},await this.w.writeFile((0,f.$Dg)(q,"package.json"),A.$ge.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$Gp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ge.fromString(JSON.stringify([])))}catch(X){(0,o.$Ck)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,C){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),C)),T.includeInvalid||(q=q.filter(V=>V.isValid)),q.sort((V,J)=>{const Y=I.$nc(V.location.fsPath),K=I.$nc(J.location.fsPath);return Y<K?-1:Y>K?1:0})}L(q,X,T,C,V){const J=(K,F,M)=>{if(K.isValid&&!F.isValid)return!1;if(K.isValid===F.isValid){if(V&&S.gt(K.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(S.eq(K.manifest.version,F.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===C)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return M?this.y.warn(`Overwriting user extension ${K.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${F.location.path}.`),!0},Y=new y.$im;return q?.forEach(K=>{const F=Y.get(K.identifier.id);(!F||J(F,K,!1))&&Y.set(K.identifier.id,K)}),X?.forEach(K=>{const F=Y.get(K.identifier.id);if(!F&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!F||J(F,K,!1))&&Y.set(K.identifier.id,K)}),T?.forEach(K=>{const F=Y.get(K.identifier.id);(!F||J(F,K,!0))&&Y.set(K.identifier.id,K),Y.set(K.identifier.id,K)}),[...Y.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),V=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",V.length),V}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const C=X?await this.O():{},V=[],J=l.URI.file(I.$hc(I.$jc(P.$kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const F=C[K.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":V.push((0,f.$Dg)(J,K.name));break;default:V.push(l.URI.file(F));break}}const Y=await Promise.all(V.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Hb)(Y)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,C,V,J,Y){const K=await this.f(V??d.$w),F=await this.Q(q),M=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=M?await this.Q(M):void 0;return new _(q,F,M,a,X,Y,T,C,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,K)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Mp=ee,e.$Mp=ee=pe([ie(4,b.$Xk),ie(5,k.$Hp),ie(6,o.$lk),ie(7,i.$jj),ie(8,O.$9h),ie(9,n.$Bj),ie(10,w.$Vk),ie(11,t.$1h)],ee);class _{constructor(q,X,T,C,V,J,Y,K,F,M,a,m,z,U,Q){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=C,this.profile=V,this.profileScanOptions=J,this.type=Y,this.excludeObsolete=K,this.validate=F,this.productVersion=M,this.productDate=a,this.productCommit=m,this.devMode=z,this.language=U,this.translations=Q}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$wg)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$wg)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&j.$ln(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&H.equals(q.translations,X.translations)}}e.$Np=_;let re=class extends c.$Sc{constructor(q,X,T,C,V){super(),this.f=q,this.g=X,this.h=T,this.j=C,this.m=V}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(C)}catch{}return(0,$.$Rf)(T)?X:X.filter(C=>!T[g.$No.create(C).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async C=>{if(!C.isDirectory||q.type===1&&(0,f.$Ag)(C.resource).indexOf(".")===0)return null;const V=new _(C.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(V)}));return(0,L.$Hb)(T).sort((C,V)=>C.location.path<V.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(C=>!C.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const C=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!C.length)return[];const V=await Promise.all(C.map(async J=>{if(X(J)){const Y=new _(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,J.metadata)}return null}));return(0,L.$Hb)(V)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$Dg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,N.$0)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=y.$cm),X=X??T.__metadata,delete T.__metadata;const C=(0,g.$Ro)(T.publisher,T.name),V=X?.id?{id:C,uuid:X.id}:{id:C},J=X?.isSystem?0:q.type,Y=J===0||!!X?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const K={type:J,identifier:V,manifest:T,location:q.location,isBuiltin:Y,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const C=(0,s.$3o)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[V,J]of C)V===v.default.Error&&(T=!1,this.m.error(this.z(X.location,J)));return q.isValid=T,q.validations=C,q}async scanExtensionManifest(q){const X=(0,f.$Dg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(V){return(0,o.$Ck)(V)!==1&&this.m.error(this.z(q,(0,p.localize)(0,null,X.path,V.message))),null}let C;try{C=JSON.parse(T)}catch{const J=[];(0,E.$0m)(T,J);for(const Y of J)this.m.error(this.z(q,(0,p.localize)(1,null,X.path,Y.offset,Y.length,(0,h.$Jp)(Y.error))));return null}return(0,E.$gn)(C)!=="object"?(this.m.error(this.z(q,(0,p.localize)(2,null,X.path))),null):C}async t(q,X,T){const C=await this.u(q,X,T);if(C)try{const V=[],J=await this.w(C.default,V);if(V.length>0)return V.forEach(K=>{this.m.error(this.z(q,(0,p.localize)(3,null,C.default?.path,(0,h.$Jp)(K.error))))}),X;if((0,E.$gn)(C)!=="object")return this.m.error(this.z(q,(0,p.localize)(4,null,C.default?.path))),X;const Y=C.values||Object.create(null);return(0,D.$Kp)(this.m,X,Y,J)}catch{}return X}async u(q,X,T){const C=(0,f.$Dg)(q,"package.nls.json"),V=(F,M)=>{M.forEach(a=>{this.m.error(this.z(q,(0,p.localize)(5,null,F?.path,(0,h.$Jp)(a.error))))})},J=F=>{this.m.error(this.z(q,(0,p.localize)(6,null,F?.path)))},Y=`${X.publisher}.${X.name}`,K=T.translations[Y];if(K)try{const F=l.URI.file(K),M=(await this.j.readFile(F)).value.toString(),a=[],m=(0,E.$0m)(M,a);return a.length>0?(V(F,a),{values:void 0,default:C}):(0,E.$gn)(m)!=="object"?(J(F),{values:void 0,default:C}):{values:m.contents?m.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let M;try{M=await this.y(q,T)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const a=(await this.j.readFile(M.localized)).value.toString(),m=[],z=(0,E.$0m)(a,m);return m.length>0?(V(M.localized,m),{values:void 0,default:M.original}):(0,E.$gn)(z)!=="object"?(J(M.localized),{values:void 0,default:M.original}):{values:z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,E.$0m)(T,X)}catch{}}y(q,X){return new Promise((T,C)=>{const V=J=>{const Y=(0,f.$Dg)(q,`package.nls.${J}.json`);this.j.exists(Y).then(K=>{K&&T({localized:Y,original:(0,f.$Dg)(q,"package.nls.json")});const F=J.lastIndexOf("-");F===-1?T({localized:(0,f.$Dg)(q,"package.nls.json"),original:null}):(J=J.substring(0,F),V(J))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$Dg)(q,"package.nls.json"),original:null});V(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};re=pe([ie(1,k.$Hp),ie(2,w.$Vk),ie(3,o.$lk),ie(4,i.$jj)],re);let se=class extends re{constructor(q,X,T,C,V,J,Y){super(X,C,V,J,Y),this.G=q,this.H=T,this.D=this.B(new R.$Zg(3e3)),this.F=this.B(new r.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(V=>(V.location=l.URI.revive(V.location),V));const C=await super.scanExtensions(q);return await this.J(X,{input:q,result:C}),C}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,u.$yh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,N.$0)(X))}return null}async J(q,X){try{await this.j.writeFile(q,A.$ge.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,N.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$ln(C,T))try{this.m.info("Invalidating Cache",T,C),await this.j.del(q),this.F.fire()}catch(V){this.m.error(V)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?y.$bm:y.$am)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,b.$Xk),ie(3,k.$Hp),ie(4,w.$Vk),ie(5,o.$lk),ie(6,i.$jj)],se);function ue(oe,q){const X=(0,g.$Po)(oe.manifest.publisher,oe.manifest.name);return{id:X,identifier:new y.$gm(X),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:q,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$Op=ue;class ce extends ee{constructor(q,X,T,C,V,J,Y,K,F,M,a,m){super(q,X,(0,f.$Dg)(T,".vscode-oss-dev","extensions","control.json"),C,V,J,Y,K,F,M,a,m),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(l.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Pp=ce}),define(te[156],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,R,j,A,N,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let d=class extends N.$Sc{constructor(S,v){super(),this.b=S,this.f=v,this.a=new R.$8g(5)}async postUninstall(S){const v=this.g(S,"uninstall");v&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(S))}catch($){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error($)}}g(S,v){const $=`vscode:${v}`;if(S.location.scheme===E.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[$]=="string"){const l=S.manifest.scripts[$].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${$} should be a node script`),null):{script:(0,h.$jc)(S.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(S,v,$,l,p){return new Promise((O,g)=>{const y=this.j(S,v,$,p);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?g(t):O(void 0)};y.on("error",t=>{o((0,j.$Mi)(t)||"Unknown")}),y.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),l&&(s=setTimeout(()=>{s=null,y.kill(),g("timed out")},5e3))})}j(S,v,$,l){const p={silent:!0,execArgv:void 0},O=(0,L.fork)(S,[`--type=extension-post-${v}`,...$],p);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const g=A.Event.fromNodeEventEmitter(O.stdout,"data"),y=A.Event.fromNodeEventEmitter(O.stderr,"data");g(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${v}`,t)),y(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${v}`,t));const s=A.Event.any(A.Event.map(g,t=>({data:`%c${t}`,format:[""]})),A.Event.map(y,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),O}m(S){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$Rp=d,e.$Rp=d=pe([ie(0,I.$Xk),ie(1,P.$jj)],d)}),define(te[157],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O,g,y,s,o,t,i,n,r,u,k,b,w,D,H,ee,_,re,se,ue,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Vp=(0,_.$3h)(t.$mo);const q=".vsctmp";let X=class extends o.$Cp{constructor(F,M,a,m,z,U,Q,W,le,ae,me,de){super(F,M,me,a,ae,de),this.fb=z,this.gb=U,this.hb=Q,this.ib=le,this.eb=new Map,this.rb=new P.$Bc;const ge=this.B(W.createInstance(k.$Rp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Tp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(u.$Qp));const fe=this.B(new D.$Up(this,this.fb,de,U,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Xo)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const M=await this.pb(F),a=await(0,O.zip)((0,f.$Dg)(this.db.extensionsDownloadDir,(0,l.$mg)()).fsPath,M);return $.URI.file(a)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:M,cleanup:a}=await this.lb(F),m=d.$kc(M.fsPath);try{return await(0,b.$Sp)(m)}finally{await a()}}getInstalled(F,M=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,M)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,M={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:a,cleanup:m}=await this.lb(F);try{const z=await(0,b.$Sp)(d.$kc(a.fsPath)),U=(0,i.$Ro)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,H.$5o)(z.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:M}])).find(({identifier:le})=>(0,i.$Mo)(le,{id:U}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$Ep)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(F,M){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const a=await this.bb.scanUserExtensionAtLocation(F);if(!a)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[a,void 0]],M),this.F.info("Successfully installed extension",a.identifier.id,M.toString()),a}async installExtensionsFromProfile(F,M,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,M.toString(),a.toString());const m=(await this.bb.scanExtensions(1,M)).filter(z=>F.some(U=>(0,i.$Mo)(U,z.identifier)));if(m.length){const z=await Promise.all(m.map(U=>this.bb.scanMetadata(U,M)));await this.ub(m.map((U,Q)=>[U,z[Q]]),a),this.F.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(F,M,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0),M.isMachineScoped===!1&&(M.isMachineScoped=void 0),M.isBuiltin===!1&&(M.isBuiltin=void 0),M.pinned===!1&&(M.pinned=void 0),F=await this.bb.updateMetadata(F,M,a),this.cb.invalidate(a),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const M=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:M,compatible:!0},j.CancellationToken.None);if(!a)throw new Error(g.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(m){throw new Error(g.localize(3,null,(0,A.$Mi)(m)))}return this.installFromGallery(a)}ab(F,M,a,m){return this.bb.copyExtension(F,M,a,m)}copyExtensions(F,M){return this.bb.copyExtensions(F,M)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,M,a){const{location:m}=await this.db.download(F,M,!a);return m}async lb(F){if(F.scheme===I.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const M=(0,f.$Dg)(this.db.extensionsDownloadDir,(0,l.$mg)());return await this.hb.download(F,M),this.F.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.ib.del(M)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,M,a){if($.URI.isUri(M))return new J(F,M,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=i.$No.create(M).toString();let z=this.eb.get(m);return z||(this.eb.set(m,z=new V(F,M,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),z}$(F,M){return new Y(F,M.profileLocation,this.gb)}async pb(F){const M=async m=>{let z=await p.Promises.readdir(m);z=z.map(W=>d.$jc(m,W));const U=await Promise.all(z.map(W=>p.Promises.stat(W)));let Q=Promise.resolve([]);return U.forEach((W,le)=>{const ae=z[le];W.isFile()&&(Q=Q.then(me=>[...me,ae])),W.isDirectory()&&(Q=Q.then(me=>M(ae).then(de=>[...me,...de])))}),Q};return(await M(F.location.fsPath)).map(m=>({path:`extension/${d.$lc(F.location.fsPath,m)}`,localPath:m}))}async qb({added:F,removed:M}){if(M){const a=F&&this.D.extUri.isEqual(M.profileLocation,F.profileLocation)?M.extensions.filter(m=>F.extensions.every(z=>!(0,i.$Mo)(z,m))):M.extensions;for(const m of a)this.F.info("Extensions removed from another source",m.id,M.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:M.profileLocation})}if(F){const m=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(U=>(0,i.$Mo)(U,z.identifier)));this.s.fire(m.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(M=>this.rb.add(M)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const M of F.children??[])M.isDirectory&&this.rb.add(M.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(M=>this.tb(M)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const M=[];for(const a of F.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.rb.add(a),M.push(m))}M.length&&(await this.ub(M.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",M.map(a=>a.identifier.id)))}async ub(F,M){const a=F.map(m=>m[0]);await this.vb(a),await this.gb.addExtensionsToProfile(F,M),this.s.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:M})))}async vb(F){const M=await this.bb.getUninstalledExtensions();for(const a of F){const m=i.$No.create(a);M[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Wp=X,e.$Wp=X=pe([ie(0,t.$ko),ie(1,ue.$pl),ie(2,re.$jj),ie(3,s.$0h),ie(4,r.$Lp),ie(5,n.$Hp),ie(6,y.$2n),ie(7,_.$1h),ie(8,ee.$lk),ie(9,se.$Bj),ie(10,ce.$Vk),ie(11,oe.$Xk)],X);let T=class extends c.$Sc{constructor(F,M,a,m,z,U){super(),this.j=F,this.m=M,this.n=a,this.s=m,this.t=z,this.u=U,this.h=this.B(new E.$Sd),this.onExtract=this.h.event,this.c=(0,f.$Dg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$9g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,M){const a={includeInvalid:!0,profileLocation:M};let m=[];return F===null||F===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):F===1&&m.push(...await this.n.scanUserExtensions(a)),m=F!==null?m.filter(z=>z.type===F):m,Promise.all(m.map(z=>this.F(z)))}async scanAllUserExtensions(F){const M=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(M.map(a=>this.F(a)))}async scanUserExtensionAtLocation(F){try{const M=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(M)return await this.F(M)}catch(M){this.u.error(M)}return null}async extractUserExtension(F,M,a,m,z){const U=F.toString(),Q=$.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$mg)()}`)),W=$.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,U));let le=await this.m.exists(W);if(le&&m){try{await this.y(F.id,W,"removeExisting")}catch{throw new t.$lo(g.localize(4,null,W.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${M} to ${W.fsPath}`),await(0,O.$Ap)(M,Q.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof O.$yp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$lo(ae.message,me)}await this.n.updateMetadata(Q,a);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${W.fsPath}`),await this.C(Q.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,N.$0)(ae)}. Deleted from extracted location`,Q),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Q,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(F,M){return M?(await this.w(F,M))?.metadata:this.n.scanMetadata(F.location)}async w(F,M){return(await this.s.scanProfileExtensions(M)).find(m=>(0,i.$Mo)(m.identifier,F.identifier))}async updateMetadata(F,M,a){return a?await this.s.updateMetadata([[F,M]],a):await this.n.updateMetadata(F.location,M),this.D(F.location,F.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const M=F.map(a=>i.$No.create(a));await this.z(a=>M.forEach(m=>{a[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.z(M=>delete M[F.toString()])}async removeExtension(F,M){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,M)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(M=>delete M[i.$No.create(F).toString()])}async copyExtension(F,M,a,m){const z=await this.w(F,M),U=await this.w(F,a);return m={...z?.metadata,...m},U?await this.s.updateMetadata([[F,{...U.metadata,...m}]],a):await this.s.addExtensionsToProfile([[F,m]],a),this.D(F.location,F.type,a)}async copyExtensions(F,M){const a=await this.scanExtensions(1,F),m=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(m,M)}async y(F,M,a){this.u.trace(`Deleting ${a} extension from disk`,F,M.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(M),`${this.t.extUri.basename(M)}.${(0,h.$Pi)((0,l.$mg)()).toString(16)}${q}`);await this.C(M.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,F,M.fsPath)}async z(F){return this.g.queue(async()=>{let M;try{M=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,ee.$Ck)(m)!==1)throw m}let a={};if(M)try{a=JSON.parse(M)}catch{}return F&&(F(a),Object.keys(a).length?await this.m.writeFile(this.c,R.$ge.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(F,M){try{await p.Promises.rename(F,M,2*60*1e3)}catch(a){throw new t.$lo(a.message||g.localize(5,null,F,M),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,M,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(U=>this.t.extUri.isEqual(U.location,F));if(z)return this.F(z)}else{const m=await this.n.scanExistingExtension(F,M,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(g.localize(6,null,F.path))}async F(F){const M=await this.m.resolve(F.location);let a,m;return M.children&&(a=M.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,m=M.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const M=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of M)F[i.$No.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$So)(M,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const Q=U.sort((W,le)=>S.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(z){this.u.error(z)}const m=M.filter(z=>z.metadata&&F[i.$No.create(z).toString()]);await Promise.allSettled(m.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(M){(0,ee.$Ck)(M)!==1&&this.u.error(M);return}if(F?.children)try{await Promise.allSettled(F.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.m.del(M.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(a){(0,ee.$Ck)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Xp=T,e.$Xp=T=pe([ie(1,ee.$lk),ie(2,r.$Lp),ie(3,n.$Hp),ie(4,ce.$Vk),ie(5,re.$jj)],T);class C extends o.$Fp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Lf)(this.options.operation)?this.l:this.options.operation}constructor(F,M,a,m,z,U,Q,W,le){super(),this.identifier=F,this.source=M,this.options=a,this.m=m,this.n=z,this.o=U,this.p=Q,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[M,a]=await this.x(F);return this.j=M.isBuiltin||M.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[M,a]],this.j),M}async u({zipPath:F,key:M,metadata:a},m,z){let U=await this.v(M);return U||(this.s.trace("Extracting extension...",M.id),U=await this.m.extractUserExtension(M,F,a,m,z),this.s.info("Extracting extension completed.",M.id)),U}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.$No.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class V extends C{constructor(F,M,a,m,z,U,Q,W,le,ae){super(M.identifier,M,a,z,U,Q,W,le,ae),this.y=M,this.z=m}async x(F){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Q=>(0,i.$Mo)(Q.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??a?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Kf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$No.create(this.y),metadata:m},!1,F),m]}catch(Q){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,N.$0)(W))}throw Q}}async B(F){try{await(0,b.$Sp)(F)}catch(M){throw new t.$lo((0,o.$Dp)(M).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Yp=V;class J extends C{constructor(F,M,a,m,z,U,Q,W,le,ae){super({id:(0,i.$Ro)(F.publisher,F.name)},M,a,z,U,Q,W,le,ae),this.y=F,this.z=M,this.A=m}async h(F){const M=await super.h(F);return this.D(M,F),M}async x(F){const M=new i.$No(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Q=>(0,i.$Mo)(this.identifier,Q.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??m?.pinned};if(m)if(this.l=3,M.equals(new i.$No(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Q=await this.v(M);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:M,metadata:z},!0,F),z]}async D(F,M){try{let[a]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],M);if(a||([a]=await this.A.getExtensions([{id:F.identifier.id}],M)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.options.profileLocation)}}catch{}}}class Y extends o.$Fp{constructor(F,M,a){super(),this.extension=F,this.j=M,this.k=a}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[158],ne([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;let P=class extends N.$Ip{constructor(d,f,S,v,$,l){super(c.URI.file(d.extensionsPath),f,S,v,$,l)}};e.$aO=P,e.$aO=P=pe([ie(0,h.$0h),ie(1,E.$lk),ie(2,R.$Xk),ie(3,j.$Vk),ie(4,A.$pl),ie(5,L.$jj)],P)}),define(te[159],ne([0,1,11,18,40,51,12,10,6,32,22,23]),function(G,e,L,R,j,A,N,E,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0;let d=class extends A.$Pp{constructor(S,v,$,l,p,O,g,y){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,S.defaultProfile,S,v,$,l,p,O,g,y)}};e.$N0b=d,e.$N0b=d=pe([ie(0,I.$Xk),ie(1,j.$Hp),ie(2,N.$lk),ie(3,h.$jj),ie(4,R.$0h),ie(5,c.$Bj),ie(6,P.$Vk),ie(7,E.$1h)],d)}),define(te[160],ne([0,1,8,4,2,125,3,86,10,23]),function(G,e,L,R,j,A,N,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gp=e.$fp=e.$ep=void 0,e.$ep="__$__isNewStorageMarker",e.$fp="__$__targetStorageMarker",e.$gp=(0,h.$2h)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f(p){const O=p.get(e.$fp);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}e.$hp=f;class S extends j.$Sc{static{this.a=60*1e3}constructor(O={flushInterval:S.a}){super(),this.m=O,this.b=this.B(new R.$Vd),this.c=this.B(new R.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,g,y){return R.Event.filter(this.b.event,s=>s.scope===O&&(g===void 0||s.key===g),y)}n(){this.j.value=(0,L.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,g){const{key:y,external:s}=g;if(y===e.$fp){switch(O){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:y,target:this.J(O)[y],external:s})}w(O){this.f.fire({reason:O})}get(O,g,y){return this.P(g)?.get(O,y)}getBoolean(O,g,y){return this.P(g)?.getBoolean(O,y)}getNumber(O,g,y){return this.P(g)?.getNumber(O,y)}getObject(O,g,y){return this.P(g)?.getObject(O,y)}storeAll(O,g){this.y(()=>{for(const y of O)this.store(y.key,y.value,y.scope,y.target,g)})}store(O,g,y,s,o=!1){if((0,N.$Nf)(g)){this.remove(O,y,o);return}this.y(()=>{this.z(O,y,s),this.P(y)?.set(O,g,o)})}remove(O,g,y=!1){this.y(()=>{this.z(O,g,void 0),this.P(g)?.delete(O,y)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,g){const y=[],s=this.J(O);for(const o of Object.keys(s))s[o]===g&&y.push(o);return y}z(O,g,y,s=!1){const o=this.J(g);typeof y=="number"?o[O]!==y&&(o[O]=y,this.P(g)?.set(e.$fp,JSON.stringify(o),s)):typeof o[O]=="number"&&(delete o[O],this.P(g)?.set(e.$fp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(O){switch(O){case-1:return this.I;case 0:return this.G;default:return this.D}}L(O){const g=this.P(O);return g?f(g):Object.create(null)}isNew(O){return this.getBoolean(e.$ep,O)===!0}async flush(O=P.NONE){this.f.fire({reason:O});const g=this.P(-1),y=this.P(0),s=this.P(1);switch(O){case P.NONE:await L.Promises.settled([g?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([g?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return l(O,g,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,g){return this.w(P.NONE),(0,c.$Wk)(O)?this.R(O,g):this.S(O,g)}M(O,g){return!(O.id===g.id||v(g)&&v(O))}N(O,g,y){this.y(()=>{const s=new Set;for(const[o,t]of O)s.add(o),g.get(o)!==t&&this.u(y,{key:o,external:!0});for(const[o]of g.items)s.has(o)||this.u(y,{key:o,external:!0})})}}e.$ip=S;function v(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$jp=v;class $ extends S{constructor(){super(),this.U=this.B(new E.$cp(new E.$dp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$cp(new E.$dp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$cp(new E.$dp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(1,O))),this.B(this.W.onDidChangeStorage(O=>this.u(0,O))),this.B(this.U.onDidChangeStorage(O=>this.u(-1,O)))}P(O){switch(O){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(O){switch(O){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$kp=$;async function l(p,O,g,y,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;p.forEach((H,ee)=>{i.set(ee,H),n.set(ee,t(H))});const r=new Map,u=new Map;O.forEach((H,ee)=>{r.set(ee,H),u.set(ee,t(H))});const k=new Map,b=new Map;g.forEach((H,ee)=>{k.set(ee,H),b.set(ee,t(H))}),console.group(y!==s?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const w=[];if(i.forEach((H,ee)=>{w.push({key:ee,value:H})}),console.table(w),console.groupEnd(),console.log(n),y!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((ee,_)=>{H.push({key:_,value:ee})}),console.table(H),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const D=[];k.forEach((H,ee)=>{D.push({key:ee,value:H})}),console.table(D),console.groupEnd(),console.log(b)}e.$lp=l}),define(te[161],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=void 0;const s=A.$o?"web":(0,I.$go)(A.$u,N.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,z)=>m|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(m=b){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,z=this.d.pageSize){return new w({...this.d,pageNumber:m,pageSize:z})}withFilter(m,...z){const U=[...this.d.criteria,...z.length?z.map(Q=>({filterType:m,value:Q})):[{filterType:m}]];return new w({...this.d,criteria:U})}withSortBy(m){return new w({...this.d,sortBy:m})}withSortOrder(m){return new w({...this.d,sortOrder:m})}withFlags(...m){return new w({...this.d,flags:m.reduce((z,U)=>z|U,0)})}withAssetTypes(...m){return new w({...this.d,assetTypes:m})}withSource(m){return new w({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:z,pageSize:U,sortBy:Q,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:m,pageNumber:z,pageSize:U,sortBy:Q,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const m=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(a,m){const z=(a||[]).filter(U=>U.statisticName===m)[0];return z?z.value:0}function H(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,Q)=>{const W=re(a,Q.assetType);return W&&U.push([Q.assetType.substring(m.length),W]),U},[])}function ee(a){if(a.properties){const m=a.properties.filter(Q=>Q.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(Q=>z.test(Q.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return re(a,r.Repository)}function _(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function re(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,m){const z=a.properties?a.properties.filter(Q=>Q.key===m):[],U=z.length>0&&z[0].value;return U?U.split(",").map(Q=>(0,d.$Qo)(Q)):[]}function ue(a){const m=a.properties?a.properties.filter(z=>z.key===u.Engine):[];return m.length>0&&m[0].value||""}function ce(a){const m=a.properties?a.properties.filter(z=>z.key===u.PreRelease):[];return m.length>0&&m[0].value==="true"}function oe(a){const m=a.properties?a.properties.filter(U=>U.key===u.LocalizedLanguages):[],z=m.length>0&&m[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(m=>m.key===u.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$fo)(a.targetPlatform):"undefined"}function C(a){const m=(0,L.$Mb)(a.versions.map(T)),z=!!a.tags?.includes(I.$ao),U=m.indexOf("web");return z?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function V(a,m){for(let z=0;z<a.length;z++){const U=a[z];if(U.version===a[z-1]?.version){let Q=z;if(T(U)===m)for(;Q>0&&a[Q-1].version===U.version;)Q--;Q!==z&&(a.splice(z,1),a.splice(Q,0,U))}}return a}e.$op=V;function J(a,m,z){a.telemetryData={index:m,querySource:z,queryActivityId:a.queryContext?.[o]}}function Y(a,m,z,U){const Q=a.versions[0],W={manifest:re(m,r.Manifest),readme:re(m,r.Details),changelog:re(m,r.Changelog),license:re(m,r.License),repository:ee(m),download:_(m),icon:re(m,r.Icon),signature:re(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,d.$Ro)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Q),description:a.shortDescription||"",installCount:D(a.statistics,"install"),rating:D(a.statistics,"averagerating"),ratingCount:D(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(m,u.Dependency),extensionPack:se(m,u.ExtensionPack),engine:ue(m),localizedLanguages:oe(m),targetPlatform:T(m),isPreReleaseVersion:ce(m)},hasPreReleaseVersion:ce(Q),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:U}}let K=class{constructor(m,z,U,Q,W,le,ae,me){this.k=z,this.l=U,this.n=Q,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,p.$np)(ae.version,ae,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,z,U){const Q=R.CancellationToken.isCancellationToken(z)?{}:z,W=R.CancellationToken.isCancellationToken(z)?z:U,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of m){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,m.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Q.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Q.source&&(fe=fe.withSource(Q.source));const{extensions:he}=await this.z(fe,{targetPlatform:Q.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Q.compatible},W);return Q.source&&he.forEach((we,be)=>J(we,be,Q.source)),he}async getCompatibleExtension(m,z,U){if((0,I.$ho)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,z,U))return m;const Q=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Q,{targetPlatform:U,compatible:!0,includePreRelease:z},R.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,z,U){if(!(0,I.$io)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!z&&m.properties.isPreReleaseVersion)return!1;let Q=m.properties.engine;if(!Q){const W=await this.getManifest(m,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Q=W.engines.vscode}return(0,f.$5o)(Q,this.u.version,this.u.date)}async y(m,z,U,Q,W){if(!(0,I.$io)(T(m),Q,W)||z!=="any"&&ce(m)!==(z==="prerelease"))return!1;if(U)try{const le=await this.E(m);if(!(0,f.$5o)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,j.$0)(le)),!1}return!0}async query(m,z){let U=m.text||"";const Q=m.pageSize??50;let W=new w().withPage(1,Q);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),W=W.withFilter(n.SearchText,U)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>J(be,(ge.pageNumber-1)*ge.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new j.$5;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(m,z,U){const Q=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Ro)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,E.$Kf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Fe=>(0,d.$Mo)(Fe,we))?.includePreRelease;if(z.compatible&&(0,I.$ho)(C(he),z.targetPlatform))continue;const ke=await this.A(he,z,ae);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new y.$Od,he=new w().withFlags(Q&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,U);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(m,z,U){const Q={id:(0,d.$Ro)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=z.versions?.find(de=>(0,d.$Mo)(de,Q))?.version,le=(0,E.$Kf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Mo)(de,Q))?.includePreRelease,ae=C(m),me=V(m.versions,z.targetPlatform);if(z.compatible&&(0,I.$ho)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Y(m,ge,ae,U);if(W&&ge.version===W)return null}}return W||z.compatible?null:Y(m,m.versions[0],ae)}async B(m,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.j,Q=JSON.stringify(m.raw),W={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},le=new y.$Od;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,l.$_o)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Q.length),duration:le.elapsed(),success:!!ae&&(0,l.$8o)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,j.$4)(me)?"canceled":(0,j.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,z,U,Q){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${z}/version/${U}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${z}/${U}/stats?statType=${Q}`),le=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},R.CancellationToken.None)}catch{}}async download(m,z,U){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Q=(0,d.$Uo)(m),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:fe}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${h.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${h.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(m,z){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.D(m.assets.signature);await this.q.writeFile(z,U.stream)}async getReadme(m,z){if(m.assets.readme){const U=await this.D(m.assets.readme,{},z);return await(0,l.$$o)(U)||""}return""}async getManifest(m,z){if(m.assets.manifest){const U=await this.D(m.assets.manifest,{},z),Q=await(0,l.$$o)(U);return Q?JSON.parse(Q):null}return null}async C(m,z){const U=re(m,r.Manifest);if(!U)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},W=await this.D(U,{headers:Q});return await(0,l.$_o)(W)}async getCoreTranslation(m,z){const U=m.assets.coreTranslations.filter(Q=>Q[0]===z.toUpperCase())[0];if(U){const Q=await this.D(U[1]),W=await(0,l.$$o)(Q);return W?JSON.parse(W):null}return null}async getChangelog(m,z){if(m.assets.changelog){const U=await this.D(m.assets.changelog,{},z);return await(0,l.$$o)(U)||""}return""}async getAllCompatibleVersions(m,z,U){let Q=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Q=Q.withFilter(n.ExtensionId,m.identifier.uuid):Q=Q.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Q,R.CancellationToken.None);if(!W.length)return[];const le=C(W[0]);if((0,I.$ho)(le,U))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of V(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(m,z={},U=R.CancellationToken.None){const Q=await this.j,W={type:"GET"},le={...Q,...z.headers||{}};z={...z,...W,headers:le};const ae=m.uri,me=m.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,U);if(ge.res.statusCode===200)return ge;const fe=await(0,l.$$o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,j.$4)(ge))throw ge;const fe=(0,j.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,U)}}async E(m){let z=ue(m);if(!z){const U=await this.C(m,R.CancellationToken.None);if(!U)throw new Error("Manifest was not found");z=U.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,l.$_o)(m),U=[],Q={},W=[];if(z){for(const le of z.malicious)U.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$5o)(ae.engine,this.u.version,this.u.date))&&(Q[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(Q[le.toLowerCase()]=(0,E.$Kf)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:U,deprecated:Q,search:W}}};K=pe([ie(1,l.$6o),ie(2,v.$jj),ie(3,P.$9h),ie(4,g.$pl),ie(5,S.$lk),ie(6,$.$Bj),ie(7,c.$vi)],K);let F=class extends K{constructor(m,z,U,Q,W,le,ae,me){super(m,z,U,Q,W,le,ae,me)}};e.$pp=F,e.$pp=F=pe([ie(0,O.$gp),ie(1,l.$6o),ie(2,v.$jj),ie(3,P.$9h),ie(4,g.$pl),ie(5,S.$lk),ie(6,$.$Bj),ie(7,c.$vi)],F);let M=class extends K{constructor(m,z,U,Q,W,le,ae){super(void 0,m,z,U,Q,W,le,ae)}};e.$qp=M,e.$qp=M=pe([ie(0,l.$6o),ie(1,v.$jj),ie(2,P.$9h),ie(3,g.$pl),ie(4,S.$lk),ie(5,$.$Bj),ie(6,c.$vi)],M)}),define(te[162],ne([0,1,11,18,12,6,140,22,23,3,68]),function(G,e,L,R,j,A,N,E,h,c,P){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=e.$0N=void 0;let f=class extends h.$1k{static{I=this}static{this.a="profileAssociationsMigration"}constructor(l,p,O,g,y){super(O,g,p,y),this.U=l,this.W=O}O(){return this.U.getItem(I.b,[]).map(p=>({...p,location:(0,c.$Ef)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):L.URI.revive(p.location)}))}Q(){const l=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0N=f,e.$0N=f=I=pe([ie(0,N.$5N),ie(1,E.$Vk),ie(2,R.$0h),ie(3,j.$lk),ie(4,A.$jj)],f);let S=d=class extends f{constructor(l,p,O,g,y){super(l,p,O,g,y),this.$=l}P(l){l.length?this.$.setItem(d.b,l.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(d.c,l):this.$.removeItem(d.c)}Q(){const l="workspaceAndProfileInfo",p=this.$.getItem(l,void 0);if(p){this.$.removeItem(l);const g=p.reduce((y,{workspace:s,profile:o})=>(y[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),y),{});this.$.setItem(d.c,{workspaces:g})}const O=super.Q();return this.$.getItem(d.a,!1)||(this.R(O),this.$.setItem(d.a,!0)),O}};e.$$N=S,e.$$N=S=d=pe([ie(0,N.$6N),ie(1,E.$Vk),ie(2,R.$0h),ie(3,j.$lk),ie(4,A.$jj)],S);let v=class extends S{constructor(l,p,O,g){super(new P.$9N(0,p,g,O),l,p,O,g)}async init(){return await this.$.init(),super.init()}};e.$_N=v,e.$_N=v=pe([ie(0,E.$Vk),ie(1,R.$0h),ie(2,j.$lk),ie(3,A.$jj)],v)}),define(te[163],ne([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;let S=class extends I.$7o{constructor(p,O,g,y){super(y),this.m=p,this.n=O,this.r=g,this.s(),this.B(p.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,O){const{f:g,g:y}=this;let s;try{s=await(0,c.$7l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(i)))}const o={...process.env,...s},t=p.agent?p.agent:await(0,d.$$q)(p.url||"",o,{proxyUrl:g,strictSSL:y});return p.agent=t,p.strictSSL=y,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>$(p,O))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((O,g)=>{G(["@vscode/proxy-agent"],O,g)})).loadSystemCertificates({log:this.r})}};e.$_q=S,e.$_q=S=pe([ie(0,E.$vi),ie(1,h.$0h),ie(2,P.$jj),ie(3,P.$kj)],S);async function v(l){return((0,L.parse)(l.url).protocol==="https:"?await new Promise((g,y)=>{G(["https"],g,y)}):await new Promise((g,y)=>{G(["http"],g,y)})).request}async function $(l,p){return R.Promises.withAsyncBody(async(O,g)=>{const y=(0,L.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await v(l),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,N.$Kf)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(o.auth=l.user+":"+l.password);const t=s(o,i=>{const n=(0,N.$If)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...l,url:i.headers.location,followRedirects:n-1},p).then(O,g);else{let r=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,j.$ve)(r)})}});t.on("error",g),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),p.onCancellationRequested(()=>{t.abort(),g(new A.$5)})})}e.$ar=$}),define(te[176],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(G,e,L,R,j,A,N,E,h,c,P,I,d,f,S,v,$,l,p,O,g,y,s,o,t,i,n,r,u,k,b,w,D,H,ee,_,re,se,ue,ce,oe,q,X,T,C,V,J,Y,K,F,M,a,m,z,U,Q,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$jj),Fe=be.get(r.$lk),B=be.get(l.$0h),Z=be.get(m.$Xk);ke.info("CLI main",this.b),this.g(ke),await this.h(B,Fe,Z,he),await Promise.all(we.map(x=>{(0,R.$Tg)(x.flush(),1e3)}))})}async f(){const he=new D.$Zh,we={_serviceBrand:void 0,...ce.default};he.set(oe.$Bj,we);const be=new p.$wm(this.b,we);he.set(l.$0h,be),await Promise.all([be.appSettingsHome.with({scheme:E.Schemas.file}).fsPath,be.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const ke=new le.$4N((0,_.$xj)(be),be.logsHome);he.set(_.$kj,ke);const Fe=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),B=[];ke.getLogLevel()===_.LogLevel.Trace&&B.push(new _.$rj(ke.getLogLevel()));const Z=this.B(new W.$bO(Fe,B));he.set(_.$jj,Z);const x=this.B(new u.$1p(Z));he.set(r.$lk,x);const $e=this.B(new k.$nq(Z));x.registerProvider(E.Schemas.file,$e);const ye=new a.$Mr(x);he.set(M.$Vk,ye);const je=new T.$8N(1,be,Z,x),Se=new z.$0N(je,ye,be,x,Z);he.set(m.$Xk,Se),x.registerProvider(E.Schemas.vscodeUserData,new me.$c$b(E.Schemas.file,$e,E.Schemas.vscodeUserData,Se,ye,Z));const Le=c.$i&&we.win32RegValueName?this.B(new ue.$a$b(Z,we.win32RegValueName)):be.policyFile?this.B(new re.$b$b(be.policyFile,x,Z)):new se.$xn;he.set(se.$vn,Le);const Ie=this.B(new S.$Xn(Se.defaultProfile.settingsResource,x,Le,Z));he.set(f.$vi,Ie),await Promise.all([je.init(),Ie.initialize()]);let Ne;try{Ne=await(0,U.$Q0b)(je,Z)}catch(Ae){Ae.code!=="ENOENT"&&Z.error(Ae)}const Ce=await(0,U.$R0b)(je,Z);Se.init(),he.set(M.$Vk,new a.$Mr(x));const Oe=new X.$_q(Ie,be,Z,ke);he.set(q.$6o,Oe),he.set(v.$2n,new b.$Yh($.$qO,void 0,!0)),he.set(o.$Hp,new b.$Yh(Q.$aO,void 0,!0)),he.set(t.$Lp,new b.$Yh(n.$N0b,void 0,!0)),he.set(y.$rp,new b.$Yh(y.$sp,void 0,!0)),he.set(i.$Vp,new b.$Yh(i.$Wp,void 0,!0)),he.set(g.$ko,new b.$Yh(O.$qp,void 0,!0)),he.set(H.$6q,new b.$Yh(ee.$8q,void 0,!1));const Re=[],ze=(0,Y.$Jo)(we,Ie);if((0,Y.$Eo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Re.push(new K.$2N(Oe,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,C.$uo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ne,Ce,ze),piiPaths:(0,Y.$Ko)(be)};he.set(V.$pl,new b.$Yh(J.$br,[Ae],!1))}else he.set(V.$pl,Y.$yo);return[new w.$qq(he),Re]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,j.$Mi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async h(he,we,be,ke){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Z=>Z.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const B=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$tp,new _.$rj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return ke.createInstance(s.$tp,new _.$rj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$tp,new _.$rj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["locate-extension"])return ke.createInstance(s.$tp,new _.$rj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$y$b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$ic)(we)?we:(0,h.$jc)((0,P.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4ded39cfd580476a8f97303ce24848a7710b3427/core/vs/code/node/cliProcessMain.js.map
