/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=le[ne[D]];return e};define(le[123],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const L=new Map,j=new Map,O=new Map,R=new Map;function k(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function m(c,g){const y=c.get(g.detail);y&&(y>=0||c.set(g.detail,y+g.timestamp))}let C=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(C=ne.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of C)switch(c.type){case 10:k(L,c);break;case 11:case 12:m(L,c);break;case 21:k(j,c);break;case 22:m(j,c);break;case 33:k(O,c);break;case 34:m(O,c);break;case 31:k(R,c);break;case 32:m(R,c);break}let S=0;O.forEach(c=>S+=c);function $(c){const g=[];return c.forEach((y,b)=>g.push([b,y])),g}return{amdLoad:$(L),amdInvoke:$(j),nodeRequire:$(O),nodeEval:$(R),nodeRequireTotal:S}}static toMarkdownTable(L,j){let O="";const R=[];return L.forEach((k,m)=>{R[m]=k.length}),j.forEach(k=>{k.forEach((m,C)=>{typeof m>"u"&&(m=k[C]="-");const S=m.toString().length;R[C]=Math.max(S,R[C])})}),L.forEach((k,m)=>{O+=`| ${k+" ".repeat(R[m]-k.toString().length)} `}),O+=`|
`,L.forEach((k,m)=>{O+=`| ${"-".repeat(R[m])} `}),O+=`|
`,j.forEach(k=>{k.forEach((m,C)=>{typeof m<"u"&&(O+=`| ${m+" ".repeat(R[C]-m.toString().length)} `)}),O+=`|
`}),O}}e.$U=D}),define(le[124],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(y,b,l){const u=N(y,b);if(u!==-1)return y[u]}e.$fb=D;function N(y,b,l=y.length-1){for(let u=l;u>=0;u--){const h=y[u];if(b(h))return u}return-1}e.$gb=N;function L(y,b){const l=j(y,b);return l===-1?void 0:y[l]}e.$hb=L;function j(y,b,l=0,u=y.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);b(y[E])?h=E+1:d=E}return h-1}e.$ib=j;function O(y,b){const l=R(y,b);return l===y.length?void 0:y[l]}e.$jb=O;function R(y,b,l=0,u=y.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);b(y[E])?d=E:h=E+1}return h}e.$kb=R;function k(y,b,l=0,u=y.length){const h=R(y,b,l,u);return h===y.length?-1:h}e.$lb=k;class m{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(m.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!b(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const l=j(this.e,b,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=m;function C(y,b){if(y.length===0)return;let l=y[0];for(let u=1;u<y.length;u++){const h=y[u];b(h,l)>0&&(l=h)}return l}e.$nb=C;function S(y,b){if(y.length===0)return;let l=y[0];for(let u=1;u<y.length;u++){const h=y[u];b(h,l)>=0&&(l=h)}return l}e.$ob=S;function $(y,b){return C(y,(l,u)=>-b(l,u))}e.$pb=$;function c(y,b){if(y.length===0)return-1;let l=0;for(let u=1;u<y.length;u++){const h=y[u];b(h,y[l])>0&&(l=u)}return l}e.$qb=c;function g(y,b){for(const l of y){const u=b(l);if(u!==void 0)return u}}e.$rb=g}),define(le[125],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(O,R){const k=Object.create(null);for(const m of O){const C=R(m);let S=k[C];S||(S=k[C]=[]),S.push(m)}return k}e.$K=D;function N(O,R){const k=[],m=[];for(const C of O)R.has(C)||k.push(C);for(const C of R)O.has(C)||m.push(C);return{removed:k,added:m}}e.$L=N;function L(O,R){const k=[],m=[];for(const[C,S]of O)R.has(C)||k.push(S);for(const[C,S]of R)O.has(C)||m.push(S);return{removed:k,added:m}}e.$M=L;function j(O,R){const k=new Set;for(const m of R)O.has(m)&&k.add(m);return k}e.$N=j}),define(le[84],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function D(O){return(R,k,m)=>{let C=null,S=null;if(typeof m.value=="function"?(C="value",S=m.value):typeof m.get=="function"&&(C="get",S=m.get),!S)throw new Error("not supported");m[C]=O(S,k)}}function N(O,R,k){let m=null,C=null;if(typeof k.value=="function"?(m="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(m="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[m]=function(...$){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,$)}),this[S]}}e.$th=N;function L(O,R,k){return D((m,C)=>{const S=`$debounce$${C}`,$=`$debounce$result$${C}`;return function(...c){this[$]||(this[$]=k?k():void 0),clearTimeout(this[S]),R&&(this[$]=R(this[$],...c),c=[this[$]]),this[S]=setTimeout(()=>{m.apply(this,c),this[$]=k?k():void 0},O)}})}e.$uh=L;function j(O,R,k){return D((m,C)=>{const S=`$throttle$timer$${C}`,$=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,g=`$throttle$pending$${C}`;return function(...y){if(this[$]||(this[$]=k?k():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[$]=R(this[$],...y)),this[g])return;const b=this[c]+O;b<=Date.now()?(this[c]=Date.now(),m.apply(this,[this[$]]),this[$]=k?k():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[c]=Date.now(),m.apply(this,[this[$]]),this[$]=k?k():void 0},b-Date.now()))}})}e.$vh=j}),define(le[7],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$W=D,e.$X=new D;function N(E){e.$X.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=N;function L(E){if(!E||typeof E!="object")return!1;const s=E;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Z=L;function j(E){m(E)||e.$X.onUnexpectedError(E)}e.$1=j;function O(E){m(E)||e.$X.onUnexpectedExternalError(E)}e.$2=O;function R(E){if(E instanceof Error){const{name:s,message:o}=E,n=E.stacktrace||E.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(E)}}return E}e.$3=R;const k="Canceled";function m(E){return E instanceof C?!0:E instanceof Error&&E.name===k&&E.message===k}e.$4=m;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const E=new Error(k);return E.name=E.message,E}e.$6=S;function $(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$7=$;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$8=c;class g extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=g;function y(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$0=y;class b extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$$=b;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const o=new h;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$bb=h;class d extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(le[18],he([0,1,7,124]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function L(q,ee=0){return q[q.length-(1+ee)]}e.$sb=L;function j(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=j;function O(q,ee,G=(Q,ie)=>Q===ie){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let Q=0,ie=q.length;Q<ie;Q++)if(!G(q[Q],ee[Q]))return!1;return!0}e.$ub=O;function R(q,ee){const G=q.length-1;ee<G&&(q[ee]=q[G]),q.pop()}e.$vb=R;function k(q,ee,G){return m(q.length,Q=>G(q[Q],ee))}e.$wb=k;function m(q,ee){let G=0,Q=q-1;for(;G<=Q;){const ie=(G+Q)/2|0,ce=ee(ie);if(ce<0)G=ie+1;else if(ce>0)Q=ie-1;else return ie}return-(G+1)}e.$xb=m;function C(q,ee,G){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");const Q=ee[Math.floor(ee.length*Math.random())],ie=[],ce=[],oe=[];for(const fe of ee){const de=G(fe,Q);de<0?ie.push(fe):de>0?ce.push(fe):oe.push(fe)}return q<ie.length?C(q,ie,G):q<ie.length+oe.length?oe[0]:C(q-(ie.length+oe.length),ce,G)}e.$yb=C;function S(q,ee){const G=[];let Q;for(const ie of q.slice(0).sort(ee))!Q||ee(Q[0],ie)!==0?(Q=[ie],G.push(Q)):Q.push(ie);return G}e.$zb=S;function*$(q,ee){let G,Q;for(const ie of q)Q!==void 0&&ee(Q,ie)?G.push(ie):(G&&(yield G),G=[ie]),Q=ie;G&&(yield G)}e.$Ab=$;function c(q,ee){for(let G=0;G<=q.length;G++)ee(G===0?void 0:q[G-1],G===q.length?void 0:q[G])}e.$Bb=c;function g(q,ee){for(let G=0;G<q.length;G++)ee(G===0?void 0:q[G-1],q[G],G+1===q.length?void 0:q[G+1])}e.$Cb=g;function y(q,ee,G){const Q=[];function ie(fe,de,we){if(de===0&&we.length===0)return;const ve=Q[Q.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=de,ve.toInsert.push(...we)):Q.push({start:fe,deleteCount:de,toInsert:we})}let ce=0,oe=0;for(;;){if(ce===q.length){ie(ce,0,ee.slice(oe));break}if(oe===ee.length){ie(ce,q.length-ce,[]);break}const fe=q[ce],de=ee[oe],we=G(fe,de);we===0?(ce+=1,oe+=1):we<0?(ie(ce,1,[]),ce+=1):we>0&&(ie(ce,0,[de]),oe+=1)}return Q}e.$Db=y;function b(q,ee,G){const Q=y(q,ee,G),ie=[],ce=[];for(const oe of Q)ie.push(...q.slice(oe.start,oe.start+oe.deleteCount)),ce.push(...oe.toInsert);return{removed:ie,added:ce}}e.$Eb=b;function l(q,ee,G){if(G===0)return[];const Q=q.slice(0,G).sort(ee);return h(q,ee,Q,G,q.length),Q}e.top=l;function u(q,ee,G,Q,ie){return G===0?Promise.resolve([]):new Promise((ce,oe)=>{(async()=>{const fe=q.length,de=q.slice(0,G).sort(ee);for(let we=G,ve=Math.min(G+Q,fe);we<fe;we=ve,ve=Math.min(ve+Q,fe)){if(we>G&&await new Promise(Ie=>setTimeout(Ie)),ie&&ie.isCancellationRequested)throw new D.$5;h(q,ee,de,we,ve)}return de})().then(ce,oe)})}e.$Gb=u;function h(q,ee,G,Q,ie){for(const ce=G.length;Q<ie;Q++){const oe=q[Q];if(ee(oe,G[ce-1])<0){G.pop();const fe=(0,N.$kb)(G,de=>ee(oe,de)<0);G.splice(fe,0,oe)}}}function d(q){return q.filter(ee=>!!ee)}e.$Hb=d;function E(q){let ee=0;for(let G=0;G<q.length;G++)q[G]&&(q[ee]=q[G],ee+=1);q.length=ee}e.$Ib=E;function s(q,ee,G){q.splice(G,0,q.splice(ee,1)[0])}e.$Jb=s;function o(q){return!Array.isArray(q)||q.length===0}e.$Kb=o;function n(q){return Array.isArray(q)&&q.length>0}e.$Lb=n;function i(q,ee=G=>G){const G=new Set;return q.filter(Q=>{const ie=ee(Q);return G.has(ie)?!1:(G.add(ie),!0)})}e.$Mb=i;function t(q){const ee=new Set;return G=>{const Q=q(G);return ee.has(Q)?!1:(ee.add(Q),!0)}}e.$Nb=t;function r(q,ee){return q.length>0?q[0]:ee}e.$Ob=r;function a(q,ee){return q.length>0?q[q.length-1]:ee}e.$Pb=a;function v(q,ee,G=(Q,ie)=>Q===ie){let Q=0;for(let ie=0,ce=Math.min(q.length,ee.length);ie<ce&&G(q[ie],ee[ie]);ie++)Q++;return Q}e.$Qb=v;function w(q){return[].concat(...q)}e.$Rb=w;function f(q,ee){let G=typeof ee=="number"?q:0;typeof ee=="number"?G=q:(G=0,ee=q);const Q=[];if(G<=ee)for(let ie=G;ie<ee;ie++)Q.push(ie);else for(let ie=G;ie>ee;ie--)Q.push(ie);return Q}e.$Sb=f;function p(q,ee,G){return q.reduce((Q,ie)=>(Q[ee(ie)]=G?G(ie):ie,Q),Object.create(null))}e.$Tb=p;function I(q,ee){return q.push(ee),()=>F(q,ee)}e.$Ub=I;function F(q,ee){const G=q.indexOf(ee);if(G>-1)return q.splice(G,1),ee}e.$Vb=F;function M(q,ee,G){const Q=q.slice(0,ee),ie=q.slice(ee);return Q.concat(G,ie)}e.$Wb=M;function T(q,ee){let G;if(typeof ee=="number"){let Q=ee;G=()=>{const ie=Math.sin(Q++)*179426549;return ie-Math.floor(ie)}}else G=Math.random;for(let Q=q.length-1;Q>0;Q-=1){const ie=Math.floor(G()*(Q+1)),ce=q[Q];q[Q]=q[ie],q[ie]=ce}}e.$Xb=T;function z(q,ee){const G=q.indexOf(ee);G>-1&&(q.splice(G,1),q.unshift(ee))}e.$Yb=z;function Z(q,ee){const G=q.indexOf(ee);G>-1&&(q.splice(G,1),q.push(ee))}e.$Zb=Z;function J(q,ee){for(const G of ee)q.push(G)}e.$1b=J;function x(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.$2b=x;function V(q){return Array.isArray(q)?q:[q]}e.$3b=V;function Y(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=Y;function W(q,ee,G){const Q=te(q,ee),ie=q.length,ce=G.length;q.length=ie+ce;for(let oe=ie-1;oe>=Q;oe--)q[oe+ce]=q[oe];for(let oe=0;oe<ce;oe++)q[oe+Q]=G[oe]}e.$5b=W;function B(q,ee,G,Q){const ie=te(q,ee);let ce=q.splice(ie,G);return ce===void 0&&(ce=[]),W(q,ie,Q),ce}e.$6b=B;function te(q,ee){return ee<0?Math.max(ee+q.length,0):Math.min(ee,q.length)}var se;(function(q){function ee(ce){return ce<0}q.isLessThan=ee;function G(ce){return ce<=0}q.isLessThanOrEqual=G;function Q(ce){return ce>0}q.isGreaterThan=Q;function ie(ce){return ce===0}q.isNeitherLessOrGreaterThan=ie,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function _(q,ee){return(G,Q)=>ee(q(G),q(Q))}e.$7b=_;function re(...q){return(ee,G)=>{for(const Q of q){const ie=Q(ee,G);if(!se.isNeitherLessOrGreaterThan(ie))return ie}return se.neitherLessOrGreaterThan}}e.$8b=re;const K=(q,ee)=>q-ee;e.$9b=K;const U=(q,ee)=>(0,e.$9b)(q?1:0,ee?1:0);e.$0b=U;function P(q){return(ee,G)=>-q(ee,G)}e.$$b=P;class A{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let G=this.c;for(;G<this.g.length&&ee(this.g[G]);)G++;const Q=G===this.c?null:this.g.slice(this.c,G);return this.c=G,Q}takeFromEndWhile(ee){let G=this.d;for(;G>=0&&ee(this.g[G]);)G--;const Q=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const G=this.g.slice(this.c,this.c+ee);return this.c+=ee,G}}e.$_b=A;class H{static{this.empty=new H(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(G=>(ee(G),!0))}toArray(){const ee=[];return this.iterate(G=>(ee.push(G),!0)),ee}filter(ee){return new H(G=>this.iterate(Q=>ee(Q)?G(Q):!0))}map(ee){return new H(G=>this.iterate(Q=>G(ee(Q))))}some(ee){let G=!1;return this.iterate(Q=>(G=ee(Q),!G)),G}findFirst(ee){let G;return this.iterate(Q=>ee(Q)?(G=Q,!1):!0),G}findLast(ee){let G;return this.iterate(Q=>(ee(Q)&&(G=Q),!0)),G}findLastMaxBy(ee){let G,Q=!0;return this.iterate(ie=>((Q||se.isGreaterThan(ee(ie,G)))&&(Q=!1,G=ie),!0)),G}}e.$ac=H}),define(le[126],he([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function N(k,m){if(!k)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=N;function L(k,m="Unreachable"){throw new Error(m)}e.$5c=L;function j(k){if(!k)throw new D.$cb("Assertion Failed")}e.$6c=j;function O(k){if(!k()){debugger;k(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=O;function R(k,m){let C=0;for(;C<k.length-1;){const S=k[C],$=k[C+1];if(!m(S,$))return!1;C++}return!0}e.$8c=R}),define(le[85],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,L){const j=this;let O=!1,R;return function(){if(O)return R;if(O=!0,L)try{R=N.apply(j,arguments)}finally{L()}else R=N.apply(j,arguments);return R}}e.$db=D}),define(le[61],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function L(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}N.is=L;const j=Object.freeze([]);function O(){return j}N.empty=O;function*R(E){yield E}N.single=R;function k(E){return L(E)?E:R(E)}N.wrap=k;function m(E){return E||j}N.from=m;function*C(E){for(let s=E.length-1;s>=0;s--)yield E[s]}N.reverse=C;function S(E){return!E||E[Symbol.iterator]().next().done===!0}N.isEmpty=S;function $(E){return E[Symbol.iterator]().next().value}N.first=$;function c(E,s){for(const o of E)if(s(o))return!0;return!1}N.some=c;function g(E,s){for(const o of E)if(s(o))return o}N.find=g;function*y(E,s){for(const o of E)s(o)&&(yield o)}N.filter=y;function*b(E,s){let o=0;for(const n of E)yield s(n,o++)}N.map=b;function*l(...E){for(const s of E)yield*s}N.concat=l;function u(E,s,o){let n=o;for(const i of E)n=s(n,i);return n}N.reduce=u;function*h(E,s,o=E.length){for(s<0&&(s+=E.length),o<0?o+=E.length:o>E.length&&(o=E.length);s<o;s++)yield E[s]}N.slice=h;function d(E,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,E];const n=E[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,N.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}N.consume=d})(D||(e.Iterable=D={}))}),define(le[35],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,v=0;function w(z){let Z=0,J=0;for(;Z<z;){const x=s.charCodeAt(n);if(x>=48&&x<=57)J=J*16+x-48;else if(x>=65&&x<=70)J=J*16+x-65+10;else if(x>=97&&x<=102)J=J*16+x-97+10;else break;n++,Z++}return Z<z&&(J=-1),J}function f(z){n=z,t="",r=0,a=16,v=0}function p(){const z=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&m(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&m(s.charCodeAt(n)))for(n++;n<s.length&&m(s.charCodeAt(n));)n++;else return v=3,s.substring(z,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&m(s.charCodeAt(n))){for(n++;n<s.length&&m(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(z,Z)}function I(){let z="",Z=n;for(;;){if(n>=i){z+=s.substring(Z,n),v=2;break}const J=s.charCodeAt(n);if(J===34){z+=s.substring(Z,n),n++;break}if(J===92){if(z+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const V=w(4);V>=0?z+=String.fromCharCode(V):v=4;break}default:v=5}Z=n;continue}if(J>=0&&J<=31)if(k(J)){z+=s.substring(Z,n),v=2;break}else v=6;n++}return z}function F(){if(t="",v=0,r=n,n>=i)return r=i,a=17;let z=s.charCodeAt(n);if(R(z)){do n++,t+=String.fromCharCode(z),z=s.charCodeAt(n);while(R(z));return a=15}if(k(z))return n++,t+=String.fromCharCode(z),z===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(z){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=I(),a=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!k(s.charCodeAt(n));)n++;return t=s.substring(Z,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const J=i-1;let x=!1;for(;n<J;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),a=13}return t+=String.fromCharCode(z),n++,a=16}case 45:if(t+=String.fromCharCode(z),n++,n===i||!m(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<i&&M(z);)n++,z=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(z),n++,a=16}}function M(z){if(R(z)||k(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=F();while(z>=12&&z<=15);return z}return{setPosition:f,getPosition:()=>n,scan:o?T:F,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$8m=O;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function k(s){return s===10||s===13||s===8232||s===8233}function m(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function S(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,f,p,I){r.value=w,r.offset=f,r.length=p,r.type=I,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(w,f)=>{if(o<=w)throw i;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,f,p)=>{if(o<f||(v(w,f,p,"property"),n[n.length-1]=w,o<=f+p))throw i},onObjectEnd:(w,f)=>{if(o<=w)throw i;t=void 0,n.pop()},onArrayBegin:(w,f)=>{if(o<=w)throw i;t=void 0,n.push(0)},onArrayEnd:(w,f)=>{if(o<=w)throw i;t=void 0,n.pop()},onLiteralValue:(w,f,p)=>{if(o<f||(v(w,f,p,E(w)),o<=f+p))throw i},onSeparator:(w,f,p)=>{if(o<=f)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=f,a=!1,t=void 0;else if(w===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let f=0;for(let p=0;f<w.length&&p<n.length;p++)if(w[f]===n[p]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.$9m=S;function $(s,o=[],n=j.DEFAULT){let i=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return h(s,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,f,p)=>{o.push({error:w,offset:f,length:p})}},n),t[0]}e.$0m=$;function c(s,o=[],n=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}h(s,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,f,p)=>{i=r({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:f,length:p,parent:i})},onObjectEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,t(w+f)},onArrayBegin:(w,f)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,t(w+f)},onLiteralValue:(w,f,p)=>{r({type:E(w),offset:f,length:p,parent:i,value:w}),t(f+p)},onSeparator:(w,f,p)=>{i.type==="property"&&(w===":"?i.colonOffset=f:w===","&&t(f))},onError:(w,f,p)=>{o.push({error:w,offset:f,length:p})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$$m=c;function g(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$_m=g;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.$an=y;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=b(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$bn=b;function l(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.$cn=l;function u(s,o,n=!1){if(l(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=u(i[t],o,n);if(r)return r}return s}}e.$dn=u;function h(s,o,n=j.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?re=>_(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),f=t(o.onArrayBegin),p=t(o.onArrayEnd),I=r(o.onLiteralValue),F=r(o.onSeparator),M=t(o.onComment),T=r(o.onError),z=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function J(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:z?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,re=[],K=[]){if(T(_),re.length+K.length>0){let U=i.getToken();for(;U!==17;){if(re.indexOf(U)!==-1){J();break}else if(K.indexOf(U)!==-1)break;U=J()}}}function V(_){const re=i.getTokenValue();return _?I(re):v(re),J(),!0}function Y(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return J(),!0}function W(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(F(":"),J(),se()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function B(){a(),J();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),J(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);W()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):J(),!0}function te(){f(),J();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),J(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);se()||x(4,[],[4,5]),_=!0}return p(),i.getToken()!==4?x(8,[4],[]):J(),!0}function se(){switch(i.getToken()){case 3:return te();case 1:return B();case 10:return V(!0);default:return Y()}}return J(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):se()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$en=h;function d(s,o){const n=O(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$fn=d;function E(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$gn=E}),define(le[42],he([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RT=e.$QT=e.$PT=e.$OT=void 0;function N(m,C,S){let $,c,g,y,b;if(C){for(y=C.offset,b=y+C.length,g=y;g>0&&!k(m,g-1);)g--;let a=b;for(;a<m.length&&!k(m,a);)a++;c=m.substring(g,a),$=O(c,S)}else c=m,$=0,g=0,y=0,b=m.length;const l=R(S,m);let u=!1,h=0,d;S.insertSpaces?d=j(" ",S.tabSize||4):d="	";const E=(0,D.$8m)(c,!1);let s=!1;function o(){return l+j(d,$+h)}function n(){let a=E.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=E.scan();return s=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,w){!s&&v<b&&w>y&&m.substring(v,w)!==a&&i.push({offset:v,length:w-v,content:a})}let r=n();if(r!==17){const a=E.getTokenOffset()+g,v=j(d,$);t(v,g,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+g,v=n(),w="";for(;!u&&(v===12||v===13);){const p=E.getTokenOffset()+g;t(" ",a,p),a=E.getTokenOffset()+E.getTokenLength()+g,w=v===12?o():"",v=n()}if(v===2)r!==1&&(h--,w=o());else if(v===4)r!==3&&(h--,w=o());else{switch(r){case 3:case 1:h++,w=o();break;case 5:case 12:w=o();break;case 13:u?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&(w=o())}const f=E.getTokenOffset()+g;t(w,a,f),r=v}return i}e.$OT=N;function L(m,C){const S=JSON.stringify(m,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$PT=L;function j(m,C){let S="";for(let $=0;$<C;$++)S+=m;return S}function O(m,C){let S=0,$=0;const c=C.tabSize||4;for(;S<m.length;){const g=m.charAt(S);if(g===" ")$++;else if(g==="	")$+=c;else break;S++}return Math.floor($/c)}function R(m,C){for(let S=0;S<C.length;S++){const $=C.charAt(S);if($==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return m&&m.eol||`
`}e.$QT=R;function k(m,C){return`\r
`.indexOf(m.charAt(C))!==-1}e.$RT=k}),define(le[86],he([0,1,35,42]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WT=e.$VT=e.$UT=e.$TT=e.$ST=void 0;function L(m,C,S){return j(m,C,void 0,S)}e.$ST=L;function j(m,C,S,$,c){const g=C.slice(),y=[],b=(0,D.$$m)(m,y);let l,u;for(;g.length>0&&(u=g.pop(),l=(0,D.$_m)(b,g),l===void 0&&S!==void 0);)typeof u=="string"?S={[u]:S}:S=[S];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const h=(0,D.$_m)(l,[u]);if(h!==void 0)if(S===void 0){if(!h.parent)throw new Error("Malformed AST");const d=l.children.indexOf(h.parent);let E,s=h.parent.offset+h.parent.length;if(d>0){const o=l.children[d-1];E=o.offset+o.length}else E=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return O(m,{offset:E,length:s-E,content:""},$)}else return O(m,{offset:h.offset,length:h.length,content:JSON.stringify(S)},$);else{if(S===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(S)}`,E=c?c(l.children.map(o=>o.children[0].value)):l.children.length;let s;if(E>0){const o=l.children[E-1];s={offset:o.offset+o.length,length:0,content:","+d}}else l.children.length===0?s={offset:l.offset+1,length:0,content:d}:s={offset:l.offset+1,length:0,content:d+","};return O(m,s,$)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(S!==void 0){const h=`${JSON.stringify(S)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?h:h+","};else{const E=u===-1||u>l.children.length?l.children.length:u,s=l.children[E-1];d={offset:s.offset+s.length,length:0,content:","+h}}return O(m,d,$)}else{const h=u,d=l.children[h];let E;if(l.children.length===1)E={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===h){const s=l.children[h-1],o=s.offset+s.length,n=l.offset+l.length;E={offset:o,length:n-2-o,content:""}}else E={offset:d.offset,length:l.children[h+1].offset-d.offset,content:""};return O(m,E,$)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return O(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(S)},$)}}e.$TT=j;function O(m,C,S){let $=R(m,C),c=C.offset,g=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,N.$RT)($,c-1);)c--;for(;g<$.length&&!(0,N.$RT)($,g);)g++}const y=(0,N.$OT)($,{offset:c,length:g-c},S);for(let l=y.length-1;l>=0;l--){const u=y[l];$=R($,u),c=Math.min(c,u.offset),g=Math.max(g,u.offset+u.length),g+=u.content.length-u.length}const b=m.length-($.length-g)-c;return[{offset:c,length:b,content:$.substring(c,g)}]}e.$UT=O;function R(m,C){return m.substring(0,C.offset)+C.content+m.substring(C.offset+C.length)}e.$VT=R;function k(m,C){const S=C.slice(0).sort((c,g)=>{const y=c.offset-g.offset;return y===0?c.length-g.length:y});let $=m.length;for(let c=S.length-1;c>=0;c--){const g=S[c];if(g.offset+g.length<=$)m=R(m,g);else throw new Error("Overlapping edit");$=g.offset}return m}e.$WT=k}),define(le[52],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(le[87],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(j){this.element=j,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let j=this.a;for(;j!==D.Undefined;){const O=j.next;j.prev=D.Undefined,j.next=D.Undefined,j=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const R=new D(j);if(this.a===D.Undefined)this.a=R,this.b=R;else if(O){const m=this.b;this.b=R,R.prev=m,m.next=R}else{const m=this.a;this.a=R,R.next=m,m.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==D.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==D.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==D.Undefined&&j.next!==D.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===D.Undefined&&j.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):j.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):j.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==D.Undefined;)yield j.element,j=j.next}}e.$3c=N}),define(le[34],he([0,1]),function(ne,e){"use strict";var D,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j(u,h,d){let E=u.get(h);return E===void 0&&(E=d,u.set(h,E)),E}e.$xc=j;function O(u){const h=[];return u.forEach((d,E)=>{h.push(`${E} => ${d}`)}),`Map(${u.size}) {${h.join(", ")}}`}e.$yc=O;function R(u){const h=[];return u.forEach(d=>{h.push(d)}),`Set(${u.size}) {${h.join(", ")}}`}e.$zc=R;class k{constructor(h,d){this.uri=h,this.value=d}}function m(u){return Array.isArray(u)}class C{static{this.a=h=>h.toString()}constructor(h,d){if(this[D]="ResourceMap",h instanceof C)this.b=new Map(h.b),this.c=d??C.a;else if(m(h)){this.b=new Map,this.c=d??C.a;for(const[E,s]of h)this.set(E,s)}else this.b=new Map,this.c=h??C.a}set(h,d){return this.b.set(this.c(h),new k(h,d)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,d){typeof d<"u"&&(h=h.bind(d));for(const[E,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$Ac=C;class S{constructor(h,d){this[N]="ResourceSet",!h||typeof h=="function"?this.a=new C(h):(this.a=new C(d),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,d){this.a.forEach((E,s)=>h.call(d,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var $;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})($||(e.Touch=$={}));class c{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,d=0){const E=this.a.get(h);if(E)return d!==0&&this.j(E,d),E.value}set(h,d,E=0){let s=this.a.get(h);if(s)s.value=d,E!==0&&this.j(s,E);else{switch(s={key:h,value:d,next:void 0,previous:void 0},E){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const d=this.a.get(h);if(d)return this.a.delete(h),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,d){const E=this.e;let s=this.b;for(;s;){if(d?h.bind(d)(s.value,s.key,this):h(s.value,s.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.key,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}values(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.value,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}entries(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:[E.key,E.value],done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let d=this.b,E=this.size;for(;d&&E>h;)this.a.delete(d.key),d=d.next,E--;this.b=d,this.d=E,d&&(d.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const d=h.next,E=h.previous;if(!d||!E)throw new Error("Invalid list");d.previous=E,E.next=d}h.next=void 0,h.previous=void 0,this.e++}j(h,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(h===this.b)return;const E=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(E.previous=s,s.next=E),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(d===2){if(h===this.c)return;const E=h.next,s=h.previous;h===this.b?(E.previous=void 0,this.b=E):(E.previous=s,s.next=E),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((d,E)=>{h.push([E,d])}),h}fromJSON(h){this.clear();for(const[d,E]of h)this.set(d,E)}}e.$Cc=c;class g extends c{constructor(h,d=1){super(),this.k=h,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,d=2){return super.get(h,d)}peek(h){return super.get(h,0)}set(h,d){return super.set(h,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=g;class y{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let d=this.a.get(h)||0;return d===0?!1:(d--,d===0?this.a.delete(h):this.a.set(h,d),!0)}has(h){return this.a.has(h)}}e.$Ec=y;class b{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[d,E]of h)this.set(d,E)}clear(){this.a.clear(),this.b.clear()}set(h,d){this.a.set(h,d),this.b.set(d,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const d=this.a.get(h);return d===void 0?!1:(this.a.delete(h),this.b.delete(d),!0)}forEach(h,d){this.a.forEach((E,s)=>{h.call(d,E,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=b;class l{constructor(){this.a=new Map}add(h,d){let E=this.a.get(h);E||(E=new Set,this.a.set(h,E)),E.add(d)}delete(h,d){const E=this.a.get(h);E&&(E.delete(d),E.size===0&&this.a.delete(h))}forEach(h,d){const E=this.a.get(h);E&&E.forEach(d)}get(h){const d=this.a.get(h);return d||new Set}}e.$Gc=l}),define(le[2],he([0,1,18,125,34,85,61]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const R=!1;let k=null;class m{constructor(){this.b=new Map}static{this.a=0}c(I){let F=this.b.get(I);return F||(F={parent:null,source:null,isSingleton:!1,value:I,idx:m.a++},this.b.set(I,F)),F}trackDisposable(I){const F=this.c(I);F.source||(F.source=new Error().stack)}setParent(I,F){const M=this.c(I);M.parent=F}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,F){const M=F.get(I);if(M)return M;const T=I.parent?this.f(this.c(I.parent),F):I;return F.set(I,T),T}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,I).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(I=10,F){let M;if(F)M=F;else{const x=new Map,V=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,x).isSingleton);if(V.length===0)return;const Y=new Set(V.map(W=>W.value));if(M=V.filter(W=>!(W.parent&&Y.has(W.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(x){function V(W,B){for(;W.length>0&&B.some(te=>typeof te=="string"?te===W[0]:W[0].match(te));)W.shift()}const Y=x.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return V(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const z=new L.$Gc;for(const x of M){const V=T(x);for(let Y=0;Y<=V.length;Y++)z.add(V.slice(0,Y).join(`
`),x)}M.sort((0,D.$7b)(x=>x.idx,D.$9b));let Z="",J=0;for(const x of M.slice(0,I)){J++;const V=T(x),Y=[];for(let W=0;W<V.length;W++){let B=V[W];B=`(shared with ${z.get(V.slice(0,W+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const se=z.get(V.slice(0,W).join(`
`)),_=(0,N.$K)([...se].map(re=>T(re)[W]),re=>re);delete _[V[W]];for(const[re,K]of Object.entries(_))Y.unshift(`    - stacktraces of ${K.length} other leaks continue with ${re}`);Y.unshift(B)}Z+=`


==================== Leaking disposable ${J}/${M.length}: ${x.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return M.length>I&&(Z+=`


... and ${M.length-I} more leaking disposables

`),{leaks:M,details:Z}}}e.$Hc=m;function C(p){k=p}if(e.$Ic=C,R){const p="__is_disposable_tracked__";C(new class{trackDisposable(I){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[p]||console.log(F)},3e3)}setParent(I,F){if(I&&I!==s.None)try{I[p]=!0}catch{}}markAsDisposed(I){if(I&&I!==s.None)try{I[p]=!0}catch{}}markAsSingleton(I){}})}function S(p){return k?.trackDisposable(p),p}e.$Jc=S;function $(p){k?.markAsDisposed(p)}e.$Kc=$;function c(p,I){k?.setParent(p,I)}function g(p,I){if(k)for(const F of p)k.setParent(F,I)}function y(p){return k?.markAsSingleton(p),p}e.$Lc=y;function b(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Mc=b;function l(p){if(O.Iterable.is(p)){const I=[];for(const F of p)if(F)try{F.dispose()}catch(M){I.push(M)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Nc=l;function u(p){for(const I of p)b(I)&&I.dispose();return[]}e.$Oc=u;function h(...p){const I=d(()=>l(p));return g(p,I),I}e.$Pc=h;function d(p){const I=S({dispose:(0,j.$db)(()=>{$(I),p()})});return I}e.$Qc=d;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return c(I,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),c(I,null))}}e.$Rc=E;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,S(this),c(this.q,this)}dispose(){$(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=s;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&c(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&c(I,null),I}}e.$Tc=o;class n{constructor(I){this.a=new o,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=n;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(I){let F=I;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,$(this))},this}}e.$Wc=t;class r{constructor(){this.a=new Map}acquire(I,...F){let M=this.a.get(I);M||(M={counter:0,object:this.b(I,...F)},this.a.set(I,M));const{object:T}=M,z=(0,j.$db)(()=>{--M.counter===0&&(this.c(I,M.object),this.a.delete(I))});return M.counter++,{object:T,dispose:z}}}e.$Xc=r;class a{constructor(I){this.a=I}async acquire(I,...F){const M=this.a.acquire(I,...F);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$Yc=a;class v{constructor(I){this.object=I}dispose(){}}e.$Zc=v;function w(p){const I=new E;try{p(I)}finally{I.dispose()}}e.$1c=w;class f{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,F,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(I)?.dispose(),this.a.set(I,F)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=f}),define(le[88],he([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=void 0;const N=new D.$Dc(1e4);function L(m){return k(m,"NFC",N)}e.$Bl=L;const j=new D.$Dc(1e4);function O(m){return k(m,"NFD",j)}e.$Cl=O;const R=/[^\u0000-\u0080]/;function k(m,C,S){if(!m)return m;const $=S.get(m);if($)return $;let c;return R.test(m)?c=m.normalize(C):c=m,S.set(m,c),c}e.$Dl=function(){const m=/[\u0300-\u036f]/g;return function(C){return O(C).replace(m,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(k){j.push(k,Date.now())}function R(){const k=[];for(let m=0;m<j.length;m+=2)k.push({name:j[m],startTime:j[m+1]});return k}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ne,D.c=e,D.d=function(N,L,j){D.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:j})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,L){if(1&L&&(N=D(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)D.d(j,O,function(R){return N[R]}.bind(null,O));return j},D.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(L,"a",L),L},D.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var L;e=ne.exports=K,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],m=0,C=m++;k[C]="0|[1-9]\\d*";var S=m++;k[S]="[0-9]+";var $=m++;k[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=m++;k[c]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var g=m++;k[g]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var y=m++;k[y]="(?:"+k[C]+"|"+k[$]+")";var b=m++;k[b]="(?:"+k[S]+"|"+k[$]+")";var l=m++;k[l]="(?:-("+k[y]+"(?:\\."+k[y]+")*))";var u=m++;k[u]="(?:-?("+k[b]+"(?:\\."+k[b]+")*))";var h=m++;k[h]="[0-9A-Za-z-]+";var d=m++;k[d]="(?:\\+("+k[h]+"(?:\\."+k[h]+")*))";var E=m++,s="v?"+k[c]+k[l]+"?"+k[d]+"?";k[E]="^"+s+"$";var o="[v=\\s]*"+k[g]+k[u]+"?"+k[d]+"?",n=m++;k[n]="^"+o+"$";var i=m++;k[i]="((?:<|>)?=?)";var t=m++;k[t]=k[S]+"|x|X|\\*";var r=m++;k[r]=k[C]+"|x|X|\\*";var a=m++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[l]+")?"+k[d]+"?)?)?";var v=m++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[u]+")?"+k[d]+"?)?)?";var w=m++;k[w]="^"+k[i]+"\\s*"+k[a]+"$";var f=m++;k[f]="^"+k[i]+"\\s*"+k[v]+"$";var p=m++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=m++;k[I]="(?:~>?)";var F=m++;k[F]="(\\s*)"+k[I]+"\\s+",R[F]=new RegExp(k[F],"g");var M=m++;k[M]="^"+k[I]+k[a]+"$";var T=m++;k[T]="^"+k[I]+k[v]+"$";var z=m++;k[z]="(?:\\^)";var Z=m++;k[Z]="(\\s*)"+k[z]+"\\s+",R[Z]=new RegExp(k[Z],"g");var J=m++;k[J]="^"+k[z]+k[a]+"$";var x=m++;k[x]="^"+k[z]+k[v]+"$";var V=m++;k[V]="^"+k[i]+"\\s*("+o+")$|^$";var Y=m++;k[Y]="^"+k[i]+"\\s*("+s+")$|^$";var W=m++;k[W]="(\\s*)"+k[i]+"\\s*("+o+"|"+k[a]+")",R[W]=new RegExp(k[W],"g");var B=m++;k[B]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=m++;k[te]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var se=m++;k[se]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,k[_]),R[_]||(R[_]=new RegExp(k[_]));function re(ue,ge){if(ue instanceof K)return ue;if(typeof ue!="string"||ue.length>j||!(ge?R[n]:R[E]).test(ue))return null;try{return new K(ue,ge)}catch{return null}}function K(ue,ge){if(ue instanceof K){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof K))return new K(ue,ge);L("SemVer",ue,ge),this.loose=ge;var me=ue.trim().match(ge?R[n]:R[E]);if(!me)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<O)return Re}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=re,e.valid=function(ue,ge){var me=re(ue,ge);return me?me.version:null},e.clean=function(ue,ge){var me=re(ue.trim().replace(/^[=v]+/,""),ge);return me?me.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ue){return L("SemVer.compare",this.version,this.loose,ue),ue instanceof K||(ue=new K(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},K.prototype.compareMain=function(ue){return ue instanceof K||(ue=new K(ue,this.loose)),P(this.major,ue.major)||P(this.minor,ue.minor)||P(this.patch,ue.patch)},K.prototype.comparePre=function(ue){if(ue instanceof K||(ue=new K(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var me=this.prerelease[ge],Pe=ue.prerelease[ge];if(L("prerelease compare",ge,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return P(me,Pe)}while(++ge)},K.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new K(ue,me).inc(ge,Pe).version}catch{return null}},e.diff=function(ue,ge){if(ee(ue,ge))return null;var me=re(ue),Pe=re(ge);if(me.prerelease.length||Pe.prerelease.length){for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Pe[Re])return Re},e.compareIdentifiers=P;var U=/^[0-9]+$/;function P(ue,ge){var me=U.test(ue),Pe=U.test(ge);return me&&Pe&&(ue=+ue,ge=+ge),me&&!Pe?-1:Pe&&!me?1:ue<ge?-1:ue>ge?1:0}function A(ue,ge,me){return new K(ue,me).compare(new K(ge,me))}function H(ue,ge,me){return A(ue,ge,me)>0}function q(ue,ge,me){return A(ue,ge,me)<0}function ee(ue,ge,me){return A(ue,ge,me)===0}function G(ue,ge,me){return A(ue,ge,me)!==0}function Q(ue,ge,me){return A(ue,ge,me)>=0}function ie(ue,ge,me){return A(ue,ge,me)<=0}function ce(ue,ge,me,Pe){var Re;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof me=="object"&&(me=me.version),Re=ue===me;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof me=="object"&&(me=me.version),Re=ue!==me;break;case"":case"=":case"==":Re=ee(ue,me,Pe);break;case"!=":Re=G(ue,me,Pe);break;case">":Re=H(ue,me,Pe);break;case">=":Re=Q(ue,me,Pe);break;case"<":Re=q(ue,me,Pe);break;case"<=":Re=ie(ue,me,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return Re}function oe(ue,ge){if(ue instanceof oe){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof oe))return new oe(ue,ge);L("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ue,ge){return P(ge,ue)},e.major=function(ue,ge){return new K(ue,ge).major},e.minor=function(ue,ge){return new K(ue,ge).minor},e.patch=function(ue,ge){return new K(ue,ge).patch},e.compare=A,e.compareLoose=function(ue,ge){return A(ue,ge,!0)},e.rcompare=function(ue,ge,me){return A(ge,ue,me)},e.sort=function(ue,ge){return ue.sort(function(me,Pe){return e.compare(me,Pe,ge)})},e.rsort=function(ue,ge){return ue.sort(function(me,Pe){return e.rcompare(me,Pe,ge)})},e.gt=H,e.lt=q,e.eq=ee,e.neq=G,e.gte=Q,e.lte=ie,e.cmp=ce,e.Comparator=oe;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof oe)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function we(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function ve(ue,ge,me,Pe,Re,Te,je,qe,Ne,Ue,ae,$e,be){return((ge=we(me)?"":we(Pe)?">="+me+".0.0":we(Re)?">="+me+"."+Pe+".0":">="+ge)+" "+(qe=we(Ne)?"":we(Ue)?"<"+(+Ne+1)+".0.0":we(ae)?"<"+Ne+"."+(+Ue+1)+".0":$e?"<="+Ne+"."+Ue+"."+ae+"-"+$e:"<="+qe)).trim()}function Ie(ue,ge){for(var me=0;me<ue.length;me++)if(!ue[me].test(ge))return!1;if(ge.prerelease.length){for(me=0;me<ue.length;me++)if(L(ue[me].semver),ue[me].semver!==fe&&ue[me].semver.prerelease.length>0){var Pe=ue[me].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function De(ue,ge,me){try{ge=new de(ge,me)}catch{return!1}return ge.test(ue)}function Me(ue,ge,me,Pe){var Re,Te,je,qe,Ne;switch(ue=new K(ue,Pe),ge=new de(ge,Pe),me){case">":Re=H,Te=ie,je=q,qe=">",Ne=">=";break;case"<":Re=q,Te=Q,je=H,qe="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(ue,ge,Pe))return!1;for(var Ue=0;Ue<ge.set.length;++Ue){var ae=ge.set[Ue],$e=null,be=null;if(ae.forEach(function(ye){ye.semver===fe&&(ye=new oe(">=0.0.0")),$e=$e||ye,be=be||ye,Re(ye.semver,$e.semver,Pe)?$e=ye:je(ye.semver,be.semver,Pe)&&(be=ye)}),$e.operator===qe||$e.operator===Ne||(!be.operator||be.operator===qe)&&Te(ue,be.semver)||be.operator===Ne&&je(ue,be.semver))return!1}return!0}oe.prototype.parse=function(ue){var ge=this.loose?R[V]:R[Y],me=ue.match(ge);if(!me)throw new TypeError("Invalid comparator: "+ue);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new K(me[2],this.loose):this.semver=fe},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(ue){return L("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new K(ue,this.loose)),ce(ue,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(ue,ge){if(!(ue instanceof oe))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new de(ue.value,ge),De(this.value,me,ge);if(ue.operator==="")return me=new de(this.value,ge),De(ue.semver,me,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Te=this.semver.version===ue.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),qe=ce(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Ne=ce(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Re||Te&&je||qe||Ne},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),L("range",ue,ge);var me=ge?R[te]:R[B];ue=ue.replace(me,ve),L("hyphen replace",ue),ue=ue.replace(R[W],"$1$2$3"),L("comparator trim",ue,R[W]),ue=(ue=(ue=ue.replace(R[F],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Pe=ge?R[V]:R[Y],Re=ue.split(" ").map(function(Te){return function(je,qe){return L("comp",je),je=function(Ne,Ue){return Ne.trim().split(/\s+/).map(function(ae){return function($e,be){L("caret",$e,be);var ye=be?R[x]:R[J];return $e.replace(ye,function(ke,Se,Ce,Oe,Ae){var Fe;return L("caret",$e,ke,Se,Ce,Oe,Ae),we(Se)?Fe="":we(Ce)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":we(Oe)?Fe=Se==="0"?">="+Se+"."+Ce+".0 <"+Se+"."+(+Ce+1)+".0":">="+Se+"."+Ce+".0 <"+(+Se+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Se==="0"?Ce==="0"?">="+Se+"."+Ce+"."+Oe+Ae+" <"+Se+"."+Ce+"."+(+Oe+1):">="+Se+"."+Ce+"."+Oe+Ae+" <"+Se+"."+(+Ce+1)+".0":">="+Se+"."+Ce+"."+Oe+Ae+" <"+(+Se+1)+".0.0"):(L("no pr"),Fe=Se==="0"?Ce==="0"?">="+Se+"."+Ce+"."+Oe+" <"+Se+"."+Ce+"."+(+Oe+1):">="+Se+"."+Ce+"."+Oe+" <"+Se+"."+(+Ce+1)+".0":">="+Se+"."+Ce+"."+Oe+" <"+(+Se+1)+".0.0"),L("caret return",Fe),Fe})}(ae,Ue)}).join(" ")}(je,qe),L("caret",je),je=function(Ne,Ue){return Ne.trim().split(/\s+/).map(function(ae){return function($e,be){var ye=be?R[T]:R[M];return $e.replace(ye,function(ke,Se,Ce,Oe,Ae){var Fe;return L("tilde",$e,ke,Se,Ce,Oe,Ae),we(Se)?Fe="":we(Ce)?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":we(Oe)?Fe=">="+Se+"."+Ce+".0 <"+Se+"."+(+Ce+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Se+"."+Ce+"."+Oe+Ae+" <"+Se+"."+(+Ce+1)+".0"):Fe=">="+Se+"."+Ce+"."+Oe+" <"+Se+"."+(+Ce+1)+".0",L("tilde return",Fe),Fe})}(ae,Ue)}).join(" ")}(je,qe),L("tildes",je),je=function(Ne,Ue){return L("replaceXRanges",Ne,Ue),Ne.split(/\s+/).map(function(ae){return function($e,be){$e=$e.trim();var ye=be?R[f]:R[w];return $e.replace(ye,function(ke,Se,Ce,Oe,Ae,Fe){L("xRange",$e,ke,Se,Ce,Oe,Ae,Fe);var ze=we(Ce),Ve=ze||we(Oe),Be=Ve||we(Ae);return Se==="="&&Be&&(Se=""),ze?ke=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(Ve&&(Oe=0),Be&&(Ae=0),Se===">"?(Se=">=",Ve?(Ce=+Ce+1,Oe=0,Ae=0):Be&&(Oe=+Oe+1,Ae=0)):Se==="<="&&(Se="<",Ve?Ce=+Ce+1:Oe=+Oe+1),ke=Se+Ce+"."+Oe+"."+Ae):Ve?ke=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Be&&(ke=">="+Ce+"."+Oe+".0 <"+Ce+"."+(+Oe+1)+".0"),L("xRange return",ke),ke})}(ae,Ue)}).join(" ")}(je,qe),L("xrange",je),je=function(Ne,Ue){return L("replaceStars",Ne,Ue),Ne.trim().replace(R[se],"")}(je,qe),L("stars",je),je}(Te,ge)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Te){return!!Te.match(Pe)})),Re=Re.map(function(Te){return new oe(Te,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ue.set.some(function(Re){return Re.every(function(Te){return Pe.intersects(Te,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new K(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ue))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(ue,ge,me){var Pe=null,Re=null;try{var Te=new de(ge,me)}catch{return null}return ue.forEach(function(je){Te.test(je)&&(Pe&&Re.compare(je)!==-1||(Re=new K(Pe=je,me)))}),Pe},e.minSatisfying=function(ue,ge,me){var Pe=null,Re=null;try{var Te=new de(ge,me)}catch{return null}return ue.forEach(function(je){Te.test(je)&&(Pe&&Re.compare(je)!==1||(Re=new K(Pe=je,me)))}),Pe},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,me){return Me(ue,ge,"<",me)},e.gtr=function(ue,ge,me){return Me(ue,ge,">",me)},e.outside=Me,e.prerelease=function(ue,ge){var me=re(ue,ge);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ue,ge,me){return ue=new de(ue,me),ge=new de(ge,me),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof K)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[p]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(b){if(D===setTimeout)return setTimeout(b,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(b,0);try{return D(b,0)}catch{try{return D.call(null,b,0)}catch{return D.call(this,b,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var k,m=[],C=!1,S=-1;function $(){C&&k&&(C=!1,k.length?m=k.concat(m):S=-1,m.length&&c())}function c(){if(!C){var b=R($);C=!0;for(var l=m.length;l;){for(k=m,m=[];++S<l;)k&&k[S].run();S=-1,l=m.length}k=null,C=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(b)}}function g(b,l){this.fun=b,this.array=l}function y(){}L.nextTick=function(b){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];m.push(new g(b,l)),m.length!==1||C||R(c)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=y,L.addListener=y,L.once=y,L.off=y,L.removeListener=y,L.removeAllListeners=y,L.emit=y,L.prependListener=y,L.prependOnceListener=y,L.listeners=function(b){return[]},L.binding=function(b){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(b){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(le[127],he([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class N{constructor(R,k,m){this.level=R,this.key=k,this.value=m,this.forward=[]}}const L=void 0;class j{constructor(R,k=2**16){this.comparator=R,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,k){return j.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=j.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let m=this.e.forward[0];for(;m;)R.call(k,m.value,m.key,this),m=m.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,m){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&m(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&m(C.key,k)===0)return C}static h(R,k,m,C){const S=[];let $=R.e;for(let c=R.d-1;c>=0;c--){for(;$.forward[c]&&C($.forward[c].key,k)<0;)$=$.forward[c];S[c]=$}if($=$.forward[0],$&&C($.key,k)===0)return $.value=m,!1;{const c=j.j(R);if(c>R.d){for(let g=R.d;g<c;g++)S[g]=R.e;R.d=c}$=new N(c,k,m);for(let g=0;g<c;g++)$.forward[g]=S[g].forward[g],S[g].forward[g]=$;return!0}}static j(R,k=.5){let m=1;for(;Math.random()<k&&m<R.c;)m+=1;return m}static k(R,k,m){const C=[];let S=R.e;for(let $=R.d-1;$>=0;$--){for(;S.forward[$]&&m(S.forward[$].key,k)<0;)S=S.forward[$];C[$]=S}if(S=S.forward[0],!S||m(S.key,k)!==0)return!1;for(let $=0;$<R.d&&C[$].forward[$]===S;$++)C[$].forward[$]=S.forward[$];for(;R.d>0&&R.e.forward[R.d-1]===L;)R.d-=1;return!0}}e.$Lr=j}),define(le[62],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=D&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=N}),define(le[3],he([0,1,7,85,2,87,62]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const R=!1,k=!1;var m;(function(w){w.None=()=>L.$Sc.None;function f(ce){if(k){const{onDidAddListener:oe}=ce,fe=g.create();let de=0;ce.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),oe?.()}}}function p(ce,oe){return Y(ce,()=>{},0,void 0,!0,void 0,oe)}w.defer=p;function I(ce){return(oe,fe=null,de)=>{let we=!1,ve;return ve=ce(Ie=>{if(!we)return ve?ve.dispose():we=!0,oe.call(fe,Ie)},null,de),we&&ve.dispose(),ve}}w.once=I;function F(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>de.call(we,oe(Ie)),null,ve),fe)}w.map=F;function M(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>{oe(Ie),de.call(we,Ie)},null,ve),fe)}w.forEach=M;function T(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>oe(Ie)&&de.call(we,Ie),null,ve),fe)}w.filter=T;function z(ce){return ce}w.signal=z;function Z(...ce){return(oe,fe=null,de)=>{const we=(0,L.$Pc)(...ce.map(ve=>ve(Ie=>oe.call(fe,Ie))));return V(we,de)}}w.any=Z;function J(ce,oe,fe,de){let we=fe;return F(ce,ve=>(we=oe(we,ve),we),de)}w.reduce=J;function x(ce,oe){let fe;const de={onWillAddFirstListener(){fe=ce(we.fire,we)},onDidRemoveLastListener(){fe?.dispose()}};oe||f(de);const we=new h(de);return oe?.add(we),we.event}function V(ce,oe){return oe instanceof Array?oe.push(ce):oe&&oe.add(ce),ce}function Y(ce,oe,fe=100,de=!1,we=!1,ve,Ie){let De,Me,ue,ge=0,me;const Pe={leakWarningThreshold:ve,onWillAddFirstListener(){De=ce(Te=>{ge++,Me=oe(Me,Te),de&&!ue&&(Re.fire(Me),Me=void 0),me=()=>{const je=Me;Me=void 0,ue=void 0,(!de||ge>1)&&Re.fire(je),ge=0},typeof fe=="number"?(clearTimeout(ue),ue=setTimeout(me,fe)):ue===void 0&&(ue=0,queueMicrotask(me))})},onWillRemoveListener(){we&&ge>0&&me?.()},onDidRemoveLastListener(){me=void 0,De.dispose()}};Ie||f(Pe);const Re=new h(Pe);return Ie?.add(Re),Re.event}w.debounce=Y;function W(ce,oe=0,fe){return w.debounce(ce,(de,we)=>de?(de.push(we),de):[we],oe,void 0,!0,void 0,fe)}w.accumulate=W;function B(ce,oe=(de,we)=>de===we,fe){let de=!0,we;return T(ce,ve=>{const Ie=de||!oe(ve,we);return de=!1,we=ve,Ie},fe)}w.latch=B;function te(ce,oe,fe){return[w.filter(ce,oe,fe),w.filter(ce,de=>!oe(de),fe)]}w.split=te;function se(ce,oe=!1,fe=[],de){let we=fe.slice(),ve=ce(Me=>{we?we.push(Me):De.fire(Me)});de&&de.add(ve);const Ie=()=>{we?.forEach(Me=>De.fire(Me)),we=null},De=new h({onWillAddFirstListener(){ve||(ve=ce(Me=>De.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(oe?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(De),De.event}w.buffer=se;function _(ce,oe){return(de,we,ve)=>{const Ie=oe(new K);return ce(function(De){const Me=Ie.evaluate(De);Me!==re&&de.call(we,Me)},void 0,ve)}}w.chain=_;const re=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(oe){return this.f.push(oe),this}forEach(oe){return this.f.push(fe=>(oe(fe),fe)),this}filter(oe){return this.f.push(fe=>oe(fe)?fe:re),this}reduce(oe,fe){let de=fe;return this.f.push(we=>(de=oe(de,we),de)),this}latch(oe=(fe,de)=>fe===de){let fe=!0,de;return this.f.push(we=>{const ve=fe||!oe(we,de);return fe=!1,de=we,ve?we:re}),this}evaluate(oe){for(const fe of this.f)if(oe=fe(oe),oe===re)break;return oe}}function U(ce,oe,fe=de=>de){const de=(...De)=>Ie.fire(fe(...De)),we=()=>ce.on(oe,de),ve=()=>ce.removeListener(oe,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}w.fromNodeEventEmitter=U;function P(ce,oe,fe=de=>de){const de=(...De)=>Ie.fire(fe(...De)),we=()=>ce.addEventListener(oe,de),ve=()=>ce.removeEventListener(oe,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}w.fromDOMEventEmitter=P;function A(ce){return new Promise(oe=>I(ce)(oe))}w.toPromise=A;function H(ce){const oe=new h;return ce.then(fe=>{oe.fire(fe)},()=>{oe.fire(void 0)}).finally(()=>{oe.dispose()}),oe.event}w.fromPromise=H;function q(ce,oe,fe){return oe(fe),ce(de=>oe(de))}w.runAndSubscribe=q;function ee(ce,oe){let fe=null;function de(ve){fe?.dispose(),fe=new L.$Rc,oe(ve,fe)}de(void 0);const we=ce(ve=>de(ve));return(0,L.$Qc)(()=>{we.dispose(),fe?.dispose()})}w.runAndSubscribeWithStore=ee;class G{constructor(oe,fe){this._observable=oe,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{oe.addObserver(this)},onDidRemoveLastListener:()=>{oe.removeObserver(this)}};fe||f(de),this.emitter=new h(de),fe&&fe.add(this.emitter)}beginUpdate(oe){this.f++}handlePossibleChange(oe){}handleChange(oe,fe){this.g=!0}endUpdate(oe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(ce,oe){return new G(ce,oe).emitter.event}w.fromObservable=Q;function ie(ce){return(oe,fe,de)=>{let we=0,ve=!1;const Ie={beginUpdate(){we++},endUpdate(){we--,we===0&&(ce.reportChanges(),ve&&(ve=!1,oe.call(fe)))},handlePossibleChange(){},handleChange(){ve=!0}};ce.addObserver(Ie),ce.reportChanges();const De={dispose(){ce.removeObserver(Ie)}};return de instanceof L.$Rc?de.add(De):Array.isArray(de)&&de.push(De),De}}w.fromObservableLight=ie})(m||(e.Event=m={}));class C{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${C.f++}`,C.all.add(this)}start(f){this.g=new O.$Od,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Qd=C;let S=-1;function $(w){const f=S;return S=w,{dispose(){S=f}}}e.$Rd=$;class c{constructor(f,p=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=p,this.g=0}dispose(){this.f?.clear()}check(f,p){const I=this.threshold;if(I<=0||p<I)return;this.f||(this.f=new Map);const F=this.f.get(f.value)||0;if(this.f.set(f.value,F+1),this.g-=1,this.g<=0){this.g=I*.5;let M,T=0;for(const[z,Z]of this.f)(!M||T<Z)&&(M=z,T=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${T}):`),console.warn(M)}return()=>{const M=this.f.get(f.value)||0;this.f.set(f.value,M-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class b{constructor(f){this.value=f,this.id=y++}}const l=2,u=(w,f)=>{if(w instanceof b)f(w);else for(let p=0;p<w.length;p++){const I=w[p];I&&f(I)}};class h{constructor(f){this.w=0,this.f=f,this.g=S>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const f=this.t;queueMicrotask(()=>{u(f,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,p,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Sc.None;if(this.m)return L.$Sc.None;p&&(f=f.bind(p));const F=new b(f);let M,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),M=this.g.check(F.stack,this.w+1)),R&&(F.stack=T??g.create()),this.t?this.t instanceof b?(this.u??=new E,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,L.$Qc)(()=>{M?.(),this.x(F)});return I instanceof L.$Rc?I.add(z):Array.isArray(I)&&I.push(z),z},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,I=p.indexOf(f);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[I]=void 0;const F=this.u.current===this;if(this.w*l<=p.length){let M=0;for(let T=0;T<p.length;T++)p[T]?p[M++]=p[T]:F&&(this.u.end--,M<this.u.i&&this.u.i--);p.length=M}}y(f,p){if(!f)return;const I=this.f?.onListenerError||D.$1;if(!I){f.value(p);return}try{f.value(p)}catch(F){I(F)}}z(f){const p=f.current.t;for(;f.i<f.end;)this.y(p[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,f);else{const p=this.u;p.enqueue(this,f,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=h;const d=()=>new E;e.$Td=d;class E{constructor(){this.i=-1,this.end=0}enqueue(f,p,I){this.i=0,this.end=I,this.current=f,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(f,p,I){if(this.t)for(this.h||(this.h=new j.$3c),u(this.t,F=>this.h.push([F.value,f]));this.h.size>0&&!p.isCancellationRequested;){const[F,M]=this.h.shift(),T=[],z={...M,token:p,waitUntil:Z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");I&&(Z=I(Z,F)),T.push(Z)}};try{F(z)}catch(Z){(0,D.$1)(Z);continue}Object.freeze(T),await Promise.allSettled(T).then(Z=>{for(const J of Z)J.status==="rejected"&&(0,D.$1)(J.reason)})}}}e.$Ud=s;class o extends h{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new j.$3c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Vd=o;class n extends o{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Wd=n;class i extends h{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$Xd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const p={event:f,listener:null};this.h.push(p),this.g&&this.m(p);const I=()=>{this.g&&this.o(p);const F=this.h.indexOf(p);this.h.splice(F,1)};return(0,L.$Qc)((0,N.$db)(I))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(p=>this.f.fire(p))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Yd=t;class r{constructor(f,p,I,F){this.f=new L.$Rc;const M=this.f.add(new t),T=this.f.add(new L.$2c);function z(Z){T.set(Z,M.add(F(Z)))}for(const Z of f)z(Z);this.f.add(p(Z=>{z(Z)})),this.f.add(I(Z=>{T.deleteAndDispose(Z)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Zd=r;class a{constructor(){this.f=[]}wrapEvent(f){return(p,I,F)=>f(M=>{const T=this.f[this.f.length-1];T?T.push(()=>p.call(I,M)):p.call(I,M)},void 0,F)}bufferEvents(f){const p=[];this.f.push(p);const I=f();return this.f.pop(),p.forEach(F=>F()),I}}e.$1d=a;class v{constructor(){this.f=!1,this.g=m.None,this.h=L.$Sc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=v}),define(le[26],he([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const N=Object.freeze(function(R,k){const m=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(m)}}});var L;(function(R){function k(m){return m===R.None||m===R.Cancelled||m instanceof j?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$3d=O}),define(le[128],he([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new D.$3d,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Be=N;class L{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$Ce=L;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$De=j}),define(le[46],he([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function L(d){const E=d;return E?typeof E.read=="function":!1}e.$4d=L;function j(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(s=>typeof s=="function"):!1}e.$5d=j;function O(d){const E=d;return E?j(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$6d=O;function R(d,E){return new k(d,E)}e.$7d=R;class k{constructor(E,s){this.e=E,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(s=>s(E))}h(E){this.c.error.length===0?(0,D.$1)(E):this.c.error.slice(0).forEach(s=>s(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,s){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(E,s){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(d,E){const s=[];let o;for(;(o=d.read())!==null;)s.push(o);return E(s)}e.$8d=m;function C(d,E,s){const o=[];let n;for(;(n=d.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return d.read()}}}e.$9d=C;function S(d,E){return new Promise((s,o)=>{const n=[];$(d,{onData:i=>{E&&n.push(i)},onError:i=>{E?o(i):s(void 0)},onEnd:()=>{s(E?E(n):void 0)}})})}e.$0d=S;function $(d,E,s){d.on("error",o=>{s?.isCancellationRequested||E.onError(o)}),d.on("end",()=>{s?.isCancellationRequested||E.onEnd()}),d.on("data",o=>{s?.isCancellationRequested||E.onData(o)})}e.$$d=$;function c(d,E){return new Promise((s,o)=>{const n=new N.$Rc,i=[],t=v=>{if(i.push(v),i.length>E)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),s({stream:d,buffer:i,ended:!0}));n.add((0,N.$Qc)(()=>d.removeListener("error",r))),d.on("error",r),n.add((0,N.$Qc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Qc)(()=>d.removeListener("data",t))),d.on("data",t)})}e.$_d=c;function g(d,E){const s=R(E);return s.end(d),s}e.$ae=g;function y(){const d=R(()=>{throw new Error("not supported")});return d.end(),d}e.$be=y;function b(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.$ce=b;function l(d,E,s){const o=R(s);return $(d,{onData:n=>o.write(E.data(n)),onError:n=>o.error(E.error?E.error(n):n),onEnd:()=>o.end()}),o}e.$de=l;function u(d,E,s){let o=!1;return{read:()=>{const n=E.read();return o?n:(o=!0,n!==null?s([d,n]):d)}}}e.$ee=u;function h(d,E,s){let o=!1;const n=R(s);return $(E,{onData:i=>o?n.write(i):(o=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(d)),n.end()}}),n}e.$fe=h}),define(le[15],he([0,1,52,46]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const L=typeof Buffer<"u",j=new D.$V(()=>new Uint8Array(256));let O,R;class k{static alloc(p){return L?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return L&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,I){return!(I?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(p)):(O||(O=new TextEncoder),new k(O.encode(p)))}static fromByteArray(p){const I=k.alloc(p.length);for(let F=0,M=p.length;F<M;F++)I.buffer[F]=p[F];return I}static concat(p,I){if(typeof I>"u"){I=0;for(let T=0,z=p.length;T<z;T++)I+=p[T].byteLength}const F=k.alloc(I);let M=0;for(let T=0,z=p.length;T<z;T++){const Z=p[T];F.set(Z,M),M+=Z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,I){return new k(this.buffer.subarray(p,I))}set(p,I){if(p instanceof k)this.buffer.set(p.buffer,I);else if(p instanceof Uint8Array)this.buffer.set(p,I);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),I);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return $(this.buffer,p)}writeUInt32BE(p,I){c(this.buffer,p,I)}readUInt32LE(p){return g(this.buffer,p)}writeUInt32LE(p,I){y(this.buffer,p,I)}readUInt8(p){return b(this.buffer,p)}writeUInt8(p,I){l(this.buffer,p,I)}indexOf(p,I=0){return m(this.buffer,p instanceof k?p.buffer:p,I)}}e.$ge=k;function m(f,p,I=0){const F=p.byteLength,M=f.byteLength;if(F===0)return 0;if(F===1)return f.indexOf(p[0]);if(F>M-I)return-1;const T=j.value;T.fill(p.length);for(let x=0;x<p.length;x++)T[p[x]]=p.length-x-1;let z=I+p.length-1,Z=z,J=-1;for(;z<M;)if(f[z]===p[Z]){if(Z===0){J=z;break}z--,Z--}else z+=Math.max(p.length-Z,T[f[z]]),Z=p.length-1;return J}e.$he=m;function C(f,p){return f[p+0]<<0>>>0|f[p+1]<<8>>>0}e.$ie=C;function S(f,p,I){f[I+0]=p&255,p=p>>>8,f[I+1]=p&255}e.$je=S;function $(f,p){return f[p]*2**24+f[p+1]*2**16+f[p+2]*2**8+f[p+3]}e.$ke=$;function c(f,p,I){f[I+3]=p,p=p>>>8,f[I+2]=p,p=p>>>8,f[I+1]=p,p=p>>>8,f[I]=p}e.$le=c;function g(f,p){return f[p+0]<<0>>>0|f[p+1]<<8>>>0|f[p+2]<<16>>>0|f[p+3]<<24>>>0}e.$me=g;function y(f,p,I){f[I+0]=p&255,p=p>>>8,f[I+1]=p&255,p=p>>>8,f[I+2]=p&255,p=p>>>8,f[I+3]=p&255}e.$ne=y;function b(f,p){return f[p]}e.$oe=b;function l(f,p,I){f[I]=p}e.$pe=l;function u(f){return N.$8d(f,p=>k.concat(p))}e.$qe=u;function h(f){return N.$ce(f)}e.$re=h;function d(f){return N.$0d(f,p=>k.concat(p))}e.$se=d;async function E(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await d(f.stream)])}e.$te=E;function s(f){return N.$ae(f,p=>k.concat(p))}e.$ue=s;function o(f){return N.$de(f,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$ve=o;function n(f){return N.$7d(p=>k.concat(p),f)}e.$we=n;function i(f,p){return N.$ee(f,p,I=>k.concat(I))}e.$xe=i;function t(f,p){return N.$fe(f,p,I=>k.concat(I))}e.$ye=t;function r(f){let p=0,I=0,F=0;const M=new Uint8Array(Math.floor(f.length/4*3)),T=Z=>{switch(I){case 3:M[F++]=p|Z,I=0;break;case 2:M[F++]=p|Z>>>2,p=Z<<6,I=3;break;case 1:M[F++]=p|Z>>>4,p=Z<<4,I=2;break;default:p=Z<<2,I=1}};for(let Z=0;Z<f.length;Z++){const J=f.charCodeAt(Z);if(J>=65&&J<=90)T(J-65);else if(J>=97&&J<=122)T(J-97+26);else if(J>=48&&J<=57)T(J-48+52);else if(J===43||J===45)T(62);else if(J===47||J===95)T(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Z]}`)}}const z=F;for(;I>0;)T(0);return k.wrap(M).slice(0,z)}e.$ze=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:f},p=!0,I=!1){const F=I?v:a;let M="";const T=f.byteLength%3;let z=0;for(;z<f.byteLength-T;z+=3){const Z=f[z+0],J=f[z+1],x=f[z+2];M+=F[Z>>>2],M+=F[(Z<<4|J>>>4)&63],M+=F[(J<<2|x>>>6)&63],M+=F[x&63]}if(T===1){const Z=f[z+0];M+=F[Z>>>2],M+=F[Z<<4&63],p&&(M+="==")}else if(T===2){const Z=f[z+0],J=f[z+1];M+=F[Z>>>2],M+=F[(Z<<4|J>>>4)&63],M+=F[J<<2&63],p&&(M+="=")}return M}e.$Ae=w}),define(le[27],he([0,1,128,52]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function L(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.$Ge=L;const j=/{(\d+)}/g;function O(ae,...$e){return $e.length===0?ae:ae.replace(j,function(be,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=$e.length?be:$e[ke]})}e.$He=O;const R=/{([^}]+)}/g;function k(ae,$e){return Object.keys($e).length===0?ae:ae.replace(R,(be,ye)=>$e[ye]??be)}e.$Ie=k;function m(ae){return ae.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Je=m;function C(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=C;function S(ae,$e){let be=0;const ye=$e.charCodeAt(0);for(let ke=ae.length-1;ke>=0;ke--)ae.charCodeAt(ke)===ye&&be++;return be}e.$Le=S;function $(ae,$e,be="\u2026"){return ae.length<=$e?ae:`${ae.substr(0,$e)}${be}`}e.$Me=$;function c(ae,$e,be="\u2026"){if(ae.length<=$e)return ae;const ye=Math.ceil($e/2)-be.length/2,ke=Math.floor($e/2)-be.length/2;return`${ae.substr(0,ye)}${be}${ae.substr(ae.length-ke)}`}e.$Ne=c;function g(ae,$e=" "){const be=y(ae,$e);return b(be,$e)}e.$Oe=g;function y(ae,$e){if(!ae||!$e)return ae;const be=$e.length;if(be===0||ae.length===0)return ae;let ye=0;for(;ae.indexOf($e,ye)===ye;)ye=ye+be;return ae.substring(ye)}e.$Pe=y;function b(ae,$e){if(!ae||!$e)return ae;const be=$e.length,ye=ae.length;if(be===0||ye===0)return ae;let ke=ye,Se=-1;for(;Se=ae.lastIndexOf($e,ke-1),!(Se===-1||Se+be!==ke);){if(Se===0)return"";ke=Se}return ae.substring(0,ke)}e.$Qe=b;function l(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=l;function u(ae){return ae.replace(/\*/g,"")}e.$Se=u;function h(ae,$e,be={}){if(!ae)throw new Error("Cannot create regex from empty string");$e||(ae=C(ae)),be.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let ye="";return be.global&&(ye+="g"),be.matchCase||(ye+="i"),be.multiline&&(ye+="m"),be.unicode&&(ye+="u"),new RegExp(ae,ye)}e.$Te=h;function d(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.$Ue=d;function E(ae){return ae.split(/\r\n|\r|\n/)}e.$Ve=E;function s(ae){for(let $e=0,be=ae.length;$e<be;$e++){const ye=ae.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$We=s;function o(ae,$e=0,be=ae.length){for(let ye=$e;ye<be;ye++){const ke=ae.charCodeAt(ye);if(ke!==32&&ke!==9)return ae.substring($e,ye)}return ae.substring($e,be)}e.$Xe=o;function n(ae,$e=ae.length-1){for(let be=$e;be>=0;be--){const ye=ae.charCodeAt(be);if(ye!==32&&ye!==9)return be}return-1}e.$Ye=n;function i(ae,$e,be){const ye=[];let ke=0;for(const Se of ae.matchAll($e)){if(ye.push(ae.slice(ke,Se.index)),Se.index===void 0)throw new Error("match.index should be defined");ke=Se.index+Se[0].length,ye.push(be(Se[0],...Se.slice(1),Se.index,ae,Se.groups))}return ye.push(ae.slice(ke)),Promise.all(ye).then(Se=>Se.join(""))}e.$Ze=i;function t(ae,$e){return ae<$e?-1:ae>$e?1:0}e.$1e=t;function r(ae,$e,be=0,ye=ae.length,ke=0,Se=$e.length){for(;be<ye&&ke<Se;be++,ke++){const Ae=ae.charCodeAt(be),Fe=$e.charCodeAt(ke);if(Ae<Fe)return-1;if(Ae>Fe)return 1}const Ce=ye-be,Oe=Se-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$2e=r;function a(ae,$e){return v(ae,$e,0,ae.length,0,$e.length)}e.$3e=a;function v(ae,$e,be=0,ye=ae.length,ke=0,Se=$e.length){for(;be<ye&&ke<Se;be++,ke++){let Ae=ae.charCodeAt(be),Fe=$e.charCodeAt(ke);if(Ae===Fe)continue;if(Ae>=128||Fe>=128)return r(ae.toLowerCase(),$e.toLowerCase(),be,ye,ke,Se);f(Ae)&&(Ae-=32),f(Fe)&&(Fe-=32);const ze=Ae-Fe;if(ze!==0)return ze}const Ce=ye-be,Oe=Se-ke;return Ce<Oe?-1:Ce>Oe?1:0}e.$4e=v;function w(ae){return ae>=48&&ae<=57}e.$5e=w;function f(ae){return ae>=97&&ae<=122}e.$6e=f;function p(ae){return ae>=65&&ae<=90}e.$7e=p;function I(ae,$e){return ae.length===$e.length&&v(ae,$e)===0}e.$8e=I;function F(ae,$e){const be=$e.length;return $e.length>ae.length?!1:v(ae,$e,0,be)===0}e.$9e=F;function M(ae,$e){const be=Math.min(ae.length,$e.length);let ye;for(ye=0;ye<be;ye++)if(ae.charCodeAt(ye)!==$e.charCodeAt(ye))return ye;return be}e.$0e=M;function T(ae,$e){const be=Math.min(ae.length,$e.length);let ye;const ke=ae.length-1,Se=$e.length-1;for(ye=0;ye<be;ye++)if(ae.charCodeAt(ke-ye)!==$e.charCodeAt(Se-ye))return ye;return be}e.$$e=T;function z(ae){return 55296<=ae&&ae<=56319}e.$_e=z;function Z(ae){return 56320<=ae&&ae<=57343}e.$af=Z;function J(ae,$e){return(ae-55296<<10)+($e-56320)+65536}e.$bf=J;function x(ae,$e,be){const ye=ae.charCodeAt(be);if(z(ye)&&be+1<$e){const ke=ae.charCodeAt(be+1);if(Z(ke))return J(ye,ke)}return ye}e.$cf=x;function V(ae,$e){const be=ae.charCodeAt($e-1);if(Z(be)&&$e>1){const ye=ae.charCodeAt($e-2);if(z(ye))return J(ye,be)}return be}class Y{get offset(){return this.e}constructor($e,be=0){this.c=$e,this.d=$e.length,this.e=be}setOffset($e){this.e=$e}prevCodePoint(){const $e=V(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=x(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$df=Y;class W{get offset(){return this.c.offset}constructor($e,be=0){this.c=new Y($e,be)}nextGraphemeLength(){const $e=me.getInstance(),be=this.c,ye=be.offset;let ke=$e.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Se=be.offset,Ce=$e.getGraphemeBreakType(be.nextCodePoint());if(ue(ke,Ce)){be.setOffset(Se);break}ke=Ce}return be.offset-ye}prevGraphemeLength(){const $e=me.getInstance(),be=this.c,ye=be.offset;let ke=$e.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Se=be.offset,Ce=$e.getGraphemeBreakType(be.prevCodePoint());if(ue(Ce,ke)){be.setOffset(Se);break}ke=Ce}return ye-be.offset}eol(){return this.c.eol()}}e.$ef=W;function B(ae,$e){return new W(ae,$e).nextGraphemeLength()}e.$ff=B;function te(ae,$e){return new W(ae,$e).prevGraphemeLength()}e.$gf=te;function se(ae,$e){$e>0&&Z(ae.charCodeAt($e))&&$e--;const be=$e+B(ae,$e);return[be-te(ae,be),be]}e.$hf=se;function _(ae){const $e=new W(ae);let be=0;for(;!$e.eol();)be++,$e.nextGraphemeLength();return be}e.$if=_;let re;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(ae){return re||(re=K()),re.test(ae)}e.$jf=U;const P=/^[\t\n\r\x20-\x7E]*$/;function A(ae){return P.test(ae)}e.$kf=A,e.$lf=/[\u2028\u2029]/;function H(ae){return e.$lf.test(ae)}e.$mf=H;function q(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.$nf=q;function ee(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.$of=ee;function G(ae,$e){if(ae.length<$e)return ae;const be=/\b/g;let ye=0;for(;be.test(ae)&&!(ae.length-be.lastIndex<$e);)ye=be.lastIndex,be.lastIndex+=1;return ae.substring(ye).replace(/^\s/,"")}e.$pf=G;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function ce(ae){return ae&&(ae=ae.replace(Q,"").replace(ie,"")),ae}e.$qf=ce,e.$rf=String.fromCharCode(65279);function oe(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.$sf=oe;function fe(ae){return oe(ae)?ae.substr(1):ae}e.$tf=fe;function de(ae,$e){if(!ae||!$e||ae.length<$e.length)return!1;const be=$e.length,ye=ae.toLowerCase();let ke=0,Se=-1;for(;ke<be;){const Ce=ye.indexOf($e[ke],Se+1);if(Ce<0)return!1;Se=Ce,ke++}return!0}e.$uf=de;function we(ae,$e=!1){return ae?($e&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.$vf=we;function ve(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.$wf=ve;function Ie(ae,$e=1){if($e===0)return"";let be=-1;do be=ae.indexOf(`
`,be+1),$e--;while($e>0&&be>=0);return be===-1?ae:(ae[be-1]==="\r"&&be--,ae.substr(0,be))}e.$xf=Ie;function De(ae){return ae=ae%(2*26),ae<26?String.fromCharCode(97+ae):String.fromCharCode(65+ae-26)}e.$yf=De;function Me(ae){return me.getInstance().getGraphemeBreakType(ae)}e.$zf=Me;function ue(ae,$e){return ae===0?$e!==5&&$e!==7:ae===2&&$e===3?!1:ae===4||ae===2||ae===3||$e===4||$e===2||$e===3?!0:!(ae===8&&($e===8||$e===9||$e===11||$e===12)||(ae===11||ae===9)&&($e===9||$e===10)||(ae===12||ae===10)&&$e===10||$e===5||$e===13||$e===7||ae===1||ae===13&&$e===14||ae===6&&$e===6)}var ge;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class me{static{this.c=null}static getInstance(){return me.c||(me.c=new me),me.c}constructor(){this.d=Pe()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const be=this.d,ye=be.length/3;let ke=1;for(;ke<=ye;)if($e<be[3*ke])ke=2*ke;else if($e>be[3*ke+1])ke=2*ke+1;else return be[3*ke+2];return 0}}function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ae,$e){if(ae===0)return 0;const be=Te(ae,$e);if(be!==void 0)return be;const ye=new Y($e,ae);return ye.prevCodePoint(),ye.offset}e.$Af=Re;function Te(ae,$e){const be=new Y($e,ae);let ye=be.prevCodePoint();for(;je(ye)||ye===65039||ye===8419;){if(be.offset===0)return;ye=be.prevCodePoint()}if(!ee(ye))return;let ke=be.offset;return ke>0&&be.prevCodePoint()===8205&&(ke=be.offset),ke}function je(ae){return 127995<=ae&&ae<=127999}var qe;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$Bf="\xA0";class Ne{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce($e=>{function be(ze){const Ve=new Map;for(let Be=0;Be<ze.length;Be+=2)Ve.set(ze[Be],ze[Be+1]);return Ve}function ye(ze,Ve){const Be=new Map(ze);for(const[xe,_e]of Ve)Be.set(xe,_e);return Be}function ke(ze,Ve){if(!ze)return Ve;const Be=new Map;for(const[xe,_e]of ze)Ve.has(xe)&&Be.set(xe,_e);return Be}const Se=this.c.value;let Ce=$e.filter(ze=>!ze.startsWith("_")&&ze in Se);Ce.length===0&&(Ce=["_default"]);let Oe;for(const ze of Ce){const Ve=be(Se[ze]);Oe=ke(Oe,Ve)}const Ae=be(Se._common),Fe=ye(Ae,Oe);return new Ne(Fe)})}static getInstance($e){return Ne.d.get(Array.from($e))}static{this.e=new N.$V(()=>Object.keys(Ne.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Ne.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=Ne;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter($e){return Ue.e().has($e)}static get codePoints(){return Ue.e()}}e.$Df=Ue}),define(le[53],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function N(l){return L(l,0)}e.$Pi=N;function L(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?k(l,u):m(l,u);case"string":return R(l,u);case"boolean":return O(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$Qi=L;function j(l,u){return(u<<5)-u+l|0}e.$Ri=j;function O(l,u){return j(l?433:863,u)}function R(l,u){u=j(149417,u);for(let h=0,d=l.length;h<d;h++)u=j(l.charCodeAt(h),u);return u}e.$Si=R;function k(l,u){return u=j(104579,u),l.reduce((h,d)=>L(d,h),u)}function m(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((h,d)=>(h=R(d,h),L(l[d],h)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$Ti=C;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function $(l,u,h=32){const d=h-u,E=~((1<<d)-1);return(l<<u|(E&l)>>>d)>>>0}function c(l,u=0,h=l.byteLength,d=0){for(let E=0;E<h;E++)l[u+E]=d}function g(l,u,h="0"){for(;l.length<u;)l=h+l;return l}function y(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((l>>>0).toString(16),u/4)}e.$Ui=y;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const d=this.p;let E=this.r,s=this.u,o,n;for(s!==0?(o=s,n=-1,s=0):(o=u.charCodeAt(0),n=0);;){let i=o;if(D.$_e(o))if(n+1<h){const t=u.charCodeAt(n+1);D.$af(t)?(n++,i=D.$bf(o,t)):i=65533}else{s=o;break}else D.$af(o)&&(i=65533);if(E=this.w(d,E,i),n++,n<h)o=u.charCodeAt(n);else break}this.r=E,this.u=s}w(u,h,d){return d<128?u[h++]=d:d<2048?(u[h++]=192|(d&1984)>>>6,u[h++]=128|(d&63)>>>0):d<65536?(u[h++]=224|(d&61440)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0):(u[h++]=240|(d&1835008)>>>18,u[h++]=128|(d&258048)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=b.g,h=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,$(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,E=this.l,s=this.m,o=this.n,n=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&s|~E&o,t=1518500249):a<40?(i=E^s^o,t=1859775393):a<60?(i=E&s|E&o|s&o,t=2400959708):(i=E^s^o,t=3395469782),r=$(d,5)+i+n+t+u.getUint32(a*4,!1)&4294967295,n=o,o=s,s=$(E,30),E=d,d=r;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Vi=b}),define(le[89],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const j="error",O="warning",R="warn",k="info",m="ignore";function C($){return $?D.$8e(j,$)?L.Error:D.$8e(O,$)||D.$8e(R,$)?L.Warning:D.$8e(k,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=C;function S($){switch($){case L.Error:return j;case L.Warning:return O;case L.Info:return k;default:return m}}L.toString=S}(N||(N={})),e.default=N}),define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(le[47],he([0,1,18,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const g=c.charCodeAt(0),y=this.b.charCodeAt(this.c);return g-y}value(){return this.b[this.c]}}e.$4h=L;class j{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$2e)(c,this.b,0,c.length,this.c,this.d):(0,N.$4e)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=j;class O{constructor(c=!0,g=!0){this.f=c,this.g=g}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let g=c.length-1;g>=0;g--,this.c--){const y=this.b.charCodeAt(g);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$2e)(c,this.b,0,c.length,this.d,this.e):(0,N.$4e)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=O;var R;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(c,g){this.f=c,this.g=g,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$3e)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$3e)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$1e)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$1e)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=k;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(C||(C={}));class S{static forUris(c=()=>!1,g=()=>!1){return new S(new k(c,g))}static forPaths(c=!1){return new S(new O(void 0,!c))}static forStrings(){return new S(new L)}static forConfigKeys(){return new S(new j)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,g){if(g){const y=g.slice(0);(0,D.$Xb)(y);for(const b of y)this.set(b,c)}else{const y=c.slice(0);(0,D.$Xb)(y);for(const b of y)this.set(b[0],b[1])}}set(c,g){const y=this.b.reset(c);let b;this.c||(this.c=new m,this.c.segment=y.value());const l=[];for(b=this.c;;){const h=y.cmp(b.segment);if(h>0)b.left||(b.left=new m,b.left.segment=y.value()),l.push([-1,b]),b=b.left;else if(h<0)b.right||(b.right=new m,b.right.segment=y.value()),l.push([1,b]),b=b.right;else if(y.hasNext())y.next(),b.mid||(b.mid=new m,b.mid.segment=y.value()),l.push([0,b]),b=b.mid;else break}const u=b.value;b.value=g,b.key=c;for(let h=l.length-1;h>=0;h--){const d=l[h][1];d.updateHeight();const E=d.balanceFactor();if(E<-1||E>1){const s=l[h][0],o=l[h+1][0];if(s===1&&o===1)l[h][1]=d.rotateLeft();else if(s===-1&&o===-1)l[h][1]=d.rotateRight();else if(s===1&&o===-1)d.right=l[h+1][1]=l[h+1][1].rotateRight(),l[h][1]=d.rotateLeft();else if(s===-1&&o===1)d.left=l[h+1][1]=l[h+1][1].rotateLeft(),l[h][1]=d.rotateRight();else throw new Error;if(h>0)switch(l[h-1][0]){case-1:l[h-1][1].left=l[h][1];break;case 1:l[h-1][1].right=l[h][1];break;case 0:l[h-1][1].mid=l[h][1];break}else this.c=l[0][1]}}return u}get(c){return this.d(c)?.value}d(c){const g=this.b.reset(c);let y=this.c;for(;y;){const b=g.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if(g.hasNext())g.next(),y=y.mid;else break}return y}has(c){const g=this.d(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,g){const y=this.b.reset(c),b=[];let l=this.c;for(;l;){const u=y.cmp(l.segment);if(u>0)b.push([-1,l]),l=l.left;else if(u<0)b.push([1,l]),l=l.right;else if(y.hasNext())y.next(),b.push([0,l]),l=l.mid;else break}if(l){if(g?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:h,value:d,segment:E}=u;this.e(u.key,!1),l.key=h,l.value=d,l.segment=E}}else{const u=l.left??l.right;if(b.length>0){const[h,d]=b[b.length-1];switch(h){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=b.length-1;u>=0;u--){const h=b[u][1];h.updateHeight();const d=h.balanceFactor();if(d>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),b[u][1]=h.rotateLeft()):d<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),b[u][1]=h.rotateRight()),u>0)switch(b[u-1][0]){case-1:b[u-1][1].left=b[u][1];break;case 1:b[u-1][1].right=b[u][1];break;case 0:b[u-1][1].mid=b[u][1];break}else this.c=b[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this.b.reset(c);let y=this.c,b;for(;y;){const l=g.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(g.hasNext())g.next(),b=y.value||b,y=y.mid;else break}return y&&y.value||b}findSuperstr(c){return this.g(c,!1)}g(c,g){const y=this.b.reset(c);let b=this.c;for(;b;){const l=y.cmp(b.segment);if(l>0)b=b.left;else if(l<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else return b.mid?this.h(b.mid):g?b.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[g,y]of this)c(y,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const g=[];return this.j(c,g),g[Symbol.iterator]()}j(c,g){c&&(c.left&&this.j(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this.j(c.mid,g),c.right&&this.j(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const y=g.balanceFactor();return y<-1||y>1?!1:c(g.left)&&c(g.right)};return c(this.c)}}e.$8h=S}),define(le[12],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function D(E){return typeof E=="string"}e.$Ef=D;function N(E){return Array.isArray(E)&&E.every(s=>D(s))}e.$Ff=N;function L(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$Gf=L;function j(E){const s=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof s}e.$Hf=j;function O(E){return typeof E=="number"&&!isNaN(E)}e.$If=O;function R(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Jf=R;function k(E){return E===!0||E===!1}e.$Kf=k;function m(E){return typeof E>"u"}e.$Lf=m;function C(E){return!S(E)}e.$Mf=C;function S(E){return m(E)||E===null}e.$Nf=S;function $(E,s){if(!E)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Of=$;function c(E){if(S(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Pf=c;function g(...E){const s=[];for(let o=0;o<E.length;o++){const n=E[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.$Qf=g;const y=Object.prototype.hasOwnProperty;function b(E){if(!L(E))return!1;for(const s in E)if(y.call(E,s))return!1;return!0}e.$Rf=b;function l(E){return typeof E=="function"}e.$Sf=l;function u(...E){return E.length>0&&E.every(l)}e.$Tf=u;function h(E,s){const o=Math.min(E.length,s.length);for(let n=0;n<o;n++)d(E[n],s[n])}e.$Uf=h;function d(E,s){if(D(s)){if(typeof E!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(E instanceof s)return}catch{}if(!S(E)&&E.constructor===s||s.length===1&&s.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=d}),define(le[30],he([0,1,12]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([h,d])=>{u[h]=d&&typeof d=="object"?N(d):d}),u}e.$hn=N;function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const h=u.shift();Object.freeze(h);for(const d in h)if(j.call(h,d)){const E=h[d];typeof E=="object"&&!Object.isFrozen(E)&&!(0,D.$Hf)(E)&&u.push(E)}}return l}e.$in=L;const j=Object.prototype.hasOwnProperty;function O(l,u){return R(l,u,new Set)}e.$jn=O;function R(l,u,h){if((0,D.$Nf)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const E=[];for(const s of l)E.push(R(s,u,h));return E}if((0,D.$Gf)(l)){if(h.has(l))throw new Error("Cannot clone recursive data-structure");h.add(l);const E={};for(const s in l)j.call(l,s)&&(E[s]=R(l[s],u,h));return h.delete(l),E}return l}function k(l,u,h=!0){return(0,D.$Gf)(l)?((0,D.$Gf)(u)&&Object.keys(u).forEach(d=>{d in l?h&&((0,D.$Gf)(l[d])&&(0,D.$Gf)(u[d])?k(l[d],u[d],h):l[d]=u[d]):l[d]=u[d]}),l):u}e.$kn=k;function m(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let h,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(h=0;h<l.length;h++)if(!m(l[h],u[h]))return!1}else{const E=[];for(d in l)E.push(d);E.sort();const s=[];for(d in u)s.push(d);if(s.sort(),!m(E,s))return!1;for(h=0;h<E.length;h++)if(!m(l[E[h]],u[E[h]]))return!1}return!0}e.$ln=m;function C(l){const u=new Set;return JSON.stringify(l,(h,d)=>{if((0,D.$Gf)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return d})}e.$mn=C;function S(l,u){const h=Object.create(null);return!l||!u||Object.keys(u).forEach(E=>{const s=l[E],o=u[E];m(s,o)||(h[E]=o)}),h}e.$nn=S;function $(l,u){const h=u.toLowerCase(),d=Object.keys(l).find(E=>E.toLowerCase()===h);return d?l[d]:l[u]}e.$on=$;function c(l,u){const h=Object.create(null);for(const[d,E]of Object.entries(l))u(d,E)&&(h[d]=E);return h}e.$pn=c;function g(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$qn=g;function y(l){const u=[];for(const h of g(l))typeof l[h]=="function"&&u.push(h);return u}e.$rn=y;function b(l,u){const h=E=>function(){const s=Array.prototype.slice.call(arguments,0);return u(E,s)},d={};for(const E of l)d[E]=h(E);return d}e.$sn=b}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return D.test(L)}e.$lg=N,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,m="";return m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+="-",m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m+=O[j[k++]],m}}()}),define(le[130],he([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function j(){const O=(0,D.networkInterfaces)();for(const R in O){const k=O[R];if(k){for(const{mac:m}of k)if(L(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$4m=j}),define(le[131],he([0,1,267,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,k){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let m=0;for(;m<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,m):(0,N.$he)(this.a,this.b,m);if(C===-1)break;this.push(this.a.slice(m,C+this.c)),m=C+this.c}this.a=m===this.a.length?void 0:this.a.slice(m),k()}_flush(O){this.a&&this.push(this.a),O()}}e.$aU=L}),define(le[132],he([0,1,63]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function N(R,k,m,C=1){let S=!1;return new Promise($=>{const c=setTimeout(()=>{if(!S)return S=!0,$(0)},m);L(R,k,C,g=>{if(!S)return S=!0,clearTimeout(c),$(g)})})}e.$og=N;function L(R,k,m,C){if(k===0)return C(0);const S=new D.Socket;S.once("connect",()=>(O(S),L(R+m,k-1,m,C))),S.once("data",()=>{}),S.once("error",$=>(O(S),$.code!=="ECONNREFUSED"?L(R+m,k-1,m,C):C(R))),S.connect(R,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,k,m,C="127.0.0.1"){let S=!1,$,c=1;const g=D.createServer({pauseOnConnect:!0});function y(b,l){S||(S=!0,g.removeAllListeners(),g.close(),$&&clearTimeout($),l(b))}return new Promise(b=>{$=setTimeout(()=>{y(0,b)},m),g.on("listening",()=>{y(R,b)}),g.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<k?(R++,c++,g.listen(R,C)):y(0,b)}),g.on("close",()=>{y(0,b)}),g.listen(R,C)})}e.$qg=j;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(le[133],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;function D(N){return!!N.parentPort}e.$qU=D}),define(le[134],he([13,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[64],he([0,1,134]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0;const N=60,L=N*60,j=L*24,O=j*7,R=j*30,k=j*365;function m(S,$,c,g){typeof S!="number"&&(S=S.getTime());const y=Math.round((new Date().getTime()-S)/1e3);if(y<-30)return(0,D.localize)(0,null,m(new Date().getTime()+y*1e3,!1));if(!g&&y<30)return(0,D.localize)(1,null);let b;return y<N?(b=y,$?b===1?c?(0,D.localize)(2,null,b):(0,D.localize)(3,null,b):c?(0,D.localize)(4,null,b):(0,D.localize)(5,null,b):b===1?c?(0,D.localize)(6,null,b):(0,D.localize)(7,null,b):c?(0,D.localize)(8,null,b):(0,D.localize)(9,null,b)):y<L?(b=Math.floor(y/N),$?b===1?c?(0,D.localize)(10,null,b):(0,D.localize)(11,null,b):c?(0,D.localize)(12,null,b):(0,D.localize)(13,null,b):b===1?c?(0,D.localize)(14,null,b):(0,D.localize)(15,null,b):c?(0,D.localize)(16,null,b):(0,D.localize)(17,null,b)):y<j?(b=Math.floor(y/L),$?b===1?c?(0,D.localize)(18,null,b):(0,D.localize)(19,null,b):c?(0,D.localize)(20,null,b):(0,D.localize)(21,null,b):b===1?c?(0,D.localize)(22,null,b):(0,D.localize)(23,null,b):c?(0,D.localize)(24,null,b):(0,D.localize)(25,null,b)):y<O?(b=Math.floor(y/j),$?b===1?(0,D.localize)(26,null,b):(0,D.localize)(27,null,b):b===1?(0,D.localize)(28,null,b):(0,D.localize)(29,null,b)):y<R?(b=Math.floor(y/O),$?b===1?c?(0,D.localize)(30,null,b):(0,D.localize)(31,null,b):c?(0,D.localize)(32,null,b):(0,D.localize)(33,null,b):b===1?c?(0,D.localize)(34,null,b):(0,D.localize)(35,null,b):c?(0,D.localize)(36,null,b):(0,D.localize)(37,null,b)):y<k?(b=Math.floor(y/R),$?b===1?c?(0,D.localize)(38,null,b):(0,D.localize)(39,null,b):c?(0,D.localize)(40,null,b):(0,D.localize)(41,null,b):b===1?c?(0,D.localize)(42,null,b):(0,D.localize)(43,null,b):c?(0,D.localize)(44,null,b):(0,D.localize)(45,null,b)):(b=Math.floor(y/k),$?b===1?c?(0,D.localize)(46,null,b):(0,D.localize)(47,null,b):c?(0,D.localize)(48,null,b):(0,D.localize)(49,null,b):b===1?c?(0,D.localize)(50,null,b):(0,D.localize)(51,null,b):c?(0,D.localize)(52,null,b):(0,D.localize)(53,null,b))}e.$qm=m;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$rm=C}),define(le[135],he([13,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,18,12,135]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function j(S,$){return $&&(S.stack||S.stacktrace)?L.localize(0,null,R(S),O(S.stack)||O(S.stacktrace)):R(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?L.localize(1,null,S.message):S.message||L.localize(2,null)}function k(S=null,$=!1){if(!S)return L.localize(3,null);if(Array.isArray(S)){const c=D.$Hb(S),g=k(c[0],$);return c.length>1?L.localize(4,null,g,c.length):g}if(N.$Ef(S))return S;if(S.detail){const c=S.detail;if(c.error)return j(c.error,$);if(c.exception)return j(c.exception,$)}return S.stack?j(S,$):S.message?S.message:L.localize(5,null)}e.$Mi=k;function m(S){const $=S;return $ instanceof Error&&Array.isArray($.actions)}e.$Ni=m;function C(S,$){let c;return typeof S=="string"?c=new Error(S):c=S,c.actions=$,c}e.$Oi=C}),define(le[136],he([13,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[137],he([0,1,136]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function N(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Jp=N}),define(le[138],he([13,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,138]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,L=!1,j=!1,O=!1,R=!1,k=!1,m=!1,C=!1,S=!1,$=!1,c,g=e.$g,y=e.$g,b,l;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&(h=process);const d=typeof h?.versions?.electron=="string",E=d&&h?.type==="renderer";if(typeof navigator=="object"&&!E)l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,$=l?.indexOf("Mobi")>=0,k=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=c,y=navigator.language;else if(typeof h=="object"){N=h.platform==="win32",L=h.platform==="darwin",j=h.platform==="linux",O=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,m=d,S=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,g=e.$g;const f=h.env.VSCODE_NLS_CONFIG;if(f)try{const p=JSON.parse(f),I=p.availableLanguages["*"];c=p.locale,y=p.osLocale,g=I||e.$g,b=p._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var s;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(s||(e.Platform=s={}));function o(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;L?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=L,e.$k=j,e.$l=O,e.$m=R,e.$n=m,e.$o=k,e.$p=k&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=C,e.$s=$,e.$t=S,e.$u=n,e.$v=l,e.$w=g;var i;(function(f){function p(){return e.$w}f.value=p;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=I;function F(){return e.$w==="en"}f.isDefault=F})(i||(e.Language=i={})),e.$x=c,e.$y=y,e.$z=b,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const f=[];u.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,M=f.length;F<M;F++){const T=f[F];if(T.id===I.data.vscodeScheduleAsyncWork){f.splice(F,1),T.callback();return}}});let p=0;return I=>{const F=++p;f.push({id:F,callback:I}),u.postMessage({vscodeScheduleAsyncWork:F},"*")}}return f=>setTimeout(f)})();var t;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||C?2:N?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,r=new Uint16Array(f.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(f){return parseFloat(f)>=20}e.$J=w}),define(le[37],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(le[16],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,j=90,O=122,R=46,k=47,m=92,C=58,S=63;class $ extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new $(o,"Object",s)}function g(s,o){if(typeof s!="string")throw new $(o,"string",s)}const y=D.$dc==="win32";function b(s){return s===k||s===m}function l(s){return s===k}function u(s){return s>=N&&s<=j||s>=L&&s<=O}function h(s,o,n,i){let t="",r=0,a=-1,v=0,w=0;for(let f=0;f<=s.length;++f){if(f<s.length)w=s.charCodeAt(f);else{if(i(w))break;w=k}if(i(w)){if(!(a===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=f,v=0;continue}else if(t.length!==0){t="",r=0,a=f,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,f)}`:t=s.slice(a+1,f),r=f-a-1;a=f,v=0}else w===R&&v!==-1?++v:v=-1}return t}function d(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.$fc={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],g(r,"path"),r.length===0)continue}else o.length===0?r=D.cwd():(r=D.env[`=${o}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let v=0,w="",f=!1;const p=r.charCodeAt(0);if(a===1)b(p)&&(v=1,f=!0);else if(b(p))if(f=!0,b(r.charCodeAt(1))){let I=2,F=I;for(;I<a&&!b(r.charCodeAt(I));)I++;if(I<a&&I!==F){const M=r.slice(F,I);for(F=I;I<a&&b(r.charCodeAt(I));)I++;if(I<a&&I!==F){for(F=I;I<a&&!b(r.charCodeAt(I));)I++;(I===a||I!==F)&&(w=`\\\\${M}\\${r.slice(F,I)}`,v=I)}}}else v=1;else u(p)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,a>2&&b(r.charCodeAt(2))&&(f=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(i){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=f,f&&o.length>0)break}return n=h(n,!i,"\\",b),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){g(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return l(r)?"\\":s;if(b(r))if(t=!0,b(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!b(s.charCodeAt(v));)v++;if(v<o&&v!==w){const f=s.slice(w,v);for(w=v;v<o&&b(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!b(s.charCodeAt(v));)v++;if(v===o)return`\\\\${f}\\${s.slice(w)}\\`;v!==w&&(i=`\\\\${f}\\${s.slice(w,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,o>2&&b(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(s.slice(n),!t,"\\",b):"";return a.length===0&&!t&&(a="."),a.length>0&&b(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){g(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return b(n)||o>2&&u(n)&&s.charCodeAt(1)===C&&b(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];g(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&b(n.charCodeAt(0))){++t;const r=n.length;r>1&&b(n.charCodeAt(1))&&(++t,r>2&&(b(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&b(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(s,o){if(g(s,"from"),g(o,"to"),s===o)return"";const n=e.$fc.resolve(s),i=e.$fc.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===m;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===m;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===m;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===m;)w--;const f=w-v,p=a<f?a:f;let I=-1,F=0;for(;F<p;F++){const T=s.charCodeAt(t+F);if(T!==o.charCodeAt(v+F))break;T===m&&(I=F)}if(F!==p){if(I===-1)return i}else{if(f>p){if(o.charCodeAt(v+F)===m)return i.slice(v+F+1);if(F===2)return i.slice(v+F)}a>p&&(s.charCodeAt(t+F)===m?I=F:F===2&&(I=3)),I===-1&&(I=0)}let M="";for(F=t+I+1;F<=r;++F)(F===r||s.charCodeAt(F)===m)&&(M+=M.length===0?"..":"\\..");return v+=I,M.length>0?`${M}${i.slice(v,w)}`:(i.charCodeAt(v)===m&&++v,i.slice(v,w))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.$fc.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const n=o.charCodeAt(2);if(n!==S&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return s},dirname(s){g(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return b(t)?s:".";if(b(t)){if(n=i=1,b(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!b(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&b(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!b(s.charCodeAt(v));)v++;if(v===o)return s;v!==w&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===C&&(n=o>2&&b(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(b(s.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&g(o,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=n;--r){const w=s.charCodeAt(r);if(b(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(b(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===C&&u(s.charCodeAt(0))&&(o=i=2);for(let v=s.length-1;v>=o;--v){const w=s.charCodeAt(v);if(b(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:d.bind(null,"\\"),parse(s){g(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return b(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(b(t)){if(i=1,b(s.charCodeAt(1))){let I=2,F=I;for(;I<n&&!b(s.charCodeAt(I));)I++;if(I<n&&I!==F){for(F=I;I<n&&b(s.charCodeAt(I));)I++;if(I<n&&I!==F){for(F=I;I<n&&!b(s.charCodeAt(I));)I++;I===n?i=I:I!==F&&(i=I+1)}}}}else if(u(t)&&s.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=s,o;if(i=2,b(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,v=-1,w=!0,f=s.length-1,p=0;for(;f>=i;--f){if(t=s.charCodeAt(f),b(t)){if(!w){a=f+1;break}continue}v===-1&&(w=!1,v=f+1),t===R?r===-1?r=f:p!==1&&(p=1):r!==-1&&(p=-1)}return v!==-1&&(r===-1||p===0||p===1&&r===v-1&&r===a+1?o.base=o.name=s.slice(a,v):(o.name=s.slice(a,r),o.base=s.slice(a,v),o.ext=s.slice(r,v))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(y){const s=/\\/g;return()=>{const o=D.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:E();g(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=h(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===k,n=s.charCodeAt(s.length-1)===k;return s=h(s,!o,"/",l),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===k},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];g(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(s,o){if(g(s,"from"),g(o,"to"),s===o||(s=e.$gc.resolve(s),o=e.$gc.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,v=t<a?t:a;let w=-1,f=0;for(;f<v;f++){const I=s.charCodeAt(n+f);if(I!==o.charCodeAt(r+f))break;I===k&&(w=f)}if(f===v)if(a>v){if(o.charCodeAt(r+f)===k)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else t>v&&(s.charCodeAt(n+f)===k?w=f:f===0&&(w=0));let p="";for(f=n+w+1;f<=i;++f)(f===i||s.charCodeAt(f)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+w)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===k;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===k){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&g(o,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=0;--r){const w=s.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===k){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const v=s.charCodeAt(a);if(v===k){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:d.bind(null,"/"),parse(s){g(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===k;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,w=s.length-1,f=0;for(;w>=i;--w){const p=s.charCodeAt(w);if(p===k){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),p===R?t===-1?t=w:f!==1&&(f=1):t!==-1&&(f=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||f===0||f===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(p,a):(o.name=s.slice(p,t),o.base=s.slice(p,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(le[48],he([0,1,16,5,27,12]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function O(r){return r===47||r===92}e.$Wf=O;function R(r){return r.replace(/[\\/]/g,D.$gc.sep)}e.$Xf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Yf=k;function m(r,a=D.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(O(w)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let p=3;const I=p;for(;p<v&&!O(r.charCodeAt(p));p++);if(I!==p&&!O(r.charCodeAt(p+1))){for(p+=1;p<v;p++)if(O(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(l(w)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(O(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Zf=m;function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$1f=C;const S=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=N.$i){const v=a?S:$;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$2f=g;function y(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,L.$8e)(r,a)}e.$3f=y;function b(r,a,v,w=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,L.$9e)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===w&&p--,r.charAt(p)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$4f=b;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$5f=l;function u(r,a){return N.$i&&r.endsWith(":")&&(r+=D.sep),(0,D.$ic)(r)||(r=(0,D.$jc)(a,r)),r=(0,D.$hc)(r),N.$i?(r=(0,L.$Qe)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,L.$Qe)(r,D.sep),r||(r=D.sep)),r}e.$6f=u;function h(r){const a=(0,D.$hc)(r);return N.$i?r.length>3?!1:d(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.$gc.sep}e.$7f=h;function d(r,a=N.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$8f=d;function E(r,a=N.$i){return d(r,a)?r[0]:void 0}e.$9f=E;function s(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$0f=s;function o(r){const a=r.split(":");let v,w,f;for(const p of a){const I=Number(p);(0,j.$If)(I)?w===void 0?w=I:f===void 0&&(f=I):v=v?[v,p].join(":"):p}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.$$f=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let p=0;p<v;p++){let I;p===0&&N.$i&&!a&&(v===3||v===4)?I=i:I=n,w+=I.charAt(Math.floor(Math.random()*I.length))}let f;return a?f=`${a}-${w}`:f=w,r?(0,D.$jc)(r,f):f}e.$_f=t}),define(le[139],he([0,1,16]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=void 0,e.$3r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const S=(0,D.$oc)(C),$=N[S.toLowerCase()];return $!==void 0?$:O(C)}e.$4r=j;function O(C){const S=(0,D.$oc)(C);return L[S.toLowerCase()]}e.$5r=O;function R(C){for(const S in L)if(L[S]===C)return S}e.$6r=R;const k=/^(.+)\/(.+?)(;.+)?$/;function m(C,S){const $=k.exec(C);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:S?void 0:C}e.$7r=m}),define(le[90],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(R,...k){const m=k.reduce(($,c)=>($[c]=!0,$),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter($=>!m[$]).forEach($=>{for(let c=0;c<C.length;c++)if($.search(C[c])!==-1){delete R[$];break}})}e.$Ml=j;function O(R){R&&(delete R.DEBUG,D.$j&&delete R.DYLD_LIBRARY_PATH,D.$k&&delete R.LD_PRELOAD)}e.$Nl=O}),define(le[10],he([0,1,16,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,t){return!i&&!t?"file":i}function m(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,f=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,f),this.authority=r||C,this.path=m(this.scheme,a||C),this.query=v||C,this.fragment=w||C,R(this,f))}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),f===void 0?f=this.fragment:f===null&&(f=C),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&f===this.fragment?this:new b(r,a,v,w,f)}static parse(t,r=!1){const a=$.exec(t);return a?new b(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new b(C,C,C,C,C)}static file(t){let r=C;if(N.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new b("file",r,t,C,C)}static from(t,r){return new b(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=c.file(D.$fc.join(d(t,!0),...r)).path:a=D.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new b(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=c;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=g;const y=N.$i?1:void 0;class b extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let a,v=-1;for(let w=0;w<i.length;w++){const f=i.charCodeAt(w);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a!==void 0&&(a+=i.charAt(w));else{a===void 0&&(a=i.substr(0,w));const p=l[f];p!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a+=p):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function h(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=l[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=d;function E(i,t){const r=t?h:u;let a="",{scheme:v,authority:w,path:f,query:p,fragment:I}=i;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=S,a+=S),w){let F=w.indexOf("@");if(F!==-1){const M=w.substr(0,F);w=w.substr(F+1),F=M.lastIndexOf(":"),F===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,F),!1,!1),a+=":",a+=r(M.substr(F+1),!1,!0)),a+="@"}w=w.toLowerCase(),F=w.lastIndexOf(":"),F===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,F),!1,!0),a+=w.substr(F))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const F=f.charCodeAt(1);F>=65&&F<=90&&(f=`/${String.fromCharCode(F+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const F=f.charCodeAt(0);F>=65&&F<=90&&(f=`${String.fromCharCode(F+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),I&&(a+="#",a+=t?I:u(I,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(le[140],he([0,1,10]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$aq=e.$_p=e.$$p=void 0;function N(m){const C=m;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$$p=N;function L(m){const C=[];let S;try{const $=JSON.parse(m.arguments),c=$[$.length-1];c&&c.__$stack&&($.pop(),S=c.__$stack),C.push(...$)}catch{C.push("Unable to log remote console arguments",m.arguments)}return{args:C,stack:S}}e.$_p=L;function j(m){if(typeof m!="string")return j(L(m).stack);const C=m;if(C){const S=O(C),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if($&&$.length===4)return{uri:D.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$aq=j;function O(m){if(!m)return m;const C=m.indexOf(`
`);return C===-1?m:m.substring(0,C)}function R(m,C){const{args:S,stack:$}=L(m),c=typeof S[0]=="string"&&S.length===1;let g=O($);g&&(g=`(${g.trim()})`);let y=[];if(typeof S[0]=="string"?g&&c?y=[`%c[${C}] %c${S[0]} %c${g}`,k("blue"),k(""),k("grey")]:y=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:y=[`%c[${C}]%`,k("blue"),...S],g&&!c&&y.push(g),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,y)}e.log=R;function k(m){return`color: ${m}`}}),define(le[65],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function L(k){return JSON.stringify(k,O)}e.$wh=L;function j(k){let m=JSON.parse(k);return m=R(m),m}e.$xh=j;function O(k,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function R(k,m=0){if(!k||m>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return N.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof D.$ge||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],m+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],m+1))}return k}e.$yh=R}),define(le[23],he([0,1,7,5,27,10]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var O;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={}));function R($,c){return j.URI.isUri($)?(0,L.$8e)($.scheme,c):(0,L.$9e)($,c+":")}e.$ag=R;function k($,...c){return c.some(g=>R($,g))}e.$bg=k,e.$cg="vscode-tkn",e.$dg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,g,y){this.a[c]=g,this.b[c]=y}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(h){return D.$1(h),c}const g=c.authority;let y=this.a[g];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const b=this.b[g],l=this.c[g];let u=`path=${encodeURIComponent(c.path)}`;return typeof l=="string"&&(u+=`&${e.$dg}=${encodeURIComponent(l)}`),j.URI.from({scheme:N.$o?this.d:O.vscodeRemoteResource,authority:`${y}:${b}`,path:this.f,query:u})}}e.$eg=new m,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class C{static{this.a=e.$jg}asBrowserUri(c){const g=this.b(c,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$eg.rewrite(c):c.scheme===O.file&&(N.$m||N.$q===`${O.vscodeFileResource}://${C.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||C.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ne);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==C.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return j.URI.isUri(c)?c:j.URI.parse(g.toUrl(c))}}e.$kg=new C;var S;(function($){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function y(l){let u;typeof l=="string"?u=new URL(l).searchParams:l instanceof URL?u=l.searchParams:j.URI.isUri(l)&&(u=new URL(l.toString(!0)).searchParams);const h=u?.get(g);if(h)return c.get(h)}$.getHeadersFromQuery=y;function b(l,u,h){if(!globalThis.crossOriginIsolated)return;const d=u&&h?"3":h?"2":"1";l instanceof URLSearchParams?l.set(g,d):l[g]=d}$.addSearchParam=b})(S||(e.COI=S={}))}),define(le[141],he([0,1,123,23,5,10]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=void 0;class O{constructor($,c,g){this.id=$,this.dependencies=c,this.callback=g}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,c,g)=>{typeof $!="string"&&(g=c,c=$,$=null),(typeof c!="object"||!Array.isArray(c))&&(g=c,c=null),this.c.push(new O($,c,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const c=await(this.a?this.i($):this.b?this.h($):this.j($));if(!c)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h($){return new Promise((c,g)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const b=()=>{y.removeEventListener("load",l),y.removeEventListener("error",u)},l=h=>{b(),c(this.c.pop())},u=h=>{b(),g(h)};y.addEventListener("load",l),y.addEventListener("error",u),this.f&&($=this.f.createScriptURL($)),y.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(y)})}i($){return new Promise((c,g)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),c(this.c.pop())}catch(y){g(y)}})}async j($){try{const c=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,b=j.URI.parse($).fsPath,l=c.readFileSync(b).toString(),u=y.wrap(l.replace(/^#!.*/,""));return new g.Script(u).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const k=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function C(S,$,c){if(D.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[S]&&(S=m[S]);const g=`${S}/${$}`;if(k.has(g))return k.get(g);let y;if(/^\w[\w\d+.-]*:\/\//.test(g))y=g;else{const h=`${c&&!L.$o?N.$hg:N.$gg}/${g}`;y=N.$kg.asBrowserUri(h).toString(!0)}const b=R.INSTANCE.load(y);return k.set(g,b),b}else return await new Promise((g,y)=>{ne([S],g,y)})}e.$YC=C}),define(le[19],he([0,1,48,23,16,5,27,10]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function k(c){return(0,R.$wc)(c,!0)}e.$rg=k;class m{constructor(g){this.a=g}compare(g,y,b=!1){return g===y?0:(0,O.$1e)(this.getComparisonKey(g,b),this.getComparisonKey(y,b))}isEqual(g,y,b=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,b)===this.getComparisonKey(y,b)}getComparisonKey(g,y=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,y,b=!1){if(g.scheme===y.scheme){if(g.scheme===N.Schemas.file)return D.$4f(k(g),k(y),this.a(g))&&g.query===y.query&&(b||g.fragment===y.fragment);if((0,e.$Ig)(g.authority,y.authority))return D.$4f(g.path,y.path,this.a(g),"/")&&g.query===y.query&&(b||g.fragment===y.fragment)}return!1}joinPath(g,...y){return R.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.$Ag)(g)||g.authority}basename(g){return L.$gc.basename(g.path)}extname(g){return L.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===N.Schemas.file?y=R.URI.file(L.$mc(k(g))).path:(y=L.$gc.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===N.Schemas.file?y=R.URI.file(L.$hc(k(g))).path:y=L.$gc.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.$Ig)(g.authority,y.authority))return;if(g.scheme===N.Schemas.file){const u=L.$lc(k(g),k(y));return j.$i?D.$Xf(u):u}let b=g.path||"/";const l=y.path||"/";if(this.a(g)){let u=0;for(const h=Math.min(b.length,l.length);u<h&&!(b.charCodeAt(u)!==l.charCodeAt(u)&&b.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);b=l.substr(0,u)+b.substr(u)}return L.$gc.relative(b,l)}resolvePath(g,y){if(g.scheme===N.Schemas.file){const b=R.URI.file(L.$kc(k(g),y));return g.with({authority:b.authority,path:b.path})}return y=D.$Yf(y),g.with({path:L.$gc.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,O.$8e)(g,y)}hasTrailingPathSeparator(g,y=L.sep){if(g.scheme===N.Schemas.file){const b=k(g);return b.length>D.$Zf(b).length&&b[b.length-1]===y}else{const b=g.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=L.sep){return(0,e.$Jg)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=L.sep){let b=!1;if(g.scheme===N.Schemas.file){const l=k(g);b=l!==void 0&&l.length===D.$Zf(l).length&&l[l.length-1]===y}else{y="/";const l=g.path;b=l.length===1&&l.charCodeAt(l.length-1)===47}return!b&&!(0,e.$Jg)(g,y)?g.with({path:g.path+"/"}):g}}e.$sg=m,e.$tg=new m(()=>!1),e.$ug=new m(c=>c.scheme===N.Schemas.file?!j.$k:!0),e.$vg=new m(c=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function C(c,g){const y=[];for(let b=0;b<c.length;b++){const l=g(c[b]);c.some((u,h)=>h===b?!1:(0,e.$xg)(l,g(u)))||y.push(c[b])}return y}e.$Mg=C;var S;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(y){const b=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(h=>{const[d,E]=h.split(":");d&&E&&b.set(d,E)});const u=y.path.substring(0,y.path.indexOf(";"));return u&&b.set(c.META_DATA_MIME,u),b}c.parseMetaData=g})(S||(e.DataUri=S={}));function $(c,g,y){if(g){let b=c.path;return b&&b[0]!==L.$gc.sep&&(b=L.$gc.sep+b),c.with({scheme:y,authority:g,path:b})}return c.with({scheme:y})}e.$Ng=$}),define(le[6],he([0,1,26,7,3,2,19,5,129,52]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function C(G){return!!G&&typeof G.then=="function"}e.$Og=C;function S(G){const Q=new D.$3d,ie=G(Q.token),ce=new Promise((oe,fe)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Q.dispose(),fe(new N.$5)});Promise.resolve(ie).then(we=>{de.dispose(),Q.dispose(),oe(we)},we=>{de.dispose(),Q.dispose(),fe(we)})});return new class{cancel(){Q.cancel()}then(oe,fe){return ce.then(oe,fe)}catch(oe){return this.then(void 0,oe)}finally(oe){return ce.finally(oe)}}}e.$Pg=S;function $(G,Q,ie){return new Promise((ce,oe)=>{const fe=Q.onCancellationRequested(()=>{fe.dispose(),ce(ie)});G.then(ce,oe).finally(()=>fe.dispose())})}e.$Qg=$;function c(G,Q){return new Promise((ie,ce)=>{const oe=Q.onCancellationRequested(()=>{oe.dispose(),ce(new N.$5)});G.then(ie,ce).finally(()=>oe.dispose())})}e.$Rg=c;async function g(G){let Q=-1;const ie=G.map((ce,oe)=>ce.then(fe=>(Q=oe,fe)));try{return await Promise.race(ie)}finally{G.forEach((ce,oe)=>{oe!==Q&&ce.cancel()})}}e.$Sg=g;function y(G,Q,ie){let ce;const oe=setTimeout(()=>{ce?.(void 0),ie?.()},Q);return Promise.race([G.finally(()=>clearTimeout(oe)),new Promise(fe=>ce=fe)])}e.$Tg=y;function b(G){return new Promise((Q,ie)=>{const ce=G();C(ce)?ce.then(Q,ie):Q(ce)})}e.$Ug=b;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.b.then(ie,ce)})}return this.a=Q(),new Promise((ie,ce)=>{this.a.then(oe=>{this.a=null,ie(oe)},oe=>{this.a=null,ce(oe)})})}dispose(){this.f=!0}}e.$Vg=l;class u{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$Wg=u;class h{constructor(){this.a=new Map}queue(Q,ie){const oe=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Q)===oe&&this.a.delete(Q)});return this.a.set(Q,oe),oe}}e.$Xg=h;const d=(G,Q)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,Q()},G);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},E=G=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,G())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class s{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,ie=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((oe,fe)=>{this.d=oe,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const oe=this.g;return this.g=null,oe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ie===k.$Pd?E(ce):d(ie,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=s;class o{constructor(Q){this.a=new s(Q),this.b=new l}trigger(Q,ie){return this.a.trigger(()=>this.b.queue(Q),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=o;class n{constructor(){this.a=!1,this.b=new Promise((Q,ie)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=n;class i extends n{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$2g=i;function t(G,Q){return Q?new Promise((ie,ce)=>{const oe=setTimeout(()=>{fe.dispose(),ie()},G),fe=Q.onCancellationRequested(()=>{clearTimeout(oe),fe.dispose(),ce(new N.$5)})}):S(ie=>t(G,ie))}e.$3g=t;function r(G,Q=0,ie){const ce=setTimeout(()=>{G(),ie&&oe.dispose()},Q),oe=(0,j.$Qc)(()=>{clearTimeout(ce),ie?.deleteAndLeak(oe)});return ie?.add(oe),oe}e.$4g=r;function a(G){const Q=[];let ie=0;const ce=G.length;function oe(){return ie<ce?G[ie++]():null}function fe(de){de!=null&&Q.push(de);const we=oe();return we?we.then(fe):Promise.resolve(Q)}return Promise.resolve(null).then(fe)}e.$5g=a;function v(G,Q=ce=>!!ce,ie=null){let ce=0;const oe=G.length,fe=()=>{if(ce>=oe)return Promise.resolve(ie);const de=G[ce++];return Promise.resolve(de()).then(ve=>Q(ve)?Promise.resolve(ve):fe())};return fe()}e.$6g=v;function w(G,Q=ce=>!!ce,ie=null){if(G.length===0)return Promise.resolve(ie);let ce=G.length;const oe=()=>{ce=-1;for(const fe of G)fe.cancel?.()};return new Promise((fe,de)=>{for(const we of G)we.then(ve=>{--ce>=0&&Q(ve)?(oe(),fe(ve)):ce===0&&fe(ie)}).catch(ve=>{--ce>=0&&(oe(),de(ve))})})}e.$7g=w;class f{constructor(Q){this.a=0,this.d=Q,this.f=[],this.b=0,this.g=new L.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(Q){return this.a++,new Promise((ie,ce)=>{this.f.push({factory:Q,c:ie,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Q=this.f.shift();this.b++;const ie=Q.factory();ie.then(Q.c,Q.e),ie.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=f;class p extends f{constructor(){super(1)}}e.$9g=p;class I{constructor(){this.a=new B,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$0g=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new _;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueFor(Q,ie=O.$tg){const ce=ie.getComparisonKey(Q);let oe=this.a.get(ce);if(!oe){oe=new p;const fe=this.f++,de=L.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$2c),this.d.set(fe,de),this.a.set(ce,oe)}return oe}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=F;class M{constructor(Q,ie){this.a=-1,typeof Q=="function"&&typeof ie=="number"&&this.setIfNotSet(Q,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},ie)}setIfNotSet(Q,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},ie))}}e.$_g=M;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,ie,ce=globalThis){this.cancel();const oe=ce.setInterval(()=>{Q()},ie);this.d=(0,j.$Qc)(()=>{ce.clearInterval(oe),this.d=void 0})}dispose(){this.cancel()}}e.$ah=T;class z{constructor(Q,ie){this.b=-1,this.a=Q,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=z;class Z{constructor(Q,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Q,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=Z;class J extends z{constructor(Q,ie){super(Q,ie),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$dh=J;class x extends j.$Sc{constructor(Q,ie){super(),this.g=Q,this.h=ie,this.a=[],this.b=this.B(new j.$Tc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Q)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(G,Q)=>{(0,R.$B)(()=>{if(ie)return;const ce=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$gh=(G,Q,ie)=>{const ce=G.requestIdleCallback(Q,typeof ie=="number"?{timeout:ie}:void 0);let oe=!1;return{dispose(){oe||(oe=!0,G.cancelIdleCallback(ce))}}},e.$fh=G=>(0,e.$gh)(globalThis,G)}();class V{constructor(Q,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$gh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=V;class Y extends V{constructor(Q){super(globalThis,Q)}}e.$ih=Y;async function W(G,Q,ie){let ce;for(let oe=0;oe<ie;oe++)try{return await G()}catch(fe){ce=fe,await t(Q)}throw ce}e.$jh=W;class B{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,ie,ce){return this.a={taskId:Q,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.d(Q),()=>this.d(Q)),ie}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{let ie,ce;const oe=new Promise((fe,de)=>{ie=fe,ce=de});this.b={run:Q,promise:oe,promiseResolve:ie,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=B;class te{constructor(Q,ie=()=>Date.now()){this.d=Q,this.f=ie,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$lh=te;var se;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(se||(se={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,ie)=>{this.a=Q,this.b=ie})}complete(Q){return new Promise(ie=>{this.a(Q),this.d={outcome:0,value:Q},ie()})}error(Q){return new Promise(ie=>{this.b(Q),this.d={outcome:1,value:Q},ie()})}cancel(){return this.error(new N.$5)}}e.$mh=_;var re;(function(G){async function Q(ce){let oe;const fe=await Promise.all(ce.map(de=>de.then(we=>we,we=>{oe||(oe=we)})));if(typeof oe<"u")throw oe;return fe}G.settled=Q;function ie(ce){return new Promise(async(oe,fe)=>{try{await ce(oe,fe)}catch(de){fe(de)}})}G.withAsyncBody=ie})(re||(e.Promises=re={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=K;class U{constructor(Q){this.b=Q,this.a=new m.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=U;var P;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(P||(P={}));class A{static fromArray(Q){return new A(ie=>{ie.emitMany(Q)})}static fromPromise(Q){return new A(async ie=>{ie.emitMany(await Q)})}static fromPromises(Q){return new A(async ie=>{await Promise.all(Q.map(async ce=>ie.emitOne(await ce)))})}static merge(Q){return new A(async ie=>{await Promise.all(Q.map(async ce=>{for await(const oe of ce)ie.emitOne(oe)}))})}static{this.EMPTY=A.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new L.$Sd,queueMicrotask(async()=>{const ie={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(Q(ie)),this.j()}catch(ce){this.k(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,ie){return new A(async ce=>{for await(const oe of Q)ce.emitOne(ie(oe))})}map(Q){return A.map(this,Q)}static filter(Q,ie){return new A(async ce=>{for await(const oe of Q)ie(oe)&&ce.emitOne(oe)})}filter(Q){return A.filter(this,Q)}static coalesce(Q){return A.filter(Q,ie=>!!ie)}coalesce(){return A.coalesce(this)}static async toPromise(Q){const ie=[];for await(const ce of Q)ie.push(ce);return ie}toPromise(){return A.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$ph=A;class H extends A{constructor(Q,ie){super(ie),this.l=Q}cancel(){this.l.cancel()}}e.$qh=H;function q(G){const Q=new D.$3d,ie=G(Q.token);return new H(Q,async ce=>{const oe=Q.token.onCancellationRequested(()=>{oe.dispose(),Q.dispose(),ce.reject(new N.$5)});try{for await(const fe of ie){if(Q.token.isCancellationRequested)return;ce.emitOne(fe)}oe.dispose(),Q.dispose()}catch(fe){oe.dispose(),Q.dispose(),ce.reject(fe)}})}e.$rh=q;class ee{constructor(){this.a=new _,this.b=new A(ce=>{if(Q){ce.reject(Q);return}return ie&&ce.emitMany(ie),this.d=oe=>ce.reject(oe),this.f=oe=>ce.emitOne(oe),this.a.p});let Q,ie;this.f=ce=>{ie||(ie=[]),ie.push(ce)},this.d=ce=>{Q||(Q=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$sh=ee}),define(le[91],he([0,1,18,6,48,34,16,5,27]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function m(){return Object.create(null)}e.$Dj=m,e.$Ej="**",e.$Fj="/";const C="[/\\\\]",S="[^/\\\\]",$=/\//g;function c(Y,W){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${W?`|${C}${S}+`:""})*?`}}function g(Y,W){if(!Y)return[];const B=[];let te=!1,se=!1,_="";for(const re of Y){switch(re){case W:if(!te&&!se){B.push(_),_="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":se=!0;break;case"]":se=!1;break}_+=re}return _&&B.push(_),B}e.$Gj=g;function y(Y){if(!Y)return"";let W="";const B=g(Y,e.$Fj);if(B.every(te=>te===e.$Ej))W=".*";else{let te=!1;B.forEach((se,_)=>{if(se===e.$Ej){if(te)return;W+=c(2,_===B.length-1)}else{let re=!1,K="",U=!1,P="";for(const A of se){if(A!=="}"&&re){K+=A;continue}if(U&&(A!=="]"||!P)){let H;A==="-"?H=A:(A==="^"||A==="!")&&!P?H="^":A===e.$Fj?H="":H=(0,k.$Ke)(A),P+=H;continue}switch(A){case"{":re=!0;continue;case"[":U=!0;continue;case"}":{const q=`(?:${g(K,",").map(ee=>y(ee)).join("|")})`;W+=q,re=!1,K="";break}case"]":{W+="["+P+"]",U=!1,P="";break}case"?":W+=S;continue;case"*":W+=c(1);continue;default:W+=(0,k.$Ke)(A)}}_<B.length-1&&(B[_+1]!==e.$Ej||_+2<B.length)&&(W+=C)}te=se===e.$Ej})}return W}const b=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new j.$Dc(1e4),o=function(){return!1},n=function(){return null};function i(Y,W){if(!Y)return n;let B;typeof Y!="string"?B=Y.pattern:B=Y,B=B.trim();const te=`${B}_${!!W.trimForExclusions}`;let se=s.get(te);if(se)return t(se,Y);let _;return b.test(B)?se=a(B.substr(4),B):(_=l.exec(r(B,W)))?se=v(_[1],B):(W.trimForExclusions?h:u).test(B)?se=w(B,W):(_=d.exec(r(B,W)))?se=f(_[1].substr(1),B,!0):(_=E.exec(r(B,W)))?se=f(_[1],B,!1):se=p(B),s.set(te,se),t(se,Y)}function t(Y,W){if(typeof W=="string")return Y;const B=function(te,se){return(0,L.$4f)(te,W.base,!R.$k)?Y((0,k.$Pe)(te.substr(W.base.length),O.sep),se):null};return B.allBasenames=Y.allBasenames,B.allPaths=Y.allPaths,B.basenames=Y.basenames,B.patterns=Y.patterns,B}function r(Y,W){return W.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,W){return function(B,te){return typeof B=="string"&&B.endsWith(Y)?W:null}}function v(Y,W){const B=`/${Y}`,te=`\\${Y}`,se=function(re,K){return typeof re!="string"?null:K?K===Y?W:null:re===Y||re.endsWith(B)||re.endsWith(te)?W:null},_=[Y];return se.basenames=_,se.patterns=[W],se.allBasenames=_,se}function w(Y,W){const B=x(Y.slice(1,-1).split(",").map(K=>i(K,W)).filter(K=>K!==n),Y),te=B.length;if(!te)return n;if(te===1)return B[0];const se=function(K,U){for(let P=0,A=B.length;P<A;P++)if(B[P](K,U))return Y;return null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const re=B.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return re.length&&(se.allPaths=re),se}function f(Y,W,B){const te=O.sep===O.$gc.sep,se=te?Y:Y.replace($,O.sep),_=O.sep+se,re=O.$gc.sep+Y;let K;return B?K=function(U,P){return typeof U=="string"&&(U===se||U.endsWith(_)||!te&&(U===Y||U.endsWith(re)))?W:null}:K=function(U,P){return typeof U=="string"&&(U===se||!te&&U===Y)?W:null},K.allPaths=[(B?"*/":"./")+Y],K}function p(Y){try{const W=new RegExp(`^${y(Y)}$`);return function(B){return W.lastIndex=0,typeof B=="string"&&W.test(B)?Y:null}}catch{return n}}function I(Y,W,B){return!Y||typeof W!="string"?!1:F(Y)(W,void 0,B)}e.$Hj=I;function F(Y,W={}){if(!Y)return o;if(typeof Y=="string"||M(Y)){const B=i(Y,W);if(B===n)return o;const te=function(se,_){return!!B(se,_)};return B.allBasenames&&(te.allBasenames=B.allBasenames),B.allPaths&&(te.allPaths=B.allPaths),te}return Z(Y,W)}e.$Ij=F;function M(Y){const W=Y;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$Jj=M;function T(Y){return Y.allBasenames||[]}e.$Kj=T;function z(Y){return Y.allPaths||[]}e.$Lj=z;function Z(Y,W){const B=x(Object.getOwnPropertyNames(Y).map(K=>J(K,Y[K],W)).filter(K=>K!==n)),te=B.length;if(!te)return n;if(!B.some(K=>!!K.requiresSiblings)){if(te===1)return B[0];const K=function(A,H){let q;for(let ee=0,G=B.length;ee<G;ee++){const Q=B[ee](A,H);if(typeof Q=="string")return Q;(0,N.$Og)(Q)&&(q||(q=[]),q.push(Q))}return q?(async()=>{for(const ee of q){const G=await ee;if(typeof G=="string")return G}return null})():null},U=B.find(A=>!!A.allBasenames);U&&(K.allBasenames=U.allBasenames);const P=B.reduce((A,H)=>H.allPaths?A.concat(H.allPaths):A,[]);return P.length&&(K.allPaths=P),K}const se=function(K,U,P){let A,H;for(let q=0,ee=B.length;q<ee;q++){const G=B[q];G.requiresSiblings&&P&&(U||(U=(0,O.$nc)(K)),A||(A=U.substr(0,U.length-(0,O.$oc)(K).length)));const Q=G(K,U,A,P);if(typeof Q=="string")return Q;(0,N.$Og)(Q)&&(H||(H=[]),H.push(Q))}return H?(async()=>{for(const q of H){const ee=await q;if(typeof ee=="string")return ee}return null})():null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const re=B.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return re.length&&(se.allPaths=re),se}function J(Y,W,B){if(W===!1)return n;const te=i(Y,B);if(te===n)return n;if(typeof W=="boolean")return te;if(W){const se=W.when;if(typeof se=="string"){const _=(re,K,U,P)=>{if(!P||!te(re,K))return null;const A=se.replace("$(basename)",()=>U),H=P(A);return(0,N.$Og)(H)?H.then(q=>q?Y:null):H?Y:null};return _.requiresSiblings=!0,_}}return te}function x(Y,W){const B=Y.filter(K=>!!K.basenames);if(B.length<2)return Y;const te=B.reduce((K,U)=>{const P=U.basenames;return P?K.concat(P):K},[]);let se;if(W){se=[];for(let K=0,U=te.length;K<U;K++)se.push(W)}else se=B.reduce((K,U)=>{const P=U.patterns;return P?K.concat(P):K},[]);const _=function(K,U){if(typeof K!="string")return null;if(!U){let A;for(A=K.length;A>0;A--){const H=K.charCodeAt(A-1);if(H===47||H===92)break}U=K.substr(A)}const P=te.indexOf(U);return P!==-1?se[P]:null};_.basenames=te,_.patterns=se,_.allBasenames=te;const re=Y.filter(K=>!K.basenames);return re.push(_),re}function V(Y,W){return(0,D.$ub)(Y,W,(B,te)=>typeof B=="string"&&typeof te=="string"?B===te:typeof B!="string"&&typeof te!="string"?B.base===te.base&&B.pattern===te.pattern:!1)}e.$Mj=V}),define(le[92],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function L(S){return S.toJSON()}class j{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:L(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:L(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Ym=j,e.$Zm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function O(S,$,c){if(!S||c>200)return null;if(typeof S=="object"){if(S instanceof N.URI)return $.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const y=O(S[g],$,c+1);y!==null&&(S[g]=y)}}return null}function R(S,$){const c=O(S,$,0);return c===null?S:c}e.$1m=R;function k(S,$,c,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return c?N.URI.revive($.transformIncoming(S)):$.transformIncoming(S);if(S instanceof D.$ge)return null;for(const y in S)if(Object.hasOwnProperty.call(S,y)){const b=k(S[y],$,c,g+1);b!==null&&(S[y]=b)}}return null}function m(S,$){const c=k(S,$,!1,0);return c===null?S:c}e.$2m=m;function C(S,$){const c=k(S,$,!0,0);return c===null?S:c}e.$3m=C}),define(le[142],he([0,1,36,47,32,130,5]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=void 0,e.$5m=new class{c($){return this.a||(this.a=N.$8h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,c=0;const g=(0,D.networkInterfaces)();for(const y in g){const b=g[y];if(b)for(const{mac:l,internal:u}of b)u||(c+=1,this.c(l.toUpperCase())&&($+=1))}this.b=c>0?$/c:0}return this.b}};let R;async function k($){return R||(R=(async()=>await m($)||L.$mg())()),R}e.$6m=k;async function m($){try{const c=await new Promise((y,b)=>{ne(["crypto"],y,b)}),g=(0,j.$4m)();return c.createHash("sha256").update(g,"utf8").digest("hex")}catch(c){$(c);return}}const C="Software\\Microsoft\\SQMClient";async function S($){if(O.$i){const c=await new Promise((g,y)=>{ne(["@vscode/windows-registry"],g,y)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(g){return $(g),""}}return""}e.$7m=S}),define(le[31],he([0,1,54,36,268,6,48,88,16,5,19,10]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function c(J,x=$.UNLINK,V){if((0,O.$7f)(J))throw new Error("rimraf - will refuse to recursively delete root");return x===$.UNLINK?y(J):g(J,V)}async function g(J,x=(0,O.$_f)((0,N.tmpdir)())){try{try{await D.promises.rename(J,x)}catch(V){return V.code==="ENOENT"?void 0:y(J)}y(x).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(J){return(0,L.promisify)(D.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function b(J){if((0,O.$7f)(J))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function l(J,x){return d(await(x?u(J):(0,L.promisify)(D.readdir)(J)))}async function u(J){try{return await(0,L.promisify)(D.readdir)(J,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const x=[],V=await l(J);for(const Y of V){let W=!1,B=!1,te=!1;try{const se=await e.Promises.lstat((0,k.$jc)(J,Y));W=se.isFile(),B=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}x.push({name:Y,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>te})}return x}function h(J){return d(D.readdirSync(J))}e.readdirSync=h;function d(J){return J.map(x=>typeof x=="string"?m.$j?(0,R.$Bl)(x):x:(x.name=m.$j?(0,R.$Bl)(x.name):x.name,x))}async function E(J){const x=await l(J),V=[];for(const Y of x)await o.existsDirectory((0,k.$jc)(J,Y))&&V.push(Y);return V}function s(J,x=1e3){return new Promise(V=>{let Y=!1;const W=setInterval(()=>{Y||(Y=!0,D.access(J,B=>{Y=!1,B&&(clearInterval(W),V(void 0))}))},x)})}e.whenDeleted=s;var o;(function(J){async function x(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(m.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw se}throw te}}J.stat=x;async function V(W){try{const{stat:B,symbolicLink:te}=await J.stat(W);return B.isFile()&&te?.dangling!==!0}catch{}return!1}J.existsFile=V;async function Y(W){try{const{stat:B,symbolicLink:te}=await J.stat(W);return B.isDirectory()&&te?.dangling!==!0}catch{}return!1}J.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const n=new j.$$g;function i(J,x,V){return n.queueFor(S.URI.file(J),C.$ug).queue(()=>{const Y=w(V);return new Promise((W,B)=>a(J,x,Y,te=>te?B(te):W()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function a(J,x,V,Y){if(!t)return D.writeFile(J,x,{mode:V.mode,flag:V.flag},Y);D.open(J,V.flag,V.mode,(W,B)=>{if(W)return Y(W);D.writeFile(B,x,te=>{if(te)return D.close(B,()=>Y(te));D.fdatasync(B,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),r(!1)),D.close(B,_=>Y(_))))})})}function v(J,x,V){const Y=w(V);if(!t)return D.writeFileSync(J,x,{mode:Y.mode,flag:Y.flag});const W=D.openSync(J,Y.flag,Y.mode);try{D.writeFileSync(W,x);try{D.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{D.closeSync(W)}}e.writeFileSync=v;function w(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function f(J,x,V=6e4){if(J!==x)try{m.$i&&typeof V=="number"?await p(J,x,Date.now(),V):await(0,L.promisify)(D.rename)(J,x)}catch(Y){if(J.toLowerCase()!==x.toLowerCase()&&Y.code==="EXDEV"||J.endsWith("."))await I(J,x,{preserveSymlinks:!1}),await c(J,$.MOVE);else throw Y}}async function p(J,x,V,Y,W=0){try{return await(0,L.promisify)(D.rename)(J,x)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-V>=Y)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let te=!1;try{const{stat:se}=await o.stat(x);se.isFile()||(te=!0)}catch{}if(te)throw B}return await(0,j.$3g)(Math.min(100,W*10)),p(J,x,V,Y,W+1)}}async function I(J,x,V){return M(J,x,{root:{source:J,target:x},options:V,handledSourcePaths:new Set})}const F=511;async function M(J,x,V){if(V.handledSourcePaths.has(J))return;V.handledSourcePaths.add(J);const{stat:Y,symbolicLink:W}=await o.stat(J);if(W){if(V.options.preserveSymlinks)try{return await Z(J,x,V)}catch{}if(W.dangling)return}return Y.isDirectory()?T(J,x,Y.mode&F,V):z(J,x,Y.mode&F)}async function T(J,x,V,Y){await e.Promises.mkdir(x,{recursive:!0,mode:V});const W=await l(J);for(const B of W)await M((0,k.$jc)(J,B),(0,k.$jc)(x,B),Y)}async function z(J,x,V){await e.Promises.copyFile(J,x),await e.Promises.chmod(x,V)}async function Z(J,x,V){let Y=await e.Promises.readlink(J);(0,O.$4f)(Y,V.root.source,!m.$k)&&(Y=(0,k.$jc)(V.root.target,Y.substr(V.root.source.length+1))),await e.Promises.symlink(Y,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(J,x,V,Y,W)=>new Promise((B,te)=>{D.read(J,x,V,Y,W,(se,_,re)=>se?te(se):B({bytesRead:_,buffer:re}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(J,x,V,Y,W)=>new Promise((B,te)=>{D.write(J,x,V,Y,W,(se,_,re)=>se?te(se):B({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return f}get copy(){return I}}}),define(le[143],he([0,1,54,16,5,27,31]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.$gq=e.$fq=void 0;function R($){if(L.$k)return $;const c=(0,N.$mc)($);if($===c)return $;const g=((0,N.$nc)($)||$).toLowerCase();try{const b=(0,O.readdirSync)(c).filter(l=>l.toLowerCase()===g);if(b.length===1){const l=R(c);if(l)return(0,N.$jc)(l,b[0])}else if(b.length>1){const l=b.indexOf(g);if(l>=0){const u=R(c);if(u)return(0,N.$jc)(u,b[l])}}}catch{}return null}e.$fq=R;async function k($){if(L.$k)return $;const c=(0,N.$mc)($);if($===c)return $;const g=((0,N.$nc)($)||$).toLowerCase();try{const b=(await O.Promises.readdir(c)).filter(l=>l.toLowerCase()===g);if(b.length===1){const l=await k(c);if(l)return(0,N.$jc)(l,b[0])}else if(b.length>1){const l=b.indexOf(g);if(l>=0){const u=await k(c);if(u)return(0,N.$jc)(u,b[l])}}}catch{}return null}e.$gq=k;async function m($){try{return await O.Promises.realpath($)}catch{const g=S($);return await O.Promises.access(g,D.constants.R_OK),g}}e.$hq=m;function C($){try{return D.realpathSync($)}catch{const g=S($);return D.accessSync(g,D.constants.R_OK),g}}e.$iq=C;function S($){return(0,j.$Qe)((0,N.$hc)($),N.sep)}}),define(le[144],he([0,1,16,5,37,90,12,31]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(S=L.env){return S.comspec||"cmd.exe"}e.$Ol=k;function m(S){let $=[],c=!1;const g=function(y){if(c){$.push(y);return}(!S.send(y,l=>{if(l&&console.error(l),c=!1,$.length>0){const u=$.slice(0);$=[],u.forEach(h=>g(h))}})||N.$i)&&(c=!0)};return{send:g}}e.$Pl=m;var C;(function(S){async function $(c,g,y){if(D.$ic(c))return c;if(g===void 0&&(g=L.cwd()),D.$mc(c)!=="."||(y===void 0&&O.$Ef(L.env.PATH)&&(y=L.env.PATH.split(D.$tc)),y===void 0||y.length===0))return D.$jc(g,c);async function l(u){if(await R.Promises.exists(u)){let h;try{h=await R.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(h=await R.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of y){let h;if(D.$ic(u)?h=D.$jc(u,c):h=D.$jc(g,u,c),await l(h))return h;let d=h+".com";if(await l(d)||(d=h+".exe",await l(d)))return d}return D.$jc(g,c)}S.findExecutable=$})(C||(e.win32=C={}))}),define(le[145],he([0,1,66,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;function L(O){return new Promise((R,k)=>{let m;const C=new Map;function S(c,g,y,b,l){const u=C.get(g);if(c===O||u){const h={name:$(y),cmd:y,pid:c,ppid:g,load:b,mem:l};C.set(c,h),c===O&&(m=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((d,E)=>d.pid-E.pid)))}}function $(c){const g=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,b=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(b.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(u.exec(c))return"conpty-agent";let d=h.exec(c);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?g.exec(c)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let s="";do d=E.exec(c),d&&(s+=d+" ");while(d);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,y)=>{ne(["@vscode/windows-process-tree"],g,y)}).then(g=>{g.getProcessList(O,y=>{if(!y){k(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(y,b=>{const l=new Map;b.forEach(u=>{const h=c(u.commandLine||"");l.set(u.pid,{name:$(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=l.get(O),m?(l.forEach(u=>{const h=l.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((h,d)=>h.pid-d.pid))}),R(m)):k(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let c=function(){let g=[m];const y=[];for(;g.length;){const l=g.shift();l&&(y.push(l.pid),l.children&&(g=g.concat(l.children)))}let b=JSON.stringify(N.$kg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+y.join(" "),(0,D.exec)(b,{},(l,u,h)=>{if(l||h)k(l||new Error(h.toString()));else{const d=u.toString().split(`
`);for(let E=0;E<y.length;E++){const s=C.get(y[E]);s.load=parseFloat(d[E])}if(!m){k(new Error(`Root process ${O} not found`));return}R(m)}})};(0,D.exec)("which ps",{},(g,y,b)=>{if(g||b)if(process.platform!=="linux")k(g||new Error(b.toString()));else{const l=JSON.stringify(N.$kg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(u,h,d)=>{u||d?k(u||new Error(d.toString())):(j(h,S),c())})}else{const l=y.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,d,E)=>{h||E&&!E.includes("screen size is bogus")?k(h||new Error(E.toString())):(j(d,S),process.platform==="linux"?c():m?R(m):k(new Error(`Root process ${O} not found`)))})}})}})}e.$Pr=L;function j(O,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=O.toString().split(`
`);for(const C of m){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var pe=this&&this.__decorate||function(ne,e,D,N){var L=arguments.length,j=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,D,N);else for(var R=ne.length-1;R>=0;R--)(O=ne[R])&&(j=(L<3?O(j):L>3?O(e,D,j):O(e,D))||j);return L>3&&j&&Object.defineProperty(e,D,j),j};define(le[40],he([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var c;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(c||(c={}));function g(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y||(y={}));function b(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function u(W){let B=0;for(let te=0;;te+=7){const se=W.read(1);if(B|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return B}}const h=n(0);function d(W,B){if(B===0){W.write(h);return}let te=0;for(let _=B;_!==0;_=_>>>7)te++;const se=L.$ge.alloc(te);for(let _=0;B!==0;_++)se.buffer[_]=B&127,B=B>>>7,B>0&&(se.buffer[_]|=128);W.write(se)}class E{constructor(B){this.b=B,this.a=0}read(B){const te=this.b.slice(this.a,this.a+B);return this.a+=te.byteLength,te}}e.$zh=E;class s{constructor(){this.a=[]}get buffer(){return L.$ge.concat(this.a)}write(B){this.a.push(B)}}e.$Ah=s;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const B=L.$ge.alloc(1);return B.writeUInt8(W,0),B}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(W,B){if(typeof B>"u")W.write(i.Undefined);else if(typeof B=="string"){const te=L.$ge.fromString(B);W.write(i.String),d(W,te.byteLength),W.write(te)}else if(t&&Buffer.isBuffer(B)){const te=L.$ge.wrap(B);W.write(i.Buffer),d(W,te.byteLength),W.write(te)}else if(B instanceof L.$ge)W.write(i.VSBuffer),d(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(i.Array),d(W,B.length);for(const te of B)r(W,te)}else if(typeof B=="number"&&(B|0)===B)W.write(i.Uint),d(W,B);else{const te=L.$ge.fromString(JSON.stringify(B));W.write(i.Object),d(W,te.byteLength),W.write(te)}}e.$Bh=r;function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(u(W)).toString();case o.Buffer:return W.read(u(W)).buffer;case o.VSBuffer:return W.read(u(W));case o.Array:{const te=u(W),se=[];for(let _=0;_<te;_++)se.push(a(W));return se}case o.Object:return JSON.parse(W.read(u(W)).toString());case o.Int:return u(W)}}e.$Ch=a;class v{constructor(B,te,se=null,_=1e3){this.h=B,this.j=te,this.k=se,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(B,te){this.b.set(B,te),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const te=this.o([B.type]);this.k?.logOutgoing(te,0,1,b(B.type));return}case 201:case 202:case 204:case 203:{const te=this.o([B.type,B.id],B.data);this.k?.logOutgoing(te,B.id,1,b(B.type),B.data);return}}}o(B,te=void 0){const se=new s;return r(se,B),r(se,te),this.p(se.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const te=new E(B),se=a(te),_=a(te),re=se[0];switch(re){case 100:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}: ${se[2]}.${se[3]}`,_),this.s({type:re,id:se[1],channelName:se[2],name:se[3],arg:_});case 102:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}: ${se[2]}.${se[3]}`,_),this.t({type:re,id:se[1],channelName:se[2],name:se[3],arg:_});case 101:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}`),this.u({type:re,id:se[1]});case 103:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}`),this.u({type:re,id:se[1]})}}s(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=new j.$3d;let _;try{_=te.call(this.j,B.name,B.arg,se.token)}catch(U){_=Promise.reject(U)}const re=B.id;_.then(U=>{this.m({id:re,data:U,type:201})},U=>{U instanceof Error?this.m({id:re,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:re,data:U,type:203})}).finally(()=>{K.dispose(),this.d.delete(B.id)});const K=(0,m.$Qc)(()=>se.cancel());this.d.set(B.id,K)}t(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=B.id,re=te.listen(this.j,B.name,B.arg)(K=>this.m({id:se,data:K,type:204}));this.d.set(B.id,re)}u(B){const te=this.d.get(B.id);te&&(te.dispose(),this.d.delete(B.id))}v(B){let te=this.g.get(B.channelName);te||(te=[],this.g.set(B.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:B,timeoutTimer:se})}w(B){const te=this.g.get(B);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=v;var w;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(B,te=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=te}getChannel(B){const te=this;return{call(se,_,re){return te.a?Promise.reject(new R.$5):te.m(B,se,_,re)},listen(se,_){return te.a?k.Event.None:te.o(B,se,_)}}}m(B,te,se,_=j.CancellationToken.None){const re=this.g++,U={id:re,type:100,channelName:B,name:te,arg:se};if(_.isCancellationRequested)return Promise.reject(new R.$5);let P;return new Promise((H,q)=>{if(_.isCancellationRequested)return q(new R.$5);const ee=()=>{const ce=oe=>{switch(oe.type){case 201:this.f.delete(re),H(oe.data);break;case 202:{this.f.delete(re);const fe=new Error(oe.data.message);fe.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,fe.name=oe.data.name,q(fe);break}case 203:this.f.delete(re),q(oe.data);break}};this.f.set(re,ce),this.p(U)};let G=null;this.b===l.Idle?ee():(G=(0,N.$Pg)(ce=>this.u()),G.then(()=>{G=null,ee()}));const Q=()=>{G?(G.cancel(),G=null):this.p({id:re,type:101}),q(new R.$5)},ie=_.onCancellationRequested(Q);P=(0,m.$Pc)((0,m.$Qc)(Q),ie),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(B,te,se){const _=this.g++,K={id:_,type:102,channelName:B,name:te,arg:se};let U=null;const P=new k.$Sd({onWillAddFirstListener:()=>{U=(0,N.$Pg)(H=>this.u()),U.then(()=>{U=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(P),this.p({id:_,type:103}))}}),A=H=>P.fire(H.data);return this.f.set(_,A),P.event}p(B){switch(B.type){case 100:case 102:{const te=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(te,B.id,0,`${g(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const te=this.q([B.type,B.id]);this.j?.logOutgoing(te,B.id,0,g(B.type));return}}}q(B,te=void 0){const se=new s;return r(se,B),r(se,te),this.r(se.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const te=new E(B),se=a(te),_=a(te),re=se[0];switch(re){case 200:return this.j?.logIncoming(B.byteLength,0,0,b(re)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,se[1],0,b(re),_),this.t({type:se[0],id:se[1],data:_})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=f,pe([O.$th],f.prototype,"onDidInitializePromise",null);class p{get connections(){const B=[];return this.f.forEach(te=>B.push(te)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new k.$Sd,this.onDidAddConnection=this.g.event,this.h=new k.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new m.$Rc,this.j.add(B(({protocol:te,onDidClientDisconnect:se})=>{const _=k.Event.once(te.onMessage);this.j.add(_(re=>{const K=new E(re),U=a(K),P=new v(te,U),A=new f(te);this.a.forEach((q,ee)=>P.registerChannel(ee,q));const H={channelServer:P,channelClient:A,ctx:U};this.f.add(H),this.g.fire(H),this.j.add(se(()=>{P.dispose(),A.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(B,te){const se=this;return{call(_,re,K){let U;if((0,$.$Sf)(te)){const A=(0,D.$4b)(se.connections.filter(te));U=A?Promise.resolve(A):k.Event.toPromise(k.Event.filter(se.onDidAddConnection,te))}else U=te.routeCall(se,_,re);const P=U.then(A=>A.channelClient.getChannel(B));return F(P).call(_,re,K)},listen(_,re){if((0,$.$Sf)(te))return se.k(B,te,_,re);const K=te.routeEvent(se,_,re).then(U=>U.channelClient.getChannel(B));return F(K).listen(_,re)}}}k(B,te,se,_){const re=this;let K;const U=new k.$Sd({onWillAddFirstListener:()=>{K=new m.$Rc;const P=new k.$Yd,A=new Map,H=ee=>{const Q=ee.channelClient.getChannel(B).listen(se,_),ie=P.add(Q);A.set(ee,ie)},q=ee=>{const G=A.get(ee);G&&(G.dispose(),A.delete(ee))};re.connections.filter(te).forEach(H),k.Event.filter(re.onDidAddConnection,te)(H,void 0,K),re.onDidRemoveConnection(q,void 0,K),P.event(U.fire,U,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return U.event}registerChannel(B,te){this.a.set(B,te);for(const se of this.f)se.channelServer.registerChannel(B,te)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=p;class I{constructor(B,te,se=null){const _=new s;r(_,te),B.send(_.buffer),this.a=new f(B,se),this.d=new v(B,te,se)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,te){this.d.registerChannel(B,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=I;function F(W){return{call(B,te,se){return W.then(_=>_.call(B,te,se))},listen(B,te){const se=new k.$2d;return W.then(_=>se.input=_.listen(B,te)),se.event}}}e.$Hh=F;function M(W){let B=!1;return{call(te,se,_){return B?W.call(te,se,_):(0,N.$3g)(0).then(()=>B=!0).then(()=>W.call(te,se,_))},listen(te,se){if(B)return W.listen(te,se);const _=new k.$2d;return(0,N.$3g)(0).then(()=>B=!0).then(()=>_.input=W.listen(te,se)),_.event}}}e.$Ih=M;class T{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const te of B.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$Jh=T;var z;(function(W){function B(re,K,U){const P=re,A=U&&U.disableMarshalling,H=new Map;for(const q in P)se(q)&&H.set(q,k.Event.buffer(P[q],!0,void 0,K));return new class{listen(q,ee,G){const Q=H.get(ee);if(Q)return Q;if(_(ee)){const ie=P[ee];if(typeof ie=="function")return ie.call(P,G)}throw new R.$bb(`Event not found: ${ee}`)}call(q,ee,G){const Q=P[ee];if(typeof Q=="function"){if(!A&&Array.isArray(G))for(let ce=0;ce<G.length;ce++)G[ce]=(0,C.$yh)(G[ce]);let ie=Q.apply(P,G);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new R.$bb(`Method not found: ${ee}`)}}}W.fromService=B;function te(re,K){const U=K&&K.disableMarshalling;return new Proxy({},{get(P,A){if(typeof A=="string")return K?.properties?.has(A)?K.properties.get(A):_(A)?function(H){return re.listen(A,H)}:se(A)?re.listen(A):async function(...H){let q;K&&!(0,$.$Nf)(K.context)?q=[K.context,...H]:q=H;const ee=await re.call(A,q);return U?ee:(0,C.$yh)(ee)};throw new R.$bb(`Property not found: ${String(A)}`)}})}W.toService=te;function se(re){return re[0]==="o"&&re[1]==="n"&&S.$7e(re.charCodeAt(2))}function _(re){return/^onDynamic/.test(re)&&S.$7e(re.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function x(W){return Array.isArray(W)?W.map(J):J(W)}function V(W,B,te,se,_,re,K){K=x(K);const U=Z[_],P=U[se%U.length];let A=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(re)?(A=A.concat(K),A.push(")")):A.push(K),console.log.apply(console,A)}class Y{constructor(B,te){this.d=B,this.f=te,this.a=0,this.b=0}logOutgoing(B,te,se,_,re){this.b+=B,V(this.d,this.b,B,te,se,_,re)}logIncoming(B,te,se,_,re){this.a+=B,V(this.f,this.a,B,te,se,_,re)}}e.$Kh=Y}),define(le[67],he([0,1,15,3,2,40]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(w,f){if(!t.has(w)){const p=String(++r);t.set(w,p)}return t.get(w)}function v(w,f,p,I){if(!i.enableDiagnostics)return;const F=a(w,f);if(I instanceof D.$ge||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const M=D.$ge.alloc(I.byteLength);M.set(I),i.records.push({timestamp:Date.now(),id:F,label:f,type:p,buff:M})}else i.records.push({timestamp:Date.now(),id:F,label:f,type:p,data:I})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let m=null;function C(){return m||(m=D.$ge.alloc(0)),m}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const a=D.$ge.alloc(t);let v=0,w=0;for(;t>0;){const f=this.a[w];if(f.byteLength>t){const p=f.slice(0,t);a.set(p,v),v+=t,r&&(this.a[w]=f.slice(t),this.b-=t),t-=t}else a.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):w++,t-=f.byteLength}return a}}e.$Lh=S;var $;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})($||($={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class y{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends L.$Sc{constructor(t){super(),this.f=this.B(new N.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$ge.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends L.$Sc{constructor(t){super(),this.f=new N.$Sd,this.onMessage=this.f.event,this.g=new N.$Sd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Mh=u;class h extends j.$Gh{static fromSocket(t,r){return new h(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Nh=h;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Oh=d;class E{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Rc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,C());this.p.write(t)}sendResume(){const t=new y(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new y(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,C());this.p.write(t)}}e.$Ph=n}),define(le[93],he([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class g extends c.$Dh{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",u=>L.$ge.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$cq=g;class y{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new k.$Sd,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new N.$Yg(h),this.d=null,this.f=null}getChannel(l){const u=this;return{call(h,d,E){return u.k(l,h,d,E)},listen(h,d){return u.l(l,h,d)}}}k(l,u,h,d=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const E=this.n(l),s=(0,N.$Pg)(i=>E.call(u,h,i)),o=d.onCancellationRequested(()=>s.cancel()),n=(0,m.$Qc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,u,h){if(!this.b)return k.Event.None;this.b.cancel();let d;const E=new k.$Sd({onWillAddFirstListener:()=>{d=this.n(l).listen(u,h)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,$.$Nl)(u.env),this.d=(0,D.fork)(this.i,l,u);const h=new k.$Sd;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$$p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$ge.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,S.$Pl)(this.d):this.d,s=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=h.event,n={send:s,onMessage:o};this.f=new c.$Eh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,m.$Nc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$dq=y}),define(le[146],he([0,1,133,15,40,3,12,18]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sU=e.$rU=void 0;class k{constructor($){this.a=$,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",c=>N.$ge.wrap(c.data)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class m extends L.$Fh{static b($){(0,O.$Of)((0,D.$qU)(process),"Electron Utility Process");const c=new j.$Sd;return process.parentPort.on("message",g=>{if($?.handledClientConnection(g))return;const y=(0,R.$Ob)(g.ports);y&&c.fire(y)}),j.Event.map(c.event,g=>({protocol:new k(g),onDidClientDisconnect:j.Event.fromNodeEventEmitter(g,"close")}))}constructor($){super(m.b($))}}e.$rU=m;function C(S,$,c){const g=y=>{y.data===$&&(S.removeListener("message",g),c())};S.on("message",g)}e.$sU=C}),define(le[68],he([0,1,6,3,2,65,12]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.StorageState=e.$bp=e.StorageHint=void 0;var R;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k($){const c=$;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$bp=k;var m;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(m||(e.StorageState=m={}));class C extends L.$Sc{static{this.a=100}constructor(c,g=Object.create(null)){super(),this.r=c,this.s=g,this.b=this.B(new N.$Vd),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=this.B(new D.$Zg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((g,y)=>this.w(y,g)),c.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(c,g){if(this.c===m.Closed)return;let y=!1;(0,O.$Nf)(g)?y=this.f.delete(c):this.f.get(c)!==g&&(this.f.set(c,g),y=!0),y&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,g){const y=this.f.get(c);return(0,O.$Nf)(y)?g:y}getBoolean(c,g){const y=this.get(c);return(0,O.$Nf)(y)?g:y==="true"}getNumber(c,g){const y=this.get(c);return(0,O.$Nf)(y)?g:parseInt(y,10)}getObject(c,g){const y=this.get(c);return(0,O.$Nf)(y)?g:(0,j.$xh)(y)}async set(c,g,y=!1){if(this.c===m.Closed)return;if((0,O.$Nf)(g))return this.delete(c,y);const b=(0,O.$Gf)(g)||Array.isArray(g)?(0,j.$wh)(g):String(g);if(this.f.get(c)!==b)return this.f.set(c,b),this.j.set(c,b),this.h.delete(c),this.b.fire({key:c,external:y}),this.D()}async delete(c,g=!1){if(!(this.c===m.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:g}),this.D()}async optimize(){if(this.c!==m.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=m.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$cp=C;class S{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((g,y)=>this.a.set(y,g)),c.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$dp=S}),define(le[147],he([13,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[69],he([0,1,54,6,16,12,31,147]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.zip=e.$yp=e.$xp=void 0,e.$xp="end of central directory record signature not found";const k=new RegExp(e.$xp);class m extends Error{constructor(E,s){let o=s.message;switch(E){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=E,this.cause=s}}e.$yp=m;function C(d){const E=d.externalFileAttributes>>16||33188;return[448,56,7].map(s=>E&s).reduce((s,o)=>s+o,E&61440)}function S(d){if(d instanceof m)return d;let E;return k.test(d.message)&&(E="CorruptZip"),new m(E,d)}function $(d,E,s,o,n,i){const t=L.$mc(E),r=L.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,E)));const a=L.$jc(o,E);let v;return i.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((w,f)=>{if(!i.isCancellationRequested)try{v=(0,D.createWriteStream)(a,{mode:s}),v.once("close",()=>w()),v.once("error",f),d.once("error",f),d.pipe(v)}catch(p){f(p)}}))}function c(d,E,s,o){let n=(0,N.$Pg)(()=>Promise.resolve()),i=0;const t=o.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((r,a)=>{const v=new N.$Wg,w=f=>{f.isCancellationRequested||(i++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{o.isCancellationRequested||d.entryCount===i?r():a(new m("Incomplete",new Error(R.localize(1,null,i,d.entryCount))))},a)),d.readEntry(),d.on("entry",f=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(f.fileName)){w(o);return}const p=f.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(p)){const M=L.$jc(E,p);n=(0,N.$Pg)(T=>O.Promises.mkdir(M,{recursive:!0}).then(()=>w(T)).then(void 0,a));return}const I=y(d,f),F=C(f);n=(0,N.$Pg)(M=>v.queue(()=>I.then(T=>$(T,p,F,E,s,M).then(()=>w(M)))).then(null,a))})}).finally(()=>t.dispose())}async function g(d,E=!1){const{open:s}=await new Promise((o,n)=>{ne(["yauzl"],o,n)});return new Promise((o,n)=>{s(d,E?{lazyEntries:!0}:void 0,(i,t)=>{i?n(S(i)):o((0,j.$Pf)(t))})})}function y(d,E){return new Promise((s,o)=>{d.openReadStream(E,(n,i)=>{n?o(S(n)):s((0,j.$Pf)(i))})})}async function b(d,E){const{ZipFile:s}=await new Promise((o,n)=>{ne(["yazl"],o,n)});return new Promise((o,n)=>{const i=new s;E.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const t=(0,D.createWriteStream)(d);i.outputStream.pipe(t),i.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(d))})}e.zip=b;function l(d,E,s={},o){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=g(d,!0);return s.overwrite&&(i=i.then(t=>O.Promises.rm(E).then(()=>t))),i.then(t=>c(t,E,{sourcePathRegex:n},o))}e.$Ap=l;function u(d,E){return g(d).then(s=>new Promise((o,n)=>{s.on("entry",i=>{i.fileName===E&&y(s,i).then(t=>o(t),t=>n(t))}),s.once("close",()=>n(new Error(R.localize(2,null,E))))}))}function h(d,E){return u(d,E).then(s=>new Promise((o,n)=>{const i=[];s.once("error",n),s.on("data",t=>i.push(t)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Bp=h}),define(le[148],he([13,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[149],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[150],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[151],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[152],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[153],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[154],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[155],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[156],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[157],he([13,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[158],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[159],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[160],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[161],he([13,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[162],he([13,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[163],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[164],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[165],he([13,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[166],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[167],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[168],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[169],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[170],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[171],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[172],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[173],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[174],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[175],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[176],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[177],he([13,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[178],he([0,1,7,150]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var L;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...m){switch(m.length){case 1:return(0,N.localize)(0,null,m[0]);case 2:return(0,N.localize)(1,null,m[0],m[1]);case 3:return(0,N.localize)(2,null,m[0],m[1],m[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,$=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:$};this.g.push({offset:S,lexeme:$,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),$=k.b.get(S);$?this.k($):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,$=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const g=this.c.charCodeAt(C);if(S)S=!1;else if(g===47&&!$){C++;break}else g===91?$=!0:g===92?S=!0:g===93&&($=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=k}),define(le[179],he([0,1,64,84,23,16,37,19,10]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=e.$sm=void 0,e.$sm=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,j.$mc)(L.$kg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Dg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Dg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$rm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",c)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Dg)(k.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Dg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Dg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Dg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,j.$jc)(c,"argv.json")):(0,R.$Dg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,j.$kc)(c):(0,j.$hc)((0,j.$jc)(L.$kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?k.URI.file((0,j.$kc)(c)):k.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,j.$kc)(c);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const y=O.env.VSCODE_PORTABLE;return y?(0,j.$jc)(y,"extensions"):(0,R.$Dg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(g=>/^[^:/?#]+?:\/\//.test(g)?k.URI.parse(g):k.URI.file((0,j.$hc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?k.URI.parse(c):k.URI.file((0,j.$hc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$sm.test(c))}get extensionLogLevel(){const c=[];for(const g of this.args.log||[]){const y=e.$sm.exec(g);y&&y[1]&&y[2]&&c.push([y[1],y[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.$Dg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,j.$jc)(c,"policy.json")):(0,R.$Dg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,g,y){this.a=c,this.b=g,this.c=y,this.editSessionId=this.args.editSessionId}}e.$tm=m,pe([N.$th],m.prototype,"appRoot",null),pe([N.$th],m.prototype,"userHome",null),pe([N.$th],m.prototype,"userDataPath",null),pe([N.$th],m.prototype,"appSettingsHome",null),pe([N.$th],m.prototype,"tmpDir",null),pe([N.$th],m.prototype,"cacheHome",null),pe([N.$th],m.prototype,"stateResource",null),pe([N.$th],m.prototype,"userRoamingDataHome",null),pe([N.$th],m.prototype,"userDataSyncHome",null),pe([N.$th],m.prototype,"sync",null),pe([N.$th],m.prototype,"machineSettingsResource",null),pe([N.$th],m.prototype,"workspaceStorageHome",null),pe([N.$th],m.prototype,"localHistoryHome",null),pe([N.$th],m.prototype,"keyboardLayoutResource",null),pe([N.$th],m.prototype,"argvResource",null),pe([N.$th],m.prototype,"isExtensionDevelopment",null),pe([N.$th],m.prototype,"untitledWorkspacesHome",null),pe([N.$th],m.prototype,"builtinExtensionsPath",null),pe([N.$th],m.prototype,"extensionsPath",null),pe([N.$th],m.prototype,"extensionDevelopmentLocationURI",null),pe([N.$th],m.prototype,"extensionDevelopmentKind",null),pe([N.$th],m.prototype,"extensionTestsLocationURI",null),pe([N.$th],m.prototype,"debugExtensionHost",null),pe([N.$th],m.prototype,"logLevel",null),pe([N.$th],m.prototype,"extensionLogLevel",null),pe([N.$th],m.prototype,"serviceMachineIdResource",null),pe([N.$th],m.prototype,"disableTelemetry",null),pe([N.$th],m.prototype,"disableWorkspaceTrust",null),pe([N.$th],m.prototype,"useInMemorySecretStorage",null),pe([N.$th],m.prototype,"policyFile",null);function C($,c){return S($["inspect-extensions"],$["inspect-brk-extensions"],5870,c,$.debugId,$.extensionEnvironment)}e.$um=C;function S($,c,g,y,b,l){const h=Number(c||$)||(y?null:g),d=h?!!c:!1;let E;if(l)try{E=JSON.parse(l)}catch{}return{port:h,break:d,debugId:b,env:E}}e.$vm=S}),function(){"use strict";function ne(e,D,N){function L(O,R){const k=j(O,R),m=[k];return e.isAbsolute(k)||m.unshift(N),e.resolve(...m)}function j(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(S,"AppData","Roaming")}break;case"darwin":m=e.join(D.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:L}}if(typeof define=="function")define(le[180],he([269,36,37]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[181],he([0,1,36,179,180]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=void 0;class j extends N.$tm{constructor(m,C){super(m,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(m,C.nameShort)},C)}}e.$wm=j;function O(k,m){return(0,N.$vm)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,m,k.extensionEnvironment)}e.$xm=O;function R(k,m){return(0,N.$vm)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,m,k.extensionEnvironment)}e.$ym=R}),define(le[182],he([0,1,12,153]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;function L(O,R,k,m){try{j(O,R,k,m)}catch(C){O.error(C?.message??C)}return R}e.$Kp=L;function j(O,R,k,m){const C=(S,$,c)=>{const g=S[$];if((0,D.$Ef)(g)){const y=g,b=y.length;if(b>1&&y[0]==="%"&&y[b-1]==="%"){const l=y.substr(1,b-2);let u=k[l];u===void 0&&m&&(u=m[l]);const h=typeof u=="string"?u:u?.message,d=m?.[l],E=typeof d=="string"?d:d?.message;if(!h){E||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,l)}`);return}if(c&&($==="title"||$==="category")&&E&&E!==h){const s={value:h,original:E};S[$]=s}else S[$]=h}}else if((0,D.$Gf)(g))for(const y in g)g.hasOwnProperty(y)&&(y==="commands"?C(g,y,!0):C(g,y,c));else if(Array.isArray(g))for(let y=0;y<g.length;y++)C(g,y,c)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(le[183],he([0,1,69,156]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;function L(j){return(0,D.$Bp)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Sp=L}),define(le[184],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=void 0;class D{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$9$b=D;class N{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$0$b=N}),define(le[70],he([0,1,19,89,157,55]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(l){return l=l.trim(),l==="*"||O.test(l)}e.$Yo=k;function m(l){if(!k(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Zo=m;function C(l){if(!l)return null;const u=l.majorBase,h=l.majorMustEqual,d=l.minorBase;let E=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(E=!1),o=!1);let n=0;if(l.preRelease){const i=R.exec(l.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:h,minorBase:d,minorMustEqual:E,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$1o=C;function S(l,u,h){let d;typeof l=="string"?d=C(m(l)):d=l;let E;u instanceof Date?E=u.getTime():typeof u=="string"&&(E=new Date(u).getTime());let s;if(typeof h=="string"?s=C(m(h)):s=h,!d||!s)return!1;const o=d.majorBase,n=d.minorBase,i=d.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const v=s.notBefore;let w=s.majorMustEqual,f=s.minorMustEqual,p=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!w||!f||!p)&&(t=1,r=0,a=0,w=!0,f=!1,p=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!f:i<a?!1:i>a?!p:!(E&&E<v))}e.$2o=S;function $(l,u,h,d,E){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([N.default.Error,L.localize(0,null)]),s;if(typeof d.name!="string")return s.push([N.default.Error,L.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([N.default.Error,L.localize(2,null,"version")]),s;if(!d.engines)return s.push([N.default.Error,L.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([N.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!b(d.extensionDependencies))return s.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!b(d.activationEvents))return s.push([N.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([N.default.Error,L.localize(9,null,"main")]),s;{const i=(0,D.$Dg)(h,d.main);(0,D.$xg)(i,h)||s.push([N.default.Warning,L.localize(10,null,i.path,h.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([N.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,D.$Dg)(h,d.browser);(0,D.$xg)(i,h)||s.push([N.default.Warning,L.localize(12,null,i.path,h.path)])}}if(!j.valid(d.version))return s.push([N.default.Error,L.localize(13,null)]),s;const o=[];if(!c(l,u,d,E,o))for(const i of o)s.push([N.default.Error,i]);return s}e.$3o=$;function c(l,u,h,d,E){return d||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(l,u,h.engines.vscode,E)}e.$4o=c;function g(l,u,h){return l==="*"||y(u,h,l)}e.$5o=g;function y(l,u,h,d=[]){const E=C(m(h));if(!E)return d.push(L.localize(14,null,h)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(L.localize(15,null,h)),!1}else if(!E.majorMustEqual)return d.push(L.localize(16,null,h)),!1;return S(l,u,E)?!0:(d.push(L.localize(17,null,l,h)),!1)}function b(l){if(!Array.isArray(l))return!1;for(let u=0,h=l.length;u<h;u++)if(typeof l[u]!="string")return!1;return!0}}),define(le[43],he([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;async function L(j,O,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await O.readFile(j.serviceMachineIdResource)).value.toString();k=(0,N.$lg)(C)?C:null}catch{k=null}if(!k){k=(0,N.$mg)();try{await O.writeFile(j.serviceMachineIdResource,D.$ge.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$mp=L}),define(le[71],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class D{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$Yh=D}),define(le[185],he([0,1,71]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.InstantiationType=void 0;const N=[];var L;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(R,k,m){k instanceof D.$Yh||(k=new D.$Yh(k,[],!!m)),N.push([R,k])}e.$Jr=j;function O(){return N}e.$Kr=O}),define(le[186],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;class D{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$oq=D;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const R=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(O);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let R=this.a.get(O);return R||(R=new D(O,j),this.a.set(O,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,R]of this.a)j.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const R=new Set([j]),k=this.c(O,R);if(k)return k}}c(j,O){for(const[R,k]of j.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const m=this.c(k,O);if(m)return m;O.delete(R)}}}e.$pq=N}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(D||(e._util=D={})),e.$1h=L("instantiationService");function N(O,R,k){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:O,index:k}):(R[D.DI_DEPENDENCIES]=[{id:O,index:k}],R[D.DI_TARGET]=R)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const R=function(k,m,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,k,C)};return R.toString=()=>O,D.serviceIds.set(O,R),R}e.$2h=L;function j(O){return O}e.$3h=j}),define(le[187],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0,e.$F$b=(0,D.$2h)("checksumService")}),define(le[20],he([0,1,12,10,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,L.$2h)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}e.$wi=j;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}e.$xi=O;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=k;function m(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$zi=m;function C(l,u){const h=Object.create(null);for(const d in l)S(h,d,l[d],u);return h}e.$Ai=C;function S(l,u,h,d){const E=u.split("."),s=E.pop();let o=l;for(let n=0;n<E.length;n++){const i=E[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${u} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=h}catch{d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$Bi=S;function $(l,u){const h=u.split(".");c(l,h)}e.$Ci=$;function c(l,u){const h=u.shift();if(u.length===0){delete l[h];return}if(Object.keys(l).indexOf(h)!==-1){const d=l[h];typeof d=="object"&&!Array.isArray(d)&&(c(d,u),Object.keys(d).length===0&&delete l[h])}}function g(l,u,h){function d(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=u.split("."),s=d(l,E);return typeof s>"u"?h:s}e.$Di=g;function y(l,u,h){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?D.$Gf(l[d])&&D.$Gf(u[d])?y(l[d],u[d],h):h&&(l[d]=u[d]):l[d]=u[d])})}e.$Ei=y;function b(l){return l.replace(/[\[\]]/g,"")}e.$Fi=b}),define(le[94],he([0,1,5,27,178,4,149,7]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.$j),k.set("isLinux",D.$k),k.set("isWindows",D.$i),k.set("isWeb",D.$o),k.set("isMacNative",D.$j&&!D.$o),k.set("isEdge",D.$H),k.set("isFirefox",D.$F),k.set("isChrome",D.$E),k.set("isSafari",D.$G);function m(U,P){if(k.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(U,P)}e.$Xi=m;const C=Object.prototype.hasOwnProperty;var S;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const $={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),g=(0,O.localize)(1,null),y=(0,O.localize)(2,null),b=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),h=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=$){this.k=P,this.d=new L.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const A=this.l();if(!this.E()){const H=this.D(),q=H.type===17?u:void 0;throw this.h.push({message:l,offset:H.offset,lexeme:L.$Wi.getLexeme(H),additionalInfo:q}),E.c}return A}catch(A){if(A!==E.c)throw A;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const A=this.o();P.push(A)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const A=this.s();P.push(A)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const A=this.l();return this.A(1,b),A?.negate()}case 17:return this.z(),I.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const A=this.l();return this.A(1,b),A}case 17:{const A=P.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const ee=q.lexeme,G=ee.lastIndexOf("/"),Q=G===ee.length-1?void 0:this.w(ee.substring(G+1));let ie;try{ie=new RegExp(ee.substring(1,G),Q)}catch{throw this.B("REGEX",q)}return J.create(A,ie)}switch(q.type){case 10:case 19:{const ee=[q.lexeme];this.z();let G=this.D(),Q=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?Q++:q.lexeme.charCodeAt(de)===41&&Q--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:Q++;break;case 1:Q--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?Q++:q.lexeme.charCodeAt(de)===41&&Q--}if(Q<0)break;ee.push(L.$Wi.getLexeme(G)),this.z(),G=this.D()}const ie=ee.join(""),ce=ie.lastIndexOf("/"),oe=ce===ie.length-1?void 0:this.w(ie.substring(ce+1));let fe;try{fe=new RegExp(ie.substring(1,ce),oe)}catch{throw this.B("REGEX",q)}return s.regex(A,fe)}case 18:{const ee=q.lexeme;this.z();let G=null;if(!(0,N.$Ge)(ee)){const Q=ee.indexOf("/"),ie=ee.lastIndexOf("/");if(Q!==ie&&Q>=0){const ce=ee.slice(Q+1,ie),oe=ee[ie+1]==="i"?"i":"";try{G=new RegExp(ce,oe)}catch{throw this.B("REGEX",q)}}}if(G===null)throw this.B("REGEX",q);return J.create(A,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const q=this.u();return s.notIn(A,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return s.equals(A,q);switch(q){case"true":return s.has(A);case"false":return s.not(A);default:return s.equals(A,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return s.notEquals(A,q);switch(q){case"true":return s.not(A);case"false":return s.has(A);default:return s.notEquals(A,q)}}case 5:return this.z(),z.create(A,this.u());case 6:return this.z(),Z.create(A,this.u());case 7:return this.z(),M.create(A,this.u());case 8:return this.z(),T.create(A,this.u());case 13:return this.z(),s.in(A,this.u());default:return s.has(A)}}case 20:throw this.h.push({message:h,offset:P.offset,lexeme:"",additionalInfo:d}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,A){if(this.C(P))return this.z();throw this.B(A,this.D())}B(P,A,H){const q=(0,O.localize)(8,null,P,L.$Wi.getLexeme(A)),ee=A.offset,G=L.$Wi.getLexeme(A);return this.h.push({message:q,offset:ee,lexeme:G,additionalInfo:H}),E.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=E;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,A){return v.create(P,A)}static notEquals(P,A){return p.create(P,A)}static regex(P,A){return J.create(P,A)}static in(P,A){return w.create(P,A)}static notIn(P,A){return f.create(P,A)}static not(P){return I.create(P)}static and(...P){return Y.create(P,null,!0)}static or(...P){return W.create(P,null,!0)}static greater(P,A){return M.create(P,A)}static greaterEquals(P,A){return T.create(P,A)}static smaller(P,A){return z.create(P,A)}static smallerEquals(P,A){return Z.create(P,A)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Zi=s;function o(U){const P=new E({regexParsingWithErrorRecovery:!1});return U.map(A=>(P.parse(A),P.lexingErrors.length>0?P.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,O.localize)(9,null,H.additionalInfo):(0,O.localize)(10,null),offset:H.offset,length:H.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.$1i=o;function n(U,P){const A=U?U.substituteConstants():void 0,H=P?P.substituteConstants():void 0;return!A&&!H?!0:!A||!H?!1:A.equals(H)}e.$2i=n;function i(U,P){return U.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$3i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$4i=r;class a{static create(P,A=null){const H=k.get(P);return typeof H=="boolean"?H?r.INSTANCE:t.INSTANCE:new a(P,A)}constructor(P,A){this.key=P,this.c=A,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:te(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$5i=a;class v{static create(P,A,H=null){if(typeof A=="boolean")return A?a.create(P,H):I.create(P,H);const q=k.get(P);return typeof q=="boolean"?A===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,A,H)}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const A=P?"true":"false";return this.d===A?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$6i=v;class w{static create(P,A){return new w(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:se(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const A=P.getValue(this.f),H=P.getValue(this.d);return Array.isArray(A)?A.includes(H):typeof H=="string"&&typeof A=="object"&&A!==null?C.call(A,H):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$7i=w;class f{static create(P,A){return new f(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=11,this.c=w.create(P,A)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=f;class p{static create(P,A,H=null){if(typeof A=="boolean")return A?I.create(P,H):a.create(P,H);const q=k.get(P);return typeof q=="boolean"?A===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new p(P,A,H)}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const A=P?"true":"false";return this.d===A?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$9i=p;class I{static create(P,A=null){const H=k.get(P);return typeof H=="boolean"?H?t.INSTANCE:r.INSTANCE:new I(P,A)}constructor(P,A){this.c=P,this.d=A,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=k.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$0i=I;function F(U,P){if(typeof U=="string"){const A=parseFloat(U);isNaN(A)||(U=A)}return typeof U=="string"||typeof U=="number"?P(U):t.INSTANCE}class M{static create(P,A,H=null){return F(A,q=>new M(P,q,H))}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$$i=M;class T{static create(P,A,H=null){return F(A,q=>new T(P,q,H))}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$_i=T;class z{static create(P,A,H=null){return F(A,q=>new z(P,q,H))}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$aj=z;class Z{static create(P,A,H=null){return F(A,q=>new Z(P,q,H))}constructor(P,A,H){this.c=P,this.d=A,this.f=H,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$bj=Z;class J{static create(P,A){return new J(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const A=this.f?this.f.source:"",H=P.f?P.f.source:"";return A<H?-1:A>H?1:0}equals(P){if(P.type===this.type){const A=this.f?this.f.source:"",H=P.f?P.f.source:"";return this.d===P.d&&A===H}return!1}substituteConstants(){return this}evaluate(P){const A=P.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$cj=J;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$dj=x;function V(U){let P=null;for(let A=0,H=U.length;A<H;A++){const q=U[A].substituteConstants();if(U[A]!==q&&P===null){P=[];for(let ee=0;ee<A;ee++)P[ee]=U[ee]}P!==null&&(P[A]=q)}return P===null?U:P}class Y{static create(P,A,H){return Y.d(P,A,H)}constructor(P,A){this.expr=P,this.c=A,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let A=0,H=this.expr.length;A<H;A++){const q=i(this.expr[A],P.expr[A]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let A=0,H=this.expr.length;A<H;A++)if(!this.expr[A].equals(P.expr[A]))return!1;return!0}return!1}substituteConstants(){const P=V(this.expr);return P===this.expr?this:Y.create(P,this.c,!1)}evaluate(P){for(let A=0,H=this.expr.length;A<H;A++)if(!this.expr[A].evaluate(P))return!1;return!0}static d(P,A,H){const q=[];let ee=!1;for(const G of P)if(G){if(G.type===1){ee=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){q.push(...G.expr);continue}q.push(G)}if(q.length===0&&ee)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let G=1;G<q.length;G++)q[G-1].equals(q[G])&&(q.splice(G,1),G--);if(q.length===1)return q[0];for(;q.length>1;){const G=q[q.length-1];if(G.type!==9)break;q.pop();const Q=q.pop(),ie=q.length===0,ce=W.create(G.expr.map(oe=>Y.create([oe,Q],null,H)),null,ie);ce&&(q.push(ce),q.sort(i))}if(q.length===1)return q[0];if(H){for(let G=0;G<q.length;G++)for(let Q=G+1;Q<q.length;Q++)if(q[G].negate().equals(q[Q]))return t.INSTANCE;if(q.length===1)return q[0]}return new Y(q,A)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const A of this.expr)P.push(...A.keys());return P}map(P){return new Y(this.expr.map(A=>A.map(P)),null)}negate(){if(!this.c){const P=[];for(const A of this.expr)P.push(A.negate());this.c=W.create(P,this,!0)}return this.c}}e.$ej=Y;class W{static create(P,A,H){return W.d(P,A,H)}constructor(P,A){this.expr=P,this.c=A,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let A=0,H=this.expr.length;A<H;A++){const q=i(this.expr[A],P.expr[A]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let A=0,H=this.expr.length;A<H;A++)if(!this.expr[A].equals(P.expr[A]))return!1;return!0}return!1}substituteConstants(){const P=V(this.expr);return P===this.expr?this:W.create(P,this.c,!1)}evaluate(P){for(let A=0,H=this.expr.length;A<H;A++)if(this.expr[A].evaluate(P))return!0;return!1}static d(P,A,H){let q=[],ee=!1;if(P){for(let G=0,Q=P.length;G<Q;G++){const ie=P[G];if(ie){if(ie.type===0){ee=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&ee)return t.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let G=1;G<q.length;G++)q[G-1].equals(q[G])&&(q.splice(G,1),G--);if(q.length===1)return q[0];if(H){for(let G=0;G<q.length;G++)for(let Q=G+1;Q<q.length;Q++)if(q[G].negate().equals(q[Q]))return r.INSTANCE;if(q.length===1)return q[0]}return new W(q,A)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const A of this.expr)P.push(...A.keys());return P}map(P){return new W(this.expr.map(A=>A.map(P)),null)}negate(){if(!this.c){const P=[];for(const A of this.expr)P.push(A.negate());for(;P.length>1;){const A=P.shift(),H=P.shift(),q=[];for(const ee of K(A))for(const G of K(H))q.push(Y.create([ee,G],null,!1));P.unshift(W.create(q,null,!1))}this.c=W.create(P,this,!0)}return this.c}}e.$fj=W;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(P,A,H){super(P,null),this.f=A,typeof H=="object"?B.d.push({...H,key:P}):H!==!0&&B.d.push({key:P,description:H,type:A!=null?typeof A:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return p.create(this.key,P)}}e.$gj=B,e.$hj=(0,j.$2h)("contextKeyService");function te(U,P){return U<P?-1:U>P?1:0}function se(U,P,A,H){return U<A?-1:U>A?1:P<H?-1:P>H?1:0}function _(U,P){if(U.type===0||P.type===1)return!0;if(U.type===9)return P.type===9?re(U.expr,P.expr):!1;if(P.type===9){for(const A of P.expr)if(_(U,A))return!0;return!1}if(U.type===6){if(P.type===6)return re(P.expr,U.expr);for(const A of U.expr)if(_(A,P))return!0;return!1}return U.equals(P)}e.$ij=_;function re(U,P){let A=0,H=0;for(;A<U.length&&H<P.length;){const q=U[A].cmp(P[H]);if(q<0)return!1;q===0&&A++,H++}return A===U.length}function K(U){return U.type===9?U.expr:[U]}}),define(le[95],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.ID=void 0,e.ID="diagnosticsService",e.$Dm=(0,D.$2h)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}e.$Em=N;class L{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Fm=L}),define(le[96],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n=(0,D.$2h)("downloadService")}),define(le[14],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,D.$2h)("environmentService"),e.$0h=(0,D.$3h)(e.$9h)}),define(le[29],he([0,1,152,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0,e.$$n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_n=new RegExp(e.$$n),e.$ao="__web_extension",e.$bo="skipWalkthrough",e.$co="extensionsSync",e.$do="dependecyOrPackExtensionInstall";function L(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$eo=L;function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$fo=j;function O(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$go=O;function R(l,u){return u==="web"&&!l.includes("web")}e.$ho=R;function k(l,u,h){return R(u,h)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===h}e.$io=k;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$jo=m;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var $;(function(l){l.Install="install",l.Uninstall="uninstall"})($||(e.StatisticType=$={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$ko=(0,N.$2h)("extensionGalleryService");var g;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var y;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class b extends Error{constructor(u,h){super(u),this.code=h,this.name=h}}e.$lo=b,e.$mo=(0,N.$2h)("extensionManagementService"),e.$no="extensionsIdentifiers/disabled",e.$oo="extensionsIdentifiers/enabled",e.$po=(0,N.$2h)("IGlobalExtensionEnablementService"),e.$qo=(0,N.$2h)("IExtensionTipsService"),e.$ro=(0,D.localize)(0,null),e.$so={value:e.$ro,original:"Extensions"},e.$to={value:(0,D.localize)(1,null),original:"Preferences"}}),define(le[188],he([0,1,3,2,30,10,92,29]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=void 0;function k(b,l){return b?j.URI.revive(l?l.transformIncoming(b):b):void 0}function m(b,l){return l?l.transformOutgoingURI(b):b}function C(b,l){l=l||O.$Zm;const u=b.manifest;return{...(0,O.$3m)({...b,manifest:void 0},l),manifest:u}}function S(b,l){return b?.profileLocation?(0,O.$3m)(b,l??O.$Zm):b}function $(b,l){return l?(0,L.$jn)(b,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):b}class c{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const h=this.b(l);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?m(d.profileLocation,h):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(E=>({...E,local:E.local?$(E.local,h):E.local,profileLocation:E.profileLocation?m(E.profileLocation,h):E.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?m(d.profileLocation,h):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?m(d.profileLocation,h):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>$(d,h))}throw new Error("Invalid listen")}async call(l,u,h){const d=this.b(l);switch(u){case"zip":{const E=C(h[0],d),s=await this.a.zip(E);return m(s,d)}case"unzip":return this.a.unzip(k(h[0],d));case"install":return this.a.install(k(h[0],d),S(h[1],d));case"installFromLocation":return this.a.installFromLocation(k(h[0],d),k(h[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],k(h[1],d),k(h[2],d));case"getManifest":return this.a.getManifest(k(h[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],S(h[1],d));case"installGalleryExtensions":{const E=h[0];return this.a.installGalleryExtensions(E.map(({extension:s,options:o})=>({extension:s,options:S(o,d)??{}})))}case"uninstall":return this.a.uninstall(C(h[0],d),S(h[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(h[0],d));case"getInstalled":return(await this.a.getInstalled(h[0],k(h[1],d))).map(s=>$(s,d));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(C(h[0],d),k(h[1],d));return $(E,d)}case"copyExtensions":return this.a.copyExtensions(k(h[0],d),k(h[1],d));case"updateMetadata":{const E=await this.a.updateMetadata(C(h[0],d),h[1],k(h[2],d));return $(E,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$up=c;class g extends N.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$Sd),this.f=this.B(new D.$Sd),this.g=this.B(new D.$Sd),this.h=this.B(new D.$Sd),this.j=this.B(new D.$Sd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(h=>(0,R.$io)(h,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(h=>C(h,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(h=>C(h,null))}async installExtensionsFromProfile(l,u,h){return(await this.m.call("installExtensionsFromProfile",[l,u,h])).map(E=>C(E,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(h=>C(h,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>C(u,null))}getInstalled(l=null,u){return Promise.resolve(this.m.call("getInstalled",[l,u])).then(h=>h.map(d=>C(d,null)))}updateMetadata(l,u,h){return Promise.resolve(this.m.call("updateMetadata",[l,u,h])).then(d=>C(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(h=>C(h,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,h){const d=await this.m.call("download",[l,u,h]);return j.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$vp=g;class y{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$wp=y}),define(le[97],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=void 0,e.$rp=(0,D.$2h)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((j,O)=>ne(["node-vsce-sign"],async R=>j(R),O))),this.a}async verify(j,O,R){let k;try{k=await this.b()}catch{return!1}return k.verify(j,O,R)}}e.$sp=N}),define(le[98],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rYb=e.RecommendationsNotificationResult=e.$qYb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$qYb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$rYb=(0,D.$2h)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,47,16,27,12,10,159,4,5,23,52]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,k.$2h)("fileService");function $(_){return _.create===!0}e.$mk=$;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var g;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function y(_){const re=_;return!!re&&typeof re.onDidChange=="function"}e.$nk=y;var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function l(_){return!!(_.capabilities&2)}e.$ok=l;function u(_){return!!(_.capabilities&8)}e.$pk=u;function h(_){return!!(_.capabilities&131072)}e.$qk=h;function d(_){return!!(_.capabilities&4)}e.$rk=d;function E(_){return!!(_.capabilities&16)}e.$sk=E;function s(_){return l(_)?!!(_.capabilities&16384):!1}e.$tk=s;function o(_){return l(_)?!!(_.capabilities&32768):!1}e.$uk=o;function n(_){return!!(_.capabilities&65536)}e.$vk=n;function i(_){return!!(_.capabilities&2048)}e.$wk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(re,K){const U=new r(re.toString(),K);return w(U,K),U}constructor(re,K){super(re),this.code=K}}e.$xk=r;function a(_,re){return r.create(_,re)}e.$yk=a;function v(_){return _||a((0,R.localize)(0,null),t.Unknown)}e.$zk=v;function w(_,re){return _.name=re?`${re} (FileSystemError)`:"FileSystemError",_}e.$Ak=w;function f(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const re=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!re)return t.Unknown;switch(re[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Bk=f;function p(_){if(_ instanceof Z)return _.fileOperationResult;switch(f(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Ck=p;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(re,K,U){this.resource=re,this.operation=K,this.target=U}isOperation(re){return this.operation===re}}e.$Dk=F;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class T{static{this.a=null}constructor(re,K){this.c=K,this.b=void 0,this.d=new S.$V(()=>{const U=D.$8h.forUris(()=>this.c);return U.fill(this.rawAdded.map(P=>[P,!0])),U}),this.f=new S.$V(()=>{const U=D.$8h.forUris(()=>this.c);return U.fill(this.rawUpdated.map(P=>[P,!0])),U}),this.g=new S.$V(()=>{const U=D.$8h.forUris(()=>this.c);return U.fill(this.rawDeleted.map(P=>[P,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of re){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==T.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(re,...K){return this.h(re,{includeChildren:!1},...K)}affects(re,...K){return this.h(re,{includeChildren:!0},...K)}h(re,K,...U){if(!re)return!1;const P=U.length>0;return!!((!P||U.includes(1))&&(this.d.value.get(re)||K.includeChildren&&this.d.value.findSuperstr(re))||(!P||U.includes(0))&&(this.f.value.get(re)||K.includeChildren&&this.f.value.findSuperstr(re))||(!P||U.includes(2))&&(this.g.value.findSubstr(re)||K.includeChildren&&this.g.value.findSuperstr(re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(re){return this.b===re}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=T;function z(_,re,K){return!_||!re||_===re||re.length>_.length?!1:(re.charAt(re.length-1)!==N.sep&&(re+=N.sep),K?(0,L.$9e)(_,re):_.indexOf(re)===0)}e.$Fk=z;class Z extends Error{constructor(re,K,U){super(re),this.fileOperationResult=K,this.options=U}}e.$Gk=Z;class J extends Z{constructor(re,K,U,P){super(re,K,P),this.fileOperationResult=K,this.size=U}}e.$Hk=J;class x extends Z{constructor(re,K,U){super(re,2,U),this.stat=K}}e.$Ik=x;var V;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var Y;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Qk="";function W(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Rk=W;async function B(_,re){if(!re.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const U=re.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(U.dispose(),K())})})}e.$Sk=B;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(re){return(0,j.$If)(re)||(re=0),re<te.KB?(0,R.localize)(1,null,re.toFixed(0)):re<te.MB?(0,R.localize)(2,null,(re/te.KB).toFixed(2)):re<te.GB?(0,R.localize)(3,null,(re/te.MB).toFixed(2)):re<te.TB?(0,R.localize)(4,null,(re/te.GB).toFixed(2)):(0,R.localize)(5,null,(re/te.TB).toFixed(2))}}e.$Tk=te;function se(_){const re=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*te.MB:re?10*te.MB:m.$o?50*te.MB:1024*te.MB}e.$Uk=se});var X=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(le[189],he([0,1,72,46,11]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((m,C)=>{const S=(0,D.createHash)("md5");(0,N.$$d)(k,{onData:$=>S.update($.buffer),onError:$=>C($),onEnd:()=>m(S.digest("base64").replace(/=+$/,""))})})}};e.$G$b=j,e.$G$b=j=pe([X(0,L.$lk)],j)}),define(le[99],he([0,1,15,7,160,11]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;async function O(C,S,$,c,g,y){let b;try{await R(C,S,$,c,g,y)}catch(l){b=l}finally{b&&g.errorTransformer&&(b=g.errorTransformer(b)),typeof b<"u"&&$.error(b),$.end()}}e.$Zp=O;async function R(C,S,$,c,g,y){k(y);const b=await C.open(S,{create:!1});try{k(y);let l=0,u=0,h=g&&typeof g.length=="number"?g.length:void 0,d=D.$ge.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),E=g&&typeof g.position=="number"?g.position:0,s=0;do u=await C.read(b,E,d.buffer,s,d.byteLength-s),E+=u,s+=u,l+=u,typeof h=="number"&&(h-=u),s===d.byteLength&&(await $.write(c(d)),d=D.$ge.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),s=0);while(u>0&&(typeof h!="number"||h>0)&&k(y)&&m(l,g));if(s>0){let o=s;typeof h=="number"&&(o=Math.min(s,h)),$.write(c(d.slice(0,o)))}}catch(l){throw(0,j.$zk)(l)}finally{await C.close(b)}}function k(C){if(C.isCancellationRequested)throw(0,N.$6)();return!0}function m(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,j.$yk)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[49],he([0,1,91,2,16,5,10,11]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=void 0;function k(l){return l.recursive===!0}e.$2p=k;class m extends N.$Sc{static{this.a=5}constructor(u,h,d,E){super(),this.h=u,this.j=h,this.m=d,this.n=E,this.c=this.B(new N.$Tc),this.f=void 0,this.g=0}s(){const u=new N.$Rc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(h=>this.h(h))),u.add(this.b.onDidLogMessage(h=>this.j(h))),u.add(this.b.onDidError(h=>this.t(h)))}t(u){this.n.restartOnError?this.g<m.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3p=m;class C extends m{constructor(u,h,d){super(u,h,d,{type:"node.js",restartOnError:!1})}}e.$4p=C;class S extends m{constructor(u,h,d){super(u,h,d,{type:"universal",restartOnError:!0})}}e.$5p=S;function $(l){return l.map(u=>({type:u.type,resource:O.URI.revive(u.resource),cId:u.cId}))}e.$6p=$;function c(l){const u=new b;for(const h of l)u.processEvent(h);return u.coalesce()}e.$7p=c;function g(l,u){return typeof u=="string"&&!u.startsWith(D.$Ej)&&!(0,L.$ic)(u)?{base:l,pattern:u}:u}e.$8p=g;function y(l,u){const h=[];for(const d of u)h.push((0,D.$Ij)(g(l,d)));return h}e.$9p=y;class b{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const h=this.b.get(this.c(u));let d=!1;if(h){const E=h.type,s=u.type;h.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?d=!0:E===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(h)):E===2&&s===1?h.type=0:E===1&&s===0||(h.type=s)}else d=!0;d&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],h=[];return Array.from(this.a).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,E)=>d.resource.fsPath.length-E.resource.fsPath.length).filter(d=>h.some(E=>(0,R.$Fk)(d.resource.fsPath,E,!j.$k))?!1:(h.push(d.resource.fsPath),!0)).concat(u)}}}),define(le[190],he([0,1,15,38,7,3,2,46,32,11,49]),function(ne,e,D,N,L,j,O,R,k,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=void 0,e.$VN="localFilesystem";class S extends O.$Sc{constructor(c,g){super(),this.a=c,this.b=g,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Sd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Sd),this.onDidWatchError=this.g.event,this.h=(0,k.$mg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,g){const{buffer:y}=await this.a.call("readFile",[c,g]);return y}readFileStream(c,g,y){const b=(0,R.$7d)(u=>D.$ge.concat(u.map(h=>D.$ge.wrap(h))).buffer),l=new O.$Rc;return l.add(this.a.listen("readFileStream",[c,g])(u=>{if(u instanceof D.$ge)b.write(u.buffer);else{if(u==="end")b.end();else{let h;if(u instanceof Error)h=u;else{const d=u;h=(0,m.$yk)(d.message??(0,N.$Mi)(d),d.code??m.FileSystemProviderErrorCode.Unknown)}b.error(h),b.end()}l.dispose()}})),l.add(y.onCancellationRequested(()=>{b.error((0,L.$6)()),b.end(),l.dispose()})),b}writeFile(c,g,y){return this.a.call("writeFile",[c,D.$ge.wrap(g),y])}open(c,g){return this.a.call("open",[c,g])}close(c){return this.a.call("close",[c])}async read(c,g,y,b,l){const[u,h]=await this.a.call("read",[c,g,l]);return y.set(u.buffer.slice(0,h),b),h}write(c,g,y,b,l){return this.a.call("write",[c,g,D.$ge.wrap(y),b,l])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,g){return this.a.call("delete",[c,g])}rename(c,g,y){return this.a.call("rename",[c,g,y])}copy(c,g,y){return this.a.call("copy",[c,g,y])}cloneFile(c,g){return this.a.call("cloneFile",[c,g])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const g=c;this.f.fire((0,C.$6p)(g))}else{const g=c;this.g.fire(g)}}))}watch(c,g){const y=(0,k.$mg)();return this.a.call("watch",[this.h,y,c,g]),(0,O.$Qc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$WN=S}),define(le[191],he([0,1,54,6,26,48,2,88,16,5,19,10,143,31,49]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class y extends O.$Sc{static{this.a=100}static{this.b=75}constructor(u,h,d,E){super(),this.m=u,this.n=h,this.r=d,this.s=E,this.c=this.B(new N.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new N.$dh(s=>this.z(s),y.b)),this.g=(0,g.$9p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$9p)(this.m.path,this.m.includes):void 0,this.j=new L.$3d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await c.Promises.stat(u);this.B(await this.w(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let h=u.path;try{h=await c.Promises.realpath(u.path),u.path===h&&(h=await(0,$.$gq)(u.path)??u.path),u.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async w(u,h){if(m.$j&&(0,j.$4f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Sc.None;const d=new L.$3d(this.j.token),E=new O.$Rc;try{const s=S.URI.file(this.m.path),o=(0,k.$nc)(u),n=(0,D.watch)(u);E.add((0,O.$Qc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const r of await c.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,O.$Qc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),m.$j&&(v=(0,R.$Bl)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,k.$jc)(u,v));if(d.token.isCancellationRequested)return;let p;f?i.has(v)?p=0:(p=1,i.add(v)):(i.delete(v),p=2),this.y({resource:(0,C.$Dg)(s,v),type:p,cId:this.m.correlationId})},y.a);t.set(v,(0,O.$Qc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$Dg)(s,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const f=await c.Promises.exists(u);d.token.isCancellationRequested||(f?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),E.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);E.clear(),E.add((0,O.$Qc)(()=>clearTimeout(w)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(u)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Qc)(()=>{d.dispose(!0),E.dispose()})}y(u,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const h=(0,g.$7p)(u);if(h.length>0){if(this.s)for(const E of h)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(m.$k)return c.Promises.exists(u);try{const h=(0,k.$nc)(u);return(await c.Promises.readdir((0,k.$mc)(u))).some(E=>E===h)}catch(h){return this.G(h),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$jq=y;async function b(l,u,h,d,E=512){const s=await c.Promises.open(l,"r"),o=Buffer.allocUnsafe(E),n=new L.$3d(d);let i,t=!1;const r={path:l,excludes:[],recursive:!1},a=new y(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await c.Promises.read(s,o,0,E,null);if(!f||n.token.isCancellationRequested)break;u(o.slice(0,f))}}catch(f){i=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(f){i=new Error(f)}i?w(i):v()})})}e.$kq=b}),define(le[192],he([0,1,3,91,2,5,191]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class R extends L.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(m){const C=this.j(m),S=C.filter(c=>{const g=this.c.get(c.path);return g?!(0,N.$Mj)(g.request.excludes,c.excludes)||!(0,N.$Mj)(g.request.includes,c.includes):!0}),$=Array.from(this.c.values()).filter(({request:c})=>!C.find(g=>g.path===c.path&&(0,N.$Mj)(g.excludes,c.excludes)&&(0,N.$Mj)(g.includes,c.includes))).map(({request:c})=>c.path);S.length&&this.m(`Request to start watching: ${S.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const c of $)this.h(c);for(const c of S)this.g(c)}g(m){const C=new O.$jq(m,$=>this.a.fire($),$=>this.b.fire($),this.f),S={request:m,instance:C};this.c.set(m.path,S)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const C=this.c.get(m);C&&(this.c.delete(m),C.instance.dispose())}j(m){const C=new Map;for(const S of m){const $=j.$k?S.path:S.path.toLowerCase();let c=C.get(S.correlationId);c||(c=new Map,C.set(S.correlationId,c)),c.set($,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(m){this.f=m;for(const[,C]of this.c)C.instance.setVerboseLogging(m)}m(m){this.f&&this.b.fire({type:"trace",message:this.n(m)})}n(m,C){return C?`[File Watcher (node.js)] ${m} (path: ${C.request.path})`:`[File Watcher (node.js)] ${m}`}}e.$lq=R}),define(le[193],he([0,1,49,192]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class L extends D.$4p{constructor(O,R,k){super(O,R,k),this.s()}r(O){return O.add(new N.$lq)}}e.$mq=L}),define(le[194],he([0,1,23,40,93,49]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class O extends j.$5p{constructor(k,m,C){super(k,m,C),this.s()}r(k){const m=k.add(new L.$dq(D.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(m.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),N.ProxyChannel.toService((0,N.$Ih)(m.getChannel("watcher")))}}e.$eq=O}),define(le[73],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class D{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Zh=D}),define(le[195],he([0,1,6,7,2,71,186,4,73,87]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;const C=!1;class S extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class ${constructor(b=new k.$Zh,l=!1,u,h=C){this.f=b,this.g=l,this.h=u,this.i=h,this.o=new Set,this.f.set(R.$1h,this),this._globalGraph=h?u?._globalGraph??new O.$pq(d=>d):void 0}createChild(b){return new $(b,this.g,this,this.i)}invokeFunction(b,...l){const u=g.traceInvocation(this.i,b);let h=!1;try{return b({get:E=>{if(h)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(E,u);if(!s)throw new Error(`[invokeFunction] unknown service '${E}'`);return s}},...l)}finally{h=!0,u.stop()}}createInstance(b,...l){let u,h;return b instanceof j.$Yh?(u=g.traceCreation(this.i,b.ctor),h=this.j(b.ctor,b.staticArguments.concat(l),u)):(u=g.traceCreation(this.i,b),h=this.j(b,l,u)),u.stop(),h}j(b,l=[],u){const h=R._util.getServiceDependencies(b).sort((s,o)=>s.index-o.index),d=[];for(const s of h){const o=this.m(s.id,u);o||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(o)}const E=h.length>0?h[0].index:l.length;if(l.length!==E){console.trace(`[createInstance] First service dependency of ${b.name} at position ${E+1} conflicts with ${l.length} static arguments`);const s=E-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,E)}return Reflect.construct(b,l.concat(d))}k(b,l){if(this.f.get(b)instanceof j.$Yh)this.f.set(b,l);else if(this.h)this.h.k(b,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const l=this.f.get(b);return!l&&this.h?this.h.l(b):l}m(b,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const u=this.l(b);return u instanceof j.$Yh?this.q(b,u,l.branch(b,!0)):(l.branch(b,!1),u)}q(b,l,u){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,l,u)}finally{this.o.delete(b)}}r(b,l,u){const h=new O.$pq(s=>s.id.toString());let d=0;const E=[{id:b,desc:l,_trace:u}];for(;E.length;){const s=E.pop();if(h.lookupOrInsertNode(s),d++>1e3)throw new S(h);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${b} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof j.$Yh){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};h.insertEdge(s,i),E.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new S(h);break}for(const{data:o}of s){if(this.l(o.id)instanceof j.$Yh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(b)}s(b,l,u=[],h,d){if(this.f.get(b)instanceof j.$Yh)return this.t(b,l,u,h,d);if(this.h)return this.h.s(b,l,u,h,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(b,l,u=[],h,d){if(h){const E=new $(void 0,this.g,this,this.i);E.c=String(b);const s=new Map,o=new D.$ih(()=>{const n=E.j(l,u,d);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new m.$3c,s.set(i,a)),(w,f,p)=>{const I=a.push([w,f,p]);return(0,L.$Qc)(I)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,d)}u(b,l){if(l&&console.warn(b),this.g)throw new Error(b)}}e.$qq=$;var c;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(c||(c={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,l){return b?new g(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(b,l){return b?new g(1,l.name):g.c}static{this.f=0}constructor(b,l){this.type=b,this.name=l,this.g=Date.now(),this.h=[]}branch(b,l){const u=new g(3,b.toString());return this.h.push([b,l,u]),u}stop(){const b=Date.now()-this.g;g.f+=b;let l=!1;function u(d,E){const s=[],o=new Array(d+1).join("	");for(const[n,i,t]of E.h)if(i&&t){l=!0,s.push(`${o}CREATES -> ${n}`);const r=u(d+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(b>2||l)&&g.all.add(h.join(`
`))}}e.$rq=g}),define(le[56],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=e.$d$b=void 0,e.$d$b=(0,D.$2h)("mainProcessService");class N{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$e$b=N}),define(le[74],he([0,1,26,2,5,162,29,4]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$5q=k,e.$6q=(0,R.$2h)("languagePackService");let m=class extends N.$Sc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new D.$3d;setTimeout(()=>S.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const g=$.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(b=>b.startsWith("lp-"))).map(y=>{const b=y.properties.localizedLanguages?.[0],l=k(y);return{...this.f(l,b,y),extensionId:y.identifier.id,galleryExtension:y}});return g.push(this.f("en","English")),g}f(S,$,c){const g=$??S;let y;if(g!==S&&(y=`(${S})`),S.toLowerCase()===L.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),c?.installCount){y??="";const b=c.installCount;let l;b>1e6?l=`${Math.floor(b/1e5)/10}M`:b>1e3?l=`${Math.floor(b/1e3)}K`:l=String(b),y+=` $(cloud-download) ${l}`}return{id:S,label:g,description:y}}};e.$7q=m,e.$7q=m=pe([X(0,O.$ko)],m)}),define(le[196],he([0,1,2,74]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;let L=class extends D.$Sc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$C$b=L,e.$C$b=L=pe([X(0,N.$6q)],L)}),define(le[8],he([0,1,38,3,53,2,34,5,19,12,10,94,4]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,$.$2h)("logService"),e.$kj=(0,$.$2h)("loggerService");function c(){return new Date().toISOString()}function g(w){return(0,m.$If)(w)}e.$lj=g;var y;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$mj=y.Info;function b(w,f,p){switch(f){case y.Trace:w.trace(p);break;case y.Debug:w.debug(p);break;case y.Info:w.info(p);break;case y.Warning:w.warn(p);break;case y.Error:w.error(p);break;case y.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=b;function l(w,f=!1){let p="";for(let I=0;I<w.length;I++){let F=w[I];if(F instanceof Error&&(F=(0,D.$Mi)(F,f)),typeof F=="object")try{F=JSON.stringify(F)}catch{}p+=(I>0?" ":"")+F}return p}class u extends j.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new N.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==y.Off&&this.b<=f}}e.$oj=u;class h extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...p){this.f(y.Trace)&&this.g(y.Trace,l([f,...p],!0))}debug(f,...p){this.f(y.Debug)&&this.g(y.Debug,l([f,...p]))}info(f,...p){this.f(y.Info)&&this.g(y.Info,l([f,...p]))}warn(f,...p){this.f(y.Warning)&&this.g(y.Warning,l([f,...p]))}error(f,...p){if(this.f(y.Error))if(f instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=f.stack,this.g(y.Error,l(I))}else this.g(y.Error,l([f,...p]))}flush(){}}e.$pj=h;class d extends u{constructor(f=e.$mj){super(),this.setLevel(f),this.g=!R.$i}trace(f,...p){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...p):console.log(`[main ${c()}]`,f,...p))}debug(f,...p){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...p):console.log(`[main ${c()}]`,f,...p))}info(f,...p){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...p):console.log(`[main ${c()}]`,f,...p))}warn(f,...p){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...p):console.warn(`[main ${c()}]`,f,...p))}error(f,...p){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...p):console.error(`[main ${c()}]`,f,...p))}dispose(){}flush(){}}e.$qj=d;class E extends u{constructor(f=e.$mj,p=!0){super(),this.g=p,this.setLevel(f)}trace(f,...p){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...p):console.log(f,...p))}debug(f,...p){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...p):console.log(f,...p))}info(f,...p){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...p):console.log(f,...p))}warn(f,...p){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...p):console.log(f,...p))}error(f,...p){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...p):console.error(f,...p))}dispose(){}flush(){}}e.$rj=E;class s extends u{constructor(f,p=e.$mj){super(),this.g=f,this.setLevel(p)}trace(f,...p){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(f),...p])}debug(f,...p){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(f),...p])}info(f,...p){this.f(y.Info)&&this.g.log(y.Info,[this.h(f),...p])}warn(f,...p){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(f),...p])}error(f,...p){this.f(y.Error)&&this.g.log(y.Error,[this.h(f),...p])}h(f){return typeof f=="string"?f:(0,D.$Mi)(f,this.f(y.Trace))}dispose(){}flush(){}}e.$sj=s;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const p of this.g)p.setLevel(f);super.setLevel(f)}trace(f,...p){for(const I of this.g)I.trace(f,...p)}debug(f,...p){for(const I of this.g)I.debug(f,...p)}info(f,...p){for(const I of this.g)I.info(f,...p)}warn(f,...p){for(const I of this.g)I.warn(f,...p)}error(f,...p){for(const I of this.g)I.error(f,...p)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$tj=o;class n extends j.$Sc{constructor(f,p,I){if(super(),this.h=f,this.j=p,this.b=new O.$Ac,this.c=this.B(new N.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeVisibility=this.g.event,I)for(const F of I)this.b.set(F.resource,{logger:void 0,info:F})}m(f){return(0,m.$Ef)(f)?[...this.b.values()].find(p=>p.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,p){const I=this.n(f),F=(0,m.$Ef)(f)?f:p?.id??(0,L.$Pi)(I.toString()).toString(16);let M=this.b.get(I)?.logger;const T=p?.logLevel==="always"?y.Trace:p?.logLevel;M||(M=this.s(I,T??this.getLogLevel(I)??this.h,{...p,id:F}));const z={logger:M,info:{resource:I,id:F,logLevel:T,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(z.info),this.b.set(I,z),M}n(f){return(0,m.$Ef)(f)?(0,k.$Dg)(this.j,`${f}.log`):f}setLogLevel(f,p){if(C.URI.isUri(f)){const I=f,F=p,M=this.b.get(I);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([I,F]))}else{this.h=f;for(const[I,F]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,p){const I=this.m(f);I&&p!==!I.info.hidden&&(I.info.hidden=!p,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,p]))}getLogLevel(f){let p;return f&&(p=this.b.get(f)?.info.logLevel),p??this.h}registerLogger(f){const p=this.b.get(f.resource);p?p.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const p=this.b.get(f);p&&(p.logger&&p.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=n;class i{constructor(){this.onDidChangeLogLevel=new N.$Sd().event}setLevel(f){}getLevel(){return y.Info}trace(f,...p){}debug(f,...p){}info(f,...p){}warn(f,...p){}error(f,...p){}critical(f,...p){}dispose(){}flush(){}}e.$vj=i;class t extends i{}e.$wj=t;function r(w){if(w.verbose)return y.Trace;if(typeof w.logLevel=="string"){const f=v(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.$mj}e.$xj=r;function a(w){switch(w){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$yj=a;function v(w){switch(w){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$zj=v,e.$Aj=new S.$gj("logLevel",a(y.Info))}),define(le[197],he([0,1,6,7,2,23,16,19,31,14,8]),function(ne,e,D,N,L,j,O,R,k,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=void 0;let S=class extends L.$Sc{constructor(c,g){super(),this.a=c,this.b=g,this.B(new D.$bh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.$Ag)(this.a.logsHome),g=(0,R.$Cg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await k.Promises.readdir(g)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==c),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>k.Promises.rm((0,O.$jc)(g,h)))))}catch(c){(0,N.$1)(c)}}};e.$D$b=S,e.$D$b=S=pe([X(0,m.$9h),X(1,C.$jj)],S)}),define(le[198],he([0,1,18,6,7,3,2,16,49,8]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class C extends O.$Sc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new j.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Zg(0)),this.w=[],this.y=this.B(new N.$Zg(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},y=(0,D.$Ub)(this.j,g);return this.r(),(0,O.$Qc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$1)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,k.$6p)(c)),c=>this.G(c),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,k.$2p)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,k.$2p)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},y=(0,D.$Ub)(this.w,g);return this.C(),(0,O.$Qc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,k.$6p)($)),$=>this.G($),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,R.$hc)($.fsPath)}}e.$0p=C}),define(le[199],he([0,1,18,6,15,26,3,53,61,2,47,23,100,19,46,158,11,99,8,7]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;let E=class extends m.$Sc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Sd),this.Y=this.B(new O.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$$g)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const i=new m.$Rc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new b.$Ek(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,m.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,m.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(i){n.push(i)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,c.$Hg)(o))throw new b.$Gk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const i=new h.$bb;throw i.message=(0,y.localize)(1,null,o.toString()),i}return n}async m(o){const n=await this.j(o);if((0,b.$rk)(n)||(0,b.$ok)(n)||(0,b.$sk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,b.$rk)(n)||(0,b.$ok)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(i){throw(0,b.$Bk)(i)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Gk((0,y.localize)(2,null,this.sb(o)),1):(0,b.$zk)(i)}}async s(o,n){const i=await this.j(o),t=this.S(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await i.stat(o);let f;return this.t(i,o,w,void 0,!!v,(p,I)=>(f||(f=C.$8h.forUris(()=>!t),f.set(o,!0),r&&f.fill(!0,r)),f.get(p.resource)||f.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?I===1:!1))}async t(o,n,i,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:n,name:v.basename(n),isFile:(i.type&b.FileType.File)!==0,isDirectory:(i.type&b.FileType.Directory)!==0,isSymbolicLink:(i.type&b.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&b.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Rk)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const f=await o.readdir(n),p=await N.Promises.settled(f.map(async([I,F])=>{try{const M=v.joinPath(n,I),T=r?await o.stat(M):{type:F};return await this.t(o,M,T,f.length,r,a)}catch(M){return this.b.trace(M),null}}));w.children=(0,D.$Hb)(p)}catch(f){this.b.trace(f),w.children=[]}return w}return w}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),i=await n.stat(o);return this.t(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(i){return i}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new b.$Gk((0,y.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$ge.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,n);return this.r.fire(new b.$Dk(o,0,t)),t}async writeFile(o,n,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,b.$uk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,b.$ok)(t)&&!(n instanceof L.$ge))if((0,g.$5d)(n)){const f=await(0,g.$_d)(n,3);f.ended?w=L.$ge.concat(f.buffer):w=f}else w=(0,g.$9d)(n,f=>L.$ge.concat(f),3);else w=n;!(0,b.$rk)(t)||(0,b.$ok)(t)&&w instanceof L.$ge||(0,b.$ok)(t)&&(0,b.$uk)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof L.$ge?(0,L.$re)(w):w),this.r.fire(new b.$Dk(o,4))}catch(v){throw new b.$Gk((0,y.localize)(4,null,this.sb(o),(0,b.$zk)(v).toString()),(0,b.$Ck)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(n)));if(t)throw new Error((0,y.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&b.FileType.Directory)throw new b.$Gk((0,y.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==b.$Qk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,b.$Rk)({mtime:i.mtime,size:a.size}))throw new b.$Gk((0,y.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.m(o);return n?.atomic?this.z(t,o,n,i):this.C(t,o,n,i)}async z(o,n,i,t){return new Promise((r,a)=>{this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,n,i,t);r(v)}catch(v){a(v)}})})}async C(o,n,i,t){const r=await this.D(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$se)(r.value)}}async readFileStream(o,n,i){const t=await this.m(o);return this.D(t,o,n,i)}async D(o,n,i,t){const r=new j.$3d(t);let a=i;(0,b.$tk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const v=this.J(n,a).then(f=>f,f=>{throw r.dispose(!0),f});let w;try{return typeof a?.etag=="string"&&a.etag!==b.$Qk&&await v,a?.atomic&&(0,b.$tk)(o)||!((0,b.$rk)(o)||(0,b.$sk)(o))||(0,b.$ok)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,b.$sk)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(f){throw w&&await(0,g.$0d)(w),this.F(f,n,a)}}F(o,n,i){const t=(0,y.localize)(11,null,this.sb(n),(0,b.$zk)(o).toString());return o instanceof b.$Ik?new b.$Ik(t,o.stat,i):o instanceof b.$Hk?new b.$Hk(t,o.fileOperationResult,o.size,o.options):new b.$Gk(t,(0,b.$Ck)(o),i)}G(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,g.$de)(r,{data:a=>a instanceof L.$ge?a:L.$ge.wrap(a),error:a=>this.F(a,n,t)},a=>L.$ge.concat(a))}H(o,n,i,t=Object.create(null)){const r=(0,L.$we)();return(0,l.$Zp)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},i),r}I(o,n,i){const t=(0,g.$7d)(r=>L.$ge.concat(r));return(async()=>{try{let r;i?.atomic&&(0,b.$tk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$ge.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new b.$Gk((0,y.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==b.$Qk&&n.etag===i.etag)throw new b.$Ik((0,y.localize)(13,null),i,n);return this.L(o,i.size,n),i}L(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new b.$Hk((0,y.localize)(14,null,this.sb(o)),7,n,i)}async canMove(o,n,i){return this.M(o,n,"move",i)}async canCopy(o,n,i){return this.M(o,n,"copy",i)}async M(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$Dk(o,a==="move"?2:3,v)),v}async copy(o,n,i){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$Dk(o,a==="copy"?3:2,v)),v}async N(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,i,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,b.$pk)(o))await o.copy(n,t,{overwrite:a});else{const f=await this.resolve(n);f.isDirectory?await this.P(o,f,i,t):await this.O(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,i,t){if((0,b.$rk)(o)&&(0,b.$rk)(i))return this.jb(o,n,i,t);if((0,b.$rk)(o)&&(0,b.$ok)(i))return this.pb(o,n,i,t);if((0,b.$ok)(o)&&(0,b.$rk)(i))return this.nb(o,n,i,t);if((0,b.$ok)(o)&&(0,b.$ok)(i))return this.lb(o,n,i,t)}async P(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,n,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:f,isPathCaseSensitive:p}=this.R(o);if(p||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new b.$Gk((0,y.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===i){const{providerExtUri:f}=this.R(o);if(f.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?c.$tg:c.$vg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$Dk(o,0,i)),i}async U(o,n){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&b.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(n)));break}catch(r){if((0,b.$Bk)(r)!==b.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,b.$Bk)(a)!==b.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(i){return i}return!0}async W(o,n){const i=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new b.$Gk((0,y.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,n){const i=await this.W(o,n);let t=n;if((0,b.$vk)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new b.$Dk(o,1))}async cloneFile(o,n){const i=await this.j(o),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,b.$qk)(i))return i.cloneFile(o,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,b.$pk)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.O(i,o,t,n))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:d.ab++})}watch(o,n={recursive:!1,excludes:[]}){const i=new m.$Rc;let t=!1,r=()=>{t=!0};i.add((0,m.$Qc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,m.$Nc)(v):r=()=>(0,m.$Nc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=i.add(new O.$Sd);return i.add(this.X.event(f=>{f.correlates(a)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,n){const i=await this.j(o),t=(0,R.$Pi)([this.R(i).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,m.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,m.$Nc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,m.$Nc)(o.disposable);this.$.clear()}async db(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,g.$5d)(t)||(0,g.$6d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,b.$zk)(a)}finally{await o.close(r)}})}async eb(o,n,i){let t=0,r;if((0,g.$6d)(i)){if(i.buffer.length>0){const a=L.$ge.concat(i.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,g.$$d)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(f){return v(f)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,i,t,r,a){let v=0;for(;v<t;){const w=await o.write(n,r+v,i.buffer,a+v,t-v);v+=w}}async hb(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(()=>this.ib(o,n,i,t))}async ib(o,n,i,t){let r;t instanceof L.$ge?r=t:(0,g.$5d)(t)?r=await(0,L.$se)(t):(0,g.$6d)(t)?r=await(0,L.$te)(t):r=(0,L.$qe)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,n,i,t))}async kb(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=L.$ge.alloc(this.a);let w=0,f=0,p=0;do p=await o.read(r,w,v.buffer,f,v.byteLength-f),await this.gb(i,a,v,p,w,f),w+=p,f+=p,f===v.byteLength&&(f=0);while(p>0)}catch(v){throw(0,b.$zk)(v)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,n,i,t))}async mb(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,n,i,t))}async ob(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(i,r,L.$ge.wrap(a),a.byteLength,0,0)}catch(a){throw(0,b.$zk)(a)}finally{await i.close(r)}}async pb(o,n,i,t){const r=await(0,L.$se)(this.H(o,n,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new b.$Gk((0,y.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&b.FilePermission.Readonly)throw new b.$Gk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$1p=E,e.$1p=E=d=pe([X(0,u.$jj)],E)}),define(le[200],he([0,1,54,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,198,38,194,193]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Mi)(o)}`)}})();class s extends u.$0p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new j.$Ac(t=>$.$ug.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:b.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,$.$Dg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=b.FileType.Unknown:n.isFile()?t=b.FileType.File:n.isDirectory()?t=b.FileType.Directory:t=b.FileType.Unknown,i&&(t|=b.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$1g;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$7d)(a=>O.$ge.concat(a.map(v=>O.$ge.wrap(v))).buffer);return(0,l.$Zp)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,$.$Dg)((0,$.$Cg)(n),`${(0,$.$Ag)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await g.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const a=new m.$Rc;try{a.add(await this.O(n)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,i,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(v)){if(!t.overwrite)throw(0,b.$yk)((0,y.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,b.$yk)((0,y.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let a;(0,b.$mk)(i)&&!t&&(a=await this.O(n));let v;try{if((0,b.$mk)(i)&&i.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(r);f.mode&128||await g.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let w;if((0,b.$mk)(i)){if(S.$i)try{await g.Promises.truncate(r,0),w="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}w||(w="w")}else w="r";v=await g.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,b.$mk)(i)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,b.$mk)(i)&&this.X.set(v,n),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await g.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await g.Promises.read(n,t,r,a,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,w)}return w}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,a){return(0,L.$jh)(()=>this.ab(n,i,t,r,a),100,3)}async ab(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await g.Promises.write(n,t,r,a,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${i.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await g.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"move",t.overwrite),await g.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"copy",t.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const a=this.H(n),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$3f)(a,v,!0)),w){if(t==="copy")throw(0,b.$yk)((0,y.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,b.$yk)((0,y.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(i);if(I){if(!r)throw(0,b.$yk)((0,y.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);p.type&b.FileType.File&&I.type&b.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),a=this.H(i),v=!!(this.capabilities&1024);if((0,k.$3f)(r,a,!v))return;const w=new m.$Rc;try{w.add(await this.O(n)),w.add(await this.O(i)),t&&await g.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(f)}finally{w.dispose()}}t(n,i,t){return new d.$eq(r=>n(r),r=>i(r),t)}F(n,i,t){return new E.$mq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof b.$xk)return n;let i=n,t;switch(n.code){case"ENOENT":t=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=b.FileSystemProviderErrorCode.Unknown;break;default:t=b.FileSystemProviderErrorCode.Unknown}return(0,b.$yk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,b.$yk)(i,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$nq=s}),define(le[101],he([0,1,3,2,4,8]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=void 0,e.$6$b=(0,L.$2h)("sharedProcessLifecycleService");let O=class extends N.$Sc{constructor(k){super(),this.b=k,this.a=this.B(new D.$Sd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$7$b=O,e.$7$b=O=pe([X(0,j.$jj)],O)}),define(le[201],he([0,1,10,3,8,2]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=void 0;class O extends L.$uj{constructor(S,$,c,g,y){super($,c,g),this.r=S,this.t=y,this.B(y.listen("onDidChangeLogLevel",S)(b=>{(0,L.$lj)(b)?super.setLogLevel(b):super.setLogLevel(D.URI.revive(b[0]),b[1])})),this.B(y.listen("onDidChangeVisibility",S)(([b,l])=>super.setVisibility(D.URI.revive(b),l))),this.B(y.listen("onDidChangeLoggers",S)(({added:b,removed:l})=>{for(const u of b)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$sj({log:(S,$)=>{this.t.call("consoleLog",[S,$])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,$){super.setLogLevel(S,$),this.t.call("setLogLevel",[S,$])}setVisibility(S,$){super.setVisibility(S,$),this.t.call("setVisibility",[this.n(S),$])}s(S,$,c){return new R(this.t,S,$,c,this.r)}static setLogLevel(S,$,c){return S.call("setLogLevel",[$,c])}}e.$lr=O;class R extends L.$pj{constructor(S,$,c,g,y){super(g?.logLevel==="always"),this.r=S,this.s=$,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[$,g,y]).then(()=>{this.u(this.n),this.m=!0})}g(S,$){const c=[[S,$]];this.m?this.u(c):this.n.push(...c)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,$){this.a=S,this.b=$}listen(S,$){const c=this.b(S);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(y=>this.c(y,c)),removed:[...g.removed].map(y=>this.c(y,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[c.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,L.$lj)(g)?g:[c.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${$}`)}async call(S,$,c){const g=this.b(S);switch($){case"setLogLevel":return(0,L.$lj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,g)))}throw new Error(`Call not found: ${$}`)}c(S,$){return{...S,resource:$.transformOutgoingURI(S.resource)}}}e.$mr=k;class m extends j.$Sc{constructor(S,$){super(),$.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(c=>$.call("setLogLevel",[c]))),$.call("getRegisteredLoggers").then(c=>{for(const g of c)S.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B($.listen("onDidChangeVisibility")(([c,g])=>S.setVisibility(D.URI.revive(c),g))),this.B($.listen("onDidChangeLoggers")(({added:c,removed:g})=>{for(const y of c)S.registerLogger({...y,resource:D.URI.revive(y.resource)});for(const y of g)S.deregisterLogger(y.resource)}))}}e.$nr=m}),define(le[202],he([0,1,2,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;class L extends D.$Sc{constructor(O,R=[]){super(),this.a=new N.$tj([O,...R]),this.B(O.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$bO=L}),define(le[57],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=void 0,e.$29b=(0,D.$2h)("nativeHostService")}),define(le[203],he([0,1,40,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=void 0;let L=class{constructor(O,R){return this.windowId=O,D.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const k=new Map;return k.set("windowId",O),k})()})}};e.$j$b=L,e.$j$b=L=pe([X(1,N.$d$b)],L)}),define(le[58],he([0,1,3,61,2,4]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0,e.$vn=(0,j.$2h)("policy");class O extends L.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const C=Object.keys(this.f).length;return this.f={...m,...this.f},C!==Object.keys(this.f).length&&await this.j(m),N.Iterable.reduce(this.g.entries(),(S,[$,c])=>({...S,[$]:c}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(m,[C,S])=>({...m,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$wn=O;class R{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$xn=R}),define(le[204],he([0,1,3,2,58]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=void 0;class j{constructor(k){this.b=k,this.a=new N.$Rc}listen(k,m){switch(m){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((S,$)=>({...S,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(k,m,C){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.$L0b=j;class O extends L.$wn{constructor(k,m){super(),this.a=m;for(const C in k){const{definition:S,value:$}=k[C];this.f[C]=S,$!==void 0&&this.g.set(C,$)}this.a.listen("onDidChange")(C=>{for(const S in C){const $=C[S];$===null?this.g.delete(S):this.g.set(S,$)}this.h.fire(Object.keys(C))})}async j(k){const m=await this.a.call("updatePolicyDefinitions",k);for(const C in m)this.g.set(C,m[C])}}e.$M0b=O}),define(le[102],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[25],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,D.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"}),define(le[205],he([0,1,6,7,2,16,31,8,25]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=void 0;let m=class extends L.$Sc{constructor(S,$,c){super(),this.b=$,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new D.$bh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),c=(0,j.$mc)(S),g=(0,j.$nc)(S),y=await O.Promises.readdir(c);await Promise.all(y.map(async b=>{if(b===g)return;const l=(0,j.$jc)(c,b),u=await O.Promises.stat(l);if(u.isDirectory()&&$-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${b}.`),O.Promises.rm(l)}))}catch($){(0,N.$1)($)}}};e.$A$b=m,e.$A$b=m=pe([X(1,k.$Bj),X(2,R.$jj)],m)}),define(le[206],he([0,1,6,7,2,16,31,14,8,25]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=void 0;let C=class extends L.$Sc{constructor($,c,g){super(),this.b=$,this.c=c,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$bh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,j.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(c)){const h=c[u];$[`${h.hash}.${u}`]=!0}const g=(0,j.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const b=await O.Promises.readdir(g);for(const u of b){if($[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$jc)(g,u))}const l=Date.now();for(const u of Object.keys($)){const h=(0,j.$jc)(g,u),d=await O.Promises.readdir(h);for(const E of d){if(E==="tcf.json")continue;const s=(0,j.$jc)(h,E),o=await O.Promises.stat(s);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$jc)(u,E)}`),await O.Promises.rm(s))}}}catch($){(0,N.$1)($)}}};e.$B$b=C,e.$B$b=C=pe([X(0,R.$0h),X(1,k.$jj),X(2,m.$Bj)],C)}),define(le[207],he([0,1,16,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$3E=void 0,e.$3E=(0,N.$2h)("IV8InspectProfilingService");var L;(function(j){function O(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=O;function R(k,m="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,D.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.$jc)(m,(0,D.$nc)(C.callFrame.url)));return k}j.rewriteAbsolutePaths=R})(L||(e.Utils=L={}))}),define(le[208],he([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((m,C)=>{ne(["v8-inspect-profiler"],m,C)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,D.$mg)();return this.a.set(k,R),k}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const R=await O.stop();return this.a.delete(j),R.profile}}e.$V$b=N}),define(le[41],he([0,1,126,12]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0;class L{constructor(){this.a=new Map}add(O,R){D.ok(N.$Ef(O)),D.ok(N.$Gf(R)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$tn=new L}),define(le[103],he([0,1,3,41]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,m){this.a[L(k)]=m,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;N.$tn.add(e.$un.JSONContribution,O)}),define(le[50],he([0,1,18,3,12,148,20,103,41]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.ConfigurationScope=e.$yn=e.EditPresentationTypes=void 0;var m;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.$yn={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn="vscode://schemas/settings/resourceLanguage",e.$Gn="vscode://schemas/settings/configurationDefaults";const S=k.$tn.as(R.$un.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$Sd,this.onDidSchemaChange=this.i.event,this.j=new N.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Fn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.n(s,o,n),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.o(s,o),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.o(o,n),this.n(s,!1,n),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.$In.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const I of Object.keys(i[r]))v.set(I,t);const w={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const f=(0,O.$Fi)(r),p={type:"object",default:w,description:j.localize(1,null,f),$ref:e.$Fn,defaultDefaultValue:w,source:L.$Ef(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),a=L.$Ef(i)?i:i?.id,v=L.$Ef(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$In.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,n){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,o=!0,n,i,t=3,r){t=L.$Nf(s.scope)?t:s.scope;const a=s.properties;if(a)for(const w in a){const f=a[w];if(o&&h(w,f)){delete a[w];continue}if(f.source=n,f.defaultDefaultValue=a[w].default,this.w(w,f),e.$In.test(w)?f.scope=void 0:(f.scope=L.$Nf(f.scope)?t:f.scope,f.restricted=L.$Nf(f.restricted)?!!i?.includes(w):f.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=s.allOf;if(v)for(const w of v)this.p(w,o,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$zn.properties[s]=o,o.scope){case 1:e.$An.properties[s]=o;break;case 2:e.$Bn.properties[s]=o;break;case 6:e.$Cn.properties[s]=o;break;case 3:e.$Dn.properties[s]=o;break;case 4:e.$En.properties[s]=o;break;case 5:e.$En.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$zn.properties[s],o.scope){case 1:delete e.$An.properties[s];break;case 2:delete e.$Bn.properties[s];break;case 6:delete e.$Cn.properties[s];break;case 3:delete e.$Dn.properties[s];break;case 4:case 5:delete e.$En.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$Fn};this.w(o,n),e.$zn.properties[o]=n,e.$An.properties[o]=n,e.$Bn.properties[o]=n,e.$Cn.properties[o]=n,e.$Dn.properties[o]=n,e.$En.properties[o]=n}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$Fn};e.$zn.patternProperties[e.$Hn]=s,e.$An.patternProperties[e.$Hn]=s,e.$Bn.patternProperties[e.$Hn]=s,e.$Cn.patternProperties[e.$Hn]=s,e.$Dn.patternProperties[e.$Hn]=s,e.$En.patternProperties[e.$Hn]=s,this.i.fire()}w(s,o){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Lf(i)&&(i=o.defaultDefaultValue,t=void 0),L.$Lf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.$Hn=`^(${c})+$`,e.$In=new RegExp(e.$Hn);function y(E){const s=[];if(e.$In.test(E)){let o=g.exec(E);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=g.exec(E)}}return(0,D.$Mb)(s)}e.$Jn=y;function b(E){return E.reduce((s,o)=>`${s}[${o}]`,"")}e.$Kn=b;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Ln=l;const u=new $;k.$tn.add(e.$yn.Configuration,u);function h(E,s){return E.trim()?e.$In.test(E)?j.localize(7,null,E):u.getConfigurationProperties()[E]!==void 0?j.localize(8,null,E):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,E,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$Mn=h;function d(){const E=[],s=u.getConfigurationProperties();for(const o of Object.keys(s))E.push([o,s[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$Nn=d}),define(le[75],he([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0;function c(o){return Object.isFrozen(o)?o:R.$in(o)}class g{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof g)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Di)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$Di)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Mb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Mb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$hn(this.contents),t=R.$hn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[f]=t.filter(p=>D.$ub(p.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=D.$Mb(f.keys)):t.push(R.$hn(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new g(i,r,t,a.every(v=>v instanceof g)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$hn(a),this.h(a,v)):a=v),t[r]=a}return new g(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&k.$Gf(n[t])&&k.$Gf(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$hn(i[t])}}i(n){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$hn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$Ci)(this.contents,n),S.$In.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$ub(t.identifiers,(0,S.$Jn)(n))),1))}j(n,i,t){(0,C.$Bi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$In.test(n)&&this.overrides.push({identifiers:(0,S.$Jn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ai)(this.contents[n],r=>console.error(r))})}}e.$On=g;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!k.$Nf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(n,i);this.b=new g(t,r,a,w?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const a=[],v=[];function w(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const f={onObjectBegin:()=>{const p={};w(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];w(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(p,I,F)=>{v.push({error:p,offset:I,length:F})}};if(n)try{L.$en(n,f),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return i}h(n,i){const t=$.$tn.as(S.$yn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const a=(0,C.$Ai)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),w=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const f in n)if(S.$In.test(f)&&t){const p=this.i(n[f],i,!1,r);v[f]=p.raw,a=a||p.hasExcludedProperties,w.push(...p.restricted)}else{const p=i[f],I=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&w.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&!(r.skipRestricted&&p?.restricted))?v[f]=n[f]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(n,i){const t=[];for(const r of Object.keys(n))if(S.$In.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,S.$Jn)(r),keys:Object.keys(a),contents:(0,C.$Ai)(a,i)})}return t}}e.$Pn=y;class b extends j.$Sc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new N.$Sd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qn=b;class l{constructor(n,i,t,r,a,v,w,f,p,I,F,M,T){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=f,this.i=p,this.j=I,this.k=F,this.l=M,this.m=T}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,a=new g,v=new g,w=new O.$Ac,f=new g,p=new O.$Ac){this.c=n,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=f,this.m=p,this.a=null,this.b=new O.$Ac,this.n=null}getValue(n,i,t){return this.p(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.p(n,i,t),a=this.t(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const f of r.overrides)for(const p of f.identifiers)r.getOverrideValue(n,p)!==void 0&&w.add(p);return new l(n,i,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const i=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,n);i=[...r,...a,...v]}for(const r of i)for(const a of(0,S.$Jn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),f=[...w.filter(p=>v.indexOf(p)===-1),...v.filter(p=>w.indexOf(p)===-1),...v.filter(p=>!R.$ln(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,f])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=E(this.d,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:w}=E(t,i),f=[...r,...a,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,i),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,i,t){let r=this.q(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},i){let t=this.r();if(i&&n){const r=i.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let i=this.b.get(n);if(!i){const t=this.r(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}t(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),w=n.folders.reduce((f,p)=>(f.set(m.URI.revive(p[0]),this.w(p[1])),f),new O.$Ac);return new u(i,t,r,a,new g,v,w,new g,new O.$Ac)}static w(n){return new g(n.contents,n.keys,n.overrides)}}e.$Rn=u;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,O.$xc)(i,a,new Set);v.forEach(f=>w.add(f))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Sn=h;class d{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,f=this.g.getValue(n,i,this.h);return!R.$ln(w,f)}return!0}}e.$Tn=d;function E(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const f=w.filter(p=>!v.includes(p));for(const p of f)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(o){const f=v.filter(p=>!w.includes(p));for(const p of f)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(n&&o){for(const f of v)if(w.includes(f)){const p=s({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...p.added,...p.removed,...p.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$Di)(n.contents,a),w=(0,C.$Di)(o.contents,a);R.$ln(v,w)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(le[209],he([0,1,18,3,2,30,12,75,50,8,58,41]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=void 0;class $ extends L.$Sc{constructor(){super(...arguments),this.a=this.B(new N.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$On}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$tn.as(k.$yn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:l})=>this.c(Array.from(b),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,l){this.h(b,S.$tn.as(k.$yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new R.$On;const b=S.$tn.as(k.$yn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,l){const u=this.f();for(const h of b){const d=u[h],E=l[h];d!==void 0?this.b.addValue(h,d):E?this.b.addValue(h,E.default):this.b.removeValue(h)}}}e.$Un=$;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$On}async initialize(){return this.configurationModel}}e.$Vn=c;let g=class extends L.$Sc{get configurationModel(){return this.b}constructor(b,l,u){super(),this.c=b,this.f=l,this.g=u,this.a=this.B(new N.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$On}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const l={},u=[],h=S.$tn.as(k.$yn.Configuration).getConfigurationProperties();for(const d of b){const E=h[d];if(!E){u.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}u.push(d),l[E.policy.name]={type:E.type}}}return(0,O.$Rf)(l)||await this.f.updatePolicyDefinitions(l),u}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const l=S.$tn.as(k.$yn.Configuration).getPolicyConfigurations(),u=(0,D.$Hb)(b.map(h=>l.get(h)));this.m(u,!0)}m(b,l){this.g.trace("PolicyConfiguration#update",b);const u=S.$tn.as(k.$yn.Configuration).getConfigurationProperties(),h=[],d=this.b.isEmpty();for(const E of b){const s=u[E]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(d?o!==void 0:!(0,j.$ln)(this.b.getValue(E),o))&&h.push([E,o])}else this.b.getValue(E)!==void 0&&h.push([E,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const E=this.b;this.b=new R.$On;for(const s of E.keys)this.b.setValue(s,E.getValue(s));for(const[s,o]of h)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Wn=g,e.$Wn=g=pe([X(1,C.$vn),X(2,m.$jj)],g)}),define(le[210],he([0,1,6,3,2,19,20,75,209,58]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class C extends L.$Sc{constructor($,c,g,y){super(),this.j=$,this.h=this.B(new N.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$Un),this.c=g instanceof m.$xn?new k.$Vn:this.B(new k.$Wn(this.b,g,y)),this.f=this.B(new R.$Qn(this.j,{},j.$ug,c)),this.a=new R.$Rn(this.b.configurationModel,this.c.configurationModel,new R.$On,new R.$On),this.g=this.B(new D.$bh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:l})=>this.n(b,l))),this.B(this.c.onDidChangeConfiguration(b=>this.r(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,c,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$Rn($,c,new R.$On,g)}getConfigurationData(){return this.a.toData()}getValue($,c){const g=typeof $=="string"?$:void 0,y=(0,O.$wi)($)?$:(0,O.$wi)(c)?c:{};return this.a.getValue(g,y,void 0)}updateValue($,c,g,y){return Promise.reject(new Error("not supported"))}inspect($){return this.a.inspect($,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.m($)}m($){const c=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration($);this.s(g,c,2)}n($,c){const g=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration($,c);this.s(y,g,7)}r($){const c=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration($);this.s(g,c,7)}s($,c,g){const y=new R.$Tn($,{data:c},this.a);y.source=g,y.sourceConfig=this.t(g),this.h.fire(y)}t($){switch($){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Xn=C}),define(le[211],he([0,1,15,3,2,67]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crb=e.$brb=e.$arb=e.$_qb=void 0;const O=(m,C,S)=>{const $=new Uint8Array(16);for(let y=0;y<16;y++)$[y]=Math.round(Math.random()*256);const c=(0,D.$Ae)(D.$ge.wrap($));return[`GET ws://localhost${m}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$_qb=O,e.$arb=D.$ge.fromString(`\r
\r
`);async function R(m,C,S,$,c){m.write(D.$ge.fromString((0,e.$_qb)(C,S,$)));const g=new L.$Rc;try{return await new Promise((y,b)=>{let l;g.add(m.onData(u=>{l?l=D.$ge.concat([l,u],l.byteLength+u.byteLength):l=u;const h=l.indexOf(e.$arb);if(h===-1)return;y(m),m.pauseData();const d=l.slice(h+e.$arb.byteLength);d.byteLength&&c.onData.fire(d)})),g.add(m.onClose(u=>b(u??new Error("socket closed")))),g.add(m.onEnd(()=>b(new Error("socket ended"))))})}catch(y){throw m.dispose(),y}finally{g.dispose()}}e.$brb=R;class k extends L.$Sc{constructor(C,S){super(),this.g=C,this.a=this.B(new N.$Vd),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event($=>this.a.fire($))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$crb=k}),define(le[212],he([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,N.$2h)("remoteAuthorityResolverService");var L;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=j;class O{constructor(S,$){this.host=S,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends D.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,$=R.Unknown,c){super(S),this._message=S,this._code=$,this._detail=c,this.isHandled=$===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,k.prototype)}}e.$6k=k;function m(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$7k=m}),define(le[76],he([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function N(m){return m.scheme===D.Schemas.vscodeRemote?m.authority:void 0}e.$8k=N;function L(m){if(!m)return;const C=m.indexOf("+");return C<0?m:m.substr(0,C)}e.$9k=L;function j(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.$0k=j;function O(m){const{host:C,port:S}=k(m);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:S}}e.$$k=O;function R(m,C){let{host:S,port:$}=k(m);return typeof $>"u"&&($=C),{host:S,port:$}}e.$_k=R;function k(m){const C=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=m.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const $=m.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:m,port:void 0}}}),define(le[44],he([0,1,27,4,76]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.TargetPlatform=e.ExtensionType=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am="extensions.user.cache",e.$bm="extensions.builtin.cache",e.$cm="undefined_publisher",e.$dm=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$em=j,e.$fm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,l){if(typeof b>"u"||b===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof b=="string"||typeof l=="string"){const u=typeof b=="string"?b:b.value,h=typeof l=="string"?l:l.value;return D.$8e(u,h)}return b._lower===l._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$gm=k;class m{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const l of b)this.add(l)}add(b){this.c.add(k.toKey(b))}delete(b){return this.c.delete(k.toKey(b))}has(b){return this.c.has(k.toKey(b))}}e.$hm=m;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(k.toKey(b))}get(b){return this.c.get(k.toKey(b))}has(b){return this.c.has(k.toKey(b))}set(b,l){this.c.set(k.toKey(b),l)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$im=C;function S(y){return $(y)}e.$jm=S;function $(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$km=$;function c(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$lm=c;function g(y,b){if(b){const l=`onResolveRemoteAuthority:${(0,L.$9k)(b)}`;return!!y.activationEvents?.includes(l)}return!1}e.$mm=g,e.$nm=(0,N.$2h)("IBuiltinExtensionsScannerService")}),define(le[213],he([0,1,2,44,11]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class j extends D.$Sc{constructor(R,k,m,C,S){super(),this.a=R,this.b=k,this.c=m,this.f=S,this.B(C.onDidInstallExtensions($=>this.g($))),this.B(C.onDidUninstallExtension($=>this.h($)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$am))}catch(k){(0,L.$Ck)(k)!==1&&this.f.error(k)}}}e.$Tp=j}),define(le[214],he([0,1,6,15,26,7,3,2,100,62,32,67,212,76]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.PersistentConnectionEventType=e.$gl=e.$fl=e.$el=e.ConnectionType=void 0;const g=30*1e3;var y;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function b(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const P=new L.$3d;return setTimeout(()=>P.cancel(),U),P.token}function u(U,P){if(U.isCancellationRequested||P.isCancellationRequested)return L.CancellationToken.Cancelled;const A=new L.$3d;return U.onCancellationRequested(()=>A.cancel()),P.onCancellationRequested(()=>A.cancel()),A.token}class h{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Rc,this.promise=new Promise((A,H)=>{this.f=A,this.g=H}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function d(U,P){const A=new h(P);return A.registerDisposable(U.onControlMessage(H=>{const q=JSON.parse(H.toString()),ee=B(q);ee?A.reject(ee):A.resolve(q)})),A.promise}function E(U,P,A,H,q,ee,G,Q){const ie=new h(Q),ce=m.$Od.create(!1);return U.info(`Creating a socket (${G})...`),k.mark(`code/willCreateSocket/${ee}`),P.connect(A,H,q,G).then(oe=>{ie.didTimeout?(k.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${G}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(k.mark(`code/didCreateSocketOK/${ee}`),U.info(`Creating a socket (${G}) was successful after ${ce.elapsed()} ms.`),ie.resolve(oe))},oe=>{k.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${G}) returned an error after ${ce.elapsed()} ms.`),U.error(oe),ie.reject(oe)}),ie.promise}function s(U,P){const A=new h(P);return U.then(H=>{A.didTimeout||A.resolve(H)},H=>{A.didTimeout||A.reject(H)}),A.promise}async function o(U,P,A,H){const q=re(U,P);U.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await E(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,c.$0k)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,b(P),`renderer-${b(P)}-${U.reconnectionToken}`,H)}catch(oe){throw U.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),U.logService.error(oe),oe}U.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let G,Q;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),G=U.reconnectionProtocol,Q=!1):(G=new S.$Ph({socket:ee}),Q=!0),U.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const ie=await s(U.signService.createNewMessage((0,C.$mg)()),H),ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:ie.data};G.sendControl(N.$ge.fromString(JSON.stringify(ce)));try{const oe=await d(G,u(H,l(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(U.logService.trace(`${q} 4/6. received SignRequest control message.`),!await s(U.signService.validate(ie,oe.signedData),H)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(U.signService.sign(oe.data),H),we={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:P};return A&&(we.args=A),U.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(N.$ge.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:Q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(U.logService.error(`${q} the handshake timed out. Error:`),U.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${q} received error control message when negotiating connection. Error:`),U.logService.error(oe)),Q&&W(G),oe}}async function n(U,P,A,H){const q=Date.now(),ee=re(U,P),{protocol:G,ownsProtocol:Q}=await o(U,P,A,H),ie=new h(H);return ie.registerDisposable(G.onControlMessage(ce=>{const oe=JSON.parse(ce.toString()),fe=B(oe);fe?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(fe),Q&&W(G),ie.reject(fe)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${K(q)}!`),ie.resolve({protocol:G,firstMessage:oe}))})),ie.promise}async function i(U,P){const{protocol:A}=await n(U,1,void 0,P);return{protocol:A}}async function t(U,P,A){const{protocol:H,firstMessage:q}=await n(U,2,P,A),ee=q&&q.debugPort;return{protocol:H,debugPort:ee}}async function r(U,P,A){const H=Date.now(),q=re(U,3),{protocol:ee}=await o(U,3,P,A);return U.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${K(H)}!`),ee}async function a(U,P,A){const{connectTo:H,connectionToken:q}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:H,connectionToken:q,reconnectionToken:P,reconnectionProtocol:A,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function v(U,P,A){return f(U,async H=>{const{protocol:q}=await i(H,L.CancellationToken.None);return new V(U,P,A,H.reconnectionToken,q)})}e.$el=v;async function w(U,P){return f(U,async A=>{const{protocol:H,debugPort:q}=await t(A,P,L.CancellationToken.None);return new Y(U,P,A.reconnectionToken,H,q)})}e.$fl=w;async function f(U,P){for(let H=1;;H++)try{const q=(0,C.$mg)(),ee=await a(U,q,null);return await P(ee)}catch(q){if(H<5)U.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(q);else throw U.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(q),x.triggerPermanentFailure(0,0,$.$6k.isHandled(q)),q}}async function p(U,P,A){const H=await a(U,(0,C.$mg)(),null);return await r(H,{host:P,port:A},L.CancellationToken.None)}e.$gl=p;function I(U){return(0,D.$Pg)(P=>new Promise((A,H)=>{const q=setTimeout(A,U*1e3);P.onCancellationRequested(()=>{clearTimeout(q),A()})}))}var F;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class M{constructor(P,A){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.type=0}}e.$hl=M;class T{constructor(P,A,H,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.durationSeconds=H,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$il=T;class z{constructor(P,A,H){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=H,this.type=2}}e.$jl=z;class Z{constructor(P,A,H){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=H,this.type=4}}e.$kl=Z;class J{constructor(P,A,H,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=H,this.handled=q,this.type=3}}e.$ll=J;class x extends R.$Sc{static triggerPermanentFailure(P,A,H){this._permanentFailure=!0,this.f=P,this.g=A,this.h=H,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,A,H,q,ee){super(),this.t=P,this.u=A,this.reconnectionToken=H,this.protocol=q,this.w=ee,this.m=this.B(new O.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(q.onSocketClose(G=>{const Q=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${Q} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${Q} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${Q} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(G=>{const Q=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Qc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const q=H<A.length?A[H]:A[A.length-1];try{if(q>0){const G=I(q);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,G)),this.u.logService.info(`${P} waiting for ${q} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.u.logService.info(`${P} resolving connection...`);const ee=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${ee.connectTo}...`),await this.G(ee,l(g)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if($.$6k.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,j.$4)(ee)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof $.$6k){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,$.$6k.isHandled(ee));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.n&&!this.s)}C(P,A,H){this.w?x.triggerPermanentFailure(P,A,H):this.D(P,A,H)}D(P,A,H){this.m.fire(new J(this.reconnectionToken,P,A,H)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ml=x;class V extends x{constructor(P,A,H,q,ee){super(1,P,q,ee,!0),this.client=this.B(new S.$Nh(ee,{remoteAuthority:A,clientId:H},P.ipcLogger))}async G(P,A){await i(P,A)}}e.$nl=V;class Y extends x{constructor(P,A,H,q,ee){super(2,P,H,q,!1),this.H=A,this.debugPort=ee}async G(P,A){await t(P,this.H,A)}}e.$ol=Y;function W(U){try{U.acceptDisconnect();const P=U.getSocket();U.dispose(),P.dispose()}catch(P){(0,j.$1)(P)}}function B(U){if(U&&U.type==="error"){const P=new Error(`Connection error: ${U.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function te(U,P){for(;U.length<P;)U+=" ";return U}function se(U,P){return`[remote-connection][${te(b(U),13)}][${P.substr(0,5)}\u2026]`}function _(U,P,A){return`${se(U,P)}[${A?"reconnect":"initial"}]`}function re(U,P){return`${_(P,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function K(U){return`${Date.now()-U} ms`}}),define(le[104],he([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=void 0,e.$al=(0,N.$2h)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,D.$Qc)(()=>{const k=this.a[O]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[O]?.splice(k,1)})}b(O){return(this.a[O.type]||[]).find(k=>k.supports(O))}connect(O,R,k,m){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,k,m)}}e.$bl=L}),define(le[215],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=e.$S$b=void 0,e.$S$b=(0,D.$2h)("sharedProcessTunnelService"),e.$T$b="sharedProcessTunnel"}),define(le[105],he([0,1,4,163]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=e.$2$b=e.$1$b=e.$Z$b=e.TunnelStates=e.$Y$b=e.$X$b=void 0,e.$X$b=(0,D.$2h)("IRemoteTunnelService"),e.$Y$b={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Z$b="remote.tunnels.access",e.$1$b=e.$Z$b+".hostNameOverride",e.$2$b=e.$Z$b+".preventSleep",e.$3$b="remoteTunnelService",e.$4$b=(0,N.localize)(0,null)}),define(le[59],he([0,1,15,7,2,165,50,4,8,41]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$6o=(0,R.$2h)("requestService");class C{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?E[s]="*****":E[s]=this.b[s];this.a=E}return this.a}}class S extends L.$Sc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,j.localize)(0,null),when:k.$Aj.isEqualTo((0,k.$yj)(k.LogLevel.Trace)).serialize()})}async c(E,s,o){const n=`${E} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,N.$0)(i)),i}}}e.$7o=S;function $(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$8o=$;function c(d){return d.res.statusCode===204}e.$9o=c;async function g(d){return c(d)?null:(await(0,D.$se)(d.stream)).toString()}e.$0o=g;async function y(d){if(!$(d))throw new Error("Server returned "+d.res.statusCode);return g(d)}e.$$o=y;async function b(d){if(!$(d))throw new Error("Server returned "+d.res.statusCode);if(c(d))return null;const s=(await(0,D.$se)(d.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$_o=b;function l(d){h(d)}e.$ap=l;let u;function h(d){const E=m.$tn.as(O.$yn.Configuration),s=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[u],remove:s?[s]:[]})}h(1)}),define(le[216],he([0,1,26,23,11,59]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;let O=class{constructor(k,m){this.a=k,this.b=m}async download(k,m,C=D.CancellationToken.None){if(k.scheme===N.Schemas.file||k.scheme===N.Schemas.vscodeRemote){await this.b.copy(k,m);return}const S={type:"GET",url:k.toString(!0)},$=await this.a.request(S,C);if($.res.statusCode===200)await this.b.writeFile(m,$.stream);else{const c=await(0,j.$$o)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${c}`)}}};e.$qO=O,e.$qO=O=pe([X(0,j.$6o),X(1,L.$lk)],O)}),define(le[217],he([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=void 0;class L{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,m,C=N.CancellationToken.None){switch(k){case"request":return this.a.request(m[0],C).then(async({res:S,stream:$})=>{const c=await(0,D.$se)($);return[{statusCode:S.statusCode,headers:S.headers},c]});case"resolveProxy":return this.a.resolveProxy(m[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$9q=L;class j{constructor(R){this.a=R}async request(R,k){const[m,C]=await this.a.call("request",[R],k);return{res:m,stream:(0,D.$ue)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$0q=j}),define(le[218],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=e.$k0b=e.$j0b=void 0,e.$j0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$k0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$l0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[219],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(D.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$e6b=D}),define(le[106],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=void 0,e.$cl="signService",e.$dl=(0,D.$2h)(e.$cl)}),define(le[220],he([0,1,219]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=void 0;class N extends D.$e6b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$_0b=N}),define(le[77],he([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hFb=e.$gFb=e.$fFb=e.$eFb=void 0;class L extends N.$Sc{constructor(S,$,c){super(),this.a=S,this.b=$,this.c=c}async getItems(){const S={profile:this.b,workspace:this.c},$=await this.a.call("getItems",S);return new Map($)}updateItems(S){const $={profile:this.b,workspace:this.c};return S.insert&&($.insert=Array.from(S.insert.entries())),S.delete&&($.delete=Array.from(S.delete.values())),this.a.call("updateItems",$)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class j extends L{constructor(S,$){super(S,$,void 0),this.f=this.B(new D.$Sd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class O extends j{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$eFb=O;class R extends j{constructor(S,$){super(S,$)}async close(){this.dispose()}}e.$fFb=R;class k extends L{constructor(S,$){super(S,void 0,$),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$gFb=k;class m{constructor(S){this.a=S}isUsed(S){const $={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$hFb=m}),define(le[107],he([0,1,5,37,32]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;function j(k){if(D.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function O(k,m,C,S,$,c,g,y,b){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=g,l.sessionID=(0,L.$mg)()+Date.now(),l.commitHash=S,l.version=$,l["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=N.$dc,l["common.nodeArch"]=C,l["common.product"]=b||"desktop",y&&(l["common.msftInternal"]=y);let u=0;const h=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const d=j(m);return d&&(l["common.platformDetail"]=d),l}e.$uo=O;function R(k){const m=N.env.USERDNSDOMAIN;if(!m)return!1;const C=m.toLowerCase();return k.some(S=>C===S)}e.$vo=R}),define(le[22],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,D.$2h)("telemetryService"),e.$ql=(0,D.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(le[221],he([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0;const b=new Map;async function l(s,o){const n=`${s}::${o.join(":")}`,i=b.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(p,I,F,M){const T=I.substring(p.length+1);return N.Promises.withAsyncBody(async z=>{let Z;try{Z=await C.Promises.readdir(I,{withFileTypes:!0})}catch{z();return}if(M.count>=v){M.count+=Z.length,M.maxReached=!0,z();return}let J=Z.length;if(J===0){z();return}let x=Z;M.count+Z.length>v&&(M.maxReached=!0,J=v-M.count,x=Z.slice(0,J)),M.count+=Z.length;for(const V of x)if(V.isDirectory()){if(F.includes(V.name)||await w(p,(0,O.$jc)(I,V.name),F,M),--J===0){z();return}}else{const Y=V.name.lastIndexOf(".");if(Y>=0){const W=V.name.substring(Y+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(T)!==!1&&W.filePattern.test(V.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--J===0){z();return}}})}const f=N.Promises.withAsyncBody(async p=>{const I={count:0,maxReached:!1};await w(s,s,o,I);const F=await d(s);p({configFiles:u(a),fileTypes:u(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:F})});return b.set(n,f),f}e.$Qr=l;function u(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Tk.GB).toFixed(2)}GB (${(D.freemem()/c.$Tk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.$5m.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.$Rr=h;async function d(s){try{const o=new Map,n=(0,O.$jc)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,L.$0m)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$gn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return u(o)}catch{return[]}}e.$Sr=d;let E=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/c.$Tk.GB).toFixed(2)}GB (${(D.freemem()/c.$Tk.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(m.$5m.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$Pr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return n.forEach(v=>{if((0,$.$Em)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[w];let p=`${f.fileCount} files`;f.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${w}): ${p}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=h(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const i=[];return(0,S.$Pr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),n.forEach(r=>{if((0,$.$Em)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${a}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const n=[];let t=0;const r=(f,p)=>{const I=` ${f}(${p})`;t+I.length>60?(n.push(a),a="|                 ",t=a.length):t+=I.length,a+=I};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let f=0;f<w;f++){const p=o.fileTypes[f];r(p.name,p.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const I=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;f+=I}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===j.Schemas.file){const v=a.fsPath;i.push(l(v,["node_modules",".git"]).then(w=>{let f=`${w.fileCount} files`;w.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,O.$nc)(v)}): ${f}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,i,t,n,0),t.join(`
`)}n(o,n,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/c.$Tk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(o,n,i,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=k.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=k.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Tr=E,e.$Tr=E=pe([X(0,y.$pl),X(1,g.$Bj)],E)}),define(le[108],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p0b=e.$o0b=void 0;class D{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:R,data:k}){return this.b.forEach(m=>m.log(R,k)),Promise.resolve(null)}}e.$o0b=D;class N{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$p0b=N}),define(le[45],he([0,1,30,12,3,20,76,107,22]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;class m{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$wo=m;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xo=C,e.$yo=new C;class S{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$zo=S,e.$Ao="telemetry",e.$Bo="extensionTelemetryLog",e.$Co={log:()=>null,flush:()=>Promise.resolve(null)};function $(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const w=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$yi)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$Do=$;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$Eo=c;function g(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Fo=g;function y(i){const t=i.getValue(k.$xl),r=i.getValue(k.$yl);if(i.getValue(k.$zl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Go=y;function b(i){const t={},r={},a={};h(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const w=a[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$Ho=b;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,O.$9k)(i);return l.has(t)?t:"other"}e.$Io=u;function h(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],f=a?a+v:v;Array.isArray(w)?t[f]=(0,D.$mn)(w):w instanceof Date?t[f]=w.toISOString():(0,N.$Gf)(w)?r<2?h(w,t,r+1,f+"."):t[f]=(0,D.$mn)(w):t[f]=w}}function d(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.$vo)(r)||a}e.$Jo=d;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ko=E;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const p of t)for(;;){const I=p.exec(i);if(!I)break;a.push([I.index,p.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const p=w.exec(i);if(!p)break;const I=a.some(([F,M])=>p.index<M&&F<w.lastIndex);!v.test(p[0])&&!I&&(r+=i.substring(f,p.index)+"<REDACTED: user-file-path>",f=w.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$jn)(i,r=>{if(r instanceof m||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Lo=n}),define(le[33],he([0,1,27,29,44,5,10,7,37,45]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$3e)(n.id,i.id)===0}e.$Mo=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,t,r)}static parse(i){const t=S.exec(i);return t&&t[1]&&t[2]?new $({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$No=$;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const i=c.exec(n);return i&&i[1]?[b(i[1]),i[2]]:[b(n),void 0]}e.$Oo=g;function y(n,i){return`${n}.${i}`}e.$Po=y;function b(n){return n.toLowerCase()}e.$Qo=b;function l(n,i){return b(y(n??L.$cm,i))}e.$Ro=l;function u(n,i){const t=[],r=a=>{for(const v of t)if(v.some(w=>C(i(w),i(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$So=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$To=h;function d(n){return{id:new m.$wo(n.identifier.id),name:new m.$wo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Uo=d,e.$Vo=new L.$gm("pprice.better-merge");function E(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(w=>C(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Wo=E;async function s(n,i){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,N.$go)(t?"alpine":j.$u,k.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Xo=o}),define(le[222],he([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=e.$l8b=void 0;let g=class extends N.$Sc{constructor(h,d){super(),this.b=h,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const d=[];for(const[E,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const o=(await this.b.readFile((0,L.$Dg)(h,E))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&d.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return d}};e.$l8b=g,e.$l8b=g=pe([X(0,O.$lk),X(1,R.$Bj)],g);const y="extensionTips/promptedExecutableTips",b="extensionTips/lastPromptedMediumImpExeTime";class l extends g{constructor(h,d,E,s,o,n,i,t){super(i,t),this.r=h,this.s=d,this.t=E,this.u=s,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],f=[];Object.entries(a.recommendations).forEach(([p,I])=>{I.important?a.important?v.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):w.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):f.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,k.$4g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),d=await this.O(this.h);return[...h,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),d=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(h,E),this.n=this.D(d,E)}D(h,d){const E=new Map;h.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.N([...E.keys()],d);for(const t of s){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[h,d]=[...this.m.entries()][0];this.H(d).then(E=>{switch(E){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new N.$Tc);s.value=(0,k.$4g)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),d=Date.now()-h,E=7*24*60*60*1e3;if(d<E){const n=this.B(new N.$Tc);n.value=(0,k.$4g)(()=>{n.dispose(),this.G()},E-d);return}const[s,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(o[0].exeName,o);const i=this.B(new N.$Tc);i.value=(0,k.$4g)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Tc);i.value=(0,k.$4g)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const d=await this.u.getInstalled(1),E=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>d.every(n=>!(0,c.$Mo)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(b,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(b,h,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(h,d){const E=this.L();E[h]=d.map(({extensionId:s})=>s.toLowerCase()),this.w.store(y,JSON.stringify(E),-1,0)}N(h,d){const E=[],s=[],o=d.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?E.push(n):s.push(n)}),{installed:E,uninstalled:s}}async O(h){const d=[],E=new Map;for(const s of h.keys()){const o=h.get(s);if(!o||!(0,D.$Lb)(o.recommendations))continue;const n=[];S.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",s)),n.push((0,C.$jc)("/usr/bin",s)),n.push((0,C.$jc)(this.r.fsPath,s)));for(const i of n){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)d.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return d}}e.$m8b=l}),define(le[223],he([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HYb=void 0;async function L(j,O,R,k,m){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const S=await j.getInstalled(1);for(const[$,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:g,autoMigrate:y,preRelease:b}=c.extension;if(!y)continue;const l=S.find(h=>(0,N.$Mo)(h.identifier,{id:$}));if(!l)continue;const u=(await O.getExtensions([{id:g,preRelease:b}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){m.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{m.info(`Migrating '${l.identifier.id}' extension to '${g}' extension...`);const h=!k.getDisabledExtensions().some(E=>(0,N.$Mo)(E,l.identifier));await j.uninstall(l),m.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=S.find(E=>(0,N.$Mo)(E.identifier,{id:g}));(!d||!d.isPreReleaseVersion&&h)&&(d=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${d.identifier.id}'`),h||(await k.disableExtension(d.identifier),m.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,N.$Po)(l.manifest.publisher,l.manifest.name),(0,N.$Po)(d.manifest.publisher,d.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${l.identifier.id}' extension to '${g}' extension.`)}catch(h){m.error(h)}}}catch(C){m.error(C)}}e.$HYb=L}),define(le[224],he([0,1,6,7,2,23,19,55,12,32,31,69,20,14,29,33,97,11,8]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let d=class extends L.$Sc{static{h=this}static{this.c=".sigzip"}constructor(s,o,n,i,t,r){super(),this.h=o,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,n){await this.g;const i=(0,O.$Dg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new g.$lo(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(w){this.r.error(w)}throw new g.$lo(S.$xp,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Kf)(o)?o:!0}async u(s){await this.g;const o=(0,O.$Dg)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,o,n=>this.j.downloadSignatureArchive(s,n)),o}async w(s,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const i=(0,O.$Dg)(this.extensionsDownloadDir,`.${(0,m.$mg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(h.c))i.push(a.resource);else{const v=y.$No.parse(a.name);v&&n.push([v,a])}const t=(0,y.$So)(n,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await D.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$No.create(s).toString().toLowerCase():(0,m.$mg)()}};e.$Qp=d,e.$Qp=d=h=pe([X(0,c.$0h),X(1,l.$lk),X(2,g.$ko),X(3,$.$vi),X(4,b.$rp),X(5,u.$jj)],d)}),define(le[225],he([0,1,3,2,34,33,44]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class R extends N.$Sc{constructor(m,C,S,$,c,g,y){super(),this.f=m,this.g=C,this.h=S,this.j=$,this.m=c,this.n=g,this.r=y,this.a=this.B(new D.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$2c),this.s().then(null,b=>y.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(m=>this.u(m.added))),this.B(this.j.onAddExtensions(m=>this.w(m))),this.B(this.j.onDidAddExtensions(m=>this.y(m))),this.B(this.j.onRemoveExtensions(m=>this.z(m))),this.B(this.j.onDidRemoveExtensions(m=>this.C(m))),this.B(this.n.onDidFilesChange(m=>this.D(m)))}async u(m){try{m.length&&await Promise.all(m.map(C=>(this.c.set(C.id,(0,N.$Pc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(m){for(const C of m.extensions)this.I(this.L(C.identifier,C.version),m.profileLocation)}async y(m){for(const C of m.extensions){const S=this.L(C.identifier,C.version);m.error?this.J(S,m.profileLocation):this.I(S,m.profileLocation)}}async z(m){for(const C of m.extensions)this.J(this.L(C.identifier,C.version),m.profileLocation)}async C(m){const C=[],S=[];for(const $ of m.extensions){const c=this.L($.identifier,$.version);m.error?this.I(c,m.profileLocation):(this.J(c,m.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),S.push(this.f.scanInstalledExtensionAtLocation($.location).then(g=>{g?C.push(g):this.r.info("Extension not found at the location",$.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch($){this.r.error($)}}D(m){for(const C of this.h.profiles)m.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(m){const C=[],S=[],$=await this.j.scanProfileExtensions(m),c=new Set,g=new Set;for(const[y,b]of this.b)b.has(m)&&g.add(y);for(const y of $){const b=this.L(y.identifier,y.version);c.add(b),g.has(b)||(C.push(y.identifier),this.I(b,m))}for(const y of g)if(!c.has(y)){const b=this.M(y);b&&(S.push(b.identifier),this.J(y,m))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:m}:void 0,removed:S.length?{extensions:S,profileLocation:m}:void 0})}async G(m){const C=await this.j.scanProfileExtensions(m);for(const S of C)this.I(this.L(S.identifier,S.version),m)}async H(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}I(m,C){let S=this.b.get(m);S||this.b.set(m,S=new L.$Bc($=>this.m.extUri.getComparisonKey($))),S.add(C)}J(m,C){const S=this.b.get(m);S&&S.delete(C),S?.size||this.b.delete(m)}L(m,C){return`${O.$gm.toKey(m.id)}@${C}`}M(m){const[C,S]=(0,j.$Oo)(m);return S?{identifier:{id:C},version:S}:void 0}}e.$Up=R}),define(le[226],he([0,1,43,45]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function L(j,O,R,k,m,C,S){const $={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,N.$Eo)(O,R)&&(0,N.$Go)(k)===3){const c=await(0,D.$mp)(R,m,C);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=S.machineId||c}return $}e.$np=L}),define(le[227],he([0,1,72,18,6,2,23,16,31,14,29,33,8,74,10]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let y=class extends c.$7q{constructor(h,d,E,s){super(E),this.h=h,this.j=s,this.g=this.B(new b(d,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(h,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const o=s.translations[h];return o?g.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),d=Object.keys(h).map(E=>{const s=h[E];return{...this.f(E,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((E,s)=>E.label.localeCompare(s.label)),d}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const d=await this.g.getLanguagePacks();Object.keys(d).some(E=>d[E]&&d[E].extensions.some(s=>(0,S.$Mo)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(d);return!(0,N.$ub)(Object.keys(h),Object.keys(E))}};e.$8q=y,e.$8q=y=pe([X(0,C.$mo),X(1,m.$0h),X(2,C.$ko),X(3,$.$jj)],y);let b=class extends j.$Sc{constructor(h,d){super(),this.j=d,this.c={},this.f=(0,R.$jc)(h.userDataPath,"languagepacks.json"),this.g=new L.$9g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(d=>{Object.keys(d).forEach(E=>delete d[E]),this.m(d,...h)}).then(()=>this.c)}m(h,...d){for(const E of d)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(h,E);Object.keys(h).forEach(E=>this.r(h[E]))}n(h,d){const E=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const o of s)if(d.location.scheme===O.Schemas.file&&l(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const i=n.extensions.filter(t=>(0,S.$Mo)(t.extensionIdentifier,E))[0];i?i.version=d.manifest.version:n.extensions.push({extensionIdentifier:E,version:d.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(d.location.fsPath,t.path)}}r(h){if(h){const d=(0,D.createHash)("md5");for(const E of h.extensions)d.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);h.hash=d.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let d=null;return k.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(d=h(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),k.Promises.writeFile(this.f,s)}).then(()=>d,E=>this.j.error(E))})}};b=pe([X(0,m.$0h),X(1,$.$jj)],b);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(le[228],he([0,1,141,7,30,45]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,$){const c=await(0,D.$YC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$YC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new c.AppInsightsCore,b=new g.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if($){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:$};l.extensionConfig[b.identifier]=u}return y.initialize(l,[]),y.addTelemetryInitializer(u=>{S&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),y}class m{constructor(S,$,c,g,y){this.e=S,this.f=$,this.g=c,this.h=y,this.c=O,this.d=R,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then($=>{S($)},$=>{(0,N.$1)($),console.error($)})}}log(S,$){if(!this.a)return;$=(0,L.$kn)($,this.g),$=(0,j.$Ho)($);const c=this.f+"/"+S;try{this.i(g=>{g.pluginVersionString=$?.properties.version??"Unknown",g.track({name:c,baseData:{name:c,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$1N=m}),define(le[109],he([0,1,2,166,14,8,25,45]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;let k=class extends D.$Sc{constructor(C,S,$,c,g=""){super(),this.b=g;const y=S.getLogger(R.$Ao);if(y)this.a=this.B(y);else{const l=(0,R.$Fo)(c,$)?" (Not Sent)":"",u=()=>(0,R.$Eo)(c,$)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(S.createLogger(R.$Ao,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$Ao,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$Ho)(S))}};e.$L7b=k,e.$L7b=k=pe([X(0,j.$jj),X(1,j.$kj),X(2,L.$9h),X(3,O.$Bj)],k)}),define(le[110],he([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,h){this.k=u,this.l=h,this.d={},this.i=new D.$Rc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,j.$Ke)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ke)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration($.$xl)||d.affectsConfiguration($.$zl)||d.affectsConfiguration($.$yl))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,c.$Go)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;l=Math.min(l,h)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,h){this.g<u||(h=(0,N.$kn)(h,this.d),h=(0,c.$Lo)(h,this.j),h=(0,N.$kn)(h,this.c),this.b.forEach(d=>d.log(l,h)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$br=g,e.$br=g=pe([X(1,R.$vi),X(2,C.$Bj)],g);function y(){const b=(0,O.localize)(0,null,m.default.nameLong),l=m.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),d=(0,O.localize)(5,null),E=(0,O.localize)(6,null),s=(0,O.localize)(7,null),o=`
|       | ${h} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${b} ${l} ${u}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}S.$tn.as(k.$yn.Configuration).registerConfiguration({id:$.$wl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[$.$xl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$tn.as(k.$yn.Configuration).registerConfiguration({id:$.$wl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[$.$zl]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,O.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,O.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${$.$xl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[229],he([0,1,15,26,271,228]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;async function O(C,S){const $=await S.request(C,N.CancellationToken.None),c=(await(0,D.$se)($.stream)).toString(),g=$.res.statusCode??200;return{headers:$.res.headers,statusCode:g,responseData:c}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((c,g)=>{const y=L.request(C.url??"",S,b=>{b.on("data",function(l){c({headers:b.headers,statusCode:b.statusCode??200,responseData:l.toString()})}),b.on("error",function(l){g(l)})});y.write(C.data,b=>{b&&g(b)}),y.end()})}async function k(C,S,$){const c=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),g={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:c};try{const y=C?await O(g,C):await R(g);$(y.statusCode,y.headers,y.responseData)}catch{$(0,{})}}class m extends j.$1N{constructor(S,$,c,g,y){const b={sendPOST:(l,u)=>{k(S,l,u)}};super($,c,g,y,b)}}e.$2N=m}),define(le[230],he([0,1,23,93,20,14,8,25,22,108,109,110]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;let $=class{constructor(g,y,b,l,u,h){this.b=g,this.c=y,this.d=b,this.e=l,this.f=u,this.g=h,this.a=new Map}h(g){if(!this.a.has(g.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const b=[g.id,JSON.stringify(y),g.aiKey],u=new N.$dq(D.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new m.$p0b(u),new C.$L7b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new S.$br({appenders:h,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,y,b){this.h(g).publicLog(y,b)}publicLogError(g,y,b){this.h(g).publicLogError(y,b)}};e.$H$b=$,e.$H$b=$=pe([X(0,L.$vi),X(1,k.$pl),X(2,O.$jj),X(3,O.$kj),X(4,j.$9h),X(5,R.$Bj)],$)}),define(le[78],he([0,1,3,20,4,8]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.ProvidedOnAutoForward=e.$nv=e.TunnelPrivacyId=e.TunnelProtocol=e.$mv=e.$lv=void 0,e.$lv=(0,L.$2h)("tunnelService"),e.$mv=(0,L.$2h)("sharedTunnelsService");var O;(function(b){b.Http="http",b.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(b){return!!b.forwardPort}e.$nv=k;var m;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function C(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(l)return{address:l[1],port:+l[2]}}e.$ov=C,e.$pv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(b){return e.$pv.indexOf(b)>=0}e.$qv=S,e.$rv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(b){return e.$rv.indexOf(b)>=0}e.$sv=$;function c(b,l,u,h){if(u===1)return!1;if(u===2&&$(l)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(d?.length===4&&parseInt(d[1])>=18)return!1}return b<1024}e.$tv=c;class g{constructor(l,u,h){this.remoteAddress=l,this.localAddress=u,this.b=h,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$uv=g;let y=class{constructor(l,u){this.j=l,this.k=u,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const l=this.k.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.h=l.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const l=[],u=Array.from(this.e.values());for(const h of u){const d=Array.from(h.values());for(const E of d){const s=await E.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:u}of l.values())await u.then(h=>typeof h!="string"?h?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,u,h,d,E){this.p(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:h,privacy:d,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){($(l)||S(l))&&(l=e.$pv[0]);const h=this.r(l,u);if(h)return++h.refcount,h.value}openTunnel(l,u,h,d,E,s=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${E}.`);const i=this.f??l;if(!i)return;if(u||(u="localhost"),d||(d=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,h,d,E,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.e.get(l.tunnelRemoteHost);if(u){const h=u.get(l.tunnelRemotePort);h&&(h.refcount--,await this.o(l.tunnelRemoteHost,l.tunnelRemotePort,h))}}}}async o(l,u,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const d=h.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(u),d}}async closeTunnel(l,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const h=this.e.get(l);if(h&&h.has(u)){const d=h.get(u);d.refcount=0,await this.o(l,u,d)}}p(l,u,h){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(u,{refcount:1,value:h})}async q(l,u){const h=this.e.get(l);if(h){const d=h.get(u),E=d?await d.value:void 0;(!E||typeof E=="string")&&h.delete(u),h.size===0&&this.e.delete(l)}}r(l,u){const h=[l];S(l)?(h.push(...e.$pv),h.push(...e.$rv)):$(l)&&h.push(...e.$rv);const d=h.map(E=>this.e.get(E));for(const E of d){const s=E?.get(u);if(s)return s}}canTunnel(l){return!!C(l)}t(l,u,h,d,E,s,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${d}.`);const n=h;this.i.add(n);const i=d===void 0?h:d,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:h},localAddressPort:d,privacy:s,public:s?s!==R.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.p(u,h,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$vv=y,e.$vv=y=pe([X(0,j.$jj),X(1,N.$vi)],y)}),define(le[231],he([0,1,8,78,2,7,6]),function(ne,e,D,N,L,j,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;class k extends L.$Sc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$mh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let m=class extends L.$Sc{static{R=this}static{this.a=0}constructor(S,$){super(),this.f=S,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,$,c,g,y,b,l){const u=new k,h=await Promise.resolve(this.f.openTunnel(S,u,c,g,y,b,l));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${g} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),u.dispose(),await h.dispose(),(0,j.$6)();return u.setTunnel(h),this.b.set($,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${h.localAddress} (local) to ${c}:${g} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(S,$){const c=this.b.get(S);c&&c.setAddress($)}async destroyTunnel(S){const $=this.b.get(S);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await $.dispose();return}this.c.add(S)}};e.$U$b=m,e.$U$b=m=R=pe([X(0,N.$mv),X(1,D.$jj)],m)}),define(le[28],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,D.$2h)("IUriIdentityService")}),define(le[232],he([0,1,28,185,11,19,127,3,2]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class m{static{this._clock=0}constructor($){this.uri=$,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let C=class{constructor($){this.g=$,this.c=new k.$Rc,this.f=2**16;const c=new Map,g=y=>{let b=c.get(y.scheme);return b===void 0&&(b=$.hasProvider(y)&&!this.g.hasCapability(y,1024),c.set(y.scheme,b)),b};this.c.add(R.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(y=>{c.delete(y.scheme)})),this.extUri=new j.$sg(g),this.d=new O.$Lr((y,b)=>this.extUri.compare(y,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,j.$Eg)($));const c=this.d.get($);return c?c.touch().uri.with({fragment:$.fragment}):(this.d.set($,new m($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((g,y)=>g[1].time<y[1].time?1:g[1].time>y[1].time?-1:0);m._clock=0,this.d.clear();const c=this.f*.5;for(let g=0;g<c;g++)this.d.set($[g][0],$[g][1].touch())}};e.$Mr=C,e.$Mr=C=pe([X(0,L.$lk)],C),(0,N.$Jr)(D.$Vk,C,1)}),define(le[233],he([0,1,3,2,11,47,34]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;class R extends N.$Sc{constructor(m,C,S,$,c,g){super(),this.f=m,this.g=C,this.h=S,this.j=$,this.m=c,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=j.$8h.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const m of this.j.profiles)this.c.add(m.settingsResource),this.c.add(m.keybindingsResource),this.c.add(m.tasksResource),this.c.add(m.extensionsResource)}open(m,C){return this.g.open(this.t(m),C)}close(m){return this.g.close(m)}read(m,C,S,$,c){return this.g.read(m,C,S,$,c)}write(m,C,S,$,c){return this.g.write(m,C,S,$,c)}watch(m,C){this.b.set(m,m);const S=this.g.watch(this.t(m),C);return(0,N.$Qc)(()=>{this.b.delete(m),S.dispose()})}stat(m){return this.g.stat(this.t(m))}mkdir(m){return this.g.mkdir(this.t(m))}rename(m,C,S){return this.g.rename(this.t(m),this.t(C),S)}readFile(m,C){return this.g.readFile(this.t(m),C)}readFileStream(m,C,S){return this.g.readFileStream(this.t(m),C,S)}readdir(m){return this.g.readdir(this.t(m))}enforceAtomicReadFile(m){return this.c.has(m)}writeFile(m,C,S){return this.g.writeFile(this.t(m),C,S)}enforceAtomicWriteFile(m){return this.c.has(m)?{postfix:".vsctmp"}:!1}delete(m,C){return this.g.delete(this.t(m),C)}copy(m,C,S){if((0,L.$pk)(this.g))return this.g.copy(this.t(m),this.t(C),S);throw new Error("copy not supported")}cloneFile(m,C){if((0,L.$qk)(this.g))return this.g.cloneFile(this.t(m),this.t(C));throw new Error("clone not supported")}s(m){const C=[];for(const S of m){if(S.resource.scheme!==this.f)continue;const $=this.u(S.resource);this.b.findSubstr($)&&C.push({resource:$,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(m){return m.with({scheme:this.f})}u(m){return m.with({scheme:this.h})}}e.$c$b=R}),define(le[79],he([0,1,86]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XEb=e.$WEb=e.edit=void 0;function N(O,R,k,m){const C=(0,D.$TT)(O,R,k,m)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=N;function L(O,R,k){let m=k;for(;m>=0;){if(O.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&O.charAt(m)===R.charAt(0))return m+2}return 0}e.$WEb=L;function j(O,R,k){let m=k;for(;m>=0;)if(O.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&O.charAt(m)===R.charAt(1)))return m;return O.length-1}e.$XEb=j}),define(le[234],he([0,1,30,55,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;function j(c,g,y,b,l,u){const h=[],d=[],E=[];if(!g){const z=c.filter(({identifier:Z})=>l.every(J=>J.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:h,removed:d,updated:E},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}c=c.map(S),g=g.map(S),y=y?y.map(S):null;const s=new Map,o=z=>{z.uuid&&s.set(z.id.toLowerCase(),z.uuid)};c.forEach(({identifier:z})=>o(z)),g.forEach(({identifier:z})=>o(z)),y?.forEach(({identifier:z})=>o(z)),b?.forEach(({identifier:z})=>o(z)),u?.forEach(z=>o(z));const n=z=>{const Z=z.identifier.uuid||s.get(z.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${z.identifier.id.toLowerCase()}`},i=(z,Z)=>(z.set(n(Z),Z),z),t=c.reduce(i,new Map),r=g.reduce(i,new Map),a=g.reduce((z,Z)=>i(z,(0,D.$hn)(Z)),new Map),v=y?y.reduce(i,new Map):null,w=b.reduce(i,new Map),f=l.reduce((z,Z)=>{const J=s.get(Z.toLowerCase());return z.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)},new Set),p=u?u.reduce((z,{id:Z,uuid:J})=>(J=J??s.get(Z.toLowerCase()),z.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)),new Set):null,I=O(t,r,f,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const z=O(v,t,f,!1),Z=O(v,r,f,!0),J=(x,V,Y,W)=>{let B,te,se;return V.installed?(B=W.pinned,se=W.preRelease,B&&(te=W.version)):(B=Y.pinned,se=Y.preRelease,B&&(te=Y.version)),B===void 0&&(B=V.pinned,B&&(te=V.version)),se===void 0&&(se=V.preRelease),{...W,installed:V.installed||Y.installed,pinned:B,preRelease:se,version:te??(Y.version&&(!V.installed||N.gt(Y.version,V.version))?Y.version:V.version),state:k(V,Y,v?.get(x))}};for(const x of Z.removed.values()){const V=t.get(x);if(!V)continue;const Y=(0,L.$Pf)(v?.get(x)),W=p&&!p.has(x)&&Y.installed;V.installed&&W?d.push(V.identifier):a.set(x,V)}for(const x of Z.added.values()){const V=(0,L.$Pf)(r.get(x)),Y=t.get(x);if(Y){if(I.updated.has(x)){const W=J(x,Y,V,V);R(Y,V,!1,!1)||E.push($(W,x)),a.set(x,W)}}else V.installed&&h.push($(V,x))}for(const x of Z.updated.values()){const V=(0,L.$Pf)(r.get(x)),Y=(0,L.$Pf)(v?.get(x)),W=t.get(x);if(W)if(p&&!p.has(x)&&Y.installed&&W.installed&&!V.installed)d.push(W.identifier);else{const te=J(x,W,V,V);E.push($(te,x)),a.set(x,te)}else V.installed&&h.push($(V,x))}for(const x of z.added.values())Z.added.has(x)||a.set(x,(0,L.$Pf)(t.get(x)));for(const x of z.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const V=(0,L.$Pf)(t.get(x)),Y=(0,L.$Pf)(r.get(x));a.set(x,J(x,V,Y,V))}for(const x of z.removed.values())Z.updated.has(x)||Z.removed.has(x)||w.has(x)||(0,L.$Pf)(r.get(x)).installed&&p&&(p.has(x)||!(0,L.$Pf)(v?.get(x)).installed||a.delete(x))}const F=[],M=O(r,a,new Set,!0),T=M.added.size>0||M.updated.size>0||M.removed.size>0;return T&&a.forEach((z,Z)=>F.push($(z,Z))),{local:{added:h,removed:d,updated:E},remote:T?{added:[...M.added].map(z=>a.get(z)),updated:[...M.updated].map(z=>a.get(z)),removed:[...M.removed].map(z=>r.get(z)),all:F}:null}}e.$r6b=j;function O(c,g,y,b){const l=c?[...c.keys()].filter(s=>!y.has(s)):[],u=[...g.keys()].filter(s=>!y.has(s)),h=u.filter(s=>!l.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),d=l.filter(s=>!u.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),E=new Set;for(const s of l){if(d.has(s))continue;const o=c.get(s),n=g.get(s);(!n||!R(o,n,b,!0))&&E.add(s)}return{added:h,removed:d,updated:E}}function R(c,g,y,b){return!(c.disabled!==g.disabled||!!c.isApplicationScoped!=!!g.isApplicationScoped||b&&c.installed!==g.installed||c.installed&&g.installed&&(c.preRelease!==g.preRelease||c.pinned!==g.pinned||g.pinned&&c.version!==g.version)||!C(c.state,g.state)||y&&c.version!==g.version)}function k(c,g,y){const b=c.state,l=g.state,u=y?.state;if(!g.version||b&&N.gt(c.version,g.version))return b;if(l&&N.gt(g.version,c.version)||!b)return l;if(!l)return b;const h=(0,D.$hn)(b),d=u?m(u,l):{added:Object.keys(l).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},E=u?m(u,b):{added:Object.keys(b).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...d.added.values(),...d.updated.values()])h[s]=l[s];for(const s of d.removed.values())E.updated.has(s)||delete h[s];return h}function m(c,g){const y=Object.keys(c),b=Object.keys(g),l=b.filter(d=>!y.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),u=y.filter(d=>!b.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),h=new Set;for(const d of y){if(u.has(d))continue;const E=c[d],s=g[d];(0,D.$ln)(E,s)||h.add(d)}return{added:l,removed:u,updated:h}}function C(c={},g={}){const{added:y,removed:b,updated:l}=m(c,g);return y.size===0&&b.size===0&&l.size===0}function S(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function $(c,g){const y={...c,identifier:{id:c.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete y.disabled,c.installed||delete y.installed,c.state||delete y.state,c.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[111],he([0,1,18,20,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UGb=e.$TGb=void 0,e.$TGb=(0,L.$2h)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return m=m.filter(C=>C!==R&&C!==`-${R}`),k&&m.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,k){let m=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return m=m.filter(C=>C!==R&&C!==`-${R}`),k&&m.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const k=R.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),m=this.b().map($=>$.toLowerCase()),C=[],S=[];if(Array.isArray(m))for(const $ of m)$.startsWith("-")?S.push($.substring(1)):C.push($);return(0,D.$Mb)([...k,...C].filter($=>!S.includes($)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$UGb=j,e.$UGb=j=pe([X(0,N.$vi)],j)}),define(le[235],he([0,1,18,35,30,94,79]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;function R(d){return(0,N.$0m)(d)||[]}async function k(d,E,s,o,n){const i=R(d),t=R(E),r=s?R(s):null,a=[...i,...t,...r||[]].map(J=>J.key),v=await n.resolveUserBindings(a),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const f=$(i),p=$(t),I=r?$(r):null,F=g(f,p,v),M=I?g(I,f,v):{added:[...f.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},T=I?g(I,p,v):{added:[...p.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},z=m(F,M,T);let Z=d;for(const J of z.removed.values())z.conflicts.has(J)||(Z=u(Z,J,o));for(const J of z.added.values()){if(z.conflicts.has(J))continue;const x=p.get(J);if(x.some(V=>V.command!==`-${J}`&&w.conflicts.has(v[V.key]))){z.conflicts.add(J);continue}Z=l(Z,x,o)}for(const J of z.updated.values()){if(z.conflicts.has(J))continue;const x=p.get(J);if(x.some(V=>V.command!==`-${J}`&&w.conflicts.has(v[V.key]))){z.conflicts.add(J);continue}Z=h(Z,J,x,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.$x6b=k;function m(d,E,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of E.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):n.add(r));for(const r of E.added.values())t.has(r)||s.added.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(E.added.has(r)?d.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||s.updated.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(E.updated.has(r)?d.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function C(d,E,s,o){const n=new Set,i=S(d,o),t=S(E,o),r=s?S(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,t):{added:[...t.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:p,updated:I,conflicts:F}=m(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:p,updated:I,conflicts:F}}function S(d,E){const s=new Map;for(const o of d){const n=E[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function $(d){const E=new Map;for(const s of d){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=E.get(o);n||(n=[],E.set(o,n)),n.push(s)}return E}function c(d,E){const s=[...d.keys()],o=[...E.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=d.get(r).map(w=>({...w,key:r})),v=E.get(r).map(w=>({...w,key:r}));(0,D.$ub)(a,v,(w,f)=>b(w,f))||t.add(r)}return{added:n,removed:i,updated:t}}function g(d,E,s){const o=[...d.keys()],n=[...E.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=d.get(a).map(f=>({...f,key:s[f.key]})),w=E.get(a).map(f=>({...f,key:s[f.key]}));y(v,w)||r.add(a)}return{added:i,removed:t,updated:r}}function y(d,E){return!(!(0,D.$ub)(d.filter(({command:s})=>s[0]!=="-"),E.filter(({command:s})=>s[0]!=="-"),(s,o)=>b(s,o))||!(0,D.$ub)(d.filter(({command:s})=>s[0]==="-"),E.filter(({command:s})=>s[0]==="-"),(s,o)=>b(s,o)))}function b(d,E){if(d.command!==E.command||d.key!==E.key)return!1;const s=j.$Zi.deserialize(d.when),o=j.$Zi.deserialize(E.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!L.$ln(d.args,E.args))}function l(d,E,s){for(const o of E)d=O.edit(d,[-1],o,s);return d}function u(d,E,s){const o=R(d);for(let n=o.length-1;n>=0;n--)(o[n].command===E||o[n].command===`-${E}`)&&(d=O.edit(d,[n],void 0,s));return d}function h(d,E,s,o){const n=R(d),i=n.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=n.length-1;t>=0;t--)(n[t].command===E||n[t].command===`-${E}`)&&(d=O.edit(d,[t],void 0,o));for(let t=s.length-1;t>=0;t--)d=O.edit(d,[i],s[t],o);return d}}),define(le[236],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.$E6b=void 0;function D(j,O,R){const k={},m={},C=new Set;if(!O)return{local:{added:k,updated:m,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const S=N(j,O);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:m,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(R,j),c=N(R,O),g={},y={},b=new Set,l=new Set;for(const u of $.removed.values())c.updated.has(u)?k[u]=O[u]:b.add(u);for(const u of c.removed.values())l.has(u)||($.updated.has(u)?l.add(u):C.add(u));for(const u of $.updated.values())l.has(u)||(c.updated.has(u)?S.updated.has(u)&&l.add(u):y[u]=j[u]);for(const u of c.updated.values())l.has(u)||($.updated.has(u)?S.updated.has(u)&&l.add(u):j[u]!==void 0&&(m[u]=O[u]));for(const u of $.added.values())l.has(u)||(c.added.has(u)?S.updated.has(u)&&l.add(u):g[u]=j[u]);for(const u of c.added.values())l.has(u)||($.added.has(u)?S.updated.has(u)&&l.add(u):k[u]=O[u]);return{local:{added:k,removed:[...C.values()],updated:m},remote:{added:g,removed:[...b.values()],updated:y},conflicts:[...l.values()]}}e.$E6b=D;function N(j,O){const R=j?Object.keys(j):[],k=O?Object.keys(O):[],m=k.filter($=>!R.includes($)).reduce(($,c)=>($.add(c),$),new Set),C=R.filter($=>!k.includes($)).reduce(($,c)=>($.add(c),$),new Set),S=new Set;for(const $ of R){if(C.has($))continue;const c=j[$],g=O[$];c!==g&&S.add($)}return{added:m,removed:C,updated:S}}function L(j,O){const{added:R,removed:k,updated:m}=N(j,O);return R.size===0&&k.size===0&&m.size===0}e.$F6b=L}),define(le[237],he([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0;function N(j,O,R,k){const m={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const $=j.filter(({id:c})=>!k.includes(c));return $.length?C.added=$:C=null,{local:m,remote:C}}const S=L(j,O,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const $=L(R,j,k),c=L(R,O,k);for(const g of c.removed){const y=j.find(b=>b.id===g);y&&m.removed.push(y)}for(const g of c.added){const y=O.find(b=>b.id===g);$.added.includes(g)?S.updated.includes(g)&&m.updated.push(y):m.added.push(y)}for(const g of c.updated)m.updated.push(O.find(y=>y.id===g));for(const g of $.added)c.added.includes(g)||C.added.push(j.find(y=>y.id===g));for(const g of $.updated)c.removed.includes(g)||c.updated.includes(g)||C.updated.push(j.find(y=>y.id===g));for(const g of $.removed){const y=O.find(b=>b.id===g);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:m,remote:C}}e.$p8b=N;function L(j,O,R){j=j?j.filter(({id:c})=>!R.includes(c)):[],O=O.filter(({id:c})=>!R.includes(c));const k=j.map(({id:c})=>c),m=O.map(({id:c})=>c),C=m.filter(c=>!k.includes(c)),S=k.filter(c=>!m.includes(c)),$=[];for(const{id:c,name:g,shortName:y,icon:b,useDefaultFlags:l}of j){if(S.includes(c))continue;const u=O.find(h=>h.id===c);(!u||u.name!==g||u.shortName!==y||u.icon!==b||!(0,D.$ln)(u.useDefaultFlags,l))&&$.push(c)}return{added:C,removed:S,updated:$}}}),define(le[24],he([0,1,18,12,173,50,29,4,103,41]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mb=e.$8mb=e.$7mb=e.$6mb=e.$5mb=e.$4mb=e.$3mb=e.$2mb=e.$1mb=e.$Zmb=e.$Ymb=e.MergeState=e.Change=e.SyncStatus=e.$Xmb=e.$Wmb=e.$Vmb=e.UserDataSyncErrorCode=e.$Umb=e.$Tmb=e.$Smb=e.$Rmb=e.$Qmb=e.$Pmb=e.$Omb=e.$Nmb=e.$Mmb=e.SyncResource=e.$Lmb=e.$Kmb=e.$Jmb=e.$Imb=e.$Hmb=e.$Gmb=void 0;function C(){const t=m.$tn.as(j.$yn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Gmb=C;function S(){const t=m.$tn.as(j.$yn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,D.$Mb)([...r,...a,...v])}e.$Hmb=S,e.$Imb="settingsSync",e.$Jmb="settingsSync.keybindingsPerPlatform";function $(){const t="vscode://schemas/ignoredSettings",r=m.$tn.as(j.$yn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$Jmb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$$n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.$tn.as(k.$un.JSONContribution),v=()=>{const w=C(),f=S(),p=Object.keys(j.$zn.properties).filter(M=>!f.includes(M)),I=f.filter(M=>!w.includes(M)),F={items:{type:"string",enum:[...p,...I.map(M=>`-${M}`)]}};a.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$Kmb=$;function c(t){return t&&(0,N.$Gf)(t)&&(0,N.$Ef)(t.id)&&Array.isArray(t.scopes)}e.$Lmb=c;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$Mmb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Nmb=y;function b(t,r,a,v){return v.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$Omb=b,e.$Pmb=(0,R.$2h)("IUserDataSyncStoreManagementService"),e.$Qmb=(0,R.$2h)("IUserDataSyncStoreService"),e.$Rmb=(0,R.$2h)("IUserDataSyncLocalStoreService"),e.$Smb="x-operation-id",e.$Tmb="X-Execution-Id";function l(t){const r={};return r[e.$Tmb]=t,r}e.$Umb=l;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Vmb=h;class d extends h{constructor(r,a,v,w,f){super(r,v,void 0,f),this.url=a,this.serverCode=w}}e.$Wmb=d;class E extends h{constructor(r,a){super(r,a)}}e.$Xmb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,f)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$Vmb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Ymb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$Zmb=i,e.$1mb=(0,R.$2h)("IUserDataSyncEnablementService"),e.$2mb=(0,R.$2h)("IUserDataSyncService"),e.$3mb=(0,R.$2h)("IUserDataSyncResourceProviderService"),e.$4mb=(0,R.$2h)("IUserDataAutoSyncService"),e.$5mb=(0,R.$2h)("IUserDataSyncUtilService"),e.$6mb=(0,R.$2h)("IUserDataSyncLogService"),e.$7mb="userDataSync",e.$8mb="vscode-userdata-sync",e.$9mb="preview"}),define(le[238],he([0,1,30,24]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dGb=void 0;function L(O,R,k,m,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const S=j(O,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=k?j(k,R):{added:Object.keys(R).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},c=k?j(k,O):{added:Object.keys(O).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=D.$hn(R),b=!k;for(const u of c.added.values())u!==N.$Ymb&&b&&$.added.has(u)||(y[u]=O[u]);for(const u of c.updated.values())y[u]=O[u];for(const u of c.removed.values())m.unregistered.includes(u)||delete y[u];for(const u of $.added.values()){const h=R[u];if(m.machine.includes(u)){C.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(k&&c.added.has(u))continue;const d=O[u];d&&d.value===h.value||u===N.$Ymb&&b&&c.added.has(u)||(d?g.updated[u]=h:g.added[u]=h)}for(const u of $.updated.values()){const h=R[u];if(m.machine.includes(u)){C.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(u)||c.removed.has(u))continue;const d=O[u];d&&d.value===h.value||(g.updated[u]=h)}for(const u of $.removed.values()){if(m.machine.includes(u)){C.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}c.updated.has(u)||c.removed.has(u)||g.removed.push(u)}const l=j(R,y);return{local:g,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.$dGb=L;function j(O,R){const k=Object.keys(O),m=Object.keys(R),C=m.filter(c=>!k.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),S=k.filter(c=>!m.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),$=new Set;for(const c of k){if(S.has(c))continue;const g=O[c],y=R[c];D.$ln(g,y)||$.add(c)}return{added:C,removed:S,updated:$}}}),define(le[239],he([0,1,18,35,86,42,30,79,24]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Eb=e.$3Eb=e.$2Eb=e.$1Eb=e.$ZEb=e.$YEb=void 0;function m(a,v,w){let f=[];w?f=S(w):f=C(v);const p=[],I=[...(0,k.$Gmb)()];if(Array.isArray(f))for(const F of f)F.startsWith("-")?I.push(F.substring(1)):p.push(F);return(0,D.$Mb)([...a,...p].filter(F=>!I.includes(F)))}e.$YEb=m;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const v=(0,N.$0m)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function $(a,v){const w=(0,N.$0m)(a)||{};let f="{}";for(const p of Object.keys(w)){const I=(0,L.$TT)(f,[p],w[p],v);f=(0,L.$WT)(f,I)}return f}e.$ZEb=$;function c(a,v,w,f){if(w.length){const p=r(v),I=(0,N.$0m)(v)||{},F=(0,N.$0m)(a);if(!F)return a;const M=[];for(const T of w){const z=I[T],Z=F[T];z===void 0?a=R.edit(a,[T],void 0,f):Z!==void 0?a=R.edit(a,[T],z,f):M.push(s(T,p))}M.sort((T,z)=>T.startOffset-z.startOffset),M.forEach(T=>a=u(T.setting.key,v,a,f))}return a}e.$1Eb=c;function g(a,v,w,f,p,I){const F=c(a,v,f,I),M=w!==F,T=w!==v;if(!M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:c(v,a,f,I),remoteContent:null,hasConflicts:!1};if(w===null&&b(a)){const A=y(a,v,f)?null:c(v,a,f,I);return{conflictsSettings:[],localContent:A,remoteContent:null,hasConflicts:!1}}let z=a,Z=v;const J=(0,N.$0m)(a),x=(0,N.$0m)(v),V=w?(0,N.$0m)(w):null,Y=f.reduce((A,H)=>(A.add(H),A),new Set),W=l(J,x,Y),B=l(V,J,Y),te=l(V,x,Y),se=new Map,_=new Set,re=A=>{_.add(A);const H=p.filter(({key:q})=>q===A)[0];H?(z=R.edit(z,[A],H.value,I),Z=R.edit(Z,[A],H.value,I)):se.set(A,{key:A,localValue:J[A],remoteValue:x[A]})};for(const A of B.removed.values())te.updated.has(A)?re(A):Z=R.edit(Z,[A],void 0,I);for(const A of te.removed.values())_.has(A)||(B.updated.has(A)?re(A):z=R.edit(z,[A],void 0,I));for(const A of B.updated.values())_.has(A)||(te.updated.has(A)?W.updated.has(A)&&re(A):Z=R.edit(Z,[A],J[A],I));for(const A of te.updated.values())_.has(A)||(B.updated.has(A)?W.updated.has(A)&&re(A):z=R.edit(z,[A],x[A],I));for(const A of B.added.values())_.has(A)||(te.added.has(A)?W.updated.has(A)&&re(A):Z=u(A,z,Z,I));for(const A of te.added.values())_.has(A)||(B.added.has(A)?W.updated.has(A)&&re(A):z=u(A,Z,z,I));const K=se.size>0||!y(z,Z,f),U=K||!y(z,a,[]),P=K||!y(Z,v,[]);return{localContent:U?z:null,remoteContent:P?Z:null,conflictsSettings:[...se.values()],hasConflicts:K}}e.$2Eb=g;function y(a,v,w){if(a===v)return!0;const f=(0,N.$0m)(a),p=(0,N.$0m)(v),I=w.reduce((T,z)=>(T.add(z),T),new Set),F=r(a).filter(T=>!(T.setting&&I.has(T.setting.key))),M=r(v).filter(T=>!(T.setting&&I.has(T.setting.key)));if(F.length!==M.length)return!1;for(let T=0;T<F.length;T++){const z=F[T],Z=M[T];if(z.setting&&Z.setting){if(z.setting.key!==Z.setting.key||!O.$ln(f[z.setting.key],p[z.setting.key]))return!1}else if(!z.setting&&!Z.setting){if(z.value!==Z.value)return!1}else return!1}return!0}function b(a){return a?r(a).length===0:!0}e.$3Eb=b;function l(a,v,w){const f=a?Object.keys(a).filter(T=>!w.has(T)):[],p=Object.keys(v).filter(T=>!w.has(T)),I=p.filter(T=>!f.includes(T)).reduce((T,z)=>(T.add(z),T),new Set),F=f.filter(T=>!p.includes(T)).reduce((T,z)=>(T.add(z),T),new Set),M=new Set;if(a)for(const T of f){if(F.has(T))continue;const z=a[T],Z=v[T];O.$ln(z,Z)||M.add(T)}return{added:I,removed:F,updated:M}}function u(a,v,w,f){const p=(0,N.$0m)(v),I=r(v),F=r(w),M=h(a,I,F);return d(w,a,p[a],M,F,f)}e.$4Eb=u;function h(a,v,w){const f=v.findIndex(I=>I.setting?.key===a),p=v[f-1];if(p){if(p.setting){const F=s(p.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!0}}else{const F=o(f,v);if(F){const M=s(F.setting.key,w);if(M){const T=n(w.indexOf(M),w),z=i(v,F,v[f]);if(T){const Z=i(w,M,T),J=t(z,Z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.indexOf(T),insertAfter:!1}}else{const Z=i(w,M,w[w.length-1]),J=t(z,Z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const I=v[f+1];if(I)if(I.setting){const F=s(I.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!1}}else{const F=n(f,v);if(F){const M=s(F.setting.key,w);if(M){const T=o(w.indexOf(M),w),z=i(v,v[f],F);if(T){const Z=i(w,T,M),J=t(z.reverse(),Z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:w.indexOf(T),insertAfter:!0}}else{const Z=i(w,w[0],M),J=t(z.reverse(),Z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(a,v,w,f,p,I){let F;return f.index===-1?F=(0,L.$TT)(a,[v],w,I):F=E(a,v,w,f,p,I).map(M=>(0,L.$UT)(a,M,I)[0]),(0,L.$WT)(a,F)}function E(a,v,w,f,p,I){const F=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,M=(0,j.$QT)(I,a),T=p[f.index];if(f.insertAfter){const z=[];if(T.setting)z.push({offset:T.endOffset,length:0,content:","+F});else{const Z=n(f.index,p),J=o(f.index,p),x=J?.setting?.commaOffset;J&&x===void 0&&z.push({offset:J.endOffset,length:0,content:","});const V=x!==void 0&&x>T.endOffset;z.push({offset:V?x+1:T.endOffset,length:0,content:Z?M+F+",":M+F})}return z}else{if(T.setting)return[{offset:T.startOffset,length:0,content:F+","}];const z=(p[f.index-1]&&!p[f.index-1].setting?M:"")+F+(n(f.index,p)?",":"")+M;return[{offset:T.startOffset,length:0,content:z}]}}function s(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function n(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(a,v,w){const f=a.indexOf(v),p=a.indexOf(w);return a.filter((I,F)=>f<F&&F<p)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,f,p;const I={onObjectBegin:F=>{w++},onObjectProperty:(F,M,T)=>{w===0&&(f=M,p=F)},onObjectEnd:(F,M)=>{w--,w===0&&v.push({startOffset:f,endOffset:F+M,value:a.substring(f,F+M),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(F,M)=>{w++},onArrayEnd:(F,M)=>{w--,w===0&&v.push({startOffset:f,endOffset:F+M,value:a.substring(f,F+M),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(F,M,T)=>{w===0&&v.push({startOffset:f,endOffset:M+T,value:a.substring(f,M+T),setting:{key:p,commaOffset:void 0}})},onSeparator:(F,M,T)=>{if(w===0&&F===","){let z=v.length-1;for(;z>=0&&!v[z].setting;z--);const Z=v[z];Z&&v.splice(z,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:M}})}},onComment:(F,M)=>{w===0&&v.push({startOffset:F,endOffset:F+M,value:a.substring(F,F+M)})}};return(0,N.$en)(a,I),v}}),define(le[80],he([0,1,3,2,4,24]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JEb=e.$IEb=void 0,e.$IEb=(0,L.$2h)("IUserDataSyncAccountService");let O=class extends N.$Sc{get account(){return this.a}constructor(k,m){super(),this.g=k,this.h=m,this.b=this.B(new D.$Sd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Sd),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$JEb=O,e.$JEb=O=pe([X(0,j.$Qmb),X(1,j.$6mb)],O)}),define(le[240],he([0,1,2,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=e.$N$b=e.$M$b=e.$L$b=e.$K$b=e.$J$b=e.$I$b=void 0;class L{constructor($){this.a=$}listen($,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$I$b=L;class j{constructor($){this.a=$}listen($,c){throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$J$b=j;class O{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$K$b=O;class R{constructor($){this.a=$}listen($,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call($,c,g){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$L$b=R;class k{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$M$b=k;class m{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$N$b=m;class C extends D.$Sc{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:N.URI.revive($.url),type:$.type,defaultUrl:N.URI.revive($.defaultUrl),insidersUrl:N.URI.revive($.insidersUrl),stableUrl:N.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$O$b=C}),define(le[241],he([0,1,19,174,14,8,24]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VGb=void 0;let R=class extends j.$oj{constructor(m,C){super(),this.g=this.B(m.createLogger((0,D.$Dg)(C.logsHome,`${O.$7mb}.log`),{id:O.$7mb,name:(0,N.localize)(0,null)}))}trace(m,...C){this.g.trace(m,...C)}debug(m,...C){this.g.debug(m,...C)}info(m,...C){this.g.info(m,...C)}warn(m,...C){this.g.warn(m,...C)}error(m,...C){this.g.error(m,...C)}flush(){this.g.flush()}};e.$VGb=R,e.$VGb=R=pe([X(0,j.$kj),X(1,L.$9h)],R)}),define(le[242],he([0,1,6,3,2]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=void 0;class j extends L.$Sc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:k,getActiveWindowId:m}){super(),this.a=this.B(new L.$Rc),N.Event.latch(N.Event.any(R,k))(this.f,this,this.a),this.b=(0,D.$Pg)(()=>m()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$J0b=j}),define(le[112],he([0,1,177,16,47,19,10,4,23]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,R.$2h)("contextService");function m(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$_h=m;function C(i){return typeof i?.id=="string"&&!m(i)&&!$(i)}e.$ai=C,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function S(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$nc)(i)}:t?e.$bi:e.$ci;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$di=S;function $(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$ei=$;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$fi=c;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$gi=y;function b(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$hi=b;class l{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=L.$8h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$8h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=l;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Dg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=u;function h(i){return new u({uri:i,index:0,name:(0,j.$zg)(i)},{uri:i.toString()})}e.$ki=h,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,D.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function d(i,t){return j.$ug.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$pi=d;function E(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===k.Schemas.tmp}e.$qi=E,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ri}e.$si=s;function o(i,t){return!d(i,t)&&!E(i)}e.$ti=o;function n(i){return(typeof i=="string"?(0,N.$oc)(i):(0,j.$Bg)(i))===e.$mi}e.$ui=n}),define(le[17],he([0,1,53,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function d(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Wk=d,e.$Xk=(0,C.$2h)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Yk=E;function s(i,t,r,a,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,j.$Dg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,j.$Dg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,j.$Dg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,j.$Dg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,j.$Dg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,j.$Dg)(r,"extensions.json"),cacheHome:(0,j.$Dg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Zk=s;let o=class extends L.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,u.$Ef)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(s((0,j.$Ag)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new c.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[f,p]of Object.entries(w.workspaces)){const I=O.URI.parse(f),F=r.find(M=>M.id===p);F&&a.set(I,F)}if(w.emptyWindows)for(const[f,p]of Object.entries(w.emptyWindows)){const I=r.find(F=>F.id===p);I&&v.set(f,I)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Ke)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const p=a.exec(f.name),I=p?parseInt(p[1]):0;v=I>v?I:v}const w=`${r} ${v+1}`;return this.createProfile((0,D.$Pi)((0,b.$mg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,D.$Pi)((0,b.$mg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,u.$Ef)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(I=>I.name===r||I.id===t);if(w)return w;const f=s(t,r,(0,j.$Dg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(f.location);const p=[];return this.j.fire({profile:f,join(I){p.push(I)}}),await y.Promises.settled(p),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,m.$Ck)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,$.$_h)(t)?t.uri:(0,$.$ei)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(p=>f.id===p.id)||(f=a.find(p=>f.id===p.id)??f,f.isTransient?this.s.profiles.push(f):w.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;O.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,f]of Object.entries(t.workspaces)){const p=O.URI.parse(f);r[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const v={};if(t.emptyWindows)for(const[w,f]of Object.entries(t.emptyWindows)){const p=O.URI.parse(f);v[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$1k=o,e.$1k=o=pe([X(0,k.$9h),X(1,m.$lk),X(2,g.$Vk),X(3,S.$jj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$2k=n}),define(le[243],he([0,1,6,2,17]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;let j=class extends N.$Sc{constructor(R){super(),this.B(new D.$bh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$W$b=j,e.$W$b=j=pe([X(0,L.$Xk)],j)}),define(le[244],he([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;let d=class extends R.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,f){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Sd),this.s=this.B(new O.$Sd),this.t=this.B(new O.$Sd),this.u=this.B(new O.$Sd),this.w=this.B(new O.$Sd),this.y=[],this.B((0,R.$Qc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,$.$io)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,c.$Mo)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new $.$lo(S.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const f=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...f,options:w})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Uo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$jm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$Mo)(f.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(w,f)=>t.some(p=>(0,c.$Qo)(f.identifier.id)===(0,c.$Ro)(p.manifest.publisher,p.manifest.name))?!1:this.L(w,f));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Ro)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const w=a.isApplicationScoped||a.isBuiltin||(0,g.$jm)(t),f={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},p=Z=>`${c.$No.create(Z).toString()}${f.profileLocation?`-${f.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Z=this.j.get(p(r));if(Z)return this.F.info("Extensions is already requested to install",r.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const I=[],F=[],M=[],T=this.Z(t,r,f);C.URI.isUri(r)||this.j.set(p(r),{task:T,waitingTasks:[]}),this.n.fire({identifier:T.identifier,source:r,profileLocation:f.profileLocation}),this.F.info("Installing extension:",T.identifier.id),I.push({task:T,manifest:t});let z=!1;try{if(f.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const J=await this.N(T.identifier,t,!!f.installOnlyNewlyAddedFromExtensionPack,!!f.installPreReleaseVersion,f.profileLocation),x=await this.getInstalled(void 0,f.profileLocation),V={...f,donotIncludePackAndDependencies:!0,context:{...f.context,[$.$do]:!0}};for(const{gallery:Y,manifest:W}of(0,D.$Mb)(J,({gallery:B})=>B.identifier.id)){z=z||!!W.extensionDependencies?.some(se=>(0,c.$Mo)({id:se},T.identifier));const B=p(Y),te=this.j.get(B);if(te){if(v(T,te.task)){const se=te.task.identifier;this.F.info("Waiting for already requested installing extension",se.id,T.identifier.id),te.waitingTasks.push(T),F.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(re=>(0,c.$Mo)(re.identifier,se)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",se.id,T.identifier.id),!_.find(K=>(0,c.$Mo)(K.identifier,se))?.local)throw new Error(`Extension ${se.id} is not installed`)}))}}else if(!x.some(({identifier:se})=>(0,c.$Mo)(se,Y.identifier))){const se=this.Z(W,Y,V);this.j.set(B,{task:se,waitingTasks:[T]}),this.n.fire({identifier:se.identifier,source:Y,profileLocation:f.profileLocation}),this.F.info("Installing extension:",se.identifier.id,T.identifier.id),I.push({task:se,manifest:W})}}}catch(J){if(C.URI.isUri(T.source))(0,D.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,J.message),(0,D.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,J.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),J}const Z=I.reduce((J,{task:x,manifest:V})=>(J.set(x.identifier.id.toLowerCase(),{task:x,manifest:V}),J),new Map);for(;Z.size;){let J;const x=[...Z.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(Y=>Z.has(Y.toLowerCase())));x.length?J=Z.size===1?x:x.filter(({task:V})=>!(V===T&&!z)):(this.F.info("Found extensions with circular dependencies",x.map(({task:V})=>V.identifier.id)),J=[...Z.values()]),await this.M(J.map(async({task:V})=>{const Y=new Date().getTime();try{const W=await V.run();if(await this.M(this.y.map(B=>B.postInstall(W,V.source,f,L.CancellationToken.None))),!C.URI.isUri(V.source)){const B=V.operation===3,te=B?void 0:(new Date().getTime()-V.source.lastUpdated)/1e3;if(o(this.C,B?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Uo)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:te}),k.$o&&V.operation!==3)try{await this.z.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}M.push({local:W,identifier:V.identifier,operation:V.operation,source:V.source,context:V.options.context,profileLocation:V.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw C.URI.isUri(V.source)||o(this.C,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Uo)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Y,error:W}),this.F.error("Error while installing the extension:",V.identifier.id),W}finally{Z.delete(V.identifier.id.toLowerCase())}}))}return F.length&&await this.M(F),M.forEach(({identifier:J})=>this.F.info("Extension installed successfully:",J.id)),M}catch(Z){if(I.forEach(({task:J})=>J.cancel()),M.length)try{const J=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:f.profileLocation}).run()));for(let x=0;x<J.length;x++){const V=J[x],{identifier:Y}=M[x];V.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Y.id):this.F.warn("Rollback: Error while uninstalling extension",Y.id,(0,j.$0)(V.reason))}}catch(J){this.F.warn("Error while rolling back extensions",(0,j.$0)(J),M.map(({identifier:x})=>x.id))}return I.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:f.context,profileLocation:f.profileLocation,error:Z}))}finally{for(const{task:Z}of I)Z.source&&!C.URI.isUri(Z.source)&&this.j.delete(p(Z.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,w){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,w),p=[],I=[],F=async(M,T)=>{p.push(M);const z=T.extensionDependencies||[],Z=[...z];if(T.extensionPack){const J=a?f.find(x=>(0,c.$Mo)(x.identifier,M)):void 0;for(const x of T.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(V=>(0,c.$Mo)({id:V},{id:x}))||Z.every(V=>!(0,c.$Mo)({id:V},{id:x}))&&Z.push(x)}if(Z.length){const J=Z.filter(x=>p.every(V=>!(0,c.$Mo)(V,{id:x})));if(J.length){const x=await this.z.getExtensions(J.map(V=>({id:V,preRelease:v})),L.CancellationToken.None);for(const V of x){if(p.find(B=>(0,c.$Mo)(B,V.identifier)))continue;const Y=z.some(B=>(0,c.$Mo)({id:B},V.identifier));let W;try{W=await this.O(V,!1,v)}catch(B){if(Y)throw B;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,j.$0)(B));continue}I.push({gallery:W.extension,manifest:W.manifest}),await F(W.extension.identifier,W.manifest)}}}};return await F(t,r),I}async O(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(I=>(0,c.$Mo)(t.identifier,I)))throw new $.$lo(S.localize(1,null,t.identifier.id),$.ExtensionManagementErrorCode.Malicious);const f=w.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new $.$lo(S.localize(2,null,t.identifier.id,f.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const I=await this.getTargetPlatform();throw new $.$lo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,$.$eo)(I)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new $.$lo(S.localize(4,null,t.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$lo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const p=await this.z.getManifest(v,L.CancellationToken.None);if(p===null)throw new $.$lo(`Missing manifest for extension ${v.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(p.version!==v.version)throw new $.$lo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:p}}async P(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const f=M=>{const T=this.$(M,a);return this.m.set(v(T.extension.identifier),T),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),T},p=(M,T)=>{T?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),T.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,T.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$To)(M),error:T}),this.u.fire({identifier:M.identifier,error:T?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},I=[],F=[];try{I.push(f(t));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const T=this.U(t,M);for(const z of T)this.m.has(v(z.identifier))?this.F.info("Extensions is already requested to uninstall",z.identifier.id):I.push(f(z))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(I.map(T=>T.extension),M,t),await this.M(I.map(async T=>{try{if(await T.run(),await this.M(this.y.map(z=>z.postUninstall(T.extension,a,L.CancellationToken.None))),T.extension.identifier.uuid)try{await this.z.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}p(T.extension)}catch(z){const Z=z instanceof $.$lo?z:new $.$lo((0,j.$0)(z),$.ExtensionManagementErrorCode.Internal);throw p(T.extension,Z),Z}finally{F.push(T)}}))}catch(M){const T=M instanceof $.$lo?M:new $.$lo((0,j.$0)(M),$.ExtensionManagementErrorCode.Internal);for(const z of I){try{z.cancel()}catch{}F.includes(z)||p(z.extension,T)}throw T}finally{for(const M of I)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,a){for(const v of t){const w=this.W(v,r);if(w.length){const f=w.filter(p=>!t.some(I=>(0,c.$Mo)(I.identifier,p.identifier)));if(f.length)throw new Error(this.S(v,f,a))}}}S(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(p=>!p.isBuiltin&&v.some(I=>(0,c.$Mo)({id:I},p.identifier))),f=[];for(const p of w)f.push(...this.U(p,r,a));return[...w,...f]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Mo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Cp=d,e.$Cp=d=pe([X(0,$.$ko),X(1,l.$pl),X(2,u.$Vk),X(3,y.$jj),X(4,b.$Bj),X(5,h.$Xk)],d);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Dp=E;function s(i){if(i instanceof $.$lo)return i;const t=new $.$lo(i.message,$.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$Ep=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:f}){let p,I;(0,m.$Mf)(a)&&(a===!0?a="Verified":(a===!1||(p=$.ExtensionManagementErrorCode.Signature,I=a),a="Unverified")),w&&(w instanceof $.$lo?(p=w.code,w.code===$.ExtensionManagementErrorCode.Signature&&(I=w.message)):p=$.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:p,errorcodeDetail:I,durationSinceUpdate:f})}class n{constructor(){this.d=new N.$1g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Pg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Pg)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$Fp=n}),define(le[51],he([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$Gp=h,e.$Hp=(0,S.$2h)("IExtensionsProfileScannerService");let d=class extends L.$Sc{constructor(n,i,t,r,a,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new j.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const w of a)n.some(([f])=>(0,m.$Mo)(f.identifier,w.identifier)&&f.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,f]of n){const p=v.findIndex(F=>(0,m.$Mo)(F.identifier,w.identifier)&&F.version===w.manifest.version),I={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:f};p===-1?(r.push(I),v.push(I)):v.splice(p,1,I)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const w=n.find(([f])=>(0,m.$Mo)(f.identifier,v.identifier)&&f.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,m.$Mo)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$Ck)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,b.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const w of a){E(w)||this.w(n);let f;if((0,y.$Ef)(w.relativeLocation)&&w.relativeLocation)f=this.z(w.relativeLocation);else if((0,y.$Ef)(w.location))f=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=f.toJSON();else{f=R.URI.revive(w.location);const p=this.y(f);p&&(v=!0,w.relativeLocation=p)}r.push({identifier:w.identifier,location:f,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,N.$ge.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,N.$ge.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$Ck)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ge.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Ck)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$Ck)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,C.$Ck)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$9g,this.h.set(n,i)),i}};e.$Ip=d,e.$Ip=d=pe([X(1,C.$lk),X(2,c.$Xk),X(3,g.$Vk),X(4,l.$pl),X(5,$.$jj)],d);function E(o){return(0,y.$Gf)(o)&&(0,k.$jo)(o.identifier)&&(s(o.location)||(0,y.$Ef)(o.location)&&o.location)&&((0,y.$Lf)(o.relativeLocation)||(0,y.$Ef)(o.relativeLocation))&&o.version&&(0,y.$Ef)(o.version)}function s(o){return o?(0,y.$Ef)(o.path)&&(0,y.$Ef)(o.scheme):!1}}),define(le[81],he([0,1,18,6,30,15,7,35,137,2,23,16,5,19,55,89,12,10,154,14,33,44,70,11,4,8,25,3,65,51,17,28,182]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o,n,i,t,r,a,v,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.Translations=void 0;var I;(function(x){function V(Y,W){if(Y===W)return!0;const B=Object.keys(Y),te=new Set;for(const se of Object.keys(W))te.add(se);if(B.length!==te.size)return!1;for(const se of B){if(Y[se]!==W[se])return!1;te.delete(se)}return te.size===0}x.equals=V})(I||(e.Translations=I={})),e.$Lp=(0,n.$2h)("IExtensionsScannerService");let F=class extends m.$Sc{constructor(V,Y,W,B,te,se,_,re,K,U,P,A){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Y,this.r=W,this.s=B,this.t=te,this.u=se,this.w=_,this.y=re,this.z=K,this.C=U,this.D=P,this.F=A,this.g=this.B(new r.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,c.$Dg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Xo)(this.w,this.y)),this.G}async scanAllExtensions(V,Y,W){const[B,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Y)]),se=W?await this.scanExtensionsUnderDevelopment(V,[...B,...te]):[];return this.L(B,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Y=[];Y.push(this.M(!!V.useCache,V.language)),Y.push(this.N(V.language,!!V.checkControlFile));const[W,B]=await Promise.all(Y);return this.J([...W,...B],0,V,!1)}async scanUserExtensions(V){const Y=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const W=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(Y,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,W),te=V.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let se;try{se=await te.scanExtensions(B)}catch(_){if(_ instanceof v.$Gp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await te.scanExtensions(B);else throw _}return se=await this.J(se,1,V,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(V,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===C.Schemas.file).map(async B=>{const te=await this.P(B,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(_=>(_.type=Y.find(re=>(0,d.$Mo)(re.identifier,_.identifier))?.type??_.type,this.n.validate(_,te)))}))).flat();return this.J(W,"development",V,!0)}return[]}async scanExistingExtension(V,Y,W){const B=await this.P(V,!1,Y,!0,W.language,!0,void 0),te=await this.n.scanExtension(B);return!te||!W.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,Y,W){const B=await this.P(V,!1,Y,!0,W.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(B);return this.J(te,Y,W,!0)}async scanMetadata(V){const Y=(0,c.$Dg)(V,"package.json"),W=(await this.w.readFile(Y)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(V,Y){const W=(0,c.$Dg)(V,"package.json"),B=(await this.w.readFile(W)).value.toString(),te=JSON.parse(B);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,te.__metadata={...te.__metadata,...Y},await this.w.writeFile((0,c.$Dg)(V,"package.json"),j.$ge.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof v.$Gp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ge.fromString(JSON.stringify([])))}catch(Y){(0,o.$Ck)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Y,W,B){return W.includeAllVersions||(V=this.L(Y===0?V:void 0,Y===1?V:void 0,Y==="development"?V:void 0,await this.getTargetPlatform(),B)),W.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,se)=>{const _=S.$nc(te.location.fsPath),re=S.$nc(se.location.fsPath);return _<re?-1:_>re?1:0})}L(V,Y,W,B,te){const se=(re,K,U)=>{if(re.isValid&&!K.isValid)return!1;if(re.isValid===K.isValid){if(te&&g.gt(re.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,K.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===B)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${re.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${K.location.path}.`),!0},_=new E.$im;return V?.forEach(re=>{const K=_.get(re.identifier.id);(!K||se(K,re,!1))&&_.set(re.identifier.id,re)}),Y?.forEach(re=>{const K=_.get(re.identifier.id);if(!K&&V&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!K||se(K,re,!1))&&_.set(re.identifier.id,re)}),W?.forEach(re=>{const K=_.get(re.identifier.id);(!K||se(K,re,!0))&&_.set(re.identifier.id,re),_.set(re.identifier.id,re)}),[..._.values()]}async M(V,Y){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),te=await(V&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",te.length),te}async N(V,Y){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const B=Y?await this.O():{},te=[],se=l.URI.file(S.$hc(S.$jc(C.$kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of W){const K=B[re.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":te.push((0,c.$Dg)(se,re.name));break;default:te.push(l.URI.file(K));break}}const _=await Promise.all(te.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Hb)(_)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Y,W,B,te,se,_){const re=await this.f(te??$.$w),K=await this.Q(V),U=Y&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=U?await this.Q(U):void 0;return new M(V,K,U,P,Y,_,W,B,se,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,re)}async Q(V){try{const Y=await this.w.stat(V);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$Mp=F,e.$Mp=F=pe([X(4,w.$Xk),X(5,v.$Hp),X(6,o.$lk),X(7,i.$jj),X(8,h.$9h),X(9,t.$Bj),X(10,f.$Vk),X(11,n.$1h)],F);class M{constructor(V,Y,W,B,te,se,_,re,K,U,P,A,H,q,ee){this.location=V,this.mtime=Y,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=B,this.profile=te,this.profileScanOptions=se,this.type=_,this.excludeObsolete=re,this.validate=K,this.productVersion=U,this.productDate=P,this.productCommit=A,this.devMode=H,this.language=q,this.translations=ee}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Y){return(0,c.$wg)(V.location,Y.location)&&V.mtime===Y.mtime&&(0,c.$wg)(V.applicationExtensionslocation,Y.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&V.profile===Y.profile&&L.$ln(V.profileScanOptions,Y.profileScanOptions)&&V.type===Y.type&&V.excludeObsolete===Y.excludeObsolete&&V.validate===Y.validate&&V.productVersion===Y.productVersion&&V.productDate===Y.productDate&&V.productCommit===Y.productCommit&&V.devMode===Y.devMode&&V.language===Y.language&&I.equals(V.translations,Y.translations)}}e.$Np=M;let T=class extends m.$Sc{constructor(V,Y,W,B,te){super(),this.f=V,this.g=Y,this.h=W,this.j=B,this.m=te}async scanExtensions(V){const Y=V.profile?await this.r(V):await this.n(V);let W={};if(V.excludeObsolete&&V.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(B)}catch{}return(0,b.$Rf)(W)?Y:Y.filter(B=>!W[d.$No.create(B).toString()])}async n(V){const Y=await this.j.resolve(V.location);if(!Y.children?.length)return[];const W=await Promise.all(Y.children.map(async B=>{if(!B.isDirectory||V.type===1&&(0,c.$Ag)(B.resource).indexOf(".")===0)return null;const te=new M(B.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,D.$Hb)(W).sort((B,te)=>B.location.path<te.location.path?-1:1)}async r(V){let Y=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Y=Y.filter(B=>!B.metadata?.isApplicationScoped);const W=await this.s(V.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,V);Y.push(...W)}return Y}async s(V,Y,W){const B=await this.g.scanProfileExtensions(V,W.profileScanOptions);if(!B.length)return[];const te=await Promise.all(B.map(async se=>{if(Y(se)){const _=new M(se.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(_,se.metadata)}return null}));return(0,D.$Hb)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,c.$Dg)(V.location,"package.json"))){const Y=await this.scanExtension(V);return Y?[Y]:[]}else return await this.scanExtensions(V)}catch(Y){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,O.$0)(Y)),[]}}async scanExtension(V,Y){try{let W=await this.scanExtensionManifest(V.location);if(W){W.publisher||(W.publisher=E.$cm),Y=Y??W.__metadata,delete W.__metadata;const B=(0,d.$Ro)(W.publisher,W.name),te=Y?.id?{id:B,uuid:Y.id}:{id:B},se=Y?.isSystem?0:V.type,_=se===0||!!Y?.isBuiltin;W=await this.t(V.location,W,M.createNlsConfiguration(V));const re={type:se,identifier:te,manifest:W,location:V.location,isBuiltin:_,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return V.validate?this.validate(re,V):re}}catch(W){V.type!==0&&this.m.error(W)}return null}validate(V,Y){let W=!0;const B=(0,s.$3o)(Y.productVersion,Y.productDate,Y.location,V.manifest,V.isBuiltin);for(const[te,se]of B)te===y.default.Error&&(W=!1,this.m.error(this.z(Y.location,se)));return V.isValid=W,V.validations=B,V}async scanExtensionManifest(V){const Y=(0,c.$Dg)(V,"package.json");let W;try{W=(await this.j.readFile(Y)).value.toString()}catch(te){return(0,o.$Ck)(te)!==1&&this.m.error(this.z(V,(0,u.localize)(0,null,Y.path,te.message))),null}let B;try{B=JSON.parse(W)}catch{const se=[];(0,R.$0m)(W,se);for(const _ of se)this.m.error(this.z(V,(0,u.localize)(1,null,Y.path,_.offset,_.length,(0,k.$Jp)(_.error))));return null}return(0,R.$gn)(B)!=="object"?(this.m.error(this.z(V,(0,u.localize)(2,null,Y.path))),null):B}async t(V,Y,W){const B=await this.u(V,Y,W);if(B)try{const te=[],se=await this.w(B.default,te);if(te.length>0)return te.forEach(re=>{this.m.error(this.z(V,(0,u.localize)(3,null,B.default?.path,(0,k.$Jp)(re.error))))}),Y;if((0,R.$gn)(B)!=="object")return this.m.error(this.z(V,(0,u.localize)(4,null,B.default?.path))),Y;const _=B.values||Object.create(null);return(0,p.$Kp)(this.m,Y,_,se)}catch{}return Y}async u(V,Y,W){const B=(0,c.$Dg)(V,"package.nls.json"),te=(K,U)=>{U.forEach(P=>{this.m.error(this.z(V,(0,u.localize)(5,null,K?.path,(0,k.$Jp)(P.error))))})},se=K=>{this.m.error(this.z(V,(0,u.localize)(6,null,K?.path)))},_=`${Y.publisher}.${Y.name}`,re=W.translations[_];if(re)try{const K=l.URI.file(re),U=(await this.j.readFile(K)).value.toString(),P=[],A=(0,R.$0m)(U,P);return P.length>0?(te(K,P),{values:void 0,default:B}):(0,R.$gn)(A)!=="object"?(se(K),{values:void 0,default:B}):{values:A.contents?A.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let U;try{U=await this.y(V,W)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const P=(await this.j.readFile(U.localized)).value.toString(),A=[],H=(0,R.$0m)(P,A);return A.length>0?(te(U.localized,A),{values:void 0,default:U.original}):(0,R.$gn)(H)!=="object"?(se(U.localized),{values:void 0,default:U.original}):{values:H,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(V,Y){if(V)try{const W=(await this.j.readFile(V)).value.toString();return(0,R.$0m)(W,Y)}catch{}}y(V,Y){return new Promise((W,B)=>{const te=se=>{const _=(0,c.$Dg)(V,`package.nls.${se}.json`);this.j.exists(_).then(re=>{re&&W({localized:_,original:(0,c.$Dg)(V,"package.nls.json")});const K=se.lastIndexOf("-");K===-1?W({localized:(0,c.$Dg)(V,"package.nls.json"),original:null}):(se=se.substring(0,K),te(se))})};if(Y.devMode||Y.pseudo||!Y.language)return W({localized:(0,c.$Dg)(V,"package.nls.json"),original:null});te(Y.language)})}z(V,Y){return`[${V.path}]: ${Y}`}};T=pe([X(1,v.$Hp),X(2,f.$Vk),X(3,o.$lk),X(4,i.$jj)],T);let z=class extends T{constructor(V,Y,W,B,te,se,_){super(Y,B,te,se,_),this.G=V,this.H=W,this.D=this.B(new N.$Zg(3e3)),this.F=this.B(new r.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Y=this.M(V),W=await this.I(Y);if(this.C=V,W&&W.input&&M.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),W.result.map(te=>(te.location=l.URI.revive(te.location),te));const B=await super.scanExtensions(V);return await this.J(Y,{input:V,result:B}),B}async I(V){try{const Y=await this.j.readFile(V),W=JSON.parse(Y.value.toString());return{result:W.result,input:(0,a.$yh)(W.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",V.path,(0,O.$0)(Y))}return null}async J(V,Y){try{await this.j.writeFile(V,j.$ge.fromString(JSON.stringify(Y)))}catch(W){this.m.debug("Error while writing the extension cache file:",V.path,(0,O.$0)(W))}}async L(){if(!this.C)return;const V=this.M(this.C),Y=await this.I(V);if(!Y)return;const W=Y.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$ln(B,W))try{this.m.info("Invalidating Cache",W,B),await this.j.del(V),this.F.fire()}catch(te){this.m.error(te)}}M(V){const Y=this.N(V);return this.h.extUri.joinPath(Y.cacheHome,V.type===0?E.$bm:E.$am)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(V.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};z=pe([X(2,w.$Xk),X(3,v.$Hp),X(4,f.$Vk),X(5,o.$lk),X(6,i.$jj)],z);function Z(x,V){const Y=(0,d.$Po)(x.manifest.publisher,x.manifest.name);return{id:Y,identifier:new E.$gm(Y),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:V,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Op=Z;class J extends F{constructor(V,Y,W,B,te,se,_,re,K,U,P,A){super(V,Y,(0,c.$Dg)(W,".vscode-oss-dev","extensions","control.json"),B,te,se,_,re,K,U,P,A),this.R=(async()=>{if($.$z)try{const H=await this.w.readFile(l.URI.file($.$z));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$Pp=J}),define(le[245],he([0,1,66,6,38,3,2,23,16,31,8,17]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let $=class extends O.$Sc{constructor(g,y){super(),this.b=g,this.f=y,this.a=new N.$8g(5)}async postUninstall(g){const y=this.g(g,"uninstall");y&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(b)}}));try{await m.Promises.rm(this.m(g))}catch(b){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(b)}}g(g,y){const b=`vscode:${y}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[b]=="string"){const l=g.manifest.scripts[b].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${b} should be a node script`),null):{script:(0,k.$jc)(g.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(g,y,b,l,u){return new Promise((h,d)=>{const E=this.j(g,y,b,u);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?d(n):h(void 0)};E.on("error",n=>{o((0,L.$Mi)(n)||"Unknown")}),E.on("exit",(n,i)=>{o(n?`post-${y} process exited with code ${n}`:void 0)}),l&&(s=setTimeout(()=>{s=null,E.kill(),d("timed out")},5e3))})}j(g,y,b,l){const u={silent:!0,execArgv:void 0},h=(0,D.fork)(g,[`--type=extension-post-${y}`,...b],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const d=j.Event.fromNodeEventEmitter(h.stdout,"data"),E=j.Event.fromNodeEventEmitter(h.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,n)),E(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,n));const s=j.Event.any(j.Event.map(d,n=>({data:`%c${n}`,format:[""]})),j.Event.map(E,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(g){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Rp=$,e.$Rp=$=pe([X(0,S.$Xk),X(1,C.$jj)],$)}),define(le[113],he([0,1,6,15,26,38,7,3,53,2,34,23,16,19,55,12,10,32,31,69,155,96,14,244,29,33,51,81,224,245,183,213,225,70,11,4,8,25,22,28,17]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o,n,i,t,r,a,v,w,f,p,I,F,M,T,z,Z,J,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Vp=(0,M.$3h)(n.$mo);const V=".vsctmp";let Y=class extends o.$Cp{constructor(K,U,P,A,H,q,ee,G,Q,ie,ce,oe){super(K,U,ce,P,ie,oe),this.fb=H,this.gb=q,this.hb=ee,this.ib=Q,this.eb=new Map,this.rb=new C.$Bc;const fe=this.B(G.createInstance(v.$Rp));this.bb=this.B(G.createInstance(W,we=>fe.postUninstall(we))),this.cb=this.B(new f.$Tp(oe,Q,ce,this,this.F)),this.db=this.B(G.createInstance(a.$Qp));const de=this.B(new p.$Up(this,this.fb,oe,q,ce,Q,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Xo)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const U=await this.pb(K),P=await(0,h.zip)((0,c.$Dg)(this.db.extensionsDownloadDir,(0,l.$mg)()).fsPath,U);return b.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:U,cleanup:P}=await this.lb(K),A=$.$kc(U.fsPath);try{return await(0,w.$Sp)(A)}finally{await P()}}getInstalled(K,U=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,U)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,U={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:A}=await this.lb(K);try{const H=await(0,w.$Sp)($.$kc(P.fsPath)),q=(0,i.$Ro)(H.publisher,H.name);if(H.engines&&H.engines.vscode&&!(0,I.$5o)(H.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,q,this.G.version));const G=(await this.I([{manifest:H,extension:P,options:U}])).find(({identifier:Q})=>(0,i.$Mo)(Q,{id:q}));if(G?.local)return G.local;throw G?.error?G.error:(0,o.$Ep)(new Error(`Unknown error while installing extension ${q}`))}finally{await A()}}async installFromLocation(K,U){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],U),this.F.info("Successfully installed extension",P.identifier.id,U.toString()),P}async installExtensionsFromProfile(K,U,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,U.toString(),P.toString());const A=(await this.bb.scanExtensions(1,U)).filter(H=>K.some(q=>(0,i.$Mo)(q,H.identifier)));if(A.length){const H=await Promise.all(A.map(q=>this.bb.scanMetadata(q,U)));await this.ub(A.map((q,ee)=>[q,H[ee]]),P),this.F.info("Successfully installed extensions",A.map(q=>q.identifier.id),P.toString())}return A}async updateMetadata(K,U,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),K=await this.bb.updateMetadata(K,U,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const U=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:U,compatible:!0},L.CancellationToken.None);if(!P)throw new Error(d.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(A){throw new Error(d.localize(3,null,(0,j.$Mi)(A)))}return this.installFromGallery(P)}ab(K,U,P,A){return this.bb.copyExtension(K,U,P,A)}copyExtensions(K,U){return this.bb.copyExtensions(K,U)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,U,P){const{location:A}=await this.db.download(K,U,!P);return A}async lb(K){if(K.scheme===S.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const U=(0,c.$Dg)(this.db.extensionsDownloadDir,(0,l.$mg)());return await this.hb.download(K,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.ib.del(U)}catch(A){this.F.error(A)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,U,P){if(b.URI.isUri(U))return new se(K,U,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const A=i.$No.create(U).toString();let H=this.eb.get(A);return H||(this.eb.set(A,H=new te(K,U,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),H.waitUntilTaskIsFinished().finally(()=>this.eb.delete(A))),H}$(K,U){return new _(K,U.profileLocation,this.gb)}async pb(K){const U=async A=>{let H=await u.Promises.readdir(A);H=H.map(G=>$.$jc(A,G));const q=await Promise.all(H.map(G=>u.Promises.stat(G)));let ee=Promise.resolve([]);return q.forEach((G,Q)=>{const ie=H[Q];G.isFile()&&(ee=ee.then(ce=>[...ce,ie])),G.isDirectory()&&(ee=ee.then(ce=>U(ie).then(oe=>[...ce,...oe])))}),ee};return(await U(K.location.fsPath)).map(A=>({path:`extension/${$.$lc(K.location.fsPath,A)}`,localPath:A}))}async qb({added:K,removed:U}){if(U){const P=K&&this.D.extUri.isEqual(U.profileLocation,K.profileLocation)?U.extensions.filter(A=>K.extensions.every(H=>!(0,i.$Mo)(H,A))):U.extensions;for(const A of P)this.F.info("Extensions removed from another source",A.id,U.profileLocation.toString()),this.u.fire({identifier:A,profileLocation:U.profileLocation})}if(K){const A=(await this.bb.scanExtensions(1,K.profileLocation)).filter(H=>K.extensions.some(q=>(0,i.$Mo)(q,H.identifier)));this.s.fire(A.map(H=>(this.F.info("Extensions added from another source",H.identifier.id,K.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(U=>this.rb.add(U)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const U of K.children??[])U.isDirectory&&this.rb.add(U.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(U=>this.tb(U)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const U=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const A=await this.bb.scanUserExtensionAtLocation(P);A&&A.installedTimestamp===void 0&&(this.rb.add(P),U.push(A))}U.length&&(await this.ub(U.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(P=>P.identifier.id)))}async ub(K,U){const P=K.map(A=>A[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,U),this.s.fire(P.map(A=>({local:A,identifier:A.identifier,operation:1,profileLocation:U})))}async vb(K){const U=await this.bb.getUninstalledExtensions();for(const P of K){const A=i.$No.create(P);U[A.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",A.id),await this.bb.setInstalled(A),this.F.info("Removed the extension from uninstalled list:",A.id))}}};e.$Wp=Y,e.$Wp=Y=pe([X(0,n.$ko),X(1,Z.$pl),X(2,T.$jj),X(3,s.$0h),X(4,r.$Lp),X(5,t.$Hp),X(6,E.$2n),X(7,M.$1h),X(8,F.$lk),X(9,z.$Bj),X(10,J.$Vk),X(11,x.$Xk)],Y);let W=class extends m.$Sc{constructor(K,U,P,A,H,q){super(),this.j=K,this.m=U,this.n=P,this.s=A,this.t=H,this.u=q,this.h=this.B(new R.$Sd),this.onExtract=this.h.event,this.c=(0,c.$Dg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$9g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,U){const P={includeInvalid:!0,profileLocation:U};let A=[];return K===null||K===0?A.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&A.push(...await this.n.scanUserExtensions(P)),A=K!==null?A.filter(H=>H.type===K):A,Promise.all(A.map(H=>this.F(H)))}async scanAllUserExtensions(K){const U=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(U.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const U=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(K,U,P,A,H){const q=K.toString(),ee=b.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$mg)()}`)),G=b.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,q));let Q=await this.m.exists(G);if(Q&&A){try{await this.y(K.id,G,"removeExisting")}catch{throw new n.$lo(d.localize(4,null,G.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}Q=!1}if(!Q)try{try{this.u.trace(`Started extracting the extension from ${U} to ${G.fsPath}`),await(0,h.$Ap)(U,ee.fsPath,{sourcePath:"extension",overwrite:!0},H),this.u.info(`Extracted extension to ${G}:`,K.id)}catch(ie){let ce=n.ExtensionManagementErrorCode.Extract;throw ie instanceof h.$yp&&(ie.type==="CorruptZip"?ce=n.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(ce=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$lo(ie.message,ce)}await this.n.updateMetadata(ee,P);try{this.u.trace(`Started renaming the extension from ${ee.fsPath} to ${G.fsPath}`),await this.C(ee.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(ie)}. Deleted from extracted location`,ee),ie}this.h.fire(G)}catch(ie){try{await this.m.del(ee,{recursive:!0})}catch{}throw ie}return this.D(G,1)}async scanMetadata(K,U){return U?(await this.w(K,U))?.metadata:this.n.scanMetadata(K.location)}async w(K,U){return(await this.s.scanProfileExtensions(U)).find(A=>(0,i.$Mo)(A.identifier,K.identifier))}async updateMetadata(K,U,P){return P?await this.s.updateMetadata([[K,U]],P):await this.n.updateMetadata(K.location,U),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const U=K.map(P=>i.$No.create(P));await this.z(P=>U.forEach(A=>{P[A.toString()]=!0,this.u.info("Marked extension as uninstalled",A.toString())}))}async setInstalled(K){await this.z(U=>delete U[K.toString()])}async removeExtension(K,U){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,U)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(U=>delete U[i.$No.create(K).toString()])}async copyExtension(K,U,P,A){const H=await this.w(K,U),q=await this.w(K,P);return A={...H?.metadata,...A},q?await this.s.updateMetadata([[K,{...q.metadata,...A}]],P):await this.s.addExtensionsToProfile([[K,A]],P),this.D(K.location,K.type,P)}async copyExtensions(K,U){const P=await this.scanExtensions(1,K),A=await Promise.all(P.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,K)]));await this.s.addExtensionsToProfile(A,U)}async y(K,U,P){this.u.trace(`Deleting ${P} extension from disk`,K,U.fsPath);const A=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,k.$Pi)((0,l.$mg)()).toString(16)}${V}`);await this.C(U.fsPath,A.fsPath),await this.m.del(A,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,U.fsPath)}async z(K){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(A){if((0,F.$Ck)(A)!==1)throw A}let P={};if(U)try{P=JSON.parse(U)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,N.$ge.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,U){try{await u.Promises.rename(K,U,2*60*1e3)}catch(P){throw new n.$lo(P.message||d.localize(5,null,K,U),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,U,P){if(P){const H=(await this.n.scanUserExtensions({profileLocation:P})).find(q=>this.t.extUri.isEqual(q.location,K));if(H)return this.F(H)}else{const A=await this.n.scanExistingExtension(K,U,{includeInvalid:!0});if(A)return this.F(A)}throw new Error(d.localize(6,null,K.path))}async F(K){const U=await this.m.resolve(K.location);let P,A;return U.children&&(P=U.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,A=U.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:A,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const H of U)K[i.$No.create(H).toString()]||P.add(H.identifier.id.toLowerCase());try{const H=(0,i.$So)(U,q=>q.identifier);await D.Promises.settled(H.map(async q=>{const ee=q.sort((G,Q)=>g.rcompare(G.manifest.version,Q.manifest.version))[0];P.has(ee.identifier.id.toLowerCase())||await this.j(await this.F(ee))}))}catch(H){this.u.error(H)}const A=U.filter(H=>H.metadata&&K[i.$No.create(H).toString()]);await Promise.allSettled(A.map(H=>this.removeUninstalledExtension(H)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,F.$Ck)(U)!==1&&this.u.error(U);return}if(K?.children)try{await Promise.allSettled(K.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(P){(0,F.$Ck)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Xp=W,e.$Xp=W=pe([X(1,F.$lk),X(2,r.$Lp),X(3,t.$Hp),X(4,J.$Vk),X(5,T.$jj)],W);class B extends o.$Fp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Lf)(this.options.operation)?this.l:this.options.operation}constructor(K,U,P,A,H,q,ee,G,Q){super(),this.identifier=K,this.source=U,this.options=P,this.m=A,this.n=H,this.o=q,this.p=ee,this.q=G,this.s=Q,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[U,P]=await this.x(K);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,P]],this.j),U}async u({zipPath:K,key:U,metadata:P},A,H){let q=await this.v(U);return q||(this.s.trace("Extracting extension...",U.id),q=await this.m.extractUserExtension(U,K,P,A,H),this.s.info("Extracting extension completed.",U.id)),q}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(A=>i.$No.create(A).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class te extends B{constructor(K,U,P,A,H,q,ee,G,Q,ie){super(U.identifier,U,P,H,q,ee,G,Q,ie),this.y=U,this.z=A}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,i.$Mo)(ee.identifier,this.y.identifier));P&&(this.l=3);const A={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Kf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,A),A];const{location:H,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(H.fsPath),[await this.u({zipPath:H.fsPath,key:i.$No.create(this.y),metadata:A},!1,K),A]}catch(ee){try{await this.z.delete(H)}catch(G){this.s.warn("Error while deleting the downloaded file",H.toString(),(0,O.$0)(G))}throw ee}}async B(K){try{await(0,w.$Sp)(K)}catch(U){throw new n.$lo((0,o.$Dp)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Yp=te;class se extends B{constructor(K,U,P,A,H,q,ee,G,Q,ie){super({id:(0,i.$Ro)(K.publisher,K.name)},U,P,H,q,ee,G,Q,ie),this.y=K,this.z=U,this.A=A}async h(K){const U=await super.h(K);return this.D(U,K),U}async x(K){const U=new i.$No(this.identifier,this.y.version),A=(await this.m.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,i.$Mo)(this.identifier,ee.identifier)),H={isApplicationScoped:this.options.isApplicationScoped||A?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||A?.isMachineScoped,isBuiltin:this.options.isBuiltin||A?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??A?.pinned};if(A)if(this.l=3,U.equals(new i.$No(A.identifier,A.manifest.version)))try{await this.m.removeExtension(A,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(A.manifest.version,this.y.version)&&await this.m.setUninstalled(A);else{const ee=await this.v(U);if(ee)try{await this.m.removeExtension(ee,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$kc(this.z.fsPath),key:U,metadata:H},!0,K),H]}async D(K,U){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],U);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],U)),P){const A={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,A,this.options.profileLocation)}}catch{}}}class _ extends o.$Fp{constructor(K,U,P){super(),this.extension=K,this.j=U,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,17,28,22,51,11,14,10]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;let C=class extends O.$Ip{constructor($,c,g,y,b,l){super(m.URI.file($.extensionsPath),c,g,y,b,l)}};e.$aO=C,e.$aO=C=pe([X(0,k.$0h),X(1,R.$lk),X(2,N.$Xk),X(3,L.$Vk),X(4,j.$pl),X(5,D.$jj)],C)}),define(le[247],he([0,1,10,14,51,81,11,4,8,25,28,17]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0;let $=class extends j.$Pp{constructor(g,y,b,l,u,h,d,E){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,g.defaultProfile,g,y,b,l,u,h,d,E)}};e.$N0b=$,e.$N0b=$=pe([X(0,S.$Xk),X(1,L.$Hp),X(2,O.$lk),X(3,k.$jj),X(4,N.$0h),X(5,m.$Bj),X(6,C.$Vk),X(7,R.$1h)],$)}),define(le[21],he([0,1,6,3,2,100,12,68,4,17]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gp=e.$fp=e.$ep=void 0,e.$ep="__$__isNewStorageMarker",e.$fp="__$__targetStorageMarker",e.$gp=(0,k.$2h)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var $;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function c(u){const h=u.get(e.$fp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$hp=c;class g extends L.$Sc{static{this.a=60*1e3}constructor(h={flushInterval:g.a}){super(),this.m=h,this.b=this.B(new N.$Vd),this.c=this.B(new N.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,d,E){return N.Event.filter(this.b.event,s=>s.scope===h&&(d===void 0||s.key===d),E)}n(){this.j.value=(0,D.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,d){const{key:E,external:s}=d;if(E===e.$fp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:E,target:this.J(h)[E],external:s})}w(h){this.f.fire({reason:h})}get(h,d,E){return this.P(d)?.get(h,E)}getBoolean(h,d,E){return this.P(d)?.getBoolean(h,E)}getNumber(h,d,E){return this.P(d)?.getNumber(h,E)}getObject(h,d,E){return this.P(d)?.getObject(h,E)}storeAll(h,d){this.y(()=>{for(const E of h)this.store(E.key,E.value,E.scope,E.target,d)})}store(h,d,E,s,o=!1){if((0,O.$Nf)(d)){this.remove(h,E,o);return}this.y(()=>{this.z(h,E,s),this.P(E)?.set(h,d,o)})}remove(h,d,E=!1){this.y(()=>{this.z(h,d,void 0),this.P(d)?.delete(h,E)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,d){const E=[],s=this.J(h);for(const o of Object.keys(s))s[o]===d&&E.push(o);return E}z(h,d,E,s=!1){const o=this.J(d);typeof E=="number"?o[h]!==E&&(o[h]=E,this.P(d)?.set(e.$fp,JSON.stringify(o),s)):typeof o[h]=="number"&&(delete o[h],this.P(d)?.set(e.$fp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const d=this.P(h);return d?c(d):Object.create(null)}isNew(h){return this.getBoolean(e.$ep,h)===!0}async flush(h=C.NONE){this.f.fire({reason:h});const d=this.P(-1),E=this.P(0),s=this.P(1);switch(h){case C.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return l(h,d,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,d){return this.w(C.NONE),(0,m.$Wk)(h)?this.R(h,d):this.S(h,d)}M(h,d){return!(h.id===d.id||y(d)&&y(h))}N(h,d,E){this.y(()=>{const s=new Set;for(const[o,n]of h)s.add(o),d.get(o)!==n&&this.u(E,{key:o,external:!0});for(const[o]of d.items)s.has(o)||this.u(E,{key:o,external:!0})})}}e.$ip=g;function y(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$jp=y;class b extends g{constructor(){super(),this.U=this.B(new R.$cp(new R.$dp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$cp(new R.$dp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$cp(new R.$dp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$kp=b;async function l(u,h,d,E,s,o){const n=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,t=new Map;u.forEach((I,F)=>{i.set(F,I),t.set(F,n(I))});const r=new Map,a=new Map;h.forEach((I,F)=>{r.set(F,I),a.set(F,n(I))});const v=new Map,w=new Map;d.forEach((I,F)=>{v.set(F,I),w.set(F,n(I))}),console.group(E!==s?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const f=[];if(i.forEach((I,F)=>{f.push({key:F,value:I})}),console.table(f),console.groupEnd(),console.log(t),E!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const I=[];r.forEach((F,M)=>{I.push({key:M,value:F})}),console.table(I),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];v.forEach((I,F)=>{p.push({key:F,value:I})}),console.table(p),console.groupEnd(),console.log(w)}e.$lp=l}),define(le[114],he([0,1,3,2,12,29,33,21]),function(ne,e,D,N,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HEb=e.$GEb=void 0;let k=class extends N.$Sc{constructor(S,$){super(),this.a=new D.$Sd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new m(S)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B($.onDidInstallExtensions(c=>c.forEach(({local:g,operation:y})=>{g&&y===4&&this.f(g.identifier)})))}async enableExtension(S,$){return this.f(S)?(this.a.fire({extensions:[S],source:$}),!0):!1}async disableExtension(S,$){return this.c(S)?(this.a.fire({extensions:[S],source:$}),!0):!1}getDisabledExtensions(){return this.h(j.$no)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const $=this.getDisabledExtensions();return $.every(c=>!(0,O.$Mo)(c,S))?($.push(S),this.g($),!0):!1}f(S){const $=this.getDisabledExtensions();for(let c=0;c<$.length;c++){const g=$[c];if((0,O.$Mo)(g,S))return $.splice(c,1),this.g($),!0}return!1}g(S){this.j(j.$no,S)}h(S){return this.b.get(S,0)}j(S,$){this.b.set(S,$,0)}};e.$GEb=k,e.$GEb=k=pe([X(0,R.$gp),X(1,j.$mo)],k);class m extends N.$Sc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new D.$Sd),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new N.$Rc))($=>this.f($)))}get(S,$){let c;return $===0?((0,L.$Nf)(this.a[S])&&(this.a[S]=this.g(S,$)),c=this.a[S]):c=this.g(S,$),JSON.parse(c)}set(S,$,c){const g=JSON.stringify($.map(({id:b,uuid:l})=>({id:b,uuid:l})));this.g(S,c)!==g&&(c===0&&($.length?this.a[S]=g:delete this.a[S]),this.h(S,$.length?g:void 0,c))}f(S){if(!(0,L.$Nf)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const c=this.get(S.key,S.scope);delete this.a[S.key];const g=this.get(S.key,S.scope),y=c.filter(l=>!g.some(u=>(0,O.$Mo)(l,u))),b=g.filter(l=>!c.some(u=>(0,O.$Mo)(u,l)));(y.length||b.length)&&this.b.fire([...y,...b])}}g(S,$){return this.c.get(S,$,"[]")}h(S,$,c){$?this.c.store(S,$,c,1):this.c.remove(S,c)}}e.$HEb=m}),define(le[248],he([0,1,18,26,7,5,37,12,10,20,14,29,33,70,11,8,25,59,226,21,22,62]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=void 0;const s=j.$o?"web":(0,S.$go)(j.$u,O.$ec),o="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((A,H)=>A|H,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(A=w){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,H=this.d.pageSize){return new f({...this.d,pageNumber:A,pageSize:H})}withFilter(A,...H){const q=[...this.d.criteria,...H.length?H.map(ee=>({filterType:A,value:ee})):[{filterType:A}]];return new f({...this.d,criteria:q})}withSortBy(A){return new f({...this.d,sortBy:A})}withSortOrder(A){return new f({...this.d,sortOrder:A})}withFlags(...A){return new f({...this.d,flags:A.reduce((H,q)=>H|q,0)})}withAssetTypes(...A){return new f({...this.d,assetTypes:A})}withSource(A){return new f({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:H,pageSize:q,sortBy:ee,sortOrder:G,flags:Q,assetTypes:ie}=this.d;return{filters:[{criteria:A,pageNumber:H,pageSize:q,sortBy:ee,sortOrder:G}],assetTypes:ie,flags:Q}}get searchText(){const A=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(P,A){const H=(P||[]).filter(q=>q.statisticName===A)[0];return H?H.value:0}function I(P){const A="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(q=>q.assetType.indexOf(A)===0).reduce((q,ee)=>{const G=T(P,ee.assetType);return G&&q.push([ee.assetType.substring(A.length),G]),q},[])}function F(P){if(P.properties){const A=P.properties.filter(ee=>ee.key===r.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=A.filter(ee=>H.test(ee.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return T(P,r.Repository)}function M(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function T(P,A){return P.files.filter(q=>q.assetType===A)[0]?{uri:`${P.assetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function z(P,A){const H=P.properties?P.properties.filter(ee=>ee.key===A):[],q=H.length>0&&H[0].value;return q?q.split(",").map(ee=>(0,$.$Qo)(ee)):[]}function Z(P){const A=P.properties?P.properties.filter(H=>H.key===a.Engine):[];return A.length>0&&A[0].value||""}function J(P){const A=P.properties?P.properties.filter(H=>H.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(P){const A=P.properties?P.properties.filter(q=>q.key===a.LocalizedLanguages):[],H=A.length>0&&A[0].value||"";return H?H.split(","):[]}function V(P){return P.properties?.find(A=>A.key===a.SponsorLink)?.value}function Y(P){return P.indexOf("preview")!==-1}function W(P){return P.targetPlatform?(0,S.$fo)(P.targetPlatform):"undefined"}function B(P){const A=(0,D.$Mb)(P.versions.map(W)),H=!!P.tags?.includes(S.$ao),q=A.indexOf("web");return H?q===-1&&A.push("web"):q!==-1&&A.splice(q,1),A}function te(P,A){for(let H=0;H<P.length;H++){const q=P[H];if(q.version===P[H-1]?.version){let ee=H;if(W(q)===A)for(;ee>0&&P[ee-1].version===q.version;)ee--;ee!==H&&(P.splice(H,1),P.splice(ee,0,q))}}return P}e.$op=te;function se(P,A,H){P.telemetryData={index:A,querySource:H,queryActivityId:P.queryContext?.[o]}}function _(P,A,H,q){const ee=P.versions[0],G={manifest:T(A,r.Manifest),readme:T(A,r.Details),changelog:T(A,r.Changelog),license:T(A,r.License),repository:F(A),download:M(A),icon:T(A,r.Icon),signature:T(A,r.Signature),coreTranslations:I(A)};return{identifier:{id:(0,$.$Ro)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:A.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(ee),description:P.shortDescription||"",installCount:p(P.statistics,"install"),rating:p(P.statistics,"averagerating"),ratingCount:p(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:H,assets:G,properties:{dependencies:z(A,a.Dependency),extensionPack:z(A,a.ExtensionPack),engine:Z(A),localizedLanguages:x(A),targetPlatform:W(A),isPreReleaseVersion:J(A)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:Y(P.flags),isSigned:!!G.signature,queryContext:q}}let re=class{constructor(A,H,q,ee,G,Q,ie,ce){this.k=H,this.l=q,this.n=ee,this.o=G,this.q=Q,this.u=ie,this.w=ce;const oe=ie.extensionsGallery,fe=oe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=fe?oe.servicePPEUrl:oe?.serviceUrl,this.g=fe?void 0:oe?.searchUrl,this.h=oe?.controlUrl,this.j=(0,u.$np)(ie.version,ie,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,H,q){const ee=N.CancellationToken.isCancellationToken(H)?{}:H,G=N.CancellationToken.isCancellationToken(H)?H:q,Q=[],ie=[],ce=[],oe=[];let fe=!0;for(const ve of A){ve.uuid?ie.push(ve.uuid):Q.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ce.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&oe.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ie}if(!ie.length&&!Q.length)return[];let de=new f().withPage(1,A.length);ie.length&&(de=de.withFilter(t.ExtensionId,...ie)),Q.length&&(de=de.withFilter(t.ExtensionName,...Q)),(ee.queryAllVersions||fe)&&(de=de.withFlags(de.flags,n.IncludeVersions)),ee.source&&(de=de.withSource(ee.source));const{extensions:we}=await this.z(de,{targetPlatform:ee.targetPlatform??s,includePreRelease:ce,versions:oe,compatible:!!ee.compatible},G);return ee.source&&we.forEach((ve,Ie)=>se(ve,Ie,ee.source)),we}async getCompatibleExtension(A,H,q){if((0,S.$ho)(A.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(A,H,q))return A;const ee=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,A.identifier.uuid),{extensions:G}=await this.z(ee,{targetPlatform:q,compatible:!0,includePreRelease:H},N.CancellationToken.None);return G[0]||null}async isExtensionCompatible(A,H,q){if(!(0,S.$io)(A.properties.targetPlatform,A.allTargetPlatforms,q)||!H&&A.properties.isPreReleaseVersion)return!1;let ee=A.properties.engine;if(!ee){const G=await this.getManifest(A,N.CancellationToken.None);if(!G)throw new Error("Manifest was not found");ee=G.engines.vscode}return(0,c.$5o)(ee,this.u.version,this.u.date)}async y(A,H,q,ee,G){if(!(0,S.$io)(W(A),ee,G)||H!=="any"&&J(A)!==(H==="prerelease"))return!1;if(q)try{const Q=await this.E(A);if(!(0,c.$5o)(Q,this.u.version,this.u.date))return!1}catch(Q){return this.l.error(`Error while getting the engine for the version ${A.version}.`,(0,L.$0)(Q)),!1}return!0}async query(A,H){let q=A.text||"";const ee=A.pageSize??50;let G=new f().withPage(1,ee);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(G=G.withFilter(t.Category,we||de),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),G=G.withFilter(t.SearchText,q)),G=G.withSortBy(0)):A.ids?G=G.withFilter(t.ExtensionId,...A.ids):A.names?G=G.withFilter(t.ExtensionName,...A.names):G=G.withSortBy(4),typeof A.sortBy=="number"&&(G=G.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(G=G.withSortOrder(A.sortOrder)),A.source&&(G=G.withSource(A.source));const Q=async(fe,de)=>{const{extensions:we,total:ve}=await this.z(fe,{targetPlatform:s,compatible:!1,includePreRelease:!!A.includePreRelease},de);return we.forEach((Ie,De)=>se(Ie,(fe.pageNumber-1)*fe.pageSize+De,A.source)),{extensions:we,total:ve}},{extensions:ie,total:ce}=await Q(G,H),oe=async(fe,de)=>{if(de.isCancellationRequested)throw new L.$5;const{extensions:we}=await Q(G.withPage(fe+1),de);return we};return{firstPage:ie,total:ce,pageSize:G.pageSize,getPage:oe}}async z(A,H,q){const ee=A.flags;A.flags&n.IncludeLatestVersionOnly&&A.flags&n.IncludeVersions&&(A=A.withFlags(A.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(A.flags&n.IncludeLatestVersionOnly)&&!(A.flags&n.IncludeVersions)&&(A=A.withFlags(A.flags,n.IncludeLatestVersionOnly)),H.versions?.length&&(A=A.withFlags(A.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),A=A.withFlags(A.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:Q,context:ie}=await this.B(A,q);if(!(A.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const ve=await this.A(we,H,ie);ve&&de.push(ve)}return{extensions:de,total:Q}}const oe=[],fe=new Map;for(let de=0;de<G.length;de++){const we=G[de],ve={id:(0,$.$Ro)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$Kf)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Me=>(0,$.$Mo)(Me,ve))?.includePreRelease;if(H.compatible&&(0,S.$ho)(B(we),H.targetPlatform))continue;const De=await this.A(we,H,ie);!De||De.properties.isPreReleaseVersion&&(!Ie||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==H.targetPlatform&&De.hasPreReleaseVersion?fe.set(we.extensionId,de):oe.push([de,De])}if(fe.size){const de=new E.$Od,we=new f().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(we,H,q);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:fe.size});for(const Ie of ve){const De=fe.get(Ie.identifier.uuid);oe.push([De,Ie])}}return{extensions:oe.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:Q}}async A(A,H,q){const ee={id:(0,$.$Ro)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},G=H.versions?.find(oe=>(0,$.$Mo)(oe,ee))?.version,Q=(0,R.$Kf)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(oe=>(0,$.$Mo)(oe,ee))?.includePreRelease,ie=B(A),ce=te(A.versions,H.targetPlatform);if(H.compatible&&(0,S.$ho)(ie,H.targetPlatform))return null;for(let oe=0;oe<ce.length;oe++){const fe=ce[oe];if(!(G&&fe.version!==G)){if(await this.y(fe,Q?"any":"release",H.compatible,ie,H.targetPlatform))return _(A,fe,ie,q);if(G&&fe.version===G)return null}}return G||H.compatible?null:_(A,A.versions[0],ie)}async B(A,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const q=await this.j,ee=JSON.stringify(A.raw),G={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Q=new E.$Od;let ie,ce,oe=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&A.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:G},H),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:oe};const fe=await(0,l.$_o)(ie);if(fe){const de=fe.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return oe=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:oe,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:oe}}catch(fe){throw ce=fe,fe}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(ee.length),duration:Q.elapsed(),success:!!ie&&(0,l.$8o)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ce?(0,L.$4)(ce)?"canceled":(0,L.$0)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(oe)})}}async reportStatistic(A,H,q,ee){if(!this.isEnabled())return;const G=j.$o?this.x(`/itemName/${A}.${H}/version/${q}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${H}/${q}/stats?statType=${ee}`),Q=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:G,headers:ce},N.CancellationToken.None)}catch{}}async download(A,H,q){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const ee=(0,$.$Uo)(A),G=new Date().getTime(),Q=de=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=q===2?"install":q===3?"update":"",ce=ie?{uri:`${A.assets.download.uri}${k.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${k.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,oe=A.queryContext?.[o]?{[o]:A.queryContext[o]}:void 0,fe=await this.D(ce,oe?{headers:oe}:void 0);await this.q.writeFile(H,fe.stream),Q(new Date().getTime()-G)}async downloadSignatureArchive(A,H){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const q=await this.D(A.assets.signature);await this.q.writeFile(H,q.stream)}async getReadme(A,H){if(A.assets.readme){const q=await this.D(A.assets.readme,{},H);return await(0,l.$$o)(q)||""}return""}async getManifest(A,H){if(A.assets.manifest){const q=await this.D(A.assets.manifest,{},H),ee=await(0,l.$$o)(q);return ee?JSON.parse(ee):null}return null}async C(A,H){const q=T(A,r.Manifest);if(!q)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},G=await this.D(q,{headers:ee});return await(0,l.$_o)(G)}async getCoreTranslation(A,H){const q=A.assets.coreTranslations.filter(ee=>ee[0]===H.toUpperCase())[0];if(q){const ee=await this.D(q[1]),G=await(0,l.$$o)(ee);return G?JSON.parse(G):null}return null}async getChangelog(A,H){if(A.assets.changelog){const q=await this.D(A.assets.changelog,{},H);return await(0,l.$$o)(q)||""}return""}async getAllCompatibleVersions(A,H,q){let ee=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?ee=ee.withFilter(t.ExtensionId,A.identifier.uuid):ee=ee.withFilter(t.ExtensionName,A.identifier.id);const{galleryExtensions:G}=await this.B(ee,N.CancellationToken.None);if(!G.length)return[];const Q=B(G[0]);if((0,S.$ho)(Q,q))return[];const ie=[];await Promise.all(G[0].versions.map(async fe=>{try{await this.y(fe,H?"any":"release",!0,Q,q)&&ie.push(fe)}catch{}}));const ce=[],oe=new Set;for(const fe of te(ie,q))oe.has(fe.version)||(oe.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:J(fe)}));return ce}async D(A,H={},q=N.CancellationToken.None){const ee=await this.j,G={type:"GET"},Q={...ee,...H.headers||{}};H={...H,...G,headers:Q};const ie=A.uri,ce=A.fallbackUri,oe={...H,url:ie};try{const fe=await this.k.request(oe,q);if(fe.res.statusCode===200)return fe;const de=await(0,l.$$o)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${de}`)}catch(fe){if((0,L.$4)(fe))throw fe;const de=(0,L.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:de});const we={...H,url:ce};return this.k.request(we,q)}}async E(A){let H=Z(A);if(!H){const q=await this.C(A,N.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const A=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,l.$_o)(A),q=[],ee={},G=[];if(H){for(const Q of H.malicious)q.push({id:Q});if(H.migrateToPreRelease)for(const[Q,ie]of Object.entries(H.migrateToPreRelease))(!ie.engine||(0,c.$5o)(ie.engine,this.u.version,this.u.date))&&(ee[Q.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[Q,ie]of Object.entries(H.deprecated))ie&&(ee[Q.toLowerCase()]=(0,R.$Kf)(ie)?{}:ie);if(H.search)for(const Q of H.search)G.push(Q)}return{malicious:q,deprecated:ee,search:G}}};re=pe([X(1,l.$6o),X(2,y.$jj),X(3,C.$9h),X(4,d.$pl),X(5,g.$lk),X(6,b.$Bj),X(7,m.$vi)],re);let K=class extends re{constructor(A,H,q,ee,G,Q,ie,ce){super(A,H,q,ee,G,Q,ie,ce)}};e.$pp=K,e.$pp=K=pe([X(0,h.$gp),X(1,l.$6o),X(2,y.$jj),X(3,C.$9h),X(4,d.$pl),X(5,g.$lk),X(6,b.$Bj),X(7,m.$vi)],K);let U=class extends re{constructor(A,H,q,ee,G,Q,ie){super(void 0,A,H,q,ee,G,Q,ie)}};e.$qp=U,e.$qp=U=pe([X(0,l.$6o),X(1,y.$jj),X(2,C.$9h),X(3,d.$pl),X(4,g.$lk),X(5,b.$Bj),X(6,m.$vi)],U)}),define(le[82],he([0,1,4,3,2,21,33,25,18,8,12]),function(ne,e,D,N,L,j,O,R,k,m,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=void 0,e.$$u=(0,D.$2h)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends L.$Sc{static{S=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$Qo)(y.id)}@${y.version}`}static c(y){const b=$.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(y,b){const l=await y.getInstalled(),u=[];for(const[h,d]of S.f(b)){const E=l.find(s=>(0,O.$Mo)(s.identifier,{id:h}))?.manifest.version;for(const s of d)E!==s&&u.push(S.b({id:h,version:s}))}for(const h of u)b.remove(h,0)}static f(y){const b=new Map,l=y.keys(0,1);for(const u of l){const h=S.c(u);if(h){let d=b.get(h.id.toLowerCase());d||b.set(h.id.toLowerCase(),d=[]),d.push(h.version)}}return b}constructor(y,b,l){super(),this.j=y,this.m=b,this.n=l,this.g=this.B(new N.$Sd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Rc))(u=>this.r(u)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const b=S.c(y.key);if(b){if(this.j.get(y.key,0)===void 0)this.h.delete(b.id.toLowerCase());else{let l=this.h.get(b.id.toLowerCase());l||this.h.set(b.id.toLowerCase(),l=[]),l.push(b.version),this.g.fire()}return}}s(y){if((0,C.$Ef)(y))return y;const b=y.manifest?y.manifest.publisher:y.publisher,l=y.manifest?y.manifest.name:y.name;return(0,O.$Po)(b,l)}getExtensionState(y,b){const l=this.s(y),u=this.getExtensionStateRaw(y,b);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${b}): ${h}`)}}getExtensionStateRaw(y,b){const l=this.s(y),u=this.j.get(l,b?0:1);return u&&u?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${b}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(y,b,l){const u=this.s(y);b===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(b),l?0:1,1)}setKeysForSync(y,b){this.j.store(S.b(y),JSON.stringify(b),0,1)}getKeysForSync(y){const b=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],l=this.j.get(S.b(y),0),u=l?JSON.parse(l):void 0;return u&&b?(0,k.$Mb)([...u,...b]):u||b}addToMigrationList(y,b){if(y!==b){const l=this.t.filter(u=>!u.includes(y)&&!u.includes(b));l.push([y,b]),this.t=l}}getSourceExtensionToMigrate(y){const b=this.t.find(([,l])=>y===l);return b?b[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const b=JSON.parse(y);if(Array.isArray(b))return b}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$_u=c,e.$_u=c=S=pe([X(0,j.$gp),X(1,R.$Bj),X(2,m.$jj)],c)}),define(le[249],he([0,1,2,29,82,223,113,8,21]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;let m=class extends D.$Sc{constructor(S,$,c,g,y,b){super(),S.cleanUp(),(0,j.$HYb)(S,$,c,g,b),L.$_u.removeOutdatedExtensionVersions(S,y)}};e.$5$b=m,e.$5$b=m=pe([X(0,O.$Vp),X(1,N.$ko),X(2,L.$$u),X(3,N.$po),X(4,k.$gp),X(5,R.$jj)],m)}),define(le[250],he([0,1,29,11,25,14,98,57,21,22,222]),function(ne,e,D,N,L,j,O,R,k,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0;let S=class extends C.$m8b{constructor(c,g,y,b,l,u,h,d){super(c.userHome,l,g,y,b,u,h,d)}};e.$_$b=S,e.$_$b=S=pe([X(0,j.$0h),X(1,m.$pl),X(2,D.$mo),X(3,k.$gp),X(4,R.$29b),X(5,O.$rYb),X(6,N.$lk),X(7,L.$Bj)],S)}),define(le[251],he([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;const E=[D.$1$b,D.$2$b],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Sc{constructor(a,v,w,f,p,I,F){super(),this.y=a,this.z=v,this.C=w,this.D=I,this.F=F,this.f=new N.$Sd,this.onDidTokenFailed=this.f.event,this.g=new N.$Sd,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Sd,this.onDidChangeMode=this.h.event,this.n=D.$Y$b,this.w=!1,this.I=(M,T)=>{T?this.j.error(M):this.j.info(M)},this.j=this.B(f.createLogger((0,d.$Dg)(w.logsHome,`${D.$3$b}.log`),{id:D.$3$b,name:D.$4$b})),this.t=new $.$Yg(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,R.$yj)(M)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(M=>{E.some(T=>M.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(D.$Y$b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(T,z)=>{z?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,y.localize)(0,null)))},f=this.O("status",["status"],w);this.r=f;try{if(await f,this.r!==f)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(D.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const T=p.token;this.G(D.TunnelStates.connecting((0,y.localize)(1,null,p.accountLabel,p.providerId)));const z=(J,x)=>{J=J.replaceAll(T,"*".repeat(4)),w(J,x)},Z=this.O("login",["user","login","--provider",p.providerId,"--access-token",T,"--log",(0,R.$yj)(this.j.getLevel())],z);this.r=Z;try{if(await Z,this.r!==Z)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(p),this.G(D.TunnelStates.disconnected(p));return}}const I=this.Q();I?this.G(D.TunnelStates.connecting((0,y.localize)(2,null,I))):this.G(D.TunnelStates.connecting((0,y.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,R.$yj)(this.j.getLevel())];I?F.push("--name",I):F.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(F)===!1),this.N(p,F,M)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,y.localize)(4,null);return this.j.warn(w),this.G(D.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const p=this.O("tunnel",v,(I,F)=>{F?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(f=!0);const M=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const T={link:M[1],domain:M[2],tunnelName:M[4],isAttached:f};this.G(D.TunnelStates.connected(T,w))}else I.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$Y$b,this.G(D.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,$.$Pg)(f=>new Promise((p,I)=>{f.isCancellationRequested&&p(-1);let F;const M=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,m.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:M});else{w(`Running tunnel CLI
`,!1);const T=this.J();w(`${a} Spawning: ${T} tunnel ${v.join(" ")}
`,!1),F=(0,m.spawn)(T,["tunnel",...v],{cwd:(0,b.homedir)(),stdio:M})}F.stdout.pipe(new h.$aU(`
`)).on("data",T=>{if(F){const z=T.toString();w(z,!1)}}),F.stderr.pipe(new h.$aU(`
`)).on("data",T=>{if(F){const z=T.toString();w(z,!0)}}),F.on("exit",T=>{F&&(w(`${a} exit(${F.pid}): + ${T} `,!1),F=void 0,p(T||0))}),F.on("error",T=>{F&&(w(`${a} error(${F.pid}): + ${T} `,!0),F=void 0,I())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$2$b)}Q(){let a=this.D.getValue(D.$1$b)||(0,b.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(s,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,u.$Ef)(w.accountLabel)&&(0,u.$Ef)(w.sessionId)&&(0,u.$Ef)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$Y$b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(o,-1)}};e.$8$b=n,e.$8$b=n=pe([X(0,L.$pl),X(1,C.$Bj),X(2,j.$0h),X(3,R.$kj),X(4,c.$6$b),X(5,g.$vi),X(6,l.$gp)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,19,68,21,77,17]),function(ne,e,D,N,L,j,O,R,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=void 0;class C extends R.$ip{constructor($,c,g,y){super(),this.bb=$,this.cb=c,this.db=g,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Rc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Rc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new k.$eFb(this.db.getChannel("storage"))),c=this.B(new O.$cp($));return this.B(c.onDidChangeStorage(g=>this.u(-1,g))),c}gb($){this.X.clear(),this.W=$;let c;if((0,R.$jp)($))c=this.U;else{const g=this.X.add(new k.$fFb(this.db.getChannel("storage"),$));c=this.X.add(new O.$cp(g))}return this.X.add(c.onDidChangeStorage(g=>this.u(0,g))),c}hb($){this.$.clear(),this.Z=$?.id;let c;if($){const g=this.$.add(new k.$gFb(this.db.getChannel("storage"),$));c=this.$.add(new O.$cp(g)),this.$.add(c.onDidChangeStorage(y=>this.u(1,y)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Dg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const c=this.Y,g=c.items;c!==this.U&&await c.close(),this.Y=this.gb($),await this.Y.init(),this.N(g,this.Y,0)}async S($,c){const g=this.ab,y=g?.items??new Map;await g?.close(),this.ab=this.hb($),await this.ab.init(),this.N(y,this.ab,1)}hasScope($){return(0,m.$Wk)($)?this.W.id===$.id:this.Z===$.id}}e.$a_b=C}),define(le[253],he([0,1,3,2,17,92]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=void 0;class O{constructor(m,C){this.a=m,this.b=C}listen(m,C){const S=this.b(m);switch(C){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(c=>(0,j.$1m)({...c},S)),added:$.added.map(c=>(0,j.$1m)({...c},S)),removed:$.removed.map(c=>(0,j.$1m)({...c},S)),updated:$.updated.map(c=>(0,j.$1m)({...c},S))}))}throw new Error(`Invalid listen ${C}`)}async call(m,C,S){const $=this.b(m);switch(C){case"createProfile":{const c=await this.a.createProfile(S[0],S[1],S[2]);return(0,j.$1m)({...c},$)}case"updateProfile":{let c=(0,L.$Yk)((0,j.$2m)(S[0],$),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,S[1]),(0,j.$1m)({...c},$)}case"removeProfile":{const c=(0,L.$Yk)((0,j.$2m)(S[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$hO=O;class R extends N.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new D.$Sd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map($=>(0,L.$Yk)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const c=$.added.map(b=>(0,L.$Yk)(b,this.profilesHome.scheme)),g=$.removed.map(b=>(0,L.$Yk)(b,this.profilesHome.scheme)),y=$.updated.map(b=>(0,L.$Yk)(b,this.profilesHome.scheme));this.a=$.all.map(b=>(0,L.$Yk)(b,this.profilesHome.scheme)),this.b.fire({added:c,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,C,S){const $=await this.f.call("createNamedProfile",[m,C,S]);return(0,L.$Yk)($,this.profilesHome.scheme)}async createProfile(m,C,S,$){const c=await this.f.call("createProfile",[m,C,S,$]);return(0,L.$Yk)(c,this.profilesHome.scheme)}async createTransientProfile(m){const C=await this.f.call("createTransientProfile",[m]);return(0,L.$Yk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(m,C){await this.f.call("setProfileForWorkspace",[m,C])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,C){const S=await this.f.call("updateProfile",[m,C]);return(0,L.$Yk)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$iO=R}),define(le[60],he([0,1,2,68,4,21,3,77,17]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kFb=e.$jFb=e.$iFb=void 0,e.$iFb=(0,L.$2h)("IUserDataProfileStorageService");let m=class extends D.$Sc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async g=>this.b(g))}async updateStorageData(c,g,y){return this.withProfileScopedStorageService(c,async b=>this.c(b,g,y))}async withProfileScopedStorageService(c,g){if(this.a.hasScope(c))return g(this.a);const y=await this.g(c),b=new S(y);try{await b.initialize();const l=await g(b);return await b.flush(),l}finally{b.dispose(),await this.f(y)}}b(c){const g=new Map,y=b=>{for(const l of c.keys(0,b))g.set(l,{value:c.get(l,0),target:b})};return y(0),y(1),g}c(c,g,y){c.storeAll(Array.from(g.entries()).map(([b,l])=>({key:b,value:l,scope:0,target:y})),!0)}async f(c){try{await c.close()}finally{(0,D.$Mc)(c)&&c.dispose()}}};e.$jFb=m,e.$jFb=m=pe([X(0,j.$gp)],m);class C extends m{constructor(c,g,y,b){super(y),this.j=c;const l=c.getChannel("profileStorageListener"),u=this.B(new D.$Tc);this.h=this.B(new O.$Sd({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(h=>{b.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(d=>(0,k.$Yk)(d,g.profilesHome.scheme)),valueChanges:h.valueChanges.map(d=>({...d,profile:(0,k.$Yk)(d.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(c){const g=this.j.getChannel("storage");return(0,j.$jp)(c)?new R.$eFb(g):new R.$fFb(g,c)}}e.$kFb=C;class S extends j.$ip{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$cp(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,21,8,17,56,60]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=void 0;let R=class extends O.$kFb{constructor(m,C,S,$){super(m,C,S,$)}};e.$R$b=R,e.$R$b=R=pe([X(0,j.$d$b),X(1,L.$Xk),X(2,D.$gp),X(3,N.$jj)],R)}),define(le[39],he([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cGb=e.$bGb=e.$aGb=e.$_Fb=e.$$Fb=e.$0Fb=e.$9Fb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$9Fb=s;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$0Fb=o;function n(v,w){return`${(0,m.$wf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$$Fb=n;let i=class extends k.$Sc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,f,p,I,F,M,T,z,Z,J,x,V){super(),this.syncResource=w,this.collection=f,this.G=p,this.H=I,this.I=F,this.J=M,this.L=T,this.M=z,this.N=Z,this.O=J,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Sd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Sd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Zg(50)),this.w=this.B(new O.$Sd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=V.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,d.$Nmb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,d.$9mb),this.y=(0,d.$Omb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,I,this.h),this.j=(0,b.$mp)(I,p,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const f=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,f={}){await this.U(w,!0,this.ob(),f)}async preview(w,f,p={}){return this.U(w,!1,f,p)}async apply(w,f={}){try{this.F={...f};const p=await this.ab(w);return this.S(p),this.c}finally{this.F={}}}async U(w,f,p,I){try{if(this.F={...I},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),T=await this.X(w,M);return F=await this.Y(T,M,f,p),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(w){const f=this.kb(w);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),I=await this.X(null,p),F=await this.W(I),M=await this.qb({ref:I.ref,syncData:f},p,F,this.ob(),j.CancellationToken.None),T=[];for(const z of M){const Z=await this.sb(z,z.remoteResource,void 0,j.CancellationToken.None),{remoteChange:J}=await this.sb(z,z.previewResource,z.remoteContent,j.CancellationToken.None);T.push([z,{...Z,remoteChange:J!==0?J:2}])}await this.tb(I,p,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const f=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===f}async X(w,f){if(f){const p=w?w[this.resource]:void 0;if(f.ref===p||p===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(w,f,p,I){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$Vmb((0,S.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,f,p,I)}catch(F){if(F instanceof d.$Vmb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,f,p,I);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(w,f,p,I)}throw F}}async Z(w,f,p,I){try{const F=await this.W(w),M=!F&&f===null&&this.gb()!==void 0,T=p&&!M;this.c||(this.c=(0,N.$Pg)(Z=>this.eb(w,f,F,T,I,Z)));let z=await this.c;if(p&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of z.resourcePreviews)z=await this.accept(Z.remoteResource)||z}return this.cb(z.resourcePreviews),z.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(w){return await this.$(w,async f=>{const p=await this.rb(f,j.CancellationToken.None);await this.G.writeFile(f.previewResource,L.$ge.fromString(p?.content||""));const I=p&&!p.hasConflicts?await this.sb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=p.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:p.localChange,f.remoteChange=I?I.remoteChange:p.remoteChange,f}),this.c}async accept(w,f){return await this.$(w,async p=>{const I=await this.sb(p,w,f,j.CancellationToken.None);return p.acceptResult=I,p.mergeState="accepted",p.localChange=I.localChange,p.remoteChange=I.remoteChange,p}),this.c}async discard(w){return await this.$(w,async f=>{const p=await this.rb(f,j.CancellationToken.None);return await this.G.writeFile(f.previewResource,L.$ge.fromString(p.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=p.localChange,f.remoteChange=p.remoteChange,f}),this.c}async $(w,f){if(!this.c)return;let p=await this.c;const I=p.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:T})=>this.h.isEqual(F,w)||this.h.isEqual(M,w)||this.h.isEqual(T,w));I!==-1&&(this.c=(0,N.$Pg)(async F=>{const M=[...p.resourcePreviews];return M[I]=await f(M[I]),{...p,resourcePreviews:M}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(p=>[p,p.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const f=w.filter(({mergeState:p})=>p==="conflict");(0,D.$ub)(this.s,f,(p,I)=>this.h.isEqual(p.previewResource,I.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const f=this.c?await this.c:null;if(f)for(const p of f.resourcePreviews){if(this.h.isEqual(p.acceptedResource,w))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,w))return p.remoteContent;if(this.h.isEqual(p.localResource,w))return p.localContent;if(this.h.isEqual(p.baseResource,w))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,g.$Ck)(w)!==1&&this.O.error(w)}}async eb(w,f,p,I,F,M){const T=await this.qb(w,f,p,F,M),z=[];for(const Z of T){const J=Z.previewResource.with({scheme:d.$8mb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)z.push({...Z,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=I?await this.rb(Z,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,L.$ge.fromString(x?.content||""));const V=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,M):void 0;z.push({...Z,acceptResult:V,mergeState:x?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:x?x.localChange:Z.localChange,remoteChange:V?V.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:f,resourcePreviews:z,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(w),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!p&&f.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let I,F=1;for(;I===void 0&&F++<6;)try{const M=await this.hb();M&&(M.ref===f.ref?I=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.$Gk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof d.$Vmb)throw M;this.O.error(M,F)}}if(I===void 0)try{const M=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);I=M===null?null:this.kb(M),await this.ib({ref:f.ref,syncData:I})}catch(M){if(M instanceof d.$Vmb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return I===void 0?null:{...f,syncData:I}}async fb(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),I={ref:w.ref,version:p,...f};this.I.store(this.z,JSON.stringify(I),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const f=w?JSON.parse(w):void 0;if(s(f))return f}catch(f){this.O.error(f)}}async ib(w){await this.G.writeFile(this.y,L.$ge.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),f=JSON.parse(w.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(w){w instanceof g.$Gk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:f,content:p}=await this.lb(w);let I=null;return p!==null&&(I=this.kb(p)),{ref:f,syncData:I}}kb(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.O.error(f)}throw new d.$Vmb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const f=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(w,f){const p=await this.j,I={version:this.pb,machineId:p,content:w};try{return f=await this.J.writeResource(this.resource,JSON.stringify(I),f,this.collection,this.F),{ref:f,syncData:I}}catch(F){throw F instanceof d.$Vmb&&F.code==="TooLarge"&&(F=new d.$Vmb(F.message,F.code,this.resource)),F}}async nb(w){const f={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Imb)}};e.$_Fb=i,e.$_Fb=i=pe([X(2,g.$lk),X(3,c.$9h),X(4,l.$gp),X(5,d.$Qmb),X(6,d.$Rmb),X(7,d.$1mb),X(8,u.$pl),X(9,d.$6mb),X(10,$.$vi),X(11,h.$Vk)],i);let t=class extends i{constructor(w,f,p,I,F,M,T,z,Z,J,x,V,Y){super(f,p,I,F,M,T,z,Z,J,x,V,Y),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,f,p){try{f?await this.G.writeFile(this.r,L.$ge.fromString(w),p?void 0:f):await this.G.createFile(this.r,L.$ge.fromString(w),{overwrite:p})}catch(I){throw I instanceof g.$Gk&&I.fileOperationResult===1||I instanceof g.$Gk&&I.fileOperationResult===3?new d.$Vmb(I.message,"LocalPreconditionFailed"):I}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof g.$Gk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$aGb=t,e.$aGb=t=pe([X(3,g.$lk),X(4,c.$9h),X(5,l.$gp),X(6,d.$Qmb),X(7,d.$Rmb),X(8,d.$1mb),X(9,u.$pl),X(10,d.$6mb),X(11,$.$vi),X(12,h.$Vk)],t);let r=class extends t{constructor(w,f,p,I,F,M,T,z,Z,J,x,V,Y,W){super(w,f,p,I,F,M,T,z,Z,J,x,Y,W),this.zb=V,this.Bb=void 0}Ab(w,f){const p=[],I=(0,R.$0m)(w,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$Lf)(I)&&f!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$bGb=r,e.$bGb=r=pe([X(3,g.$lk),X(4,c.$9h),X(5,l.$gp),X(6,d.$Qmb),X(7,d.$Rmb),X(8,d.$1mb),X(9,u.$pl),X(10,d.$6mb),X(11,d.$5mb),X(12,$.$vi),X(13,h.$Vk)],r);let a=class{constructor(w,f,p,I,F,M,T){this.resource=w,this.g=f,this.h=p,this.j=I,this.k=F,this.l=M,this.d=T.extUri,this.f=(0,d.$Omb)(void 0,this.resource,p,this.d)}async initialize({ref:w,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(f);if(p)try{await this.o({ref:w,syncData:p})}catch(I){this.j.error(I)}}m(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const p={ref:w.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,L.$ge.fromString(JSON.stringify(w)))}};e.$cGb=a,e.$cGb=a=pe([X(1,E.$Xk),X(2,c.$9h),X(3,y.$jj),X(4,g.$lk),X(5,l.$gp),X(6,h.$Vk)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,20,14,114,29,33,82,44,11,4,73,8,21,22,28,17,39,234,111,24,60]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=e.$u6b=e.$t6b=e.$s6b=void 0;async function v(M,T){const z=JSON.parse(M.content);if(M.version===1||M.version===2){const Z=(await T.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of z)M.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),M.version===2&&Z.every(x=>!(0,c.$Mo)(x.identifier,J.identifier))&&(J.installed=!0)}return z}function w(M){return JSON.parse(M.content)}e.$s6b=w;function f(M,T){return M.sort((z,Z)=>!z.identifier.uuid&&Z.identifier.uuid?-1:z.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$1e)(z.identifier.id,Z.identifier.id)),T?(0,O.$PT)(M,{}):JSON.stringify(M)}e.$t6b=f;let p=class extends n.$_Fb{constructor(T,z,Z,J,x,V,Y,W,B,te,se,_,re,K,U,P,A){super({syncResource:"extensions",profile:T},z,J,Z,x,V,Y,_,re,te,se,U),this.Cb=W,this.Db=B,this.Eb=A,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$8mb,authority:"base"}),this.yb=this.wb.with({scheme:r.$8mb,authority:"local"}),this.zb=this.wb.with({scheme:r.$8mb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$8mb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,H=>H.some(({local:q})=>!!q)),j.Event.filter(this.Cb.onDidUninstallExtension,H=>!H.error),j.Event.filter(P.onDidChange,H=>H.valueChanges.some(({profile:q,changes:ee})=>this.syncResource.profile.id===q.id&&ee.some(G=>G.key===$.$no))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,z){const Z=T.syncData?await v(T.syncData,this.Cb):null,J=z?.skippedExtensions??[],x=z?.builtinExtensions??null,V=z?.syncData?await v(z.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:te}=(0,i.$r6b)(Y,Z,V,J,W,x),se={local:B,remote:te,content:this.Hb(Y,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:te!==null?2:0},_=this.Ob(Y,!1);return[{skippedExtensions:J,builtinExtensions:x,baseResource:this.xb,baseContent:V?this.Ob(V,!1):_,localResource:this.yb,localContent:_,localExtensions:Y,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(T){const z=T.syncData?await v(T.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$r6b)(Z,z,z,T.skippedExtensions||[],J,T.builtinExtensions||[]);return x!==null}Hb(T,z,Z,J){const x=[...z,...Z],V=new Set,Y=W=>{V.add(W.id.toLowerCase()),W.uuid&&V.add(W.uuid)};x.forEach(({identifier:W})=>Y(W)),J.forEach(Y);for(const W of T)V.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&V.has(W.identifier.uuid)||x.push(W);return this.Ob(x,!1)}async rb(T,z){return{...T.previewResult,hasConflicts:!1}}async sb(T,z,Z,J){if(this.h.isEqual(z,this.yb))return this.Kb(T);if(this.h.isEqual(z,this.zb))return this.Lb(T);if(this.h.isEqual(z,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Kb(T){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),J=(0,i.$r6b)(T.localExtensions,null,null,T.skippedExtensions,Z,T.builtinExtensions),{local:x,remote:V}=J;return{content:T.localContent,local:x,remote:V,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(T){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),J=T.remoteContent?JSON.parse(T.remoteContent):null;if(J!==null){const x=(0,i.$r6b)(T.localExtensions,J,T.localExtensions,[],Z,T.builtinExtensions),{local:V,remote:Y}=x;return{content:T.remoteContent,local:V,remote:Y,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,z,Z,J){let{skippedExtensions:x,builtinExtensions:V,localExtensions:Y}=Z[0][0];const{local:W,remote:B,localChange:te,remoteChange:se}=Z[0][1];if(te===0&&se===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Y)),x=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,x,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(B.all);T=await this.mb(_,J?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(re=>re.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(re=>re.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(re=>re.identifier.id))}.`:""}`)}z?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(Y,V),await this.fb(T,{skippedExtensions:x,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(T,z){const Z=new Set,J=[];for(const x of T)Z.add(x.identifier.id.toLowerCase()),x.installed||J.push(x.identifier);if(z)for(const x of z)Z.has(x.id.toLowerCase())||J.push(x);return J}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const z=await this.db(T);return z&&this.Ob(JSON.parse(z),!0)}return null}Ob(T,z){return f(T,z)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.$u6b=p,e.$u6b=p=pe([X(2,C.$9h),X(3,b.$lk),X(4,d.$gp),X(5,r.$Qmb),X(6,r.$Rmb),X(7,$.$mo),X(8,t.$TGb),X(9,r.$6mb),X(10,m.$vi),X(11,r.$1mb),X(12,E.$pl),X(13,g.$$u),X(14,s.$Vk),X(15,a.$iFb),X(16,l.$1h)],p);let I=class{constructor(T,z,Z,J,x,V){this.a=T,this.b=z,this.c=Z,this.d=J,this.f=x,this.g=V}async getLocalExtensions(T){const z=await this.a.getInstalled(void 0,T.extensionsResource),Z=this.d.getIgnoredExtensions(z);return{localExtensions:await this.j(T,async(x,V)=>{const Y=x.getDisabledExtensions();return z.map(W=>{const{identifier:B,isBuiltin:te,manifest:se,preRelease:_,pinned:re,isApplicationScoped:K}=W,U={identifier:B,preRelease:_,version:se.version,pinned:!!re};K&&!(0,y.$jm)(se)&&(U.isApplicationScoped=K),Y.some(P=>(0,c.$Mo)(P,B))&&(U.disabled=!0),te||(U.installed=!0);try{const P=V.getKeysForSync({id:B.id,version:se.version});if(P){const A=V.getExtensionState(W,!0)||{};U.state=Object.keys(A).reduce((H,q)=>(P.includes(q)&&(H[q]=A[q]),H),{})}}catch(P){this.g.info(`${(0,n.$$Fb)("extensions",T)}: Error while parsing extension state`,(0,L.$0)(P))}return U})}),ignoredExtensions:Z}}async updateLocalExtensions(T,z,Z,J,x){const V=(0,n.$$Fb)("extensions",x),Y=[],W=new Map,B=[],te=[],se=await this.a.getInstalled(void 0,x.extensionsResource);if((T.length||Z.length)&&await this.j(x,async(K,U)=>{await D.Promises.settled([...T,...Z].map(async P=>{const A=se.find(ee=>(0,c.$Mo)(ee.identifier,P.identifier));if(A&&A.isBuiltin){P.state&&A.manifest.version===P.version&&this.h(P.state,A,A.manifest.version,U),K.getDisabledExtensions().some(G=>(0,c.$Mo)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${V}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${V}: Disabled extension`,P.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${V}: Enabled extension`,P.identifier.id))),B.push(P.identifier);return}const H=P.pinned?P.version:void 0,q=(await this.c.getExtensions([{...P.identifier,version:H,preRelease:H?void 0:P.preRelease}],N.CancellationToken.None))[0];if(P.state&&(A?A.manifest.version===P.version:q)&&this.h(P.state,A||q,A?.manifest.version,U),q)try{K.getDisabledExtensions().some(G=>(0,c.$Mo)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${V}: Disabling extension...`,P.identifier.id,q.version),await K.disableExtension(q.identifier),this.g.info(`${V}: Disabled extension`,P.identifier.id,q.version)):(this.g.trace(`${V}: Enabling extension...`,P.identifier.id,q.version),await K.enableExtension(q.identifier),this.g.info(`${V}: Enabled extension`,P.identifier.id,q.version))),(!A||A.preRelease!==P.preRelease||A.pinned!==P.pinned||H&&A.manifest.version!==H)&&(await this.a.canInstall(q)?(Y.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[$.$bo]:!0,[$.$co]:!0}}}),W.set(q.identifier.id.toLowerCase(),P)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(P)))}catch(ee){te.push(P),this.g.error(ee),this.g.info(`${V}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(P),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),z.length){const K=se.filter(({identifier:U,isBuiltin:P})=>!P&&z.some(A=>(0,c.$Mo)(U,A)));await D.Promises.settled(K.map(async U=>{this.g.trace(`${V}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,U.identifier.id),B.push(U.identifier)}))}const _=await this.a.installGalleryExtensions(Y);for(const{identifier:K,local:U,error:P,source:A}of _){const H=A;if(U)this.g.info(`${V}: Installed extension.`,K.id,H.version),B.push(K);else{const q=W.get(K.id.toLowerCase());q&&(te.push(q),this.g.info(`${V}: Skipped synchronizing extension`,H.displayName||H.identifier.id)),P instanceof $.$lo&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,H.displayName||H.identifier.id):P&&this.g.error(P)}}const re=[];for(const K of J)B.some(U=>(0,c.$Mo)(U,K.identifier))||re.push(K);for(const K of te)re.some(U=>(0,c.$Mo)(U.identifier,K.identifier))||re.push(K);return re}h(T,z,Z,J){const x=J.getExtensionState(z,!0)||{},V=Z?J.getKeysForSync({id:z.identifier.id,version:Z}):void 0;V?V.forEach(Y=>{x[Y]=T[Y]}):Object.keys(T).forEach(Y=>x[Y]=T[Y]),J.setExtensionState(z,x,!0)}async j(T,z){return this.b.withProfileScopedStorageService(T,async Z=>{const J=new R.$Rc,x=this.f.createChild(new u.$Zh([d.$gp,Z])),V=J.add(x.createInstance(S.$GEb)),Y=J.add(x.createInstance(g.$_u));try{return await z(V,Y)}finally{J.dispose()}})}};e.$v6b=I,e.$v6b=I=pe([X(0,$.$mo),X(1,a.$iFb),X(2,$.$ko),X(3,t.$TGb),X(4,l.$1h),X(5,r.$6mb)],I);let F=class extends n.$cGb{constructor(T,z,Z,J,x,V,Y,W){super("extensions",J,x,V,Z,Y,W),this.p=T,this.q=z}async t(T){return T.syncData?await v(T.syncData,this.p):null}u(T,z){const Z=[],J=[],x=[];for(const V of T){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const Y=z.find(W=>(0,c.$Mo)(W.identifier,V.identifier));Y?(Z.push(Y),V.disabled&&x.push(V.identifier)):V.installed&&(J.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&x.push(V.identifier))}return{installedExtensions:Z,newExtensions:J,disabledExtensions:x,remoteExtensions:T}}};e.$w6b=F,e.$w6b=F=pe([X(0,$.$mo),X(1,t.$TGb),X(2,b.$lk),X(3,o.$Xk),X(4,C.$9h),X(5,h.$jj),X(6,d.$gp),X(7,s.$Vk)],F)}),define(le[116],he([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,79,238,24,17,60,4]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iGb=e.$hGb=e.$gGb=e.$fGb=e.$eGb=void 0;const n="globalState.argv.",i=["locale"];function t(p,I){const F=p.storage?Object.keys(p.storage).sort():[],M={};return F.forEach(T=>M[T]=p.storage[T]),p.storage=M,I?(0,O.$PT)(p,{}):JSON.stringify(p)}e.$eGb=t;const r=1;let a=class extends l.$_Fb{constructor(I,F,M,T,z,Z,J,x,V,Y,W,B,te,se){super({syncResource:"globalState",profile:I},F,T,x,B,z,Z,V,Y,J,W,te),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$8mb,authority:"base"}),this.xb=this.vb.with({scheme:d.$8mb,authority:"local"}),this.yb=this.vb.with({scheme:d.$8mb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$8mb,authority:"accepted"}),this.Ab=se.createInstance(v),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(T.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(re=>this.syncResource.profile.id===re.id)||_.valueChanges.some(({profile:re,changes:K})=>this.syncResource.profile.id===re.id&&K.some(U=>U.target===0)))))(()=>this.Q()))}async qb(I,F,M){const T=I.syncData?JSON.parse(I.syncData.content):null;F=F===null&&M?I:F;const z=F&&F.syncData?JSON.parse(F.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(z),{local:x,remote:V}=(0,h.$dGb)(Z.storage,T?T.storage:null,z?z.storage:null,J,this.O),Y={content:null,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:V.all!==null?2:0},W=t(Z,!1);return[{baseResource:this.wb,baseContent:z?t(z,!1):W,localResource:this.xb,localContent:W,localUserData:Z,remoteResource:this.yb,remoteContent:T?t(T,!1):null,previewResource:this.vb,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(I){const F=I.syncData?JSON.parse(I.syncData.content):null;if(F===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(F),{remote:z}=(0,h.$dGb)(M.storage,F.storage,F.storage,T,this.O);return z.all!==null}async rb(I,F){return{...I.previewResult,hasConflicts:!1}}async sb(I,F,M,T){if(this.h.isEqual(F,this.xb))return this.Gb(I);if(this.h.isEqual(F,this.yb))return this.Hb(I);if(this.h.isEqual(F,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:0,remoteChange:2}}async Hb(I){if(I.remoteContent!==null){const F=JSON.parse(I.remoteContent),{local:M,remote:T}=(0,h.$dGb)(I.localUserData.storage,F.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:M,remote:T,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(I,F,M,T){const{localUserData:z}=M[0][0],{local:Z,remote:J,localChange:x,remoteChange:V}=M[0][1];if(x===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(z)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Y=JSON.stringify({storage:J.all});I=await this.mb(Y,T?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}F?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const F=await this.db(I);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const F=await this.Bb.readStorageData(this.syncResource.profile),M=[],T=[];for(const[J,x]of F)x.target===0?M.push(J):x.target===1&&T.push(J);const z=[...M,...T],Z=I?.storage?Object.keys(I.storage).filter(J=>!J.startsWith(n)&&!z.includes(J)&&F.get(J)!==void 0):[];if(!R.$o){const J=[...d.$Mmb.map(x=>(0,d.$Zmb)(x)),d.$Ymb];Z.push(...J),T.push(...J)}return{user:M,machine:T,unregistered:Z}}};e.$fGb=a,e.$fGb=a=pe([X(2,s.$iFb),X(3,S.$lk),X(4,d.$Qmb),X(5,d.$Rmb),X(6,d.$6mb),X(7,C.$9h),X(8,d.$1mb),X(9,y.$pl),X(10,m.$vi),X(11,g.$gp),X(12,b.$Vk),X(13,o.$1h)],a);let v=class{constructor(I,F,M,T){this.a=I,this.b=F,this.c=M,this.d=T}async getLocalGlobalState(I){const F={};if(I.isDefault){const T=await this.f(),z=(0,j.$0m)(T);for(const Z of i)z[Z]!==void 0&&(F[`${n}${Z}`]={version:1,value:z[Z]})}const M=await this.c.readStorageData(I);for(const[T,z]of M)z.value&&z.target===0&&(F[T]={version:1,value:z.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,N.$0)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:F,updated:M},T){const z=(0,l.$$Fb)("globalState",T),Z={},J=new Map,x=await this.c.readStorageData(T),V=(Y,W)=>{for(const B of Y){if(B.startsWith(n)){Z[B.substring(n.length)]=W?W[B].value:void 0;continue}if(W){const te=W[B];te.value!==x.get(B)?.value&&J.set(B,te.value)}else x.get(B)!==void 0&&J.set(B,void 0)}};if(V(Object.keys(I),I),V(Object.keys(M),M),V(F),Object.keys(Z).length){this.d.trace(`${z}: Updating locale...`);const Y=await this.f();let W=Y;for(const B of Object.keys(Z))W=(0,u.edit)(W,[B],Z[B],{});Y!==W&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$ge.fromString(W)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}J.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(T,J,0),this.d.info(`${z}: Updated global state`,[...J.keys()]))}};e.$gGb=v,e.$gGb=v=pe([X(0,S.$lk),X(1,C.$9h),X(2,s.$iFb),X(3,d.$6mb)],v);let w=class extends l.$cGb{constructor(I,F,M,T,z,Z){super("globalState",M,T,z,F,I,Z)}async o(I){const F=I.syncData?JSON.parse(I.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},T={};for(const z of Object.keys(F.storage))z.startsWith(n)?M[z.substring(n.length)]=F.storage[z].value:this.l.get(z,0)===void 0&&(T[z]=F.storage[z].value);if(Object.keys(M).length){let z="{}";try{z=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(M))z=(0,u.edit)(z,[Z],M[Z],{});await this.k.writeFile(this.h.argvResource,D.$ge.fromString(z))}if(Object.keys(T).length){const z=[];for(const Z of Object.keys(T))z.push({key:Z,value:T[Z],scope:0,target:0});this.l.storeAll(z,!0)}}};e.$hGb=w,e.$hGb=w=pe([X(0,g.$gp),X(1,S.$lk),X(2,E.$Xk),X(3,C.$9h),X(4,d.$6mb),X(5,b.$Vk)],w);let f=class{constructor(I,F,M,T,z){this.a=I,this.b=F,this.c=M,this.d=T,this.f=z}getSyncStoreType(I){return this.h(I)?.storage[d.$Ymb]?.value}async sync(I){const F=(0,d.$Umb)((0,k.$mg)());try{return await this.g(I,F)}catch(M){if(M instanceof d.$Vmb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,F)}throw M}}async g(I,F){const M=await this.a.readResource("globalState",null,void 0,F),T=this.h(M)||{storage:{}};T.storage[d.$Ymb]={value:I,version:r};const z=await(0,c.$mp)(this.c,this.d,this.b),Z={version:r,machineId:z,content:t(T,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),M.ref,void 0,F)}h({content:I}){if(!I)return null;const F=JSON.parse(I);if((0,l.$0Fb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$iGb=f,e.$iGb=f=pe([X(1,g.$gp),X(2,C.$9h),X(3,S.$lk),X(4,$.$jj)],f)}),define(le[117],he([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,235,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.$y6b=void 0;function h(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,R.$Lf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,R.$Lf)(i.mac)?null:i.mac;case 3:return(0,R.$Lf)(i.linux)?null:i.linux;case 1:return(0,R.$Lf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$y6b=h;let d=class extends b.$bGb{constructor(o,n,i,t,r,a,v,w,f,p,I,F,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,f,p,i,t,v,F,r,I,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$8mb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$8mb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$8mb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$8mb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,i,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?o:n;const a=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let f=null,p=!1,I=!1,F=!1;if(r){let z=v?v.value.toString():"[]";if(z=z||"[]",this.Ab(z,!0))throw new u.$Vmb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,l.$x6b)(z,r,a,w,this.zb);Z.hasChanges&&(f=Z.mergeContent,F=Z.hasConflicts,p=F||Z.mergeContent!==z,I=F||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),I=!0);const M={content:F?a:f,localChange:p?v?2:1:0,remoteChange:I?2:0,hasConflicts:F},T=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,l.$x6b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$Vmb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(f,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$0m)(o.value.toString());if((0,D.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:h(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,O.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$Jmb)}};e.$z6b=d,e.$z6b=d=pe([X(2,u.$Qmb),X(3,u.$Rmb),X(4,u.$6mb),X(5,m.$vi),X(6,u.$1mb),X(7,S.$lk),X(8,C.$9h),X(9,$.$gp),X(10,u.$5mb),X(11,c.$pl),X(12,g.$Vk)],d);let E=class extends b.$cGb{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ge.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$0m)(o.value.toString());return!(0,D.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return h(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$A6b=E,e.$A6b=E=pe([X(0,S.$lk),X(1,y.$Xk),X(2,C.$9h),X(3,u.$6mb),X(4,$.$gp),X(5,g.$Vk)],E)}),define(le[118],he([0,1,15,3,171,20,75,14,29,11,21,22,28,17,39,239,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=e.$B6b=void 0;function l(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function u(E){const s=JSON.parse(E);return l(s)?s:{settings:E}}e.$B6b=u;let h=class extends g.$bGb{constructor(s,o,n,i,t,r,a,v,w,f,p,I,F,M){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,p,I,v,w,f,M),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:b.$8mb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$8mb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$8mb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$8mb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.X(s,o),i=this.Lb(n),t=new O.$Pn(b.$Imb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(b.$Imb)||{}}async qb(s,o,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);o=o===null&&n?s:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,f=!1,p=!1,I=!1;if(r){let z=i?i.value.toString().trim():"{}";z=z||"{}",this.Qb(z),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,y.$2Eb)(z,r.settings,a?a.settings:null,v,[],t);w=Z.localContent||Z.remoteContent,f=Z.localContent!==null,p=Z.remoteContent!==null,I=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),p=!0);const F=i?i.value.toString():null,M=a?.settings??null,T={content:I?M:w,localChange:f?2:0,remoteChange:p?2:0,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(s){const o=this.Lb(s);if(o===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$2Eb)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(s,o){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,y.$1Eb)(s.previewResult.content,"{}",i,n):null}}async sb(s,o,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:s.fileContent?(0,y.$1Eb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,y.$1Eb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.$1Eb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),f=this.Lb(s),p=await this.Pb(r);r=(0,y.$1Eb)(r,f?f.settings:"{}",p,w),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,y.$3Eb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let o=await super.db(s);if(o){const n=await this.Cb(),i=await this.Pb();o=(0,y.$1Eb)(o,"{}",i,n)}return o}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(o){this.O.error(o)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,y.$YEb)(o,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new b.$Vmb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$C6b=h,e.$C6b=h=pe([X(2,m.$lk),X(3,R.$9h),X(4,C.$gp),X(5,b.$Qmb),X(6,b.$Rmb),X(7,b.$6mb),X(8,b.$5mb),X(9,j.$vi),X(10,b.$1mb),X(11,S.$pl),X(12,k.$mo),X(13,$.$Vk)],h);let d=class extends g.$cGb{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$ge.fromString(o.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$3Eb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(o){this.j.error(o)}return null}};e.$D6b=d,e.$D6b=d=pe([X(0,m.$lk),X(1,c.$Xk),X(2,R.$9h),X(3,b.$6mb),X(4,C.$gp),X(5,$.$Vk)],d)}),define(le[119],he([0,1,15,3,30,20,14,11,21,22,28,17,39,236,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=e.$G6b=void 0;function y(u){return JSON.parse(u.content)}e.$G6b=y;let b=class extends $.$_Fb{constructor(h,d,E,s,o,n,i,t,r,a,v,w){super({syncResource:"snippets",profile:h},d,s,E,o,n,i,a,v,t,r,w),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(h,d,E){const s=await this.Hb(),o=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;d=d===null&&E?h:d;const i=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$E6b)(o,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const d=h.syncData?this.Fb(h.syncData):null;if(d===null)return!0;const E=await this.Hb(),s=this.Gb(E),o=(0,c.$E6b)(s,d,d);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(h,d){return h.previewResult}async sb(h,d,E,s){if(this.h.isEqualOrParent(d,this.g.with({scheme:g.$8mb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:g.$8mb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return E===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:E,localChange:E===null?h.fileContent!==null?3:0:2,remoteChange:E===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(h,d,E,s){const o=E.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,s)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(o,h,s)),d?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(h,d,E,s){const o=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:E[n]?2:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}for(const n of Object.keys(d))if(!o.has(n)){const i={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$8mb,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:g.$8mb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$8mb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$8mb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$8mb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const d={};for(const E of h)E.fileContent&&(d[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(h,d){for(const{fileContent:E,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$ge.fromString(s.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$ge.fromString(s.content),d?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,d,E){const s=d.syncData?this.Fb(d.syncData):{},o=(0,L.$hn)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.$F6b)(s,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(o),E?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(h){return y(h)}Gb(h){const d={};for(const E of Object.keys(h))d[E]=h[E].value.toString();return d}async Hb(){const h={};let d;try{d=await this.G.resolve(this.vb)}catch(E){if(E instanceof R.$Gk&&E.fileOperationResult===1)return h;throw E}for(const E of d.children||[]){const s=E.resource,o=this.h.extname(s);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$H6b=b,e.$H6b=b=pe([X(2,O.$9h),X(3,R.$lk),X(4,k.$gp),X(5,g.$Qmb),X(6,g.$Rmb),X(7,g.$6mb),X(8,j.$vi),X(9,g.$1mb),X(10,m.$pl),X(11,C.$Vk)],b);let l=class extends $.$cGb{constructor(h,d,E,s,o,n){super("snippets",d,E,s,h,o,n)}async o(h){const d=h.syncData?JSON.parse(h.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(d)){const o=d[s];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$ge.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$I6b=l,e.$I6b=l=pe([X(0,R.$lk),X(1,S.$Xk),X(2,O.$9h),X(3,g.$6mb),X(4,k.$gp),X(5,C.$Vk)],l)}),define(le[120],he([0,1,15,20,14,11,21,22,28,17,39,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=e.$J6b=void 0;function $(b,l){try{return JSON.parse(b).tasks??null}catch(u){return l.error(u),null}}e.$J6b=$;let c=class extends C.$aGb{constructor(l,u,h,d,E,s,o,n,i,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,i,t,h,d,o,r,E,s,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$8mb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$8mb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$8mb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$8mb,authority:"accepted"})}async qb(l,u,h,d){const E=l.syncData?$(l.syncData.content,this.O):null;u=u===null&&h?l:u;const s=u?.syncData?$(u.syncData.content,this.O):null,o=await this.vb();let n=null,i=!1,t=!1,r=!1;if(l.syncData){const w=o?o.value.toString():null;if(!s||s!==w||s!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=y(w,E,s);n=f.content,r=f.hasConflicts,i=f.hasLocalChanged,t=f.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?$(l.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),d=h?h.value.toString():null,E=y(d,u,u);return E.hasLocalChanged||E.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,h,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,h,d){const{fileContent:E}=h[0][0],{content:s,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),s?await this.wb(s,E,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));l=await this.mb(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$K6b=c,e.$K6b=c=pe([X(2,S.$Qmb),X(3,S.$Rmb),X(4,S.$6mb),X(5,N.$vi),X(6,S.$1mb),X(7,j.$lk),X(8,L.$9h),X(9,O.$gp),X(10,R.$pl),X(11,k.$Vk)],c);let g=class extends C.$cGb{constructor(l,u,h,d,E,s){super("tasks",u,h,d,l,E,s),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?$(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$ge.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$L6b=g,e.$L6b=g=pe([X(0,j.$lk),X(1,m.$Xk),X(2,L.$9h),X(3,S.$6mb),X(4,O.$gp),X(5,k.$Vk)],g);function y(b,l,u){if(b===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(b===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==b,d=u!==l;return!h&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!d?{content:b,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!h?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:b,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,20,14,11,21,22,28,17,39,237,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=e.$q8b=void 0;let c=class extends C.$_Fb{constructor(l,u,h,d,E,s,o,n,i,t,r,a,v){super({syncResource:"profiles",profile:l},u,d,E,s,o,n,r,a,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$8mb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$8mb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$8mb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$8mb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),h=await this.X(l,u);return h?.syncData?y(h.syncData):null}async qb(l,u,h){if(!this.vb.isEnabled())throw new $.$Vmb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?y(l.syncData):null,E=u?.syncData?y(u.syncData):null,s=this.Db(),{local:o,remote:n}=(0,S.$p8b)(s,d,E,[]),i={local:o,remote:n,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(s,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?y(l.syncData):null,h=this.Db(),{remote:d}=(0,S.$p8b)(h,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,h,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),h=(0,S.$p8b)(u,null,null,[]),{local:d,remote:E}=h;return{content:l.localContent,local:d,remote:E,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,h=[],d=[];for(const E of this.Db()){const s=u?.find(o=>o.id===E.id);s&&(h.push({id:E.id,name:E.name,collection:s.collection}),d.push(E))}if(u!==null){const E=(0,S.$p8b)(d,u,h,[]),{local:s,remote:o}=E;return{content:l.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,h,d){const{local:E,remote:s,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new $.$Vmb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of s?.updated||[]){const v=i.find(({id:w})=>a.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of s?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,D.$PT)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$q8b=c,e.$q8b=c=pe([X(2,m.$Xk),X(3,j.$lk),X(4,L.$9h),X(5,O.$gp),X(6,$.$Qmb),X(7,$.$Rmb),X(8,$.$6mb),X(9,N.$vi),X(10,$.$1mb),X(11,R.$pl),X(12,k.$Vk)],c);function g(b,l){const u=[...b].sort((h,d)=>h.name.localeCompare(d.name)).map(h=>({id:h.id,name:h.name}));return l?(0,D.$PT)(u,{}):JSON.stringify(u)}e.$r8b=g;function y(b){return JSON.parse(b.content)}e.$s8b=y}),define(le[255],he([0,1,3,2,5,14,21,22,24]),function(ne,e,D,N,L,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;const m="sync.enable";let C=class extends N.$Sc{constructor($,c,g,y){super(),this.c=$,this.f=c,this.g=g,this.h=y,this.a=new D.$Sd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Sd,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$Rc))(b=>this.m(b)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(m,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(m,{enabled:$}),this.c.store(m,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,k.$Zmb)($),-1,!0)}setResourceEnablement($,c){if(this.isResourceEnabled($)!==c){const g=(0,k.$Zmb)($);this.j(g,c)}}getResourceSyncStateVersion($){}j($,c){this.c.store($,c,-1,L.$o?0:1)}m($){if(m===$.key){this.a.fire(this.isEnabled());return}const c=k.$Mmb.filter(g=>(0,k.$Zmb)(g)===$.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$d8b=C,e.$d8b=C=pe([X(0,O.$gp),X(1,R.$pl),X(2,j.$9h),X(3,k.$Pmb)],C)}),define(le[256],he([0,1,6,15,64,2,19,20,14,11,17,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=void 0;let $=class extends j.$Sc{constructor(g,y,b,l,u){super(),this.a=g,this.b=y,this.c=b,this.f=l,this.g=u,this.h()}async h(){for(const y of this.g.profiles)for(const b of S.$Mmb)try{await this.m(this.j(b,y.isDefault?void 0:y.id))}catch(l){this.f.error(l)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,m.$Ck)(y)!==1&&this.f.error(y);return}if(g.children){for(const y of g.children)if(y.isDirectory&&!this.g.profiles.some(b=>b.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(b){this.f.error(b)}}}async getAllResourceRefs(g,y,b){const l=this.j(g,y,b);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,m.$Ck)(u)!==1)throw u}return[]}async resolveResourceContent(g,y,b,l){const u=this.j(g,b,l),h=(0,O.$Dg)(u,y);try{return(await this.b.readFile(h)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(g,y,b,l,u){const h=this.j(g,l,u),d=(0,O.$Dg)(h,`${(0,L.$rm)(b).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$ge.fromString(y))}catch(E){this.f.error(E)}}j(g,y,b=this.a.userDataSyncHome){return(0,O.$Dg)(b,...y?[y,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const y=await this.b.resolve(g);if(y.children){const b=y.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=b.filter(d=>Date.now()-this.n(d)>l);const h=b.length-u.length;h<10&&(u=u.slice(10-h)),await D.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(y){this.f.error(y)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$o8b=$,e.$o8b=$=pe([X(0,k.$9h),X(1,m.$lk),X(2,R.$vi),X(3,S.$6mb),X(4,C.$Xk)],$)}),define(le[83],he([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmb=e.$Emb=e.$Dmb=void 0,e.$Dmb=(0,m.$2h)("IUserDataSyncMachinesService");const y="sync.currentMachineName",b="Safari",l="Chrome",u="Edge",h="Firefox",d="Android";function E(n){switch(n){case b:case l:case u:case h:case d:case(0,L.$h)(0):return!0}return!1}e.$Emb=E;function s(){return L.$G?b:L.$E?l:L.$H?u:L.$F?h:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let o=class extends N.$Sc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new D.$Sd),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$mp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(a);const w=await this.f;i===w&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Ke)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const f=a.exec(w.name),p=f?parseInt(f[1]):0;v=p>v?p:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$Fmb=o,e.$Fmb=o=g=pe([X(0,R.$9h),X(1,k.$lk),X(2,$.$gp),X(3,c.$Qmb),X(4,c.$6mb),X(5,C.$Bj)],o)}),define(le[257],he([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,80,83]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",d="sync.storeUrl",E="sync.productQuality";let s=class extends R.$Sc{get n(){const i=this.H.get(d,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,w,f,p,I,F){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=f,this.F=p,this.G=I,this.H=F,this.a=this.B(new R.$Tc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Sd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Zg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,m.$wg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$rm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$Vmb.toUserDataSyncError(i);t instanceof y.$Xmb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,D.$3g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$u8b=s,e.$u8b=s=pe([X(0,$.$Bj),X(1,y.$Pmb),X(2,y.$Qmb),X(3,y.$1mb),X(4,y.$2mb),X(5,y.$6mb),X(6,b.$IEb),X(7,g.$pl),X(8,l.$Dmb),X(9,c.$gp)],s);class o extends R.$Sc{static{this.a="Interval"}constructor(i,t,r,a,v,w,f,p,I){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=f,this.z=p,this.C=I,this.b=this.B(new R.$Tc),this.c=this.B(new O.$Sd),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Sd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Qc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,D.$4g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Pg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$4)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,m.$wg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,m.$wg)(t.defaultUrl,i.defaultUrl)||!(0,m.$wg)(t.insidersUrl,i.insidersUrl)||!(0,m.$wg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,y.$Vmb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$Xmb((0,S.localize)(0,null),"DefaultServiceChanged"):new y.$Xmb((0,S.localize)(1,null),"ServiceChanged"):new y.$Xmb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$Xmb((0,S.localize)(3,null),"DefaultServiceChanged"):new y.$Xmb((0,S.localize)(4,null),"ServiceChanged"):new y.$Xmb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(f=>f.isCurrent);if(v?.disabled)throw new y.$Xmb((0,S.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new y.$Xmb((0,L.$Mi)(f),f instanceof y.$Vmb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[258],he([0,1,10,176,14,11,43,21,28,24,17,39,119,118,117,20,120,115,116,4,121,42,27]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,f,p,I,F,M){this.e=t,this.f=r,this.g=a,this.h=w,this.i=f,this.j=p,this.k=I,this.l=F,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,d.$s8b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,d.$s8b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:f})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$mp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:f}=await this.M(r,v,a);return f}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$B6b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$y6b)(t.content,!!this.l.getValue(m.$Jmb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,b.$J6b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,$.$G6b)(v),f=[];for(const p of Object.keys(w)){const I=this.d.joinPath(t,p),F=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);f.push({resource:I,comparableResource:F})}return f}}return[]}z(t,r){return(0,$.$G6b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$t6b)((0,l.$s6b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$v6b).getLocalExtensions(t);return(0,l.$t6b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$eGb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$gGb).getLocalGlobalState(t);return(0,u.$eGb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$PT)(JSON.parse(t.content),{})}return null}async I(t){return(0,d.$r8b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.$Oe)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(D.URI.from({scheme:m.$8mb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==m.$8mb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const f=[];let p,I,F,M,T;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?v=z.substring(7):z.startsWith("authority:")?w=z.substring(10):z.startsWith("syncResource:")?p=z.substring(13):z.startsWith("profile:")?I=z.substring(8):z.startsWith("collection:")?F=z.substring(11):z.startsWith("ref:")?M=z.substring(4):p?T=z:f.push(z)}return{remote:a,syncResource:p,profile:I,collection:F,ref:M,node:T,location:v&&w!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$0Fb)(a))return a}catch(a){this.g.error(a)}throw new m.$Vmb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$38b=n,e.$38b=n=o=pe([X(0,m.$Qmb),X(1,m.$Rmb),X(2,m.$6mb),X(3,k.$Vk),X(4,L.$9h),X(5,R.$gp),X(6,j.$lk),X(7,C.$Xk),X(8,y.$vi),X(9,h.$1h)],n)}),define(le[259],he([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Sc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,I,F,M,T,z,Z,J,x,V,Y){super(),this.C=p,this.D=I,this.F=F,this.G=M,this.H=T,this.I=z,this.J=Z,this.L=J,this.M=x,this.N=V,this.O=Y,this.f="uninitialized",this.g=this.B(new O.$Sd),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Sd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Sd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Sd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Sd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Sd),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Sd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Qc)(()=>this.bb()))}async createSyncTask(p,I){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),M=(0,C.$mg)();try{const J=(0,i.$Umb)(M);I&&(J["Cache-Control"]="no-cache"),p=await this.D.manifest(p,J)}catch(J){const x=i.$Vmb.toUserDataSyncError(J);throw w(x,M,this.F,this.I),x}const T=!1,z=this;let Z;return{manifest:p,async run(){if(T)throw new Error("Can run a task only once");Z=(0,N.$Pg)(J=>z.P(p,!1,M,J)),await Z.finally(()=>Z=void 0),z.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),z.$()},stop(){return Z?.cancel(),z.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Vmb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),I=(0,C.$mg)(),F=(0,i.$Umb)(I);let M;try{M=await this.D.manifest(null,F)}catch(Z){const J=i.$Vmb.toUserDataSyncError(Z);throw w(J,I,this.F,this.I),J}await this.resetLocal();const T=this,z=new L.$3d;return{id:I,async merge(){return T.P(M,!0,I,z.token)},async apply(){try{try{await T.R(M,I,z.token)}catch(Z){if(i.$Vmb.toUserDataSyncError(Z).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(M,I,z.token);else throw Z}}catch(Z){throw T.H.error(Z),Z}T.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),T.$()},async stop(){z.cancel(),await T.U(),await T.resetLocal()}}}async P(p,I,F,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,p,I,F,M));const z=T.enabled.find(Z=>Z.resource==="profiles");if(z){const Z=await z.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Z,p,I,F,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,I,F,M,T){for(const z of p){if(T.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===z.id);if(!Z){this.H.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",z.name);const J=this.getOrCreateActiveProfileSynchronizer(Z,z);this.n.push(...await this.S(J,I,F,M,T))}for(const[z,Z]of this.z.entries())this.M.profiles.some(J=>J.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(z))}async R(p,I,F){const M=this.ab();for(const x of M){if(F.isCancellationRequested)return;await x.apply(I,F)}const T=M.find(x=>x.profile.isDefault);if(!T)return;const z=T.enabled.find(x=>x.resource==="profiles");if(!z)return;const J=(await z.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>M.every(V=>V.profile.id!==x.id));J.length&&await this.Q(J,p,!1,I,F)}async S(p,I,F,M,T){return(await p.sync(I,F,M,T)).map(([Z,J])=>({profile:p.profile,syncResource:Z,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const I=await this.N.resolveContent(p);if(I)return I;for(const F of this.ab())for(const M of F.enabled){const T=await M.resolveContent(p);if(T)return T}return null}async replace(p){this.cb();const I=this.N.resolveUserDataSyncResource(p);if(!I)return;const F=await this.resolveContent(p.uri);F&&await this.W(I.profile,async M=>{if(I.syncResource===M.resource)return await M.replace(F),!0})}async accept(p,I,F,M){this.cb(),await this.W(p.profile,async T=>{if(p.syncResource===T.resource)return await T.accept(I,F),M&&await T.apply((0,m.$Kf)(M)?!1:M.force,(0,i.$Umb)((0,C.$mg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(I){this.H.error(I)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),I=p.map(z=>z.collection),F=await this.D.getAllCollections(),M=F.filter(z=>!I.includes(z));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(z=>this.D.deleteCollection(z))),this.H.info("Deleted redundant collections on server"));const T=p.filter(z=>F.includes(z.collection));if(T.length!==p.length){const z=this.G.createInstance(n.$q8b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(p){this.cb();const I=await this.D.getActivityData();await this.C.writeFile(p,I)}async extractActivityData(p,I){const F=(await this.C.readFile(p)).value.toString(),M=JSON.parse(F);if(M.resources)for(const T in M.resources)for(const z of M.resources[T])await this.O.writeResource(T,z.content,new Date(z.created*1e3),void 0,I);if(M.collections)for(const T in M.collections)for(const z in M.collections[T].resources)for(const Z of M.collections[T].resources?.[z]??[])await this.O.writeResource(z,Z.content,new Date(Z.created*1e3),T,I)}async W(p,I){const F=new R.$Rc;try{const M=this.z.get(p.id);if(M){const x=await this.X(M[0],I,F);return(0,m.$Lf)(x)?null:x}if(p.isDefault){const x=F.add(this.G.createInstance(a,p,void 0)),V=await this.X(x,I,F);return(0,m.$Lf)(V)?null:V}if(this.M.isEnabled())return null;const T=F.add(this.G.createInstance(n.$q8b,p,void 0)),z=await this.D.manifest(null),J=(await T.getRemoteSyncedProfiles(z?.latest??null)||[]).find(x=>x.id===p.id);if(J){const x=F.add(this.G.createInstance(a,p,J.collection)),V=await this.X(x,I,F);return(0,m.$Lf)(V)?null:V}return null}finally{F.dispose()}}async X(p,I,F){const M=[...p.enabled,...p.disabled.reduce((T,z)=>(z!=="workspaceState"&&T.push(F.add(p.createSynchronizer(z))),T),[])];for(const T of M){const z=await I(T);if(!(0,m.$Lf)(z))return z}}Y(p){const I=this.f;this.f!==p&&(this.f=p,this.g.fire(p),I==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(I=>I.conflicts).flat();(0,D.$ub)(this.j,p,(I,F)=>I.profile.id===F.profile.id&&I.syncResource===F.syncResource&&(0,D.$ub)(I.conflicts,F.conflicts,(M,T)=>(0,k.$wg)(M.previewResource,T.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,I){let F=this.z.get(p.id);if(F&&F[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(p.id)),!F){const M=new R.$Rc,T=M.add(this.G.createInstance(a,p,I?.collection));M.add(T.onDidChangeStatus(z=>this.Y(z))),M.add(T.onDidChangeConflicts(z=>this.Z())),M.add(T.onDidChangeLocal(z=>this.h.fire(z))),this.z.set(p.id,F=[T,M])}return F[0]}ab(){const p=[];for(const[I]of this.z.values())p.push(I);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$t8b=r,e.$t8b=r=pe([X(0,c.$lk),X(1,i.$Qmb),X(2,i.$Pmb),X(3,g.$1h),X(4,i.$6mb),X(5,b.$pl),X(6,y.$gp),X(7,i.$1mb),X(8,l.$Xk),X(9,i.$3mb),X(10,i.$Rmb)],r);let a=class extends R.$Sc{get enabled(){return this.f.sort((p,I)=>p[1]-I[1]).map(([p])=>p)}get disabled(){return i.$Mmb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,I,F,M,T,z,Z,J,x,V){super(),this.profile=p,this.collection=I,this.r=F,this.t=M,this.u=T,this.w=z,this.y=Z,this.z=J,this.C=x,this.D=V,this.f=[],this.g="idle",this.h=this.B(new O.$Sd),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Sd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Sd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([Y,W])=>this.F(Y,W))),this.B((0,R.$Qc)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of i.$Mmb)F.isResourceEnabled(Y)&&this.G(Y)}F(p,I){I?this.G(p):this.H(p)}G(p){if(this.f.some(([T])=>T.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const I=new R.$Rc,F=I.add(this.createSynchronizer(p));I.add(F.onDidChangeStatus(()=>this.L())),I.add(F.onDidChangeConflicts(()=>this.M())),I.add(F.onDidChangeLocal(()=>this.j.fire(p)));const M=this.N(p);this.f.push([F,M,I])}H(p){const I=this.f.findIndex(([F])=>F.resource===p);if(I!==-1){const[[F,,M]]=this.f.splice(I,1);M.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(E.$C6b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$z6b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$H6b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$K6b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$fGb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$u6b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$q8b,this.profile,this.collection)}}async sync(p,I,F,M){if(M.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const z=[],Z=(0,i.$Umb)(F),J=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=I?await this.I(J):{};for(const V of T){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(I){const Y=await V.preview(J,x,Z);if(Y)for(const W of Y.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await V.merge(W.previewResource)}else await V.sync(J,Z)}catch(Y){const W=i.$Vmb.toUserDataSyncError(Y);if(w(W,F,this.w,this.y),v(Y))throw W;this.z.error(Y),this.z.error(`${V.resource}: ${(0,j.$Mi)(Y)}`),z.push([V.resource,W])}}return z}finally{this.L()}}async apply(p,I){const F=(0,i.$Umb)(p);for(const M of this.enabled){if(I.isCancellationRequested)return;try{await M.apply(!1,F)}catch(T){const z=i.$Vmb.toUserDataSyncError(T);if(w(z,p,this.w,this.y),v(T))throw z;this.z.error(T),this.z.error(`${M.resource}: ${(0,j.$Mi)(T)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(I){this.z.error(`${p.resource}: ${(0,j.$Mi)(I)}`),this.z.error(I)}}async I(p){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$Imb),F=this.enabled.find(M=>M instanceof E.$C6b);if(F){const M=await F.getRemoteUserDataSyncConfiguration(p);return{...I,...M}}return I}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,D.$ub)(this.m,p,(I,F)=>I.syncResource===F.syncResource&&(0,D.$ub)(I.conflicts,F.conflicts,(M,T)=>(0,k.$wg)(M.previewResource,T.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=pe([X(2,i.$1mb),X(3,g.$1h),X(4,$.$ko),X(5,i.$Pmb),X(6,b.$pl),X(7,i.$6mb),X(8,l.$Xk),X(9,S.$vi)],a);function v(f){if(f instanceof i.$Vmb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(f,p,I,F){F.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.$Wmb?String(f.serverCode):void 0,url:f instanceof i.$Wmb?f.url:void 0,resource:f.resource,executionId:p,service:I.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,17,24]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=e.$P$b=void 0;function R($,c){return{...$,profile:(0,j.$Yk)($.profile,c.profilesHome.scheme)}}function k($){return{created:$.created,uri:L.URI.revive($.uri)}}class m{constructor(c,g,y){this.c=c,this.d=g,this.f=y,this.a=new Map,this.b=new D.$Sd}listen(c,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(c,g,y){try{return await this.g(c,g,y)}catch(b){throw this.f.error(b),b}}async g(c,g,y){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),L.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(k(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(y[0]),L.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const b=g.substring(11),l=y[0],u=this.h(l);switch(y=y.slice(1),b){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(c){const g=this.a.get(this.j(c));if(!g)throw new Error(`Manual sync taks not found: ${c}`);return g}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$P$b=m;let C=class extends N.$Sc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new D.$Sd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Sd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Sd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Sd),this.onSyncErrors=this.m.event,this.a={call(y,b,l){return c.call(y,b,l).then(null,u=>{throw O.$Vmb.toUserDataSyncError(u)})},listen(y,b){return c.listen(y,b)}},this.a.call("_getInitialData").then(([y,b,l])=>{this.s(y),this.t(b),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(b=>({...b,error:O.$Vmb.toUserDataSyncError(b.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),g=this;return new S(c,{async call(b,l,u){return g.a.call(`manualSync/${b}`,[c,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,g,y,b){return this.a.call("accept",[c,g,y,b])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,g){return this.a.call("extractActivityData",[c,g])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map(g=>({syncResource:g.syncResource,profile:(0,j.$Yk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(y=>({...y,baseResource:L.URI.revive(y.baseResource),localResource:L.URI.revive(y.localResource),remoteResource:L.URI.revive(y.remoteResource),previewResource:L.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$Q$b=C,e.$Q$b=C=pe([X(1,j.$Xk)],C);class S extends N.$Sc{constructor(c,g){super(),this.id=c,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(le[261],he([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,59,43,21,24]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Fb=e.$7Fb=e.$6Fb=e.$5Fb=e.$4Fb=void 0;const E="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Sc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$Ymb,-1)}set c(F){this.h.store(d.$Ymb,F,-1,k.$o?0:1)}constructor(F,M,T){super(),this.f=F,this.g=M,this.h=T,this.a=this.B(new j.$Sd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const z=this.B(new O.$Rc);this.B(j.Event.filter(T.onDidChangeValue(-1,d.$Ymb,z),()=>this.c!==this.userDataSyncStore?.type,z)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(F){if(F&&(F=k.$o&&F.web?{...F,...F.web}:F,(0,C.$Ef)(F.url)&&(0,C.$Gf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(M=>Array.isArray(F.authenticationProviders[M].scopes)))){const M=F,T=!!M.canSwitch,z=M.url===M.insidersUrl?"insiders":"stable",Z=(T?this.c:void 0)||z,J=Z==="insiders"?M.insidersUrl:Z==="stable"?M.stableUrl:M.url;return{url:S.URI.parse(J),type:Z,defaultType:z,defaultUrl:S.URI.parse(M.url),stableUrl:S.URI.parse(M.stableUrl),insidersUrl:S.URI.parse(M.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,V)=>(x.push({id:V,scopes:M.authenticationProviders[V].scopes}),x),[])}}}};e.$4Fb=a,e.$4Fb=a=pe([X(0,b.$Bj),X(1,c.$vi),X(2,h.$gp)],a);let v=class extends a{constructor(F,M,T){super(F,M,T);const z=this.h.get(s,-1);z&&(this.n=JSON.parse(z));const Z=this.f[E];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$5Fb=v,e.$5Fb=v=pe([X(0,b.$Bj),X(1,c.$vi),X(2,h.$gp)],v);let w=class extends O.$Sc{get donotMakeRequestsUntil(){return this.j}constructor(F,M,T,z,Z,J,x){super(),this.n=T,this.r=z,this.s=x,this.g=this.B(new j.$Sd),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Sd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Sd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,u.$mp)(Z,J,x).then(V=>{const Y={"X-Client-Name":`${M.applicationName}${k.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,O.$Qc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,M){this.b={token:F,type:M}}t(F){this.a=F?(0,m.$Dg)(F,"v1"):void 0}u(){const F=this.s.getNumber(o,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,D.$Pg)(M=>(0,D.$3g)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,m.$Dg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const T=await this.D(M,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,l.$_o)(T))?.map(({id:z})=>z)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,m.$Dg)(this.a,"collection").toString();F={...F},F["Content-Type"]=R.$3r.text;const T=await this.D(M,{type:"POST",headers:F},[],N.CancellationToken.None),z=await(0,l.$$o)(T);if(!z)throw new d.$Wmb("Server did not return the collection id",M,"NoCollection",T.res.statusCode,T.res.headers[d.$Smb]);return z}async deleteCollection(F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=F?(0,m.$Dg)(this.a,"collection",F).toString():(0,m.$Dg)(this.a,"collection").toString();M={...M},await this.D(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(F,M){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,M,F),z={},Z=await this.D(T.toString(),{type:"GET",headers:z},[],N.CancellationToken.None);return(await(0,l.$_o)(Z)||[]).map(({url:x,created:V})=>({ref:(0,m.$Fg)(T,T.with({path:x})),created:V*1e3}))}async resolveResourceContent(F,M,T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,m.$Dg)(this.z(this.a,T,F),M).toString();z={...z},z["Cache-Control"]="no-cache";const J=await this.D(Z,{type:"GET",headers:z},[],N.CancellationToken.None);return await(0,l.$$o)(J)}async deleteResource(F,M,T){if(!this.a)throw new Error("No settings sync store url configured.");const z=M!==null?(0,m.$Dg)(this.z(this.a,T,F),M).toString():this.z(this.a,T,F).toString(),Z={};await this.D(z,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$Dg)(this.a,"resource").toString(),M={"Content-Type":R.$3r.text};await this.D(F,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(F,M,T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,m.$Dg)(this.z(this.a,T,F),"latest").toString();z={...z},z["Cache-Control"]="no-cache",M&&(z["If-None-Match"]=M.ref);const J=await this.D(Z,{type:"GET",headers:z},[304],N.CancellationToken.None);let x=null;if(J.res.statusCode===304&&(x=M),x===null){const V=J.res.headers.etag;if(!V)throw new d.$Wmb("Server did not return the ref",Z,"NoRef",J.res.statusCode,J.res.headers[d.$Smb]);const Y=await(0,l.$$o)(J);if(!Y&&J.res.statusCode===304)throw new d.$Wmb("Empty response",Z,"EmptyResponse",J.res.statusCode,J.res.headers[d.$Smb]);x={ref:V,content:Y}}return x}async writeResource(F,M,T,z,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,z,F).toString();Z={...Z},Z["Content-Type"]=R.$3r.text,T&&(Z["If-Match"]=T);const x=await this.D(J,{type:"POST",data:M,headers:Z},[],N.CancellationToken.None),V=x.res.headers.etag;if(!V)throw new d.$Wmb("Server did not return the ref",J,"NoRef",x.res.statusCode,x.res.headers[d.$Smb]);return V}async manifest(F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,m.$Dg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",F&&(M["If-None-Match"]=F.ref);const z=await this.D(T,{type:"GET",headers:M},[304],N.CancellationToken.None);let Z=null;if(z.res.statusCode===304&&(Z=F),!Z){const x=z.res.headers.etag;if(!x)throw new d.$Wmb("Server did not return the ref",T,"NoRef",z.res.statusCode,z.res.headers[d.$Smb]);const V=await(0,l.$$o)(z);if(!V&&z.res.statusCode===304)throw new d.$Wmb("Empty response",T,"EmptyResponse",z.res.statusCode,z.res.headers[d.$Smb]);V&&(Z={...JSON.parse(V),ref:x})}const J=this.s.get(n,-1);return J&&Z&&J!==Z.session&&this.C(),Z===null&&J&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,m.$Dg)(this.a,"download").toString(),M={},T=await this.D(F,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,l.$8o)(T))throw new d.$Wmb("Server returned "+T.res.statusCode,F,"EmptyResponse",T.res.statusCode,T.res.headers[d.$Smb]);if((0,l.$9o)(T))throw new d.$Wmb("Empty response",F,"EmptyResponse",T.res.statusCode,T.res.headers[d.$Smb]);return T.stream}z(F,M,T){return M?(0,m.$Dg)(F,"collection",M,"resource",T):(0,m.$Dg)(F,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(F,M,T,z){if(!this.b)throw new d.$Wmb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$Wmb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;M.headers={...M.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:F,type:M.type,headers:{...M.headers,authorization:void 0}});let J;try{J=await this.f.request(F,M,z)}catch(B){if(!(B instanceof d.$Wmb)){let te="RequestFailed";const se=(0,L.$0)(B).toLowerCase();se.includes("xhr timeout")?te="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?te="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":se.includes("headers must be an object")?te="RequestHeadersNotObject":(0,L.$4)(B)&&(te="RequestCanceled"),B=new d.$Wmb(`Connection refused for the request '${F}'.`,F,te,void 0,void 0)}throw this.r.info("Request failed",F),B}const x=J.res.headers[d.$Smb],V={url:F,status:J.res.statusCode,"execution-id":M.headers[d.$Tmb],"operation-id":x},Y=(0,l.$8o)(J)||J.res.statusCode&&T.includes(J.res.statusCode);let W="";if(Y?this.r.trace("Request succeeded",V):(W=await(0,l.$0o)(J)||"",this.r.info("Request failed",V,W)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$Wmb(`${M.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",J.res.statusCode,x);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$Wmb(`${M.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",J.res.statusCode,x)}if(this.h.fire(),J.res.statusCode===404)throw new d.$Wmb(`${M.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",J.res.statusCode,x);if(J.res.statusCode===405)throw new d.$Wmb(`${M.type} request '${F}' failed because the requested endpoint is not found (405). ${W}`,F,"MethodNotFound",J.res.statusCode,x);if(J.res.statusCode===409)throw new d.$Wmb(`${M.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",J.res.statusCode,x);if(J.res.statusCode===410)throw new d.$Wmb(`${M.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",J.res.statusCode,x);if(J.res.statusCode===412)throw new d.$Wmb(`${M.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",J.res.statusCode,x);if(J.res.statusCode===413)throw new d.$Wmb(`${M.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",J.res.statusCode,x);if(J.res.statusCode===426)throw new d.$Wmb(`${M.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",J.res.statusCode,x);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new d.$Wmb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",J.res.statusCode,x)):new d.$Wmb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",J.res.statusCode,x)}if(!Y)throw new d.$Wmb("Server returned "+J.res.statusCode,F,"Unknown",J.res.statusCode,x);return J}F(F){let M=this.s.get(i,-1);M===void 0&&(M=(0,$.$mg)(),this.s.store(i,M,-1,1)),F["X-Machine-Session-Id"]=M;const T=this.s.get(n,-1);T!==void 0&&(F["X-User-Session-Id"]=T)}};e.$6Fb=w,e.$6Fb=w=pe([X(1,b.$Bj),X(2,l.$6o),X(3,d.$6mb),X(4,g.$9h),X(5,y.$lk),X(6,h.$gp)],w);let f=class extends w{constructor(F,M,T,z,Z,J,x){super(F.userDataSyncStore?.url,M,T,z,Z,J,x),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$7Fb=f,e.$7Fb=f=pe([X(0,d.$Pmb),X(1,b.$Bj),X(2,l.$6o),X(3,d.$6mb),X(4,g.$9h),X(5,y.$lk),X(6,h.$gp)],f);class p{constructor(F,M,T,z){this.c=F,this.d=M,this.f=T,this.g=z,this.a=[],this.b=void 0}request(F,M,T){if(this.h()&&this.i(),M.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$Wmb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(M,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$8Fb=p}),define(le[262],he([0,1,3,57,25,21,22,257,24,80,83]),function(ne,e,D,N,L,j,O,R,k,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=void 0;let S=class extends R.$u8b{constructor(c,g,y,b,l,u,h,d,E,s,o){super(c,g,y,b,l,h,d,E,s,o),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$$$b=S,e.$$$b=S=pe([X(0,L.$Bj),X(1,k.$Pmb),X(2,k.$Qmb),X(3,k.$1mb),X(4,k.$2mb),X(5,N.$29b),X(6,k.$6mb),X(7,m.$IEb),X(8,O.$pl),X(9,C.$Dmb),X(10,j.$gp)],S)}),define(le[263],he([0,1,72,23,5,19]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=e.$u9b=e.$t9b=void 0,e.$t9b=128/4;function O(m){function C(){let S=m.scheme===N.Schemas.file?(0,j.$rg)(m):m.toString();return L.$k||(S=S.toLowerCase()),(0,D.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:m}}e.$u9b=O;function R(m,C){function S(){if(m.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(m.toString()).digest("hex");if(!C)return;let c;return L.$k?c=C.ino:L.$j?c=C.birthtime.getTime():L.$i&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,D.createHash)("md5").update(m.fsPath).update(c?String(c):"").digest("hex")}const $=S();if(typeof $=="string")return{id:$,uri:m}}e.$v9b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$w9b=k}),define(le[264],he([0,1,6,7,2,16,31,14,8,77,112,263,57,56,23]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=void 0;let y=class extends L.$Sc{constructor(l,u,h,d){super(),this.a=l,this.b=u,this.c=h,this.f=d,this.B(new D.$bh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,u=await O.Promises.readdir(l),h=new m.$hFb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const E=(0,j.$jc)(l,d);d.length===S.$t9b||d===C.$bi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await h.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(E))}))}catch(l){(0,N.$1)(l)}}};e.$E$b=y,e.$E$b=y=pe([X(0,R.$0h),X(1,k.$jj),X(2,$.$29b),X(3,c.$d$b)],y)}),define(le[122],he([0,1,72,63,36,272,15,7,3,2,16,5,32,40,67]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class y{traceSocketEvent(f,p){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,p)}constructor(f,p=""){this.f=!0,this.debugLabel=p,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,R.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const p=I=>{this.traceSocketEvent("read",I),f(O.$ge.wrap(I))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(f){const p=I=>{f({type:0,hadError:I,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(f){const p=()=>{f()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Qh=y;var b;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var l;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(l||(l={}));class u extends m.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,p){this.socket.traceSocketEvent(f,p)}constructor(f,p,I,F){super(),this.f=this.B(new k.$Sd),this.g=this.B(new k.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:I?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new h(this,p,I,F,this.f,(M,T)=>this.m(M,T))),this.B(this.a.onError(M=>{console.error(M),(0,R.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new g.$Lh,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let p=0;for(;p<f.byteLength;)this.a.writeMessage(f.slice(p,Math.min(p+262144,f.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(f,{compressed:p,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let F=2;f.byteLength<126?F+=0:f.byteLength<2**16?F+=2:F+=8;const M=O.$ge.alloc(F),T=p?64:0,z=I&15;if(M.writeUInt8(128|T|z,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let Z=1;M.writeUInt8(f.byteLength>>>8&255,++Z),M.writeUInt8(f.byteLength>>>0&255,++Z)}else{M.writeUInt8(127,1);let Z=1;M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(0,++Z),M.writeUInt8(f.byteLength>>>24&255,++Z),M.writeUInt8(f.byteLength>>>16&255,++Z),M.writeUInt8(f.byteLength>>>8&255,++Z),M.writeUInt8(f.byteLength>>>0&255,++Z)}this.socket.write(O.$ge.concat([M,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),I=p.readUInt8(0),F=(I&128)>>>7,M=(I&64)>>>6,T=I&15,z=p.readUInt8(1),Z=(z&128)>>>7,J=z&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),I=p.readUInt8(1),F=(I&128)>>>7;let M=I&127,T=1;M===126?M=p.readUInt8(++T)*2**8+p.readUInt8(++T):M===127&&(M=p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*0+p.readUInt8(++T)*2**24+p.readUInt8(++T)*2**16+p.readUInt8(++T)*2**8+p.readUInt8(++T));let z=0;F&&(z=p.readUInt8(++T)*2**24+p.readUInt8(++T)*2**16+p.readUInt8(++T)*2**8+p.readUInt8(++T)),this.j.state=3,this.j.readLen=M,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),s(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=u;class h extends m.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ge.alloc(0)}constructor(f,p,I,F,M,T){super(),this.n=f,this.r=M,this.s=T,this.a=this.B(new k.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new d(this.n,F,I,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(f,p){this.g.push({data:f,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:p}=this.g.shift();if(this.f&&p.compressed){const I=await this.w(this.f,f);this.s(I,p)}else this.s(f,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,p){return new Promise((I,F)=>{f.write(p),f.flush(M=>I(M))})}acceptFrame(f,p,I){this.h.push({data:f,isCompressed:p,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const p=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,p,I){return new Promise((F,M)=>{f.write(p),I&&f.write(O.$ge.fromByteArray([0,0,255,255])),f.flush(T=>F(T))})}}class d extends m.$Sc{get recordedInflateBytes(){return this.j?O.$ge.concat(this.f):O.$ge.alloc(0)}constructor(f,p,I,F){super(),this.h=f,this.j=p,this.a=this.B(new k.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(F),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$ge.wrap(M))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=O.$ge.concat(this.g);this.g.length=0,f(p)})}}class E extends m.$Sc{constructor(f,p){super(),this.g=f,this.a=this.B(new k.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(O.$ge.wrap(I))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=O.$ge.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),f(p)})}}function s(w,f){if(f===0)return;const p=w.byteLength>>>2;for(let Z=0;Z<p;Z++){const J=w.readUInt32BE(Z*4);w.writeUInt32BE(J^f,Z*4)}const I=p*4,F=w.byteLength-I,M=f>>>24&255,T=f>>>16&255,z=f>>>8&255;F>=1&&w.writeUInt8(w.readUInt8(I)^M,I),F>=2&&w.writeUInt8(w.readUInt8(I+1)^T,I+1),F>=3&&w.writeUInt8(w.readUInt8(I+2)^z,I+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const w=(0,$.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,L.tmpdir)(),p=(0,C.$jc)(f,`vscode-ipc-${w}.sock`);return t(p),p}e.$Th=n;function i(w,f,p){const I=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${p}-${f}-sock`;const F=p.substr(0,4),M=f.substr(0,6),T=I.substr(0,8);let z;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?z=(0,C.$jc)(e.$Sh,`vscode-${T}-${F}-${M}.sock`):z=(0,C.$jc)(w,`${F}-${M}.sock`),t(z),z}e.$Uh=i;function t(w){const f=o[S.$u];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$Fh{static b(f){const p=k.Event.fromNodeEventEmitter(f,"connection");return k.Event.map(p,I=>({protocol:new g.$Mh(new y(I,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(I,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=r;function a(w){return new Promise((f,p)=>{const I=(0,N.createServer)();I.on("error",p),I.listen(w,()=>{I.removeListener("error",p),f(new r(I))})})}e.$Wh=a;function v(w,f){return new Promise((p,I)=>{const F=(0,N.createConnection)(w,()=>{F.removeListener("error",I),p(g.$Nh.fromSocket(new y(F,`ipc-client${f}`),f))});F.once("error",I)})}e.$Xh=v}),define(le[265],he([0,1,63,122,211]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=void 0,e.$b_b=new class{supports(j){return!0}connect({host:j,port:O},R,k,m){return new Promise((C,S)=>{const $=D.createConnection({host:j,port:O},()=>{$.removeListener("error",S),$.write((0,L.$_qb)(R,k,m));const c=g=>{g.toString().indexOf(`\r
\r
`)>=0&&($.off("data",c),C(new N.$Qh($,m)))};$.on("data",c)});$.setNoDelay(!0),$.once("error",S)})}}}),define(le[266],he([0,1,63,36,132,122,6,2,5,20,8,25,214,104,106,78,15]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=e.$80b=e.$70b=void 0;async function l(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new u(s,o,n,i,t).waitForReady(),!(t&&L.$pg[t]||!L.$pg[r.tunnelLocalPort]));a--);return r}class u extends R.$Sc{constructor(o,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=D.createServer(),this.c=new O.$1g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,y.$sv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$qg)(o,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,y.$qv)(this.tunnelRemoteHost)||(0,y.$sv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,$.$gl)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$Qh?t.socket.destroy():t.end()}),t instanceof j.$Qh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(b.$ge.wrap(i))),o.resume()}t(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$70b=u;let h=class extends y.$vv{constructor(o,n,i,t,r){super(n,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,y.$tv)(o,this.l,k.OS,N.release())}s(o,n,i,t,r,a,v,w){const f=this.r(n,i);if(f)return++f.refcount,f.value;if((0,y.$nv)(o))return this.t(o,n,i,r,a,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=l(p,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,I),I}}};e.$80b=h,e.$80b=h=pe([X(0,c.$al),X(1,C.$jj),X(2,g.$dl),X(3,S.$Bj),X(4,m.$vi)],h);let d=class extends h{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.$90b=d,e.$90b=d=pe([X(0,c.$al),X(1,C.$jj),X(2,g.$dl),X(3,S.$Bj),X(4,m.$vi)],d);let E=class extends R.$Sc{constructor(o,n,i,t,r){super(),this.b=o,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,i,t,r,a,v,w,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const p=new d(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,i,t,r,a,v,w,f)}};e.$00b=E,e.$00b=E=pe([X(0,c.$al),X(1,C.$jj),X(2,S.$Bj),X(3,g.$dl),X(4,m.$vi)],E)}),define(le[273],he([0,1,36,38,7,2,23,10,18,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,14,114,248,29,97,188,113,98,11,199,200,71,4,195,73,74,227,8,201,102,25,59,21,107,22,108,109,110,45,230,82,111,24,80,256,240,241,83,255,259,260,261,60,254,242,106,220,78,266,215,231,28,232,5,233,190,208,207,81,247,17,51,204,58,253,229,243,105,258,249,9,202,101,251,246,217,184,57,203,262,250,56,252,104,265,181,218]),function(ne,e,D,N,L,j,O,R,k,m,C,S,$,c,g,y,b,l,u,h,d,E,s,o,n,i,t,r,a,v,w,f,p,I,F,M,T,z,Z,J,x,V,Y,W,B,te,se,_,re,K,U,P,A,H,q,ee,G,Q,ie,ce,oe,fe,de,we,ve,Ie,De,Me,ue,ge,me,Pe,Re,Te,je,qe,Ne,Ue,ae,$e,be,ye,ke,Se,Ce,Oe,Ae,Fe,ze,Ve,Be,xe,_e,yt,vt,Et,St,ft,kt,Pt,Ct,Rt,It,Ot,Dt,jt,dt,Lt,$t,At,Nt,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends j.$Sc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new S.$rU(this)),this.b=void 0,this.c=this.B(new m.$Sd),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,S.$sU)(process.parentPort,nt.$j0b.exit,Le)}async init(){const Ee=await this.h();(0,Q.$Kmb)(),Ee.invokeFunction(Le=>{const Ke=Le.get(Y.$jj),We=Le.get(K.$pl),Qe=Le.get(Oe.$Xk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ke),this.n(We,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(We,Qe)))}),this.B((0,j.$Pc)(Ee.createInstance($.$A$b,this.f.codeCachePath),Ee.createInstance(c.$B$b),Ee.createInstance(b.$E$b),Ee.createInstance(y.$D$b),Ee.createInstance(g.$C$b),Ee.createInstance(vt.$5$b),Ee.createInstance(xe.$W$b)))}async h(){const Ee=new J.$Zh,Le={_serviceBrand:void 0,...B.default};Ee.set(te.$Bj,Le);const Ke=new C.$Jh(Ge=>Ge==="main"),We=new dt.$e$b(this.a,Ke);Ee.set(dt.$d$b,We);const Qe=this.f.policiesData?new Fe.$M0b(this.f.policiesData,We.getChannel("policy")):new ze.$xn;Ee.set(ze.$vn,Qe);const He=new Nt.$wm(this.f.args,Le);Ee.set(i.$0h,He);const et=new W.$lr(void 0,this.f.logLevel,He.logsHome,this.f.loggers.map(Ge=>({...Ge,resource:R.URI.revive(Ge.resource)})),We.getChannel("logger"));Ee.set(Y.$kj,et);const rt=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),lt=this.B(new Y.$rj(rt.getLevel())),Je=this.B(new St.$bO(rt,[lt]));Ee.set(Y.$jj,Je),this.b=this.B(new ft.$7$b(Je)),Ee.set(ft.$6$b,this.b);const Ye=this.B(new F.$1p(Je));Ee.set(I.$lk,Ye);const ht=this.B(new M.$nq(Je));Ye.registerProvider(O.Schemas.file,ht);const ot=new Ue.$Mr(Ye);Ee.set(Ne.$Vk,ot);const Xe=this.B(new Ve.$iO(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Ee.set(Oe.$Xk,Xe);const ut=this.B(new $e.$c$b(O.Schemas.file,this.B(new be.$WN(We.getChannel(be.$VN),{pathCaseSensitive:ae.$k})),O.Schemas.vscodeUserData,Xe,ot,Je));Ye.registerProvider(O.Schemas.vscodeUserData,ut);const Ze=this.B(new d.$Xn(Xe.defaultProfile.settingsResource,Ye,Qe,Je));Ee.set(h.$vi,Ze);const tt=new Lt.$a_b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},We,He);Ee.set(_.$gp,tt),this.B((0,j.$Qc)(()=>tt.flush())),await Promise.all([Ze.initialize(),tt.initialize()]);const mt=new Ct.$0q(We.getChannel("request"));Ee.set(se.$6o,mt),Ee.set(l.$F$b,new T.$Yh(u.$G$b,void 0,!1)),Ee.set(ke.$3E,new T.$Yh(ye.$V$b,void 0,!1));const bt=new Ot.$j$b(-1,We);Ee.set(It.$29b,bt),Ee.set(o.$2n,new T.$Yh(n.$qO,void 0,!0));const Mt=this.B(new ge.$J0b(bt)),Tt=new C.$Jh(Ge=>Mt.getActiveClientId().then(ct=>Ge===ct));Ee.set(p.$rYb,new Rt.$9$b(this.a.getChannel("extensionRecommendationNotification",Tt)));let at;const it=[],wt=(0,H.$Jo)(Le,Ze);if((0,H.$Eo)(Le,He)){const Ge=new P.$L7b(Je,et,He,Le);if(it.push(Ge),!(0,H.$Fo)(Le,He)&&Le.aiConfig?.ariaKey){const ct=new Be.$2N(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Qc)(()=>ct.flush())),it.push(ct)}at=new A.$br({appenders:it,commonProperties:(0,re.$uo)((0,D.release)(),(0,D.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,H.$Ko)(He)},Ze,Le)}else{at=H.$yo;const Ge=H.$Co;it.push(Ge)}this.a.registerChannel("telemetryAppender",new U.$o0b(it)),Ee.set(K.$pl,at);const Ut=new q.$H$b(Ze,at,Je,et,He,Le);Ee.set(K.$ql,Ut),Ee.set(Ae.$Hp,new T.$Yh(Pt.$aO,void 0,!0)),Ee.set(Se.$Lp,new T.$Yh(Ce.$N0b,void 0,!0)),Ee.set(v.$rp,new T.$Yh(v.$sp,void 0,!0)),Ee.set(f.$Vp,new T.$Yh(f.$Wp,void 0,!0)),Ee.set(a.$ko,new T.$Yh(r.$pp,void 0,!0)),Ee.set(a.$qo,new T.$Yh(jt.$_$b,void 0,!1)),Ee.set(x.$6q,new T.$Yh(V.$8q,void 0,!1)),Ee.set(E.$Dm,new T.$Yh(s.$Tr,void 0,!1)),Ee.set(ie.$IEb,new T.$Yh(ie.$JEb,void 0,!0)),Ee.set(Q.$6mb,new T.$Yh(fe.$VGb,void 0,!0)),Ee.set(Q.$5mb,new oe.$K$b(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Ee.set(a.$po,new T.$Yh(t.$GEb,void 0,!1)),Ee.set(G.$TGb,new T.$Yh(G.$UGb,void 0,!0)),Ee.set(ee.$$u,new T.$Yh(ee.$_u)),Ee.set(Q.$Pmb,new T.$Yh(De.$5Fb,void 0,!0)),Ee.set(Q.$Qmb,new T.$Yh(De.$7Fb,void 0,!0)),Ee.set(de.$Dmb,new T.$Yh(de.$Fmb,void 0,!0)),Ee.set(Q.$Rmb,new T.$Yh(ce.$o8b,void 0,!1)),Ee.set(Q.$1mb,new T.$Yh(we.$d8b,void 0,!0)),Ee.set(Q.$2mb,new T.$Yh(ve.$t8b,void 0,!1)),Ee.set(Me.$iFb,new T.$Yh(ue.$R$b,void 0,!0)),Ee.set(Q.$3mb,new T.$Yh(yt.$38b,void 0,!0)),Ee.set(me.$dl,new T.$Yh(Pe.$_0b,void 0,!1));const pt=new $t.$bl;return Ee.set($t.$al,pt),pt.register(0,At.$b_b),Ee.set(Re.$mv,new T.$Yh(Te.$00b)),Ee.set(je.$S$b,new T.$Yh(qe.$U$b)),Ee.set(_e.$X$b,new T.$Yh(kt.$8$b)),new Z.$qq(Ee)}j(Ee){const Le=this.B(new j.$Rc),Ke=new w.$up(Ee.get(a.$mo),()=>null);this.a.registerChannel("extensions",Ke);const We=C.ProxyChannel.fromService(Ee.get(x.$6q),Le);this.a.registerChannel("languagePacks",We);const Qe=C.ProxyChannel.fromService(Ee.get(E.$Dm),Le);this.a.registerChannel("diagnostics",Qe);const He=new w.$wp(Ee.get(a.$qo));this.a.registerChannel("extensionTipsService",He);const et=C.ProxyChannel.fromService(Ee.get(l.$F$b),Le);this.a.registerChannel("checksum",et);const rt=C.ProxyChannel.fromService(Ee.get(ke.$3E),Le);this.a.registerChannel("v8InspectProfiling",rt);const lt=new oe.$L$b(Ee.get(de.$Dmb));this.a.registerChannel("userDataSyncMachines",lt);const Je=C.ProxyChannel.fromService(Ee.get(K.$ql),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Ye=new oe.$M$b(Ee.get(ie.$IEb));this.a.registerChannel("userDataSyncAccount",Ye);const ht=new oe.$N$b(Ee.get(Q.$Pmb));this.a.registerChannel("userDataSyncStoreManagement",ht);const ot=new Ie.$P$b(Ee.get(Q.$2mb),Ee.get(Oe.$Xk),Ee.get(Y.$jj));this.a.registerChannel("userDataSync",ot);const Xe=this.B(Ee.get(z.$1h).createInstance(Dt.$$$b)),ut=new oe.$I$b(Xe);this.a.registerChannel("userDataAutoSync",ut),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Ee.get(Q.$3mb),Le));const Ze=C.ProxyChannel.fromService(Ee.get(je.$S$b),Le);this.a.registerChannel(je.$T$b,Ze);const tt=C.ProxyChannel.fromService(Ee.get(_e.$X$b),Le);this.a.registerChannel("remoteTunnel",tt)}m(Ee){process.on("uncaughtException",Le=>(0,L.$1)(Le)),process.on("unhandledRejection",Le=>(0,L.$1)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Ke=(0,N.$Mi)(Le,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==nt.$l0b.response)return!1;const Le=(0,k.$Ob)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function gt(st){const Ee=new Ft(st);process.parentPort.postMessage(nt.$j0b.ipcReady),await Ee.init(),process.parentPort.postMessage(nt.$j0b.initDone)}e.main=gt,process.parentPort.once("message",st=>{gt(st.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4ded39cfd580476a8f97303ce24848a7710b3427/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
