/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(me){for(var e=[],E=0,T=me.length;E<T;E++)e[E]=Pe[me[E]];return e};define(Pe[66],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function E(A){return(m,g,w)=>{let R=null,S=null;if(typeof w.value=="function"?(R="value",S=w.value):typeof w.get=="function"&&(R="get",S=w.get),!S)throw new Error("not supported");w[R]=A(S,g)}}function T(A,m,g){let w=null,R=null;if(typeof g.value=="function"?(w="value",R=g.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",R=g.get),!R)throw new Error("not supported");const S=`$memoize$${m}`;g[w]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[S]}}e.$th=T;function I(A,m,g){return E((w,R)=>{const S=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...$){this[l]||(this[l]=g?g():void 0),clearTimeout(this[S]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[S]=setTimeout(()=>{w.apply(this,$),this[l]=g?g():void 0},A)}})}e.$uh=I;function M(A,m,g){return E((w,R)=>{const S=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...n){if(this[l]||(this[l]=g?g():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...n)),this[v])return;const o=this[$]+A;o<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[v]=!0,this[S]=setTimeout(()=>{this[v]=!1,this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$vh=M}),define(Pe[89],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$VM=E,e.$WM=new E("id#")}),define(Pe[119],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(i,s=!1){let u=0;const d=i.length;let b="",f=0,D=16,F=0;function p(z){let C=0,P=0;for(;C<z;){const Y=i.charCodeAt(u);if(Y>=48&&Y<=57)P=P*16+Y-48;else if(Y>=65&&Y<=70)P=P*16+Y-65+10;else if(Y>=97&&Y<=102)P=P*16+Y-97+10;else break;u++,C++}return C<z&&(P=-1),P}function y(z){u=z,b="",f=0,D=16,F=0}function k(){const z=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return F=3,i.substring(z,u);let C=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;C=u}else F=3;return i.substring(z,C)}function O(){let z="",C=u;for(;;){if(u>=d){z+=i.substring(C,u),F=2;break}const P=i.charCodeAt(u);if(P===34){z+=i.substring(C,u),u++;break}if(P===92){if(z+=i.substring(C,u),u++,u>=d){F=2;break}switch(i.charCodeAt(u++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const ae=p(4);ae>=0?z+=String.fromCharCode(ae):F=4;break}default:F=5}C=u;continue}if(P>=0&&P<=31)if(g(P)){z+=i.substring(C,u),F=2;break}else F=6;u++}return z}function K(){if(b="",F=0,f=u,u>=d)return f=d,D=17;let z=i.charCodeAt(u);if(m(z)){do u++,b+=String.fromCharCode(z),z=i.charCodeAt(u);while(m(z));return D=15}if(g(z))return u++,b+=String.fromCharCode(z),z===13&&i.charCodeAt(u)===10&&(u++,b+=`
`),D=14;switch(z){case 123:return u++,D=1;case 125:return u++,D=2;case 91:return u++,D=3;case 93:return u++,D=4;case 58:return u++,D=6;case 44:return u++,D=5;case 34:return u++,b=O(),D=10;case 47:{const C=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return b=i.substring(C,u),D=12}if(i.charCodeAt(u+1)===42){u+=2;const P=d-1;let Y=!1;for(;u<P;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,Y=!0;break}u++}return Y||(u++,F=1),b=i.substring(C,u),D=13}return b+=String.fromCharCode(z),u++,D=16}case 45:if(b+=String.fromCharCode(z),u++,u===d||!w(i.charCodeAt(u)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=k(),D=11;default:for(;u<d&&U(z);)u++,z=i.charCodeAt(u);if(f!==u){switch(b=i.substring(f,u),b){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return b+=String.fromCharCode(z),u++,D=16}}function U(z){if(m(z)||g(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let z;do z=K();while(z>=12&&z<=15);return z}return{setPosition:y,getPosition:()=>u,scan:s?L:K,getToken:()=>D,getTokenValue:()=>b,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>F}}e.$8m=A;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,s){const u=[],d=new Object;let b;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function F(p,y,k,O){f.value=p,f.offset=y,f.length=k,f.type=O,f.colonOffset=void 0,b=f}try{a(i,{onObjectBegin:(p,y)=>{if(s<=p)throw d;b=void 0,D=s>p,u.push("")},onObjectProperty:(p,y,k)=>{if(s<y||(F(p,y,k,"property"),u[u.length-1]=p,s<=y+k))throw d},onObjectEnd:(p,y)=>{if(s<=p)throw d;b=void 0,u.pop()},onArrayBegin:(p,y)=>{if(s<=p)throw d;b=void 0,u.push(0)},onArrayEnd:(p,y)=>{if(s<=p)throw d;b=void 0,u.pop()},onLiteralValue:(p,y,k)=>{if(s<y||(F(p,y,k,h(p)),s<=y+k))throw d},onSeparator:(p,y,k)=>{if(s<=y)throw d;if(p===":"&&b&&b.type==="property")b.colonOffset=y,D=!1,b=void 0;else if(p===","){const O=u[u.length-1];typeof O=="number"?u[u.length-1]=O+1:(D=!0,u[u.length-1]=""),b=void 0}}})}catch(p){if(p!==d)throw p}return{path:u,previousNode:b,isAtPropertyKey:D,matches:p=>{let y=0;for(let k=0;y<p.length&&k<u.length;k++)if(p[y]===u[k]||p[y]==="*")y++;else if(p[y]!=="**")return!1;return y===p.length}}}e.$9m=S;function l(i,s=[],u=M.DEFAULT){let d=null,b=[];const f=[];function D(p){Array.isArray(b)?b.push(p):d!==null&&(b[d]=p)}return a(i,{onObjectBegin:()=>{const p={};D(p),f.push(b),b=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const p=[];D(p),f.push(b),b=p,d=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:D,onError:(p,y,k)=>{s.push({error:p,offset:y,length:k})}},u),b[0]}e.$0m=l;function $(i,s=[],u=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(p){d.type==="property"&&(d.length=p-d.offset,d=d.parent)}function f(p){return d.children.push(p),p}a(i,{onObjectBegin:p=>{d=f({type:"object",offset:p,length:-1,parent:d,children:[]})},onObjectProperty:(p,y,k)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:p,offset:y,length:k,parent:d})},onObjectEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onArrayBegin:(p,y)=>{d=f({type:"array",offset:p,length:-1,parent:d,children:[]})},onArrayEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onLiteralValue:(p,y,k)=>{f({type:h(p),offset:y,length:k,parent:d,value:p}),b(y+k)},onSeparator:(p,y,k)=>{d.type==="property"&&(p===":"?d.colonOffset=y:p===","&&b(y))},onError:(p,y,k)=>{s.push({error:p,offset:y,length:k})}},u);const F=d.children[0];return F&&delete F.parent,F}e.$$m=$;function v(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let b=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],b=!0;break}if(!b)return}else{const b=d;if(u.type!=="array"||b<0||!Array.isArray(u.children)||b>=u.children.length)return;u=u.children[b]}return u}e.$_m=v;function n(i){if(!i.parent||!i.parent.children)return[];const s=n(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$an=n;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$bn=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$cn=t;function r(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let b=0;b<d.length&&d[b].offset<=s;b++){const f=r(d[b],s,u);if(f)return f}return i}}e.$dn=r;function a(i,s,u=M.DEFAULT){const d=A(i,!1);function b(te){return te?()=>te(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(te){return te?Se=>te(Se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const D=b(s.onObjectBegin),F=f(s.onObjectProperty),p=b(s.onObjectEnd),y=b(s.onArrayBegin),k=b(s.onArrayEnd),O=f(s.onLiteralValue),K=f(s.onSeparator),U=b(s.onComment),L=f(s.onError),z=u&&u.disallowComments,C=u&&u.allowTrailingComma;function P(){for(;;){const te=d.scan();switch(d.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:z||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(te){case 12:case 13:z?Y(10):U();break;case 16:Y(1);break;case 15:case 14:break;default:return te}}}function Y(te,Se=[],oe=[]){if(L(te),Se.length+oe.length>0){let X=d.getToken();for(;X!==17;){if(Se.indexOf(X)!==-1){P();break}else if(oe.indexOf(X)!==-1)break;X=P()}}}function ae(te){const Se=d.getTokenValue();return te?O(Se):F(Se),P(),!0}function ge(){switch(d.getToken()){case 11:{let te=0;try{te=JSON.parse(d.getTokenValue()),typeof te!="number"&&(Y(2),te=0)}catch{Y(2)}O(te);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return P(),!0}function ve(){return d.getToken()!==10?(Y(3,[],[2,5]),!1):(ae(!1),d.getToken()===6?(K(":"),P(),he()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function De(){D(),P();let te=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(te||Y(4,[],[]),K(","),P(),d.getToken()===2&&C)break}else te&&Y(6,[],[]);ve()||Y(4,[],[2,5]),te=!0}return p(),d.getToken()!==2?Y(7,[2],[]):P(),!0}function de(){y(),P();let te=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(te||Y(4,[],[]),K(","),P(),d.getToken()===4&&C)break}else te&&Y(6,[],[]);he()||Y(4,[],[4,5]),te=!0}return k(),d.getToken()!==4?Y(8,[4],[]):P(),!0}function he(){switch(d.getToken()){case 3:return de();case 1:return De();case 10:return ae(!0);default:return ge()}}return P(),d.getToken()===17?u.allowEmptyContent?!0:(Y(4,[],[]),!1):he()?(d.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$en=a;function c(i,s){const u=A(i),d=[];let b,f=0,D;do switch(D=u.getPosition(),b=u.scan(),b){case 12:case 13:case 17:f!==D&&d.push(i.substring(f,D)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(b!==17);return d.join("")}e.$fn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$gn=h}),function(me,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Ce,ce){for(var ie=0;ie<ce.length;ie++){var Q=ce[ie];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ce,Q.key,Q)}}function E(Ce,ce,ie){return ce&&e(Ce.prototype,ce),ie&&e(Ce,ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,ce){if(Ce){if(typeof Ce=="string")return I(Ce,ce);var ie=Object.prototype.toString.call(Ce).slice(8,-1);if(ie==="Object"&&Ce.constructor&&(ie=Ce.constructor.name),ie==="Map"||ie==="Set")return Array.from(Ce);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return I(Ce,ce)}}function I(Ce,ce){(ce==null||ce>Ce.length)&&(ce=Ce.length);for(var ie=0,Q=new Array(ce);ie<ce;ie++)Q[ie]=Ce[ie];return Q}function M(Ce,ce){var ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ie)return(ie=ie.call(Ce)).next.bind(ie);if(Array.isArray(Ce)||(ie=T(Ce))||ce&&Ce&&typeof Ce.length=="number"){ie&&(Ce=ie);var Q=0;return function(){return Q>=Ce.length?{done:!0}:{done:!1,value:Ce[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function m(Ce){me.defaults=Ce}var g=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(ce){return l[ce]};function v(Ce,ce){if(ce){if(g.test(Ce))return Ce.replace(w,$)}else if(R.test(Ce))return Ce.replace(S,$);return Ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(n,function(ce,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function r(Ce,ce){Ce=typeof Ce=="string"?Ce:Ce.source,ce=ce||"";var ie={replace:function(ee,$e){return $e=$e.source||$e,$e=$e.replace(t,"$1"),Ce=Ce.replace(ee,$e),ie},getRegex:function(){return new RegExp(Ce,ce)}};return ie}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,ce,ie){if(Ce){var Q;try{Q=decodeURIComponent(o(ie)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ce&&!c.test(ie)&&(ie=b(ce,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Ce,ce){i[" "+Ce]||(s.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=p(Ce,"/",!0)),Ce=i[" "+Ce];var ie=Ce.indexOf(":")===-1;return ce.substring(0,2)==="//"?ie?ce:Ce.replace(u,"$1")+ce:ce.charAt(0)==="/"?ie?ce:Ce.replace(d,"$1")+ce:Ce+ce}var f={exec:function(){}};function D(Ce){for(var ce=1,ie,Q;ce<arguments.length;ce++){ie=arguments[ce];for(Q in ie)Object.prototype.hasOwnProperty.call(ie,Q)&&(Ce[Q]=ie[Q])}return Ce}function F(Ce,ce){var ie=Ce.replace(/\|/g,function($e,be,Le){for(var le=!1,we=be;--we>=0&&Le[we]==="\\";)le=!le;return le?"|":" |"}),Q=ie.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ce)Q.splice(ce);else for(;Q.length<ce;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function p(Ce,ce,ie){var Q=Ce.length;if(Q===0)return"";for(var ee=0;ee<Q;){var $e=Ce.charAt(Q-ee-1);if($e===ce&&!ie)ee++;else if($e!==ce&&ie)ee++;else break}return Ce.slice(0,Q-ee)}function y(Ce,ce){if(Ce.indexOf(ce[1])===-1)return-1;for(var ie=Ce.length,Q=0,ee=0;ee<ie;ee++)if(Ce[ee]==="\\")ee++;else if(Ce[ee]===ce[0])Q++;else if(Ce[ee]===ce[1]&&(Q--,Q<0))return ee;return-1}function k(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(Ce,ce){if(ce<1)return"";for(var ie="";ce>1;)ce&1&&(ie+=Ce),ce>>=1,Ce+=Ce;return ie+Ce}function K(Ce,ce,ie,Q){var ee=ce.href,$e=ce.title?v(ce.title):null,be=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){Q.state.inLink=!0;var Le={type:"link",raw:ie,href:ee,title:$e,text:be,tokens:Q.inlineTokens(be)};return Q.state.inLink=!1,Le}return{type:"image",raw:ie,href:ee,title:$e,text:v(be)}}function U(Ce,ce){var ie=Ce.match(/^(\s+)(?:```)/);if(ie===null)return ce;var Q=ie[1];return ce.split(`
`).map(function(ee){var $e=ee.match(/^\s+/);if($e===null)return ee;var be=$e[0];return be.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var L=function(){function Ce(ie){this.options=ie||me.defaults}var ce=Ce.prototype;return ce.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var $e=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:p($e,`
`)}}},ce.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var $e=ee[0],be=U($e,ee[3]||"");return{type:"code",raw:$e,lang:ee[2]?ee[2].trim():ee[2],text:be}}},ce.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var $e=ee[2].trim();if(/#$/.test($e)){var be=p($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:$e,tokens:this.lexer.inline($e)}}},ce.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var $e=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ce.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var $e,be,Le,le,we,N,q,H,B,J,_,ye,Te=ee[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ye=!1,!(!(ee=Ye.exec(Q))||this.rules.block.hr.test(Q)));){if($e=ee[0],Q=Q.substring($e.length),H=ee[2].split(`
`,1)[0],B=Q.split(`
`,1)[0],this.options.pedantic?(le=2,_=H.trimLeft()):(le=ee[2].search(/[^ ]/),le=le>4?1:le,_=H.slice(le),le+=ee[1].length),N=!1,!H&&/^ *$/.test(B)&&($e+=B+`
`,Q=Q.substring(B.length+1),ye=!0),!ye)for(var rt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(J=Q.split(`
`,1)[0],H=J,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(H)||ot.test(H)||rt.test(H)||it.test(Q)));){if(H.search(/[^ ]/)>=le||!H.trim())_+=`
`+H.slice(le);else if(!N)_+=`
`+H;else break;!N&&!H.trim()&&(N=!0),$e+=J+`
`,Q=Q.substring(J.length+1)}He.loose||(q?He.loose=!0:/\n *\n *$/.test($e)&&(q=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(_),be&&(Le=be[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:$e,task:!!be,checked:Le,loose:!1,text:_}),He.raw+=$e}He.items[He.items.length-1].raw=$e.trimRight(),He.items[He.items.length-1].text=_.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(we=0;we<at;we++){this.lexer.state.top=!1,He.items[we].tokens=this.lexer.blockTokens(He.items[we].text,[]);var ze=He.items[we].tokens.filter(function(Z){return Z.type==="space"}),pt=ze.every(function(Z){for(var x=Z.raw.split(""),pe=0,Ue=M(x),Qe;!(Qe=Ue()).done;){var tt=Qe.value;if(tt===`
`&&(pe+=1),pe>1)return!0}return!1});!He.loose&&ze.length&&pt&&(He.loose=!0,He.items[we].loose=!0)}return He}},ce.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var $e={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},ce.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var $e=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var $e={type:"table",header:F(ee[1]).map(function(q){return{text:q}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ee[0];var be=$e.align.length,Le,le,we,N;for(Le=0;Le<be;Le++)/^ *-+: *$/.test($e.align[Le])?$e.align[Le]="right":/^ *:-+: *$/.test($e.align[Le])?$e.align[Le]="center":/^ *:-+ *$/.test($e.align[Le])?$e.align[Le]="left":$e.align[Le]=null;for(be=$e.rows.length,Le=0;Le<be;Le++)$e.rows[Le]=F($e.rows[Le],$e.header.length).map(function(q){return{text:q}});for(be=$e.header.length,le=0;le<be;le++)$e.header[le].tokens=this.lexer.inline($e.header[le].text);for(be=$e.rows.length,le=0;le<be;le++)for(N=$e.rows[le],we=0;we<N.length;we++)N[we].tokens=this.lexer.inline(N[we].text);return $e}}},ce.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var $e=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:$e,tokens:this.lexer.inline($e)}}},ce.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:v(ee[1])}},ce.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):v(ee[0]):ee[0]}},ce.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var $e=ee[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=p($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Le=y(ee[2],"()");if(Le>-1){var le=ee[0].indexOf("!")===0?5:4,we=le+ee[1].length+Le;ee[2]=ee[2].substring(0,Le),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var N=ee[2],q="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(N);H&&(N=H[1],q=H[3])}else q=ee[3]?ee[3].slice(1,-1):"";return N=N.trim(),/^</.test(N)&&(this.options.pedantic&&!/>$/.test($e)?N=N.slice(1):N=N.slice(1,-1)),K(ee,{href:N&&N.replace(this.rules.inline._escapes,"$1"),title:q&&q.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(Q,ee){var $e;if(($e=this.rules.inline.reflink.exec(Q))||($e=this.rules.inline.nolink.exec(Q))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=ee[be.toLowerCase()],!be||!be.href){var Le=$e[0].charAt(0);return{type:"text",raw:Le,text:Le}}return K($e,be,$e[0],this.lexer)}},ce.emStrong=function(Q,ee,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(Q);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=be[1]||be[2]||"";if(!Le||Le&&($e===""||this.rules.inline.punctuation.exec($e))){var le=be[0].length-1,we,N,q=le,H=0,B=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,ee=ee.slice(-1*Q.length+le);(be=B.exec(ee))!=null;)if(we=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!we){if(N=we.length,be[3]||be[4]){q+=N;continue}else if((be[5]||be[6])&&le%3&&!((le+N)%3)){H+=N;continue}if(q-=N,!(q>0)){if(N=Math.min(N,N+q+H),Math.min(le,N)%2){var J=Q.slice(1,le+be.index+N);return{type:"em",raw:Q.slice(0,le+be.index+N+1),text:J,tokens:this.lexer.inlineTokens(J)}}var _=Q.slice(2,le+be.index+N-1);return{type:"strong",raw:Q.slice(0,le+be.index+N+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},ce.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var $e=ee[2].replace(/\n/g," "),be=/[^ ]/.test($e),Le=/^ /.test($e)&&/ $/.test($e);return be&&Le&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:ee[0],text:$e}}},ce.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(Q,ee){var $e=this.rules.inline.autolink.exec(Q);if($e){var be,Le;return $e[2]==="@"?(be=v(this.options.mangle?ee($e[1]):$e[1]),Le="mailto:"+be):(be=v($e[1]),Le=be),{type:"link",raw:$e[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(Q,ee){var $e;if($e=this.rules.inline.url.exec(Q)){var be,Le;if($e[2]==="@")be=v(this.options.mangle?ee($e[0]):$e[0]),Le="mailto:"+be;else{var le;do le=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(le!==$e[0]);be=v($e[0]),$e[1]==="www."?Le="http://"+be:Le=be}return{type:"link",raw:$e[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(Q,ee){var $e=this.rules.inline.text.exec(Q);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:be=v(this.options.smartypants?ee($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},Ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=r(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=r(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=r(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=r(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=r(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=r(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=D({},z),z.gfm=D({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=r(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=r(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=D({},z.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:r(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=r(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=r(z._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=r(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=r(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=r(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=r(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=r(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=r(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=r(C.reflink).replace("label",C._label).replace("ref",z._label).getRegex(),C.nolink=r(C.nolink).replace("ref",z._label).getRegex(),C.reflinkSearch=r(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=D({},C),C.pedantic=D({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=D({},C.normal,{escape:r(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=r(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=D({},C.gfm,{br:r(C.br).replace("{2,}","*").getRegex(),text:r(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function P(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(Ce){var ce="",ie,Q,ee=Ce.length;for(ie=0;ie<ee;ie++)Q=Ce.charCodeAt(ie),Math.random()>.5&&(Q="x"+Q.toString(16)),ce+="&#"+Q+";";return ce}var ae=function(){function Ce(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:z.normal,inline:C.normal};this.options.pedantic?(Q.block=z.pedantic,Q.inline=C.pedantic):this.options.gfm&&(Q.block=z.gfm,this.options.breaks?Q.inline=C.breaks:Q.inline=C.gfm),this.tokenizer.rules=Q}Ce.lex=function(Q,ee){var $e=new Ce(ee);return $e.lex(Q)},Ce.lexInline=function(Q,ee){var $e=new Ce(ee);return $e.inlineTokens(Q)};var ce=Ce.prototype;return ce.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(q,H,B){return H+"    ".repeat(B.length)});for(var be,Le,le,we;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(q){return(be=q.call({lexer:$e},Q,ee))?(Q=Q.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.space(Q)){Q=Q.substring(be.raw.length),be.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(be);continue}if(be=this.tokenizer.code(Q)){Q=Q.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(be=this.tokenizer.fences(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.heading(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.hr(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.blockquote(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.list(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.html(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.def(Q)){Q=Q.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.lheading(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var q=1/0,H=Q.slice(1),B=void 0;$e.options.extensions.startBlock.forEach(function(J){B=J.call({lexer:this},H),typeof B=="number"&&B>=0&&(q=Math.min(q,B))}),q<1/0&&q>=0&&(le=Q.substring(0,q+1))}(),this.state.top&&(be=this.tokenizer.paragraph(le))){Le=ee[ee.length-1],we&&Le.type==="paragraph"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be),we=le.length!==Q.length,Q=Q.substring(be.raw.length);continue}if(be=this.tokenizer.text(Q)){Q=Q.substring(be.raw.length),Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(Q){var N="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(N);break}else throw new Error(N)}}return this.state.top=!0,ee},ce.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ce.inlineTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]);var be,Le,le,we=Q,N,q,H;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(N=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)B.includes(N[0].slice(N[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,N.index)+"["+O("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(N=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,N.index)+"["+O("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(N=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,N.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(q||(H=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(be=_.call({lexer:$e},Q,ee))?(Q=Q.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.escape(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.tag(Q)){Q=Q.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.link(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.emStrong(Q,we,H)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.codespan(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.br(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.del(Q)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.autolink(Q,Y)){Q=Q.substring(be.raw.length),ee.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Q,Y))){Q=Q.substring(be.raw.length),ee.push(be);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,ye=Q.slice(1),Te=void 0;$e.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},ye),typeof Te=="number"&&Te>=0&&(_=Math.min(_,Te))}),_<1/0&&_>=0&&(le=Q.substring(0,_+1))}(),be=this.tokenizer.inlineText(le,P)){Q=Q.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(H=be.raw.slice(-1)),q=!0,Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(Q){var J="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ee},E(Ce,null,[{key:"rules",get:function(){return{block:z,inline:C}}}]),Ce}(),ge=function(){function Ce(ie){this.options=ie||me.defaults}var ce=Ce.prototype;return ce.code=function(Q,ee,$e){var be=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(Q,be);Le!=null&&Le!==Q&&($e=!0,Q=Le)}return Q=Q.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+v(be,!0)+'">'+($e?Q:v(Q,!0))+`</code></pre>
`:"<pre><code>"+($e?Q:v(Q,!0))+`</code></pre>
`},ce.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ce.html=function(Q){return Q},ce.heading=function(Q,ee,$e,be){if(this.options.headerIds){var Le=this.options.headerPrefix+be.slug($e);return"<h"+ee+' id="'+Le+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Q,ee,$e){var be=ee?"ol":"ul",Le=ee&&$e!==1?' start="'+$e+'"':"";return"<"+be+Le+`>
`+Q+"</"+be+`>
`},ce.listitem=function(Q){return"<li>"+Q+`</li>
`},ce.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Q){return"<p>"+Q+`</p>
`},ce.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ce.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ce.tablecell=function(Q,ee){var $e=ee.header?"th":"td",be=ee.align?"<"+$e+' align="'+ee.align+'">':"<"+$e+">";return be+Q+("</"+$e+`>
`)},ce.strong=function(Q){return"<strong>"+Q+"</strong>"},ce.em=function(Q){return"<em>"+Q+"</em>"},ce.codespan=function(Q){return"<code>"+Q+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Q){return"<del>"+Q+"</del>"},ce.link=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var be='<a href="'+v(Q)+'"';return ee&&(be+=' title="'+ee+'"'),be+=">"+$e+"</a>",be},ce.image=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var be='<img src="'+Q+'" alt="'+$e+'"';return ee&&(be+=' title="'+ee+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(Q){return Q},Ce}(),ve=function(){function Ce(){}var ce=Ce.prototype;return ce.strong=function(Q){return Q},ce.em=function(Q){return Q},ce.codespan=function(Q){return Q},ce.del=function(Q){return Q},ce.html=function(Q){return Q},ce.text=function(Q){return Q},ce.link=function(Q,ee,$e){return""+$e},ce.image=function(Q,ee,$e){return""+$e},ce.br=function(){return""},Ce}(),De=function(){function Ce(){this.seen={}}var ce=Ce.prototype;return ce.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Q,ee){var $e=Q,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[Q];do be++,$e=Q+"-"+be;while(this.seen.hasOwnProperty($e))}return ee||(this.seen[Q]=be,this.seen[$e]=0),$e},ce.slug=function(Q,ee){ee===void 0&&(ee={});var $e=this.serialize(Q);return this.getNextSafeSlug($e,ee.dryrun)},Ce}(),de=function(){function Ce(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new De}Ce.parse=function(Q,ee){var $e=new Ce(ee);return $e.parse(Q)},Ce.parseInline=function(Q,ee){var $e=new Ce(ee);return $e.parseInline(Q)};var ce=Ce.prototype;return ce.parse=function(Q,ee){ee===void 0&&(ee=!0);var $e="",be,Le,le,we,N,q,H,B,J,_,ye,Te,We,He,Ye,rt,it,et,ot,at=Q.length;for(be=0;be<at;be++){if(_=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(ot=this.options.extensions.renderers[_.type].call({parser:this},_),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){$e+=ot||"";continue}switch(_.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(_.tokens),_.depth,o(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(B="",H="",we=_.header.length,Le=0;Le<we;Le++)H+=this.renderer.tablecell(this.parseInline(_.header[Le].tokens),{header:!0,align:_.align[Le]});for(B+=this.renderer.tablerow(H),J="",we=_.rows.length,Le=0;Le<we;Le++){for(q=_.rows[Le],H="",N=q.length,le=0;le<N;le++)H+=this.renderer.tablecell(this.parseInline(q[le].tokens),{header:!1,align:_.align[le]});J+=this.renderer.tablerow(H)}$e+=this.renderer.table(B,J);continue}case"blockquote":{J=this.parse(_.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(ye=_.ordered,Te=_.start,We=_.loose,we=_.items.length,J="",Le=0;Le<we;Le++)Ye=_.items[Le],rt=Ye.checked,it=Ye.task,He="",Ye.task&&(et=this.renderer.checkbox(rt),We?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=et+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=et+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:et}):He+=et),He+=this.parse(Ye.tokens,We),J+=this.renderer.listitem(He,it,rt);$e+=this.renderer.list(J,ye,Te);continue}case"html":{$e+=this.renderer.html(_.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(J=_.tokens?this.parseInline(_.tokens):_.text;be+1<at&&Q[be+1].type==="text";)_=Q[++be],J+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);$e+=ee?this.renderer.paragraph(J):J;continue}default:{var ze='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return $e},ce.parseInline=function(Q,ee){ee=ee||this.renderer;var $e="",be,Le,le,we=Q.length;for(be=0;be<we;be++){if(Le=Q[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(le=this.options.extensions.renderers[Le.type].call({parser:this},Le),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){$e+=le||"";continue}switch(Le.type){case"escape":{$e+=ee.text(Le.text);break}case"html":{$e+=ee.html(Le.text);break}case"link":{$e+=ee.link(Le.href,Le.title,this.parseInline(Le.tokens,ee));break}case"image":{$e+=ee.image(Le.href,Le.title,Le.text);break}case"strong":{$e+=ee.strong(this.parseInline(Le.tokens,ee));break}case"em":{$e+=ee.em(this.parseInline(Le.tokens,ee));break}case"codespan":{$e+=ee.codespan(Le.text);break}case"br":{$e+=ee.br();break}case"del":{$e+=ee.del(this.parseInline(Le.tokens,ee));break}case"text":{$e+=ee.text(Le.text);break}default:{var N='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(N);return}else throw new Error(N)}}}return $e},Ce}();function he(Ce,ce,ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof ce=="function"&&(ie=ce,ce=null),ce=D({},he.defaults,ce||{}),k(ce),ie){var Q=ce.highlight,ee;try{ee=ae.lex(Ce,ce)}catch(we){return ie(we)}var $e=function(N){var q;if(!N)try{ce.walkTokens&&he.walkTokens(ee,ce.walkTokens),q=de.parse(ee,ce)}catch(H){N=H}return ce.highlight=Q,N?ie(N):ie(null,q)};if(!Q||Q.length<3||(delete ce.highlight,!ee.length))return $e();var be=0;he.walkTokens(ee,function(we){we.type==="code"&&(be++,setTimeout(function(){Q(we.text,we.lang,function(N,q){if(N)return $e(N);q!=null&&q!==we.text&&(we.text=q,we.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Le(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(we.message+"",!0)+"</pre>";throw we}try{var le=ae.lex(Ce,ce);if(ce.walkTokens){if(ce.async)return Promise.all(he.walkTokens(le,ce.walkTokens)).then(function(){return de.parse(le,ce)}).catch(Le);he.walkTokens(le,ce.walkTokens)}return de.parse(le,ce)}catch(we){Le(we)}}he.options=he.setOptions=function(Ce){return D(he.defaults,Ce),m(he.defaults),he},he.getDefaults=A,he.defaults=me.defaults,he.use=function(){for(var Ce=arguments.length,ce=new Array(Ce),ie=0;ie<Ce;ie++)ce[ie]=arguments[ie];var Q=D.apply(void 0,[{}].concat(ce)),ee=he.defaults.extensions||{renderers:{},childTokens:{}},$e;ce.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var we=ee.renderers?ee.renderers[le.name]:null;we?ee.renderers[le.name]=function(){for(var N=arguments.length,q=new Array(N),H=0;H<N;H++)q[H]=arguments[H];var B=le.renderer.apply(this,q);return B===!1&&(B=we.apply(this,q)),B}:ee.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[le.level]?ee[le.level].unshift(le.tokenizer):ee[le.level]=[le.tokenizer],le.start&&(le.level==="block"?ee.startBlock?ee.startBlock.push(le.start):ee.startBlock=[le.start]:le.level==="inline"&&(ee.startInline?ee.startInline.push(le.start):ee.startInline=[le.start]))}le.childTokens&&(ee.childTokens[le.name]=le.childTokens)})),be.renderer&&function(){var le=he.defaults.renderer||new ge,we=function(H){var B=le[H];le[H]=function(){for(var J=arguments.length,_=new Array(J),ye=0;ye<J;ye++)_[ye]=arguments[ye];var Te=be.renderer[H].apply(le,_);return Te===!1&&(Te=B.apply(le,_)),Te}};for(var N in be.renderer)we(N);Q.renderer=le}(),be.tokenizer&&function(){var le=he.defaults.tokenizer||new L,we=function(H){var B=le[H];le[H]=function(){for(var J=arguments.length,_=new Array(J),ye=0;ye<J;ye++)_[ye]=arguments[ye];var Te=be.tokenizer[H].apply(le,_);return Te===!1&&(Te=B.apply(le,_)),Te}};for(var N in be.tokenizer)we(N);Q.tokenizer=le}(),be.walkTokens){var Le=he.defaults.walkTokens;Q.walkTokens=function(le){var we=[];return we.push(be.walkTokens.call(this,le)),Le&&(we=we.concat(Le.call(this,le))),we}}$e&&(Q.extensions=ee),he.setOptions(Q)})},he.walkTokens=function(Ce,ce){for(var ie=[],Q=function(){var Le=$e.value;switch(ie=ie.concat(ce.call(he,Le)),Le.type){case"table":{for(var le=M(Le.header),we;!(we=le()).done;){var N=we.value;ie=ie.concat(he.walkTokens(N.tokens,ce))}for(var q=M(Le.rows),H;!(H=q()).done;)for(var B=H.value,J=M(B),_;!(_=J()).done;){var ye=_.value;ie=ie.concat(he.walkTokens(ye.tokens,ce))}break}case"list":{ie=ie.concat(he.walkTokens(Le.items,ce));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[Le.type]?he.defaults.extensions.childTokens[Le.type].forEach(function(Te){ie=ie.concat(he.walkTokens(Le[Te],ce))}):Le.tokens&&(ie=ie.concat(he.walkTokens(Le.tokens,ce)))}},ee=M(Ce),$e;!($e=ee()).done;)Q();return ie},he.parseInline=function(Ce,ce){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");ce=D({},he.defaults,ce||{}),k(ce);try{var ie=ae.lexInline(Ce,ce);return ce.walkTokens&&he.walkTokens(ie,ce.walkTokens),de.parseInline(ie,ce)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Q.message+"",!0)+"</pre>";throw Q}},he.Parser=de,he.parser=de.parse,he.Renderer=ge,he.TextRenderer=ve,he.Lexer=ae,he.lexer=ae.lex,he.Tokenizer=L,he.Slugger=De,he.parse=he;var te=he.options,Se=he.setOptions,oe=he.use,X=he.walkTokens,V=he.parseInline,ne=he,Ie=de.parse,Me=ae.lex;me.Lexer=ae,me.Parser=de,me.Renderer=ge,me.Slugger=De,me.TextRenderer=ve,me.Tokenizer=L,me.getDefaults=A,me.lexer=Me,me.marked=he,me.options=te,me.parse=ne,me.parseInline=V,me.parser=Ie,me.setOptions=Se,me.use=oe,me.walkTokens=X,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function E(n){const o=M(n);if(o&&o.length>0)return new Uint32Array(o)}e.$Nj=E;let T=0;const I=new Uint32Array(10);function M(n){if(T=0,A(n,S,4352),T>0||(A(n,l,4449),T>0)||(A(n,$,4520),T>0)||(A(n,v,12593),T))return I.subarray(0,T);if(n>=44032&&n<=55203){const o=n-44032,t=o%588,r=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(r<S.length?A(r,S,0):4352+r-12593<v.length&&A(4352+r,v,12593),a<l.length?A(a,l,0):4449+a-12593<v.length&&A(4449+a-12593,v,12593),c>=0&&(c<$.length?A(c,$,0):4520+c-12593<v.length&&A(4520+c-12593,v,12593)),T>0)return I.subarray(0,T)}}function A(n,o,t){n>=t&&n<t+o.length&&m(o[n-t])}function m(n){n!==0&&(I[T++]=n&255,n>>8&&(I[T++]=n>>8&255),n>>16&&(I[T++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(w||(w={}));var R;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(R||(R={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.rot=e.$2l=void 0;function E(m,g,w){return Math.min(Math.max(m,g),w)}e.$2l=E;function T(m,g){return(g+m%g)%g}e.rot=T;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$4l=I;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$5l=M;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$6l=A}),function(){function me(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function A(g){M.push(g,Date.now())}function m(){const g=[];for(let w=0;w<M.length;w+=2)g.push({name:M[w],startTime:M[w+1]});return g}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(I+A.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:me)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function E(T){if(e[T])return e[T].exports;var I=e[T]={i:T,l:!1,exports:{}};return me[T].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=me,E.c=e,E.d=function(T,I,M){E.o(T,I)||Object.defineProperty(T,I,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,I){if(1&I&&(T=E(T)),8&I||4&I&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&I&&typeof T!="string")for(var A in T)E.d(M,A,function(m){return T[m]}.bind(null,A));return M},E.n=function(T){var I=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(I,"a",I),I},E.o=function(T,I){return Object.prototype.hasOwnProperty.call(T,I)},E.p="",E(E.s=0)}([function(me,e,E){(function(T){var I;e=me.exports=oe,I=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],w=0,R=w++;g[R]="0|[1-9]\\d*";var S=w++;g[S]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;g[$]="("+g[R]+")\\.("+g[R]+")\\.("+g[R]+")";var v=w++;g[v]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var n=w++;g[n]="(?:"+g[R]+"|"+g[l]+")";var o=w++;g[o]="(?:"+g[S]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[n]+"(?:\\."+g[n]+")*))";var r=w++;g[r]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=w++;g[a]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=w++,i="v?"+g[$]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[v]+g[r]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var b=w++;g[b]=g[S]+"|x|X|\\*";var f=w++;g[f]=g[R]+"|x|X|\\*";var D=w++;g[D]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var F=w++;g[F]="[v=\\s]*("+g[b]+")(?:\\.("+g[b]+")(?:\\.("+g[b]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var p=w++;g[p]="^"+g[d]+"\\s*"+g[D]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[F]+"$";var k=w++;g[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;g[O]="(?:~>?)";var K=w++;g[K]="(\\s*)"+g[O]+"\\s+",m[K]=new RegExp(g[K],"g");var U=w++;g[U]="^"+g[O]+g[D]+"$";var L=w++;g[L]="^"+g[O]+g[F]+"$";var z=w++;g[z]="(?:\\^)";var C=w++;g[C]="(\\s*)"+g[z]+"\\s+",m[C]=new RegExp(g[C],"g");var P=w++;g[P]="^"+g[z]+g[D]+"$";var Y=w++;g[Y]="^"+g[z]+g[F]+"$";var ae=w++;g[ae]="^"+g[d]+"\\s*("+s+")$|^$";var ge=w++;g[ge]="^"+g[d]+"\\s*("+i+")$|^$";var ve=w++;g[ve]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[D]+")",m[ve]=new RegExp(g[ve],"g");var De=w++;g[De]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var de=w++;g[de]="^\\s*("+g[F]+")\\s+-\\s+("+g[F]+")\\s*$";var he=w++;g[he]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,g[te]),m[te]||(m[te]=new RegExp(g[te]));function Se(B,J){if(B instanceof oe)return B;if(typeof B!="string"||B.length>M||!(J?m[u]:m[h]).test(B))return null;try{return new oe(B,J)}catch{return null}}function oe(B,J){if(B instanceof oe){if(B.loose===J)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(B,J);I("SemVer",B,J),this.loose=J;var _=B.trim().match(J?m[u]:m[h]);if(!_)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Te=+ye;if(Te>=0&&Te<A)return Te}return ye}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=Se,e.valid=function(B,J){var _=Se(B,J);return _?_.version:null},e.clean=function(B,J){var _=Se(B.trim().replace(/^[=v]+/,""),J);return _?_.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(B){return I("SemVer.compare",this.version,this.loose,B),B instanceof oe||(B=new oe(B,this.loose)),this.compareMain(B)||this.comparePre(B)},oe.prototype.compareMain=function(B){return B instanceof oe||(B=new oe(B,this.loose)),V(this.major,B.major)||V(this.minor,B.minor)||V(this.patch,B.patch)},oe.prototype.comparePre=function(B){if(B instanceof oe||(B=new oe(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var J=0;do{var _=this.prerelease[J],ye=B.prerelease[J];if(I("prerelease compare",J,_,ye),_===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(_===void 0)return-1;if(_!==ye)return V(_,ye)}while(++J)},oe.prototype.inc=function(B,J){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,J,_,ye){typeof _=="string"&&(ye=_,_=void 0);try{return new oe(B,_).inc(J,ye).version}catch{return null}},e.diff=function(B,J){if(Ce(B,J))return null;var _=Se(B),ye=Se(J);if(_.prerelease.length||ye.prerelease.length){for(var Te in _)if((Te==="major"||Te==="minor"||Te==="patch")&&_[Te]!==ye[Te])return"pre"+Te;return"prerelease"}for(var Te in _)if((Te==="major"||Te==="minor"||Te==="patch")&&_[Te]!==ye[Te])return Te},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(B,J){var _=X.test(B),ye=X.test(J);return _&&ye&&(B=+B,J=+J),_&&!ye?-1:ye&&!_?1:B<J?-1:B>J?1:0}function ne(B,J,_){return new oe(B,_).compare(new oe(J,_))}function Ie(B,J,_){return ne(B,J,_)>0}function Me(B,J,_){return ne(B,J,_)<0}function Ce(B,J,_){return ne(B,J,_)===0}function ce(B,J,_){return ne(B,J,_)!==0}function ie(B,J,_){return ne(B,J,_)>=0}function Q(B,J,_){return ne(B,J,_)<=0}function ee(B,J,_,ye){var Te;switch(J){case"===":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Te=B===_;break;case"!==":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Te=B!==_;break;case"":case"=":case"==":Te=Ce(B,_,ye);break;case"!=":Te=ce(B,_,ye);break;case">":Te=Ie(B,_,ye);break;case">=":Te=ie(B,_,ye);break;case"<":Te=Me(B,_,ye);break;case"<=":Te=Q(B,_,ye);break;default:throw new TypeError("Invalid operator: "+J)}return Te}function $e(B,J){if(B instanceof $e){if(B.loose===J)return B;B=B.value}if(!(this instanceof $e))return new $e(B,J);I("comparator",B,J),this.loose=J,this.parse(B),this.semver===be?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(B,J){return V(J,B)},e.major=function(B,J){return new oe(B,J).major},e.minor=function(B,J){return new oe(B,J).minor},e.patch=function(B,J){return new oe(B,J).patch},e.compare=ne,e.compareLoose=function(B,J){return ne(B,J,!0)},e.rcompare=function(B,J,_){return ne(J,B,_)},e.sort=function(B,J){return B.sort(function(_,ye){return e.compare(_,ye,J)})},e.rsort=function(B,J){return B.sort(function(_,ye){return e.rcompare(_,ye,J)})},e.gt=Ie,e.lt=Me,e.eq=Ce,e.neq=ce,e.gte=ie,e.lte=Q,e.cmp=ee,e.Comparator=$e;var be={};function Le(B,J){if(B instanceof Le)return B.loose===J?B:new Le(B.raw,J);if(B instanceof $e)return new Le(B.value,J);if(!(this instanceof Le))return new Le(B,J);if(this.loose=J,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function le(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,J,_,ye,Te,We,He,Ye,rt,it,et,ot,at){return((J=le(_)?"":le(ye)?">="+_+".0.0":le(Te)?">="+_+"."+ye+".0":">="+J)+" "+(Ye=le(rt)?"":le(it)?"<"+(+rt+1)+".0.0":le(et)?"<"+rt+"."+(+it+1)+".0":ot?"<="+rt+"."+it+"."+et+"-"+ot:"<="+Ye)).trim()}function N(B,J){for(var _=0;_<B.length;_++)if(!B[_].test(J))return!1;if(J.prerelease.length){for(_=0;_<B.length;_++)if(I(B[_].semver),B[_].semver!==be&&B[_].semver.prerelease.length>0){var ye=B[_].semver;if(ye.major===J.major&&ye.minor===J.minor&&ye.patch===J.patch)return!0}return!1}return!0}function q(B,J,_){try{J=new Le(J,_)}catch{return!1}return J.test(B)}function H(B,J,_,ye){var Te,We,He,Ye,rt;switch(B=new oe(B,ye),J=new Le(J,ye),_){case">":Te=Ie,We=Q,He=Me,Ye=">",rt=">=";break;case"<":Te=Me,We=ie,He=Ie,Ye="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(q(B,J,ye))return!1;for(var it=0;it<J.set.length;++it){var et=J.set[it],ot=null,at=null;if(et.forEach(function(ze){ze.semver===be&&(ze=new $e(">=0.0.0")),ot=ot||ze,at=at||ze,Te(ze.semver,ot.semver,ye)?ot=ze:He(ze.semver,at.semver,ye)&&(at=ze)}),ot.operator===Ye||ot.operator===rt||(!at.operator||at.operator===Ye)&&We(B,at.semver)||at.operator===rt&&He(B,at.semver))return!1}return!0}$e.prototype.parse=function(B){var J=this.loose?m[ae]:m[ge],_=B.match(J);if(!_)throw new TypeError("Invalid comparator: "+B);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new oe(_[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(B){return I("Comparator.test",B,this.loose),this.semver===be||(typeof B=="string"&&(B=new oe(B,this.loose)),ee(B,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(B,J){if(!(B instanceof $e))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Le(B.value,J),q(this.value,_,J);if(B.operator==="")return _=new Le(this.value,J),q(B.semver,_,J);var ye=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),We=this.semver.version===B.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ye=ee(this.semver,"<",B.semver,J)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),rt=ee(this.semver,">",B.semver,J)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ye||Te||We&&He||Ye||rt},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(B){var J=this.loose;B=B.trim(),I("range",B,J);var _=J?m[de]:m[De];B=B.replace(_,we),I("hyphen replace",B),B=B.replace(m[ve],"$1$2$3"),I("comparator trim",B,m[ve]),B=(B=(B=B.replace(m[K],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ye=J?m[ae]:m[ge],Te=B.split(" ").map(function(We){return function(He,Ye){return I("comp",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){I("caret",ot,at);var ze=at?m[Y]:m[P];return ot.replace(ze,function(pt,Z,x,pe,Ue){var Qe;return I("caret",ot,pt,Z,x,pe,Ue),le(Z)?Qe="":le(x)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le(pe)?Qe=Z==="0"?">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+".0 <"+(+Z+1)+".0.0":Ue?(I("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Qe=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+Ue+" <"+(+Z+1)+".0.0"):(I("no pr"),Qe=Z==="0"?x==="0"?">="+Z+"."+x+"."+pe+" <"+Z+"."+x+"."+(+pe+1):">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0":">="+Z+"."+x+"."+pe+" <"+(+Z+1)+".0.0"),I("caret return",Qe),Qe})}(et,it)}).join(" ")}(He,Ye),I("caret",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){var ze=at?m[L]:m[U];return ot.replace(ze,function(pt,Z,x,pe,Ue){var Qe;return I("tilde",ot,pt,Z,x,pe,Ue),le(Z)?Qe="":le(x)?Qe=">="+Z+".0.0 <"+(+Z+1)+".0.0":le(pe)?Qe=">="+Z+"."+x+".0 <"+Z+"."+(+x+1)+".0":Ue?(I("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Qe=">="+Z+"."+x+"."+pe+Ue+" <"+Z+"."+(+x+1)+".0"):Qe=">="+Z+"."+x+"."+pe+" <"+Z+"."+(+x+1)+".0",I("tilde return",Qe),Qe})}(et,it)}).join(" ")}(He,Ye),I("tildes",He),He=function(rt,it){return I("replaceXRanges",rt,it),rt.split(/\s+/).map(function(et){return function(ot,at){ot=ot.trim();var ze=at?m[y]:m[p];return ot.replace(ze,function(pt,Z,x,pe,Ue,Qe){I("xRange",ot,pt,Z,x,pe,Ue,Qe);var tt=le(x),nt=tt||le(pe),Ne=nt||le(Ue);return Z==="="&&Ne&&(Z=""),tt?pt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(nt&&(pe=0),Ne&&(Ue=0),Z===">"?(Z=">=",nt?(x=+x+1,pe=0,Ue=0):Ne&&(pe=+pe+1,Ue=0)):Z==="<="&&(Z="<",nt?x=+x+1:pe=+pe+1),pt=Z+x+"."+pe+"."+Ue):nt?pt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(pt=">="+x+"."+pe+".0 <"+x+"."+(+pe+1)+".0"),I("xRange return",pt),pt})}(et,it)}).join(" ")}(He,Ye),I("xrange",He),He=function(rt,it){return I("replaceStars",rt,it),rt.trim().replace(m[he],"")}(He,Ye),I("stars",He),He}(We,J)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(ye)})),Te=Te.map(function(We){return new $e(We,J)})},Le.prototype.intersects=function(B,J){if(!(B instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ye){return B.set.some(function(Te){return Te.every(function(We){return ye.intersects(We,J)})})})})},e.toComparators=function(B,J){return new Le(B,J).set.map(function(_){return _.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new oe(B,this.loose));for(var J=0;J<this.set.length;J++)if(N(this.set[J],B))return!0;return!1},e.satisfies=q,e.maxSatisfying=function(B,J,_){var ye=null,Te=null;try{var We=new Le(J,_)}catch{return null}return B.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==-1||(Te=new oe(ye=He,_)))}),ye},e.minSatisfying=function(B,J,_){var ye=null,Te=null;try{var We=new Le(J,_)}catch{return null}return B.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==1||(Te=new oe(ye=He,_)))}),ye},e.validRange=function(B,J){try{return new Le(B,J).range||"*"}catch{return null}},e.ltr=function(B,J,_){return H(B,J,"<",_)},e.gtr=function(B,J,_){return H(B,J,">",_)},e.outside=H,e.prerelease=function(B,J){var _=Se(B,J);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(B,J,_){return B=new Le(B,_),J=new Le(J,_),B.intersects(J)},e.coerce=function(B){if(B instanceof oe)return B;if(typeof B!="string")return null;var J=B.match(m[k]);return J==null?null:Se((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,E(1))},function(me,e){var E,T,I=me.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var g,w=[],R=!1,S=-1;function l(){R&&g&&(R=!1,g.length?w=g.concat(w):S=-1,w.length&&$())}function $(){if(!R){var o=m(l);R=!0;for(var t=w.length;t;){for(g=w,w=[];++S<t;)g&&g[S].run();S=-1,t=w.length}g=null,R=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(o)}}function v(o,t){this.fun=o,this.array=t}function n(){}I.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)t[r-1]=arguments[r];w.push(new v(o,t)),w.length!==1||R||m($)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=n,I.addListener=n,I.once=n,I.off=n,I.removeListener=n,I.removeAllListeners=n,I.emit=n,I.prependListener=n,I.prependOnceListener=n,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[123],Ae([1,0,11,6]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=I;function M(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=M;function A(c){const h=c;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=A;function m(c,h){return new g(c,h)}e.$7d=m;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$8d=w;function R(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=R;function S(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=S;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$$d=l;function $(c,h){return new Promise((i,s)=>{const u=new T.$Rc,d=[],b=F=>{if(d.push(F),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=F=>(u.dispose(),s(F)),D=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Qc)(()=>c.removeListener("end",D))),c.on("end",D),u.add((0,T.$Qc)(()=>c.removeListener("data",b))),c.on("data",b)})}e.$_d=$;function v(c,h){const i=m(h);return i.end(c),i}e.$ae=v;function n(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$be=n;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=o;function t(c,h,i){const s=m(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$de=t;function r(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ee=r;function a(c,h,i){let s=!1;const u=m(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$fe=a}),define(Pe[24],Ae([1,0,39,123]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",M=new E.$V(()=>new Uint8Array(256));let A,m;class g{static alloc(k){return I?new g(Buffer.allocUnsafe(k)):new g(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new g(k)}static fromString(k,O){return!(O?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(k)):(A||(A=new TextEncoder),new g(A.encode(k)))}static fromByteArray(k){const O=g.alloc(k.length);for(let K=0,U=k.length;K<U;K++)O.buffer[K]=k[K];return O}static concat(k,O){if(typeof O>"u"){O=0;for(let L=0,z=k.length;L<z;L++)O+=k[L].byteLength}const K=g.alloc(O);let U=0;for(let L=0,z=k.length;L<z;L++){const C=k[L];K.set(C,U),U+=C.byteLength}return K}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=g.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(k,O){return new g(this.buffer.subarray(k,O))}set(k,O){if(k instanceof g)this.buffer.set(k.buffer,O);else if(k instanceof Uint8Array)this.buffer.set(k,O);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),O);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,O){$(this.buffer,k,O)}readUInt32LE(k){return v(this.buffer,k)}writeUInt32LE(k,O){n(this.buffer,k,O)}readUInt8(k){return o(this.buffer,k)}writeUInt8(k,O){t(this.buffer,k,O)}indexOf(k,O=0){return w(this.buffer,k instanceof g?k.buffer:k,O)}}e.$ge=g;function w(y,k,O=0){const K=k.byteLength,U=y.byteLength;if(K===0)return 0;if(K===1)return y.indexOf(k[0]);if(K>U-O)return-1;const L=M.value;L.fill(k.length);for(let Y=0;Y<k.length;Y++)L[k[Y]]=k.length-Y-1;let z=O+k.length-1,C=z,P=-1;for(;z<U;)if(y[z]===k[C]){if(C===0){P=z;break}z--,C--}else z+=Math.max(k.length-C,L[y[z]]),C=k.length-1;return P}e.$he=w;function R(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0}e.$ie=R;function S(y,k,O){y[O+0]=k&255,k=k>>>8,y[O+1]=k&255}e.$je=S;function l(y,k){return y[k]*2**24+y[k+1]*2**16+y[k+2]*2**8+y[k+3]}e.$ke=l;function $(y,k,O){y[O+3]=k,k=k>>>8,y[O+2]=k,k=k>>>8,y[O+1]=k,k=k>>>8,y[O]=k}e.$le=$;function v(y,k){return y[k+0]<<0>>>0|y[k+1]<<8>>>0|y[k+2]<<16>>>0|y[k+3]<<24>>>0}e.$me=v;function n(y,k,O){y[O+0]=k&255,k=k>>>8,y[O+1]=k&255,k=k>>>8,y[O+2]=k&255,k=k>>>8,y[O+3]=k&255}e.$ne=n;function o(y,k){return y[k]}e.$oe=o;function t(y,k,O){y[O]=k}e.$pe=t;function r(y){return T.$8d(y,k=>g.concat(k))}e.$qe=r;function a(y){return T.$ce(y)}e.$re=a;function c(y){return T.$0d(y,k=>g.concat(k))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return T.$ae(y,k=>g.concat(k))}e.$ue=i;function s(y){return T.$de(y,{data:k=>typeof k=="string"?g.fromString(k):g.wrap(k)},k=>g.concat(k))}e.$ve=s;function u(y){return T.$7d(k=>g.concat(k),y)}e.$we=u;function d(y,k){return T.$ee(y,k,O=>g.concat(O))}e.$xe=d;function b(y,k){return T.$fe(y,k,O=>g.concat(O))}e.$ye=b;function f(y){let k=0,O=0,K=0;const U=new Uint8Array(Math.floor(y.length/4*3)),L=C=>{switch(O){case 3:U[K++]=k|C,O=0;break;case 2:U[K++]=k|C>>>2,k=C<<6,O=3;break;case 1:U[K++]=k|C>>>4,k=C<<4,O=2;break;default:k=C<<2,O=1}};for(let C=0;C<y.length;C++){const P=y.charCodeAt(C);if(P>=65&&P<=90)L(P-65);else if(P>=97&&P<=122)L(P-97+26);else if(P>=48&&P<=57)L(P-48+52);else if(P===43||P===45)L(62);else if(P===47||P===95)L(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const z=K;for(;O>0;)L(0);return g.wrap(U).slice(0,z)}e.$ze=f;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:y},k=!0,O=!1){const K=O?F:D;let U="";const L=y.byteLength%3;let z=0;for(;z<y.byteLength-L;z+=3){const C=y[z+0],P=y[z+1],Y=y[z+2];U+=K[C>>>2],U+=K[(C<<4|P>>>4)&63],U+=K[(P<<2|Y>>>6)&63],U+=K[Y&63]}if(L===1){const C=y[z+0];U+=K[C>>>2],U+=K[C<<4&63],k&&(U+="==")}else if(L===2){const C=y[z+0],P=y[z+1];U+=K[C>>>2],U+=K[(C<<4|P>>>4)&63],U+=K[P<<2&63],k&&(U+="=")}return U}e.$Ae=p}),define(Pe[124],Ae([1,0,28,121,12]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function M(...le){return function(we,N){for(let q=0,H=le.length;q<H;q++){const B=le[q](we,N);if(B)return B}return null}}e.or=M,e.$Pj=A.bind(void 0,!1),e.$Qj=A.bind(void 0,!0);function A(le,we,N){if(!N||N.length<we.length)return null;let q;return le?q=I.$9e(N,we):q=N.indexOf(we)===0,q?we.length>0?[{start:0,end:we.length}]:[]:null}function m(le,we){const N=we.toLowerCase().indexOf(le.toLowerCase());return N===-1?null:[{start:N,end:N+le.length}]}e.$Rj=m;function g(le,we){return w(le.toLowerCase(),we.toLowerCase(),0,0)}e.$Sj=g;function w(le,we,N,q){if(N===le.length)return[];if(q===we.length)return null;if(le[N]===we[q]){let H=null;return(H=w(le,we,N+1,q+1))?c({start:q,end:q+1},H):null}return w(le,we,N,q+1)}function R(le){return 97<=le&&le<=122}function S(le){return 65<=le&&le<=90}e.$Tj=S;function l(le){return 48<=le&&le<=57}function $(le){return le===32||le===9||le===10||le===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>v.add(le.charCodeAt(0)));function n(le){return $(le)||v.has(le)}function o(le,we){return le===we||n(le)&&n(we)}const t=new Map;function r(le){if(t.has(le))return t.get(le);let we;const N=(0,T.$Nj)(le);return N&&(we=N),t.set(le,we),we}function a(le){return R(le)||S(le)||l(le)}function c(le,we){return we.length===0?we=[le]:le.end===we[0].start?we[0].start=le.start:we.unshift(le),we}function h(le,we){for(let N=we;N<le.length;N++){const q=le.charCodeAt(N);if(S(q)||l(q)||N>0&&!a(le.charCodeAt(N-1)))return N}return le.length}function i(le,we,N,q){if(N===le.length)return[];if(q===we.length)return null;if(le[N]!==we[q].toLowerCase())return null;{let H=null,B=q+1;for(H=i(le,we,N+1,q+1);!H&&(B=h(we,B))<we.length;)H=i(le,we,N+1,B),B++;return H===null?null:c({start:q,end:q+1},H)}}function s(le){let we=0,N=0,q=0,H=0,B=0;for(let We=0;We<le.length;We++)B=le.charCodeAt(We),S(B)&&we++,R(B)&&N++,a(B)&&q++,l(B)&&H++;const J=we/le.length,_=N/le.length,ye=q/le.length,Te=H/le.length;return{upperPercent:J,lowerPercent:_,alphaPercent:ye,numericPercent:Te}}function u(le){const{upperPercent:we,lowerPercent:N}=le;return N===0&&we>.6}function d(le){const{upperPercent:we,lowerPercent:N,alphaPercent:q,numericPercent:H}=le;return N>.2&&we<.8&&q>.6&&H<.2}function b(le){let we=0,N=0,q=0,H=0;for(let B=0;B<le.length;B++)q=le.charCodeAt(B),S(q)&&we++,R(q)&&N++,$(q)&&H++;return(we===0||N===0)&&H===0?le.length<=30:we<=5}function f(le,we){if(!we||(we=we.trim(),we.length===0)||!b(le)||we.length>60)return null;const N=s(we);if(!d(N)){if(!u(N))return null;we=we.toLowerCase()}let q=null,H=0;for(le=le.toLowerCase();H<we.length&&(q=i(le,we,0,H))===null;)H=h(we,H+1);return q}e.$Uj=f;function D(le,we,N=!1){if(!we||we.length===0)return null;let q=null,H=0;for(le=le.toLowerCase(),we=we.toLowerCase();H<we.length&&(q=F(le,we,0,H,N),q===null);)H=p(we,H+1);return q}e.$Vj=D;function F(le,we,N,q,H){let B=0;if(N===le.length)return[];if(q===we.length)return null;if(!o(le.charCodeAt(N),we.charCodeAt(q))){const ye=r(le.charCodeAt(N));if(!ye)return null;for(let Te=0;Te<ye.length;Te++)if(!o(ye[Te],we.charCodeAt(q+Te)))return null;B+=ye.length-1}let J=null,_=q+B+1;if(J=F(le,we,N+1,_,H),!H)for(;!J&&(_=p(we,_))<we.length;)J=F(le,we,N+1,_,H),_++;if(!J)return null;if(le.charCodeAt(N)!==we.charCodeAt(q)){const ye=r(le.charCodeAt(N));if(!ye)return J;for(let Te=0;Te<ye.length;Te++)if(ye[Te]!==we.charCodeAt(q+Te))return J}return c({start:q,end:q+B+1},J)}function p(le,we){for(let N=we;N<le.length;N++)if(n(le.charCodeAt(N))||N>0&&n(le.charCodeAt(N-1)))return N;return le.length}const y=M(e.$Qj,f,m),k=M(e.$Qj,f,g),O=new E.$Dc(1e4);function K(le,we,N=!1){if(typeof le!="string"||typeof we!="string")return null;let q=O.get(le);q||(q=new RegExp(I.$Re(le),"i"),O.set(le,q));const H=q.exec(we);return H?[{start:H.index,end:H.index+H[0].length}]:N?k(le,we):y(le,we)}e.$Wj=K;function U(le,we){const N=ce(le,le.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?z(N):null}e.$Xj=U;function L(le,we,N,q,H,B){const J=Math.min(13,le.length);for(;N<J;N++){const _=ce(le,we,N,q,H,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return _}return[0,B]}e.$Yj=L;function z(le){if(typeof le>"u")return[];const we=[],N=le[1];for(let q=le.length-1;q>1;q--){const H=le[q]+N,B=we[we.length-1];B&&B.end===H?B.end=H+1:we.push({start:H,end:H+1})}return we}e.$Zj=z;const C=128;function P(){const le=[],we=[];for(let N=0;N<=C;N++)we[N]=0;for(let N=0;N<=C;N++)le.push(we.slice(0));return le}function Y(le){const we=[];for(let N=0;N<=le;N++)we[N]=0;return we}const ae=Y(2*C),ge=Y(2*C),ve=P(),De=P(),de=P(),he=!1;function te(le,we,N,q,H){function B(_,ye,Te=" "){for(;_.length<ye;)_=Te+_;return _}let J=` |   |${q.split("").map(_=>B(_,3)).join("|")}
`;for(let _=0;_<=N;_++)_===0?J+=" |":J+=`${we[_-1]}|`,J+=le[_].slice(0,H+1).map(ye=>B(ye.toString(),3)).join("|")+`
`;return J}function Se(le,we,N,q){le=le.substr(we),N=N.substr(q),console.log(te(De,le,le.length,N,N.length)),console.log(te(de,le,le.length,N,N.length)),console.log(te(ve,le,le.length,N,N.length))}function oe(le,we){if(we<0||we>=le.length)return!1;const N=le.codePointAt(we);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$of(N)}}function X(le,we){if(we<0||we>=le.length)return!1;switch(le.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function V(le,we,N){return we[le]!==N[le]}function ne(le,we,N,q,H,B,J=!1){for(;we<N&&H<B;)le[we]===q[H]&&(J&&(ae[we]=H),we+=1),H+=1;return we===N}e.$1j=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(le){le.Default=[-100,0];function we(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}le.isDefault=we})(Me||(e.FuzzyScore=Me={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,N){this.firstMatchCanBeWeak=we,this.boostFullMatch=N}}e.$2j=Ce;function ce(le,we,N,q,H,B,J=Ce.default){const _=le.length>C?C:le.length,ye=q.length>C?C:q.length;if(N>=_||B>=ye||_-N>ye-B||!ne(we,N,_,H,B,ye,!0))return;ie(_,ye,N,B,we,H);let Te=1,We=1,He=N,Ye=B;const rt=[!1];for(Te=1,He=N;He<_;Te++,He++){const ze=ae[He],pt=ge[He],Z=He+1<_?ge[He+1]:ye;for(We=ze-B+1,Ye=ze;Ye<Z;We++,Ye++){let x=Number.MIN_SAFE_INTEGER,pe=!1;Ye<=pt&&(x=Q(le,we,He,N,q,H,Ye,ye,B,ve[Te-1][We-1]===0,rt));let Ue=0;x!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ue=x+De[Te-1][We-1]);const Qe=Ye>ze,tt=Qe?De[Te][We-1]+(ve[Te][We-1]>0?-5:0):0,nt=Ye>ze+1&&ve[Te][We-1]>0,Ne=nt?De[Te][We-2]+(ve[Te][We-2]>0?-5:0):0;if(nt&&(!Qe||Ne>=tt)&&(!pe||Ne>=Ue))De[Te][We]=Ne,de[Te][We]=3,ve[Te][We]=0;else if(Qe&&(!pe||tt>=Ue))De[Te][We]=tt,de[Te][We]=2,ve[Te][We]=0;else if(pe)De[Te][We]=Ue,de[Te][We]=1,ve[Te][We]=ve[Te-1][We-1]+1;else throw new Error("not possible")}}if(he&&Se(le,N,q,B),!rt[0]&&!J.firstMatchCanBeWeak)return;Te--,We--;const it=[De[Te][We],B];let et=0,ot=0;for(;Te>=1;){let ze=We;do{const pt=de[Te][ze];if(pt===3)ze=ze-2;else if(pt===2)ze=ze-1;else break}while(ze>=1);et>1&&we[N+Te-1]===H[B+We-1]&&!V(ze+B-1,q,H)&&et+1>ve[Te][ze]&&(ze=We),ze===We?et++:et=1,ot||(ot=ze),Te--,We=ze-1,it.push(We)}ye===_&&J.boostFullMatch&&(it[0]+=2);const at=ot-_;return it[0]-=at,it}e.$3j=ce;function ie(le,we,N,q,H,B){let J=le-1,_=we-1;for(;J>=N&&_>=q;)H[J]===B[_]&&(ge[J]=_,J--),_--}function Q(le,we,N,q,H,B,J,_,ye,Te,We){if(we[N]!==B[J])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return J===N-q?He=le[N]===H[J]?7:5:V(J,H,B)&&(J===0||!V(J-1,H,B))?(He=le[N]===H[J]?7:5,Ye=!0):oe(B,J)&&(J===0||!oe(B,J-1))?He=5:(oe(B,J-1)||X(B,J-1))&&(He=5,Ye=!0),He>1&&N===q&&(We[0]=!0),Ye||(Ye=V(J,H,B)||oe(B,J-1)||X(B,J-1)),N===q?J>ye&&(He-=Ye?3:5):Te?He+=Ye?2:0:He+=Ye?0:1,J+1===_&&(He-=Ye?3:5),He}function ee(le,we,N,q,H,B,J){return be(le,we,N,q,H,B,!0,J)}e.$4j=ee;function $e(le,we,N,q,H,B,J){return be(le,we,N,q,H,B,!1,J)}e.$5j=$e;function be(le,we,N,q,H,B,J,_){let ye=ce(le,we,N,q,H,B,_);if(ye&&!J)return ye;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=N+1;We<Te;We++){const He=Le(le,We);if(He){const Ye=ce(He,He.toLowerCase(),N,q,H,B,_);Ye&&(Ye[0]-=3,(!ye||Ye[0]>ye[0])&&(ye=Ye))}}}return ye}function Le(le,we){if(we+1>=le.length)return;const N=le[we],q=le[we+1];if(N!==q)return le.slice(0,we)+q+N+le.slice(we+2)}}),define(Pe[31],Ae([1,0,12]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(T||(T={})),function(I){const M="error",A="warning",m="warn",g="info",w="ignore";function R(l){return l?E.$8e(M,l)?I.Error:E.$8e(A,l)||E.$8e(m,l)?I.Warning:E.$8e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function S(l){switch(l){case I.Error:return M;case I.Warning:return A;case I.Info:return g;default:return w}}I.toString=S}(T||(T={})),e.default=T}),define(Pe[125],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class I{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const v=$.charCodeAt(0),n=this.b.charCodeAt(this.c);return v-n}value(){return this.b[this.c]}}e.$4h=I;class M{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,T.$2e)($,this.b,0,$.length,this.c,this.d):(0,T.$4e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=M;class A{constructor($=!0,v=!0){this.f=$,this.g=v}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let v=$.length-1;v>=0;v--,this.c--){const n=this.b.charCodeAt(v);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,T.$2e)($,this.b,0,$.length,this.d,this.e):(0,T.$4e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=A;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor($,v){this.f=$,this.g=v,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,T.$3e)($,this.c.scheme);if(this.d[this.e]===2)return(0,T.$3e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,T.$1e)($,this.c.query);if(this.d[this.e]===5)return(0,T.$1e)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class S{static forUris($=()=>!1,v=()=>!1){return new S(new g($,v))}static forPaths($=!1){return new S(new A(void 0,!$))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new M)}constructor($){this.b=$}clear(){this.c=void 0}fill($,v){if(v){const n=v.slice(0);(0,E.$Xb)(n);for(const o of n)this.set(o,$)}else{const n=$.slice(0);(0,E.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set($,v){const n=this.b.reset($);let o;this.c||(this.c=new w,this.c.segment=n.value());const t=[];for(o=this.c;;){const a=n.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=n.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=n.value()),t.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new w,o.mid.segment=n.value()),t.push([0,o]),o=o.mid;else break}const r=o.value;o.value=v,o.key=$;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return r}get($){return this.d($)?.value}d($){const v=this.b.reset($);let n=this.c;for(;n;){const o=v.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(v.hasNext())v.next(),n=n.mid;else break}return n}has($){const v=this.d($);return!(v?.value===void 0&&v?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,v){const n=this.b.reset($),o=[];let t=this.c;for(;t;){const r=n.cmp(t.segment);if(r>0)o.push([-1,t]),t=t.left;else if(r<0)o.push([1,t]),t=t.right;else if(n.hasNext())n.next(),o.push([0,t]),t=t.mid;else break}if(t){if(v?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const r=this.f(t.right);if(r.key){const{key:a,value:c,segment:h}=r;this.e(r.key,!1),t.key=a,t.value=c,t.segment=h}}else{const r=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=r;break;case 0:c.mid=r;break;case 1:c.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const a=o[r][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[r][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[r][1]=a.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const v=this.b.reset($);let n=this.c,o;for(;n;){const t=v.cmp(n.segment);if(t>0)n=n.left;else if(t<0)n=n.right;else if(v.hasNext())v.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr($){return this.g($,!1)}g($,v){const n=this.b.reset($);let o=this.c;for(;o;){const t=n.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):v?o.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[v,n]of this)$(n,v)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const v=[];return this.j($,v),v[Symbol.iterator]()}j($,v){$&&($.left&&this.j($.left,v),$.value&&v.push([$.key,$.value]),$.mid&&this.j($.mid,v),$.right&&this.j($.right,v))}_isBalanced(){const $=v=>{if(!v)return!0;const n=v.balanceFactor();return n<-1||n>1?!1:$(v.left)&&$(v.right)};return $(this.c)}}e.$8h=S}),define(Pe[45],Ae([1,0,90]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var T;(function(A){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}A.isThemeColor=m})(T||(e.ThemeColor=T={}));function I(A){return{id:A}}e.$9j=I;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function g(r){const a=m.exec(r.id);if(!a)return g(E.$8j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}A.asClassNameArray=g;function w(r){return g(r).join(" ")}A.asClassName=w;function R(r){return"."+g(r).join(".")}A.asCSSSelector=R;function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=S;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function $(r){const a=l.exec(r);if(!a)return;const[,c]=a;return{id:c}}A.fromString=$;function v(r){return{id:r}}A.fromId=v;function n(r,a){let c=r.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}A.modify=n;function o(r){const a=r.id.lastIndexOf("~");if(a!==-1)return r.id.substring(a+1)}A.getModifier=o;function t(r,a){return r.id===a.id&&r.color?.id===a.color?.id}A.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[126],Ae([1,0,124,12,45]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const M="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function g(t){return t.replace(m,(r,a)=>a?r:`\\${r}`)}e.$0j=g;const w=new RegExp(`\\\\${A.source}`,"g");function R(t){return t.replace(w,r=>`\\${r}`)}e.$$j=R;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(S,(r,a,c,h)=>c?r:a||h||"")}e.$_j=l;function $(t){return t?t.replace(/\$\((.*?)\)/g,(r,a)=>` ${a} `).trim():""}e.$ak=$;const v=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(t){v.lastIndex=0;let r="";const a=[];let c=0;for(;;){const h=v.lastIndex,i=v.exec(t),s=t.substring(h,i?.index);if(s.length>0){r+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:r,iconOffsets:a}}e.$bk=n;function o(t,r,a=!1){const{text:c,iconOffsets:h}=r;if(!h||h.length===0)return(0,E.$Wj)(t,c,a);const i=(0,T.$Pe)(c," "),s=c.length-i.length,u=(0,E.$Wj)(t,i,a);if(u)for(const d of u){const b=h[d.start+s]+s;d.start+=b,d.end+=b}return u}e.$ck=o}),define(Pe[33],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(I){return E.test(I)}e.$lg=T,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const M=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,w="";return w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w}}()}),define(Pe[127],Ae([1,0,18,67,33]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.$_s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$_s=M;function A(S,l,$){const v={id:(0,I.$mg)(),name:S,uri:l,data:$};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$at=A;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return T.Iterable.some(this,([v,n])=>n.asFile())&&$.push("files"),R(g(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const v=this.a.get(l);v?v.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const v of $)yield[l,v]}b(l){return g(l)}}e.$bt=m;function g(S){return S.toLowerCase()}function w(S,l){return R(g(S),l.map(g))}e.$ct=w;function R(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const $=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[v,n,o]=$;return o==="*"?l.some(t=>t.startsWith(n+"/")):!1}e.$dt=Object.freeze({create:S=>(0,E.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$dt.split(S).filter(l=>!l.startsWith("#"))})}),define(Pe[128],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(I){let M=0,A=0,m=0,g=0;for(let w=0,R=I.length;w<R;w++){const S=I.charCodeAt(w);S===13?(M===0&&(A=w),M++,w+1<R&&I.charCodeAt(w+1)===10?(g|=2,w++):g|=3,m=w+1):S===10&&(g|=1,M===0&&(A=w),M++,m=w+1)}return M===0&&(A=I.length),[M,A,I.length-m,g]}e.$gt=T}),define(Pe[129],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$ds={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=e.IndentAction=void 0;var E;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,w=m.notIn.length;g<w;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(g-2),R=m.getStandardTokenType(w);return this.isOK(R)}g(m,g){for(let w=m;w<=g;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Dt=T;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)M(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),M(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),M(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),M(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&M(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Et=I;function M(A,m,g){A.has(m)?A.get(m).push(g):A.set(m,[g])}}),define(Pe[131],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.NodeColor=e.$AB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$BB)return I(this.right);let o=this;for(;o.parent!==e.$BB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$BB?e.$BB:o.parent}prev(){if(this.left!==e.$BB)return M(this.left);let o=this;for(;o.parent!==e.$BB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$BB?e.$BB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$AB=E;var T;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$BB=new E(null,0),e.$BB.parent=e.$BB,e.$BB.left=e.$BB,e.$BB.right=e.$BB,e.$BB.color=0;function I(n){for(;n.left!==e.$BB;)n=n.left;return n}e.$CB=I;function M(n){for(;n.right!==e.$BB;)n=n.right;return n}e.$DB=M;function A(n){return n===e.$BB?0:n.size_left+n.piece.length+A(n.right)}function m(n){return n===e.$BB?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function g(){e.$BB.parent=e.$BB}function w(n,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$BB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$BB?n.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$EB=w;function R(n,o){const t=o.left;o.left=t.right,t.right!==e.$BB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$BB?n.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$FB=R;function S(n,o){let t,r;if(o.left===e.$BB?(r=o,t=r.right):o.right===e.$BB?(r=o,t=r.left):(r=I(o.right),t=r.right),r===n.root){n.root=t,t.color=0,o.detach(),g(),n.root.parent=e.$BB;return}const a=r.color===1;if(r===r.parent.left?r.parent.left=t:r.parent.right=t,r===o?(t.parent=r.parent,v(n,t)):(r.parent===o?t.parent=r:t.parent=r.parent,v(n,t),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$BB&&(r.left.parent=r),r.right!==e.$BB&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,v(n,r)),o.detach(),t.parent.left===t){const h=A(t),i=m(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,$(n,t.parent,s,u)}}if(v(n,t.parent),a){g();return}let c;for(;t!==n.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(n,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(n,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(n,t.parent),t=n.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,R(n,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(n,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,R(n,t.parent),t=n.root));t.color=0,g()}e.$GB=S;function l(n,o){for(v(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(n,o)),o.parent.color=0,o.parent.parent.color=1,R(n,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(n,o)),o.parent.color=0,o.parent.parent.color=1,w(n,o.parent.parent))}n.root.color=0}e.$HB=l;function $(n,o,t,r){for(;o!==n.root&&o!==e.$BB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}e.$IB=$;function v(n,o){let t=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,t=A(o.left)-o.size_left,r=m(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=r;o!==n.root&&(t!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}}e.$JB=v}),define(Pe[91],Ae([1,0,92,29,93,131,94]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UB=e.$TB=e.$SB=e.$RB=e.$QB=void 0;const m=65535;function g(t){let r;return t[t.length-1]<65536?r=new Uint16Array(t.length):r=new Uint32Array(t.length),r.set(t,0),r}class w{constructor(r,a,c,h,i){this.lineStarts=r,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function R(t,r=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return r?g(a):a}e.$QB=R;function S(t,r){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,b=r.length;d<b;d++){const f=r.charCodeAt(d);f===13?d+1<b&&r.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$RB=S;class l{constructor(r,a,c,h,i){this.bufferIndex=r,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$SB=l;class ${constructor(r,a){this.buffer=r,this.lineStarts=a}}e.$TB=$;class v{constructor(r,a){this.a=[],this.c=r,this.d=a,this.b=0,r.root!==M.$BB&&r.iterate(r.root,c=>(c!==M.$BB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=r&&c.nodeStartOffset+c.node.piece.length>=r)return c}return null}get2(r){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<r&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=r)return c}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=r){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(r,a,c){this.create(r,a,c)}create(r,a,c){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=M.$BB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=r.length;i<s;i++)if(r[i].buffer.length>0){r[i].lineStarts||(r[i].lineStarts=R(r[i].buffer));const u=new l(i+1,{line:0,column:0},{line:r[i].lineStarts.length-1,column:r[i].buffer.length-r[i].lineStarts[r[i].lineStarts.length-1]},r[i].lineStarts.length-1,r[i].buffer.length);this.a.push(r[i]),h=this.S(h,u)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const a=m,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const b=this.R(d),f=b.length;if(s<=c||s+f<h)return i+=b,s+=f,!0;const D=i.replace(/\r\n|\r|\n/g,r);return u.push(new $(D,R(D))),i=b,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,r);u.push(new $(d,R(d)))}this.create(u,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===M.$BB)return!0;const i=this.R(h),s=i.length,u=r.G(a),d=r.G(a+s),b=r.getValueInRange2(u,d);return a+=s,i===b})}getOffsetAt(r,a){let c=0,h=this.root;for(;h!==M.$BB;)if(h.left!==M.$BB&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){c+=h.size_left;const i=this.B(h,r-h.lf_left-2);return c+=i+a-1}else r-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let a=this.root,c=0;const h=r;for(;a!==M.$BB;)if(a.size_left!==0&&a.size_left>=r)a=a.left;else if(a.size_left+a.piece.length>=r){const i=this.A(a,r-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Fs(c+1,u+1)}return new E.$Fs(c+1,i.remainder+1)}else if(r-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===M.$BB){const i=this.getOffsetAt(c+1,1),s=h-r-i;return new E.$Fs(c+1,s+1)}else a=a.right;return new E.$Fs(1,1)}getValueInRange(r,a){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const c=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(r,a){if(r.node===a.node){const u=r.node,d=this.a[u.piece.bufferIndex].buffer,b=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(b+r.remainder,b+a.remainder)}let c=r.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+r.remainder,i+c.piece.length);for(c=c.next();c!==M.$BB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const r=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===M.$BB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,b=this.a[s.bufferIndex].lineStarts,f=s.start.line,D=s.end.line;let F=b[f]+s.start.column;if(h&&(d.charCodeAt(F)===10&&(F++,u--),r[a++]=c,c="",h=!1,u===0))return!0;if(f===D)return!this.f&&d.charCodeAt(F+u-1)===13?(h=!0,c+=d.substr(F,u-1)):c+=d.substr(F,u),!0;c+=this.f?d.substring(F,Math.max(F,b[f+1]-this.e)):d.substring(F,b[f+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;for(let p=f+1;p<D;p++)c=this.f?d.substring(b[p],b[p+1]-this.e):d.substring(b[p],b[p+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;return!this.f&&d.charCodeAt(b[D]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(b[D],s.end.column-1)):c=d.substr(b[D],s.end.column),!0}),h&&(r[a++]=c,c=""),r[a++]=c,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const a=r.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(r,a){const c=this.H(r,a+1);return this.l(c)}getLineLength(r){if(r===this.getLineCount()){const a=this.getOffsetAt(r,1);return this.getLength()-a}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const a=this.G(r);return this.l(a)}findMatchesInNode(r,a,c,h,i,s,u,d,b,f,D){const F=this.a[r.piece.bufferIndex],p=this.u(r.piece.bufferIndex,r.piece.start),y=this.u(r.piece.bufferIndex,i),k=this.u(r.piece.bufferIndex,s);let O;const K={line:0,column:0};let U,L;a._wordSeparators?(U=F.buffer.substring(y,k),L=z=>z+y,a.reset(0)):(U=F.buffer,L=z=>z,a.reset(y));do if(O=a.next(U),O){if(L(O.index)>=k)return f;this.s(r,L(O.index)-p,K);const z=this.t(r.piece.bufferIndex,i,K),C=K.line===i.line?K.column-i.column+h:K.column+1,P=C+O[0].length;if(D[f++]=(0,A.$MB)(new T.$Gs(c+z,C,c+z,P),O,d),L(O.index)+O[0].length>=k||f>=b)return f}while(O);return f}findMatchesLineByLine(r,a,c,h){const i=[];let s=0;const u=new A.$PB(a.wordSeparators,a.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const b=this.H(r.endLineNumber,r.endColumn);if(b===null)return[];let f=this.s(d.node,d.remainder);const D=this.s(b.node,b.remainder);if(d.node===b.node)return this.findMatchesInNode(d.node,u,r.startLineNumber,r.startColumn,f,D,a,c,h,s,i),i;let F=r.startLineNumber,p=d.node;for(;p!==b.node;){const k=this.t(p.piece.bufferIndex,f,p.piece.end);if(k>=1){const K=this.a[p.piece.bufferIndex].lineStarts,U=this.u(p.piece.bufferIndex,p.piece.start),L=K[f.line+k],z=F===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(p,u,F,z,f,this.s(p,L-U),a,c,h,s,i),s>=h)return i;F+=k}const O=F===r.startLineNumber?r.startColumn-1:0;if(F===r.endLineNumber){const K=this.getLineContent(F).substring(O,r.endColumn-1);return s=this.n(a,u,K,r.endLineNumber,O,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(F).substr(O),F,O,s,i,c,h),s>=h)return i;F++,d=this.H(F,1),p=d.node,f=this.s(d.node,d.remainder)}if(F===r.endLineNumber){const k=F===r.startLineNumber?r.startColumn-1:0,O=this.getLineContent(F).substring(k,r.endColumn-1);return s=this.n(a,u,O,r.endLineNumber,k,s,i,c,h),i}const y=F===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(b.node,u,F,y,f,D,a,c,h,s,i),i}n(r,a,c,h,i,s,u,d,b){const f=r.wordSeparators;if(!d&&r.simpleSearch){const F=r.simpleSearch,p=F.length,y=c.length;let k=-p;for(;(k=c.indexOf(F,k+p))!==-1;)if((!f||(0,A.$OB)(f,c,y,k,p))&&(u[s++]=new I.$Yu(new T.$Gs(h,k+1+i,h,k+1+p+i),null),s>=b))return s;return s}let D;a.reset(0);do if(D=a.next(c),D&&(u[s++]=(0,A.$MB)(new T.$Gs(h,D.index+1+i,h,D.index+1+D[0].length+i),D,d),s>=b))return s;while(D);return s}insert(r,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$BB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(r),u=h.piece,d=u.bufferIndex,b=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===r&&a.length<m){this.F(h,a),this.y();return}if(s===r)this.o(a,h),this.h.validate(r);else if(s+h.piece.length>r){const f=[];let D=new l(u.bufferIndex,b,u.end,this.t(u.bufferIndex,b,u.end),this.u(d,u.end)-this.u(d,b));if(this.K()&&this.M(a)&&this.I(h,i)===10){const k={line:D.start.line+1,column:0};D=new l(D.bufferIndex,k,D.end,this.t(D.bufferIndex,k,D.end),D.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const k=this.s(h,i-1);this.C(h,k),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,b);else this.C(h,b);const F=this.w(a);D.length>0&&this.S(h,D);let p=h;for(let y=0;y<F.length;y++)p=this.S(p,F[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(r,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===M.$BB)return;const c=this.G(r),h=this.G(r+a),i=c.node,s=h.node;if(i===s){const F=this.s(i,c.remainder),p=this.s(i,h.remainder);if(c.nodeStartOffset===r){if(a===i.piece.length){const y=i.next();(0,M.$GB)(this,i),this.N(y),this.y();return}this.D(i,p),this.h.validate(r),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===r+a){this.C(i,F),this.O(i),this.y();return}this.E(i,F,p),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(r),i.piece.length===0&&u.push(i);const b=this.s(s,h.remainder);this.D(s,b),s.piece.length===0&&u.push(s);const f=i.next();for(let F=f;F!==M.$BB&&F!==s;F=F.next())u.push(F);const D=i.piece.length===0?i.prev():i;this.v(u),this.O(D),this.y()}o(r,a){const c=[];if(this.K()&&this.M(r)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,r+=`
`,(0,M.$IB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(r);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(r,a){this.Q(r,a)&&(r+=`
`);const c=this.w(r),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(r,a,c){const h=r.piece,i=r.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let b=h.start.line,f=h.end.line,D=0,F=0,p=0;for(;b<=f&&(D=b+(f-b)/2|0,p=s[D],D!==f);)if(F=s[D+1],d<p)f=D-1;else if(d>=F)b=D+1;else break;return c?(c.line=D,c.column=d-p,null):{line:D,column:d-p}}t(r,a,c){if(c.column===0)return c.line-a.line;const h=this.a[r].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[r].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(r,a){return this.a[r].lineStarts[a.line]+a.column}v(r){for(let a=0;a<r.length;a++)(0,M.$GB)(this,r[a])}w(r){if(r.length>m){const f=[];for(;r.length>m;){const F=r.charCodeAt(m-1);let p;F===13||F>=55296&&F<=56319?(p=r.substring(0,m-1),r=r.substring(m-1)):(p=r.substring(0,m),r=r.substring(m));const y=R(p);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:p.length-y[y.length-1]},y.length-1,p.length)),this.a.push(new $(p,y))}const D=R(r);return f.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:r.length-D[D.length-1]},D.length-1,r.length)),this.a.push(new $(r,D)),f}let a=this.a[0].buffer.length;const c=R(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+r,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=r}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},b=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,a=0){let c=this.root,h="";const i=this.h.get2(r);if(i){c=i.node;const s=this.B(c,r-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===r)h=u.substring(d+s,d+c.piece.length);else{const b=this.B(c,r-i.nodeStartLineNumber);return u.substring(d+s,d+b-a)}}else{let s=0;const u=r;for(;c!==M.$BB;)if(c.left!==M.$BB&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const d=this.B(c,r-c.lf_left-2),b=this.B(c,r-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(r-1-c.lf_left)}),f.substring(D+d,D+b-a)}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const d=this.B(c,r-c.lf_left-2),b=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=b.substring(f+d,f+c.piece.length);break}else r-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$BB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let r=this.root,a=1,c=0;for(;r!==M.$BB;)a+=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;this.b=a,this.c=c,this.h.validate(this.c)}A(r,a){const c=r.piece,h=this.s(r,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(r.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(r,a){if(a<0)return 0;const c=r.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(r,a){const c=r.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),b=d-h,f=u-i,D=c.length+f;r.piece=new l(c.bufferIndex,c.start,s,d,D),(0,M.$IB)(this,r,f,b)}D(r,a){const c=r.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),b=u-h,f=i-d,D=c.length+f;r.piece=new l(c.bufferIndex,s,c.end,u,D),(0,M.$IB)(this,r,f,b)}E(r,a,c){const h=r.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,b=a,f=this.t(h.bufferIndex,h.start,b),D=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);r.piece=new l(h.bufferIndex,h.start,b,f,D),(0,M.$IB)(this,r,D-u,f-d);const F=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),p=this.S(r,F);this.N(p)}F(r,a){this.Q(a,r)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=R(a,!1);for(let p=0;p<i.length;p++)i[p]+=h;if(c){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},b=r.piece.length+a.length,f=r.piece.lineFeedCnt,D=this.t(0,r.piece.start,d),F=D-f;r.piece=new l(r.piece.bufferIndex,r.piece.start,d,D,b),this.g=d,(0,M.$IB)(this,r,a.length,F)}G(r){let a=this.root;const c=this.h.get(r);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:r-c.nodeStartOffset};let h=0;for(;a!==M.$BB;)if(a.size_left>r)a=a.left;else if(a.size_left+a.piece.length>=r){h+=a.size_left;const i={node:a,remainder:r-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else r-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(r,a){let c=this.root,h=0;for(;c!==M.$BB;)if(c.left!==M.$BB&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const i=this.B(c,r-c.lf_left-2),s=this.B(c,r-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const i=this.B(c,r-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else r-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$BB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(r,a){if(r.piece.lineFeedCnt<1)return-1;const c=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+a;return c.buffer.charCodeAt(h)}J(r){if(!r)return 0;let a=r.size_left;for(;r!==this.root;)r.parent.right===r&&(a+=r.parent.size_left+r.parent.piece.length),r=r.parent;return a}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$BB||r.piece.lineFeedCnt===0)return!1;const a=r.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$BB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const a=r.prev();this.M(a)&&this.P(a,r)}}O(r){if(this.K()&&this.M(r)){const a=r.next();this.L(a)&&this.P(r,a)}}P(r,a){const c=[],h=this.a[r.piece.bufferIndex].lineStarts;let i;r.piece.end.column===0?i={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:i={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,u=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,i,u,s),(0,M.$IB)(this,r,-1,-1),r.piece.length===0&&c.push(r);const d={line:a.piece.start.line+1,column:0},b=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,b),(0,M.$IB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const D=this.w(`\r
`);this.S(r,D[0]);for(let F=0;F<c.length;F++)(0,M.$GB)(this,c[F])}Q(r,a){if(this.K()&&this.M(r)){const c=a.next();if(this.L(c)){if(r+=`
`,c.piece.length===1)(0,M.$GB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,M.$IB)(this,c,-1,-1)}return!0}}return!1}iterate(r,a){if(r===M.$BB)return a(M.$BB);const c=this.iterate(r.left,a);return c&&a(r)&&this.iterate(r.right,a)}R(r){if(r===M.$BB)return"";const a=this.a[r.piece.bufferIndex],c=r.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(r){const a=this.a[r.bufferIndex],c=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return a.buffer.substring(c,h)}S(r,a){const c=new M.$AB(a,1);if(c.left=M.$BB,c.right=M.$BB,c.parent=M.$BB,c.size_left=0,c.lf_left=0,this.root===M.$BB)this.root=c,c.color=0;else if(r.right===M.$BB)r.right=c,c.parent=r;else{const i=(0,M.$CB)(r.right);i.left=c,c.parent=i}return(0,M.$HB)(this,c),c}T(r,a){const c=new M.$AB(a,1);if(c.left=M.$BB,c.right=M.$BB,c.parent=M.$BB,c.size_left=0,c.lf_left=0,this.root===M.$BB)this.root=c,c.color=0;else if(r.left===M.$BB)r.left=c,c.parent=r;else{const h=(0,M.$DB)(r.left);h.right=c,c.parent=h}return(0,M.$HB)(this,c),c}U(r){let a="";return this.iterate(r,c=>(a+=this.R(c),!0)),a}}e.$UB=o}),define(Pe[132],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7=e.$07=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$07=E;class T{constructor(M){this.identifier=M}}e.$$7=T}),define(Pe[133],Ae([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class M extends T.$Sc{constructor(l,$="",v="",n=!0,o){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=v,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Gi=M;class A extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,$)}catch(n){v=n}this.m.fire({action:l,error:v})}async u(l,$){await l.run($)}}e.$Hi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const v of l)v.length&&($.length?$=[...$,new m,...v]:$=v);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=m;class g{get actions(){return this.a}constructor(l,$,v,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=n,this.a=v}async run(){}}e.$Ji=g;class w extends M{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Ki=w;function R(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Li=R}),define(Pe[135],Ae([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0;const T=60,I=T*60,M=I*24,A=M*7,m=M*30,g=M*365;function w(S,l,$,v){typeof S!="number"&&(S=S.getTime());const n=Math.round((new Date().getTime()-S)/1e3);if(n<-30)return(0,E.localize)(0,null,w(new Date().getTime()+n*1e3,!1));if(!v&&n<30)return(0,E.localize)(1,null);let o;return n<T?(o=n,l?o===1?$?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):$?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?$?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):$?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):n<I?(o=Math.floor(n/T),l?o===1?$?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):$?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?$?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):$?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):n<M?(o=Math.floor(n/I),l?o===1?$?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):$?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?$?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):$?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):n<A?(o=Math.floor(n/M),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):n<m?(o=Math.floor(n/A),l?o===1?$?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):$?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?$?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):$?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):n<g?(o=Math.floor(n/m),l?o===1?$?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):$?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?$?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):$?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(n/g),l?o===1?$?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):$?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?$?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):$?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$qm=w;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$rm=R}),define(Pe[137],Ae([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,18,16,137]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function M(S,l){return l&&(S.stack||S.stacktrace)?I.localize(0,null,m(S),A(S.stack)||A(S.stacktrace)):m(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function m(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?I.localize(1,null,S.message):S.message||I.localize(2,null)}function g(S=null,l=!1){if(!S)return I.localize(3,null);if(Array.isArray(S)){const $=E.$Hb(S),v=g($[0],l);return $.length>1?I.localize(4,null,v,$.length):v}if(T.$Ef(S))return S;if(S.detail){const $=S.detail;if($.error)return M($.error,l);if($.exception)return M($.exception,l)}return S.stack?M(S,l):S.message?S.message:I.localize(5,null)}e.$Mi=g;function w(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Ni=w;function R(S,l){let $;return typeof S=="string"?$=new Error(S):$=S,$.actions=l,$}e.$Oi=R}),define(Pe[138],Ae([1,0,39,19]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=void 0;const I=new E.$V(()=>{const F=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:F,collatorIsNumeric:F.resolvedOptions().numeric}}),M=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(F,p,y=!1){const k=F||"",O=p||"",K=I.value.collator.compare(k,O);return I.value.collatorIsNumeric&&K===0&&k!==O?k<O?-1:1:K}e.$uq=m;function g(F,p){const y=M.value.collator;return F=F||"",p=p||"",c(y,F,p)}e.$vq=g;function w(F,p){const y=M.value.collator;return F=F||"",p=p||"",u(F,p)||c(y,F,p)}e.$wq=w;function R(F,p){const y=M.value.collator;return F=F||"",p=p||"",s(F,p)||c(y,F,p)}e.$xq=R;function S(F,p){return F=F||"",p=p||"",F===p?0:F<p?-1:1}e.$yq=S;function l(F,p){const[y,k]=r(F),[O,K]=r(p);let U=I.value.collator.compare(k,K);if(U===0){if(I.value.collatorIsNumeric&&k!==K)return k<K?-1:1;if(U=I.value.collator.compare(y,O),I.value.collatorIsNumeric&&U===0&&y!==O)return y<O?-1:1}return U}e.$zq=l;function $(F,p){F=F||"",p=p||"";const y=a(F),k=a(p),O=M.value.collator,K=A.value.collator;return c(K,y,k)||c(O,F,p)}e.$Aq=$;function v(F,p){F=F||"",p=p||"";const y=a(F),k=a(p),O=M.value.collator,K=A.value.collator;return c(K,y,k)||u(F,p)||c(O,F,p)}e.$Bq=v;function n(F,p){F=F||"",p=p||"";const y=a(F),k=a(p),O=M.value.collator,K=A.value.collator;return c(K,y,k)||s(F,p)||c(O,F,p)}e.$Cq=n;function o(F,p){F=F||"",p=p||"";const y=a(F).toLowerCase(),k=a(p).toLowerCase();return y!==k?y<k?-1:1:F!==p?F<p?-1:1:0}e.$Dq=o;const t=/^(.*?)(\.([^.]*))?$/;function r(F,p=!1){const y=F?t.exec(F):[];let k=[y&&y[1]||"",y&&y[3]||""];return p&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function a(F){const p=F?t.exec(F):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function c(F,p,y){const k=F.compare(p,y);return k!==0?k:p.length!==y.length?p.length<y.length?-1:1:0}function h(F){const p=F.charAt(0);return p.toLocaleUpperCase()!==p}function i(F){const p=F.charAt(0);return p.toLocaleLowerCase()!==p}function s(F,p){return h(F)&&i(p)?-1:i(F)&&h(p)?1:0}function u(F,p){return i(F)&&h(p)?-1:h(F)&&i(p)?1:0}function d(F,p,y=!1){return y||(F=F&&F.toLowerCase(),p=p&&p.toLowerCase()),F===p?0:F<p?-1:1}function b(F,p,y=!1){const k=F.split(T.sep),O=p.split(T.sep),K=k.length-1,U=O.length-1;let L,z;for(let C=0;;C++){if(L=K===C,z=U===C,L&&z)return m(k[C],O[C],y);if(L)return-1;if(z)return 1;const P=d(k[C],O[C],y);if(P!==0)return P}}e.$Eq=b;function f(F,p,y){const k=F.toLowerCase(),O=p.toLowerCase(),K=D(F,p,y);if(K)return K;const U=k.endsWith(y),L=O.endsWith(y);if(U!==L)return U?-1:1;const z=m(k,O);return z!==0?z:k.localeCompare(O)}e.$Fq=f;function D(F,p,y){const k=F.toLowerCase(),O=p.toLowerCase(),K=k.startsWith(y),U=O.startsWith(y);if(K!==U)return K?-1:1;if(K&&U){if(k.length<O.length)return-1;if(k.length>O.length)return 1}return 0}e.$Gq=D}),define(Pe[46],Ae([1,0,19,21,12,16]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function A(f){return f===47||f===92}e.$Wf=A;function m(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Xf=m;function g(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Yf=g;function w(f,D=E.$gc.sep){if(!f)return"";const F=f.length,p=f.charCodeAt(0);if(A(p)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let k=3;const O=k;for(;k<F&&!A(f.charCodeAt(k));k++);if(O!==k&&!A(f.charCodeAt(k+1))){for(k+=1;k<F;k++)if(A(f.charCodeAt(k)))return f.slice(0,k+1).replace(/[\\/]/g,D)}}return D}else if(t(p)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+D:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<F;y++)if(A(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Zf=w;function R(f){if(!T.$i||!f||f.length<5)return!1;let D=f.charCodeAt(0);if(D!==92||(D=f.charCodeAt(1),D!==92))return!1;let F=2;const p=F;for(;F<f.length&&(D=f.charCodeAt(F),D!==92);F++);return!(p===F||(D=f.charCodeAt(F+1),isNaN(D)||D===92))}e.$1f=R;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(f,D=T.$i){const F=D?S:l;return!(!f||f.length===0||/^\s+$/.test(f)||(F.lastIndex=0,F.test(f))||D&&$.test(f)||f==="."||f===".."||D&&f[f.length-1]==="."||D&&f.length!==f.trim().length||f.length>255)}e.$2f=v;function n(f,D,F){const p=f===D;return!F||p?p:!f||!D?!1:(0,I.$8e)(f,D)}e.$3f=n;function o(f,D,F,p=E.sep){if(f===D)return!0;if(!f||!D||D.length>f.length)return!1;if(F){if(!(0,I.$9e)(f,D))return!1;if(D.length===f.length)return!0;let k=D.length;return D.charAt(D.length-1)===p&&k--,f.charAt(k)===p}return D.charAt(D.length-1)!==p&&(D+=p),f.indexOf(D)===0}e.$4f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$5f=t;function r(f,D){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(D,f)),f=(0,E.$hc)(f),T.$i?(f=(0,I.$Qe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Qe)(f,E.sep),f||(f=E.sep)),f}e.$6f=r;function a(f){const D=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(D)&&(f.length===2||D.charCodeAt(2)===92):D===E.$gc.sep}e.$7f=a;function c(f,D=T.$i){return D?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$8f=c;function h(f,D=T.$i){return c(f,D)?f[0]:void 0}e.$9f=h;function i(f,D,F){return D.length>f.length?-1:f===D?0:(F&&(f=f.toLowerCase(),D=D.toLowerCase()),f.indexOf(D))}e.$0f=i;function s(f){const D=f.split(":");let F,p,y;for(const k of D){const O=Number(k);(0,M.$If)(O)?p===void 0?p=O:y===void 0&&(y=O):F=F?[F,k].join(":"):k}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:p!==void 0?p:void 0,column:y!==void 0?y:p!==void 0?1:void 0}}e.$$f=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(f,D,F=8){let p="";for(let k=0;k<F;k++){let O;k===0&&T.$i&&!D&&(F===3||F===4)?O=d:O=u,p+=O.charAt(Math.floor(Math.random()*O.length))}let y;return D?y=`${D}-${p}`:y=p,f?(0,E.$jc)(f,y):y}e.$_f=b}),define(Pe[68],Ae([1,0,19]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=void 0,e.$3r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,E.$oc)(R),l=T[S.toLowerCase()];return l!==void 0?l:A(R)}e.$4r=M;function A(R){const S=(0,E.$oc)(R);return I[S.toLowerCase()]}e.$5r=A;function m(R){for(const S in I)if(I[S]===R)return S}e.$6r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function w(R,S){const l=g.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:R}e.$7r=w}),define(Pe[51],Ae([1,0,24,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function I(g){return JSON.stringify(g,A)}e.$wh=I;function M(g){let w=JSON.parse(g);return w=m(w),w}e.$xh=M;function A(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let R=0;R<g.length;++R)g[R]=m(g[R],w+1);else for(const R in g)Object.hasOwnProperty.call(g,R)&&(g[R]=m(g[R],w+1))}return g}e.$yh=m}),define(Pe[13],Ae([1,0,11,21,12,2]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function m(l,$){return M.URI.isUri(l)?(0,I.$8e)(l.scheme,$):(0,I.$9e)(l,$+":")}e.$ag=m;function g(l,...$){return $.some(v=>m(l,v))}e.$bg=g,e.$cg="vscode-tkn",e.$dg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${A.vscodeRemoteResource}`}set($,v,n){this.a[$]=v,this.b[$]=n}setConnectionToken($,v){this.c[$]=v}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(a){return E.$1(a),$}const v=$.authority;let n=this.a[v];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const o=this.b[v],t=this.c[v];let r=`path=${encodeURIComponent($.path)}`;return typeof t=="string"&&(r+=`&${e.$dg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${n}:${o}`,path:this.f,query:r})}}e.$eg=new w,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class R{static{this.a=e.$jg}asBrowserUri($){const v=this.b($,me);return this.uriToBrowserUri(v)}uriToBrowserUri($){return $.scheme===A.vscodeRemote?e.$eg.rewrite($):$.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${R.a}`)?$.with({scheme:A.vscodeFileResource,authority:$.authority||R.a,query:null,fragment:null}):$}asFileUri($){const v=this.b($,me);return this.uriToFileUri(v)}uriToFileUri($){return $.scheme===A.vscodeFileResource?$.with({scheme:A.file,authority:$.authority!==R.a?$.authority:null,query:null,fragment:null}):$}b($,v){return M.URI.isUri($)?$:M.URI.parse(v.toUrl($))}}e.$kg=new R;var S;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const v="vscode-coi";function n(t){let r;typeof t=="string"?r=new URL(t).searchParams:t instanceof URL?r=t.searchParams:M.URI.isUri(t)&&(r=new URL(t.toString(!0)).searchParams);const a=r?.get(v);if(a)return $.get(a)}l.getHeadersFromQuery=n;function o(t,r,a){if(!globalThis.crossOriginIsolated)return;const c=r&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(v,c):t[v]=c}l.addSearchParam=o})(S||(e.COI=S={}))}),define(Pe[25],Ae([1,0,46,13,19,21,12,2]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function g($){return(0,m.$wc)($,!0)}e.$rg=g;class w{constructor(v){this.a=v}compare(v,n,o=!1){return v===n?0:(0,A.$1e)(this.getComparisonKey(v,o),this.getComparisonKey(n,o))}isEqual(v,n,o=!1){return v===n?!0:!v||!n?!1:this.getComparisonKey(v,o)===this.getComparisonKey(n,o)}getComparisonKey(v,n=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,n,o=!1){if(v.scheme===n.scheme){if(v.scheme===T.Schemas.file)return E.$4f(g(v),g(n),this.a(v))&&v.query===n.query&&(o||v.fragment===n.fragment);if((0,e.$Ig)(v.authority,n.authority))return E.$4f(v.path,n.path,this.a(v),"/")&&v.query===n.query&&(o||v.fragment===n.fragment)}return!1}joinPath(v,...n){return m.URI.joinPath(v,...n)}basenameOrAuthority(v){return(0,e.$Ag)(v)||v.authority}basename(v){return I.$gc.basename(v.path)}extname(v){return I.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let n;return v.scheme===T.Schemas.file?n=m.URI.file(I.$mc(g(v))).path:(n=I.$gc.dirname(v.path),v.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),n="/")),v.with({path:n})}normalizePath(v){if(!v.path.length)return v;let n;return v.scheme===T.Schemas.file?n=m.URI.file(I.$hc(g(v))).path:n=I.$gc.normalize(v.path),v.with({path:n})}relativePath(v,n){if(v.scheme!==n.scheme||!(0,e.$Ig)(v.authority,n.authority))return;if(v.scheme===T.Schemas.file){const r=I.$lc(g(v),g(n));return M.$i?E.$Xf(r):r}let o=v.path||"/";const t=n.path||"/";if(this.a(v)){let r=0;for(const a=Math.min(o.length,t.length);r<a&&!(o.charCodeAt(r)!==t.charCodeAt(r)&&o.charAt(r).toLowerCase()!==t.charAt(r).toLowerCase());r++);o=t.substr(0,r)+o.substr(r)}return I.$gc.relative(o,t)}resolvePath(v,n){if(v.scheme===T.Schemas.file){const o=m.URI.file(I.$kc(g(v),n));return v.with({authority:o.authority,path:o.path})}return n=E.$Yf(n),v.with({path:I.$gc.resolve(v.path,n)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,n){return v===n||v!==void 0&&n!==void 0&&(0,A.$8e)(v,n)}hasTrailingPathSeparator(v,n=I.sep){if(v.scheme===T.Schemas.file){const o=g(v);return o.length>E.$Zf(o).length&&o[o.length-1]===n}else{const o=v.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,n=I.sep){return(0,e.$Jg)(v,n)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,n=I.sep){let o=!1;if(v.scheme===T.Schemas.file){const t=g(v);o=t!==void 0&&t.length===E.$Zf(t).length&&t[t.length-1]===n}else{n="/";const t=v.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Jg)(v,n)?v.with({path:v.path+"/"}):v}}e.$sg=w,e.$tg=new w(()=>!1),e.$ug=new w($=>$.scheme===T.Schemas.file?!M.$k:!0),e.$vg=new w($=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function R($,v){const n=[];for(let o=0;o<$.length;o++){const t=v($[o]);$.some((r,a)=>a===o?!1:(0,e.$xg)(t,v(r)))||n.push($[o])}return n}e.$Mg=R;var S;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function v(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set($.META_DATA_MIME,r),o}$.parseMetaData=v})(S||(e.DataUri=S={}));function l($,v,n){if(v){let o=$.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),$.with({scheme:n,authority:v,path:o})}return $.with({scheme:n})}e.$Ng=l}),define(Pe[14],Ae([1,0,20,11,5,6,25,21,125,39]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function R(ce){return!!ce&&typeof ce.then=="function"}e.$Og=R;function S(ce){const ie=new E.$3d,Q=ce(ie.token),ee=new Promise(($e,be)=>{const Le=ie.token.onCancellationRequested(()=>{Le.dispose(),ie.dispose(),be(new T.$5)});Promise.resolve(Q).then(le=>{Le.dispose(),ie.dispose(),$e(le)},le=>{Le.dispose(),ie.dispose(),be(le)})});return new class{cancel(){ie.cancel()}then($e,be){return ee.then($e,be)}catch($e){return this.then(void 0,$e)}finally($e){return ee.finally($e)}}}e.$Pg=S;function l(ce,ie,Q){return new Promise((ee,$e)=>{const be=ie.onCancellationRequested(()=>{be.dispose(),ee(Q)});ce.then(ee,$e).finally(()=>be.dispose())})}e.$Qg=l;function $(ce,ie){return new Promise((Q,ee)=>{const $e=ie.onCancellationRequested(()=>{$e.dispose(),ee(new T.$5)});ce.then(Q,ee).finally(()=>$e.dispose())})}e.$Rg=$;async function v(ce){let ie=-1;const Q=ce.map((ee,$e)=>ee.then(be=>(ie=$e,be)));try{return await Promise.race(Q)}finally{ce.forEach((ee,$e)=>{$e!==ie&&ee.cancel()})}}e.$Sg=v;function n(ce,ie,Q){let ee;const $e=setTimeout(()=>{ee?.(void 0),Q?.()},ie);return Promise.race([ce.finally(()=>clearTimeout($e)),new Promise(be=>ee=be)])}e.$Tg=n;function o(ce){return new Promise((ie,Q)=>{const ee=ce();R(ee)?ee.then(ie,Q):ie(ee)})}e.$Ug=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=ie(),new Promise((Q,ee)=>{this.a.then($e=>{this.a=null,Q($e)},$e=>{this.a=null,ee($e)})})}dispose(){this.f=!0}}e.$Vg=t;class r{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Wg=r;class a{constructor(){this.a=new Map}queue(ie,Q){const $e=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(ie)===$e&&this.a.delete(ie)});return this.a.set(ie,$e),$e}}e.$Xg=a;const c=(ce,ie)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,ie()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ce=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ce())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,Q=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise(($e,be)=>{this.d=$e,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Pd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=i;class s{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,Q){return this.a.trigger(()=>this.b.queue(ie),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=s;class u{constructor(){this.a=!1,this.b=new Promise((ie,Q)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$2g=d;function b(ce,ie){return ie?new Promise((Q,ee)=>{const $e=setTimeout(()=>{be.dispose(),Q()},ce),be=ie.onCancellationRequested(()=>{clearTimeout($e),be.dispose(),ee(new T.$5)})}):S(Q=>b(ce,Q))}e.$3g=b;function f(ce,ie=0,Q){const ee=setTimeout(()=>{ce(),Q&&$e.dispose()},ie),$e=(0,M.$Qc)(()=>{clearTimeout(ee),Q?.deleteAndLeak($e)});return Q?.add($e),$e}e.$4g=f;function D(ce){const ie=[];let Q=0;const ee=ce.length;function $e(){return Q<ee?ce[Q++]():null}function be(Le){Le!=null&&ie.push(Le);const le=$e();return le?le.then(be):Promise.resolve(ie)}return Promise.resolve(null).then(be)}e.$5g=D;function F(ce,ie=ee=>!!ee,Q=null){let ee=0;const $e=ce.length,be=()=>{if(ee>=$e)return Promise.resolve(Q);const Le=ce[ee++];return Promise.resolve(Le()).then(we=>ie(we)?Promise.resolve(we):be())};return be()}e.$6g=F;function p(ce,ie=ee=>!!ee,Q=null){if(ce.length===0)return Promise.resolve(Q);let ee=ce.length;const $e=()=>{ee=-1;for(const be of ce)be.cancel?.()};return new Promise((be,Le)=>{for(const le of ce)le.then(we=>{--ee>=0&&ie(we)?($e(),be(we)):ee===0&&be(Q)}).catch(we=>{--ee>=0&&($e(),Le(we))})})}e.$7g=p;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((Q,ee)=>{this.f.push({factory:ie,c:Q,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const Q=ie.factory();Q.then(ie.c,ie.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=y;class k extends y{constructor(){super(1)}}e.$9g=k;class O{constructor(){this.a=new De,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$0g=O;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new te;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,Q=A.$tg){const ee=Q.getComparisonKey(ie);let $e=this.a.get(ee);if(!$e){$e=new k;const be=this.f++,Le=I.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$2c),this.d.set(be,Le),this.a.set(ee,$e)}return $e}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=K;class U{constructor(ie,Q){this.a=-1,typeof ie=="function"&&typeof Q=="number"&&this.setIfNotSet(ie,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},Q)}setIfNotSet(ie,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},Q))}}e.$_g=U;class L{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,Q,ee=globalThis){this.cancel();const $e=ee.setInterval(()=>{ie()},Q);this.d=(0,M.$Qc)(()=>{ee.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$ah=L;class z{constructor(ie,Q){this.b=-1,this.a=ie,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=z;class C{constructor(ie,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=ie,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=C;class P extends z{constructor(ie,Q){super(ie,Q),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$dh=P;class Y extends M.$Sc{constructor(ie,Q){super(),this.g=ie,this.h=Q,this.a=[],this.b=this.B(new M.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of ie)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(ce,ie)=>{(0,m.$B)(()=>{if(Q)return;const ee=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$gh=(ce,ie,Q)=>{const ee=ce.requestIdleCallback(ie,typeof Q=="number"?{timeout:Q}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ce.cancelIdleCallback(ee))}}},e.$fh=ce=>(0,e.$gh)(globalThis,ce)}();class ae{constructor(ie,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$gh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=ae;class ge extends ae{constructor(ie){super(globalThis,ie)}}e.$ih=ge;async function ve(ce,ie,Q){let ee;for(let $e=0;$e<Q;$e++)try{return await ce()}catch(be){ee=be,await b(ie)}throw ee}e.$jh=ve;class De{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,Q,ee){return this.a={taskId:ie,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(ie),()=>this.d(ie)),Q}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let Q,ee;const $e=new Promise((be,Le)=>{Q=be,ee=Le});this.b={run:ie,promise:$e,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=De;class de{constructor(ie,Q=()=>Date.now()){this.d=ie,this.f=Q,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$lh=de;var he;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,Q)=>{this.a=ie,this.b=Q})}complete(ie){return new Promise(Q=>{this.a(ie),this.d={outcome:0,value:ie},Q()})}error(ie){return new Promise(Q=>{this.b(ie),this.d={outcome:1,value:ie},Q()})}cancel(){return this.error(new T.$5)}}e.$mh=te;var Se;(function(ce){async function ie(ee){let $e;const be=await Promise.all(ee.map(Le=>Le.then(le=>le,le=>{$e||($e=le)})));if(typeof $e<"u")throw $e;return be}ce.settled=ie;function Q(ee){return new Promise(async($e,be)=>{try{await ee($e,be)}catch(Le){be(Le)}})}ce.withAsyncBody=Q})(Se||(e.Promises=Se={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=oe;class X{constructor(ie){this.b=ie,this.a=new w.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=X;var V;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(ie){return new ne(Q=>{Q.emitMany(ie)})}static fromPromise(ie){return new ne(async Q=>{Q.emitMany(await ie)})}static fromPromises(ie){return new ne(async Q=>{await Promise.all(ie.map(async ee=>Q.emitOne(await ee)))})}static merge(ie){return new ne(async Q=>{await Promise.all(ie.map(async ee=>{for await(const $e of ee)Q.emitOne($e)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(ie(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,Q){return new ne(async ee=>{for await(const $e of ie)ee.emitOne(Q($e))})}map(ie){return ne.map(this,ie)}static filter(ie,Q){return new ne(async ee=>{for await(const $e of ie)Q($e)&&ee.emitOne($e)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const Q=[];for await(const ee of ie)Q.push(ee);return Q}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$ph=ne;class Ie extends ne{constructor(ie,Q){super(Q),this.l=ie}cancel(){this.l.cancel()}}e.$qh=Ie;function Me(ce){const ie=new E.$3d,Q=ce(ie.token);return new Ie(ie,async ee=>{const $e=ie.token.onCancellationRequested(()=>{$e.dispose(),ie.dispose(),ee.reject(new T.$5)});try{for await(const be of Q){if(ie.token.isCancellationRequested)return;ee.emitOne(be)}$e.dispose(),ie.dispose()}catch(be){$e.dispose(),ie.dispose(),ee.reject(be)}})}e.$rh=Me;class Ce{constructor(){this.a=new te,this.b=new ne(ee=>{if(ie){ee.reject(ie);return}return Q&&ee.emitMany(Q),this.d=$e=>ee.reject($e),this.f=$e=>ee.emitOne($e),this.a.p});let ie,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{ie||(ie=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$sh=Ce}),define(Pe[34],Ae([1,0,18,14,46,28,19,21,12]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function w(){return Object.create(null)}e.$Dj=w,e.$Ej="**",e.$Fj="/";const R="[/\\\\]",S="[^/\\\\]",l=/\//g;function $(ge,ve){switch(ge){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ve?`|${R}${S}+`:""})*?`}}function v(ge,ve){if(!ge)return[];const De=[];let de=!1,he=!1,te="";for(const Se of ge){switch(Se){case ve:if(!de&&!he){De.push(te),te="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":he=!0;break;case"]":he=!1;break}te+=Se}return te&&De.push(te),De}e.$Gj=v;function n(ge){if(!ge)return"";let ve="";const De=v(ge,e.$Fj);if(De.every(de=>de===e.$Ej))ve=".*";else{let de=!1;De.forEach((he,te)=>{if(he===e.$Ej){if(de)return;ve+=$(2,te===De.length-1)}else{let Se=!1,oe="",X=!1,V="";for(const ne of he){if(ne!=="}"&&Se){oe+=ne;continue}if(X&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Fj?Ie="":Ie=(0,g.$Ke)(ne),V+=Ie;continue}switch(ne){case"{":Se=!0;continue;case"[":X=!0;continue;case"}":{const Me=`(?:${v(oe,",").map(Ce=>n(Ce)).join("|")})`;ve+=Me,Se=!1,oe="";break}case"]":{ve+="["+V+"]",X=!1,V="";break}case"?":ve+=S;continue;case"*":ve+=$(1);continue;default:ve+=(0,g.$Ke)(ne)}}te<De.length-1&&(De[te+1]!==e.$Ej||te+2<De.length)&&(ve+=R)}de=he===e.$Ej})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(ge,ve){if(!ge)return u;let De;typeof ge!="string"?De=ge.pattern:De=ge,De=De.trim();const de=`${De}_${!!ve.trimForExclusions}`;let he=i.get(de);if(he)return b(he,ge);let te;return o.test(De)?he=D(De.substr(4),De):(te=t.exec(f(De,ve)))?he=F(te[1],De):(ve.trimForExclusions?a:r).test(De)?he=p(De,ve):(te=c.exec(f(De,ve)))?he=y(te[1].substr(1),De,!0):(te=h.exec(f(De,ve)))?he=y(te[1],De,!1):he=k(De),i.set(de,he),b(he,ge)}function b(ge,ve){if(typeof ve=="string")return ge;const De=function(de,he){return(0,I.$4f)(de,ve.base,!m.$k)?ge((0,g.$Pe)(de.substr(ve.base.length),A.sep),he):null};return De.allBasenames=ge.allBasenames,De.allPaths=ge.allPaths,De.basenames=ge.basenames,De.patterns=ge.patterns,De}function f(ge,ve){return ve.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function D(ge,ve){return function(De,de){return typeof De=="string"&&De.endsWith(ge)?ve:null}}function F(ge,ve){const De=`/${ge}`,de=`\\${ge}`,he=function(Se,oe){return typeof Se!="string"?null:oe?oe===ge?ve:null:Se===ge||Se.endsWith(De)||Se.endsWith(de)?ve:null},te=[ge];return he.basenames=te,he.patterns=[ve],he.allBasenames=te,he}function p(ge,ve){const De=Y(ge.slice(1,-1).split(",").map(oe=>d(oe,ve)).filter(oe=>oe!==u),ge),de=De.length;if(!de)return u;if(de===1)return De[0];const he=function(oe,X){for(let V=0,ne=De.length;V<ne;V++)if(De[V](oe,X))return ge;return null},te=De.find(oe=>!!oe.allBasenames);te&&(he.allBasenames=te.allBasenames);const Se=De.reduce((oe,X)=>X.allPaths?oe.concat(X.allPaths):oe,[]);return Se.length&&(he.allPaths=Se),he}function y(ge,ve,De){const de=A.sep===A.$gc.sep,he=de?ge:ge.replace(l,A.sep),te=A.sep+he,Se=A.$gc.sep+ge;let oe;return De?oe=function(X,V){return typeof X=="string"&&(X===he||X.endsWith(te)||!de&&(X===ge||X.endsWith(Se)))?ve:null}:oe=function(X,V){return typeof X=="string"&&(X===he||!de&&X===ge)?ve:null},oe.allPaths=[(De?"*/":"./")+ge],oe}function k(ge){try{const ve=new RegExp(`^${n(ge)}$`);return function(De){return ve.lastIndex=0,typeof De=="string"&&ve.test(De)?ge:null}}catch{return u}}function O(ge,ve,De){return!ge||typeof ve!="string"?!1:K(ge)(ve,void 0,De)}e.$Hj=O;function K(ge,ve={}){if(!ge)return s;if(typeof ge=="string"||U(ge)){const De=d(ge,ve);if(De===u)return s;const de=function(he,te){return!!De(he,te)};return De.allBasenames&&(de.allBasenames=De.allBasenames),De.allPaths&&(de.allPaths=De.allPaths),de}return C(ge,ve)}e.$Ij=K;function U(ge){const ve=ge;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}e.$Jj=U;function L(ge){return ge.allBasenames||[]}e.$Kj=L;function z(ge){return ge.allPaths||[]}e.$Lj=z;function C(ge,ve){const De=Y(Object.getOwnPropertyNames(ge).map(oe=>P(oe,ge[oe],ve)).filter(oe=>oe!==u)),de=De.length;if(!de)return u;if(!De.some(oe=>!!oe.requiresSiblings)){if(de===1)return De[0];const oe=function(ne,Ie){let Me;for(let Ce=0,ce=De.length;Ce<ce;Ce++){const ie=De[Ce](ne,Ie);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(Me||(Me=[]),Me.push(ie))}return Me?(async()=>{for(const Ce of Me){const ce=await Ce;if(typeof ce=="string")return ce}return null})():null},X=De.find(ne=>!!ne.allBasenames);X&&(oe.allBasenames=X.allBasenames);const V=De.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(oe.allPaths=V),oe}const he=function(oe,X,V){let ne,Ie;for(let Me=0,Ce=De.length;Me<Ce;Me++){const ce=De[Me];ce.requiresSiblings&&V&&(X||(X=(0,A.$nc)(oe)),ne||(ne=X.substr(0,X.length-(0,A.$oc)(oe).length)));const ie=ce(oe,X,ne,V);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Me of Ie){const Ce=await Me;if(typeof Ce=="string")return Ce}return null})():null},te=De.find(oe=>!!oe.allBasenames);te&&(he.allBasenames=te.allBasenames);const Se=De.reduce((oe,X)=>X.allPaths?oe.concat(X.allPaths):oe,[]);return Se.length&&(he.allPaths=Se),he}function P(ge,ve,De){if(ve===!1)return u;const de=d(ge,De);if(de===u)return u;if(typeof ve=="boolean")return de;if(ve){const he=ve.when;if(typeof he=="string"){const te=(Se,oe,X,V)=>{if(!V||!de(Se,oe))return null;const ne=he.replace("$(basename)",()=>X),Ie=V(ne);return(0,T.$Og)(Ie)?Ie.then(Me=>Me?ge:null):Ie?ge:null};return te.requiresSiblings=!0,te}}return de}function Y(ge,ve){const De=ge.filter(oe=>!!oe.basenames);if(De.length<2)return ge;const de=De.reduce((oe,X)=>{const V=X.basenames;return V?oe.concat(V):oe},[]);let he;if(ve){he=[];for(let oe=0,X=de.length;oe<X;oe++)he.push(ve)}else he=De.reduce((oe,X)=>{const V=X.patterns;return V?oe.concat(V):oe},[]);const te=function(oe,X){if(typeof oe!="string")return null;if(!X){let ne;for(ne=oe.length;ne>0;ne--){const Ie=oe.charCodeAt(ne-1);if(Ie===47||Ie===92)break}X=oe.substr(ne)}const V=de.indexOf(X);return V!==-1?he[V]:null};te.basenames=de,te.patterns=he,te.allBasenames=de;const Se=ge.filter(oe=>!oe.basenames);return Se.push(te),Se}function ae(ge,ve){return(0,E.$ub)(ge,ve,(De,de)=>typeof De=="string"&&typeof de=="string"?De===de:typeof De!="string"&&typeof de!="string"?De.base===de.base&&De.pattern===de.pattern:!1)}e.$Mj=ae}),define(Pe[52],Ae([1,0,11,126,25,12,2]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(t="",r=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(t,r=0){return this.value+=l(this.supportThemeIcons?(0,T.$0j)(t):t).replace(/([ \t]+)/g,(a,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,r){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(t,r,a){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(t),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(t,r){const a=new RegExp((0,M.$Ke)(r),"g");return t.replace(a,(c,h)=>t.charAt(h-1)!=="\\"?`\\${c}`:c)}}e.$dk=g;function w(o){return R(o)?!o.value:Array.isArray(o)?o.every(w):!0}e.$ek=w;function R(o){return o instanceof g?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$fk=R;function S(o,t){return o===t?!0:!o||!t?!1:o.value===t.value&&o.isTrusted===t.isTrusted&&o.supportThemeIcons===t.supportThemeIcons&&o.supportHtml===t.supportHtml&&(o.baseUri===t.baseUri||!!o.baseUri&&!!t.baseUri&&(0,I.$wg)(A.URI.from(o.baseUri),A.URI.from(t.baseUri)))}e.$gk=S;function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=l;function $(o){return o.replace(/"/g,"&quot;")}e.$ik=$;function v(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=v;function n(o){const t=[],r=o.split("|").map(c=>c.trim());o=r[0];const a=r[1];if(a){const c=/height=(\d+)/.exec(a),h=/width=(\d+)/.exec(a),i=c?c[1]:"",s=h?h[1]:"",u=isFinite(parseInt(s)),d=isFinite(parseInt(i));u&&t.push(`width="${s}"`),d&&t.push(`height="${i}"`)}return{href:o,dimensions:t}}e.$kk=n}),define(Pe[95],Ae([1,0,18,46,19,21,25,12]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=void 0;function g(d,b){const{os:f,tildify:D,relative:F}=b;if(F){const k=w(d,F,f);if(typeof k=="string")return k}let p=d.fsPath;if(f===1&&!M.$i?p=p.replace(/\//g,"\\"):f!==1&&M.$i&&(p=p.replace(/\\/g,"/")),f!==1&&D?.userHome){const k=D.userHome.fsPath;let O;d.scheme!==D.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?O=D.userHome.with({path:d.path}).fsPath:O=p,p=l(O,k,f)}return(f===1?I.$fc:I.$gc).normalize(R(p,f===1))}e.$Gv=g;function w(d,b,f){const D=f===1?I.$fc:I.$gc,F=f===3?A.$tg:A.$vg,p=b.getWorkspace(),y=(0,E.$Ob)(p.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const k=b.getWorkspaceFolder(d);if(!k)return;let O;if(F.isEqual(k.uri,d)?O="":O=F.relativePath(k.uri,d)??"",O&&(O=D.normalize(O)),p.folders.length>1&&!b.noPrefix){const K=k.name?k.name:F.basenameOrAuthority(k.uri);O=O?`${K} \u2022 ${O}`:K}return O}function R(d,b=M.$i){return(0,T.$8f)(d,b)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Hv=R;let S=Object.create(null);function l(d,b,f=M.OS){if(f===1||!d||!b)return d;let D=S.original===b?S.normalized:void 0;D||(D=b,M.$i&&(D=(0,T.$Xf)(D)),D=`${(0,m.$Qe)(D,I.$gc.sep)}${I.$gc.sep}`,S={original:b,normalized:D});let F=d;return M.$i&&(F=(0,T.$Xf)(F)),(f===3?F.startsWith(D):(0,m.$9e)(F,D))?`~/${F.substr(D.length)}`:d}e.$Iv=l;function $(d,b){return d.replace(/^~($|\/|\\)/,`${b}$1`)}e.$Jv=$;const v="\u2026",n="\\\\",o="~";function t(d,b=I.sep){const f=new Array(d.length);let D=!1;for(let F=0;F<d.length;F++){const p=d[F];if(p===""){f[F]=`.${b}`;continue}if(!p){f[F]=p;continue}D=!0;let y="",k=p;k.indexOf(n)===0?(y=k.substr(0,k.indexOf(n)+n.length),k=k.substr(k.indexOf(n)+n.length)):k.indexOf(b)===0?(y=k.substr(0,k.indexOf(b)+b.length),k=k.substr(k.indexOf(b)+b.length)):k.indexOf(o)===0&&(y=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length));const O=k.split(b);for(let K=1;D&&K<=O.length;K++)for(let U=O.length-K;D&&U>=0;U--){D=!1;let L=O.slice(U,U+K).join(b);for(let z=0;!D&&z<d.length;z++)if(z!==F&&d[z]&&d[z].indexOf(L)>-1){const C=U+K===O.length,P=U>0&&d[z].indexOf(b)>-1?b+L:L,Y=d[z].endsWith(P);D=!C||Y}if(!D){let z="";(O[0].endsWith(":")||y!=="")&&(U===1&&(U=0,K++,L=O[0]+b+L),U>0&&(z=O[0]+b),z=y+z),U>0&&(z=z+v+b),z=z+L,U+K<O.length&&(z=z+b+v),f[F]=z}}D&&(f[F]=p)}return f}e.$Kv=t;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function a(d,b=Object.create(null)){const f=[];let D=!1,F="";for(const p of d)if(p==="$"||D&&p==="{")F&&f.push({value:F,type:r.TEXT}),F="",D=!0;else if(p==="}"&&D){const y=b[F];if(typeof y=="string")y.length&&f.push({value:y,type:r.VARIABLE});else if(y){const k=f[f.length-1];(!k||k.type!==r.SEPARATOR)&&f.push({value:y.label,type:r.SEPARATOR})}F="",D=!1}else F+=p;return F&&!D&&f.push({value:F,type:r.TEXT}),f.filter((p,y)=>{if(p.type===r.SEPARATOR){const k=f[y-1],O=f[y+1];return[k,O].every(K=>K&&(K.type===r.VARIABLE||K.type===r.TEXT)&&K.value.length>0)}return!0}).map(p=>p.value).join("")}e.$Lv=a;function c(d,b){return M.$j||b?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Mv=c;function h(d,b){return M.$j||b?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Nv=h;function i(d){return d.replace(/&/g,"&&")}e.$Ov=i;function s(d){if(d.endsWith("]")){const b=d.lastIndexOf(" [",d.length-2);if(b!==-1){const f=u(d.substring(0,b));return{name:f.name,parentPath:f.parentPath+d.substring(b)}}}return u(d)}e.$Pv=s;function u(d){const b=d.indexOf("/")!==-1?I.$gc:I.$fc,f=b.basename(d),D=b.dirname(d);return f.length?{name:f,parentPath:D}:{name:D,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function I(S){return S.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:I(T.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:I(T.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:T.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Ym=M,e.$Zm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,l,$){if(!S||$>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const v in S)if(Object.hasOwnProperty.call(S,v)){const n=A(S[v],l,$+1);n!==null&&(S[v]=n)}}return null}function m(S,l){const $=A(S,l,0);return $===null?S:$}e.$1m=m;function g(S,l,$,v){if(!S||v>200)return null;if(typeof S=="object"){if(S.$mid===1)return $?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$ge)return null;for(const n in S)if(Object.hasOwnProperty.call(S,n)){const o=g(S[n],l,$,v+1);o!==null&&(S[n]=o)}}return null}function w(S,l){const $=g(S,l,!1,0);return $===null?S:$}e.$2m=w;function R(S,l){const $=g(S,l,!0,0);return $===null?S:$}e.$3m=R}),define(Pe[140],Ae([1,0,12,21,24]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.$Ys=void 0;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function R(){return w||(w=T.$D()?A():g()),w}e.$Ys=R;function S(v,n,o){const t=new Uint16Array(v.buffer,n,o);return o>0&&(t[0]===65279||t[0]===65534)?l(v,n,o):A().decode(t)}e.$Zs=S;function l(v,n,o){const t=[];let r=0;for(let a=0;a<o;a++){const c=I.$ie(v,n);n+=2,t[r++]=String.fromCharCode(c)}return t.join("")}class ${constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return R().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||E.$_e(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let t=0;t<o;t++)this.b[this.d++]=n.charCodeAt(t)}}e.$1s=$}),define(Pe[141],Ae([1,0,24,140]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,R,S,l){this.oldPosition=w,this.oldText=R,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,R,S){const l=R.length;E.$le(w,l,S),S+=4;for(let $=0;$<l;$++)E.$je(w,R.charCodeAt($),S),S+=2;return S}static d(w,R){const S=E.$ke(w,R);return R+=4,(0,T.$Zs)(w,R,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(w,R){return E.$le(w,this.oldPosition,R),R+=4,E.$le(w,this.newPosition,R),R+=4,R=M.c(w,this.oldText,R),R=M.c(w,this.newText,R),R}static read(w,R,S){const l=E.$ke(w,R);R+=4;const $=E.$ke(w,R);R+=4;const v=M.d(w,R);R+=M.a(v);const n=M.d(w,R);return R+=M.a(n),S.push(new M(l,v,$,n)),R}}e.$2s=M;function A(g,w){return g===null||g.length===0?w:new m(g,w).compress()}e.$3s=A;class m{constructor(w,R){this.a=w,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,R=0,S=this.n(w),l=this.l(R);for(;w<this.f||R<this.h;){if(S===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(S),S=this.n(++w);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++R);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++w);continue}if(l.oldPosition<S.newPosition){const[t,r]=m.r(l,S.newPosition-l.oldPosition);this.k(t),l=r;continue}if(S.newPosition<l.oldPosition){const[t,r]=m.q(S,l.oldPosition-S.newPosition);this.m(t),S=r;continue}let n,o;if(l.oldEnd===S.newEnd)n=S,o=l,S=this.n(++w),l=this.l(++R);else if(l.oldEnd<S.newEnd){const[t,r]=m.q(S,l.oldLength);n=t,o=l,S=r,l=this.l(++R)}else{const[t,r]=m.r(l,S.newLength);n=S,o=t,S=this.n(++w),l=r}this.d[this.e++]=new M(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const $=m.s(this.d);return m.t($)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,R){return new M(R.oldPosition-w,R.oldText,R.newPosition,R.newText)}static p(w,R){return new M(R.oldPosition,R.oldText,R.newPosition+w,R.newText)}static q(w,R){const S=w.newText.substr(0,R),l=w.newText.substr(R);return[new M(w.oldPosition,w.oldText,w.newPosition,S),new M(w.oldEnd,"",w.newPosition+R,l)]}static r(w,R){const S=w.oldText.substr(0,R),l=w.oldText.substr(R);return[new M(w.oldPosition,S,w.newPosition,w.newText),new M(w.oldPosition+R,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const R=[];let S=0,l=w[0];for(let $=1;$<w.length;$++){const v=w[$];l.oldEnd===v.oldPosition?l=new M(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(R[S++]=l,l=v)}return R[S++]=l,R}static t(w){if(w.length===0)return w;const R=[];let S=0;for(let l=0;l<w.length;l++){const $=w[l];$.oldText!==$.newText&&(R[S++]=$)}return R}}}),define(Pe[142],Ae([1,0,34,19]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=void 0;function I(M,A,m,g,w,R){if(Array.isArray(M)){let S=0;for(const l of M){const $=I(l,A,m,g,w,R);if($===10)return $;$>S&&(S=$)}return S}else{if(typeof M=="string")return g?M==="*"?5:M===m?10:0:0;if(M){const{language:S,pattern:l,scheme:$,hasAccessToAllModels:v,notebookType:n}=M;if(!g&&!v)return 0;n&&w&&(A=w);let o=0;if($)if($===A.scheme)o=10;else if($==="*")o=5;else return 0;if(S)if(S===m)o=10;else if(S==="*")o=Math.max(o,5);else return 0;if(n)if(n===R)o=10;else if(n==="*"&&R!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===A.fsPath||(0,E.$Hj)(t,A.fsPath))o=10;else return 0}return o}else return 0}}e.$nt=I}),define(Pe[143],Ae([1,0,5,12,29,93,91,128,141,6]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=void 0;class R extends w.$Sc{constructor(l,$,v,n,o,t,r){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!t,this.g=n,this.h=o,this.c=new A.$UB(l,v,r)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const v=l+$,n=this.getPositionAt(l),o=this.getPositionAt(v);return new I.$Gs(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const v=this.n($);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),n=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n($),r=this.getEOL();if(t.length!==r.length){const a=t.length-r.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return n-v+o}getCharacterCountInRange(l,$=0){if(this.j){let v=0;const n=l.startLineNumber,o=l.endLineNumber;for(let t=n;t<=o;t++){const r=this.getLineContent(t),a=t===n?l.startColumn-1:0,c=t===o?l.endColumn-1:r.length;for(let h=a;h<c;h++)T.$_e(r.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n($).length*(o-n),v}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=T.$We(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=T.$Ye(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,v){let n=this.g,o=this.h,t=this.j,r=!0,a=[];for(let b=0;b<l.length;b++){const f=l[b];r&&f._isTracked&&(r=!1);const D=f.range;if(f.text){let O=!0;t||(O=!T.$kf(f.text),t=O),!n&&O&&(n=T.$jf(f.text)),!o&&O&&(o=T.$mf(f.text))}let F="",p=0,y=0,k=0;if(f.text){let O;[p,y,k,O]=(0,m.$gt)(f.text);const K=this.getEOL();O===0||O===(K===`\r
`?2:1)?F=f.text:F=f.text.replace(/\r\n|\r|\n/g,K)}a[b]={sortIndex:b,identifier:f.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:F,eolCount:p,firstLineLength:y,lastLineLength:k,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(R.u);let c=!1;for(let b=0,f=a.length-1;b<f;b++){const D=a[b].range.getEndPosition(),F=a[b+1].range.getStartPosition();if(F.isBeforeOrEqual(D)){if(F.isBefore(D))throw new Error("Overlapping ranges are not allowed!");c=!0}}r&&(a=this.s(a));const h=v||$?R._getInverseEditRanges(a):[],i=[];if($)for(let b=0;b<a.length;b++){const f=a[b],D=h[b];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let F=D.startLineNumber;F<=D.endLineNumber;F++){let p="";F===D.startLineNumber&&(p=this.getLineContent(f.range.startLineNumber),T.$We(p)!==-1)||i.push({lineNumber:F,oldContent:p})}}let s=null;if(v){let b=0;s=[];for(let f=0;f<a.length;f++){const D=a[f],F=h[f],p=this.getValueInRange(D.range),y=D.rangeOffset+b;b+=D.text.length-p.length,s[f]={sortIndex:D.sortIndex,identifier:D.identifier,range:F,text:p,textChange:new g.$2s(D.rangeOffset,p,y,D.text)}}c||s.sort((f,D)=>f.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=t;const u=this.t(a);let d=null;if($&&i.length>0){i.sort((b,f)=>f.lineNumber-b.lineNumber),d=[];for(let b=0,f=i.length;b<f;b++){const D=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===D)continue;const F=i[b].oldContent,p=this.getLineContent(D);p.length===0||p===F||T.$We(p)!==-1||d.push(D)}}return this.m.fire(),new M.$3u(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const v=l[0].range,n=l[l.length-1].range,o=new I.$Gs(v.startLineNumber,v.startColumn,n.endLineNumber,n.endColumn);let t=v.startLineNumber,r=v.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const b=l[u],f=b.range;$=$||b.forceMoveMarkers,a.push(this.getValueInRange(new I.$Gs(t,r,f.startLineNumber,f.startColumn))),b.text.length>0&&a.push(b.text),t=f.endLineNumber,r=f.endColumn}const c=a.join(""),[h,i,s]=(0,m.$gt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const $=[];for(let v=0;v<l.length;v++){const n=l[v],o=n.range.startLineNumber,t=n.range.startColumn,r=n.range.endLineNumber,a=n.range.endColumn;if(o===r&&t===a&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const c=new I.$Gs(o,t,r,a);$.push({range:c,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,v,n){return this.c.findMatchesLineByLine(l,$,v,n)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const v=l.startLineNumber,n=l.startColumn,[o,t,r]=(0,m.$gt)($);let a;if($.length>0){const c=o+1;c===1?a=new I.$Gs(v,n,v,n+t):a=new I.$Gs(v,n,v+c-1,r+1)}else a=new I.$Gs(v,n,v,n);return a}static _getInverseEditRanges(l){const $=[];let v=0,n=0,o=null;for(let t=0,r=l.length;t<r;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=v,h=n+(a.range.startColumn-o.range.endColumn)):(c=v+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new I.$Gs(c,h,c,h+a.firstLineLength):i=new I.$Gs(c,h,c+s-1,a.lastLineLength+1)}else i=new I.$Gs(c,h,c,h);v=i.endLineNumber,n=i.endColumn,$.push(i),o=a}return $}static u(l,$){const v=I.$Gs.compareRangesUsingEnds(l.range,$.range);return v===0?l.sortIndex-$.sortIndex:v}static w(l,$){const v=I.$Gs.compareRangesUsingEnds(l.range,$.range);return v===0?$.sortIndex-l.sortIndex:-v}}e.$VB=R}),define(Pe[144],Ae([1,0,12,91,143]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class M{constructor(g,w,R,S,l,$,v,n,o){this.a=g,this.b=w,this.c=R,this.d=S,this.e=l,this.f=$,this.g=v,this.h=n,this.j=o}k(g){const w=this.c+this.d+this.e,R=this.c+this.e;return w===0?g===1?`
`:`\r
`:R>w/2?`\r
`:`
`}create(g){const w=this.k(g),R=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,$=R.length;l<$;l++){const v=R[l].buffer.replace(/\r\n|\r|\n/g,w),n=(0,T.$QB)(v);R[l]=new T.$TB(v,n)}const S=new I.$VB(R,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$sf(g)&&(this.b=E.$rf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$RB)(this.e,g);this.a.push(new T.$TB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$jf(g)),this.k||(this.k=E.$mf(g)))}finish(g=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$QB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$WB=A}),define(Pe[96],Ae([1,0,24,21]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$=e.$g$=void 0;var I;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(I||(I={}));function M(S){for(let l=0,$=S.length;l<$;l+=4){const v=S[l+0],n=S[l+1],o=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=o,S[l+2]=n,S[l+3]=v}}function A(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||M(l),E.$ge.wrap(l)}function m(S){const l=S.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function g(S){const l=new Uint32Array(w(S));let $=0;if(l[$++]=S.id,S.type==="full")l[$++]=1,l[$++]=S.data.length,l.set(S.data,$),$+=S.data.length;else{l[$++]=2,l[$++]=S.deltas.length;for(const v of S.deltas)l[$++]=v.start,l[$++]=v.deleteCount,v.data?(l[$++]=v.data.length,l.set(v.data,$),$+=v.data.length):l[$++]=0}return A(l)}e.$g$=g;function w(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const $ of S.deltas)$.data&&(l+=$.data.length)}return l}function R(S){const l=m(S);let $=0;const v=l[$++];if(l[$++]===1){const r=l[$++],a=l.subarray($,$+r);return $+=r,{id:v,type:"full",data:a}}const o=l[$++],t=[];for(let r=0;r<o;r++){const a=l[$++],c=l[$++],h=l[$++];let i;h>0&&(i=l.subarray($,$+h),$+=h),t[r]={start:a,deleteCount:c,data:i}}return{id:v,type:"delta",deltas:t}}e.$h$=R}),define(Pe[145],Ae([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,129,147,145]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(x,pe,Ue,Qe){this.id=x,this.name=pe,this.defaultValue=Ue,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}compute(x,pe,Ue){return Ue}}class l{constructor(x,pe){this.newValue=x,this.didChange=pe}}e.ApplyUpdateResult=l;function $(Z,x){if(typeof Z!="object"||typeof x!="object"||!Z||!x)return new l(x,Z!==x);if(Array.isArray(Z)||Array.isArray(x)){const Ue=Array.isArray(Z)&&Array.isArray(x)&&E.$ub(Z,x);return new l(x,!Ue)}let pe=!1;for(const Ue in x)if(x.hasOwnProperty(Ue)){const Qe=$(Z[Ue],x[Ue]);Qe.didChange&&(Z[Ue]=Qe.newValue,pe=!0)}return new l(Z,pe)}class v{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,pe){return $(x,pe)}validate(x){return this.defaultValue}}class n{constructor(x,pe,Ue,Qe){this.id=x,this.name=pe,this.defaultValue=Ue,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,pe,Ue){return Ue}}function o(Z,x){return typeof Z>"u"?x:Z==="false"?!1:!!Z}e.boolean=o;class t extends n{constructor(x,pe,Ue,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ue),super(x,pe,Ue,Qe)}validate(x){return o(x,this.defaultValue)}}function r(Z,x,pe,Ue){if(typeof Z>"u")return x;let Qe=parseInt(Z,10);return isNaN(Qe)?x:(Qe=Math.max(pe,Qe),Qe=Math.min(Ue,Qe),Qe|0)}e.clampedInt=r;class a extends n{static clampedInt(x,pe,Ue,Qe){return r(x,pe,Ue,Qe)}constructor(x,pe,Ue,Qe,tt,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ue,nt.minimum=Qe,nt.maximum=tt),super(x,pe,Ue,nt),this.minimum=Qe,this.maximum=tt}validate(x){return a.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function c(Z,x,pe,Ue){if(typeof Z>"u")return x;const Qe=h.float(Z,x);return h.clamp(Qe,pe,Ue)}e.clampedFloat=c;class h extends n{static clamp(x,pe,Ue){return x<pe?pe:x>Ue?Ue:x}static float(x,pe){if(typeof x=="number")return x;if(typeof x>"u")return pe;const Ue=parseFloat(x);return isNaN(Ue)?pe:Ue}constructor(x,pe,Ue,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Ue),super(x,pe,Ue,tt),this.validationFn=Qe}validate(x){return this.validationFn(h.float(x,this.defaultValue))}}class i extends n{static string(x,pe){return typeof x!="string"?pe:x}constructor(x,pe,Ue,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ue),super(x,pe,Ue,Qe)}validate(x){return i.string(x,this.defaultValue)}}function s(Z,x,pe,Ue){return typeof Z!="string"?x:Ue&&Z in Ue?Ue[Z]:pe.indexOf(Z)===-1?x:Z}e.stringSet=s;class u extends n{constructor(x,pe,Ue,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Ue),super(x,pe,Ue,tt),this.c=Qe}validate(x){return s(x,this.defaultValue,this.c)}}class d extends S{constructor(x,pe,Ue,Qe,tt,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=tt,Ne.default=Qe),super(x,pe,Ue,Ne),this.c=tt,this.d=nt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function b(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,pe,Ue){return Ue===0?x.accessibilitySupport:Ue}}class D extends S{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var F;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(F||(e.TextEditorCursorBlinkingStyle=F={}));function p(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function k(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function O(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class K extends v{constructor(){super(140)}compute(x,pe,Ue){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),x.extraEditorClassName&&Qe.push(x.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class U extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,pe,Ue){return Ue&&x.emptySelectionClipboard}}class L extends S{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class z extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?z.OFF:x==="true"?z.ON:x:x?z.ON:z.OFF}}e.EditorFontLigatures=z;class C extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?C.OFF:x==="true"?C.TRANSLATE:x:x?C.TRANSLATE:C.OFF}compute(x,pe,Ue){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class P extends v{constructor(){super(50)}compute(x,pe,Ue){return x.fontInfo}}class Y extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const pe=h.float(x,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(x,pe,Ue){return x.fontInfo.fontSize}}class ae extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.d,maximum:ae.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(a.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.d,ae.e))}}class ge extends S{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ue,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ue,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ue,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ue,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ue,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends S{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:a.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var De;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class de extends v{constructor(){super(143)}compute(x,pe,Ue){return de.computeLayout(pe,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const pe=x.height/x.lineHeight,Ue=Math.floor(x.paddingTop/x.lineHeight);let Qe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const tt=(Ue+x.viewLineCount+Qe)/(x.pixelRatio*x.height),nt=Math.floor(x.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:nt}}static c(x,pe){const Ue=x.outerWidth,Qe=x.outerHeight,tt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const nt=pe.stableMinimapLayoutInput,Ne=nt&&x.outerHeight===nt.outerHeight&&x.lineHeight===nt.lineHeight&&x.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&x.pixelRatio===nt.pixelRatio&&x.scrollBeyondLastLine===nt.scrollBeyondLastLine&&x.paddingTop===nt.paddingTop&&x.paddingBottom===nt.paddingBottom&&x.minimap.enabled===nt.minimap.enabled&&x.minimap.side===nt.minimap.side&&x.minimap.size===nt.minimap.size&&x.minimap.showSlider===nt.minimap.showSlider&&x.minimap.renderCharacters===nt.minimap.renderCharacters&&x.minimap.maxColumn===nt.minimap.maxColumn&&x.minimap.scale===nt.minimap.scale&&x.verticalScrollbarWidth===nt.verticalScrollbarWidth&&x.isViewportWrapping===nt.isViewportWrapping,It=x.lineHeight,Lt=x.typicalHalfwidthCharacterWidth,Kt=x.scrollBeyondLastLine,Bt=x.minimap.renderCharacters;let wt=tt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const qt=x.minimap.maxColumn,Ft=x.minimap.size,Qt=x.minimap.side,Ot=x.verticalScrollbarWidth,Ct=x.viewLineCount,Xe=x.remainingWidth,Ht=x.isViewportWrapping,Gt=Bt?2:3;let ut=Math.floor(tt*Qe);const mt=ut/tt;let jt=!1,Ut=!1,Et=Gt*wt,ht=wt/tt,Pt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Ee,desiredRatio:Fe,minimapLineCount:fe}=de.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Kt,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Qe,lineHeight:It,pixelRatio:tt});if(Ct/fe>1)jt=!0,Ut=!0,wt=1,Et=1,ht=wt/tt;else{let Re=!1,Be=wt+1;if(Ft==="fit"){const Ze=Math.ceil((Mt+Ct+Ee)*Et);Ht&&Ne&&Xe<=pe.stableFitRemainingWidth?(Re=!0,Be=pe.stableFitMaxMinimapScale):Re=Ze>ut}if(Ft==="fill"||Re){jt=!0;const Ze=wt;Et=Math.min(It*tt,Math.max(1,Math.floor(1/Fe))),Ht&&Ne&&Xe<=pe.stableFitRemainingWidth&&(Be=pe.stableFitMaxMinimapScale),wt=Math.min(Be,Math.max(1,Math.floor(Et/Gt))),wt>Ze&&(Pt=Math.min(2,wt/Ze)),ht=wt/tt/Pt,ut=Math.ceil(Math.max(ft,Mt+Ct+Ee)*Et),Ht?(pe.stableMinimapLayoutInput=x,pe.stableFitRemainingWidth=Xe,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Xt=Math.floor(qt*ht),kt=Math.min(Xt,Math.max(0,Math.floor((Xe-Ot-2)*ht/(Lt+ht)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(tt*kt);const Rt=qe/tt;qe=Math.floor(qe*Pt);const Wt=Bt?1:2,Jt=Qt==="left"?0:Ue-kt-Ot;return{renderMinimap:Wt,minimapLeft:Jt,minimapWidth:kt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Ut,minimapScale:wt,minimapLineHeight:Et,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:mt}}static computeLayout(x,pe){const Ue=pe.outerWidth|0,Qe=pe.outerHeight|0,tt=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,Lt=pe.pixelRatio,Kt=pe.viewLineCount,Bt=x.get(135),wt=Bt==="inherit"?x.get(134):Bt,qt=wt==="inherit"?x.get(130):wt,Ft=x.get(133),Qt=pe.isDominatedByLongLines,Ot=x.get(57),Ct=x.get(67).renderType!==0,Xe=x.get(68),Ht=x.get(104),Gt=x.get(83),ut=x.get(72),mt=x.get(102),jt=mt.verticalScrollbarSize,Ut=mt.verticalHasArrows,Et=mt.arrowSize,ht=mt.horizontalScrollbarSize,Pt=x.get(43),Xt=x.get(109)!=="never";let kt=x.get(65);Pt&&Xt&&(kt+=16);let qe=0;if(Ct){const _e=Math.max(nt,Xe);qe=Math.round(_e*It)}let Rt=0;Ot&&(Rt=tt*pe.glyphMarginDecorationLaneCount);let Wt=0,Jt=Wt+Rt,ft=Jt+qe,Mt=ft+kt;const Ee=Ue-Rt-qe-kt;let Fe=!1,fe=!1,G=-1;wt==="inherit"&&Qt?(Fe=!0,fe=!0):qt==="on"||qt==="bounded"?fe=!0:qt==="wordWrapColumn"&&(G=Ft);const Re=de.c({outerWidth:Ue,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Lt,scrollBeyondLastLine:Ht,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:ut,verticalScrollbarWidth:jt,viewLineCount:Kt,remainingWidth:Ee,isViewportWrapping:fe},pe.memory||new R);Re.renderMinimap!==0&&Re.minimapLeft===0&&(Wt+=Re.minimapWidth,Jt+=Re.minimapWidth,ft+=Re.minimapWidth,Mt+=Re.minimapWidth);const Be=Ee-Re.minimapWidth,Ze=Math.max(1,Math.floor((Be-jt-2)/Ne)),Ve=Ut?Et:0;return fe&&(G=Math.max(1,Ze),qt==="bounded"&&(G=Math.min(G,Ft))),{width:Ue,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Jt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:kt,contentLeft:Mt,contentWidth:Be,minimap:Re,viewportColumn:Ze,isWordWrapMinified:Fe,isViewportWrapping:fe,wrappingColumn:G,verticalScrollbarWidth:jt,horizontalScrollbarHeight:ht,overviewRuler:{top:Ve,width:jt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=de;class he extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return s(x,"simple",["simple","advanced"])}compute(x,pe,Ue){return pe.get(2)===2?"advanced":Ue}}var te;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(te||(e.ShowAiIconMode=te={}));class Se extends S{constructor(){const x={enabled:!0,experimental:{showAiIcon:te.Off}};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"boolean",default:x.enabled,description:m.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[te.Off,te.OnCode,te.On],default:x.experimental.showAiIcon,enumDescriptions:[m.localize(51,null),m.localize(52,null),m.localize(53,null)],description:m.localize(54,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:s(pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[te.Off,te.OnCode,te.On])}}}}class oe extends S{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(58,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends S{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(60,null),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(66,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class V extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):a.clampedInt(x,this.defaultValue,0,1e3)}compute(x,pe,Ue){return Ue<0?a.clampedInt(-Ue*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>h.clamp(x,0,150),{markdownDescription:m.localize(67,null)})}compute(x,pe,Ue){return x.fontInfo.lineHeight}}class Ie extends S{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:x.size,description:m.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(75,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(78,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(pe.scale,1,1,3),maxColumn:a.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(Z){return Z==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(80,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{top:a.clampedInt(pe.top,0,0,1e3),bottom:a.clampedInt(pe.bottom,0,0,1e3)}}}class ce extends S{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(82,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class ie extends v{constructor(){super(141)}compute(x,pe,Ue){return x.pixelRatio}}class Q extends S{constructor(){const x={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(83,null),m.localize(84,null),m.localize(85,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:x.strings,description:m.localize(86,null)},comments:{anyOf:pe,default:x.comments,description:m.localize(87,null)},other:{anyOf:pe,default:x.other,description:m.localize(88,null)}},default:x,markdownDescription:m.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Lt=x?"on":"off";return{comments:Lt,strings:Lt,other:Lt}}if(!x||typeof x!="object")return this.defaultValue;const{other:pe,comments:Ue,strings:Qe}=x,tt=["on","inline","off"];let nt,Ne,It;return typeof pe=="boolean"?nt=pe?"on":"off":nt=s(pe,this.defaultValue.other,tt),typeof Ue=="boolean"?Ne=Ue?"on":"off":Ne=s(Ue,this.defaultValue.comments,tt),typeof Qe=="boolean"?It=Qe?"on":"off":It=s(Qe,this.defaultValue.strings,tt),{other:nt,comments:Ne,strings:It}}}var ee;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class $e extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(90,null),m.localize(91,null),m.localize(92,null),m.localize(93,null)],default:"on",description:m.localize(94,null)})}validate(x){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(pe=4,Ue=x):x==="interval"?pe=3:x==="relative"?pe=2:x==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function be(Z){const x=Z.get(97);return x==="editable"?Z.get(90):x!=="on"}e.filterValidationDecorations=be;class Le extends S{constructor(){const x=[],pe={type:"number",description:m.localize(95,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(96,null),format:"color-hex"}}}]},default:x,description:m.localize(97,null)})}validate(x){if(Array.isArray(x)){const pe=[];for(const Ue of x)if(typeof Ue=="number")pe.push({column:a.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Qe=Ue;pe.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Ue,Qe)=>Ue.column-Qe.column),pe}return this.defaultValue}}class le extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function we(Z,x){if(typeof Z!="string")return x;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends S{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(102,null),m.localize(103,null),m.localize(104,null)],default:"auto",description:m.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(109,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x,Ue=a.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(pe.vertical,this.defaultValue.vertical),horizontal:we(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:a.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends S{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(116,null)}})}applyUpdate(x,pe){let Ue=!1;pe.allowedCharacters&&x&&(T.$ln(x.allowedCharacters,pe.allowedCharacters)||(x={...x,allowedCharacters:pe.allowedCharacters},Ue=!0)),pe.allowedLocales&&x&&(T.$ln(x.allowedLocales,pe.allowedLocales)||(x={...x,allowedLocales:pe.allowedLocales},Ue=!0));const Qe=super.applyUpdate(x,pe);return Ue?new l(Qe.newValue,!0):Qe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,pe){if(typeof x!="object"||!x)return pe;const Ue={};for(const[Qe,tt]of Object.entries(x))tt===!0&&(Ue[Qe]=!0);return Ue}}class H extends S{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(118,null),m.localize(119,null),m.localize(120,null)],description:m.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class B extends S{constructor(){const x={enabled:M.$ds.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$ds.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends S{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:x.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:x.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:x.highlightActiveIndentation,description:m.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Z,x,pe){const Ue=pe.indexOf(Z);return Ue===-1?x:pe[Ue]}class ye extends S{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:x.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:x.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(x.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,pe,Ue){return pe.get(2)===2?0:Ue}}class Ye extends v{constructor(){super(144)}compute(x,pe,Ue){const Qe=pe.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class rt extends S{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends S{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?ot:I.$k?at:et,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var pt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(pt||(e.EditorOption=pt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:ze(new f),accessibilityPageSize:ze(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",m.localize(206,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:ze(new B),bracketPairGuides:ze(new J),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:ze(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:ze(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:ze(new D),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:ze(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:m.localize(248,null)})),cursorSurroundingLines:ze(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:ze(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:ze(new U),dropIntoEditor:ze(new rt),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(259,null)})),find:ze(new L),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:ze(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:ze(new P),fontLigatures2:ze(new z),fontSize:ze(new Y),fontWeight:ze(new ae),fontVariations:ze(new C),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:ze(new ge),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:ze(new ve),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(273,null)})),lightbulb:ze(new Se),lineDecorationsWidth:ze(new V),lineHeight:ze(new ne),lineNumbers:ze(new $e),lineNumbersMinChars:ze(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:ze(new t(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:ze(new Ie),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(278,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:ze(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:ze(new a(82,"overviewRulerLanes",3,0,3)),padding:ze(new Ce),pasteAs:ze(new it),parameterHints:ze(new ce),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:ze(new Q),quickSuggestionsDelay:ze(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new le),renameOnType:ze(new t(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:ze(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:ze(new Le),scrollbar:ze(new N),scrollBeyondLastColumn:ze(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:m.localize(312,null),included:I.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:ze(new X),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:ze(new Te),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:ze(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ye),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:ze(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:ze(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:ze(new i(129,"wordSeparators",A.$es,{description:m.localize(346,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new K),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:ze(new ie),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:ze(new de),wrappingInfo:ze(new Ye),wrappingIndent:ze(new He),wrappingStrategy:ze(new he)}}),define(Pe[148],Ae([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[171],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[172],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[173],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Ae([1,0,11,150]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const S=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:R}),this.f.push($)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const S=this.c.substring(this.d,this.e),l=g.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,S=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const v=this.c.charCodeAt(R);if(S)S=!1;else if(v===47&&!l){R++;break}else v===91?l=!0:v===92?S=!0:v===93&&(l=!1);R++}for(;R<this.c.length&&g.a.has(this.c.charCodeAt(R));)R++;this.e=R;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=g}),define(Pe[182],Ae([1,0,25,31,152,294]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||A.test(t)}e.$Yo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=t.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Zo=w;function R(t){if(!t)return null;const r=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(r===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=m.exec(t.preRelease);if(d){const[,b,f,D]=d;u=Date.UTC(Number(b),Number(f)-1,Number(D))}}return{majorBase:r,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$1o=R;function S(t,r,a){let c;typeof t=="string"?c=R(w(t)):c=t;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let i;if(typeof a=="string"?i=R(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let b=i.majorBase,f=i.minorBase,D=i.patchBase;const F=i.notBefore;let p=i.majorMustEqual,y=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:u>f?!0:u<f||h&&h<F?!1:d>=D:(s===1&&b===0&&(!p||!y||!k)&&(b=1,f=0,D=0,p=!0,y=!1,k=!1),s<b?!1:s>b?!p:u<f?!1:u>f?!y:d<D?!1:d>D?!k:!(h&&h<F))}e.$2o=S;function l(t,r,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([T.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([T.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Dg)(a,c.main);(0,E.$xg)(d,a)||i.push([T.default.Warning,I.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Dg)(a,c.browser);(0,E.$xg)(d,a)||i.push([T.default.Warning,I.localize(12,null,d.path,a.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,I.localize(13,null)]),i;const s=[];if(!$(t,r,c,h,s))for(const d of s)i.push([T.default.Error,d]);return i}e.$3o=l;function $(t,r,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:n(t,r,a.engines.vscode,h)}e.$4o=$;function v(t,r,a){return t==="*"||n(r,a,t)}e.$5o=v;function n(t,r,a,c=[]){const h=R(w(a));if(!h)return c.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,a)),!1;return S(t,r,h)?!0:(c.push(I.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let r=0,a=t.length;r<a;r++)if(typeof t[r]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(I,M=[],A=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Yh=E}),define(Pe[70],Ae([1,0,69]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.InstantiationType=void 0;const T=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M(m,g,w){g instanceof E.$Yh||(g=new E.$Yh(g,[],!!w)),T.push([m,g])}e.$Jr=M;function A(){return T}e.$Kr=A}),define(Pe[183],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;class E{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$oq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const m=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(A);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let m=this.a.get(A);return m||(m=new E(A,M),this.a.set(A,m)),m}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,m]of this.a)M.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const m=new Set([M]),g=this.c(A,m);if(g)return g}}c(M,A){for(const[m,g]of M.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const w=this.c(g,A);if(w)return w;A.delete(m)}}}e.$pq=T}),define(Pe[4],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(E||(e._util=E={})),e.$1h=I("instantiationService");function T(A,m,g){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:A,index:g}):(m[E.DI_DEPENDENCIES]=[{id:A,index:g}],m[E.DI_TARGET]=m)}function I(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const m=function(g,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,g,R)};return m.toString=()=>A,E.serviceIds.set(A,m),m}e.$2h=I;function M(A){return A}e.$3h=M}),define(Pe[41],Ae([1,0,16,2,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,I.$2h)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$wi=M;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$xi=A;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$zi=w;function R(t,r){const a=Object.create(null);for(const c in t)S(a,c,t[c],r);return a}e.$Ai=R;function S(t,r,a,c){const h=r.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let b=s[d];switch(typeof b){case"undefined":b=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Bi=S;function l(t,r){const a=r.split(".");$(t,a)}e.$Ci=l;function $(t,r){const a=r.shift();if(r.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&($(c,r),Object.keys(c).length===0&&delete t[a])}}function v(t,r,a){function c(s,u){let d=s;for(const b of u){if(typeof d!="object"||d===null)return;d=d[b]}return d}const h=r.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Di=v;function n(t,r,a){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in t?E.$Gf(t[c])&&E.$Gf(r[c])?n(t[c],r[c],a):a&&(t[c]=r[c]):t[c]=r[c])})}e.$Ei=n;function o(t){return t.replace(/[\[\]]/g,"")}e.$Fi=o}),define(Pe[35],Ae([1,0,21,12,181,4,149,11]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(X,V){if(g.get(X)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(X,V)}e.$Xi=w;const R=Object.prototype.hasOwnProperty;var S;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},$=(0,A.localize)(0,null),v=(0,A.localize)(1,null),n=(0,A.localize)(2,null),o=(0,A.localize)(3,null),t=(0,A.localize)(4,null),r=(0,A.localize)(5,null),a=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Me=Ie.type===17?r:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Wi.getLexeme(Ie),additionalInfo:Me}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),O.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Me.type!==10)throw this.B("REGEX",Me);const Ce=Me.lexeme,ce=Ce.lastIndexOf("/"),ie=ce===Ce.length-1?void 0:this.w(Ce.substring(ce+1));let Q;try{Q=new RegExp(Ce.substring(1,ce),ie)}catch{throw this.B("REGEX",Me)}return P.create(ne,Q)}switch(Me.type){case 10:case 19:{const Ce=[Me.lexeme];this.z();let ce=this.D(),ie=0;for(let Le=0;Le<Me.lexeme.length;Le++)Me.lexeme.charCodeAt(Le)===40?ie++:Me.lexeme.charCodeAt(Le)===41&&ie--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Le=0;Le<ce.lexeme.length;Le++)ce.lexeme.charCodeAt(Le)===40?ie++:Me.lexeme.charCodeAt(Le)===41&&ie--}if(ie<0)break;Ce.push(I.$Wi.getLexeme(ce)),this.z(),ce=this.D()}const Q=Ce.join(""),ee=Q.lastIndexOf("/"),$e=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let be;try{be=new RegExp(Q.substring(1,ee),$e)}catch{throw this.B("REGEX",Me)}return i.regex(ne,be)}case 18:{const Ce=Me.lexeme;this.z();let ce=null;if(!(0,T.$Ge)(Ce)){const ie=Ce.indexOf("/"),Q=Ce.lastIndexOf("/");if(ie!==Q&&ie>=0){const ee=Ce.slice(ie+1,Q),$e=Ce[Q+1]==="i"?"i":"";try{ce=new RegExp(ee,$e)}catch{throw this.B("REGEX",Me)}}}if(ce===null)throw this.B("REGEX",Me);return P.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Me=this.u();return i.notIn(ne,Me)}switch(this.D().type){case 3:{this.z();const Me=this.u();if(this.x().type===18)return i.equals(ne,Me);switch(Me){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Me)}}case 4:{this.z();const Me=this.u();if(this.x().type===18)return i.notEquals(ne,Me);switch(Me){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Me)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),U.create(ne,this.u());case 8:return this.z(),L.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Me=(0,A.localize)(8,null,V,I.$Wi.getLexeme(ne)),Ce=ne.offset,ce=I.$Wi.getLexeme(ne);return this.h.push({message:Me,offset:Ce,lexeme:ce,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=h;class i{static false(){return b.INSTANCE}static true(){return f.INSTANCE}static has(V){return D.create(V)}static equals(V,ne){return F.create(V,ne)}static notEquals(V,ne){return k.create(V,ne)}static regex(V,ne){return P.create(V,ne)}static in(V,ne){return p.create(V,ne)}static notIn(V,ne){return y.create(V,ne)}static not(V){return O.create(V)}static and(...V){return ge.create(V,null,!0)}static or(...V){return ve.create(V,null,!0)}static greater(V,ne){return U.create(V,ne)}static greaterEquals(V,ne){return L.create(V,ne)}static smaller(V,ne){return z.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Zi=i;function s(X){const V=new h({regexParsingWithErrorRecovery:!1});return X.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,A.localize)(9,null,Ie.additionalInfo):(0,A.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$1i=s;function u(X,V){const ne=X?X.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$2i=u;function d(X,V){return X.cmp(V)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$3i=b;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return b.INSTANCE}}e.$4i=f;class D{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:b.INSTANCE:new D(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:de(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:b.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$5i=D;class F{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?D.create(V,Ie):O.create(V,Ie);const Me=g.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?f.INSTANCE:b.INSTANCE:new F(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?f.INSTANCE:b.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$6i=F;class p{static create(V,ne){return new p(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:he(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$7i=p;class y{static create(V,ne){return new y(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=p.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=y;class k{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?O.create(V,Ie):D.create(V,Ie);const Me=g.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?b.INSTANCE:f.INSTANCE:new k(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?b.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$9i=k;class O{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?b.INSTANCE:f.INSTANCE:new O(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:de(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?b.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$0i=O;function K(X,V){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?V(X):b.INSTANCE}class U{static create(V,ne,Ie=null){return K(ne,Me=>new U(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$$i=U;class L{static create(V,ne,Ie=null){return K(ne,Me=>new L(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$_i=L;class z{static create(V,ne,Ie=null){return K(ne,Me=>new z(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$aj=z;class C{static create(V,ne,Ie=null){return K(ne,Me=>new C(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$bj=C;class P{static create(V,ne){return new P(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$cj=P;class Y{static create(V){return new Y(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new Y(this.c.map(V))}negate(){return this.c}}e.$dj=Y;function ae(X){let V=null;for(let ne=0,Ie=X.length;ne<Ie;ne++){const Me=X[ne].substituteConstants();if(X[ne]!==Me&&V===null){V=[];for(let Ce=0;Ce<ne;Ce++)V[Ce]=X[Ce]}V!==null&&(V[ne]=Me)}return V===null?X:V}class ge{static create(V,ne,Ie){return ge.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=d(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:ge.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Me=[];let Ce=!1;for(const ce of V)if(ce){if(ce.type===1){Ce=!0;continue}if(ce.type===0)return b.INSTANCE;if(ce.type===6){Me.push(...ce.expr);continue}Me.push(ce)}if(Me.length===0&&Ce)return f.INSTANCE;if(Me.length!==0){if(Me.length===1)return Me[0];Me.sort(d);for(let ce=1;ce<Me.length;ce++)Me[ce-1].equals(Me[ce])&&(Me.splice(ce,1),ce--);if(Me.length===1)return Me[0];for(;Me.length>1;){const ce=Me[Me.length-1];if(ce.type!==9)break;Me.pop();const ie=Me.pop(),Q=Me.length===0,ee=ve.create(ce.expr.map($e=>ge.create([$e,ie],null,Ie)),null,Q);ee&&(Me.push(ee),Me.sort(d))}if(Me.length===1)return Me[0];if(Ie){for(let ce=0;ce<Me.length;ce++)for(let ie=ce+1;ie<Me.length;ie++)if(Me[ce].negate().equals(Me[ie]))return b.INSTANCE;if(Me.length===1)return Me[0]}return new ge(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ge(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=ve.create(V,this,!0)}return this.c}}e.$ej=ge;class ve{static create(V,ne,Ie){return ve.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=d(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ae(this.expr);return V===this.expr?this:ve.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Me=[],Ce=!1;if(V){for(let ce=0,ie=V.length;ce<ie;ce++){const Q=V[ce];if(Q){if(Q.type===0){Ce=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Me=Me.concat(Q.expr);continue}Me.push(Q)}}if(Me.length===0&&Ce)return b.INSTANCE;Me.sort(d)}if(Me.length!==0){if(Me.length===1)return Me[0];for(let ce=1;ce<Me.length;ce++)Me[ce-1].equals(Me[ce])&&(Me.splice(ce,1),ce--);if(Me.length===1)return Me[0];if(Ie){for(let ce=0;ce<Me.length;ce++)for(let ie=ce+1;ie<Me.length;ie++)if(Me[ce].negate().equals(Me[ie]))return f.INSTANCE;if(Me.length===1)return Me[0]}return new ve(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ve(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Me=[];for(const Ce of oe(ne))for(const ce of oe(Ie))Me.push(ge.create([Ce,ce],null,!1));V.unshift(ve.create(Me,null,!1))}this.c=ve.create(V,this,!0)}return this.c}}e.$fj=ve;class De extends D{static{this.d=[]}static all(){return De.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?De.d.push({...Ie,key:V}):Ie!==!0&&De.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return F.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$gj=De,e.$hj=(0,M.$2h)("contextKeyService");function de(X,V){return X<V?-1:X>V?1:0}function he(X,V,ne,Ie){return X<ne?-1:X>ne?1:V<Ie?-1:V>Ie?1:0}function te(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?Se(X.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(te(X,ne))return!0;return!1}if(X.type===6){if(V.type===6)return Se(V.expr,X.expr);for(const ne of X.expr)if(te(ne,V))return!0;return!1}return X.equals(V)}e.$ij=te;function Se(X,V){let ne=0,Ie=0;for(;ne<X.length&&Ie<V.length;){const Me=X[ne].cmp(V[Ie]);if(Me<0)return!1;Me===0&&ne++,Ie++}return ne===X.length}function oe(X){return X.type===9?X.expr:[X]}}),define(Pe[184],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,E.$2h)("environmentService"),e.$0h=(0,E.$3h)(e.$9h)}),define(Pe[97],Ae([1,0,151,4]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0,e.$$n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_n=new RegExp(e.$$n),e.$ao="__web_extension",e.$bo="skipWalkthrough",e.$co="extensionsSync",e.$do="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$eo=I;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$fo=M;function A(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$go=A;function m(t,r){return r==="web"&&!t.includes("web")}e.$ho=m;function g(t,r,a){return m(r,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$io=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$jo=w;var R;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$ko=(0,T.$2h)("extensionGalleryService");var v;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var n;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$lo=o,e.$mo=(0,T.$2h)("extensionManagementService"),e.$no="extensionsIdentifiers/disabled",e.$oo="extensionsIdentifiers/enabled",e.$po=(0,T.$2h)("IGlobalExtensionEnablementService"),e.$qo=(0,T.$2h)("IExtensionTipsService"),e.$ro=(0,E.localize)(0,null),e.$so={value:e.$ro,original:"Extensions"},e.$to={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[42],Ae([1,0,50,19,12,16,2,153,4,21,13,39]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,g.$2h)("fileService");function l(te){return te.create===!0}e.$mk=l;var $;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function n(te){const Se=te;return!!Se&&typeof Se.onDidChange=="function"}e.$nk=n;var o;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(te){return!!(te.capabilities&2)}e.$ok=t;function r(te){return!!(te.capabilities&8)}e.$pk=r;function a(te){return!!(te.capabilities&131072)}e.$qk=a;function c(te){return!!(te.capabilities&4)}e.$rk=c;function h(te){return!!(te.capabilities&16)}e.$sk=h;function i(te){return t(te)?!!(te.capabilities&16384):!1}e.$tk=i;function s(te){return t(te)?!!(te.capabilities&32768):!1}e.$uk=s;function u(te){return!!(te.capabilities&65536)}e.$vk=u;function d(te){return!!(te.capabilities&2048)}e.$wk=d;var b;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class f extends Error{static create(Se,oe){const X=new f(Se.toString(),oe);return p(X,oe),X}constructor(Se,oe){super(Se),this.code=oe}}e.$xk=f;function D(te,Se){return f.create(te,Se)}e.$yk=D;function F(te){return te||D((0,m.localize)(0,null),b.Unknown)}e.$zk=F;function p(te,Se){return te.name=Se?`${Se} (FileSystemError)`:"FileSystemError",te}e.$Ak=p;function y(te){if(!te)return b.Unknown;if(te instanceof f)return te.code;const Se=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Se)return b.Unknown;switch(Se[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$Bk=y;function k(te){if(te instanceof C)return te.fileOperationResult;switch(y(te)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$Ck=k;var O;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class K{constructor(Se,oe,X){this.resource=Se,this.operation=oe,this.target=X}isOperation(Se){return this.operation===Se}}e.$Dk=K;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class L{static{this.a=null}constructor(Se,oe){this.c=oe,this.b=void 0,this.d=new S.$V(()=>{const X=E.$8h.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new S.$V(()=>{const X=E.$8h.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new S.$V(()=>{const X=E.$8h.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Se){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==L.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=L.a):this.b!==void 0&&(this.b=L.a))}}contains(Se,...oe){return this.h(Se,{includeChildren:!1},...oe)}affects(Se,...oe){return this.h(Se,{includeChildren:!0},...oe)}h(Se,oe,...X){if(!Se)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.d.value.get(Se)||oe.includeChildren&&this.d.value.findSuperstr(Se))||(!V||X.includes(0))&&(this.f.value.get(Se)||oe.includeChildren&&this.f.value.findSuperstr(Se))||(!V||X.includes(2))&&(this.g.value.findSubstr(Se)||oe.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=L;function z(te,Se,oe){return!te||!Se||te===Se||Se.length>te.length?!1:(Se.charAt(Se.length-1)!==T.sep&&(Se+=T.sep),oe?(0,I.$9e)(te,Se):te.indexOf(Se)===0)}e.$Fk=z;class C extends Error{constructor(Se,oe,X){super(Se),this.fileOperationResult=oe,this.options=X}}e.$Gk=C;class P extends C{constructor(Se,oe,X,V){super(Se,oe,V),this.fileOperationResult=oe,this.size=X}}e.$Hk=P;class Y extends C{constructor(Se,oe,X){super(Se,2,X),this.stat=oe}}e.$Ik=Y;var ae;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var ge;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.$Qk="";function ve(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Rk=ve;async function De(te,Se){if(!Se.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(oe=>{const X=Se.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===te.scheme&&V.added&&(X.dispose(),oe())})})}e.$Sk=De;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Se){return(0,M.$If)(Se)||(Se=0),Se<de.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<de.MB?(0,m.localize)(2,null,(Se/de.KB).toFixed(2)):Se<de.GB?(0,m.localize)(3,null,(Se/de.MB).toFixed(2)):Se<de.TB?(0,m.localize)(4,null,(Se/de.GB).toFixed(2)):(0,m.localize)(5,null,(Se/de.TB).toFixed(2))}}e.$Tk=de;function he(te){const Se=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*de.MB:Se?10*de.MB:w.$o?50*de.MB:1024*de.MB}e.$Uk=he}),define(Pe[71],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(...I){this.a=new Map;for(const[M,A]of I)this.set(M,A)}set(I,M){const A=this.a.get(I);return this.a.set(I,M),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Zh=E}),define(Pe[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;const R=!1;class S extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$Zh,t=!1,r,a=R){this.f=o,this.g=t,this.h=r,this.i=a,this.o=new Set,this.f.set(m.$1h,this),this._globalGraph=a?r?._globalGraph??new A.$pq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const r=v.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,r);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,r.stop()}}createInstance(o,...t){let r,a;return o instanceof M.$Yh?(r=v.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),r)):(r=v.traceCreation(this.i,o),a=this.j(o,t,r)),r.stop(),a}j(o,t=[],r){const a=m._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,r);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof M.$Yh)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.l(o);return r instanceof M.$Yh?this.q(o,r,t.branch(o,!0)):(t.branch(o,!1),r)}q(o,t,r){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,r)}finally{this.o.delete(o)}}r(o,t,r){const a=new A.$pq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:r}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new S(a);for(const s of m._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof M.$Yh){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new S(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof M.$Yh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,r=[],a,c){if(this.f.get(o)instanceof M.$Yh)return this.t(o,t,r,a,c);if(this.h)return this.h.s(o,t,r,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,r=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$ih(()=>{const u=h.j(t,r,c);for(const[d,b]of i){const f=u[d];if(typeof f=="function")for(const D of b)f.apply(u,D)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let D=i.get(d);return D||(D=new w.$3c,i.set(d,D)),(p,y,k)=>{const O=D.push([p,y,k]);return(0,I.$Qc)(O)}}if(d in u)return u[d];const b=s.value;let f=b[d];return typeof f!="function"||(f=f.bind(b),u[d]=f),f},set(u,d,b){return s.value[d]=b,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,r,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$qq=l;var $;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})($||($={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new v(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(o,t){return o?new v(1,t.name):v.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const r=new v(3,o.toString());return this.h.push([o,t,r]),r}stop(){const o=Date.now()-this.g;v.f+=o;let t=!1;function r(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,b]of h.h)if(d&&b){t=!0,i.push(`${s}CREATES -> ${u}`);const f=r(c+1,b);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(o>2||t)&&v.all.add(a.join(`
`))}}e.$rq=v}),define(Pe[15],Ae([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,l.$2h)("logService"),e.$kj=(0,l.$2h)("loggerService");function $(){return new Date().toISOString()}function v(p){return(0,w.$If)(p)}e.$lj=v;var n;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(n||(e.LogLevel=n={})),e.$mj=n.Info;function o(p,y,k){switch(y){case n.Trace:p.trace(k);break;case n.Debug:p.debug(k);break;case n.Info:p.info(k);break;case n.Warning:p.warn(k);break;case n.Error:p.error(k);break;case n.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t(p,y=!1){let k="";for(let O=0;O<p.length;O++){let K=p[O];if(K instanceof Error&&(K=(0,E.$Mi)(K,y)),typeof K=="object")try{K=JSON.stringify(K)}catch{}k+=(O>0?" ":"")+K}return k}class r extends M.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==n.Off&&this.b<=y}}e.$oj=r;class a extends r{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...k){this.f(n.Trace)&&this.g(n.Trace,t([y,...k],!0))}debug(y,...k){this.f(n.Debug)&&this.g(n.Debug,t([y,...k]))}info(y,...k){this.f(n.Info)&&this.g(n.Info,t([y,...k]))}warn(y,...k){this.f(n.Warning)&&this.g(n.Warning,t([y,...k]))}error(y,...k){if(this.f(n.Error))if(y instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=y.stack,this.g(n.Error,t(O))}else this.g(n.Error,t([y,...k]))}flush(){}}e.$pj=a;class c extends r{constructor(y=e.$mj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...k){this.f(n.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...k):console.log(`[main ${$()}]`,y,...k))}debug(y,...k){this.f(n.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...k):console.log(`[main ${$()}]`,y,...k))}info(y,...k){this.f(n.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...k):console.log(`[main ${$()}]`,y,...k))}warn(y,...k){this.f(n.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,y,...k):console.warn(`[main ${$()}]`,y,...k))}error(y,...k){this.f(n.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,y,...k):console.error(`[main ${$()}]`,y,...k))}dispose(){}flush(){}}e.$qj=c;class h extends r{constructor(y=e.$mj,k=!0){super(),this.g=k,this.setLevel(y)}trace(y,...k){this.f(n.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...k):console.log(y,...k))}debug(y,...k){this.f(n.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...k):console.log(y,...k))}info(y,...k){this.f(n.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...k):console.log(y,...k))}warn(y,...k){this.f(n.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...k):console.log(y,...k))}error(y,...k){this.f(n.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...k):console.error(y,...k))}dispose(){}flush(){}}e.$rj=h;class i extends r{constructor(y,k=e.$mj){super(),this.g=y,this.setLevel(k)}trace(y,...k){this.f(n.Trace)&&this.g.log(n.Trace,[this.h(y),...k])}debug(y,...k){this.f(n.Debug)&&this.g.log(n.Debug,[this.h(y),...k])}info(y,...k){this.f(n.Info)&&this.g.log(n.Info,[this.h(y),...k])}warn(y,...k){this.f(n.Warning)&&this.g.log(n.Warning,[this.h(y),...k])}error(y,...k){this.f(n.Error)&&this.g.log(n.Error,[this.h(y),...k])}h(y){return typeof y=="string"?y:(0,E.$Mi)(y,this.f(n.Trace))}dispose(){}flush(){}}e.$sj=i;class s extends r{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const k of this.g)k.setLevel(y);super.setLevel(y)}trace(y,...k){for(const O of this.g)O.trace(y,...k)}debug(y,...k){for(const O of this.g)O.debug(y,...k)}info(y,...k){for(const O of this.g)O.info(y,...k)}warn(y,...k){for(const O of this.g)O.warn(y,...k)}error(y,...k){for(const O of this.g)O.error(y,...k)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$tj=s;class u extends M.$Sc{constructor(y,k,O){if(super(),this.h=y,this.j=k,this.b=new A.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,O)for(const K of O)this.b.set(K.resource,{logger:void 0,info:K})}m(y){return(0,w.$Ef)(y)?[...this.b.values()].find(k=>k.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,k){const O=this.n(y),K=(0,w.$Ef)(y)?y:k?.id??(0,I.$Pi)(O.toString()).toString(16);let U=this.b.get(O)?.logger;const L=k?.logLevel==="always"?n.Trace:k?.logLevel;U||(U=this.s(O,L??this.getLogLevel(O)??this.h,{...k,id:K}));const z={logger:U,info:{resource:O,id:K,logLevel:L,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(z.info),this.b.set(O,z),U}n(y){return(0,w.$Ef)(y)?(0,g.$Dg)(this.j,`${y}.log`):y}setLogLevel(y,k){if(R.URI.isUri(y)){const O=y,K=k,U=this.b.get(O);U&&K!==U.info.logLevel&&(U.info.logLevel=K===this.h?void 0:K,U.logger?.setLevel(K),this.b.set(U.info.resource,U),this.f.fire([O,K]))}else{this.h=y;for(const[O,K]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,k){const O=this.m(y);O&&k!==!O.info.hidden&&(O.info.hidden=!k,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,k]))}getLogLevel(y){let k;return y&&(k=this.b.get(y)?.info.logLevel),k??this.h}registerLogger(y){const k=this.b.get(y.resource);k?k.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const k=this.b.get(y);k&&(k.logger&&k.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(y){}getLevel(){return n.Info}trace(y,...k){}debug(y,...k){}info(y,...k){}warn(y,...k){}error(y,...k){}critical(y,...k){}dispose(){}flush(){}}e.$vj=d;class b extends d{}e.$wj=b;function f(p){if(p.verbose)return n.Trace;if(typeof p.logLevel=="string"){const y=F(p.logLevel.toLowerCase());if(y!==void 0)return y}return e.$mj}e.$xj=f;function D(p){switch(p){case n.Trace:return"trace";case n.Debug:return"debug";case n.Info:return"info";case n.Warning:return"warn";case n.Error:return"error";case n.Off:return"off"}}e.$yj=D;function F(p){switch(p){case"trace":return n.Trace;case"debug":return n.Debug;case"info":return n.Info;case"warn":return n.Warning;case"error":return n.Error;case"critical":return n.Error;case"off":return n.Off}}e.$zj=F,e.$Aj=new S.$gj("logLevel",D(n.Info))}),define(Pe[187],Ae([1,0,6,15]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;class I extends E.$Sc{constructor(A,m=[]){super(),this.a=new T.$tj([A,...m]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$bO=I}),define(Pe[99],Ae([1,0,31,154,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(g){function w(v,n){return n-v}g.compare=w;const R=Object.create(null);R[g.Error]=(0,T.localize)(0,null),R[g.Warning]=(0,T.localize)(1,null),R[g.Info]=(0,T.localize)(2,null);function S(v){return R[v]||""}g.toString=S;function l(v){switch(v){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function $(v){switch(v){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=$}(A||(e.MarkerSeverity=A={}));var m;(function(g){const w="";function R(l){return S(l,!0)}g.makeKey=R;function S(l,$){const v=[w];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(w),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(w),l.severity!==void 0&&l.severity!==null?v.push(A.toString(l.severity)):v.push(w),l.message&&$?v.push(l.message.replace("\xA6","\\\xA6")):v.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(w),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(w),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(w),v.push(w),v.join("\xA6")}g.makeKeyOptionalMessage=S})(m||(e.IMarkerData=m={})),e.$mt=(0,I.$2h)("markerService")}),define(Pe[188],Ae([1,0,5,31,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$bv=e.Severity=void 0,e.Severity=T.default,e.$bv=(0,I.$2h)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$cv=g;class w{infinite(){}done(){}total(S){}worked(S){}}e.$dv=w}),define(Pe[189],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,E.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(me,e,E,T){var I=arguments.length,M=I<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(me,e,E,T);else for(var m=me.length-1;m>=0;m--)(A=me[m])&&(M=(I<3?A(M):I>3?A(e,E,M):A(e,E))||M);return I>3&&M&&Object.defineProperty(e,E,M),M},Ke=this&&this.__param||function(me,e){return function(E,T){e(E,T,me)}};define(Pe[72],Ae([1,0,14,20,6,4]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.ProgressLocation=e.$ev=void 0,e.$ev=(0,M.$2h)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$fv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$gv=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$hv=g;let w=class extends I.$Sc{constructor(l,$){super(),this.a=new E.$mh,$.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$iv=w,e.$iv=w=Ge([Ke(1,e.$ev)],w);class R extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const $=++this.a,v=new T.$3d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>v.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:$,token:v.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$jv=R,e.$kv=(0,M.$2h)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0;class I{constructor(){this.a=new Map}add(A,m){E.ok(T.$Ef(A)),E.ok(T.$Gf(m)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$tn=new I}),define(Pe[73],Ae([1,0,5,30]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class M{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[I(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;T.$tn.add(e.$un.JSONContribution,A)}),define(Pe[54],Ae([1,0,18,5,16,148,41,73,30]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.ConfigurationScope=e.$yn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$yn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn="vscode://schemas/settings/resourceLanguage",e.$Gn="vscode://schemas/settings/configurationDefaults";const S=g.$tn.as(m.$un.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Fn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),S.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:b}of i)for(const f in d)if(s.add(f),e.$In.test(f)){const D=this.a.get(f),F=D?.valuesSources??new Map;if(b)for(const O of Object.keys(d[f]))F.set(O,b);const p={...D?.value||{},...d[f]};this.a.set(f,{source:b,value:p,valuesSources:F});const y=(0,A.$Fi)(f),k={type:"object",default:p,description:M.localize(1,null,y),$ref:e.$Fn,defaultDefaultValue:p,source:I.$Ef(b)?void 0:b,defaultValueSource:b};u.push(...n(f)),this.d[f]=k,this.b.properties[f]=k}else{this.a.set(f,{value:d[f],source:b});const D=this.d[f];D&&(this.w(f,D),this.r(f,D))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const b in u){const f=this.a.get(b),D=I.$Ef(d)?d:d?.id,F=I.$Ef(f?.source)?f?.source:f?.source?.id;if(D===F)if(s.add(b),this.a.delete(b),e.$In.test(b))delete this.d[b],delete this.b.properties[b];else{const p=this.d[b];p&&(this.w(b,p),this.r(b,p))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const b in d.properties){s.add(b);const f=this.d[b];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[b],this.s(b,d.properties[b])}d.allOf?.forEach(b=>u(b))};for(const d of i){u(d);const b=this.c.indexOf(d);b!==-1&&this.c.splice(b,1)}}p(i,s=!0,u,d,b=3,f){b=I.$Nf(i.scope)?b:i.scope;const D=i.properties;if(D)for(const p in D){const y=D[p];if(s&&a(p,y)){delete D[p];continue}if(y.source=u,y.defaultDefaultValue=D[p].default,this.w(p,y),e.$In.test(p)?y.scope=void 0:(y.scope=I.$Nf(y.scope)?b:y.scope,y.restricted=I.$Nf(y.restricted)?!!d?.includes(p):y.restricted),D[p].hasOwnProperty("included")&&!D[p].included){this.f[p]=D[p],delete D[p];continue}else this.d[p]=D[p],D[p].policy?.name&&this.e.set(D[p].policy.name,p);!D[p].deprecationMessage&&D[p].markdownDeprecationMessage&&(D[p].deprecationMessage=D[p].markdownDeprecationMessage),f.add(p)}const F=i.allOf;if(F)for(const p of F)this.p(p,s,u,d,b,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$zn.properties[i]=s,s.scope){case 1:e.$An.properties[i]=s;break;case 2:e.$Bn.properties[i]=s;break;case 6:e.$Cn.properties[i]=s;break;case 3:e.$Dn.properties[i]=s;break;case 4:e.$En.properties[i]=s;break;case 5:e.$En.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$zn.properties[i],s.scope){case 1:delete e.$An.properties[i];break;case 2:delete e.$Bn.properties[i];break;case 6:delete e.$Cn.properties[i];break;case 3:delete e.$Dn.properties[i];break;case 4:case 5:delete e.$En.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Fn};this.w(s,u),e.$zn.properties[s]=u,e.$An.properties[s]=u,e.$Bn.properties[s]=u,e.$Cn.properties[s]=u,e.$Dn.properties[s]=u,e.$En.properties[s]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Fn};e.$zn.patternProperties[e.$Hn]=i,e.$An.patternProperties[e.$Hn]=i,e.$Bn.patternProperties[e.$Hn]=i,e.$Cn.patternProperties[e.$Hn]=i,e.$Dn.patternProperties[e.$Hn]=i,e.$En.patternProperties[e.$Hn]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,b=u?.source;I.$Lf(d)&&(d=s.defaultDefaultValue,b=void 0),I.$Lf(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=b}}const $="\\[([^\\]]+)\\]",v=new RegExp($,"g");e.$Hn=`^(${$})+$`,e.$In=new RegExp(e.$Hn);function n(h){const i=[];if(e.$In.test(h)){let s=v.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=v.exec(h)}}return(0,E.$Mb)(i)}e.$Jn=n;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Kn=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Ln=t;const r=new l;g.$tn.add(e.$yn.Configuration,r);function a(h,i){return h.trim()?e.$In.test(h)?M.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&r.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,r.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Mn=a;function c(){const h=[],i=r.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Nn=c}),define(Pe[190],Ae([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0;function $(s){return Object.isFrozen(s)?s:m.$in(s)}class v{constructor(u={},d=[],b=[],f){this.b=u,this.c=d,this.d=b,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof v)return d;const b=new n("");return b.parseRaw(d),b.configurationModel});this.f=u.reduce((d,b)=>b===d?b:d.merge(b),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,R.$Di)(this.contents,u):this.contents}inspect(u,d){const b=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,D=d?this.rawConfiguration.override(d).getValue(u):b;return{value:b,override:f,merged:D}}getOverrideValue(u,d){const b=this.i(d);return b?u?(0,R.$Di)(b,u):b:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const b of this.overrides)b.identifiers.includes(u)&&d.push(...b.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=m.$hn(this.contents),b=m.$hn(this.overrides),f=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const F of u)if(D.push(...F.raw?.length?F.raw:[F]),!F.isEmpty()){this.h(d,F.contents);for(const p of F.overrides){const[y]=b.filter(k=>E.$ub(k.identifiers,p.identifiers));y?(this.h(y.contents,p.contents),y.keys.push(...p.keys),y.keys=E.$Mb(y.keys)):b.push(m.$hn(p))}for(const p of F.keys)f.indexOf(p)===-1&&f.push(p)}return new v(d,f,b,D.every(F=>F instanceof v)?void 0:D)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const b={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let D=this.contents[f];const F=d[f];F&&(typeof D=="object"&&typeof F=="object"?(D=m.$hn(D),this.h(D,F)):D=F),b[f]=D}return new v(b,this.keys,this.overrides)}h(u,d){for(const b of Object.keys(d)){if(b in u&&g.$Gf(u[b])&&g.$Gf(d[b])){this.h(u[b],d[b]);continue}u[b]=m.$hn(d[b])}}i(u){let d=null,b=null;const f=D=>{D&&(b?this.h(b,D):b=m.$hn(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===u?d=D.contents:D.identifiers.includes(u)&&f(D.contents);return f(d),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,R.$Ci)(this.contents,u),S.$In.test(u)&&this.overrides.splice(this.overrides.findIndex(b=>E.$ub(b.identifiers,(0,S.$Jn)(u))),1))}j(u,d,b){(0,R.$Bi)(this.contents,u,d,f=>console.error(f)),b=b||this.keys.indexOf(u)===-1,b&&this.keys.push(u),S.$In.test(u)&&this.overrides.push({identifiers:(0,S.$Jn)(u),keys:Object.keys(this.contents[u]),contents:(0,R.$Ai)(this.contents[u],f=>console.error(f))})}}e.$On=v;class n{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Nf(u)){const b=this.g(u);this.parseRaw(b,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:b,keys:f,overrides:D,restricted:F,hasExcludedProperties:p}=this.h(u,d);this.b=new v(b,f,D,p?[u]:void 0),this.c=F||[]}g(u){let d={},b=null,f=[];const D=[],F=[];function p(k){Array.isArray(f)?f.push(k):b!==null&&(f[b]=k)}const y={onObjectBegin:()=>{const k={};p(k),D.push(f),f=k,b=null},onObjectProperty:k=>{b=k},onObjectEnd:()=>{f=D.pop()},onArrayBegin:()=>{const k=[];p(k),D.push(f),f=k,b=null},onArrayEnd:()=>{f=D.pop()},onLiteralValue:p,onError:(k,O,K)=>{F.push({error:k,offset:O,length:K})}};if(u)try{I.$en(u,y),d=f[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}h(u,d){const b=l.$tn.as(S.$yn.Configuration).getConfigurationProperties(),f=this.i(u,b,!0,d);u=f.raw;const D=(0,R.$Ai)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),F=Object.keys(u),p=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:D,keys:F,overrides:p,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,b,f){let D=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:D};const F={},p=[];for(const y in u)if(S.$In.test(y)&&b){const k=this.i(u[y],d,!1,f);F[y]=k.raw,D=D||k.hasExcludedProperties,p.push(...k.restricted)}else{const k=d[y],O=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&p.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(O===void 0||f.scopes===void 0||f.scopes.includes(O))&&!(f.skipRestricted&&k?.restricted))?F[y]=u[y]:D=!0}return{raw:F,restricted:p,hasExcludedProperties:D}}j(u,d){const b=[];for(const f of Object.keys(u))if(S.$In.test(f)){const D={};for(const F in u[f])D[F]=u[f][F];b.push({identifiers:(0,S.$Jn)(f),keys:Object.keys(D),contents:(0,R.$Ai)(D,d)})}return b}}e.$Pn=n;class o extends M.$Sc{constructor(u,d,b,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&b.isEqual(D.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qn=o;class t{constructor(u,d,b,f,D,F,p,y,k,O,K,U,L){this.a=u,this.b=d,this.c=b,this.overrideIdentifiers=f,this.d=D,this.f=F,this.g=p,this.h=y,this.i=k,this.j=O,this.k=K,this.l=U,this.m=L}get value(){return $(this.c)}n(u,d,b){const f=u.inspect(d,b);return{get value(){return $(f.value)},get override(){return $(f.override)},get merged(){return $(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(u,d,b,f,D=new v,F=new v,p=new A.$Ac,y=new v,k=new A.$Ac){this.c=u,this.d=d,this.f=b,this.g=f,this.h=D,this.i=F,this.j=p,this.l=y,this.m=k,this.a=null,this.b=new A.$Ac,this.n=null}getValue(u,d,b){return this.p(u,d,b).getValue(u)}updateValue(u,d,b={}){let f;b.resource?(f=this.m.get(b.resource),f||(f=new v,this.m.set(b.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),b.resource||(this.a=null)}inspect(u,d,b){const f=this.p(u,d,b),D=this.t(d.resource,b),F=d.resource?this.m.get(d.resource)||this.l:this.l,p=new Set;for(const y of f.overrides)for(const k of y.identifiers)f.getOverrideValue(u,k)!==void 0&&p.add(k);return new t(u,d,f.getValue(u),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,D||void 0,F)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const b=[];if(!d){const{added:f,updated:D,removed:F}=h(this.c,u);d=[...f,...D,...F]}for(const f of d)for(const D of(0,S.$Jn)(f)){const F=this.c.getKeysForOverrideIdentifier(D),p=u.getKeysForOverrideIdentifier(D),y=[...p.filter(k=>F.indexOf(k)===-1),...F.filter(k=>p.indexOf(k)===-1),...F.filter(k=>!m.$ln(this.c.override(D).getValue(k),u.override(D).getValue(k)))];b.push([D,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:b}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:b,removed:f}=h(this.d,u),D=[...d,...b,...f];return D.length&&this.updatePolicyConfiguration(u),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.applicationConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateApplicationConfiguration(u),{keys:F,overrides:D}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.localUserConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateLocalUserConfiguration(u),{keys:F,overrides:D}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.remoteUserConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateRemoteUserConfiguration(u),{keys:F,overrides:D}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.workspaceConfiguration,u),F=[...d,...b,...f];return F.length&&this.updateWorkspaceConfiguration(u),{keys:F,overrides:D}}compareAndUpdateFolderConfiguration(u,d){const b=this.folderConfigurations.get(u),{added:f,updated:D,removed:F,overrides:p}=h(b,d),y=[...f,...D,...F];return(y.length||!b)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:p}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:b,updated:f,removed:D,overrides:F}=h(d,void 0);return{keys:[...b,...f,...D],overrides:F}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,b){let f=this.q(d,b);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let b=this.r();if(d&&u){const f=d.getFolder(u);f&&(b=this.s(f.uri)||b);const D=this.m.get(u);D&&(b=b.merge(D))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const b=this.r(),f=this.j.get(u);f?(d=b.merge(f),this.b.set(u,d)):d=b}return d}t(u,d){if(d&&u){const b=d.getFolder(u);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:b,overrides:f,keys:D}=this.j.get(d);return u.push([d,{contents:b,overrides:f,keys:D}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(b=>u.add(b))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(b=>u.add(b))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.i.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),b=this.w(u.policy),f=this.w(u.application),D=this.w(u.user),F=this.w(u.workspace),p=u.folders.reduce((y,k)=>(y.set(w.URI.revive(k[0]),this.w(k[1])),y),new A.$Ac);return new r(d,b,f,D,new v,F,p,new v,new A.$Ac)}static w(u){return new v(u.contents,u.keys,u.overrides)}}e.$Rn=r;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(D=>u.add(D)),f.overrides.forEach(([D,F])=>{const p=(0,A.$xc)(d,D,new Set);F.forEach(y=>p.add(y))});const b=[];return d.forEach((f,D)=>b.push([D,[...f.values()]])),{keys:[...u.values()],overrides:b}}e.$Sn=a;class c{constructor(u,d,b,f){this.change=u,this.f=d,this.g=b,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of u.keys)this.affectedKeys.add(D);for(const[,D]of u.overrides)for(const F of D)this.affectedKeys.add(F);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(u,d){const b=this.a+u,f=this.d.indexOf(b);if(f<0)return!1;const D=f+b.length;if(D>=this.d.length)return!1;const F=this.d.charCodeAt(D);if(F!==this.b&&F!==this.c)return!1;if(d){const p=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!m.$ln(p,y)}return!0}}e.$Tn=c;function h(s,u){const{added:d,removed:b,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),D=[],F=s?.getAllOverrideIdentifiers()||[],p=u?.getAllOverrideIdentifiers()||[];if(u){const y=p.filter(k=>!F.includes(k));for(const k of y)D.push([k,u.getKeysForOverrideIdentifier(k)])}if(s){const y=F.filter(k=>!p.includes(k));for(const k of y)D.push([k,s.getKeysForOverrideIdentifier(k)])}if(u&&s){for(const y of F)if(p.includes(y)){const k=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});D.push([y,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:b,updated:f,overrides:D}}function i(s,u){const d=s?u?s.keys.filter(D=>u.keys.indexOf(D)===-1):[...s.keys]:[],b=u?s?u.keys.filter(D=>s.keys.indexOf(D)===-1):[...u.keys]:[],f=[];if(s&&u){for(const D of u.keys)if(s.keys.indexOf(D)!==-1){const F=(0,R.$Di)(u.contents,D),p=(0,R.$Di)(s.contents,D);m.$ln(F,p)||f.push(D)}}return{added:d,removed:b,updated:f}}}),define(Pe[100],Ae([1,0,11,4]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,T.$2h)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=M;class A{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=A;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends E.$bb{static isNotAvailable(S){return S instanceof g&&S._code===m.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof g&&S._code===m.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof g&&S._code===m.NoResolverFound}static isInvalidAuthority(S){return S instanceof g&&S._code===m.InvalidAuthority}static isHandled(S){return S instanceof g&&S.isHandled}constructor(S,l=m.Unknown,$){super(S),this._message=S,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,g.prototype)}}e.$6k=g;function w(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.$7k=w}),define(Pe[55],Ae([1,0,13]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$8k=T;function I(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$9k=I;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$0k=M;function A(w){const{host:R,port:S}=g(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.$$k=A;function m(w,R){let{host:S,port:l}=g(w);return typeof l>"u"&&(l=R),{host:S,port:l}}e.$_k=m;function g(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.TargetPlatform=e.ExtensionType=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am="extensions.user.cache",e.$bm="extensions.builtin.cache",e.$cm="undefined_publisher",e.$dm=["ui","workspace","web"];function M(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$em=M,e.$fm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const r=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$8e(r,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$gm=g;class w{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$hm=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$im=R;function S(n){return l(n)}e.$jm=S;function l(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.$km=l;function $(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.$lm=$;function v(n,o){if(o){const t=`onResolveRemoteAuthority:${(0,I.$9k)(o)}`;return!!n.activationEvents?.includes(t)}return!1}e.$mm=v,e.$nm=(0,T.$2h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2E=e.$1E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const g of A){const w=this.readActivationEvents(g);w.length>0&&(m[T.$gm.toKey(g.identifier)]=w)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${T.$gm.toKey(A.identifier)}`);if(!A.contributes)return m;for(const g in A.contributes){const w=this.a.get(g);if(!w)continue;const R=A.contributes[g],S=Array.isArray(R)?R:[R];try{w(S,m)}catch(l){(0,E.$1)(l)}}return m}}e.$1E=I,e.$2E=new I}),define(Pe[191],Ae([1,0,21,74,33]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;function M(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,w,R,S,l,$,v,n,o){const t=Object.create(null);t["common.machineId"]=$,t["common.sqmId"]=v,t.sessionID=(0,I.$mg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=R,t["common.product"]=o||"desktop",n&&(t["common.msftInternal"]=n);let r=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(w);return c&&(t["common.platformDetail"]=c),t}e.$uo=A;function m(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return g.some(S=>R===S)}e.$vo=m}),define(Pe[192],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,E.$2h)("telemetryService"),e.$ql=(0,E.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[56],Ae([1,0,26,16,5,41,55,191,192]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;class w{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$wo=w;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xo=R,e.$yo=new R;class S{async publicLog(b,f,D){}async publicLogError(b,f,D){}}e.$zo=S,e.$Ao="telemetry",e.$Bo="extensionTelemetryLog",e.$Co={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,b){return I.Event.debounce(b.onDidChangeConfiguration,(D,F)=>{const p=D?new Set([...D.affectedKeys,...F.affectedKeys]):F.affectedKeys;return{...F,affectedKeys:p}},1e3,!0)(D=>{D.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$yi)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$Do=l;function $(d,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!d.enableTelemetry)}e.$Eo=$;function v(d,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Fo=v;function n(d){const b=d.getValue(g.$xl),f=d.getValue(g.$yl);if(d.getValue(g.$zl)===!1||f===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Go=n;function o(d){const b={},f={},D={};a(d,D);for(let F in D){F=F.length>150?F.substr(F.length-149):F;const p=D[F];typeof p=="number"?f[F]=p:typeof p=="boolean"?f[F]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${F} has been trimmed to 8192, the original length is ${p.length}`),b[F]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(b[F]=p)}return{properties:b,measurements:f}}e.$Ho=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const b=(0,A.$9k)(d);return t.has(b)?b:"other"}e.$Io=r;function a(d,b,f=0,D){if(d)for(const F of Object.getOwnPropertyNames(d)){const p=d[F],y=D?D+F:F;Array.isArray(p)?b[y]=(0,E.$mn)(p):p instanceof Date?b[y]=p.toISOString():(0,T.$Gf)(p)?f<2?a(p,b,f+1,y+"."):b[y]=(0,E.$mn)(p):b[y]=p}}function c(d,b){const f=d.msftInternalDomains||[],D=b.getValue("telemetry.internalTesting");return(0,m.$vo)(f)||D}e.$Jo=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Ko=h;function i(d,b){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const D=[];for(const k of b)for(;;){const O=k.exec(d);if(!O)break;D.push([O.index,k.lastIndex])}const F=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const k=p.exec(d);if(!k)break;const O=D.some(([K,U])=>k.index<U&&K<p.lastIndex);!F.test(k[0])&&!O&&(f+=d.substring(y,k.index)+"<REDACTED: user-file-path>",y=p.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of b)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,b){return(0,E.$jn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let D=f.replaceAll("%20"," ");D=i(D,b);for(const F of b)D=D.replace(F,"");return D=s(D),D}})}e.$Lo=u}),define(Pe[193],Ae([1,0,12,97,22,21,2,11,74,56]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;function R(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$3e)(u.id,d.id)===0}e.$Mo=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const b=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,b,f)}static parse(d){const b=S.exec(d);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(d,b,f="undefined"){this.version=b,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$No=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(u){const d=$.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$Oo=v;function n(u,d){return`${u}.${d}`}e.$Po=n;function o(u){return u.toLowerCase()}e.$Qo=o;function t(u,d){return o(n(u??I.$cm,d))}e.$Ro=t;function r(u,d){const b=[],f=D=>{for(const F of b)if(F.some(p=>R(d(p),d(D))))return F;return null};for(const D of u){const F=f(D);F?F.push(D):b.push([D])}return b}e.$So=r;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$To=a;function c(u){return{id:new w.$wo(u.identifier.id),name:new w.$wo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Uo=c,e.$Vo=new I.$gm("pprice.better-merge");function h(u,d){const b=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const D=f.shift();if(D&&b.every(F=>!R(F.identifier,{id:D}))){const F=u.filter(p=>R(p.identifier,{id:D}));F.length===1&&(b.push(F[0]),f.push(...F[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$Wo=h;async function i(u,d){if(!M.$k)return!1;let b;try{b=(await u.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await u.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){d.debug("Error while getting the os-release file.",(0,m.$0)(D))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const b=await i(u,d),f=(0,T.$go)(b?"alpine":M.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Xo=s}),define(Pe[194],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=void 0;function E(g){return[...g.entries()]}e.$xr=E;function T(g){return g?[...g.entries()]:[]}e.$yr=T;function I(g){return new Map(g)}e.$zr=I;function M(g){return new Map(g??[])}e.$Ar=M;function A(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$Br=A;function m(g){return new Map(g.map(w=>[w[0],{map:I(w[1]),descriptionMap:M(w[2])}]))}e.$Cr=m}),define(Pe[195],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,M,A=5){const m=M(g=>{const w=typeof g=="string"?g:g.data;let R=this.a.get(I);if(R){R.data.push(w);return}const S=setTimeout(()=>this.flushBuffer(I),A);R={data:[w],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(I),m.dispose()}},this.a.set(I,R)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const M=this.a.get(I);M&&(this.a.delete(I),this.b(I,M.data.join("")))}}e.$trb=E}),define(Pe[196],Ae([1,0,14,90,45,5,16,2,155,73,30]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.IconFontDefinition=e.IconContribution=e.$hw=void 0,e.$hw={IconContribution:"base.contributions.icons"};var S;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=v.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(S||(e.IconContribution=S={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,A.$Ef)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,A.$Ef)(d.format)&&(0,A.$Ef)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new M.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const D=this.e.enum.indexOf(h);D!==-1&&(this.e.enumDescriptions[D]=s),this.a.fire()}return d}const b={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=b;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,b)=>d.id.localeCompare(b.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(b=>!!b.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(b=>!I.ThemeIcon.isThemeIcon(b.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const v=new $;R.$tn.add(e.$hw.IconContribution,v);function n(c,h,i,s){return v.registerIcon(c,h,i,s)}e.$iw=n;function o(){return v}e.$jw=o;function t(){const c=(0,T.$6j)();for(const h in c){const i="\\"+c[h].toString(16);v.registerIcon(h,{fontCharacter:i})}}t(),e.$kw="vscode://schemas/icons";const r=R.$tn.as(w.$un.JSONContribution);r.registerSchema(e.$kw,v.getIconSchema());const a=new E.$bh(()=>r.notifySchemaChanged(e.$kw),200);v.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$lw=n("widget-close",T.$8j.close,(0,g.localize)(2,null)),e.$mw=n("goto-previous-location",T.$8j.arrowUp,(0,g.localize)(3,null)),e.$nw=n("goto-next-location",T.$8j.arrowDown,(0,g.localize)(4,null)),e.$ow=I.ThemeIcon.modify(T.$8j.sync,"spin"),e.$pw=I.ThemeIcon.modify(T.$8j.loading,"spin")}),define(Pe[197],Ae([1,0,5,41,4,15]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.ProvidedOnAutoForward=e.$nv=e.TunnelPrivacyId=e.TunnelProtocol=e.$mv=e.$lv=void 0,e.$lv=(0,I.$2h)("tunnelService"),e.$mv=(0,I.$2h)("sharedTunnelsService");var A;(function(o){o.Http="http",o.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(o){return!!o.forwardPort}e.$nv=g;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$ov=R,e.$pv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(o){return e.$pv.indexOf(o)>=0}e.$qv=S,e.$rv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$rv.indexOf(o)>=0}e.$sv=l;function $(o,t,r,a){if(r===1)return!1;if(r===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$tv=$;class v{constructor(t,r,a){this.remoteAddress=t,this.localAddress=r,this.b=a,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$uv=v;let n=class{constructor(t,r){this.j=t,this.k=r,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],r=Array.from(this.e.values());for(const a of r){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:r}of t.values())await r.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,r,a,c,h){this.p(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(l(t)||S(t))&&(t=e.$pv[0]);const a=this.r(t,r);if(a)return++a.refcount,a.value}openTunnel(t,r,a,c,h,i=!1,s,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(r||(r="localhost"),c||(c=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.s(d,r,a,c,h,i,s,u);return b?b.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,a),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(f);return(f.tunnelRemoteHost!==r||f.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.e.get(t.tunnelRemoteHost);if(r){const a=r.get(t.tunnelRemotePort);a&&(a.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async o(t,r,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(r),c}}async closeTunnel(t,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const a=this.e.get(t);if(a&&a.has(r)){const c=a.get(r);c.refcount=0,await this.o(t,r,c)}}p(t,r,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(r,{refcount:1,value:a})}async q(t,r){const a=this.e.get(t);if(a){const c=a.get(r),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(r),a.size===0&&this.e.delete(t)}}r(t,r){const a=[t];S(t)?(a.push(...e.$pv),a.push(...e.$rv)):l(t)&&a.push(...e.$rv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(r);if(i)return i}}canTunnel(t){return!!R(t)}t(t,r,a,c,h,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${a} on local port ${c}.`);const u=a;this.i.add(u);const d=c===void 0?a:c,b={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:r,port:a},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:s},D=t.forwardPort(f,b);return D?(this.p(r,a,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),D}};e.$vv=n,e.$vv=n=Ge([Ke(0,M.$jj),Ke(1,T.$vi)],n)}),define(Pe[198],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$wv=void 0,e.$wv=(0,E.$2h)("editSessionIdentityService");var T;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[199],Ae([1,0,13]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$jK=T;function I(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$kK=I;function M(g){return I(g)?.scheme}e.$lK=M;function A(g){return I(g)?.authority}e.$mK=A;function m(g){return I(g)!==void 0}e.$nK=m}),define(Pe[47],Ae([1,0,156,19,50,25,2,4,13]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,m.$2h)("contextService");function w(d){const b=d;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}e.$_h=w;function R(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$ai=R,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function S(d,b){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:b?e.$bi:e.$ci;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$di=S;function l(d){const b=d;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}e.$ei=l;function $(d){const b=d;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$fi=$;var v;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function n(d){const b=d;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$gi=n;function o(d){const b=d;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$hi=o;class t{constructor(b,f,D,F,p){this.h=b,this.j=D,this.k=F,this.l=p,this.c=I.$8h.forUris(this.l,()=>!0),this.folders=f}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=I.$8h.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=t;class r{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,M.$Dg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=r;function a(d){return new r({uri:d,index:0,name:(0,M.$zg)(d)},{uri:d.toString()})}e.$ki=a,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,E.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function c(d,b){return M.$ug.isEqualOrParent(d,b.untitledWorkspacesHome)}e.$pi=c;function h(d){let b;return A.URI.isUri(d)?b=d:b=d.configuration,b?.scheme===g.Schemas.tmp}e.$qi=h,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$ri}e.$si=i;function s(d,b){return!c(d,b)&&!h(d)}e.$ti=s;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,M.$Bg)(d))===e.$mi}e.$ui=u}),define(Pe[75],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const M=this.c++;return this.b.set(M,I),this.e(),M}get(I,M){return this.b.has(I)?this.b.get(I)[M]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$5ec=E}),define(Pe[43],Ae([1,0,13,25,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$sg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$8ec=M,e.$9ec=(0,I.$2h)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$7M=(0,E.$2h)("IExtHostInitDataService")}),define(Pe[200],Ae([1,0,161,15,187,27]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let A=class extends I.$bO{constructor(g,w,R){const S=R.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=R.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(S,{name:l}))}};e.$chc=A,e.$chc=A=Ge([Ke(1,T.$kj),Ke(2,M.$7M)],A)}),define(Pe[201],Ae([1,0,14]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=void 0;class T{constructor(A,m,g){this.h=new Map,this.a=A,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$bh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const S of w.values())S.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let g=this.f[A];return typeof g>"u"&&(g=m),g}update(A,m){this.f[A]=m;const g=this.h.get(A);if(g!==void 0)return g.p;const w=new E.$mh;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Qfc=T;class I extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$Rfc=I}),define(Pe[202],Ae([1,0,5,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class I{constructor(A){this.c=A,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,g,w){const S=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(m.value,g,w);this.b.fire(S)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$Egc=I}),define(Pe[17],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM=(0,E.$2h)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$RM=T}),define(Pe[203],Ae([1,0,22,5]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;class I{#e;constructor(A,m){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=E.$gm.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$Yfc=I}),define(Pe[57],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0,e.$ofc=(0,E.$2h)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$pfc=T}),define(Pe[204],Ae([1,0,24]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=e.$Wkb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function I(m,g){if(g.serializeBuffersForPostMessage){const w=new T,S=JSON.stringify(m,($,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v)};if(ArrayBuffer.isView(v)){const n=M(v);if(n)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v.buffer),view:{type:n,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=w.buffers.map($=>{const v=new Uint8Array($);return E.$ge.wrap(v)});return{message:S,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Wkb=I;function M(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,g){const w=g.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),R=g.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const v=$,{index:n}=v,o=w[n];if(v.view)switch(v.view.type){case 1:return new Int8Array(o,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return $}:void 0;return{message:JSON.parse(m,R),arrayBuffers:w}}e.$Xkb=A}),define(Pe[102],Ae([1,0,171,16,2,6,4,30,42,13,40,134,31]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=e.$KE=e.$JE=e.EditorsOrder=e.$IE=e.CloseDirection=e.$HE=e.$GE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.EditorInputCapabilities=e.$xE=e.SaveReason=e.Verbosity=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=void 0,e.$kE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$mE="workbench.editor.sidebysideEditor",e.$nE="workbench.editors.textDiffEditor",e.$oE="workbench.editors.binaryResourceDiffEditor";var $;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var v;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function n(oe){const X=oe;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$pE=n;function o(oe,X,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===X&&oe.matches(ne.input))return ne.getViewState()}e.$qE=o;function t(oe){if(D(oe))return!1;const X=oe;return I.URI.isUri(X?.resource)}e.$rE=t;function r(oe){if(D(oe))return!1;const X=oe;return X?.original!==void 0&&X.modified!==void 0}e.$sE=r;function a(oe){if(D(oe))return!1;const X=oe;return Array.isArray(X?.resources)}e.$tE=a;function c(oe){if(D(oe)||r(oe))return!1;const X=oe;return X?.primary!==void 0&&X.secondary!==void 0}e.$uE=c;function h(oe){if(D(oe))return!1;const X=oe;return X?X.resource===void 0||X.resource.scheme===w.Schemas.untitled||X.forceUntitled===!0:!1}e.$vE=h;function i(oe){if(D(oe))return!1;const X=oe;return I.URI.isUri(X?.base?.resource)&&I.URI.isUri(X?.input1?.resource)&&I.URI.isUri(X?.input2?.resource)&&I.URI.isUri(X?.result?.resource)}e.$wE=i;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(X,V){let ne=this.a.get(X);return ne||(ne={source:X,label:V},this.a.set(X,ne)),ne.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$xE=new d;var b;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class f extends M.$Sc{}e.$yE=f;function D(oe){return oe instanceof f}e.$zE=D;function F(oe){const X=oe;return I.URI.isUri(X?.preferredResource)}function p(oe){const X=oe;return D(X?.primary)&&D(X?.secondary)}e.$AE=p;function y(oe){const X=oe;return D(X?.modified)&&D(X?.original)}e.$BE=y;function k(oe,X,V,ne,Ie){return Se(ne,[(0,S.$Li)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Me={...V,limits:{size:Number.MAX_VALUE}};oe.openEditor(X,Me)}}),(0,S.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$CE=k;function O(oe){return D(oe?.editor)}e.$DE=O;function K(oe){const X=oe;return O(oe)&&X?.group!==void 0}e.$EE=K;function U(oe){const X=oe;return typeof X?.groupId=="number"&&D(X.editor)}e.$FE=U;var L;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(L||(e.EditorCloseContext=L={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var C;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class P{getOriginalUri(X,V){if(!X)return;if(i(X))return e.$HE.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(X);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Me,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(r(X)||a(X)||c(X)||i(X))return;const ne=F(X)?X.preferredResource:X.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(X){return p(X)||c(X)?{primary:X.primary,secondary:X.secondary}:y(X)||r(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(i(X))return e.$HE.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(X);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(r(X)||a(X)||c(X)||i(X))return;const ne=X.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(X,V){if(Array.isArray(V)){if(V.some(ne=>X.scheme===ne))return X}else if(V===X.scheme)return X}}var Y;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function ae(oe,X,V,ne){if(!oe.isSticky(X))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===Y.MOUSE||V===Y.KEYBOARD;case"mouse":return V===Y.MOUSE;case"keyboard":return V===Y.KEYBOARD}return!1}e.$GE=ae,e.$HE=new P;var ge;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class ve{constructor(){this.c=new Map,this.d=new Map}start(X){const V=this.a=X.get(A.$1h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(X,V,ne){const Ie=ne.createInstance(V);this.d.set(X,Ie)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,T.$Pf)(this.b)}registerEditorSerializer(X,V){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,V,this.a):this.c.set(X,V),(0,M.$Qc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}m.$tn.add(e.$kE.EditorFactory,new ve);async function De(oe,X,V){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await X.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,ce=ne.type;if(typeof Ce!="boolean"||typeof ce!="number")try{ce=(await X.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(Q){V.error(Q),Ce=!1}if(!Ce&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ce===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return Ce?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$IE=De;var de;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function he(oe){const X=oe;if(!X)return!1;const V=X;if(V.modified)return he(V.modified);const ne=X;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$JE=he;function te(oe){return(0,R.$Ni)(oe)}e.$KE=te;function Se(oe,X,V){const ne=(0,R.$Oi)(oe,X);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$LE=Se}),define(Pe[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$SE=e.$RE=e.ViewContentGroups=e.$QE=e.$PE=e.ViewContainerLocation=e.Extensions=e.$OE=e.$NE=e.$ME=void 0,e.$ME="views",e.$NE=(0,T.localize)(0,null),e.$OE=(0,S.$iw)("default-view-icon",R.$8j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$PE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$QE=v;class n extends M.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,b){const f=this.get(u.id);if(f)return f;const D=u;return D.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,A.$xc)(this.g,d,[]).push(D),b?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:d}),D}deregisterViewContainer(u){for(const d of this.g.keys()){const b=this.g.get(d),f=b?.indexOf(u);if(f!==-1){b?.splice(f,1),b.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}m.$tn.add(l.ViewContainersRegistry,new n);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,b=u.group??o.More;return d!==b?d.localeCompare(b):(s.order??5)-(u.order??5)}class r extends M.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:b})=>this.r(d,b)),this.c.fire(u)}deregisterViews(u,d){const b=this.s(u,d);b.length&&this.f.fire({views:b,viewContainer:d})}moveViews(u,d){for(const b of this.m.keys())if(b!==d){const f=this.s(u,b);f.length&&(this.r(f,d),this.g.fire({views:f,from:b,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const b=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(b)return b}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,M.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const b=new Map;for(const[f,D]of d)this.n.add(u,D),b.set(f,(0,M.$Qc)(()=>{this.n.delete(u,D),this.h.fire(u)}));return this.h.fire(u),b}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,b=>d.push(b)),d.sort(t)}r(u,d){let b=this.m.get(d);b||(b=[],this.m.set(d,b),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));b.push(f)}}s(u,d){const b=this.m.get(d);if(!b)return[];const f=[],D=[];for(const F of b)u.includes(F)?f.push(F):D.push(F);return f.length&&(D.length?this.m.set(d,D):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}m.$tn.add(l.ViewsRegistry,new r),e.$RE=(0,I.$2h)("viewsService"),e.$SE=(0,I.$2h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$kn)(this,u),this.d=!!d,this.resolve=async b=>{if(d&&!this.c){const f=await d(b);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$TE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$UE=i}),define(Pe[206],Ae([1,0,2,29,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$LF=e.$KF=void 0;function M(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Gs.isIRange)}e.$KF=M;function A(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(M)}e.$LF=A;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.InteractiveSessionCopyKind=g={})),e.$MF=(0,I.$2h)("IChatService")}),define(Pe[207],Ae([1,0,5,14,173]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,w,R){const S={command:m};if(g&&Object.keys(g).length>0&&(S.arguments=g),this.s("request",S),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(S.seq);if($){this.f.delete(S.seq);const v={type:"response",seq:0,request_seq:S.seq,success:!1,command:m,message:(0,I.localize)(0,null,R,m)};$(v)}},R)}return w&&this.f.set(S.seq,w),S.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$3g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,w)=>m.set(w,g)),await(0,T.$3g)(500),m.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$qlb=M}),define(Pe[208],Ae([1,0,174,35,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$vH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$uH=e.MemoryRangeType=e.$tH=e.State=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG="workbench.view.debug",e.$rG="workbench.debug.variablesView",e.$sG="workbench.debug.watchExpressionsView",e.$tG="workbench.debug.callStackView",e.$uG="workbench.debug.loadedScriptsView",e.$vG="workbench.debug.breakPointsView",e.$wG="workbench.debug.disassemblyView",e.$xG="workbench.panel.repl",e.$yG="workbench.panel.repl.view",e.$zG=new T.$gj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$AG=new T.$gj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$BG=new T.$gj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$CG="debugUx",e.$DG=new T.$gj(e.$CG,"default",{type:"string",description:E.localize(3,null)}),e.$EG=new T.$gj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$FG=new T.$gj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$GG=new T.$gj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$HG=new T.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$IG=new T.$gj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$JG=new T.$gj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$KG=new T.$gj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$LG=new T.$gj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$MG=new T.$gj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$NG=new T.$gj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$OG=new T.$gj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$PG=new T.$gj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$QG=new T.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$RG=new T.$gj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$SG=new T.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$TG=new T.$gj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$UG=new T.$gj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$VG=new T.$gj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$WG=new T.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$XG=new T.$gj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$YG=new T.$gj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$ZG=new T.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$1G=new T.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$2G=new T.$gj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$3G=new T.$gj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$4G=new T.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$5G=new T.$gj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$6G=new T.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$7G=new T.$gj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$8G=new T.$gj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$9G=new T.$gj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$0G=new T.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$$G=new T.$gj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$_G=new T.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$aH=new T.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$bH=new T.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$cH=new T.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$dH=new T.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$eH=new T.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$fH=new T.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$gH=new T.$gj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$hH=new T.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$iH=new T.$gj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$jH=new T.$gj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$kH=new T.$gj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$lH=new T.$gj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$mH=new T.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$nH=new T.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$oH=M,e.$pH="editor.contrib.debug",e.$qH="editor.contrib.breakpoint",e.$rH="debug",e.$sH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var A;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(A||(e.State=A={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$tH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$uH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$vH=(0,I.$2h)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[209],Ae([1,0,12,2,19,26,13,29,20,18]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0;const R=/{([^}]+)}/g;function S(F,p,y){return F.replace(R,function(k,O){return p&&O.length>0&&O[0]!=="_"?k:y&&y.hasOwnProperty(O)?y[O]:k})}e.$RF=S;function l(F){const p={};for(const y of Object.keys(F))y.startsWith("!")||(p[y]=F[y]);return p}e.$SF=l;function $(F){return F.configuration.request==="attach"&&!v(F)&&(!F.parentSession||$(F.parentSession))}e.$TF=$;function v(F){let p=F.configuration.type;if(p)return p==="vslsShare"&&(p=F.configuration.adapterProxy.configuration.type),(0,E.$8e)(p,"extensionhost")||(0,E.$8e)(p,"pwa-extensionhost")?F:F.parentSession?v(F.parentSession):void 0}e.$UF=v;function n(F){return F.type&&(F.label||F.program||F.runtime)}e.$VF=n;function o(F,p,y){let k,O=0;const K=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=K.exec(F);){const L=U.index+1,z=L+U[0].length;if(L<=p&&z>=y){k=U[0],O=L;break}}if(k){const L=/\w+/g;let z=null;for(;(z=L.exec(k))&&!(z.index+1+O+z[0].length>=y););z&&(k=k.substring(0,L.lastIndex))}return k?{start:O,end:O+k.length-1}:{start:0,end:0}}e.$WF=o;async function t(F,p,y,k){if(F.evaluatableExpressionProvider.has(p)){const O=F.evaluatableExpressionProvider.ordered(p),K=(0,w.$Hb)(await Promise.all(O.map(async U=>{try{return await U.provideEvaluatableExpression(p,y,k??g.CancellationToken.None)}catch{return}})));if(K.length>0){let U=K[0].expression;const L=K[0].range;return U||(U=p.getLineContent(y.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:U}}}else{const O=p.getLineContent(y.lineNumber),{start:K,end:U}=o(O,y.column,y.column),L=O.substring(K-1,U);return{matchingExpression:L,range:new m.$Gs(y.lineNumber,K,y.lineNumber,K+L.length)}}return null}e.$XF=t;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(F){return!!(F&&F.match(r))}e.$YF=a;function c(F){if(typeof F.path=="string"&&!(typeof F.sourceReference=="number"&&F.sourceReference>0)){if(a(F.path))return T.URI.parse(F.path);if((0,I.$ic)(F.path))return T.URI.file(F.path)}return F.path}function h(F){if(typeof F.path=="object"){const p=T.URI.revive(F.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return F.path}function i(F,p){const y=p?c:h,k=(0,M.$hn)(F);return u(k,(O,K)=>{O&&K&&(K.path=y(K))}),k}e.$ZF=i;function s(F,p){const y=p?c:h,k=(0,M.$hn)(F);return u(k,(O,K)=>{!O&&K&&(K.path=y(K))}),k}e.$1F=s;function u(F,p){switch(F.type){case"event":{const y=F;switch(y.event){case"output":p(!1,y.body.source);break;case"loadedSource":p(!1,y.body.source);break;case"breakpoint":p(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=F;switch(y.command){case"setBreakpoints":p(!0,y.arguments.source);break;case"breakpointLocations":p(!0,y.arguments.source);break;case"source":p(!0,y.arguments.source);break;case"gotoTargets":p(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(k=>p(!1,k));break;default:break}break}case"response":{const y=F;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(k=>p(!1,k.source));break;case"loadedSources":y.body.sources.forEach(k=>p(!1,k));break;case"scopes":y.body.scopes.forEach(k=>p(!1,k.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(k=>p(!1,k.source));break;case"setBreakpoints":y.body.breakpoints.forEach(k=>p(!1,k.source));break;case"disassemble":y.body?.instructions.forEach(O=>p(!1,O.location));break;default:break}break}}}function d(F){return F.filter(p=>!p.presentation?.hidden).sort((p,y)=>p.presentation?y.presentation?p.presentation.group?y.presentation.group?p.presentation.group!==y.presentation.group?p.presentation.group.localeCompare(y.presentation.group):b(p.presentation.order,y.presentation.order):-1:y.presentation.group?1:b(p.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$2F=d;function b(F,p){return typeof F!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:F-p}async function f(F,p){const y=F.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(y!=="none"&&(await p.saveAll(),y==="allEditorsInActiveGroup")){const k=p.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:k.input,groupId:k.group.id})}await F.reloadConfiguration()}e.$3F=f;const D=(F,p)=>!F||!p?F===p:F.name===p.name&&F.path===p.path&&F.sourceReference===p.sourceReference;e.$4F=D}),define(Pe[76],Ae([1,0,24,34,67,68,13,19,21,35]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.$RI=e.$QI=e.$PI=e.CellStatusbarAlignment=e.$OI=e.$NI=e.$MI=e.NotebookEditorPriority=e.$LI=e.$KI=e.$JI=e.$II=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HI=e.$GI=e.$FI=e.$EI=e.CellKind=e.$DI=e.$CI=e.$BI=void 0,e.$BI="workbench.editor.notebook",e.$CI="workbench.editor.notebookTextDiffEditor",e.$DI="workbench.editor.interactive";var R;(function(P){P[P.Markup=1]="Markup",P[P.Code=2]="Code"})(R||(e.CellKind=R={})),e.$EI=["application/json","application/javascript","text/html","image/svg+xml",M.$3r.latex,M.$3r.markdown,"image/png","image/jpeg",M.$3r.text],e.$FI=[M.$3r.latex,M.$3r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$3r.text],e.$GI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HI="_notAvailable";var S;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var $;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var v;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var n;(function(P){P.Always="always",P.Never="never",P.Optional="optional"})(n||(e.RendererMessagingSpec=n={}));var o;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.ChangeCellLanguage=5]="ChangeCellLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",P[P.ChangeCellMime=13]="ChangeCellMime",P[P.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var r;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata",P[P.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var a;(function(P){P.scheme=A.Schemas.vscodeNotebookCell;const Y=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${Y.join("")}]+`),ge=7;function ve(oe,X){const V=X.toString(ge),Ie=`${V.length<Y.length?Y[V.length-1]:"z"}${V}s${(0,E.$Ae)(E.$ge.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:P.scheme,fragment:Ie})}P.generate=ve;function De(oe){if(oe.scheme!==P.scheme)return;const X=oe.fragment.indexOf("s");if(X<0)return;const V=parseInt(oe.fragment.substring(0,X).replace(ae,""),ge),ne=(0,E.$ze)(oe.fragment.substring(X+1)).toString();if(!isNaN(V))return{handle:V,notebook:oe.with({scheme:ne,fragment:null})}}P.parse=De;function de(oe,X){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}P.generateCellOutputUri=de;function he(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!X)return;const V=X[1]&&X[1]!==""?X[1]:void 0,ne=X[2];return{outputId:V,notebook:oe.with({scheme:ne||A.Schemas.file,fragment:null})}}P.parseCellOutputUri=he;function te(oe,X,V){return P.generate(oe,X).with({scheme:V})}P.generateCellPropertyUri=te;function Se(oe,X){if(oe.scheme===X)return P.parse(oe.with({scheme:P.scheme}))}P.parseCellPropertyUri=Se})(a||(e.CellUri=a={}));const c=P=>g.$i?P.replace(/\//g,"\\"):P;class h{constructor(Y=[],ae=e.$EI){this.e=ae,this.d=[...new Set(Y)].map(ge=>({pattern:ge,matches:T.$Ij(c(ge))}))}sort(Y){const ae=new Map(I.Iterable.map(Y,ve=>[ve,c(ve)]));let ge=[];for(const{matches:ve}of this.d)for(const[De,de]of ae)if(ve(de)){ge.push(De),ae.delete(De);break}return ae.size&&(ge=ge.concat([...ae.keys()].sort((ve,De)=>this.e.indexOf(ve)-this.e.indexOf(De)))),ge}prioritize(Y,ae){const ge=this.f(Y);if(ge===-1){this.d.unshift({pattern:Y,matches:T.$Ij(c(Y))});return}const ve=new Set(ae.map(de=>this.f(de,ge)));ve.delete(-1);const De=Array.from(ve).sort();this.d.splice(ge+1,0,...De.map(de=>this.d[de]));for(let de=De.length-1;de>=0;de--)this.d.splice(De[de],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,ae=this.d.length){const ge=c(Y);for(let ve=0;ve<ae;ve++)if(this.d[ve].matches(ge))return ve;return-1}}e.$II=h;function i(P,Y,ae,ge=(ve,De)=>ve===De){const ve=[];function De(te,Se,oe){if(Se===0&&oe.length===0)return;const X=ve[ve.length-1];X&&X.start+X.deleteCount===te?(X.deleteCount+=Se,X.toInsert.push(...oe)):ve.push({start:te,deleteCount:Se,toInsert:oe})}let de=0,he=0;for(;;){if(de===P.length){De(de,0,Y.slice(he));break}if(he===Y.length){De(de,P.length-de,[]);break}const te=P[de],Se=Y[he];if(ge(te,Se)){de+=1,he+=1;continue}ae(Se)?(De(de,1,[]),de+=1):(De(de,0,[Se]),he+=1)}return ve}e.$JI=i,e.$KI=new w.$gj("notebookEditorCursorAtBoundary","none"),e.$LI=new w.$gj("notebookEditorCursorAtLineBoundary","none");var s;(function(P){P.default="default",P.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(P){const Y=P;return!!((typeof Y.include=="string"||T.$Jj(Y.include))&&(typeof Y.exclude=="string"||T.$Jj(Y.exclude)))}e.$MI=u;function d(P,Y,ae){if(Array.isArray(P.viewType)&&P.viewType.indexOf(Y)>=0||P.viewType===Y)return!0;if(P.filenamePattern){const ge=u(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,ve=u(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(T.$Hj(ge,(0,m.$nc)(ae.fsPath).toLowerCase()))return!(ve&&T.$Hj(ve,(0,m.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$NI=d,e.$OI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var b;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class f{static{this.d="notebook/"}static create(Y){return`${f.d}${Y}`}static parse(Y){if(Y.startsWith(f.d))return Y.substring(f.d.length)}}e.$PI=f;function D(P){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(P)}e.$QI=D;const F=new TextDecoder;function p(P){const Y=[];let ae=!1;for(const de of P)(Y.length===0||ae)&&(Y.push(de),ae=!0);let ge=O(Y);const ve=E.$ge.concat(Y.map(de=>E.$ge.wrap(de))),De=C(ve);return ge=ge||De.byteLength!==ve.byteLength,{data:De,didCompression:ge}}e.$RI=p,e.$SI=`${String.fromCharCode(27)}[A`;const y=e.$SI.split("").map(P=>P.charCodeAt(0)),k=10;function O(P){let Y=!1;return P.forEach((ae,ge)=>{if(ge===0||ae.length<e.$SI.length)return;const ve=P[ge-1],De=ae.subarray(0,e.$SI.length);if(De[0]===y[0]&&De[1]===y[1]&&De[2]===y[2]){const de=ve.lastIndexOf(k);if(de===-1)return;Y=!0,P[ge-1]=ve.subarray(0,de),P[ge]=ae.subarray(e.$SI.length)}}),Y}function K(P){let Y=P;do P=Y,Y=P.replace(/[^\n]\x08/gm,"");while(Y.length<P.length);return P}function U(P){for(P=P.replace(/\r+\n/gm,`
`);P.search(/\r[^$]/g)>-1;){const Y=P.match(/^(.*)\r+/m)[1];let ae=P.match(/\r+(.*)$/m)[1];ae=ae+Y.slice(ae.length,Y.length),P=P.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return P}const L="\b".charCodeAt(0),z="\r".charCodeAt(0);function C(P){return!P.buffer.includes(L)&&!P.buffer.includes(z)?P:E.$ge.fromString(U(K(F.decode(P.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v){"use strict";var n,o,t,r,a,c,h,i,s,u,d,b,f,D,F,p,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$FM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$EM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.TestRunProfileKind=e.TestResultState=e.$kM=e.$jM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$iM=e.NotebookVariablesRequestKind=e.$hM=e.$gM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$fM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.ColorThemeKind=e.$_L=e.$$L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$0L=e.DebugConsoleMode=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$4L=e.$3L=e.FileChangeType=e.$2L=e.$1L=e.$ZL=e.$YL=e.InlineCompletionTriggerKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.ConfigurationTarget=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BL=e.ViewBadge=e.ProgressLocation=e.$AL=e.$zL=e.TaskScope=e.ShellQuoting=e.$yL=e.$xL=e.$wL=e.TaskPanelKind=e.TaskRevealKind=e.$vL=e.TerminalLocation=e.$uL=e.$tL=e.$sL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rL=e.$qL=e.$pL=e.$oL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$nL=e.StatusBarAlignment=e.ViewColumn=e.$mL=e.$lL=e.$kL=e.$jL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iL=e.$hL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.LanguageStatusSeverity=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.CodeActionTriggerKind=e.$8K=e.$7K=e.SymbolTag=e.SymbolKind=e.$6K=e.$5K=e.DocumentHighlightKind=e.$4K=e.$3K=e.$2K=e.$1K=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZK=e.$YK=e.FileEditType=e.$XK=e.$WK=e.$VK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(W){return Object.assign(W,{apply:function(...se){if(se.length===0)return Reflect.construct(W,[]);{const ke=se.length===1?[]:se[1];return Reflect.construct(W,ke,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(W,[]);{const[ke,...Je]=se;return Reflect.construct(W,Je,ke.constructor)}}})}var O;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var K;(function(W){W[W.TerminalCommand=0]="TerminalCommand",W[W.Opener=1]="Opener",W[W.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let U=n=class{static from(...j){let se=j;return new n(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$OK=U,e.$OK=U=n=Ge([k],U);let L=o=class{static Min(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let ke=1;ke<j.length;ke++){const Je=j[ke];Je.isBefore(se)&&(se=Je)}return se}static Max(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let ke=1;ke<j.length;ke++){const Je=j[ke];Je.isAfter(se)&&(se=Je)}return se}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:se,character:ke}=j;return typeof se=="number"&&typeof ke=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,se){if(j<0)throw(0,T.$7)("line must be non-negative");if(se<0)throw(0,T.$7)("character must be non-negative");this.c=j,this.e=se}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,se=0){if(j===null||se===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,se=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&se===0?this:new o(this.line+ke,this.character+se)}with(j,se=this.character){if(j===null||se===null)throw(0,T.$7)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,se=typeof j.character=="number"?j.character:this.character),ke===this.line&&se===this.character?this:new o(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.$PK=L,e.$PK=L=o=Ge([k],L);let z=t=class{static isRange(j){return j instanceof t?!0:j?L.isPosition(j.start)&&L.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,se,ke,Je){let xe,ct;if(typeof j=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"?(xe=new L(j,se),ct=new L(ke,Je)):L.isPosition(j)&&L.isPosition(se)&&(xe=L.of(j),ct=L.of(se)),!xe||!ct)throw new Error("Invalid arguments");xe.isBefore(ct)?(this.c=xe,this.e=ct):(this.c=ct,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):L.isPosition(j)?!(L.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const se=L.Max(j.start,this.c),ke=L.Min(j.end,this.e);if(!se.isAfter(ke))return new t(se,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const se=L.Min(j.start,this.c),ke=L.Max(j.end,this.end);return new t(se,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,se=this.end){if(j===null||se===null)throw(0,T.$7)();let ke;return j?L.isPosition(j)?ke=j:(ke=j.start||this.start,se=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&se.isEqual(this.end)?this:new t(ke,se)}toJSON(){return[this.start,this.end]}};e.$QK=z,e.$QK=z=t=Ge([k],z);let C=r=class extends z{static isSelection(j){return j instanceof r?!0:j?z.isRange(j)&&L.isPosition(j.anchor)&&L.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,se,ke,Je){let xe,ct;if(typeof j=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"?(xe=new L(j,se),ct=new L(ke,Je)):L.isPosition(j)&&L.isPosition(se)&&(xe=L.of(j),ct=L.of(se)),!xe||!ct)throw new Error("Invalid arguments");super(xe,ct),this.f=xe,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$RK=C,e.$RK=C=r=Ge([k],C);const P=W=>{if(typeof W!="string"||W.length===0||!/^[0-9A-Za-z_\-]+$/.test(W))throw(0,T.$7)("connectionToken")};class Y{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se,ke){if(typeof j!="string"||j.length===0)throw(0,T.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,T.$7)("port");typeof ke<"u"&&P(ke),this.host=j,this.port=Math.round(se),this.connectionToken=ke}}e.$SK=Y;class ae{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se){this.makeConnection=j,this.connectionToken=se,typeof se<"u"&&P(se)}}e.$TK=ae;class ge extends Error{static NotAvailable(j,se){return new ge(j,$.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(j){return new ge(j,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,se=$.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=se,this._detail=ke,Object.setPrototypeOf(this,ge.prototype)}}e.$UK=ge;var ve;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var De;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let de=a=class{static isTextEdit(j){return j instanceof a?!0:j?z.isRange(j)&&typeof j.newText=="string":!1}static replace(j,se){return new a(j,se)}static insert(j,se){return a.replace(new z(j,j),se)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const se=new a(new z(new L(0,0),new L(0,0)),"");return se.newEol=j,se}get range(){return this.c}set range(j){if(j&&!z.isRange(j))throw(0,T.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$7)("newEol");this.f=j}constructor(j,se){this.c=j,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VK=de,e.$VK=de=a=Ge([k],de);let he=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?_t.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,se){return new c(j,se)}static insertCells(j,se){return new c(new _t(j,j),se)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,se){const ke=new c(new _t(j,j),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(j){const se=new c(new _t(0,0),[]);return se.newNotebookMetadata=j,se}constructor(j,se){this.range=j,this.newCells=se}};e.$WK=he,e.$WK=he=c=Ge([k],he);class te{static isSnippetTextEdit(j){return j instanceof te?!0:j?z.isRange(j.range)&&X.isSnippetString(j.snippet):!1}static replace(j,se){return new te(j,se)}static insert(j,se){return te.replace(new z(j,j),se)}constructor(j,se){this.range=j,this.snippet=se}}e.$XK=te;var Se;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,se,ke,Je){this.c.push({_type:1,from:j,to:se,options:ke,metadata:Je})}createFile(j,se,ke){this.c.push({_type:1,from:void 0,to:j,options:se,metadata:ke})}deleteFile(j,se,ke){this.c.push({_type:1,from:j,to:void 0,options:se,metadata:ke})}e(j,se,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:se},notebookMetadata:se})}f(j,se,ke,Je){const xe=se.start,ct=se.end;(xe!==ct||ke.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ct-xe,cells:ke,metadata:Je})}g(j,se,ke,Je){this.c.push({_type:3,metadata:Je,uri:j,edit:{editType:3,index:se,metadata:ke}})}replace(j,se,ke,Je){this.c.push({_type:2,uri:j,edit:new de(se,ke),metadata:Je})}insert(j,se,ke,Je){this.replace(j,new z(se,se),ke,Je)}delete(j,se,ke){this.replace(j,se,"",ke)}has(j){return this.c.some(se=>se._type===2&&se.uri.toString()===j.toString())}set(j,se){if(se)for(const ke of se){if(!ke)continue;let Je,xe;Array.isArray(ke)?(Je=ke[0],xe=ke[1]):Je=ke,he.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(j,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(j,Je.newNotebookMetadata,xe):this.f(j,Je.range,Je.newCells,xe):te.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:j,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Je,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Je=this.c[ke];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const se=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&se.push(ke.edit);return se}entries(){const j=new M.$Ac;for(const se of this.c)if(se._type===2){let ke=j.get(se.uri);ke||(ke=[se.uri,[]],j.set(se.uri,ke)),ke[1].push(se.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YK=oe,e.$YK=oe=Ge([k],oe);let X=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,se=this.e++){if(typeof j=="function"){const ke=new h;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=h.c(j);return this.value+="${",this.value+=se,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,se=this.e++){const ke=j.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,se){if(typeof se=="function"){const ke=new h;ke.e=this.e,se(ke),this.e=ke.e,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$ZK=X,e.$ZK=X=h=Ge([k],X);var V;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?z.isRange(j.range)&&w.URI.isUri(j.uri):!1}constructor(j,se){if(this.uri=j,se)if(z.isRange(se))this.range=z.of(se);else if(L.isPosition(se))this.range=new z(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1K=Ie,e.$1K=Ie=i=Ge([k],Ie);let Me=class{static is(j){return j?typeof j.message=="string"&&j.location&&z.isRange(j.location.range)&&w.URI.isUri(j.location.uri):!1}constructor(j,se){this.location=j,this.message=se}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.location.range.isEqual(se.location.range)&&j.location.uri.toString()===se.location.uri.toString()}};e.$2K=Me,e.$2K=Me=Ge([k],Me);let Ce=class{constructor(j,se,ke=ne.Error){if(!z.isRange(j))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=j,this.message=se,this.severity=ke}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.severity===se.severity&&j.code===se.code&&j.severity===se.severity&&j.source===se.source&&j.range.isEqual(se.range)&&(0,E.$ub)(j.tags,se.tags)&&(0,E.$ub)(j.relatedInformation,se.relatedInformation,Me.isEqual)}};e.$3K=Ce,e.$3K=Ce=Ge([k],Ce);let ce=class{constructor(j,se){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=se}};e.$4K=ce,e.$4K=ce=Ge([k],ce);var ie;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let Q=class{constructor(j,se=ie.Text){this.range=j,this.kind=se}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$5K=Q,e.$5K=Q=Ge([k],Q);let ee=class{constructor(j,se){this.uri=j,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$6K=ee,e.$6K=ee=Ge([k],ee);var $e;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var be;(function(W){W[W.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Le=s=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,se,ke,Je,xe){this.name=j,this.kind=se,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Je instanceof Ie?this.location=Je:ke instanceof z&&(this.location=new Ie(Je,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$7K=Le,e.$7K=Le=s=Ge([k],Le);let le=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,se,ke,Je,xe){this.name=j,this.detail=se,this.kind=ke,this.range=Je,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$8K=le,e.$8K=le=u=Ge([k],le);var we;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let N=class{constructor(j,se){this.title=j,this.kind=se}};e.$9K=N,e.$9K=N=Ge([k],N);let q=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$0K=q,e.$0K=q=d=Ge([k],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let H=class{constructor(j,se){if(this.range=j,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$K=H,e.$$K=H=Ge([k],H);class B{constructor(j,se,ke,Je,xe,ct){this.kind=j,this.name=se,this.detail=ke,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$_K=B;class J{constructor(j,se){this.fromRanges=se,this.from=j}}e.$aL=J;class _{constructor(j,se){this.fromRanges=se,this.to=j}}e.$bL=_;var ye;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let Te=class{constructor(j,se){this.range=j,this.command=se}get isResolved(){return!!this.command}};e.$cL=Te,e.$cL=Te=Ge([k],Te);let We=b=class{#e;static isMarkdownString(j){return j instanceof b?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,se=!1){this.#e=new I.$dk(j,{supportThemeIcons:se})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,se){return this.#e.appendCodeblock(se??"",j),this}};e.$dL=We,e.$dL=We=b=Ge([k],We);let He=class{constructor(j,se){this.label=j,this.documentation=se}};e.$eL=He,e.$eL=He=Ge([k],He);let Ye=class{constructor(j,se){this.label=j,this.documentation=se,this.parameters=[]}};e.$fL=Ye,e.$fL=Ye=Ge([k],Ye);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gL=rt,e.$gL=rt=Ge([k],rt);var it;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let ot=class{constructor(j){this.value=j}};e.$hL=ot,e.$hL=ot=Ge([k],ot);let at=class{constructor(j,se,ke){this.position=j,this.label=se,this.kind=ke}};e.$iL=at,e.$iL=at=Ge([k],at);var ze;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var pt;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var Z;(function(W){W[W.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let x=class{constructor(j,se){this.label=j,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jL=x,e.$jL=x=Ge([k],x);let pe=class{constructor(j=[],se=!1){this.items=j,this.isIncomplete=se}};e.$kL=pe,e.$kL=pe=Ge([k],pe);let Ue=class{constructor(j,se,ke){this.insertText=j,this.range=se,this.command=ke}};e.$lL=Ue,e.$lL=Ue=Ge([k],Ue);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$mL=Qe,e.$mL=Qe=Ge([k],Qe);var tt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var nt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(W,j){return`${S.$gm.toKey(W)}.${j}`}e.$nL=Ne;var It;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(It||(e.TextEditorLineNumbersStyle=It={}));var Lt;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var Kt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Bt;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var wt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(wt||(e.TextDocumentChangeReason=wt={}));var qt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(W){function j(se){switch(se){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=j}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Ft;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Ft||(e.SyntaxTokenType=Ft={})),function(W){function j(se){switch(se){case W.Other:return"other";case W.Comment:return"comment";case W.String:return"string";case W.RegEx:return"regex"}return"other"}W.toString=j}(Ft||(e.SyntaxTokenType=Ft={}));let Qt=class{constructor(j,se){if(se&&!w.URI.isUri(se))throw(0,T.$7)("target");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.target=se}};e.$oL=Qt,e.$oL=Qt=Ge([k],Qt);let Ot=class{constructor(j,se,ke,Je){this.red=j,this.green=se,this.blue=ke,this.alpha=Je}};e.$pL=Ot,e.$pL=Ot=Ge([k],Ot);let Ct=class{constructor(j,se){if(se&&!(se instanceof Ot))throw(0,T.$7)("color");if(!z.isRange(j)||j.isEmpty)throw(0,T.$7)("range");this.range=j,this.color=se}};e.$qL=Ct,e.$qL=Ct=Ge([k],Ct);let Xe=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$7)("label");this.label=j}};e.$rL=Xe,e.$rL=Xe=Ge([k],Xe);var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Gt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var ut;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class mt{constructor(j,se,ke){if(this.startIndex=j,this.length=se,this.tooltip=ke,typeof j!="number"||j<0)throw(0,T.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,T.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,T.$7)("tooltip")}}e.$sL=mt;class jt{constructor(j){this.uri=j}}e.$tL=jt;class Ut{constructor(j){this.terminalCommand=j}}e.$uL=Ut;var Et;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class ht{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$7)("options")}}e.$vL=ht;var Pt;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Xt;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let kt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,se){if(this.label=se,typeof j!="string"||typeof se!="string")throw(0,T.$7)("name");this.c=j}get id(){return this.c}};e.$wL=kt,e.$wL=kt=f=Ge([k],kt);function qe(W){let j="";for(let se=0;se<W.length;se++)j+=W[se].replace(/,/g,",,")+",";return j}let Rt=class{constructor(j,se,ke){if(typeof j!="string")throw(0,T.$7)("process");this.e=[],this.c=j,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ke):this.f=se)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const se of this.e)j.push(se);return qe(j)}};e.$xL=Rt,e.$xL=Rt=Ge([k],Rt);let Wt=class{constructor(j,se,ke){if(this.f=[],Array.isArray(se)){if(!j)throw(0,T.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j,this.f=se,this.g=ke}else{if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j,this.g=se}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)j.push(typeof se=="string"?se:se.value);return qe(j)}};e.$yL=Wt,e.$yL=Wt=Ge([k],Wt);var Jt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var ft;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Mt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.$mg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$zL=Mt;let Ee=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,se,ke,Je,xe,ct){this.k=!1,this.l=this.definition=j;let dt;typeof se=="string"?(this.n=this.name=se,this.u=this.source=ke,this.execution=Je,dt=xe,this.k=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this.n=this.name=ke,this.u=this.source=Je,this.execution=xe,dt=ct):(this.target=se,this.n=this.name=ke,this.u=this.source=Je,this.execution=xe,dt=ct),typeof dt=="string"?(this.q=[dt],this.r=!0):Array.isArray(dt)?(this.q=dt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Rt?this.l={type:D.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:D.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:D.c,id:this.o.computeId()}:this.l={type:D.g,id:(0,R.$mg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,T.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const se=this.l.type;(D.g===se||D.e===se||D.f===se||D.c===se)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$AL=Ee,e.$AL=Ee=D=Ge([k],Ee);var Fe;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var fe;(function(W){function j(se){const ke=se;return(0,g.$If)(ke.value)?ke.tooltip&&!(0,g.$Ef)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}W.isViewBadge=j})(fe||(e.ViewBadge=fe={}));let G=F=class{static isTreeItem(j,se){const ke=j;if(ke.checkboxState!==void 0){const Je=(0,g.$If)(ke.checkboxState)?ke.checkboxState:(0,g.$Gf)(ke.checkboxState)&&(0,g.$If)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,g.$If)(ke.checkboxState)&&(0,g.$Gf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Be.Checked&&Je!==Be.Unchecked||xe!==void 0&&!(0,g.$Ef)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(j instanceof F)return!0;if(ke.label!==void 0&&!(0,g.$Ef)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,g.$Ef)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,g.$Ef)(ke.iconPath)&&!w.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,g.$Ef)(ke.iconPath.id))){const Je=ke.iconPath;if(!Je||!(0,g.$Ef)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,g.$Ef)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,g.$Ef)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!w.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,g.$Ef)(ke.tooltip)&&!(ke.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Re.None&&ke.collapsibleState>Re.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,g.$Ef)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(j,se=Re.None){this.collapsibleState=se,w.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$BL=G,e.$BL=G=F=Ge([k],G);var Re;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Re||(e.TreeItemCollapsibleState=Re={}));var Be;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Be||(e.TreeItemCheckboxState=Be={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$CL=Ze,e.$CL=Ze=Ge([k],Ze);class Ve extends Ze{}e.$DL=Ve;class _e extends Ve{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$EL=_e;class gt{constructor(j,se,ke,Je){this.name=j,this.uri=se,this._itemId=ke,this.c=Je}data(){return this.c()}}e.$FL=gt;let zt=class{#e=new Map;constructor(j){for(const[se,ke]of j??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(ke):this.#e.set(this.#t(se),[ke])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,se){this.#e.set(this.#t(j),[se])}forEach(j,se){for(const[ke,Je]of this.#e)for(const xe of Je)j.call(se,xe,ke,this)}*[Symbol.iterator](){for(const[j,se]of this.#e)for(const ke of se)yield[j,ke]}#t(j){return j.toLowerCase()}};e.$GL=zt,e.$GL=zt=Ge([k],zt);let yt=class{constructor(j){this.insertText=j}};e.$HL=yt,e.$HL=yt=Ge([k],yt);let Dt=class{constructor(j,se){this.label=se,this.insertText=j}};e.$IL=Dt,e.$IL=Dt=Ge([k],Dt);let bt=class{constructor(j,se){this.id=j,this.color=se}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$JL=bt,e.$JL=bt=Ge([k],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let mi=class{constructor(j){this.id=j}};e.$KL=mi,e.$KL=mi=Ge([k],mi);var At;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Di=class{get base(){return this.c}set base(j){this.c=j,this.e=w.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,se){if(typeof j!="string"&&(!j||!w.URI.isUri(j)&&!w.URI.isUri(j.uri)))throw(0,T.$7)("base");if(typeof se!="string")throw(0,T.$7)("pattern");typeof j=="string"?this.baseUri=w.URI.file(j):w.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$LL=Di,e.$LL=Di=Ge([k],Di);const Vi=new WeakMap;function St(W,j){Vi.set(W,j)}e.$ML=St;let ni=class{constructor(j,se,ke,Je){this.enabled=typeof j=="boolean"?j:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,R.$mg)()),this.c}};e.$NL=ni,e.$NL=ni=Ge([k],ni);let $i=class extends ni{constructor(j,se,ke,Je,xe){if(super(se,ke,Je,xe),j===null)throw(0,T.$7)("location");this.location=j}};e.$OL=$i,e.$OL=$i=Ge([k],$i);let ai=class extends ni{constructor(j,se,ke,Je,xe){super(se,ke,Je,xe),this.functionName=j}};e.$PL=ai,e.$PL=ai=Ge([k],ai);let Si=class extends ni{constructor(j,se,ke,Je,xe,ct,dt){if(super(Je,xe,ct,dt),!se)throw(0,T.$7)("dataId");this.label=j,this.dataId=se,this.canPersist=ke}};e.$QL=Si,e.$QL=Si=Ge([k],Si);let Ii=class{constructor(j,se,ke){this.command=j,this.args=se||[],this.options=ke}};e.$RL=Ii,e.$RL=Ii=Ge([k],Ii);let Tt=class{constructor(j,se){this.port=j,this.host=se}};e.$SL=Tt,e.$SL=Tt=Ge([k],Tt);let pi=class{constructor(j){this.path=j}};e.$TL=pi,e.$TL=pi=Ge([k],pi);let Ci=class{constructor(j){this.implementation=j}};e.$UL=Ci,e.$UL=Ci=Ge([k],Ci);let ci=class{constructor(j,se,ke){this.session=j,this.threadId=se,this.frameId=ke}};e.$VL=ci,e.$VL=ci=Ge([k],ci);let ui=class{constructor(j,se){this.session=j,this.threadId=se}};e.$WL=ui,e.$WL=ui=Ge([k],ui);let lt=class{constructor(j,se){this.range=j,this.expression=se}};e.$XL=lt,e.$XL=lt=Ge([k],lt);var qi;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let xt=class{constructor(j,se){this.range=j,this.text=se}};e.$YL=xt,e.$YL=xt=Ge([k],xt);let ri=class{constructor(j,se,ke=!0){this.range=j,this.variableName=se,this.caseSensitiveLookup=ke}};e.$ZL=ri,e.$ZL=ri=Ge([k],ri);let di=class{constructor(j,se){this.range=j,this.expression=se}};e.$1L=di,e.$1L=di=Ge([k],di);let Pi=class{constructor(j,se){this.frameId=j,this.stoppedLocation=se}};e.$2L=Pi,e.$2L=Pi=Ge([k],Pi);var Ki;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ai=p=class extends Error{static FileExists(j){return new p(j,l.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(j){return new p(j,l.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(j){return new p(j,l.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(j){return new p(j,l.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(j){return new p(j,l.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(j){return new p(j,l.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(j,se=l.FileSystemProviderErrorCode.Unknown,ke){super(w.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,l.$Ak)(this,se),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$3L=Ai,e.$3L=Ai=p=Ge([k],Ai);let vi=class{constructor(j,se,ke){this.start=j,this.end=se,this.kind=ke}};e.$4L=vi,e.$4L=vi=Ge([k],vi);var Hi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ri;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var li;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(j,se=[]){this.tokenTypes=j,this.tokenModifiers=se}}e.$5L=Mi;function cn(W){return typeof W>"u"||(0,g.$Ff)(W)}class Li{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let se=0,ke=j.tokenTypes.length;se<ke;se++)this.k.set(j.tokenTypes[se],se);for(let se=0,ke=j.tokenModifiers.length;se<ke;se++)this.l.set(j.tokenModifiers[se],se)}}push(j,se,ke,Je,xe){if(typeof j=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,se,ke,Je,xe);if(z.isRange(j)&&typeof se=="string"&&cn(ke))return this.n(j,se,ke);throw(0,T.$7)()}n(j,se,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=j.start.line,xe=j.start.character,ct=j.end.character-j.start.character,dt=this.k.get(se);let Vt=0;if(ke)for(const Yt of ke){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Yt);Vt|=1<<ti>>>0}this.o(Je,xe,ct,dt,Vt)}o(j,se,ke,Je,xe){if(this.f&&(j<this.c||j===this.c&&se<this.e)){this.f=!1;const Vt=this.g.length/5|0;let Yt=0,ti=0;for(let ii=0;ii<Vt;ii++){let oi=this.g[5*ii],Ui=this.g[5*ii+1];oi===0?(oi=Yt,Ui+=ti):oi+=Yt,this.g[5*ii]=oi,this.g[5*ii+1]=Ui,Yt=oi,ti=Ui}}let ct=j,dt=se;this.f&&this.j>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=dt,this.g[this.j++]=ke,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=j,this.e=se}static q(j){const se=[],ke=j.length/5|0;for(let dt=0;dt<ke;dt++)se[dt]=dt;se.sort((dt,Vt)=>{const Yt=j[5*dt],ti=j[5*Vt];if(Yt===ti){const ii=j[5*dt+1],oi=j[5*Vt+1];return ii-oi}return Yt-ti});const Je=new Uint32Array(j.length);let xe=0,ct=0;for(let dt=0;dt<ke;dt++){const Vt=5*se[dt],Yt=j[Vt+0],ti=j[Vt+1],ii=j[Vt+2],oi=j[Vt+3],Ui=j[Vt+4],Dn=Yt-xe,On=Dn===0?ti-ct:ti,Wi=5*dt;Je[Wi+0]=Dn,Je[Wi+1]=On,Je[Wi+2]=ii,Je[Wi+3]=oi,Je[Wi+4]=Ui,xe=Yt,ct=ti}return Je}build(j){return this.f?new si(new Uint32Array(this.g),j):new si(Li.q(this.g),j)}}e.$6L=Li;class si{constructor(j,se){this.resultId=se,this.data=j}}e.$7L=si;class un{constructor(j,se,ke){this.start=j,this.deleteCount=se,this.data=ke}}e.$8L=un;class ln{constructor(j,se){this.resultId=se,this.edits=j}}e.$9L=ln;var Ji;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$0L=fi,e.$0L=fi=Ge([k],fi);var Qi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(j){if(typeof j.badge=="string"){let se=(0,m.$ff)(j.badge,0);if(se<j.badge.length&&(se+=(0,m.$ff)(j.badge,se)),j.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,se,ke){this.badge=j,this.tooltip=se,this.color=ke}}e.$$L=Yi;let Fi=class{constructor(j){this.kind=j}};e.$_L=Fi,e.$_L=Fi=Ge([k],Fi);var Ti;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(j){return j instanceof _t?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,se){if(j<0)throw(0,T.$7)("start must be positive");if(se<0)throw(0,T.$7)("end must be positive");j<=se?(this.c=j,this.e=se):(this.c=se,this.e=j)}with(j){let se=this.c,ke=this.e;return j.start!==void 0&&(se=j.start),j.end!==void 0&&(ke=j.end),se===this.c&&ke===this.e?this:new _t(se,ke)}}e.$aM=_t;class wi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(j){return!0}constructor(j,se,ke,Je,xe,ct,dt){this.kind=j,this.value=se,this.languageId=ke,this.mime=Je,this.outputs=xe??[],this.metadata=ct,this.executionSummary=dt,wi.validate(this)}}e.$bM=wi;class hn{constructor(j){this.cells=j}}e.$cM=hn;class Zt{static isNotebookCellOutputItem(j){return j instanceof Zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const se={name:j.name,message:j.message,stack:j.stack};return Zt.json(se,"application/vnd.code.notebook.error")}static stdout(j){return Zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,se="application/octet-stream"){return new Zt(j,se)}static#e=new TextEncoder;static text(j,se=A.$3r.text){const ke=Zt.#e.encode(String(j));return new Zt(ke,se)}static json(j,se="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return Zt.text(ke,se)}constructor(j,se){this.data=j,this.mime=se;const ke=(0,A.$7r)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$dM=Zt;class yi{static isNotebookCellOutput(j){return j instanceof yi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,se=!1){const ke=new Set,Je=new Set;for(let xe=0;xe<j.length;xe++){const ct=j[xe],dt=(0,A.$7r)(ct.mime);if(!ke.has(dt)||(0,v.$QI)(dt)){ke.add(dt);continue}Je.add(xe),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Je.size===0?j:j.filter((xe,ct)=>!Je.has(ct))}constructor(j,se,ke){this.items=yi.ensureUniqueMimeTypes(j,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,R.$mg)(),this.metadata=se??ke)}}e.$eM=yi;var Ei;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Ni;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var je;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(je||(e.NotebookCellStatusBarAlignment=je={}));var ei;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(j,se){this.text=j,this.alignment=se}}e.$fM=Xi;var $t;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var xi;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(j,se=[]){this.uri=j,this.provides=(0,E.$3b)(se)}}e.$gM=dn;class _i{constructor(j){this.label=j}}e.$hM=_i;var en;(function(W){W[W.Named=1]="Named",W[W.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(j,se){this.label=j,this.timestamp=se}};e.$iM=hi,e.$iM=hi=Ge([k],hi);var tn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(j,se){this.ranges=j,this.wordPattern=se}}e.$jM=sn;class fn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$kM=fn;var on;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(j=void 0,se=void 0,ke=void 0,Je=!1){this.include=j,this.exclude=se,this.profile=ke,this.continuous=Je}};e.$lM=Oi,e.$lM=Oi=Ge([k],Oi);let ji=y=class{static diff(j,se,ke){const Je=new y(j);return Je.expectedOutput=se,Je.actualOutput=ke,Je}constructor(j){this.message=j}};e.$mM=ji,e.$mM=ji=y=Ge([k],ji);let zi=class{constructor(j){this.id=j}};e.$nM=zi,e.$nM=zi=Ge([k],zi);class ki{constructor(j,se){this.covered=j,this.total=se}}e.$oM=ki;class Bi{static fromDetails(j,se){const ke=new ki(0,0),Je=new ki(0,0),xe=new ki(0,0);for(const dt of se)if("branches"in dt){ke.total+=1,ke.covered+=dt.executionCount>0?1:0;for(const Vt of dt.branches)Je.total+=1,Je.covered+=Vt.executionCount>0?1:0}else xe.total+=1,xe.covered+=dt.executionCount>0?1:0;const ct=new Bi(j,ke,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ct.detailedCoverage=se,ct}constructor(j,se,ke,Je){this.uri=j,this.statementCoverage=se,this.branchCoverage=ke,this.functionCoverage=Je}}e.$pM=Bi;class gn{constructor(j,se,ke=[]){this.executionCount=j,this.location=se,this.branches=ke}}e.$qM=gn;class mn{constructor(j,se){this.executionCount=j,this.location=se}}e.$rM=mn;class re{constructor(j,se,ke){this.name=j,this.executionCount=se,this.location=ke}}e.$sM=re;var ue;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var st;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class vt{constructor(j,se,ke,Je,xe,ct){this.kind=j,this.name=se,this.detail=ke,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$tM=vt;class Nt{constructor(j){this.uri=j}}e.$uM=Nt;class Sn{constructor(j,se){this.original=j,this.modified=se}}e.$vM=Sn;class In{constructor(j,se,ke,Je){this.base=j,this.input1=se,this.input2=ke,this.result=Je}}e.$wM=In;class Cn{constructor(j,se){this.uri=j,this.viewType=se}}e.$xM=Cn;class Pn{constructor(j){this.viewType=j}}e.$yM=Pn;class An{constructor(j,se){this.uri=j,this.notebookType=se}}e.$zM=An;class Rn{constructor(j,se,ke){this.original=j,this.modified=se,this.notebookType=ke}}e.$AM=Rn;class Mn{constructor(){}}e.$BM=Mn;class Ln{constructor(j,se){this.uri=j,this.inputBoxUri=se}}e.$CM=Ln;class Fn{constructor(j){this.providerId=j}}e.$DM=Fn;var $n;(function(W){W[W.Down=0]="Down",W[W.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(W){W[W.Action=1]="Action",W[W.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(W){W[W.Short=1]="Short",W[W.Medium=2]="Medium",W[W.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(j,se){this.label=j,this.values=se}}e.$EM=Tn;var bn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful",W[W.Undone=2]="Undone",W[W.Accepted=3]="Accepted",W[W.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(W){W[W.System=0]="System",W[W.User=1]="User",W[W.Assistant=2]="Assistant",W[W.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Nn{constructor(j,se){this.role=j,this.content=se}}e.$FM=Nn;var yn;(function(W){W[W.Unhelpful=0]="Unhelpful",W[W.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(W){W[W.SymbolInformation=1]="SymbolInformation",W[W.CommandInformation=2]="CommandInformation",W[W.SearchInformation=3]="SearchInformation",W[W.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var kn;(function(W){W[W.Started=1]="Started",W[W.Recognizing=2]="Recognizing",W[W.Recognized=3]="Recognized",W[W.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Pe[103],Ae([1,0,53,13,12,295,147,7,18]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=void 0;const w=new Map;function R(v,n){n?w.set(v,n):w.delete(v)}e.$SM=R;function S(v){return w.get(v)}class l extends M.$0u{constructor(n,o,t,r,a,c,h,i){super(o,t,r,a),this.c=n,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,g.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===T.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,t){return n.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,E.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,E.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,r=o.start.line,a=o.end.line,c=[];c.push(this.f[r].substring(o.start.character));for(let h=r+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(n){let o;if(n instanceof m.$PK?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new $(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),t=this.f[o.index].length;return new m.$PK(o.index,Math.min(o.remainder,t))}w(n){if(!(n instanceof m.$QK))throw new Error("Invalid argument");const o=this.x(n.start),t=this.x(n.end);return o===n.start&&t===n.end?n:new m.$QK(o.line,o.character,t.line,t.character)}x(n){if(!(n instanceof m.$PK))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:t}=n,r=!1;if(o<0)o=0,t=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,r=!0;else{const a=this.f[o].length;t<0?(t=0,r=!0):t>a&&(t=a,r=!0)}return r?new m.$PK(o,t):n}y(n,o){const t=this.x(n);if(!o)o=S(this.m);else if((0,I.$Ue)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,A.$is)(t.character+1,(0,A.$gs)(o),this.f[t.line],0);if(r)return new m.$QK(t.line,r.startColumn-1,t.line,r.endColumn-1)}}e.$TM=l;class ${constructor(n,o,t){this.a=n,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$QK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$QK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$UM=$}),define(Pe[210],Ae([1,0,7,17,5]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let M=class{constructor(m){this.a=new E.$_L(E.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$_L(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$3gc=M,e.$3gc=M=Ge([Ke(0,T.$QM)],M)}),define(Pe[211],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.CellExecutionUpdateType=void 0;var T;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$UI=(0,E.$2h)("INotebookExecutionService")}),define(Pe[212],Ae([1,0,6,29,144,94]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Pb=void 0;class A extends E.$Sc{constructor(g,w,R){super(),this._source=g,this.b=w,this.c=R,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Gs(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new I.$WB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:R,disposable:S}=w.create(1);this.b=R,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new I.$WB;w.acceptChunk(g);const R=w.finish(!0),{textBuffer:S,disposable:l}=R.create(1);return this.B(l),S})),this.a}findInInputs(g){const R=new M.$KB(g,!1,!1,null).parseSearchRequest();if(!R)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,R,!0,5e3)}findInOutputs(g){const R=new M.$KB(g,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),R,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$4Pb=A}),define(Pe[48],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class I{static fromExtHostTestItem(A,m,g=A.parent){if(A._isRoot)return new I([m]);const w=[A.id];for(let R=g;R&&R.id!==m;R=R.parent)w.push(R.id);return w.push(m),new I(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new I(A.split("\0"))}static join(A,m){return new I([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:I.isChild(A,m)?2:I.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$EJ=I}),define(Pe[58],Ae([1,0,2,92,29,48]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$LJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$KJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$JJ=e.$IJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$HJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$GJ=e.$FJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$FJ=[2,4,8,16,32,64];const w=C=>"runId"in C;e.$GJ=w;var R;(function(C){C.serialize=P=>({range:P.range.toJSON(),uri:P.uri.toJSON()}),C.deserialize=P=>({range:I.$Gs.lift(P.range),uri:E.URI.revive(P.uri)})})(R||(e.IRichLocation=R={}));var S;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(C){C.serialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&R.serialize(P.location)}),C.deserialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&R.deserialize(P.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,P)=>`${P?"s":"e"}${C}`;e.$HJ=$;var v;(function(C){C.serialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&R.serialize(P.location)}),C.deserialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&R.deserialize(P.location)})})(v||(e.ITestOutputMessage=v={}));var n;(function(C){C.serialize=P=>P.type===0?l.serialize(P):v.serialize(P),C.deserialize=P=>P.type===0?l.deserialize(P):v.deserialize(P)})(n||(e.ITestMessage=n={}));var o;(function(C){C.serializeWithoutMessages=P=>({state:P.state,duration:P.duration,messages:[]}),C.serialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.serialize)}),C.deserialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",r=(C,P)=>C+t+P;e.$IJ=r;const a=C=>{const P=C.indexOf(t);return{ctrlId:C.slice(0,P),tagId:C.slice(P+1)}};e.$JJ=a;var c;(function(C){C.serialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?.toJSON(),range:P.range?.toJSON()||null,description:P.description,error:P.error,sortText:P.sortText}),C.deserialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?E.URI.revive(P.uri):void 0,range:P.range?I.$Gs.lift(P.range):null,description:P.description,error:P.error,sortText:P.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(C){C.serialize=P=>({expand:P.expand,item:c.serialize(P.item)}),C.deserialize=P=>({controllerId:M.$EJ.root(P.item.extId),expand:P.expand,item:c.deserialize(P.item)})})(i||(e.InternalTestItem=i={}));var s;(function(C){C.serialize=P=>{let Y;return P.item&&(Y={},P.item.label!==void 0&&(Y.label=P.item.label),P.item.tags!==void 0&&(Y.tags=P.item.tags),P.item.busy!==void 0&&(Y.busy=P.item.busy),P.item.uri!==void 0&&(Y.uri=P.item.uri?.toJSON()),P.item.range!==void 0&&(Y.range=P.item.range?.toJSON()),P.item.description!==void 0&&(Y.description=P.item.description),P.item.error!==void 0&&(Y.error=P.item.error),P.item.sortText!==void 0&&(Y.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:Y}},C.deserialize=P=>{let Y;return P.item&&(Y={},P.item.label!==void 0&&(Y.label=P.item.label),P.item.tags!==void 0&&(Y.tags=P.item.tags),P.item.busy!==void 0&&(Y.busy=P.item.busy),P.item.range!==void 0&&(Y.range=P.item.range?I.$Gs.lift(P.item.range):null),P.item.description!==void 0&&(Y.description=P.item.description),P.item.error!==void 0&&(Y.error=P.item.error),P.item.sortText!==void 0&&(Y.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:Y}}})(s||(e.ITestItemUpdate=s={}));const u=(C,P)=>{P.expand!==void 0&&(C.expand=P.expand),P.item!==void 0&&(C.item=C.item?Object.assign(C.item,P.item):P.item)};e.$KJ=u;var d;(function(C){C.serializeWithoutMessages=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serializeWithoutMessages)}),C.serialize=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serialize)}),C.deserialize=P=>({...i.deserialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var b;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(P,Y)=>{P.covered+=Y.covered,P.total+=Y.total}})(b||(e.ICoveredCount=b={}));var f;(function(C){C.serialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.serialize),uri:P.uri.toJSON()}),C.deserialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.deserialize),uri:E.URI.from(P.uri)})})(f||(e.IFileCoverage=f={}));function D(C){return{...C,location:C.location?.toJSON()}}function F(C){return C.location=C.location?T.$Fs.isIPosition(C.location)?T.$Fs.lift(C.location):I.$Gs.lift(C.location):void 0,C}e.$LJ=3;var p;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(p||(e.DetailType=p={}));var y;(function(C){C.serialize=P=>P.type===0?O.serialize(P):K.serialize(P),C.deserialize=P=>P.type===0?O.deserialize(P):K.deserialize(P)})(y||(e.CoverageDetails=y={}));var k;(function(C){C.serialize=D,C.deserialize=F})(k||(e.IBranchCoverage=k={}));var O;(function(C){C.serialize=D,C.deserialize=F})(O||(e.IFunctionCoverage=O={}));var K;(function(C){C.serialize=P=>({...D(P),branches:P.branches?.map(k.serialize)}),C.deserialize=P=>({...F(P),branches:P.branches?.map(k.deserialize)})})(K||(e.IStatementCoverage=K={}));var U;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var L;(function(C){C.deserialize=P=>P.op===0?{op:P.op,item:i.deserialize(P.item)}:P.op===1?{op:P.op,item:s.deserialize(P.item)}:P.op===2?{op:P.op,uri:E.URI.revive(P.uri),docv:P.docv}:P,C.serialize=P=>P.op===0?{op:P.op,item:i.serialize(P.item)}:P.op===1?{op:P.op,item:s.serialize(P.item)}:P})(L||(e.TestsDiffOp=L={}));class z{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(P){const Y=this.o();for(const ae of P)switch(ae.op){case 0:this.j(i.deserialize(ae.item),Y);break;case 1:this.k(s.deserialize(ae.item),Y);break;case 3:this.l(ae.itemId,Y);break;case 5:this.m(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this.c.set(ae.tag.id,ae.tag);break;case 7:this.c.delete(ae.id);break}Y.complete?.()}j(P,Y){const ae=M.$EJ.parentId(P.item.extId)?.toString();let ge;if(!ae)ge=this.p(P),this.f.add(ge),this.d.set(P.item.extId,ge);else if(this.d.has(ae)){const ve=this.d.get(ae);ve.children.add(P.item.extId),ge=this.p(P,ve),this.d.set(P.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(P)}`);return}return Y.add?.(ge),P.expand===2&&this.g++,ge}k(P,Y){const ae=this.d.get(P.extId);if(ae)return P.expand!==void 0&&(ae.expand===2&&this.g--,P.expand===2&&this.g++),(0,e.$KJ)(ae,P),Y.update?.(ae),ae}l(P,Y){const ae=this.d.get(P);if(!ae)return;const ge=M.$EJ.parentId(ae.item.extId)?.toString();ge?this.d.get(ge).children.delete(ae.item.extId):this.f.delete(ae);const ve=[[P]];for(;ve.length;)for(const De of ve.pop()){const de=this.d.get(De);de&&(ve.push(de.children),this.d.delete(De),Y.remove?.(de,de!==ae),de.expand===2&&this.g--)}}m(P){}updatePendingRoots(P){this.h+=P}o(){return{}}}e.$MJ=z}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.TestItemEventOp=void 0;var g;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(r,a)=>r===a,S=Object.entries({range:(r,a)=>r===a?!0:!r||!a?!1:r.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(r,a)=>!(r.length!==a.length||r.some(c=>!a.includes(c)))}),l=(r,a)=>{let c;for(const[h,i]of S)i(r[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class $ extends I.$Sc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$bh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,A.$KJ)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,A.$KJ)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.L(h);return i.isOpen()?this.J(h,c-1):i.wait().then(()=>this.J(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,c-1)):this.J(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(a,c){switch(c.op){case 3:this.N(m.$EJ.joinToString(a.fullId,c.id));break;case 0:this.y(c.item,a);break;case 5:for(const h of c.ops)this.u(a,h);break;case 1:this.z(c.new,c.old,a.fullId.toString());break;case 2:this.I(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.w(a.actual.uri);break;default:(0,M.$5c)(c)}}w(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}y(a,c){const h=m.$EJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.H(a,s,c);return}if(s.actual===a){this.G(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.N(h.toString()),this.y(a,c);const u=this.s.getChildren(s.actual),d=s.actual,b=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.z(a.tags,d.tags,h.toString()),delete b.tags),this.u(s,{op:4,update:b})),this.H(a,s,c);for(const[f,D]of u)this.s.getChildren(a).get(D.id)||this.N(m.$EJ.joinToString(h,D.id));this.w(s.actual.uri)}z(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,A.$IJ)(this.s.controllerId,s.id))}}}),i.forEach(this.D,this)}C(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$IJ)(this.s.controllerId,a.id)}}))}D(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,A.$IJ)(this.s.controllerId,a)}))}F(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}G(a,c,h){this.F(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.u(c,s),this.I(c)}H(a,c,h){this.G(a,c,h);for(const[i,s]of this.s.getChildren(a))this.y(s,c)}I(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.L(a))}J(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand(m.$EJ.joinToString(a.fullId,s.id),c);(0,E.$Og)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}L(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$1g;return s.open(),s}a.expand=2,this.M(a);const c=a.resolveBarrier=new E.$1g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Og)(i)?i.catch(h).then(()=>{c.open(),this.I(a)}):(c.open(),this.I(a)),a.resolveBarrier}M(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}N(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.D(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$EJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$GM=$;class v extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$HM=v;class n extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$IM=n;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$JM=o;const t=(r,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const b of i){if(!(b instanceof c))throw new n(b.id);const f=a(b).controllerId;if(f!==r.controllerId)throw new o(b.id,f,r.controllerId);if(s.has(b.id))throw new v(b.id);s.set(b.id,b),u.delete(b.id),d.ops.push({op:0,item:b})}for(const b of u.keys())d.ops.push({op:3,id:b});r.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new n(i.id);h.set(i.id,i),r.listener?.({op:0,item:i})},delete(i){h.delete(i)&&r.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$KM=t}),define(Pe[104],Ae([1,0,77]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;const T=new WeakMap,I=(A,m)=>{const g={controllerId:m};return T.set(A,g),g};e.$LM=I;const M=A=>{const m=T.get(A);if(!m)throw new E.$IM(A?.id||"<unknown>");return m};e.$MM=M}),define(Pe[78],Ae([1,0,13,2]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gvb=e.$fvb=e.$evb=e.$dvb=e.$cvb=void 0,e.$cvb="vscode-cdn.net",e.$dvb=`vscode-resource.${e.$cvb}`,e.$evb=`'self' https://*.${e.$cvb}`;function I(m,g){return m.scheme===E.Schemas.http||m.scheme===E.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===E.Schemas.file&&(m=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:m.path})),T.URI.from({scheme:E.Schemas.https,authority:`${m.scheme}+${M(m.authority)}.${e.$dvb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$fvb=I;function M(m){return m.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$gvb=A}),define(Pe[213],Ae([1,0,5,6,78]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class M{constructor(m,g,w){this.d=m,this.e=g,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const R=g.getVisibleTextEditors();for(const S of this.c.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,w,R,S){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===m){l=a;break}if(!l)throw new Error("not a visible editor");const $=this,v=this.a++,n=new E.$Sd,o=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$fvb)(a,$.f)}get cspSource(){return I.$evb}set options(a){this.b=a,$.d.$setOptions(v,a)}get options(){return this.b}set html(a){this.a=a,$.d.$setHtml(v,a)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(a){return $.d.$postMessage(v,a)}},r=new class{constructor(){this.editor=m,this.line=g,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){$.c.has(v)&&($.c.delete(v),$.d.$disposeEditorInset(v),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,g+1,w,R||{},S.identifier,S.extensionLocation),this.c.set(v,{editor:m,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$mfc=M}),define(Pe[214],Ae([1,0,4]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.VariableKind=e.$CN=void 0,e.$CN=(0,E.$2h)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class I extends Error{constructor(A,m){super(m),this.variable=A}}e.$DN=I}),define(Pe[215],Ae([1,0,19,74,16,26,21,95,177,214,12]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,v,n,o){this.h=new Map,this.a=$,this.b=v,this.g=n,o&&(this.c=o.then(t=>this.i(t)))}i($){if(A.$i){const v=Object.create(null);return Object.keys($).forEach(n=>{v[n.toLowerCase()]=$[n]}),v}return $}resolveWithEnvironment($,v,n){return this.l({env:this.i($),userHome:void 0},v?v.uri:void 0,n)}async resolveAsync($,v){const n={env:await this.c,userHome:await this.g};return this.l(n,$?$.uri:void 0,v)}async j($,v,n,o){const t=M.$hn(v);A.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):A.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):A.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,$?$.uri:void 0,t,n,o)}async resolveAnyAsync($,v,n){return this.j($,v,n)}async resolveAnyMap($,v,n){const o=new Map;return{newConfig:await this.j($,v,n,o),resolvedVariables:o}}resolveWithInteractionReplace($,v,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,v,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,v){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,v)}async l($,v,n,o,t){if(I.$Ef(n))return this.m($,v,n,o,t);if(Array.isArray(n))return Promise.all(n.map(r=>this.l($,v,r,o,t)));if(I.$Gf(n)){const r=Object.create(null),a=await Promise.all(Object.keys(n).map(async c=>[await this.m($,v,c,o,t),await this.l($,v,n[c],o,t)]));for(const[c,h]of a)r[c]=h;return r}return n}m($,v,n,o,t){return(0,R.$Ze)(n,S.VARIABLE_REGEXP,async(r,a)=>{if(a.includes(S.VARIABLE_LHS))return r;let c=await this.o($,r,a,v,o);return t?.set(a,c),c!==r&&I.$Ef(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m($,v,c,o,t)),c})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,v,n,o,t){let r;const a=n.split(":");a.length>1&&(n=a[0],r=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,m.$Hv)(u);throw new w.$DN(s,(0,g.localize)(0,null,v))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,m.$Hv)(d)}throw new w.$DN(s,(0,g.localize)(1,null,v,E.$nc(u)))},i=s=>{if(r){const u=this.a.getFolderUri(r);if(u)return u;throw new w.$DN(s,(0,g.localize)(2,null,v,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new w.$DN(s,(0,g.localize)(3,null,v)):new w.$DN(s,(0,g.localize)(4,null,v))};switch(n){case"env":if(r){if($.env){const s=$.env[A.$i?r.toLowerCase():r];if(I.$Ef(s))return s}return""}throw new w.$DN(w.VariableKind.Env,(0,g.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(o,r);if(I.$Nf(s))throw new w.$DN(w.VariableKind.Config,(0,g.localize)(6,null,v,r));if(I.$Gf(s))throw new w.$DN(w.VariableKind.Config,(0,g.localize)(7,null,v,r));return s}throw new w.$DN(w.VariableKind.Config,(0,g.localize)(8,null,v));case"command":return this.p(w.VariableKind.Command,v,r,t,"command");case"input":return this.p(w.VariableKind.Input,v,r,t,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new w.$DN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new w.$DN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,v));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$Hv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,m.$Hv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Hv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new w.$DN(w.VariableKind.UserHome,(0,g.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$DN(w.VariableKind.LineNumber,(0,g.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$DN(w.VariableKind.SelectedText,(0,g.localize)(13,null,v))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(o||r){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return E.sep;default:try{const s=r?`${n}:${r}`:n;return this.p(w.VariableKind.Unknown,v,s,t,void 0)}catch{return v}}}}p($,v,n,o,t){if(n&&o){const r=t===void 0?o[n]:o[t+":"+n];if(typeof r=="string")return r;throw new w.$DN($,(0,g.localize)(14,null,v))}return v}}e.$RN=S}),define(Pe[105],Ae([1,0,4,102]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.OpenEditorContext=e.GroupsOrder=e.$RC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QC=void 0,e.$QC=(0,E.$2h)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(v){const n=v;return(0,T.$zE)(n?.editor)&&(0,T.$zE)(n?.replacement)}e.$RC=w;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var S;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(v){const n=v;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.$SC=l;function $(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$TC=$}),define(Pe[216],Ae([1,0,4,105]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.$VC=e.$UC=void 0,e.$UC=(0,E.$2h)("editorService"),e.$VC=-1,e.$WC=-2;function I(M){const A=M;return typeof M=="number"||(0,T.$SC)(A)}e.$XC=I}),define(Pe[217],Ae([1,0,4,184]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=void 0,e.$0J=(0,E.$3h)(T.$9h)}),define(Pe[106],Ae([1,0,22,5,19,6]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=e.$g7b=e.$f7b=e.$e7b=e.$d7b=void 0;class A{constructor(t,r){this.versionId=t,this.removedDueToLooping=r}}e.$d7b=A;class m{static isHostExtension(t,r,a){if(r.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,r){this.j=t,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new E.$im,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const r=this.j.readActivationEvents(t);for(const a of r)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,r){this.e=n(this.e,r),this.e=this.e.concat(t);const a=m.l(this.e);return this.e=n(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,a)}static l(t){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=r.getArcs(s);for(let b=0;b<d.length;b++)if(!u.has(d[b]))return!1;return!0}getNodes(){return this.e}},a=new E.$im;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)r.addArc(E.$gm.toKey(s.identifier),E.$gm.toKey(u));const c=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>c.add(s));const h=r.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];r.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this.h.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const r=this.f.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this.g)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$e7b=m;class g{constructor(t,r){this.versionId=t,this.extensions=r}}e.$f7b=g;class w{constructor(t){this.d=new l,this.c=new m(t,[])}async acquireLock(t){const r=await this.d.acquire(t);return new R(this,r)}deltaExtensions(t,r,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this.c.getExtensionDescriptionByIdOrUUID(t,r)}}e.$g7b=w;class R extends M.$Sc{constructor(t,r){super(),this.f=t,this.c=!1,this.B(r)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$h7b=R;class S{constructor(t){this.name=t,this.promise=new Promise((r,a)=>{this.c=r})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const r=new S(t);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let r=!0;const a=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{r&&(clearTimeout(a),r=!1,this.d=!1,this.e())};t.resolve((0,M.$Qc)(c))}}var $;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})($||($={}));function v(o,t){const r=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==a)return r-a;const c=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function n(o,t){const r=new E.$hm(t);return o.filter(a=>!r.has(a.identifier))}}),define(Pe[79],Ae([1,0,24]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$pm=e.$om=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(w){const R=E.$ge.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$om=A;function m(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$pm=m;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.$9M=e.$8M=void 0;let $=class extends S.$Sc{constructor(t,r){super(),this.s=t,this.t=r,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:g.$Bo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(a=>{(0,I.$lj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,r,a){const c=this.getTelemetryDetails(),h=new v(r,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,r,a){this.f=t,this.g=r,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const r=Object.create(null);switch(r["common.extname"]=`${t.publisher}.${t.name}`,r["common.extversion"]=t.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,m.$9k)((0,g.$Io)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const r=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,r){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(r),h=!0);return h}};e.$8M=$,e.$8M=$=Ge([Ke(0,M.$7M),Ke(1,I.$kj)],$);class v{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,r,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,r){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let r="properties"in t?t.properties??{}:t;return r=(0,g.$Lo)(r,[]),this.c&&(r=(0,w.$kn)(r,this.c)),this.b||(r=(0,w.$kn)(r,this.j)),"properties"in t?t.properties=r:t=r,t}k(t,r){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(t,r),this.h.trace(t,r))}logUsage(t,r){this.d.isUsageEnabled&&this.k(t,r)}logError(t,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,r);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Lo)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const t=this,r={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$9M=v;function n(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$0M=n,e.$$M=(0,E.$2h)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,193,101,22,4]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.$nF=e.ActivationKind=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.ExtensionHostStartup=e.$hF=e.$gF=e.$fF=e.$eF=void 0,e.$eF=Object.freeze({identifier:new A.$gm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$fF="extensions.webWorker",e.$gF=(0,m.$2h)("extensionService");class g{constructor(h){this.dependency=h}}e.$hF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$2E.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],b=[],f=[],D=S(this.d),F=S(i),p=(U,L)=>U.extensionLocation.toString()===L.extensionLocation.toString()||U.isBuiltin===L.isBuiltin||U.isUserBuiltin===L.isUserBuiltin||U.isUnderDevelopment===L.isUnderDevelopment;for(const U of this.d){const L=F.get(U.identifier);if(!L){u.push(U.identifier),D.delete(U.identifier);continue}if(!p(U,L)){u.push(U.identifier),D.delete(U.identifier);continue}}for(const U of i){const L=D.get(U.identifier);if(!L){d.push(U);continue}if(!p(L,U)){u.push(L.identifier),D.delete(L.identifier);continue}}const y=new A.$hm(this.e),k=new A.$hm(s);for(const U of this.e)k.has(U)||b.push(U);for(const U of s)y.has(U)||f.push(U);const O=M.$2E.createActivationEventsMap(d),K={versionId:h,toRemove:u,toAdd:d,addActivationEvents:O,myToRemove:b,myToAdd:f};return this.delta(K),K}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,b=new A.$hm(i),f=new A.$hm(u);for(let D=0;D<this.d.length;D++)b.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)f.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of s)this.d.push(D);for(const D of d)this.e.push(D);return this.f=null,h}containsExtension(h){for(const i of this.e)if(A.$gm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=M.$2E.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$iF=R;function S(c){const h=new A.$im;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$jF=l;function $(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$kF=$;class v{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$lF=v;class n{constructor(h,i){this.description=h,this.value=i}}e.$mF=n;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$Ro)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$nF=t;function r(c,h){return{identifier:new A.$gm((0,I.$Po)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$oF=r;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$pF=a}),define(Pe[218],Ae([1,0,11,106,22,23,15,14]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=e.$Jfc=e.$Ifc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,r,a,c){this.startup=t,this.codeLoadingTime=r,this.activateCallTime=a,this.activateResolvedTime=c}}e.$Ifc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,r){return t===-1||r===-1?-1:r-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jfc=w;class R{constructor(t,r,a,c,h,i){this.activationFailed=t,this.activationFailedError=r,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$Kfc=R;class S extends R{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lfc=S;class l extends R{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mfc=l;class $ extends R{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(t,r,a,c){this.g=c,this.a=t,this.b=r,this.c=a,this.d=new I.$im,this.f=Object.create(null)}dispose(){for(const[t,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const t=[];for(const[r,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const r=this.d.get(t);return!!(r&&r.value)}getActivatedExtension(t){const r=this.d.get(t);if(!r||!r.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return r.value}async activateByEvent(t,r){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:r,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,r){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:r}])}async h(t){const r=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(r.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const r=this.a.getExtensionDescription(t.id);if(!r){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new $(h));return this.c.onExtensionActivationError(t.id,h,new M.$hF(t.id.value)),i}const a=[],c=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),b=this.k(t,r.displayName,[],new $(d));return this.c.onExtensionActivationError(r.identifier,d,new M.$hF(h)),b}return this.k(t,r.displayName,a,null)}k(t,r,a,c){const h=new n(t.id,r,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$e7b.isHostExtension(t,this.a,this.b)}m(t){const r=this.b.getExtensionDescription(t);return r?!r.main&&!r.browser:!1}};e.$Nfc=v,e.$Nfc=v=Ge([Ke(3,A.$jj)],v);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,r,a,c,h,i,s){this.c=t,this.d=r,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new m.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const r=this.g[t];if(r.value&&!r.value.activationFailed){this.g.splice(t,1),t--;continue}if(r.value&&r.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);a.detail=r.value.activationFailedError,this.h=new $(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const r=new Error;if(t&&t.name&&(r.name=t.name),t&&t.message?r.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(r.stack=t.stack),this.h=new $(r),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};n=Ge([Ke(6,A.$jj)],n)}),define(Pe[8],Ae([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$PM=e.$OM=e.MarkdownString=e.$NM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ee){function Fe(G){const{selectionStartLineNumber:Re,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:Ve}=G,_e=new s.$PK(Re-1,Be-1),gt=new s.$PK(Ze-1,Ve-1);return new s.$RK(_e,gt)}Ee.to=Fe;function fe(G){const{anchor:Re,active:Be}=G;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ee.from=fe})(d||(e.Selection=d={}));var b;(function(Ee){function Fe(G){if(!G)return;const{start:Re,end:Be}=G;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ee.from=Fe;function fe(G){if(!G)return;const{startLineNumber:Re,startColumn:Be,endLineNumber:Ze,endColumn:Ve}=G;return new s.$QK(Re-1,Be-1,Ze-1,Ve-1)}Ee.to=fe})(b||(e.Range=b={}));var f;(function(Ee){function Fe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ee.to=Fe})(f||(e.TokenType=f={}));var D;(function(Ee){function Fe(G){return new s.$PK(G.lineNumber-1,G.column-1)}Ee.to=Fe;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=fe})(D||(e.Position=D={}));var F;(function(Ee){function Fe(Re,Be,Ze){return(0,E.$Hb)((0,E.$3b)(Re).map(Ve=>fe(Ve,Be,Ze)))}Ee.from=Fe;function fe(Re,Be,Ze){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Ze?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:G(Re.scheme,Be),pattern:Z.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Re,Be){return Be&&typeof Re=="string"?Be.transformOutgoingScheme(Re):Re}})(F||(e.DocumentSelector=F={}));var p;(function(Ee){function Fe(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ee.to=fe})(p||(e.DiagnosticTag=p={}));var y;(function(Ee){function Fe(G){let Re;return G.code&&((0,l.$Ef)(G.code)||(0,l.$If)(G.code)?Re=String(G.code):Re={value:String(G.code.value),target:G.code.target}),{...b.from(G.range),message:G.message,source:G.source,code:Re,severity:O.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(k.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map(p.from)):void 0}}Ee.from=Fe;function fe(G){const Re=new s.$3K(b.to(G),G.message,O.to(G.severity));return Re.source=G.source,Re.code=(0,l.$Ef)(G.code)?G.code:G.code?.value,Re.relatedInformation=G.relatedInformation&&G.relatedInformation.map(k.to),Re.tags=G.tags&&(0,E.$Hb)(G.tags.map(p.to)),Re}Ee.to=fe})(y||(e.Diagnostic=y={}));var k;(function(Ee){function Fe(G){return{...b.from(G.location.range),message:G.message,resource:G.location.uri}}Ee.from=Fe;function fe(G){return new s.$2K(new s.$1K(G.resource,b.to(G)),G.message)}Ee.to=fe})(k||(e.DiagnosticRelatedInformation=k={}));var O;(function(Ee){function Fe(G){switch(G){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ee.from=Fe;function fe(G){switch(G){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ee.to=fe})(O||(e.DiagnosticSeverity=O={}));var K;(function(Ee){function Fe(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$WC:i.$VC}Ee.from=Fe;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=fe})(K||(e.ViewColumn=K={}));function U(Ee){return typeof Ee.range<"u"}function L(Ee){return Ee.length===0?!0:!!U(Ee[0])}e.$NM=L;var z;(function(Ee){function Fe(Ve){return Ve.map(Ee.from)}Ee.fromMany=Fe;function fe(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(fe(Ve)){const{language:Dt,value:bt}=Ve;_e={value:"```"+Dt+`
`+bt+"\n```\n"}}else s.$dL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const gt=Object.create(null);_e.uris=gt;const zt=Dt=>{try{let bt=$.URI.parse(Dt,!0);bt=bt.with({query:Re(bt.query,gt)}),gt[Dt]=bt}catch{}return""},yt=new g.marked.Renderer;return yt.link=zt,yt.image=Dt=>typeof Dt=="string"?zt(A.$kk(Dt).href):"",(0,g.marked)(_e.value,{renderer:yt}),_e}Ee.from=G;function Re(Ve,_e){if(!Ve)return Ve;let gt;try{gt=(0,w.$xh)(Ve)}catch{}if(!gt)return Ve;let zt=!1;return gt=(0,S.$jn)(gt,yt=>{if($.URI.isUri(yt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[Dt]=yt,zt=!0,Dt}else return}),zt?JSON.stringify(gt):Ve}function Be(Ve){const _e=new s.$dL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?$.URI.from(Ve.baseUri):void 0,_e}Ee.to=Be;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:Ee.from(Ve)}Ee.fromStrict=Ze})(z||(e.MarkdownString=z={}));function C(Ee){return L(Ee)?Ee.map(Fe=>({range:b.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?z.fromMany(Fe.hoverMessage):Fe.hoverMessage?z.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ee.map(Fe=>({range:b.from(Fe)}))}e.$OM=C;function P(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?$.URI.file(Ee):Ee}e.$PM=P;var Y;(function(Ee){function Fe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?P(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ee.from=Fe})(Y||(e.ThemableDecorationAttachmentRenderOptions=Y={}));var ae;(function(Ee){function Fe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Y.from(fe.before):void 0,after:fe.after?Y.from(fe.after):void 0}}Ee.from=Fe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var ge;(function(Ee){function Fe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Fe})(ge||(e.DecorationRangeBehavior=ge={}));var ve;(function(Ee){function Fe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ge.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Y.from(fe.before):void 0,after:fe.after?Y.from(fe.after):void 0}}Ee.from=Fe})(ve||(e.DecorationRenderOptions=ve={}));var De;(function(Ee){function Fe(G){return{text:G.newText,eol:G.newEol&&et.from(G.newEol),range:b.from(G.range)}}Ee.from=Fe;function fe(G){const Re=new s.$VK(b.to(G.range),G.text);return Re.newEol=typeof G.eol>"u"?void 0:et.to(G.eol),Re}Ee.to=fe})(De||(e.TextEdit=De={}));var de;(function(Ee){function Fe(G,Re){const Be={edits:[]};if(G instanceof s.$YK){const Ze=new m.$Bc;for(const Ve of G._allEntries())Ve._type===1&&$.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),Be.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?Be.edits.push({resource:Ve.uri,textEdit:De.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Re?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Be.edits.push({resource:Ve.uri,textEdit:{range:b.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Re?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(It.from)}})}return Be}Ee.from=Fe;function fe(G){const Re=new s.$YK,Be=new m.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const Ve=Ze,_e=$.URI.revive(Ve.resource),gt=b.to(Ve.textEdit.range),zt=Ve.textEdit.text,yt=Ve.textEdit.insertAsSnippet;let Dt;yt?Dt=s.$XK.replace(gt,new s.$ZK(zt)):Dt=s.$VK.replace(gt,zt);const bt=Be.get(_e);bt?bt.push(Dt):Be.set(_e,[Dt])}else Re.renameFile($.URI.revive(Ze.oldResource),$.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of Be)Re.set(Ze,Ve);return Re}Ee.to=fe})(de||(e.WorkspaceEdit=de={}));var he;(function(Ee){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Fe[Re]=="number"?Fe[Re]:6}Ee.from=fe;function G(Re){for(const Be in Fe)if(Fe[Be]===Re)return Number(Be);return s.SymbolKind.Property}Ee.to=G})(he||(e.SymbolKind=he={}));var te;(function(Ee){function Fe(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ee.to=fe})(te||(e.SymbolTag=te={}));var Se;(function(Ee){function Fe(G){return{name:G.name,kind:he.from(G.kind),tags:G.tags&&G.tags.map(te.from),containerName:G.containerName,location:Ie.from(G.location)}}Ee.from=Fe;function fe(G){const Re=new s.$7K(G.name,he.to(G.kind),G.containerName,Ie.to(G.location));return Re.tags=G.tags&&G.tags.map(te.to),Re}Ee.to=fe})(Se||(e.WorkspaceSymbol=Se={}));var oe;(function(Ee){function Fe(G){const Re={name:G.name||"!!MISSING: name!!",detail:G.detail,range:b.from(G.range),selectionRange:b.from(G.selectionRange),kind:he.from(G.kind),tags:G.tags?.map(te.from)??[]};return G.children&&(Re.children=G.children.map(Fe)),Re}Ee.from=Fe;function fe(G){const Re=new s.$8K(G.name,G.detail,he.to(G.kind),b.to(G.range),b.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Re.tags=G.tags.map(te.to)),G.children&&(Re.children=G.children.map(fe)),Re}Ee.to=fe})(oe||(e.DocumentSymbol=oe={}));var X;(function(Ee){function Fe(G){const Re=new s.$_K(he.to(G.kind),G.name,G.detail||"",$.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ee.to=Fe;function fe(G,Re,Be){if(Re=Re??G._sessionId,Be=Be??G._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,name:G.name,detail:G.detail,kind:he.from(G.kind),uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(te.from)}}Ee.from=fe})(X||(e.CallHierarchyItem=X={}));var V;(function(Ee){function Fe(fe){return new s.$aL(X.to(fe.from),fe.fromRanges.map(G=>b.to(G)))}Ee.to=Fe})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Ee){function Fe(fe){return new s.$bL(X.to(fe.to),fe.fromRanges.map(G=>b.to(G)))}Ee.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Ee){function Fe(G){return{range:G.range&&b.from(G.range),uri:G.uri}}Ee.from=Fe;function fe(G){return new s.$1K($.URI.revive(G.uri),b.to(G.range))}Ee.to=fe})(Ie||(e.location=Ie={}));var Me;(function(Ee){function Fe(G){const Re=G,Be=G;return{originSelectionRange:Re.originSelectionRange?b.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Be.uri,range:b.from(Re.targetRange?Re.targetRange:Be.range),targetSelectionRange:Re.targetSelectionRange?b.from(Re.targetSelectionRange):void 0}}Ee.from=Fe;function fe(G){return{targetUri:$.URI.revive(G.uri),targetRange:b.to(G.range),targetSelectionRange:G.targetSelectionRange?b.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?b.to(G.originSelectionRange):void 0}}Ee.to=fe})(Me||(e.DefinitionLink=Me={}));var Ce;(function(Ee){function Fe(G){return{range:b.from(G.range),contents:z.fromMany(G.contents)}}Ee.from=Fe;function fe(G){return new s.$4K(G.contents.map(z.to),b.to(G.range))}Ee.to=fe})(Ce||(e.Hover=Ce={}));var ce;(function(Ee){function Fe(G){return{range:b.from(G.range),expression:G.expression}}Ee.from=Fe;function fe(G){return new s.$XL(b.to(G.range),G.expression)}Ee.to=fe})(ce||(e.EvaluatableExpression=ce={}));var ie;(function(Ee){function Fe(G){if(G instanceof s.$YL)return{type:"text",range:b.from(G.range),text:G.text};if(G instanceof s.$ZL)return{type:"variable",range:b.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$1L)return{type:"expression",range:b.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Fe;function fe(G){switch(G.type){case"text":return{range:b.to(G.range),text:G.text};case"variable":return{range:b.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:b.to(G.range),expression:G.expression}}}Ee.to=fe})(ie||(e.InlineValue=ie={}));var Q;(function(Ee){function Fe(G){return{frameId:G.frameId,stoppedLocation:b.from(G.stoppedLocation)}}Ee.from=Fe;function fe(G){return new s.$2L(G.frameId,b.to(G.stoppedLocation))}Ee.to=fe})(Q||(e.InlineValueContext=Q={}));var ee;(function(Ee){function Fe(G){return{range:b.from(G.range),kind:G.kind}}Ee.from=Fe;function fe(G){return new s.$5K(b.to(G.range),G.kind)}Ee.to=fe})(ee||(e.DocumentHighlight=ee={}));var $e;(function(Ee){function Fe(G){return{uri:G.uri,highlights:G.highlights.map(ee.from)}}Ee.from=Fe;function fe(G){return new s.$6K($.URI.revive(G.uri),G.highlights.map(ee.to))}Ee.to=fe})($e||(e.MultiDocumentHighlight=$e={}));var be;(function(Ee){function Fe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ee.to=Fe})(be||(e.CompletionTriggerKind=be={}));var Le;(function(Ee){function Fe(fe){return{triggerKind:be.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ee.to=Fe})(Le||(e.CompletionContext=Le={}));var le;(function(Ee){function Fe(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ee.from=Fe;function fe(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ee.to=fe})(le||(e.CompletionItemTag=le={}));var we;(function(Ee){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Be){return Fe.get(Be)??9}Ee.from=fe;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Re(Be){return G.get(Be)??s.CompletionItemKind.Property}Ee.to=Re})(we||(e.CompletionItemKind=we={}));var N;(function(Ee){function Fe(fe,G){const Re=new s.$jL(fe.label);return Re.insertText=fe.insertText,Re.kind=we.to(fe.kind),Re.tags=fe.tags?.map(le.to),Re.detail=fe.detail,Re.documentation=A.$fk(fe.documentation)?z.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,v.$Gs.isIRange(fe.range)?Re.range=b.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:b.to(fe.range.insert),replacing:b.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new s.$ZK(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof s.$QK?new s.$VK(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(Be=>De.to(Be))),Re.command=G&&fe.command?G.fromInternal(fe.command):void 0,Re}Ee.to=Fe})(N||(e.CompletionItem=N={}));var q;(function(Ee){function Fe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:z.fromStrict(G.documentation)}}Ee.from=Fe;function fe(G){return{label:G.label,documentation:A.$fk(G.documentation)?z.to(G.documentation):G.documentation}}Ee.to=fe})(q||(e.ParameterInformation=q={}));var H;(function(Ee){function Fe(G){return{label:G.label,documentation:z.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(q.from):[],activeParameter:G.activeParameter}}Ee.from=Fe;function fe(G){return{label:G.label,documentation:A.$fk(G.documentation)?z.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(q.to):[],activeParameter:G.activeParameter}}Ee.to=fe})(H||(e.SignatureInformation=H={}));var B;(function(Ee){function Fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Ee.from=Fe;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Ee.to=fe})(B||(e.SignatureHelp=B={}));var J;(function(Ee){function Fe(fe,G){const Re=new s.$iL(D.to(G.position),typeof G.label=="string"?G.label:G.label.map(_.to.bind(void 0,fe)),G.kind&&ye.to(G.kind));return Re.textEdits=G.textEdits&&G.textEdits.map(De.to),Re.tooltip=A.$fk(G.tooltip)?z.to(G.tooltip):G.tooltip,Re.paddingLeft=G.paddingLeft,Re.paddingRight=G.paddingRight,Re}Ee.to=Fe})(J||(e.InlayHint=J={}));var _;(function(Ee){function Fe(fe,G){const Re=new s.$hL(G.label);return Re.tooltip=A.$fk(G.tooltip)?z.to(G.tooltip):G.tooltip,n.Command.is(G.command)&&(Re.command=fe.fromInternal(G.command)),G.location&&(Re.location=Ie.to(G.location)),Re}Ee.to=Fe})(_||(e.InlayHintLabelPart=_={}));var ye;(function(Ee){function Fe(G){return G}Ee.from=Fe;function fe(G){return G}Ee.to=fe})(ye||(e.InlayHintKind=ye={}));var Te;(function(Ee){function Fe(G){return{range:b.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Fe;function fe(G){let Re;if(G.url)try{Re=typeof G.url=="string"?$.URI.parse(G.url,!0):$.URI.revive(G.url)}catch{}return new s.$oL(b.to(G.range),Re)}Ee.to=fe})(Te||(e.DocumentLink=Te={}));var We;(function(Ee){function Fe(G){const Re=new s.$rL(G.label);return G.textEdit&&(Re.textEdit=De.to(G.textEdit)),G.additionalTextEdits&&(Re.additionalTextEdits=G.additionalTextEdits.map(Be=>De.to(Be))),Re}Ee.to=Fe;function fe(G){return{label:G.label,textEdit:G.textEdit?De.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Re=>De.from(Re)):void 0}}Ee.from=fe})(We||(e.ColorPresentation=We={}));var He;(function(Ee){function Fe(G){return new s.$pL(G[0],G[1],G[2],G[3])}Ee.to=Fe;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=fe})(He||(e.Color=He={}));var Ye;(function(Ee){function Fe(G){return{range:b.from(G.range)}}Ee.from=Fe;function fe(G){return new s.$$K(b.to(G.range))}Ee.to=fe})(Ye||(e.SelectionRange=Ye={}));var rt;(function(Ee){function Fe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ee.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var it;(function(Ee){function Fe(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Fe;function fe(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ee.to=fe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Ee){function Fe(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ee.from=Fe;function fe(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ee.to=fe})(et||(e.EndOfLine=et={}));var ot;(function(Ee){function Fe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Fe})(ot||(e.ProgressLocation=ot={}));var at;(function(Ee){function Fe(G){const Re={start:G.start+1,end:G.end+1};return G.kind&&(Re.kind=ze.from(G.kind)),Re}Ee.from=Fe;function fe(G){const Re={start:G.start-1,end:G.end-1};return G.kind&&(Re.kind=ze.to(G.kind)),Re}Ee.to=fe})(at||(e.FoldingRange=at={}));var ze;(function(Ee){function Fe(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return n.$wt.Comment;case s.FoldingRangeKind.Imports:return n.$wt.Imports;case s.FoldingRangeKind.Region:return n.$wt.Region}}Ee.from=Fe;function fe(G){if(G)switch(G.value){case n.$wt.Comment.value:return s.FoldingRangeKind.Comment;case n.$wt.Imports.value:return s.FoldingRangeKind.Imports;case n.$wt.Region.value:return s.FoldingRangeKind.Region}}Ee.to=fe})(ze||(e.FoldingRangeKind=ze={}));var pt;(function(Ee){function Fe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?b.from(fe.selection):void 0,override:typeof fe.override=="boolean"?r.$lE.id:void 0}}Ee.from=Fe})(pt||(e.TextEditorOpenOptions=pt={}));var Z;(function(Ee){function Fe(Be){return Be instanceof s.$LL?Be.toJSON():typeof Be=="string"?Be:fe(Be)||G(Be)?new s.$LL(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ee.from=Fe;function fe(Be){const Ze=Be;return Ze?$.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Re(Be){return typeof Be=="string"?Be:new s.$LL($.URI.revive(Be.baseUri),Be.pattern)}Ee.to=Re})(Z||(e.GlobPattern=Z={}));var x;(function(Ee){function Fe(fe){if(fe){if(Array.isArray(fe))return fe.map(Fe);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:Z.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ee.from=Fe})(x||(e.LanguageSelector=x={}));var pe;(function(Ee){function Fe(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Re=>Array.isArray(Re)&&Re.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&$.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof s.$QK)))}Ee.is=Fe;function fe(G){return{documents:G.documents.map(Re=>Re.map(Be=>({uri:$.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>b.from(Ze))})))}}Ee.from=fe})(pe||(e.MappedEditsContext=pe={}));var Ue;(function(Ee){function Fe(G){return{start:G.start,end:G.end}}Ee.from=Fe;function fe(G){return new s.$aM(G.start,G.end)}Ee.to=fe})(Ue||(e.NotebookRange=Ue={}));var Qe;(function(Ee){function Fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Fe;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ee.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var tt;(function(Ee){function Fe(fe){if(fe===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===a.NotebookCellExecutionState.Pending)return;if(fe===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ee.to=Fe})(tt||(e.NotebookCellExecutionState=tt={}));var nt;(function(Ee){function Fe(G){switch(G){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Ee.from=Fe;function fe(G){switch(G){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Ee.to=fe})(nt||(e.NotebookCellKind=nt={}));var Ne;(function(Ee){function Fe(G){const Re={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)s.$bM.validate(Be),Re.cells.push(It.from(Be));return Re}Ee.from=Fe;function fe(G){const Re=new s.$cM(G.cells.map(It.to));return(0,l.$Rf)(G.metadata)||(Re.metadata=G.metadata),Re}Ee.to=fe})(Ne||(e.NotebookData=Ne={}));var It;(function(Ee){function Fe(G){return{cellKind:nt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Kt.from):[]}}Ee.from=Fe;function fe(G){return new s.$bM(nt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Kt.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Ee.to=fe})(It||(e.NotebookCellData=It={}));var Lt;(function(Ee){function Fe(G){return{mime:G.mime,valueBytes:T.$ge.wrap(G.data)}}Ee.from=Fe;function fe(G){return new s.$dM(G.valueBytes.buffer,G.mime)}Ee.to=fe})(Lt||(e.NotebookCellOutputItem=Lt={}));var Kt;(function(Ee){function Fe(G){return{outputId:G.id,items:G.items.map(Lt.from),metadata:G.metadata}}Ee.from=Fe;function fe(G){const Re=G.items.map(Lt.to);return new s.$eM(Re,G.outputId,G.metadata)}Ee.to=fe})(Kt||(e.NotebookCellOutput=Kt={}));var Bt;(function(Ee){function Fe(Re){return G(Re)?{include:Z.from(Re.include)??void 0,exclude:Z.from(Re.exclude)??void 0}:Z.from(Re)??void 0}Ee.from=Fe;function fe(Re){return G(Re)?{include:Z.to(Re.include),exclude:Z.to(Re.exclude)}:Z.to(Re)}Ee.to=fe;function G(Re){const Be=Re;return Be?!(0,l.$Nf)(Be.include)&&!(0,l.$Nf)(Be.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var wt;(function(Ee){function Fe(fe,G,Re){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ee.from=Fe})(wt||(e.NotebookStatusBarItem=wt={}));var qt;(function(Ee){function Fe(fe,G,Re){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Be,Re),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ee.from=Fe})(qt||(e.NotebookKernelSourceAction=qt={}));var Ft;(function(Ee){function Fe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ee.from=Fe})(Ft||(e.NotebookDocumentContentOptions=Ft={}));var Qt;(function(Ee){function Fe(G){return{uri:G.uri,provides:G.provides}}Ee.from=Fe;function fe(G){return new s.$gM($.URI.revive(G.uri),G.provides)}Ee.to=fe})(Qt||(e.NotebookRendererScript=Qt={}));var Ot;(function(Ee){function Fe(G){return{message:z.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:b.from(G.location.range),uri:G.location.uri}}}Ee.from=Fe;function fe(G){const Re=new s.$mM(typeof G.message=="string"?G.message:z.to(G.message));return Re.actualOutput=G.actual,Re.expectedOutput=G.expected,Re.contextValue=G.contextValue,Re.location=G.location?Ie.to(G.location):void 0,Re}Ee.to=fe})(Ot||(e.TestMessage=Ot={}));var Ct;(function(Ee){Ee.namespace=h.$IJ,Ee.denamespace=h.$JJ})(Ct||(e.TestTag=Ct={}));var Xe;(function(Ee){function Fe(G){const Re=(0,t.$MM)(G).controllerId;return{extId:c.$EJ.fromExtHostTestItem(G,Re).toString(),label:G.label,uri:$.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Ct.namespace(Re,Be.id)),range:v.$Gs.lift(b.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&z.fromStrict(G.error)||null}}Ee.from=Fe;function fe(G){return{parent:void 0,error:void 0,id:c.$EJ.fromString(G.extId).localId,label:G.label,uri:$.URI.revive(G.uri),tags:(G.tags||[]).map(Re=>{const{tagId:Be}=Ct.denamespace(Re);return new s.$nM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ee.toPlain=fe})(Xe||(e.TestItem=Xe={})),function(Ee){function Fe(G){return{id:G.id}}Ee.from=Fe;function fe(G){return new s.$nM(G.id)}Ee.to=fe}(Ct||(e.TestTag=Ct={}));var Ht;(function(Ee){const Fe=(G,Re)=>{const Be=[];for(const[Ve,_e]of Re)c.$EJ.compare(_e.item.extId,Ve)===2&&(Re.delete(Ve),Be.push(_e));const Ze={...Xe.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(Ot.to)})),children:Be.map(Ve=>Fe(Ve,Re))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function fe(G){const Re=[],Be=new Map;for(const Ze of G.items){Be.set(Ze.item.extId,Ze);const Ve=c.$EJ.root(Ze.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Ze.item.extId))&&Re.push(Ze)}return{completedAt:G.completedAt,results:Re.map(Ze=>Fe(Ze,Be))}}Ee.to=fe})(Ht||(e.TestResults=Ht={}));var Gt;(function(Ee){function Fe(Be){return{covered:Be.covered,total:Be.total}}function fe(Be){return"line"in Be?D.from(Be):b.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:fe(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&fe(Ze.location)})):void 0}:{type:0,name:Be.name,count:Be.executionCount,location:fe(Be.location)}}Ee.fromDetailed=G;function Re(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ee.fromFile=Re})(Gt||(e.TestCoverage=Gt={}));var ut;(function(Ee){function Fe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ee.to=Fe})(ut||(e.CodeActionTriggerKind=ut={}));var mt;(function(Ee){function Fe(G){const Re=new s.$tM(he.to(G.kind),G.name,G.detail||"",$.URI.revive(G.uri),b.to(G.range),b.to(G.selectionRange));return Re._sessionId=G._sessionId,Re._itemId=G._itemId,Re}Ee.to=Fe;function fe(G,Re,Be){if(Re=Re??G._sessionId,Be=Be??G._itemId,Re===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Be,kind:he.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:b.from(G.range),selectionRange:b.from(G.selectionRange),tags:G.tags?.map(te.from)}}Ee.from=fe})(mt||(e.TypeHierarchyItem=mt={}));var jt;(function(Ee){function Fe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ee.from=Fe})(jt||(e.ViewBadge=jt={}));var Ut;(function(Ee){function Fe(Be,Ze,Ve){const _e=Ze.fileData;return _e?new s.$EL(new s.$FL(_e.name,$.URI.revive(_e.uri),_e.id,(0,M.$db)(()=>Ve(_e.id)))):Be===R.$3r.uriList&&Ze.uriListData?new s.$DL(Re(Ze.uriListData)):new s.$DL(Ze.asString)}Ee.to=Fe;async function fe(Be,Ze){const Ve=await Ze.asString();if(Be===R.$3r.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Ze.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ee.from=fe;function G(Be){return I.$dt.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return $.URI.parse(Ze)}catch{}return Ze})}function Re(Be){return I.$dt.create(Be.map(Ze=>typeof Ze=="string"?Ze:$.URI.revive(Ze)))}})(Ut||(e.DataTransferItem=Ut={}));var Et;(function(Ee){function Fe(G,Re){const Be=G.items.map(([Ze,Ve])=>[Ze,Ut.to(Ze,Ve,Re)]);return new s.$GL(Be)}Ee.toDataTransfer=Fe;async function fe(G){const Re={items:[]},Be=[];for(const[Ze,Ve]of G)Be.push((async()=>{Re.items.push([Ze,await Ut.from(Ze,Ve)])})());return await Promise.all(Be),Re}Ee.from=fe})(Et||(e.DataTransfer=Et={}));var ht;(function(Ee){function Fe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Ee.from=Fe})(ht||(e.ChatReplyFollowup=ht={}));var Pt;(function(Ee){function Fe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:ht.from(fe)}Ee.from=Fe})(Pt||(e.ChatFollowup=Pt={}));var Xt;(function(Ee){function Fe(G){const Re=new s.$FM(kt.to(G.role),G.content);return Re.name=G.name,Re}Ee.to=Fe;function fe(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Ee.from=fe})(Xt||(e.ChatMessage=Xt={}));var kt;(function(Ee){function Fe(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ee.to=Fe;function fe(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ee.from=fe})(kt||(e.ChatMessageRole=kt={}));var qe;(function(Ee){function Fe(Re){const Be={};for(const Ze of Object.keys(Re))Be[Ze]=Re[Ze].map(Ee.to);return Be}Ee.objectTo=Fe;function fe(Re){return{level:Rt.to(Re.level),kind:Re.kind,value:(0,w.$yh)(Re.value),description:Re.description}}Ee.to=fe;function G(Re){return{level:Rt.from(Re.level),kind:Re.kind,value:Re.value,description:Re.description}}Ee.from=G})(qe||(e.ChatVariable=qe={}));var Rt;(function(Ee){function Fe(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ee.to=Fe;function fe(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ee.from=fe})(Rt||(e.ChatVariableLevel=Rt={}));var Wt;(function(Ee){function Fe(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Fe})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Jt;(function(Ee){function Fe(fe,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$kF)(fe,"chatAgents2Additions"),{content:z.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$kF)(fe,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$kF)(fe,"chatAgents2Additions"),{content:z.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Re=>({uri:Re.uri,version:Re.version,ranges:Re.ranges.map(Be=>b.from(Be))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:b.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:b.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$kF)(fe,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Ee.from=Fe})(Jt||(e.ChatResponseProgress=Jt={}));var ft;(function(Ee){function Fe(fe){return{label:fe.label,values:fe.values.map(qe.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Ee.from=Fe})(ft||(e.ChatAgentCompletionItem=ft={}));var Mt;(function(Ee){function Fe(fe,G,Re){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Re)}Ee.from=Fe})(Mt||(e.TerminalQuickFix=Mt={}))}),define(Pe[220],Ae([1,0,2,11,7,8,186]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class m{constructor(w,R,S,l={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=S,this.g=l,this.a=new A.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,S,l)=>{const v={dispose:this.a.push([R,S,w])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(w,R){const S=E.URI.revive(w);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const n of[...this.a]){if(l)break;const o=this.d.getDocument(S),t=await this.h(n,{document:o,reason:M.TextDocumentSaveReason.to(R)});v.push(t)}}finally{clearTimeout($)}return v}h([w,R,S],l){const $=this.b.get(w);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(S,w,R,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const n=this.b.get(w);this.b.set(w,n?n+1:1),typeof n=="number"&&n>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,S,l){const $=[],v=Date.now(),{document:n,reason:o}=l,{version:t}=n,r=Object.freeze({document:n,reason:o,waitUntil(a){if(Object.isFrozen($))throw(0,T.$8)("waitUntil can not be called async");$.push(Promise.resolve(a))}});try{R.apply(S,[r])}catch(a){return Promise.reject(a)}return Object.freeze($),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all($).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof I.$VK))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:s&&M.EndOfLine.from(s)}});if(c.edits.length!==0)return t===n.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$hgc=m}),define(Pe[221],Ae([1,0,13,2,8,7,76]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0;class m{constructor(S,l,$,v){this.start=S,this.deletedCount=l,this.deletedItems=$,this.items=v}asApiEvent(){return{range:new M.$aM(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,$){this.notebook=S,this.h=l,this.j=$,this.handle=$.handle,this.uri=T.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(I.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(v){S.g=v},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze($)}return this.f}setOutputs(S){this.a=S.map(I.NotebookCellOutput.to)}setOutputItems(S,l,$){const v=$.map(I.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===S);if(n&&(l||(n.items.length=0),n.items.push(...v),n.items.length>1&&n.items.every(o=>A.$QI(o.mime)))){const o=new Map,t=[];n.items.forEach(r=>{let a;o.has(r.mime)?a=o.get(r.mime):(a=[],o.set(r.mime,a),t.push(r.mime)),a.push(r.data)}),n.items.length=0,t.forEach(r=>{const a=A.$RI(o.get(r));n.items.push({mime:r,data:a.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$mgc=g;class w{static{this.a=0}constructor(S,l,$,v,n){this.k=S,this.l=l,this.m=$,this.uri=v,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt($){return $=S.n($),S.b[$].apiCell},getCells($){return($?S.p($):S.b).map(n=>n.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,$){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const v={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},n=[];for(const t of S.rawEvents)t.kind===A.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,v.contentChanges):t.kind===A.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,v.contentChanges):t.kind===A.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),n.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),n.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),n.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===A.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),n.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),n.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<n.length;t++){const r=n[t],a=o.get(r.cell);if(a===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,c-1)}else v.cellChanges[a]={...v.cellChanges[a],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,$=S.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),S.with({start:l,end:$})}p(S){S=this.o(S);const l=[];for(let $=S.start;$<S.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,$){if(this.j)return;const v=[],n=[],o=[];if(S.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||n.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new m(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),$)for(const t of v)$.push(t.asApiEvent())}s(S,l,$,v){const n=this.b.splice(S,l);this.b.splice($,0,...n);const o=[new m(S,l,n.map(t=>t.apiCell),[]),new m($,0,[],n)];for(const t of o)v.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,$,v){this.b[S].setOutputItems(l,$,v)}v(S,l){const $=this.b[S];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(S,l){const $=this.b[S];$.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$ngc=w}),define(Pe[222],Ae([1,0,5,2,8,7]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class A{constructor(g,w,R,S={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=R,this.f=S,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,R,S)=>{const l=function(v){w.call(R,v)};return l.extension=g,this.a.event(l,void 0,S)}}async $participateInSave(g,w,R){const S=T.URI.revive(g),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},R,async(n,o)=>{const t=Date.now(),r=await await Promise.resolve(n);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof M.$YK?$.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if($.length===0)return!0;const v={edits:[]};for(const n of $){const{edits:o}=I.WorkspaceEdit.from(n);v.edits=v.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$Dgc=A}),define(Pe[107],Ae([1,0,11,8,7]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,w,R,S,l){this.id=m,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=R,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$aM.isNotebookRange))throw(0,E.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,w){m.f.$tryRevealRange(m.id,T.NotebookRange.from(g),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$ogc=M}),define(Pe[223],Ae([1,0,11,5,15,8]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;let A=class{constructor(g,w){this.c=g,this.d=w,this.a=new T.$Sd({onListenerError:E.$2}),this.b=new T.$Sd({onListenerError:E.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const R=this.d.getEditorById(g);w.visibleRanges&&R._acceptVisibleRanges(w.visibleRanges.ranges.map(M.NotebookRange.to)),w.selections&&R._acceptSelections(w.selections.selections.map(M.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const w in g)this.d.getEditorById(w)._acceptViewColumn(M.ViewColumn.to(g[w]))}};e.$Fgc=A,e.$Fgc=A=Ge([Ke(0,I.$jj)],A)}),define(Pe[224],Ae([1,0,8,72,163,20,66,11]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,$,v){const n=this.b++,{title:o,location:t,cancellable:r}=$,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(n,{location:E.ProgressLocation.from(t),title:o,source:a,cancellable:r},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$2),this.d(n,v,!!r)}d(l,$,v){let n;v&&(n=new M.$3d,this.c.set(l,n));const o=r=>{this.a.$progressEnd(r),this.c.delete(r),n?.dispose()};let t;try{t=$(new R(this.a,l),v&&n?n.token:M.CancellationToken.None)}catch(r){throw o(l),r}return t.then(r=>o(l),r=>o(l)),t}$acceptProgressCanceled(l){const $=this.c.get(l);$&&($.cancel(),this.c.delete(l))}}e.$Mgc=g;function w(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class R extends T.$gv{constructor(l,$){super(v=>this.throttledReport(v)),this.c=l,this.d=$}throttledReport(l){this.c.$progressReport(this.d,l)}}Ge([(0,A.$vh)(100,(S,l)=>w(S,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=e.$3M=void 0;const w=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},R=(a,c)=>a===c,S={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),$=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Gs.lift(m.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),S.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:w(a,c,S.label,l(h=>({label:h}))),description:w(a,void 0,S.description,l(h=>({description:h}))),sortText:w(a,void 0,S.sortText,l(h=>({sortText:h}))),canResolveChildren:w(a,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:w(a,!1,S.busy,l(h=>({busy:h}))),error:w(a,void 0,S.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(a,[],S.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),v=a=>{const c=I.$EJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=m.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>m.TestTag.to({id:(0,A.$JJ)(i).tagId})),h},n=a=>{let c;for(const h of a.tests){const i=v(h.item);(0,T.$MM)(i).parent=c,c=i}return c};e.$3M=n;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$LM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$KM)(u,T.$MM,o),enumerable:!0,writable:!1},...$(u,i)})}}e.$4M=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$5M=t;class r extends M.$GM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:T.$MM,getChildren:s=>s.children,root:new t(c,h),toITestItem:m.TestItem.from})}}e.$6M=r}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=void 0;class m{static{this.c=new I.$VM("TextEditorDecorationType")}constructor(l,$,v){const n=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,n,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:n,dispose(){l.$removeTextEditorDecorationType(n)}})}}e.$XM=m;class g{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let v=null;if(l instanceof A.$PK)v=new A.$QK(l,l);else if(l instanceof A.$QK)v=l;else throw new Error("Unrecognized location");this.l(v,$,!1)}insert(l,$){this.k(),this.l(new A.$QK(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof A.$QK)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,v){const n=this.c.validateRange(l);this.g.push({range:n,text:$,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,$,v,n){this.c=l,this.d=$,this._accept(v),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.m(t)},get indentSize(){return o.g},set indentSize(t){o.o(t)},get insertSpaces(){return o.h},set insertSpaces(t){o.q(t)},get cursorStyle(){return o.j},set cursorStyle(t){o.s(t)},get lineNumbers(){return o.k},set lineNumbers(t){o.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}m(l){const $=this.l(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}o(l){const $=this.n(l);if($!==null){if(typeof $=="number"){if(this.g===$)return;this.g=$}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const $=this.p(l);if(typeof $=="boolean"){if(this.h===$)return;this.h=$}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let v=!1;if(typeof l.tabSize<"u"){const n=this.l(l.tabSize);n==="auto"?(v=!0,$.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,v=!0,$.tabSize=n)}if(typeof l.indentSize<"u"){const n=this.n(l.indentSize);n==="tabSize"?(v=!0,$.indentSize=n):typeof n=="number"&&this.g!==n&&(this.g=n,v=!0,$.indentSize=n)}if(typeof l.insertSpaces<"u"){const n=this.p(l.insertSpaces);n==="auto"?(v=!0,$.insertSpaces=n):this.h!==n&&(this.h=n,v=!0,$.insertSpaces=n)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,v=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,v=!0,$.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,$))}u(l,$){$.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$YM=w;class R{constructor(l,$,v,n,o,t,r,a){this.id=l,this.j=$,this.k=v,this.g=!1,this.h=new Set,this.c=o,this.d=new w(this.j,this.id,t,v),this.e=r,this.f=a;const c=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof A.$RK))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof A.$RK)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(n.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>M.Range.from(d));else if(i instanceof A.$PK){const{lineNumber:d,column:b}=M.Position.from(i);u=[{startLineNumber:d,startColumn:b,endLineNumber:d,endColumn:b}]}else if(i instanceof A.$QK)u=[M.Range.from(i)];else{u=[];for(const d of i)if(d instanceof A.$QK)u.push(M.Range.from(d));else{const{lineNumber:b,column:f}=M.Position.from(d);u.push({startLineNumber:b,startColumn:f,endLineNumber:b,endColumn:f})}}return $.$tryInsertSnippet(l,n.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(M.$NM(i))return $.$trySetDecorations(l,h.key,M.$OM(i));{const u=new Array(4*i.length);for(let d=0,b=i.length;d<b;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return $.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>$.$tryRevealRange(l,M.Range.from(h),i||A.TextEditorRevealType.Default))},show(h){$.$tryShowEditor(l,M.ViewColumn.from(h))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const v=$.edits.map(o=>o.range);v.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=v.length-1;o<t;o++){const r=v[o].end;if(v[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=$.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,n,{setEndOfLine:typeof $.setEndOfLine=="number"?M.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$ZM=R}),define(Pe[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;function t(c,h){if((0,R.$Ef)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class r extends A.$Sc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new n.$07;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(b=>u(b)?this.r(b):b):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,D=this.m(h,i,s),F={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:b,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(h,F),y={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$kF)(s,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$kF)(s,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(k){(0,$.$fk)(k)&&(0,o.$kF)(s,"treeViewMarkdownMessage"),D.message=k},get title(){return D.title},set title(k){D.title=k},get description(){return D.description},set description(k){D.description=k},get badge(){return D.badge},set badge(k){k!==void 0&&w.ViewBadge.isViewBadge(k)?D.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(D.badge=void 0)},reveal:(k,O)=>D.reveal(k,O),dispose:async()=>{await p,this.a.delete(h),D.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new m.$UE(h))}async $handleDrop(h,i,s,u,d,b,f,D){const F=this.a.get(h);if(!F)return Promise.reject(new m.$UE(h));const p=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&D&&await this.j(p,F,D,d,b),F.onDrop(p,u,d)}async j(h,i,s,u,d){const b=this.b.removeDragOperationTransfer(d);if(b)(await b)?.forEach((f,D)=>{f&&h.set(D,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new m.$UE(h));const b=await this.j(new w.$GL,d,i,u,s);if(!(!b||u.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$UE(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new m.$UE(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new m.$UE(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new m.$UE(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new m.$UE(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new m.$UE(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$6gc=r;class a extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Nf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,b){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$3d,b.contributes&&b.contributes.views)for(const p in b.contributes.views)for(const y of b.contributes.views[p])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let f,D;const F=M.Event.debounce(this.F.event,(p,y)=>(p||(p={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(k=>D=k),this.G=this.G.then(()=>f)),Array.isArray(y.element)?p.elements.push(...y.element):p.elements.push(y.element)),y.message&&(p.message=!0),p),200,!0);this.B(F(({message:p,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const k=D;return f=null,this.$(y).then(()=>k())})),p&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,R.$Nf)(i.select)?!0:i.select,u=(0,R.$Nf)(i.focus)?!1:i.focus,d=(0,R.$Nf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:b.map(D=>D.item)},{select:s,focus:u,expand:d})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,S.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const b=this.getExtensionElement(d);b&&u.push(b)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Ug)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Ug)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const b=this.m.get(d);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new v.$3d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=await Promise.all((0,S.$Hb)(u||[]).map(async b=>{const f=await this.f.getTreeItem(b);return f&&!i.token.isCancellationRequested?this.db(b,f,s):null}));return i.token.isCancellationRequested?void 0:(0,S.$Hb)(d)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$3d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let b=d;for(;b&&b.parent&&s.findIndex(f=>b&&b.parent&&f&&f.item.handle===b.parent.item.handle)===-1;){const f=this.j.get(b.parent.item.handle);b=f?this.m.get(f):void 0}b&&!b.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const b=this.j.get(d);if(b){const f=this.m.get(b);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Ug)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$dL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$BL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new A.$Rc),d=this.kb(h,i,s),b=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,R.$Nf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$JL?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,b){if(i)return`${a.b}/${i}`;const f=t(s,this.N),D=d?d.item.handle:a.a;let F=f?f.label:u?(0,T.$Ag)(u):"";F=F.indexOf("/")!==-1?F.replace("/","//"):F;const p=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let k,O=0;do{if(k=`${D}/${O}:${F}`,b||!this.j.has(k)||p===k)break;O++}while(O<=y.length);return k}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$JL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$JL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],b=d.filter(f=>f.item.handle===s.item.handle)[0];b&&d.splice(d.indexOf(b),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Ae([1,0,179,11,31,97,73,30,22,226,189,101]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=void 0;const l=m.$tn.as(A.$un.JSONContribution);class ${constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$$E=$;class v{static a(h){const i=new g.$hm;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new v(i,[]);if(!i||!i.length)return new v([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),b=h.filter(f=>!u.has(f.description.identifier));return new v(d,b)}constructor(h,i){this.added=h,this.removed=i}}e.$_E=v;class n{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$aF=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$bF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$fm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$$n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$$n}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&S.$2E.register(h.extensionPoint,h.activationEventsGenerator),e.$bF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$bF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$cF=r;const a={ExtensionsRegistry:"ExtensionsRegistry"};m.$tn.add(a.ExtensionsRegistry,new r),e.$dF=m.$tn.as(a.ExtensionsRegistry),l.registerSchema(t,e.$bF),l.registerSchema(R.$Cj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[228],Ae([1,0,175,16,26,227,35,5]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function $(v,n,o){if(!v)return;const t=T.$Ef(v.type)?v.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const a of v.required)T.$Ef(a)&&r.push(a);return{extensionId:n.value,taskType:t,required:r,properties:v.properties?I.$hn(v.properties):{},when:v.when?A.$Zi.deserialize(v.when):void 0}}l.from=$})(w||(w={}));const R=M.$dF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const v of l)v.type&&$.push(`onTaskType:${v.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class S{constructor(){this.d=new m.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,v)=>{R.setHandler((n,o)=>{this.c=void 0;try{for(const t of o.removed){const r=t.value;for(const a of r)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const r=t.value;for(const a of r){const c=w.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const v of this.all()){const n={type:"object",additionalProperties:!1};v.required.length>0&&(n.required=v.required.slice(0)),v.properties!==void 0?n.properties=I.$hn(v.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[v.taskType]},$.push(n)}this.c={oneOf:$}}return this.c}}e.$fG=new S}),define(Pe[229],Ae([1,0,176,16,25,26,35,228]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pG=e.JsonSchemaVersion=e.ExecutionEngine=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jG=e.ShellQuoting=e.$iG=e.$hG=e.$gG=void 0,e.$gG="settings",e.$hG=new A.$gj("taskRunning",!1,E.localize(0,null)),e.$iG={value:E.localize(1,null),original:"Tasks"};var g;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$jG="$customized",function(C){function P(Y){if(!Y)return C.Strong;switch(Y.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=P}(g||(e.ShellQuoting=g={}));var w;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(R||(e.RevealKind=R={})),function(C){function P(Y){switch(Y.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=P}(R||(e.RevealKind=R={}));var S;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(C){function P(Y){switch(Y.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=P}(S||(e.RevealProblemKind=S={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function P(Y){switch(Y.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=P}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var v;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(C){function P(ae){switch(ae.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=P;function Y(ae){switch(ae){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=Y}(v||(e.RuntimeType=v={}));var n;(function(C){function P(Y){return T.$Ef(Y)?Y:Y.value}C.value=P})(n||(e.CommandString=n={}));var o;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function P(ae){return ae===C.Clean._id||ae===C.Build._id||ae===C.Rebuild._id||ae===C.Test._id}C.is=P;function Y(ae){if(ae!==void 0)return T.$Ef(ae)?P(ae)?{_id:ae,isDefault:!1}:void 0:ae}C.from=Y})(o||(e.TaskGroup=o={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var r;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function P(Y){switch(Y){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=P})(r||(e.TaskSourceKind=r={}));var a;(function(C){C.parallel="parallel",C.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(P,Y,ae,ge,ve,De){this._label="",this._id=P,Y&&(this._label=Y),ae&&(this.type=ae),this.runOptions=ge,this.configurationProperties=ve,this._source=De}getDefinition(P){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const P={folder:this.d(),id:this._id};return JSON.stringify(P)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(P,Y=!1){if(P===void 0)return!1;if(T.$Ef(P))return P===this._label||P===this.configurationProperties.identifier||Y&&P===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===P._key}getQualifiedLabel(){const P=this.getWorkspaceFolder();return P?`${this._label} (${P.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(P){this.c===void 0&&(this.c=[]),P&&(this.c=this.c.concat(P))}get taskLoadMessages(){return this.c}}e.$kG=i;class s extends i{constructor(P,Y,ae,ge,ve,De,de,he){super(P,ae,void 0,de,he,Y),this.command={},this._source=Y,this.hasDefinedMatchers=De,ve&&(this.command=ve)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(P=!1){if(P&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case v.Shell:Y="shell";break;case v.Process:Y="process";break;case v.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(P){return P instanceof s}getMapKey(){const P=this._source.config.workspaceFolder;return P?`${P.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$gG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const P=this.d();if(!P)return;let Y=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Y+=this._source.kind);const ae={type:e.$jG,folder:P,id:Y};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(P){return new s(P._id,P._source,P._label,P.type,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$lG=s;class u extends i{constructor(P,Y,ae,ge,ve,De,de){super(P,ae,ge,De,de,Y),this._source=Y,this.configures=ve}static is(P){return P instanceof u}f(P){return P}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$gG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const P=this.d();if(!P)return;let Y=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Y+=this._source.kind);const ae={type:e.$jG,folder:P,id:Y};return JSON.stringify(ae)}}e.$mG=u;class d extends i{constructor(P,Y,ae,ge,ve,De,de,he,te){super(P,ae,ge,he,te,Y),this.defines=ve,this.hasDefinedMatchers=de,this.command=De,this.icon=te.icon,this.hide=te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(P){return P instanceof d}getMapKey(){const P=this._source.workspaceFolder;return P?`${this._source.scope.toString()}|${P.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const P={type:"contributed",scope:this._source.scope,id:this._id};return P.folder=this.d(),JSON.stringify(P)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(P){return new d(P._id,P._source,P._label,P.type,P.defines,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$nG=d;class b extends i{constructor(P,Y,ae,ge,ve,De){super(P,ae,ge,ve,De,Y),this._source=Y}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(P){return P instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(P){return new b(P._id,P._source,P._label,P.type,P.runOptions,P.configurationProperties)}}e.$oG=b;var f;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(C){C._default=C.Terminal}(f||(e.ExecutionEngine=f={}));var D;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class F{constructor(P){this.c=new Map;for(let Y=0;Y<P.length;Y++)this.c.set(P[Y].uri.toString(),Y)}compare(P,Y){const ae=P.getWorkspaceFolder(),ge=Y.getWorkspaceFolder();if(ae&&ge){let ve=this.c.get(ae.uri.toString());ve=ve===void 0?0:ve+1;let De=this.c.get(ge.uri.toString());return De=De===void 0?0:De+1,ve===De?P._label.localeCompare(Y._label):ve-De}else return!ae&&ge?-1:ae&&!ge?1:0}}e.$pG=F;var p;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(p||(e.TaskEventKind=p={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var k;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var O;(function(C){function P(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function Y(he,te,Se){return{...P(he),kind:"start",terminalId:te,resolvedVariables:Se}}C.start=Y;function ae(he,te,Se){return{...P(he),kind:"processStarted",terminalId:te,processId:Se}}C.processStarted=ae;function ge(he,te,Se){return{...P(he),kind:"processEnded",terminalId:te,exitCode:Se}}C.processEnded=ge;function ve(he,te,Se){return{...P(he),kind:"terminated",exitReason:Se,terminalId:te}}C.terminated=ve;function De(he,te,Se){return{...P(te),kind:he,terminalId:Se}}C.general=De;function de(){return{kind:"changed"}}C.changed=de})(O||(e.TaskEvent=O={}));var K;(function(C){function P(ae){const ge=Object.keys(ae).sort();let ve="";for(const De of ge){let de=ae[De];de instanceof Object?de=P(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ve+=De+","+de+","}return ve}function Y(ae){const ve={_key:P(ae),type:ae.taskType};return Object.assign(ve,ae),ve}C.create=Y})(K||(e.KeyedTaskIdentifier=K={}));var U;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var L;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var z;(function(C){function P(Y,ae){const ge=m.$fG.get(Y.type);if(ge===void 0){const he=M.$hn(Y);return delete he._key,K.create(he)}const ve=Object.create(null);ve.type=ge.taskType;const De=new Set;ge.required.forEach(he=>De.add(he));const de=ge.properties;for(const he of Object.keys(de)){const te=Y[he];if(te!=null)ve[he]=te;else if(De.has(he)){const Se=de[he];if(Se.default!==void 0)ve[he]=M.$hn(Se.default);else switch(Se.type){case"boolean":ve[he]=!1;break;case"number":case"integer":ve[he]=0;break;case"string":ve[he]="";break;default:ae.error(E.localize(2,null,JSON.stringify(Y,void 0,0),he));return}}}return K.create(ve)}C.createTaskIdentifier=P})(z||(e.TaskDefinition=z={}))}),define(Pe[230],Ae([1,0,11]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=e.$i7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,E.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$i7b=T;class I extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$j7b=I}),define(Pe[49],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Bv=E;const T=[];function I(m){const g=new E(m);return T[g.nid]=g,g}e.$Cv=I;function M(m){return T[m].sid}e.$Dv=M;class A{constructor(g){this.value=g}}e.$Ev=A}),define(Pe[3],Ae([1,0,49]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$LK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var I;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class S{static{this.a=0}static mixin(o){return o._id=S.a++,o}}e.$LK=S;var l;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})($||(e.ISuggestResultDtoField=$={}));var v;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$MK={MainThreadAuthentication:(0,E.$Cv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Cv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Cv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Cv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Cv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Cv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Cv)("MainThreadCommands"),MainThreadComments:(0,E.$Cv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Cv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Cv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Cv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Cv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Cv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Cv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Cv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Cv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Cv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Cv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Cv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Cv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Cv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Cv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Cv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Cv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Cv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Cv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Cv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Cv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Cv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Cv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Cv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Cv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Cv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Cv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Cv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Cv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Cv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Cv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Cv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Cv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Cv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Cv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Cv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Cv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Cv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Cv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Cv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Cv)("MainThreadSCM"),MainThreadSearch:(0,E.$Cv)("MainThreadSearch"),MainThreadShare:(0,E.$Cv)("MainThreadShare"),MainThreadTask:(0,E.$Cv)("MainThreadTask"),MainThreadWindow:(0,E.$Cv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Cv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Cv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Cv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Cv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Cv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Cv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Cv)("MainThreadInteractive"),MainThreadChat:(0,E.$Cv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Cv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Cv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Cv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Cv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Cv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Cv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Cv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Cv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Cv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Cv)("MainThreadIssueReporter")},e.$NK={ExtHostCommands:(0,E.$Cv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Cv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Cv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Cv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Cv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Cv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Cv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Cv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Cv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Cv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Cv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Cv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Cv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Cv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Cv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Cv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Cv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Cv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Cv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Cv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Cv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Cv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Cv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Cv)("ExtHostSCM"),ExtHostSearch:(0,E.$Cv)("ExtHostSearch"),ExtHostTask:(0,E.$Cv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Cv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Cv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Cv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Cv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Cv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Cv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Cv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Cv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Cv)("ExtHostProgress"),ExtHostComments:(0,E.$Cv)("ExtHostComments"),ExtHostSecretState:(0,E.$Cv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Cv)("ExtHostStorage"),ExtHostUrls:(0,E.$Cv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Cv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Cv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Cv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$Cv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Cv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Cv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Cv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Cv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Cv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Cv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Cv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Cv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Cv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Cv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Cv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Cv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Cv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Cv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Cv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Cv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Cv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Cv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Cv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Cv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Cv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Cv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Cv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Cv)("ExtHostIssueReporter")}}),define(Pe[231],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$MK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,g)??[]}getRelatedInformation(A,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,m),new T.$OK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$6ec=I}),define(Pe[81],Ae([1,0,4,15,3,17]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=void 0,e.$_ec=(0,E.$2h)("IExtHostApiDeprecationService");let A=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(I.$MK.MainThreadTelemetry)}report(g,w,R){const S=this.d(g,w);this.a.has(S)||(this.a.add(S),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$afc=A,e.$afc=A=Ge([Ke(0,M.$QM),Ke(1,T.$jj)],A),e.$bfc=Object.freeze(new class{report(m,g,w){}})}),define(Pe[232],Ae([1,0,5,3,7,22]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=w.getProxy(T.$MK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,R,S,l={}){const $=M.$gm.toKey(w.identifier),v=[...S].sort().join(" ");return await this.f.getOrCreate(`${$} ${R} ${v}`,async()=>{await this.a.$ensureProvider(R);const n=w.displayName||w.name;return this.a.$getSession(R,S,$,n,l)})}async getSessions(w,R,S){const l=M.$gm.toKey(w.identifier),$=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(R);const v=w.displayName||w.name;return this.a.$getSessions(R,S,l,v)})}async removeSession(w,R){const S=this.b.get(w);return S?S.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,S,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===w)||this.c.push({id:w,label:R});const $=S.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(w,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(w,R,l?.supportsMultipleAccounts??!1),new I.$OK(()=>{$.dispose(),this.b.delete(w);const v=this.c.findIndex(n=>n.id===w);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,S){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(R,S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.d.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$efc=A;class m{constructor(){this.a=new Map}getOrCreate(w,R){const S=this.a.get(w);if(S)return S;const l=R().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[233],Ae([1,0,3,17,8]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;let M=class{constructor(m,g){this.a=m.getProxy(E.$MK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,w){const R=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$ffc=M,e.$ffc=M=Ge([Ke(0,T.$QM)],M)}),define(Pe[234],Ae([1,0,5,67,6,3,8]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class m{static{this.a=0}constructor(R,S){this.extension=R,this.provider=S,this.handle=m.a++}}class g{static{this.a=0}constructor(R){this.b=new Map,this.c=new Map,this.d=new E.$Sd,this.onDidPerformUserAction=this.d.event,this.e=R.getProxy(M.$MK.MainThreadChat)}registerChatProvider(R,S,l){const $=new m(R,l);return this.b.set($.handle,$),this.e.$registerChatProvider($.handle,S),(0,I.$Qc)(()=>{this.e.$unregisterChatProvider($.handle),this.b.delete($.handle)})}transferChatSession(R,S){const l=T.Iterable.find(this.c.keys(),$=>this.c.get($)===R)??0;typeof l=="number"&&this.e.$transferChatSession(l,S)}sendInteractiveRequestToProvider(R,S){this.e.$sendRequestToProvider(R,S)}async $prepareChat(R,S){const l=this.b.get(R);if(!l)return;const $=await l.provider.prepareSession(S);if(!$)return;const v=g.a++;return this.c.set(v,$),{id:v,requesterUsername:$.requester?.name,requesterAvatarIconUri:$.requester?.icon,responderUsername:$.responder?.name,responderAvatarIconUri:$.responder?.icon,inputPlaceholder:$.inputPlaceholder}}async $provideWelcomeMessage(R,S){const l=this.b.get(R);if(!l||!l.provider.provideWelcomeMessage)return;const $=await l.provider.provideWelcomeMessage(S);if($)return $.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(n=>A.ChatReplyFollowup.from(n)):A.MarkdownString.from(v))}async $provideSampleQuestions(R,S){const l=this.b.get(R);if(!l||!l.provider.provideSampleQuestions)return;const $=await l.provider.provideSampleQuestions(S);if($)return $?.map(v=>A.ChatReplyFollowup.from(v))}$releaseSession(R){this.c.delete(R)}async $onDidPerformUserAction(R){this.d.fire(R)}}e.$gfc=g}),define(Pe[235],Ae([1,0,14,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(S.$MK.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let b=!1;function f(){if(b)throw new Error("Only valid while executing the command")}const D=new E.$mh;u.onCancellationRequested(()=>D.complete()),setTimeout(()=>D.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,D.p);const F=i.command?await d.validateSlashCommand(i.command):void 0,p=A.$Od.create(!1);let y;try{const k=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:F},{history:s.history.map(l.ChatMessage.to)},new R.$gv(O=>{f(),typeof y>"u"&&"content"in O&&(y=p.elapsed());const K=l.ChatResponseProgress.from(d.extension,O);if(!K){this.j.error("Unknown progress type: "+JSON.stringify(O));return}if("placeholder"in O&&"resolvedContent"in O){const U=Promise.all([this.d.$handleProgressChunk(h,K),O.resolvedContent]);(0,E.$Qg)(U,u).then(L=>{if(!L)return;const[z,C]=L,P=l.ChatResponseProgress.from(d.extension,C);if(!P){this.j.error("Unknown progress type: "+JSON.stringify(C));return}this.d.$handleProgressChunk(h,P,z??void 0)})}else this.d.$handleProgressChunk(h,K)}),u);return await(0,E.$Qg)(Promise.resolve(k).then(O=>{if(O){this.g.set(c,O);let K=this.h.get(c);K||(K=new Map,this.h.set(c,K)),K.set(h,O);const U={firstProgress:y,totalElapsed:p.elapsed()};return{errorDetails:O.errorDetails,timings:U}}else this.g.delete(c)}),u)}catch(k){return this.j.error(k,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Mi)(k)),responseIsIncomplete:!0}}}finally{b=!0,D.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let b;switch(i){case v.InteractiveSessionVoteDirection.Down:b=$.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:b=$.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:b,reportIssue:s}:{result:d,kind:b}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$ifc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new M.$Sd,this.q=new M.$Sd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,m.$Of)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$JL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,n.$kF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,n.$kF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,n.$kF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,n.$kF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,n.$kF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,n.$kF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,n.$kF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,n.$kF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,n.$kF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,n.$kF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,n.$jF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Pe[236],Ae([1,0,20,6,3,8,72,22,14,5]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class R{constructor(v,n){this.stream=new g.$sh,this.stream=n??new g.$sh;const o=this;this.apiObj={option:v,response:o.stream.asyncIterable}}}class S{constructor(v,n){this.a=new w.$Sd,this.b=new Map,this.c=new g.$sh,this.d=!1;const o=this;this.apiObject={result:v,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){n.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let n=this.b.get(v.index);n||(this.b.size===0?n=new R(v.index,this.c):n=new R(v.index),this.b.set(v.index,n),this.a.fire(n.apiObj)),n.stream.emitOne(v.part)}}class l{static{this.a=1}constructor(v,n){this.d=n,this.c=new Map,this.e=new Map,this.f=new m.$im,this.b=v.getProxy(I.$MK.MainThreadChatProvider)}registerProvider(v,n,o,t){const r=l.a++;return this.c.set(r,{extension:v,provider:o}),this.b.$registerProvider(r,n,{extension:v,model:t.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,n,o,t,r){const a=this.c.get(v);if(!a)return;const c=new A.$gv(async h=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(n,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(M.ChatMessage.to),t,c,r)}allowListExtensionWhile(v,n){this.f.set(v,n),n.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,n){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(n);if(!o)throw new Error(`ChatAccess '${n}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(v)},makeRequest(r,a,c){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const h=new E.$3d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(v,n,i,r.map(M.ChatMessage.from),a??{},h.token),u=new S(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(v,n){const o=this.e.get(v);o&&o.res.handleFragment(n)}}e.$hfc=l}),define(Pe[237],Ae([1,0,6,3,11,8]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class A{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$MK.MainThreadChatVariables)}async $resolveVariable(g,w,R){const S=this.b.get(g);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:w},R);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,w,R,S){const l=A.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:R},resolver:S}),this.c.$registerVariable(l,{name:w,description:R}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$jfc=A}),define(Pe[238],Ae([1,0,3]),function(me,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class T{constructor(M){const A=M.getProxy(E.$MK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$kfc=T}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=void 0;let u=class{#e;#t;#i;constructor(p,y,k){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$MK.MainThreadCommands),this.d=y,this.#i=k,this.#t=p.getProxy(A.$MK.MainThreadTelemetry),this.converter=new d(this,O=>{const K=this.c.get(O);return K?.result===f.Void?K:void 0},y),this.f=[{processArgument(O){return(0,w.$yh)(O)}},{processArgument(O){return(0,M.$jn)(O,function(K){if(R.$Gs.isIRange(K))return I.Range.to(K);if(S.$Fs.isIPosition(K))return I.Position.to(K);if(R.$Gs.isIRange(K.range)&&l.URI.isUri(K.uri))return I.location.to(K);if(K instanceof t.$ge)return K.buffer.buffer;if(!Array.isArray(K))return K})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const y=this.registerCommand(!1,p.id,async(...k)=>{const O=p.args.map((U,L)=>{if(!U.validate(k[L]))throw new Error(`Invalid argument '${U.name}' when running '${p.id}', received: ${typeof k[L]=="object"?JSON.stringify(k[L],null,"	"):k[L]} `);return U.convert(k[L])}),K=await this.executeCommand(p.internalId,...O);return p.result.convert(K,k,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new T.$OK(()=>{y.dispose(),this.c.delete(p.id)})}registerCommand(p,y,k,O,K,U){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:k,thisArg:O,metadata:K,extension:U}),p&&this.#e.$registerCommand(y),new T.$OK(()=>{this.b.delete(y)&&p&&this.#e.$unregisterCommand(y)})}executeCommand(p,...y){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,y,!0)}async g(p,y,k){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,y,!1);{let O=!1;const K=(0,M.$jn)(y,function(U){if(U instanceof T.$PK)return I.Position.from(U);if(U instanceof T.$QK)return I.Range.from(U);if(U instanceof T.$1K)return I.location.from(U);if(T.$aM.isNotebookRange(U))return I.NotebookRange.from(U);if(U instanceof ArrayBuffer)return O=!0,t.$ge.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return O=!0,t.$ge.wrap(U);if(U instanceof t.$ge)return O=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(p,O?new r.$Ev(K):K,k);return(0,w.$yh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(p,y,!1);throw U}}}async h(p,y,k){const O=this.b.get(p);if(!O)throw new Error("Unknown command");const{callback:K,thisArg:U,metadata:L}=O;if(L?.args)for(let C=0;C<L.args.length;C++)try{(0,E.$Vf)(y[C],L.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${L.args[C].name}' - ${L.args[C].description}`)}const z=c.$Od.create();try{return await K.apply(U,y)}catch(C){if(p===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...y);P&&(p=P.command)}if(this.d.error(C,p,O.extension?.identifier),!k)throw C;if(O.extension?.identifier){const P=this.#i.onExtensionError(O.extension.identifier,C);this.d.trace("forwarded error to extension?",P,O.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Mi)(C)),this.id=p,this.source=O.extension?.displayName??O.extension?.name}}}finally{this.j(O,p,z.elapsed())}}j(p,y,k){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new h.$wo(y),duration:k})}$executeContributedCommand(p,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const k=this.b.get(p);return k?(y=y.map(O=>this.f.reduce((K,U)=>U.processArgument(K,k.extension?.identifier),O)),this.h(p,y,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(y=>(p&&(y=y.filter(k=>k[0]!=="_")),y))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[y,k]of this.b){const{metadata:O}=k;O&&(p[y]=O)}return Promise.resolve(p)}};e.$_M=u,e.$_M=u=Ge([Ke(0,n.$QM),Ke(1,g.$jj),Ke(2,i.$$M)],u),e.$aN=(0,v.$2h)("IExtHostCommands");class d{constructor(p,y,k){this.d=p,this.f=y,this.g=k,this.delegatingCommandId=`__vsc${(0,s.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,y){if(!p)return;const k={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return k;const O=this.f(p.command);if(O)k.id=O.internalId,k.arguments=O.args.map((K,U)=>K.convert(p.arguments&&p.arguments[U]));else if((0,m.$Lb)(p.arguments)){const K=`${p.command} /${++this.c}`;this.b.set(K,p),y.add((0,$.$Qc)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),k.$ident=K,k.id=this.delegatingCommandId,k.arguments=[K],this.g.trace("CommandsConverter#CREATE",p.command,K)}return k}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const y=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$bN=d;class b{static{this.Uri=new b("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p)}static{this.Position=new b("position","A position in a text document",p=>T.$PK.isPosition(p),I.Position.from)}static{this.Range=new b("range","A range in a text document",p=>T.$QK.isRange(p),I.Range.from)}static{this.Selection=new b("selection","A selection in a text document",p=>T.$RK.isSelection(p),I.Selection.from)}static{this.Number=new b("number","",p=>typeof p=="number",p=>p)}static{this.String=new b("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=b.Arr(b.String)}static Arr(p){return new b(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,y=>Array.isArray(y)&&y.every(k=>p.validate(k)),y=>y.map(k=>p.convert(k)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof T.$_K,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof T.$tM,I.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof o.$4M,I.TestItem.from)}constructor(p,y,k,O){this.name=p,this.description=y,this.validate=k,this.convert=O}optional(){return new b(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,y){return new b(p??this.name,y??this.description,this.validate,this.convert)}}e.$cN=b;class f{static{this.Void=new f("no result",p=>p)}constructor(p,y){this.description=p,this.convert=y}}e.$dN=f;class D{constructor(p,y,k,O,K){this.id=p,this.internalId=y,this.description=k,this.args=O,this.result=K}}e.$eN=D}),define(Pe[239],Ae([1,0,18,13,2,80,96,35,32,8,7]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;const S=[new g.$eN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of DocumentHighlight-instances.",$(w.DocumentHighlight.to))),new g.$eN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$cN.Uri],new g.$dN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,E.$Kb)(n))return;class t extends R.$7K{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new R.$1K(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return n.map(t.to)})),new g.$eN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$cN.Uri,new g.$cN("options","Formatting options",n=>!0,n=>n)],new g.$dN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$eN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$cN.Uri,g.$cN.Range,new g.$cN("options","Formatting options",n=>!0,n=>n)],new g.$dN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$eN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$cN.Uri,g.$cN.Position,new g.$cN("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$cN("options","Formatting options",n=>!0,n=>n)],new g.$dN("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$eN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$eN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$eN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$eN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$eN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Location-instances.",$(w.location.to))),new g.$eN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of Hover-instances.",$(w.Hover.to))),new g.$eN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$cN.Uri,new g.$cN("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>R.$PK.isPosition(o)),n=>n.map(w.Position.from))],new g.$dN("A promise that resolves to an array of ranges.",n=>n.map(o=>{let t;for(const r of o.reverse())t=new R.$$K(w.Range.to(r),t);return t}))),new g.$eN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$cN.String.with("query","Search string")],new g.$dN("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(w.WorkspaceSymbol.to))),new g.$eN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(w.CallHierarchyItem.to))),new g.$eN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$cN.CallHierarchyItem],new g.$dN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(w.CallHierarchyIncomingCall.to))),new g.$eN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$cN.CallHierarchyItem],new g.$dN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(w.CallHierarchyOutgoingCall.to))),new g.$eN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:w.Range.to(n.range),placeholder:n.text}})),new g.$eN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$cN.Uri,g.$cN.Position,g.$cN.String.with("newName","The new symbol name")],new g.$dN("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return w.WorkspaceEdit.to(n)}})),new g.$eN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$cN.Uri,g.$cN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$dN("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(w.DocumentLink.to))),new g.$eN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$cN.Uri],new g.$dN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$5L(n.tokenTypes,n.tokenModifiers)})),new g.$eN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$cN.Uri],new g.$dN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$h$)(n);if(o.type==="full")return new R.$7L(o.data,void 0)})),new g.$eN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$cN.Uri,g.$cN.Range.optional()],new g.$dN("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new R.$5L(n.tokenTypes,n.tokenModifiers)})),new g.$eN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$cN.Uri,g.$cN.Range],new g.$dN("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,A.$h$)(n);if(o.type==="full")return new R.$7L(o.data,void 0)})),new g.$eN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$cN.Uri,g.$cN.Position,g.$cN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$cN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$dN("A promise that resolves to a CompletionList-instance.",(n,o,t)=>{if(!n)return new R.$kL([]);const r=n.suggestions.map(a=>w.CompletionItem.to(a,t));return new R.$kL(r,n.incomplete)})),new g.$eN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$cN.Uri,g.$cN.Position,g.$cN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$dN("A promise that resolves to SignatureHelp.",n=>{if(n)return w.SignatureHelp.to(n)})),new g.$eN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$cN.Uri,g.$cN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$dN("A promise that resolves to an array of CodeLens-instances.",(n,o,t)=>$(r=>new R.$cL(w.Range.to(r.range),r.command&&t.fromInternal(r.command)))(n))),new g.$eN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$cN.Uri,new g.$cN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>R.$QK.isRange(n),n=>R.$RK.isSelection(n)?w.Selection.from(n):w.Range.from(n)),g.$cN.String.with("kind","Code action kind to return code actions for").optional(),g.$cN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$dN("A promise that resolves to an array of Command-instances.",(n,o,t)=>$(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(r.command)}else{const a=new R.$9K(r.title,r.kind?new R.$0K(r.kind):void 0);return r.edit&&(a.edit=w.WorkspaceEdit.to(r.edit)),r.command&&(a.command=t.fromInternal(r.command)),a.isPreferred=r.isPreferred,a}})(n))),new g.$eN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$cN.Uri],new g.$dN("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new R.$qL(w.Range.to(o.range),w.Color.to(o.color))):[])),new g.$eN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$cN("color","The color to show and insert",n=>n instanceof R.$pL,w.Color.from),new g.$cN("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:w.Range.from(n.range)}))],new g.$dN("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(w.ColorPresentation.to):[])),new g.$eN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$cN.Uri,g.$cN.Range],new g.$dN("A promise that resolves to an array of Inlay objects",(n,o,t)=>n.map(w.InlayHint.to.bind(void 0,t)))),new g.$eN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$cN.Uri],new g.$dN("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(w.FoldingRange.to)})),new g.$eN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$dN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new g.$eN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$cN.Uri,g.$cN.Range,new g.$cN("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof R.$QK,n=>w.InlineValueContext.from(n))],new g.$dN("A promise that resolves to an array of InlineValue objects",n=>n.map(w.InlineValue.to))),new g.$eN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$cN("uriOrString","Uri-instance or string (only http/https)",n=>I.URI.isUri(n)||typeof n=="string"&&(0,T.$bg)(n,T.Schemas.http,T.Schemas.https),n=>n),new g.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional(),g.$cN.String.with("label","").optional()],g.$dN.Void),new g.$eN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$cN.Uri.with("resource","Resource to open"),g.$cN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional()],g.$dN.Void),new g.$eN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$cN.Uri.with("left","Left-hand side resource of the diff editor"),g.$cN.Uri.with("right","Right-hand side resource of the diff editor"),g.$cN.String.with("title","Human readable title for the diff editor").optional(),new g.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)]).optional()],g.$dN.Void),new g.$eN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$cN.String.with("title","Human readable title for the changes editor"),new g.$cN("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[t,r,a]=o;if(!I.URI.isUri(t)||!I.URI.isUri(r)&&r!==void 0&&r!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},n=>n)],g.$dN.Void),new g.$eN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$cN.Uri,g.$cN.Position],new g.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$eN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$cN.TypeHierarchyItem],new g.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$eN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$cN.TypeHierarchyItem],new g.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new g.$eN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$cN.TestItem],g.$dN.Void),new g.$eN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$cN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$dN.Void),new g.$eN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$cN.String.with("name","The context key name"),new g.$cN("value","The context key value",()=>!0,n=>n)],g.$dN.Void),new g.$eN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$cN.Uri,g.$cN.StringArray,new g.$cN("MappedEditsContext","Mapped Edits Context",n=>w.MappedEditsContext.is(n),n=>w.MappedEditsContext.from(n))],new g.$dN("A promise that resolves to a workspace edit or null",n=>n?w.WorkspaceEdit.to(n):null))];class l{static register(o){S.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$1i)}}e.$dfc=l;function $(n){return o=>{if(Array.isArray(o))return o.map(n)}}function v(n){if(!Array.isArray(n))return;const o=[];for(const t of n)M.$st(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Pe[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;function $(v,n,o){const t=v.getProxy(S.$MK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$im,n.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const D=this.b.get(f.handle);return D?D.value:f}else if(f&&f.$mid===7){const D=this.b.get(f.commentControlHandle);if(!D)return f;const F=D.getCommentThread(f.commentThreadHandle);return F?F.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const F=D.getCommentThread(f.thread.commentThreadHandle);return F?f.$mid===8?F.value:{thread:F.value,text:f.text}:f}else if(f&&f.$mid===10){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const F=D.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const p=f.commentUniqueId,y=F.getCommentByUniqueId(p);return y||f}else if(f&&f.$mid===11){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const F=D.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const p=f.text,y=f.commentUniqueId,k=F.getCommentByUniqueId(y);return k?(typeof k.body=="string"?k.body=p:k.body=new R.$dL(p),k):f}return f}})}createCommentController(f,D,F){const p=r.a++,y=new c(f,p,D,F);this.b.set(y.handle,y);const k=this.c.get(f.identifier)||[];return k.push(y),this.c.set(f.identifier,k),y.value}async $createCommentThreadTemplate(f,D,F){const p=this.b.get(f);p&&p.$createCommentThreadTemplate(D,F)}async $updateCommentThreadTemplate(f,D,F){const p=this.b.get(f);p&&p.$updateCommentThreadTemplate(D,F)}$deleteCommentThread(f,D){this.b.get(f)?.$deleteCommentThread(D)}$provideCommentingRanges(f,D,F){const p=this.b.get(f);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(A.URI.revive(D));return(0,E.$Ug)(async()=>{const k=await p.commentingRangeProvider.provideCommentingRanges(y,F);let O;return Array.isArray(k)?O={ranges:k,fileComments:!1}:k?O={ranges:k.ranges||[],fileComments:k.fileComments||!1}:O=k??void 0,O}).then(k=>{let O;return k&&(O={ranges:k.ranges.map(K=>w.Range.from(K)),fileComments:k.fileComments}),O})}$toggleReaction(f,D,F,p,y){const k=this.b.get(f);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Ug)(()=>{const O=k.getCommentThread(D);if(O){const K=O.getCommentByUniqueId(p.uniqueIdInThread);if(k!==void 0&&K&&k.reactionHandler)return k.reactionHandler(K,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,D,F,p,y,k,O,K){this.m=D,this.n=F,this.o=p,this.p=y,this.q=k,this.extensionDescription=O,this.r=K,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Tc,this.l.value=new M.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(D,this.handle,this.n,this.o,w.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{t.$deleteCommentThread(D,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(L){U.range=L},get comments(){return U.comments},set comments(L){U.comments=L},get collapsibleState(){return U.collapsibleState},set collapsibleState(L){U.collapsibleState=L},get canReply(){return U.canReply},set canReply(L){U.canReply=L},get contextValue(){return U.contextValue},set contextValue(L){U.contextValue=L},get label(){return U.label},set label(L){U.label=L},get state(){return U.state},set state(L){U.state=L},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Rc);const f=F=>Object.prototype.hasOwnProperty.call(this.b,F),D={};f("range")&&(D.range=w.Range.from(this.p)),f("label")&&(D.label=this.label),f("contextValue")&&(D.contextValue=this.contextValue??null),f("comments")&&(D.comments=this.q.map(F=>h(this,F,this.k,this.extensionDescription))),f("collapsibleState")&&(D.collapseState=u(this.g)),f("canReply")&&(D.canReply=this.canReply),f("state")&&(D.state=d(this.h)),f("isTemplate")&&(D.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(f){for(const D of this.k){const F=D[0],p=D[1];if(f===p)return F}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ge([(0,T.$uh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,D,F,p){this.f=f,this.g=D,this.h=F,this.i=p,this.a=new Map,t.$registerCommentController(this.handle,F,p,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(k){y.options=k},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(k){y.commentingRangeProvider=k},get reactionHandler(){return y.reactionHandler},set reactionHandler(k){y.reactionHandler=k},createCommentThread(k,O,K){return y.createCommentThread(k,O,K).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,D,F){D===void 0&&(0,l.$kF)(this.f,"fileComments");const p=new a(this.id,this.handle,void 0,f,D,F,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(f,D){const F=new a(this.id,this.handle,void 0,A.URI.revive(f),w.Range.to(D),[],this.f,!0);return F.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(F.handle,F),F}$updateCommentThreadTemplate(f,D){const F=this.a.get(f);F&&(F.range=w.Range.to(D))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(b,f,D,F){let p=D.get(f);return p||(p=++b.commentHandle,D.set(f,p)),f.state!==void 0&&(0,l.$kF)(F,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:p,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(b){return{label:b.label,iconPath:b.iconPath?w.$PM(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function s(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?A.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function u(b){if(b!==void 0)switch(b){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(b){if(b!==void 0)switch(b){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new r}e.$nfc=$}),define(Pe[241],Ae([1,0,26,3,27,17]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let A=class{constructor(R,S){this.a=R.getProxy(T.$MK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,S){const l=this,$=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,S,$,arguments)}})}e(R,S,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:g($,this.b)}),this.c&&this.f(R,l,$)}};e.$bhc=A,e.$bhc=A=Ge([Ke(0,M.$QM),Ke(1,I.$7M)],A);const m=1e5;function g(w,R){const S=[];if(w.length)for(let l=0;l<w.length;l++){let $=w[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const v=$;v.stack?$=v.stack:$=v.toString()}S.push($)}if(R){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$mn)(S);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,19,23]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(T.$MK.MainThreadDecorations)}registerFileDecorationProvider(n,o){const t=l.c++;this.f.set(t,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Le)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$1e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const b of u){const f=(0,R.$mc)(b.uri.path);if(d!==f&&(d=f,s.push(b.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$OK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(n,o,t){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$$L.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$kF)(c,"codiconDecoration"),r[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),r}};e.$dgc=$,e.$dgc=$=l=Ge([Ke(0,A.$QM),Ke(1,m.$jj)],$),e.$egc=(0,M.$2h)("IExtHostDecorations")}),define(Pe[242],Ae([1,0,158,99,2,3,7,8,5,15,28,43]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0;class ${#e;#t;#i;constructor(o,t,r,a,c,h,i,s){this.d=o,this.e=t,this.f=r,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,r),this.#i=new R.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let r=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),r=[o]}else if(Array.isArray(o)){r=[];let h;o=[...o].sort($.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,r.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const a=[];let c=0;for(const h of r){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const b of s)if(b.severity===u[d]&&i.push({...m.Diagnostic.from(b),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[r,a]of this)o.call(t,r,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$0ec=$;let v=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new R.$Ac;for(const r of o)t.set(r,r);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,r,a){this.j=t,this.k=r,this.l=a,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(M.$MK.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:r,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,D){a.$changeMany(f,D),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,D.length===0?"CLEARING":D)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!r.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(r.has(d))}return new class extends ${constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,r=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=r.length,t.set(c.toString(),i),r.push([c,[]])),r[i][1]=r[i][1].concat(...h)});return r}}m(o){let t=[];for(const r of this.g.values())r.has(o)&&(t=t.concat(r.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",r=new $(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,r),this.n=r}for(const[t,r]of o)this.n.set(I.URI.revive(t),r.map(m.Diagnostic.to))}};e.$$ec=v,e.$$ec=v=l=Ge([Ke(1,w.$jj),Ke(2,S.$9ec)],v)}),define(Pe[243],Ae([1,0,2,3,23]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class M{constructor(m){this.a=m.getProxy(T.$MK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,I.$kF)(m,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(R=>E.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?E.URI.revive(g):void 0)}}e.$fgc=M}),define(Pe[244],Ae([1,0,11,2,7,3,13,20,12]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class w{static{this.a=0}constructor(S,l,$){this.d=l,this.e=$,this.b=new Map,this.c=S.getProxy(M.$MK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const $=w.a++;this.b.set($,l),this.c.$registerTextContentProvider($,S);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(n=>{if(n.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this.d.getDocument(n)&&this.$provideTextDocumentContent($,n).then(o=>{if(!o&&typeof o!="string")return;const t=this.d.getDocument(n);if(!t)return;const r=(0,g.$Ve)(o);if(!t.equalLines(r))return this.c.$onVirtualDocumentChange(n,o)},E.$1)})),new I.$OK(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(S,l){const $=this.b.get(S);return $?Promise.resolve($.provideTextDocumentContent(T.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$ggc=w}),define(Pe[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class l{constructor(v,n){this.a=new E.$Sd({onListenerError:S.$2}),this.b=new E.$Sd({onListenerError:S.$2}),this.c=new E.$Sd({onListenerError:S.$2}),this.d=new E.$Sd({onListenerError:S.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=v.getProxy(M.$MK.MainThreadDocuments),this.g=n,this.g.onDidRemoveDocuments(o=>{for(const t of o)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const t of o)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const n=this.g.getDocument(v);if(n)return n}getDocument(v){const n=this.getDocumentData(v);if(!n?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return n.document}ensureDocumentData(v){const n=this.g.getDocument(v);if(n)return Promise.resolve(n);let o=this.h.get(v.toString());return o||(o=this.f.$tryOpenDocument(v).then(t=>{this.h.delete(v.toString());const r=I.URI.revive(t);return(0,g.$Pf)(this.g.getDocument(r))},t=>(this.h.delete(v.toString()),Promise.reject(t))),this.h.set(v.toString(),o)),o}createDocumentData(v){return this.f.$tryCreateDocument(v).then(n=>I.URI.revive(n))}$acceptModelLanguageChanged(v,n){const o=I.URI.revive(v),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(n),this.a.fire(t.document)}$acceptModelSaved(v){const n=I.URI.revive(v),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(v,n){const o=I.URI.revive(v),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(n),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,n,o){const t=I.URI.revive(v),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(o),r.onEvents(n);let a;n.isUndoing?a=R.TextDocumentChangeReason.Undo:n.isRedoing&&(a=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$in)({document:r.document,contentChanges:n.changes.map(c=>({range:m.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:a}))}setWordDefinitionFor(v,n){(0,A.$SM)(v,n)}}e.$7ec=l}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=M.URI.revive(u),b=this.c.get(d);b?.unref()&&(this.c.delete(d),h.push(b.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=M.URI.revive(u.uri);let b=this.c.get(d);if(b&&d.scheme!==v.Schemas.vscodeNotebookCell&&d.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);b||(b=new t(new g.$TM(this.h.getProxy(m.$MK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,b),i.push(b.value)),b.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=M.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const b=this.c.get(d).value,f=new R.$ZM(u.id,this.h.getProxy(m.$MK.MainThreadTextEditors),this.i,new o.$V(()=>b.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(D=>S.Range.to(D)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return n.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$1M=r,e.$1M=r=Ge([Ke(0,w.$QM),Ke(1,l.$jj)],r),e.$2M=(0,A.$2h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,A.$2h)("IExtHostEditorTabs");class S{constructor(o,t,r){this.e=r,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$uM(M.URI.revive(this.b.input.uri));case 2:return new R.$vM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new R.$wM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new R.$xM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$yM(this.b.input.viewType);case 4:return new R.$zM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$AM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$BM;case 9:return new R.$CM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$DM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new S(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return w.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new S(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const t=this.c.find(r=>r.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let $=class{constructor(o){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=o.getProxy(m.$MK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,I.$Pf)(o.e.find(c=>c.groupId===r)?.apiObject)},close:async(r,a)=>{const c=Array.isArray(r)?r:[r];return c.length?v(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),r=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,r),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Pf)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(r=>r.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const r=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const t of this.e)for(const r of t.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const r=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");r.push(c.tabId)}return this.a.$closeTab(r,t)}async j(o,t){const r=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");r.push(c.groupId)}return this.a.$closeGroup(r,t)}};e.$Hfc=$,e.$Hfc=$=Ge([Ke(0,g.$QM)],$);function v(n){return n.tabs!==void 0}}),define(Pe[247],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$MK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(m,g);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider(m,w),new T.$OK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$igc=I}),define(Pe[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class l{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let t,r,a=14,c=14;for(const h of n){let i=t?(0,g.$0e)(t,h):0;for(i===0?r=1:r=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([r,h.toUpperCase().charCodeAt(i),c]),o.push([r,h.toLowerCase().charCodeAt(i),c]),r=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$jZ(o)}}provideDocumentLinks(n){this.c();const o=[],t=m.$kZ.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of t){const a=A.DocumentLink.to(r);a.target&&o.push(a)}return o}}class ${constructor(n,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(T.$MK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,t,r={}){if($.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;r.isCaseSensitive&&(c+=1024),r.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.$kF)(n,"fsChunks"),c+=4);let h;r.isReadonly&&(0,S.$fk)(r.isReadonly)&&((0,R.$kF)(n,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:b,type:f}=d;if(b.scheme!==o)continue;let D;switch(f){case M.FileChangeType.Changed:D=0;break;case M.FileChangeType.Created:D=1;break;case M.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:b,type:D})}this.a.$onFileSystemChange(a,u)});return(0,I.$Qc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:t,mtime:r,size:a,permissions:c}=n;return{type:o,ctime:t,mtime:r,size:a,permissions:c}}$stat(n,o){return Promise.resolve(this.l(n).stat(E.URI.revive(o))).then(t=>$.k(t))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(E.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(E.URI.revive(o))).then(t=>w.$ge.wrap(t))}$writeFile(n,o,t,r){return Promise.resolve(this.l(n).writeFile(E.URI.revive(o),t.buffer,r))}$delete(n,o,t){return Promise.resolve(this.l(n).delete(E.URI.revive(o),t))}$rename(n,o,t,r){return Promise.resolve(this.l(n).rename(E.URI.revive(o),E.URI.revive(t),r))}$copy(n,o,t,r){const a=this.l(n);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(E.URI.revive(o)))}$watch(n,o,t,r){const a=this.l(n).watch(E.URI.revive(t),r);this.f.set(o,a)}$unwatch(n,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(n,o,t){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(E.URI.revive(o),t))}$close(n,o){const t=this.l(n);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(n,o,t,r){const a=this.l(n);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(r);return Promise.resolve(a.read(o,t,c.buffer,0,r)).then(h=>c.slice(0,h))}$write(n,o,t,r){const a=this.l(n);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$jgc=$}),define(Pe[63],Ae([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=void 0;let v=$=class{constructor(o,t){this.b=new Map,this.c=new R.$$g,this.a=o.getProxy(E.$MK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(a){try{let c;const h=r.b.get(a.scheme);return h?(await r.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await r.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){$.e(c)}},async readDirectory(a){try{const c=r.b.get(a.scheme);return c?(await r.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await r.a.$readdir(a)}catch(c){return $.e(c)}},async createDirectory(a){try{const c=r.b.get(a.scheme);return c&&!c.isReadonly?(await r.a.$ensureActivation(a.scheme),await r.d(c.impl,c.extUri,a)):await r.a.$mkdir(a)}catch(c){return $.e(c)}},async readFile(a){try{const c=r.b.get(a.scheme);return c?(await r.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await r.a.$readFile(a)).buffer}catch(c){return $.e(c)}},async writeFile(a,c){try{const h=r.b.get(a.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(a.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(a)),await r.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await r.a.$writeFile(a,M.$ge.wrap(c))}catch(h){return $.e(h)}},async delete(a,c){try{const h=r.b.get(a.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await r.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return $.e(h)}},async rename(a,c,h){try{return await r.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},async copy(a,c,h){try{return await r.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,r){const a=[];for(;!t.isEqual(r,t.dirname(r));)try{if(!((await o.stat(r)).type&T.FileType.Directory))throw I.$3L.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$Bk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(r)),r=t.dirname(r)}for(let c=a.length-1;c>=0;c--){r=t.joinPath(r,a[c]);try{await o.createDirectory(r)}catch(h){if(T.$Bk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$3L)throw o;if(o instanceof T.$xk)switch(o.code){case T.FileSystemProviderErrorCode.FileExists:throw I.$3L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$3L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$3L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$3L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$3L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$3L.Unavailable(o.message);default:throw new I.$3L(o.message,o.name)}if(!(o instanceof Error))throw new I.$3L(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$3L.Unavailable(o.message);switch(o.name){case T.FileSystemProviderErrorCode.FileExists:throw I.$3L.FileExists(o.message);case T.FileSystemProviderErrorCode.FileNotFound:throw I.$3L.FileNotFound(o.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw I.$3L.FileNotADirectory(o.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw I.$3L.FileIsADirectory(o.message);case T.FileSystemProviderErrorCode.NoPermissions:throw I.$3L.NoPermissions(o.message);case T.FileSystemProviderErrorCode.Unavailable:throw I.$3L.Unavailable(o.message);default:throw new I.$3L(o.message,o.name)}}addFileSystemProvider(o,t,r){return this.b.set(o,{impl:t,extUri:r?.isCaseSensitive?S.$tg:S.$vg,isReadonly:!!r?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??S.$tg}};e.$vfc=v,e.$vfc=v=$=Ge([Ke(0,m.$QM),Ke(1,g.$9ec)],v),e.$wfc=(0,A.$2h)("IExtHostConsumerFileSystem")}),define(Pe[249],Ae([1,0,5,34,2,3,8,7,39]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,v,n,o,t,r){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const a=(0,T.$Ij)(t),c=typeof t=="string",h=r?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);a(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=m.$OK.from(this.i($,n,t,r,r?.correlate),this.b,this.c,this.d,i)}i($,v,n,o,t){const r=m.$OK.from();if(typeof n=="string")return r;const a=$.getProxy(M.$MK.MainThreadFileSystemEventService);let c=!1;return(n.pattern.includes(T.$Ej)||n.pattern.includes(T.$Fj))&&(c=!0),a.$watch(v.identifier.value,this.a,n.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),m.$OK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor($){this.a=$,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor($,v,n){this.j=$,this.k=v,this.l=n,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,v,n,o){return new w(this.j,$,v,this.a.event,A.GlobPattern.from(n),o)}$onFileEvent($){this.a.fire(new R($))}$onDidRunFileOperation($,v){switch($){case 2:this.b.fire(Object.freeze({files:v.map(n=>({oldUri:I.URI.revive(n.source),newUri:I.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(n=>I.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,v){return(n,o,t)=>{const r=function(c){n.call(o,c)};return r.extension=$,v.event(r,void 0,t)}}async $onWillRunFileOperation($,v,n,o){switch($){case 2:return await this.n(this.g,{files:v.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},n,o);case 1:return await this.n(this.i,{files:v.map(t=>I.URI.revive(t.target))},n,o);case 0:case 3:return await this.n(this.h,{files:v.map(t=>I.URI.revive(t.target))},n,o)}}async n($,v,n,o){const t=new Set,r=[];if(await $.fireAsync(v,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof m.$YK&&(r.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const a={edits:[]};for(const[,c]of r){const{edits:h}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$kgc=S}),define(Pe[250],Ae([1,0,6,2,3,8,7,32,14]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class w{static{this.a=0}constructor($,v){this.extension=$,this.provider=v,this.handle=w.a++}}class R{constructor($){this.session=$,this.responses=[]}}class S{static{this.a=0}constructor($,v,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=$.getProxy(I.$MK.MainThreadInlineChat),v.registerApiCommand(new m.$eN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$cN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],m.$dN.Void))}registerProvider($,v,n){const o=new w($,v);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??$.displayName??$.name,$.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",n?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession($,v,n,o){const t=this.b.get($);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(v)),a=M.Selection.to(n),c=await t.provider.prepareInteractiveEditorSession({document:r,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new R(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse($,v,n,o){const t=this.b.get($);if(!t)return;const r=this.d.get(v.id);if(!r)return;const a={prompt:n.prompt,selection:M.Selection.to(n.selection),wholeRange:M.Range.to(n.wholeRange),attempt:n.attempt,live:n.live};let c=!1;const h={report:async b=>{if(!n.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:b.message,edits:b.edits?.map(M.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:A.$dL.isMarkdownString(b.content)?b.content.value:b.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(r.session,a,h,o));let s;try{s=await(0,g.$Qg)(i,o)}finally{c=!0}if(!s)return;const u=r.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s)){const{edits:b,contents:f}=s,D=f!==void 0?M.MarkdownString.from(f):void 0;return b instanceof A.$YK?{...d,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(b),message:D}:{...d,id:u,type:"editorEdit",edits:b.map(M.TextEdit.from),message:D}}return{...d,id:u,type:"message",message:M.MarkdownString.from(s.contents)}}async $provideFollowups($,v,n,o){const t=this.b.get($),r=this.d.get(v),a=r?.responses[n];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(r.session,a,o));return(await(0,g.$Qg)(c,o))?.map(M.ChatReplyFollowup.from)}}$handleFeedback($,v,n,o){const t=this.b.get($),r=this.d.get(v),a=r?.responses[n];if(t&&a){const c=M.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(r.session,a,c)}}$releaseSession($,v){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$lgc=S}),define(Pe[251],Ae([1,0,2,32]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class I{constructor(A,m,g,w,R){this.a=m,this.b=g,this.c=w;const S=new T.$eN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$cN("showOptions","Show Options",l=>!0,l=>l),new T.$cN("resource","Interactive resource Uri",l=>!0,l=>l),new T.$cN("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$cN("title","Interactive editor title",l=>!0,l=>l)],new T.$dN("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,m,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$ygc=I}),define(Pe[252],Ae([1,0,3,7]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class I{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(E.$MK.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(A);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(A,m){const g=A.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new T.$OK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(A,m){const g=A.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new T.$OK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$zgc=I}),define(Pe[253],Ae([1,0,6,3]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(T.$MK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Agc=I}),define(Pe[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,96,89,75,60,11,14,23,160]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class u{constructor(N,q){this.d=N,this.e=q}async provideDocumentSymbols(N,q){const H=this.d.getDocument(N),B=await this.e.provideDocumentSymbols(H,q);if(!(0,R.$Kb)(B))return B[0]instanceof M.$8K?B.map(I.DocumentSymbol.from):u.f(B)}static f(N){N=N.slice(0).sort((B,J)=>{let _=B.location.range.start.compareTo(J.location.range.start);return _===0&&(_=J.location.range.end.compareTo(B.location.range.end)),_});const q=[],H=[];for(const B of N){const J={name:B.name||"!!MISSING: name!!",kind:I.SymbolKind.from(B.kind),tags:B.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:I.Range.from(B.location.range),selectionRange:I.Range.from(B.location.range),children:[]};for(;;){if(H.length===0){H.push(J),q.push(J);break}const _=H[H.length-1];if(w.$Gs.containsRange(_.range,J.range)&&!w.$Gs.equalsRange(_.range,J.range)){_.children?.push(J),H.push(J);break}H.pop()}}return q}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(N,q,H){this.g=N,this.h=q,this.j=H,this.e=new r.$5ec("CodeLens"),this.f=new Map}async provideCodeLenses(N,q){const H=this.g.getDocument(N),B=await this.j.provideCodeLenses(H,q);if(!B||q.isCancellationRequested)return;const J=this.e.add(B),_=new n.$Rc;this.f.set(J,_);const ye={cacheId:J,lenses:[]};for(let Te=0;Te<B.length;Te++)ye.lenses.push({cacheId:[J,Te],range:I.Range.from(B[Te].range),command:this.h.toInternal(B[Te].command,_)});return ye}async resolveCodeLens(N,q){const H=N.cacheId&&this.e.get(...N.cacheId);if(!H)return;let B;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?B=H:B=await this.j.resolveCodeLens(H,q),B||(B=H),q.isCancellationRequested)return;const J=N.cacheId&&this.f.get(N.cacheId[0]);if(J)return N.command=this.h.toInternal(B.command??d.d,J),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}function b(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class f{constructor(N,q){this.d=N,this.e=q}async provideDefinition(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDefinition(B,J,H);return b(_)}}class D{constructor(N,q){this.d=N,this.e=q}async provideDeclaration(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDeclaration(B,J,H);return b(_)}}class F{constructor(N,q){this.d=N,this.e=q}async provideImplementation(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideImplementation(B,J,H);return b(_)}}class p{constructor(N,q){this.d=N,this.e=q}async provideTypeDefinition(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideTypeDefinition(B,J,H);return b(_)}}class y{constructor(N,q){this.d=N,this.e=q}async provideHover(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideHover(B,J,H);if(!(!_||(0,R.$Kb)(_.contents)))return _.range||(_.range=B.getWordRangeAtPosition(J)),_.range||(_.range=new M.$QK(J,J)),I.Hover.from(_)}}class k{constructor(N,q){this.d=N,this.e=q}async provideEvaluatableExpression(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideEvaluatableExpression(B,J,H);if(_)return I.EvaluatableExpression.from(_)}}class O{constructor(N,q){this.d=N,this.e=q}async provideInlineValues(N,q,H,B){const J=this.d.getDocument(N),_=await this.e.provideInlineValues(J,I.Range.to(q),I.InlineValueContext.to(H),B);if(Array.isArray(_))return _.map(ye=>I.InlineValue.from(ye))}}class K{constructor(N,q){this.d=N,this.e=q}async provideDocumentHighlights(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideDocumentHighlights(B,J,H);if(Array.isArray(_))return _.map(I.DocumentHighlight.from)}}class U{constructor(N,q){this.d=N,this.e=q}async provideMultiDocumentHighlights(N,q,H,B){const J=this.d.getDocument(N),_=H.map(We=>this.d.getDocument(We)),ye=I.Position.to(q),Te=await this.e.provideMultiDocumentHighlights(J,ye,_,B);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class L{constructor(N,q){this.d=N,this.e=q}async provideLinkedEditingRanges(N,q,H){const B=this.d.getDocument(N),J=I.Position.to(q),_=await this.e.provideLinkedEditingRanges(B,J,H);if(_&&Array.isArray(_.ranges))return{ranges:(0,R.$Hb)(_.ranges.map(I.Range.from)),wordPattern:_.wordPattern}}}class z{constructor(N,q){this.d=N,this.e=q}async provideReferences(N,q,H,B){const J=this.d.getDocument(N),_=I.Position.to(q),ye=await this.e.provideReferences(J,_,H,B);if(Array.isArray(ye))return ye.map(I.location.from)}}class C{static{this.d=1e3}constructor(N,q,H,B,J,_,ye){this.g=N,this.h=q,this.j=H,this.k=B,this.l=J,this.m=_,this.n=ye,this.e=new r.$5ec("CodeAction"),this.f=new Map}async provideCodeActions(N,q,H,B){const J=this.g.getDocument(N),_=l.$Is.isISelection(q)?I.Selection.to(q):I.Range.to(q),ye=[];for(const it of this.j.getDiagnostics(N))if(_.intersection(it.range)&&ye.push(it)>C.d)break;const Te={diagnostics:ye,only:H.only?new M.$0K(H.only):void 0,triggerKind:I.CodeActionTriggerKind.to(H.trigger)},We=await this.k.provideCodeActions(J,_,Te,B);if(!(0,R.$Lb)(We)||B.isCancellationRequested)return;const He=this.e.add(We),Ye=new n.$Rc;this.f.set(He,Ye);const rt=[];for(let it=0;it<We.length;it++){const et=We[it];et&&(C.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Ye)})):(Te.only&&(et.kind?Te.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[He,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Ye),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.$jF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:He,actions:rt}}async resolveCodeAction(N,q){const[H,B]=N,J=this.e.get(H,B);if(!J||C.o(J))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(J,q)??J;let ye;_.edit&&(ye=I.WorkspaceEdit.from(_.edit,void 0));let Te;if(_.command){const We=this.f.get(H);We&&(Te=this.h.toInternal(_.command,We))}return{edit:ye,command:Te}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}class P{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,H,B,J){this.d=N,this.e=q,this.f=H,this.g=B,this.h=J}async prepareDocumentPaste(N,q,H,B){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(N),_=q.map(We=>I.Range.to(We)),ye=I.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(J,_,ye,B),B.isCancellationRequested)return;const Te=Array.from(ye).filter(([,We])=>!(We instanceof M.$DL));return I.DataTransfer.from(Te)}async providePasteEdits(N,q,H,B,J){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(q),ye=H.map(He=>I.Range.to(He)),Te=I.DataTransfer.toDataTransfer(B,async He=>(await this.d.$resolvePasteFileData(this.g,N,He)).buffer),We=await this.f.provideDocumentPasteEdits(_,ye,Te,J);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:P.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class Y{constructor(N,q){this.d=N,this.e=q}async provideDocumentFormattingEdits(N,q,H){const B=this.d.getDocument(N),J=await this.e.provideDocumentFormattingEdits(B,q,H);if(Array.isArray(J))return J.map(I.TextEdit.from)}}class ae{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeFormattingEdits(N,q,H,B){const J=this.d.getDocument(N),_=I.Range.to(q),ye=await this.e.provideDocumentRangeFormattingEdits(J,_,H,B);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,q,H,B){(0,S.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(N),_=q.map(I.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(J,_,H,B);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}}class ge{constructor(N,q){this.d=N,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,q,H,B,J){const _=this.d.getDocument(N),ye=I.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(_,ye,H,B,J);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class ve{constructor(N,q){this.e=N,this.f=q,this.d=new r.$5ec("WorkspaceSymbols")}async provideWorkspaceSymbols(N,q){const H=await this.e.provideWorkspaceSymbols(N,q);if(!(0,R.$Lb)(H))return{symbols:[]};const B=this.d.add(H),J={cacheId:B,symbols:[]};for(let _=0;_<H.length;_++){const ye=H[_];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}J.symbols.push({...I.WorkspaceSymbol.from(ye),cacheId:[B,_]})}return J}async resolveWorkspaceSymbol(N,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const H=this.d.get(...N.cacheId);if(H){const B=await this.e.resolveWorkspaceSymbol(H,q);return B&&(0,T.$kn)(N,I.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class De{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,q,H){this.d=N,this.e=q,this.f=H}async provideRenameEdits(N,q,H,B){const J=this.d.getDocument(N),_=I.Position.to(q);try{const ye=await this.e.provideRenameEdits(J,_,H,B);return ye?I.WorkspaceEdit.from(ye):void 0}catch(ye){const Te=De.g(ye);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(N,q,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const B=this.d.getDocument(N),J=I.Position.to(q);try{const _=await this.e.prepareRename(B,J,H);let ye,Te;if(M.$QK.isRange(_)?(ye=_,Te=B.getText(_)):(0,S.$Gf)(_)&&(ye=_.range,Te=_.placeholder),!ye||!Te)return;if(ye.start.line>J.line||ye.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ye),text:Te}}catch(_){const ye=De.g(_);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(_)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class de{constructor(N,q){this.resultId=N,this.tokens=q}}class he{constructor(N,q){this.f=N,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,q,H){const B=this.f.getDocument(N),J=q!==0?this.d.get(q):null;let _=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(B,J.resultId,H):await this.g.provideDocumentSemanticTokens(B,H);return J&&this.d.delete(q),_?(_=he.h(_),this.o(he.n(J,_),_)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return he.j(N)?he.k(N)?N:new M.$7L(new Uint32Array(N.data),N.resultId):he.l(N)?he.m(N)?N:new M.$9L(N.edits.map(q=>new M.$8L(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(N,q){if(!he.j(q)||!N||!N.tokens)return q;const H=N.tokens,B=H.length,J=q.data,_=J.length;let ye=0;const Te=Math.min(B,_);for(;ye<Te&&H[ye]===J[ye];)ye++;if(ye===B&&ye===_)return new M.$9L([],q.resultId);let We=0;const He=Te-ye;for(;We<He&&H[B-We-1]===J[_-We-1];)We++;return new M.$9L([{start:ye,deleteCount:B-ye-We,data:J.subarray(ye,_-We)}],q.resultId)}o(N,q){if(he.j(N)){const H=this.e++;return this.d.set(H,new de(N.resultId,N.data)),(0,o.$g$)({id:H,type:"full",data:N.data})}if(he.l(N)){const H=this.e++;return he.j(q)?this.d.set(H,new de(q.resultId,q.data)):this.d.set(H,new de(N.resultId)),(0,o.$g$)({id:H,type:"delta",deltas:(N.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class te{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeSemanticTokens(N,q,H){const B=this.d.getDocument(N),J=await this.e.provideDocumentRangeSemanticTokens(B,I.Range.to(q),H);return J?this.f(J):null}f(N){return(0,o.$g$)({id:0,type:"full",data:N.data})}}class Se{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,q,H,B,J){this.f=N,this.g=q,this.h=H,this.j=B,this.k=J,this.d=new r.$5ec("CompletionItem"),this.e=new Map}async provideCompletionItems(N,q,H,B){const J=this.f.getDocument(N),_=I.Position.to(q),ye=J.getWordRangeAtPosition(_)||new M.$QK(_,_),Te=ye.with({end:_}),We=new a.$Od,He=await this.h.provideCompletionItems(J,_,B,I.CompletionContext.to(H));if(!He||B.isCancellationRequested)return;const Ye=Array.isArray(He)?new M.$kL(He):He,rt=Se.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),it=new n.$Rc;this.e.set(rt,it);const et=[],ot={x:rt,b:et,a:{replace:I.Range.from(ye),insert:I.Range.from(Te)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let at=0;at<Ye.items.length;at++){const ze=Ye.items[at],pt=this.l(ze,[rt,at],Te,ye);et.push(pt)}return ot}async resolveCompletionItem(N,q){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...N);if(!H)return;const B=this.l(H,N),J=await this.h.resolveCompletionItem(H,q);if(!J)return;const _=this.l(J,N);return(B.h!==_.h||B.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==_.n||B.o!==_.o||!(0,T.$ln)(B.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q,H,B){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const _=this.g.toInternal(N.command,J),ye={x:q,a:N.label,b:N.kind!==void 0?I.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(I.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:I.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(I.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=N.textEdit.newText):typeof N.insertText=="string"?ye.h=N.insertText:N.insertText instanceof M.$ZK&&(ye.h=N.insertText.value,ye.i|=4);let Te;return N.textEdit?Te=N.textEdit.range:N.range&&(Te=N.range),M.$QK.isRange(Te)?ye.j=I.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!B?.isEqual(Te.replacing))&&(ye.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),ye}}class oe{async provideInlineCompletions(N,q,H,B){}disposeCompletions(N){}handleDidShowCompletionItem(N,q,H){}handlePartialAccept(N,q,H){}}class X extends oe{constructor(N,q,H,B){super(),this.f=N,this.g=q,this.h=H,this.j=B,this.d=new V,this.e=(0,i.$jF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$jF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,q,H,B){const J=this.g.getDocument(N),_=I.Position.to(q),ye=await this.h.provideInlineCompletionItems(J,_,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:I.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},B);if(!ye||B.isCancellationRequested)return;const Te=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],He=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Te}),items:Te.map((it,et)=>{let ot;it.command&&(Ye||(Ye=new n.$Rc),ot=this.j.toInternal(it.command,Ye));const at=it.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:it.filterText,range:it.range?I.Range.from(it.range):void 0,command:ot,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:We.map(it=>(Ye||(Ye=new n.$Rc),this.j.toInternal(it,Ye))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,q,H){const B=this.d.get(N)?.items[q];B&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(B,H)}handlePartialAccept(N,q,H){const B=this.d.get(N)?.items[q];B&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(B,H)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const q=this.e++;return this.d.set(q,N),q}disposeReferenceId(N){const q=this.d.get(N);return this.d.delete(N),q}get(N){return this.d.get(N)}}class ne{constructor(N,q){this.e=N,this.f=q,this.d=new r.$5ec("SignatureHelp")}async provideSignatureHelp(N,q,H,B){const J=this.e.getDocument(N),_=I.Position.to(q),ye=this.g(H),Te=await this.f.provideSignatureHelp(J,_,B,ye);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(N){let q;if(N.activeSignatureHelp){const H=I.SignatureHelp.to(N.activeSignatureHelp),B=this.d.get(N.activeSignatureHelp.id,0);B?(q=B,q.activeSignature=H.activeSignature,q.activeParameter=H.activeParameter):q=H}return{...N,activeSignatureHelp:q}}releaseSignatureHelp(N){this.d.delete(N)}}class Ie{constructor(N,q,H,B,J){this.f=N,this.g=q,this.h=H,this.j=B,this.k=J,this.d=new r.$5ec("InlayHints"),this.e=new Map}async provideInlayHints(N,q,H){const B=this.f.getDocument(N),J=I.Range.to(q),_=await this.h.provideInlayHints(B,J,H);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(H.isCancellationRequested)return;const ye=this.d.add(_);this.e.set(ye,new n.$Rc);const Te={hints:[],cacheId:ye};for(let We=0;We<_.length;We++)this.l(_[We],J)&&Te.hints.push(this.m(_[We],[ye,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Te}async resolveInlayHint(N,q){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...N);if(!H)return;const B=await this.h.resolveInlayHint(H,q);if(B&&this.l(B))return this.m(B,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q){return N.label.length===0||Array.isArray(N.label)&&N.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(q&&!q.contains(N.position))}m(N,q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const B={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(N.tooltip),position:I.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(I.TextEdit.from),kind:N.kind&&I.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?B.label=N.label:B.label=N.label.map(J=>{const _={label:J.value};return _.tooltip=I.MarkdownString.fromStrict(J.tooltip),M.$1K.isLocation(J.location)&&(_.location=I.location.from(J.location)),J.command&&(_.command=this.g.toInternal(J.command,H)),_}),B}}class Me{constructor(N,q){this.e=N,this.f=q,this.d=new r.$5ec("DocumentLink")}async provideLinks(N,q){const H=this.e.getDocument(N),B=await this.f.provideDocumentLinks(H,q);if(!(!Array.isArray(B)||B.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:B.filter(Me.g).map(I.DocumentLink.from)};{const J=this.d.add(B),_={links:[],cacheId:J};for(let ye=0;ye<B.length;ye++){if(!Me.g(B[ye]))continue;const Te=I.DocumentLink.from(B[ye]);Te.cacheId=[J,ye],_.links.push(Te)}return _}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,q){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...N);if(!H)return;const B=await this.f.resolveDocumentLink(H,q);if(!(!B||!Me.g(B)))return I.DocumentLink.from(B)}releaseLinks(N){this.d.delete(N)}}class Ce{constructor(N,q){this.d=N,this.e=q}async provideColors(N,q){const H=this.d.getDocument(N),B=await this.e.provideDocumentColors(H,q);return Array.isArray(B)?B.map(_=>({color:I.Color.from(_.color),range:I.Range.from(_.range)})):[]}async provideColorPresentations(N,q,H){const B=this.d.getDocument(N),J=I.Range.to(q.range),_=I.Color.to(q.color),ye=await this.e.provideColorPresentations(_,{document:B,range:J},H);if(Array.isArray(ye))return ye.map(I.ColorPresentation.from)}}class ce{constructor(N,q){this.d=N,this.e=q}async provideFoldingRanges(N,q,H){const B=this.d.getDocument(N),J=await this.e.provideFoldingRanges(B,q,H);if(Array.isArray(J))return J.map(I.FoldingRange.from)}}class ie{constructor(N,q,H){this.d=N,this.e=q,this.f=H}async provideSelectionRanges(N,q,H){const B=this.d.getDocument(N),J=q.map(I.Position.to),_=await this.e.provideSelectionRanges(B,J,H);if(!(0,R.$Lb)(_))return[];if(_.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Te=0;Te<J.length;Te++){const We=[];ye.push(We);let He=J[Te],Ye=_[Te];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return ye}}class Q{constructor(N,q){this.f=N,this.g=q,this.d=new t.$VM(""),this.e=new Map}async prepareSession(N,q,H){const B=this.f.getDocument(N),J=I.Position.to(q),_=await this.g.prepareCallHierarchy(B,J,H);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(Te=>this.h(ye,Te)):[this.h(ye,_)]}async provideCallsTo(N,q,H){const B=this.j(N,q);if(!B)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(B,H);if(J)return J.map(_=>({from:this.h(N,_.from),fromRanges:_.fromRanges.map(ye=>I.Range.from(ye))}))}async provideCallsFrom(N,q,H){const B=this.j(N,q);if(!B)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(B,H);if(J)return J.map(_=>({to:this.h(N,_.to),fromRanges:_.fromRanges.map(ye=>I.Range.from(ye))}))}releaseSession(N){this.e.delete(N)}h(N,q){const H=this.e.get(N),B=I.CallHierarchyItem.from(q,N,H.size.toString(36));return H.set(B._itemId,q),B}j(N,q){return this.e.get(N)?.get(q)}}class ee{constructor(N,q){this.f=N,this.g=q,this.d=new t.$VM(""),this.e=new Map}async prepareSession(N,q,H){const B=this.f.getDocument(N),J=I.Position.to(q),_=await this.g.prepareTypeHierarchy(B,J,H);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(Te=>this.h(ye,Te)):[this.h(ye,_)]}async provideSupertypes(N,q,H){const B=this.j(N,q);if(!B)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(B,H);if(J)return J.map(_=>this.h(N,_))}async provideSubtypes(N,q,H){const B=this.j(N,q);if(!B)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(B,H);if(J)return J.map(_=>this.h(N,_))}releaseSession(N){this.e.delete(N)}h(N,q){const H=this.e.get(N),B=I.TypeHierarchyItem.from(q,N,H.size.toString(36));return H.set(B._itemId,q),B}j(N,q){return this.e.get(N)?.get(q)}}class $e{static toInternalProviderId(N,q){return N+"."+q}constructor(N,q,H,B,J){this.d=N,this.e=q,this.f=H,this.g=B,this.h=J}async provideDocumentOnDropEdits(N,q,H,B,J){const _=this.e.getDocument(q),ye=I.Position.to(H),Te=I.DataTransfer.toDataTransfer(B,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,He)).buffer),We=await this.f.provideDocumentDropEdits(_,ye,Te,J);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:$e.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class be{constructor(N,q){this.d=N,this.e=q}async provideMappedEdits(N,q,H,B){const J=E.URI.revive(N),_=this.d.getDocument(J),ye=H.documents.map(He=>He.map(Ye=>({uri:E.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(rt=>I.Range.to(rt))}))),Te={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(_,q,Te,B);return We?I.WorkspaceEdit.from(We):null}}class Le{constructor(N,q){this.adapter=N,this.extension=q}}class le{static{this.d=0}constructor(N,q,H,B,J,_,ye,Te){this.g=q,this.h=H,this.j=B,this.k=J,this.l=_,this.m=ye,this.n=Te,this.f=new Map,this.e=N.getProxy(m.$MK.MainThreadLanguageFeatures)}o(N,q){return I.DocumentSelector.from(N,this.g,q)}p(N){return new M.$OK(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return le.d++}async s(N,q,H,B,J,_=!1){const ye=this.f.get(N);if(!ye||!(ye.adapter instanceof q))return B;const Te=Date.now();_||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const We=H(ye.adapter,ye.extension);return Promise.resolve(We).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(ye.extension.identifier,He))}).finally(()=>{_||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),$.CancellationToken.isCancellationToken(J)?(0,h.$Rg)(We,J):We}t(N,q){const H=this.q();return this.f.set(H,new Le(N,q)),H}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,H,B){const J=this.t(new u(this.h,H),N),_=B&&B.label||le.u(N);return this.e.$registerDocumentSymbolProvider(J,this.o(q,N),_),this.p(J)}$provideDocumentSymbols(N,q,H){return this.s(N,u,B=>B.provideDocumentSymbols(E.URI.revive(q),H),void 0,H)}registerCodeLensProvider(N,q,H){const B=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(B,new Le(new d(this.h,this.j.converter,H),N)),this.e.$registerCodeLensSupport(B,this.o(q,N),J);let _=this.p(B);if(J!==void 0){const ye=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(J));_=M.$OK.from(_,ye)}return _}$provideCodeLenses(N,q,H){return this.s(N,d,B=>B.provideCodeLenses(E.URI.revive(q),H),void 0,H)}$resolveCodeLens(N,q,H){return this.s(N,d,B=>B.resolveCodeLens(q,H),void 0,void 0)}$releaseCodeLenses(N,q){this.s(N,d,H=>Promise.resolve(H.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(N,q,H){const B=this.t(new f(this.h,H),N);return this.e.$registerDefinitionSupport(B,this.o(q,N)),this.p(B)}$provideDefinition(N,q,H,B){return this.s(N,f,J=>J.provideDefinition(E.URI.revive(q),H,B),[],B)}registerDeclarationProvider(N,q,H){const B=this.t(new D(this.h,H),N);return this.e.$registerDeclarationSupport(B,this.o(q,N)),this.p(B)}$provideDeclaration(N,q,H,B){return this.s(N,D,J=>J.provideDeclaration(E.URI.revive(q),H,B),[],B)}registerImplementationProvider(N,q,H){const B=this.t(new F(this.h,H),N);return this.e.$registerImplementationSupport(B,this.o(q,N)),this.p(B)}$provideImplementation(N,q,H,B){return this.s(N,F,J=>J.provideImplementation(E.URI.revive(q),H,B),[],B)}registerTypeDefinitionProvider(N,q,H){const B=this.t(new p(this.h,H),N);return this.e.$registerTypeDefinitionSupport(B,this.o(q,N)),this.p(B)}$provideTypeDefinition(N,q,H,B){return this.s(N,p,J=>J.provideTypeDefinition(E.URI.revive(q),H,B),[],B)}registerHoverProvider(N,q,H,B){const J=this.t(new y(this.h,H),N);return this.e.$registerHoverProvider(J,this.o(q,N)),this.p(J)}$provideHover(N,q,H,B){return this.s(N,y,J=>J.provideHover(E.URI.revive(q),H,B),void 0,B)}registerEvaluatableExpressionProvider(N,q,H,B){const J=this.t(new k(this.h,H),N);return this.e.$registerEvaluatableExpressionProvider(J,this.o(q,N)),this.p(J)}$provideEvaluatableExpression(N,q,H,B){return this.s(N,k,J=>J.provideEvaluatableExpression(E.URI.revive(q),H,B),void 0,B)}registerInlineValuesProvider(N,q,H,B){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new O(this.h,H),N);this.e.$registerInlineValuesProvider(_,this.o(q,N),J);let ye=this.p(_);if(J!==void 0){const Te=H.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(J));ye=M.$OK.from(ye,Te)}return ye}$provideInlineValues(N,q,H,B,J){return this.s(N,O,_=>_.provideInlineValues(E.URI.revive(q),H,B,J),void 0,J)}registerDocumentHighlightProvider(N,q,H){const B=this.t(new K(this.h,H),N);return this.e.$registerDocumentHighlightProvider(B,this.o(q,N)),this.p(B)}registerMultiDocumentHighlightProvider(N,q,H){const B=this.t(new U(this.h,H),N);return this.e.$registerMultiDocumentHighlightProvider(B,this.o(q,N)),this.p(B)}$provideDocumentHighlights(N,q,H,B){return this.s(N,K,J=>J.provideDocumentHighlights(E.URI.revive(q),H,B),void 0,B)}$provideMultiDocumentHighlights(N,q,H,B,J){return this.s(N,U,_=>_.provideMultiDocumentHighlights(E.URI.revive(q),H,B.map(ye=>E.URI.revive(ye)),J),void 0,J)}registerLinkedEditingRangeProvider(N,q,H){const B=this.t(new L(this.h,H),N);return this.e.$registerLinkedEditingRangeProvider(B,this.o(q,N)),this.p(B)}$provideLinkedEditingRanges(N,q,H,B){return this.s(N,L,async J=>{const _=await J.provideLinkedEditingRanges(E.URI.revive(q),H,B);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?le.w(_.wordPattern):void 0}},void 0,B)}registerReferenceProvider(N,q,H){const B=this.t(new z(this.h,H),N);return this.e.$registerReferenceSupport(B,this.o(q,N)),this.p(B)}$provideReferences(N,q,H,B,J){return this.s(N,z,_=>_.provideReferences(E.URI.revive(q),H,B,J),void 0,J)}registerCodeActionProvider(N,q,H,B){const J=new n.$Rc,_=this.t(new C(this.h,this.j.converter,this.k,H,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(_,this.o(q,N),{providedKinds:B?.providedCodeActionKinds?.map(ye=>ye.value),documentation:B?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,J)}))},le.u(N),!!H.resolveCodeAction),J.add(this.p(_)),J}$provideCodeActions(N,q,H,B,J){return this.s(N,C,_=>_.provideCodeActions(E.URI.revive(q),H,B,J),void 0,J)}$resolveCodeAction(N,q,H){return this.s(N,C,B=>B.resolveCodeAction(q,H),{},void 0)}$releaseCodeActions(N,q){this.s(N,C,H=>Promise.resolve(H.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(N,q,H){const B=this.t(new Y(this.h,H),N);return this.e.$registerDocumentFormattingSupport(B,this.o(q,N),N.identifier,N.displayName||N.name),this.p(B)}$provideDocumentFormattingEdits(N,q,H,B){return this.s(N,Y,J=>J.provideDocumentFormattingEdits(E.URI.revive(q),H,B),void 0,B)}registerDocumentRangeFormattingEditProvider(N,q,H){const B=typeof H.provideDocumentRangesFormattingEdits=="function",J=this.t(new ae(this.h,H),N);return this.e.$registerRangeFormattingSupport(J,this.o(q,N),N.identifier,N.displayName||N.name,B),this.p(J)}$provideDocumentRangeFormattingEdits(N,q,H,B,J){return this.s(N,ae,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(q),H,B,J),void 0,J)}$provideDocumentRangesFormattingEdits(N,q,H,B,J){return this.s(N,ae,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(q),H,B,J),void 0,J)}registerOnTypeFormattingEditProvider(N,q,H,B){const J=this.t(new ge(this.h,H),N);return this.e.$registerOnTypeFormattingSupport(J,this.o(q,N),B,N.identifier),this.p(J)}$provideOnTypeFormattingEdits(N,q,H,B,J,_){return this.s(N,ge,ye=>ye.provideOnTypeFormattingEdits(E.URI.revive(q),H,B,J,_),void 0,_)}registerWorkspaceSymbolProvider(N,q){const H=this.t(new ve(q,this.l),N);return this.e.$registerNavigateTypeSupport(H,typeof q.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(N,q,H){return this.s(N,ve,B=>B.provideWorkspaceSymbols(q,H),{symbols:[]},H)}$resolveWorkspaceSymbol(N,q,H){return this.s(N,ve,B=>B.resolveWorkspaceSymbol(q,H),void 0,void 0)}$releaseWorkspaceSymbols(N,q){this.s(N,ve,H=>H.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(N,q,H){const B=this.t(new De(this.h,H,this.l),N);return this.e.$registerRenameSupport(B,this.o(q,N),De.supportsResolving(H)),this.p(B)}$provideRenameEdits(N,q,H,B,J){return this.s(N,De,_=>_.provideRenameEdits(E.URI.revive(q),H,B,J),void 0,J)}$resolveRenameLocation(N,q,H,B){return this.s(N,De,J=>J.resolveRenameLocation(E.URI.revive(q),H,B),void 0,B)}registerDocumentSemanticTokensProvider(N,q,H,B){const J=this.t(new he(this.h,H),N),_=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(q,N),B,_);let ye=this.p(J);if(_){const Te=H.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(_));ye=M.$OK.from(ye,Te)}return ye}$provideDocumentSemanticTokens(N,q,H,B){return this.s(N,he,J=>J.provideDocumentSemanticTokens(E.URI.revive(q),H,B),null,B)}$releaseDocumentSemanticTokens(N,q){this.s(N,he,H=>H.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,q,H,B){const J=this.t(new te(this.h,H),N);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(q,N),B),this.p(J)}$provideDocumentRangeSemanticTokens(N,q,H,B){return this.s(N,te,J=>J.provideDocumentRangeSemanticTokens(E.URI.revive(q),H,B),null,B)}registerCompletionItemProvider(N,q,H,B){const J=this.t(new Se(this.h,this.j.converter,H,this.m,N),N);return this.e.$registerCompletionsProvider(J,this.o(q,N),B,Se.supportsResolving(H),N.identifier),this.p(J)}$provideCompletionItems(N,q,H,B,J){return this.s(N,Se,_=>_.provideCompletionItems(E.URI.revive(q),H,B,J),void 0,J)}$resolveCompletionItem(N,q,H){return this.s(N,Se,B=>B.resolveCompletionItem(q,H),void 0,H)}$releaseCompletionItems(N,q){this.s(N,Se,H=>H.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(N,q,H,B){const J=new X(N,this.h,H,this.j.converter),_=this.t(J,N);return this.e.$registerInlineCompletionsSupport(_,this.o(q,N),J.supportsHandleEvents,v.$gm.toKey(N.identifier.value),B?.yieldTo?.map(ye=>v.$gm.toKey(ye))||[]),this.p(_)}$provideInlineCompletions(N,q,H,B,J){return this.s(N,oe,_=>_.provideInlineCompletions(E.URI.revive(q),H,B,J),void 0,J)}$handleInlineCompletionDidShow(N,q,H,B){this.s(N,oe,async J=>{J.handleDidShowCompletionItem(q,H,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,q,H,B){this.s(N,oe,async J=>{J.handlePartialAccept(q,H,B)},void 0,void 0)}$freeInlineCompletionsList(N,q){this.s(N,oe,async H=>{H.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(N,q,H,B){const J=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,_=this.t(new ne(this.h,H),N);return this.e.$registerSignatureHelpProvider(_,this.o(q,N),J),this.p(_)}$provideSignatureHelp(N,q,H,B,J){return this.s(N,ne,_=>_.provideSignatureHelp(E.URI.revive(q),H,B,J),void 0,J)}$releaseSignatureHelp(N,q){this.s(N,ne,H=>H.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(N,q,H){const B=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new Ie(this.h,this.j.converter,H,this.l,N),N);this.e.$registerInlayHintsProvider(J,this.o(q,N),typeof H.resolveInlayHint=="function",B,le.u(N));let _=this.p(J);if(B!==void 0){const ye=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(B));_=M.$OK.from(_,ye)}return _}$provideInlayHints(N,q,H,B){return this.s(N,Ie,J=>J.provideInlayHints(E.URI.revive(q),H,B),void 0,B)}$resolveInlayHint(N,q,H){return this.s(N,Ie,B=>B.resolveInlayHint(q,H),void 0,H)}$releaseInlayHints(N,q){this.s(N,Ie,H=>H.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(N,q,H){const B=this.t(new Me(this.h,H),N);return this.e.$registerDocumentLinkProvider(B,this.o(q,N),typeof H.resolveDocumentLink=="function"),this.p(B)}$provideDocumentLinks(N,q,H){return this.s(N,Me,B=>B.provideLinks(E.URI.revive(q),H),void 0,H,q.scheme==="output")}$resolveDocumentLink(N,q,H){return this.s(N,Me,B=>B.resolveLink(q,H),void 0,void 0,!0)}$releaseDocumentLinks(N,q){this.s(N,Me,H=>H.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(N,q,H){const B=this.t(new Ce(this.h,H),N);return this.e.$registerDocumentColorProvider(B,this.o(q,N)),this.p(B)}$provideDocumentColors(N,q,H){return this.s(N,Ce,B=>B.provideColors(E.URI.revive(q),H),[],H)}$provideColorPresentations(N,q,H,B){return this.s(N,Ce,J=>J.provideColorPresentations(E.URI.revive(q),H,B),void 0,B)}registerFoldingRangeProvider(N,q,H){const B=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(B,new Le(new ce(this.h,H),N)),this.e.$registerFoldingRangeProvider(B,this.o(q,N),N.identifier,J);let _=this.p(B);if(J!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));_=M.$OK.from(_,ye)}return _}$provideFoldingRanges(N,q,H,B){return this.s(N,ce,J=>J.provideFoldingRanges(E.URI.revive(q),H,B),void 0,B)}registerSelectionRangeProvider(N,q,H){const B=this.t(new ie(this.h,H,this.l),N);return this.e.$registerSelectionRangeProvider(B,this.o(q,N)),this.p(B)}$provideSelectionRanges(N,q,H,B){return this.s(N,ie,J=>J.provideSelectionRanges(E.URI.revive(q),H,B),[],B)}registerCallHierarchyProvider(N,q,H){const B=this.t(new Q(this.h,H),N);return this.e.$registerCallHierarchyProvider(B,this.o(q,N)),this.p(B)}$prepareCallHierarchy(N,q,H,B){return this.s(N,Q,J=>Promise.resolve(J.prepareSession(E.URI.revive(q),H,B)),void 0,B)}$provideCallHierarchyIncomingCalls(N,q,H,B){return this.s(N,Q,J=>J.provideCallsTo(q,H,B),void 0,B)}$provideCallHierarchyOutgoingCalls(N,q,H,B){return this.s(N,Q,J=>J.provideCallsFrom(q,H,B),void 0,B)}$releaseCallHierarchy(N,q){this.s(N,Q,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(N,q,H){const B=this.t(new ee(this.h,H),N);return this.e.$registerTypeHierarchyProvider(B,this.o(q,N)),this.p(B)}$prepareTypeHierarchy(N,q,H,B){return this.s(N,ee,J=>Promise.resolve(J.prepareSession(E.URI.revive(q),H,B)),void 0,B)}$provideTypeHierarchySupertypes(N,q,H,B){return this.s(N,ee,J=>J.provideSupertypes(q,H,B),void 0,B)}$provideTypeHierarchySubtypes(N,q,H,B){return this.s(N,ee,J=>J.provideSubtypes(q,H,B),void 0,B)}$releaseTypeHierarchy(N,q){this.s(N,ee,H=>Promise.resolve(H.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(N,q,H,B){const J=this.q();this.f.set(J,new Le(new $e(this.e,this.h,H,J,N),N));const _=(0,i.$jF)(N,"dropMetadata")&&B?$e.toInternalProviderId(N.identifier.value,B.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(q,N),_,(0,i.$jF)(N,"dropMetadata")?B:void 0),this.p(J)}$provideDocumentOnDropEdits(N,q,H,B,J,_){return this.s(N,$e,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(q,E.URI.revive(H),B,J,_)),void 0,void 0)}registerMappedEditsProvider(N,q,H){const B=this.t(new be(this.h,H),N);return this.e.$registerMappedEditsProvider(B,this.o(q,N)),this.p(B)}$provideMappedEdits(N,q,H,B,J){return this.s(N,be,_=>Promise.resolve(_.provideMappedEdits(q,H,B,J)),null,J)}registerDocumentPasteEditProvider(N,q,H,B){const J=this.q();this.f.set(J,new Le(new P(this.e,this.h,H,J,N),N));const _=P.toInternalProviderId(N.identifier.value,B.id);return this.e.$registerPasteEditProvider(J,this.o(q,N),_,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(N,q,H,B,J){return this.s(N,P,_=>_.prepareDocumentPaste(E.URI.revive(q),H,B,J),void 0,J)}$providePasteEdits(N,q,H,B,J,_){return this.s(N,P,ye=>ye.providePasteEdits(q,E.URI.revive(H),B,J,_),void 0,_)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:le.w(N.decreaseIndentPattern),increaseIndentPattern:le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:le.w(N.beforeText),afterText:N.afterText?le.w(N.afterText):void 0,previousLineText:N.previousLineText?le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(le.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(N){return N.map(le.C)}setLanguageConfiguration(N,q,H){const{wordPattern:B}=H;if(B&&(0,g.$Ue)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this.h.setWordDefinitionFor(q,B):this.h.setWordDefinitionFor(q,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const J=this.q(),_={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,q,_),this.p(J)}$setWordDefinitions(N){for(const q of N)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$cfc=le}),define(Pe[255],Ae([1,0,3,8,7,31,14,6,23]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class w{constructor(S,l,$,v){this.c=l,this.d=$,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$MK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const $=this.c.getDocumentData(S);if(!$)throw new Error(`document '${S.toString()}' NOT found`);return $.document}async tokenAtPosition(S,l){const $=S.version,v=T.Position.from(l),n=await this.a.$tokensAtPosition(S.uri,v),o={type:I.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new I.$QK(l.line,l.character,l.line,l.character)};if(!n)return o;const t={range:T.Range.to(n.range),type:T.TokenType.to(n.type)};return!t.range.contains(l)||$!==S.version?o:t}createLanguageStatusItem(S,l,$){const v=this.f++,n=this.a,o=this.g,t=`${S.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const r={selector:$,id:l,name:S.displayName??S.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new m.$Rc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,A.$4g)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:t,name:r.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===I.LanguageStatusSeverity.Error?M.default.Error:r.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,c),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),n.$removeLanguageStatus(v),o.delete(t)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,h()},get selector(){return r.selector},set selector(s){r.selector=s,h()},get text(){return r.text},set text(s){r.text=s,h()},set text2(s){(0,g.$kF)(S,"languageStatusText"),r.text=s,h()},get text2(){return(0,g.$kF)(S,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,h()},get severity(){return r.severity},set severity(s){r.severity=s,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,h()},get command(){return r.command},set command(s){r.command=s,h()},get busy(){return r.busy},set busy(s){r.busy=s,h()}};return h(),i}}e.$Bgc=w}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0;let R=class{constructor(l,$,v){this.f=v,this.d=new Map,this.a=$.getProxy(m.$MK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,$){const{message:v,args:n,comment:o}=$;if(this.c)return(0,T.$Ie)(v,n??{});let t=v;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(l)?.contents[t];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ie)(r??v,n??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(v),o=JSON.parse(n);$=l.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${n.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:v})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive($)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Zfc=R,e.$Zfc=R=Ge([Ke(0,g.$7M),Ke(1,w.$QM),Ke(2,A.$jj)],R),e.$1fc=(0,M.$2h)("IExtHostLocalizationService")}),define(Pe[256],Ae([1,0,15,3,27,17,2,51]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let g=class extends E.$uj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$yh)($))),this.r=S.getProxy(T.$MK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(A.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,$){return new w(this.r,S,l,$)}};e.$ahc=g,e.$ahc=g=Ge([Ke(0,M.$QM),Ke(1,I.$7M)],g);class w extends E.$pj{constructor(S,l,$,v){super(v?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const $=[[S,l]];this.m?this.u($):this.n.push(...$)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0,e.$2fc=(0,T.$2h)("IExtHostManagedSockets");let m=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$MK.MainThreadManagedSockets)}setFactory(S,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,$=await this.c.makeConnection(),v=new I.$Rc;return this.d.set(l,new w(l,$,v)),v.add((0,I.$Qc)(()=>this.d.delete(l))),v.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add($.onDidClose(n=>{this.a.$onDidManagedSocketClose(l,n?.stack??n?.message),v.dispose()})),v.add($.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(l,A.$ge.wrap(n)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$3fc=m,e.$3fc=m=Ge([Ke(0,M.$QM)],m);class g{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class w extends I.$Sc{constructor(S,l,$){super(),this.socketId=S,this.actual=l,this.B($)}}}),define(Pe[257],Ae([1,0,3,15,23]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;function M(m){return m&&m.title}let A=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$MK.MainThreadMessageService)}showMessage(g,w,R,S,l){const $={source:{identifier:g.identifier,label:g.displayName||g.name}};let v;typeof S=="string"||M(S)?v=[S,...l]:($.modal=S?.modal,$.useCustom=S?.useCustom,$.detail=S?.detail,v=l),$.useCustom&&(0,I.$kF)(g,"resolvers");const n=[];for(let o=0;o<v.length;o++){const t=v[o];if(typeof t=="string")n.push({title:t,handle:o,isCloseAffordance:!1});else if(typeof t=="object"){const{title:r,isCloseAffordance:a}=t;n.push({title:r,isCloseAffordance:!!a,handle:o})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(w,R,$,n).then(o=>{if(typeof o=="number")return v[o]})}};e.$Cgc=A,e.$Cgc=A=Ge([Ke(1,T.$jj)],A)}),define(Pe[258],Ae([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0;let a=class{constructor(f,D,F,p,y){this.m=D,this.n=F,this.o=p,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(S.$MK.MainThreadNotebookKernels);const k=new l.$eN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$cN("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const K=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:K}}else if(O&&"notebookEditor"in O){const K=this.n.getIdByEditor(O.notebookEditor);if(K===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:K}}return O})],l.$dN.Void);this.o.registerApiCommand(k)}createNotebookController(f,D,F,p,y,k){for(const te of this.j.values())if(te.controller.id===D&&w.$gm.equals(f.identifier,te.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,K=this;this.q.trace(`NotebookController[${O}], CREATED by ${f.identifier.value}, ${D}`);const U=()=>console.warn(`NO execute handler from notebook controller '${P.id}' of extension: '${f.identifier}'`);let L=!1;const z=new M.$Sd,C=new M.$Sd,P={id:d(f.identifier,D),notebookType:F,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:p||f.identifier.value,preloads:k?k.map($.NotebookRendererScript.from):[]};let Y=y??U,ae,ge;this.a.$addKernel(O,P).catch(te=>{console.log(te),L=!0});let ve=0;const De=()=>{if(L)return;const te=++ve;Promise.resolve().then(()=>{te===ve&&this.a.$updateKernel(O,P)})},de=new m.$Ac,he={get id(){return D},get notebookType(){return P.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return P.label},set label(te){P.label=te??f.displayName??f.name,De()},get detail(){return P.detail??""},set detail(te){P.detail=te,De()},get description(){return P.description??""},set description(te){P.description=te,De()},get supportedLanguages(){return P.supportedLanguages},set supportedLanguages(te){P.supportedLanguages=te,De()},get supportsExecutionOrder(){return P.supportsExecutionOrder??!1},set supportsExecutionOrder(te){P.supportsExecutionOrder=te,De()},get rendererScripts(){return P.preloads?P.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(te){Y=te??U},get interruptHandler(){return ae},set interruptHandler(te){ae=te,P.supportsInterrupt=!!te,De()},set variableProvider(te){(0,t.$kF)(f,"notebookVariableProvider"),ge=te,P.hasVariableProvider=!!te,te?.onDidChangeVariables(Se=>K.a.$variablesUpdated(Se.uri)),De()},get variableProvider(){return ge},createNotebookCellExecution(te){if(L)throw new Error("notebook controller is DISPOSED");if(!de.has(te.notebook.uri))throw K.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return K._createNotebookCellExecution(te,d(f.identifier,this.id))},createNotebookExecution(te){if((0,t.$kF)(f,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!de.has(te.uri))throw K.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return K._createNotebookExecution(te,d(f.identifier,this.id))},dispose:()=>{L||(this.q.trace(`NotebookController[${O}], DISPOSED`),L=!0,this.j.delete(O),z.dispose(),C.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(te,Se){Se===v.NotebookControllerAffinity2.Hidden&&(0,t.$kF)(f,"notebookControllerAffinityHidden"),K.a.$updateNotebookPriority(O,te.uri,Se)},onDidReceiveMessage:C.event,postMessage(te,Se){return(0,t.$kF)(f,"notebookMessaging"),K.a.$postMessage(O,Se&&K.n.getIdByEditor(Se),te)},asWebviewUri(te){return(0,t.$kF)(f,"notebookMessaging"),(0,n.$fvb)(te,K.m.remote)}};return this.j.set(O,{extensionId:f.identifier,controller:he,onDidReceiveMessage:C,onDidChangeSelection:z,associatedNotebooks:de}),he}getIdByController(f){for(const[D,F]of this.j)if(F.controller===f)return d(F.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const F=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${F}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(F,D);const y={dispose:()=>{this.f.delete(F),p.a.$removeKernelDetectionTask(F)}};return this.f.set(F,y),y}registerKernelSourceActionProvider(f,D,F){const p=this.i++,y=typeof F.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,k=this;this.h.set(p,F),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,D);let O;return y!==void 0&&(O=F.onDidChangeNotebookKernelSourceActions(K=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(p),k.a.$removeKernelSourceActionProvider(p,p),O?.dispose()}}}async $provideKernelSourceActions(f,D){const F=this.h.get(f);if(F){const p=new A.$Rc;return(await F.provideNotebookKernelSourceActions(D)??[]).map(k=>$.NotebookKernelSourceAction.from(k,this.o.converter,p))}return[]}$acceptNotebookAssociation(f,D,F){const p=this.j.get(f);if(p){const y=this.n.getNotebookDocument(g.URI.revive(D));F?p.associatedNotebooks.set(y.uri,!0):p.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),F),p.onDidChangeSelection.fire({selected:F,notebook:y.apiNotebook})}}async $executeCells(f,D,F){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(D)),k=[];for(const O of F){const K=y.getCell(O);K&&k.push(K.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),k.length),await p.controller.executeHandler.call(p.controller,k,y.apiNotebook,p.controller)}catch(O){this.q.error(`NotebookController[${f}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(f,D,F){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(D));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,y.apiNotebook);else for(const k of F){const O=y.getCell(k);O&&this.b.get(O.uri)?.cancel()}if(p.controller.interruptHandler){const k=this.c.get(y.uri);F.length&&Array.isArray(k)&&k.length&&k.forEach(O=>O.dispose())}}async $provideVariables(f,D,F,p,y,k,O){const K=this.j.get(f);if(!K)return;const U=this.n.getNotebookDocument(g.URI.revive(F)),L=K.controller.variableProvider;if(!L)return;const z=p?{name:p,value:""}:void 0,C=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,P=L.provideVariables(U.apiNotebook,z,C,k,O);for await(const Y of P){if(O.isCancellationRequested)return;this.a.$receiveVariable(D,Y)}}$acceptKernelMessageFromRenderer(f,D,F){const p=this.j.get(f);if(!p)return;const y=this.n.getEditorById(D);p.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:F}))}$cellExecutionChanged(f,D,F){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(D);if(y){const k=F?$.NotebookCellExecutionState.to(F):v.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:y.apiCell,state:k})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const y=new h(D,p,this.a);this.b.set(p.uri,y);const k=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),k.dispose(),this.b.delete(p.uri))});return y.asApiObject()}_createNotebookExecution(f,D){const F=this.n.getNotebookDocument(f.uri),p=f.getCells().find(O=>{const K=F.getCellFromApiCell(O);return K&&this.b.has(K.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(F.uri))throw new Error(`duplicate notebook execution for ${F.uri}`);const y=new s(D,F,this.a),k=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),k.dispose(),this.c.delete(F.uri))});return this.c.set(F.uri,[y,k]),y.asApiObject()}};e.$Ggc=a,e.$Ggc=a=Ge([Ke(4,R.$jj)],a);var c;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(c||(c={}));class h extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,D,F){super(),this.m=D,this.n=F,this.b=h.a++,this.c=new M.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$3d),this.h=new u(10,p=>this.s(p)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new r.$Ev(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const F=v.$eM.ensureUniqueMimeTypes(D.items,!0);return F===D.items?$.NotebookCellOutput.from(D):$.NotebookCellOutput.from({items:F,id:D.id,metadata:D.metadata})})}async z(f,D,F){const p=this.w(D),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:p,append:F,outputs:y})}async C(f,D,F){return f=v.$eM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map($.NotebookCellOutputItem.from),outputId:D.id,append:F})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(F){f.j=F,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(F){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:F})},end(F,p){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new r.$Ev({runEndTime:p,lastRunSuccess:F}))},clearOutput(F){return f.t(),f.z([],F,!1)},appendOutput(F,p){return f.t(),f.z(F,p,!0)},replaceOutput(F,p){return f.t(),f.z(F,p,!1)},appendOutputItems(F,p){return f.t(),f.C(F,p,!0)},replaceOutputItems(F,p){return f.t(),f.C(F,p,!1)}})}}var i;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(i||(i={}));class s extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(f,D,F){super(),this.h=D,this.j=F,this.b=s.a++,this.c=new M.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$mh,this.b=Date.now(),(0,T.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function d(b,f){return`${b.value}/${f}`}e.$Hgc=d}),define(Pe[259],Ae([1,0,5,3,107]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class M{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(T.$MK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,w){const R=this.c.getEditorById(m);this.a.get(g)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(R=>R.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(R,S,l)=>this.d(g).event(R,S,l),postMessage:(R,S)=>{I.$ogc.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const l=S&&I.$ogc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,g,R)}}}d(m){let g=this.a.get(m);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Igc=M}),define(Pe[260],Ae([1,0,6,16,2,23,3]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(A.$MK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,R,S){if((0,M.$kF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,S),this.a.$registerProfileContentHandler(R,S.name,S.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,S,l){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.saveProfile(R,S,l)}async $readProfile(w,R,S){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Ef)(R)?R:I.URI.revive(R),S)}}e.$Lgc=m}),define(Pe[261],Ae([1,0,2,3,14,8]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class A{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$MK.MainThreadQuickDiff)}$provideOriginalResource(g,w,R){const S=E.URI.revive(w),l=this.c.get(g);return l?(0,I.$Ug)(()=>l.provideOriginalResource(S,R)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,R,S){const l=A.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(g,this.d),R,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Ngc=A}),define(Pe[262],Ae([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;function v(n,o,t){const r=n.getProxy(M.$MK.MainThreadQuickOpen);class a{constructor(D,F){this.e=new Map,this.f=0,this.a=D,this.b=F}showQuickPick(D,F,p,y=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(F),O=++this.f,K=r.$show(O,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},y),U={},L=K.then(()=>U);return Promise.race([L,k]).then(z=>{if(z===U)return;const C=(0,l.$jF)(D,"quickPickItemTooltip");return k.then(P=>{const Y=[];for(let ae=0;ae<P.length;ae++){const ge=P[ae];if(typeof ge=="string")Y.push({label:ge,handle:ae});else if(ge.kind===m.QuickPickItemKind.Separator)Y.push({type:"separator",label:ge.label});else{ge.tooltip&&!C&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ve=ge.iconPath?u(ge.iconPath):void 0;Y.push({label:ge.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ae})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=ae=>{p.onDidSelectItem(P[ae])}),r.$setItems(O,Y),K.then(ae=>{if(typeof ae=="number")return P[ae];if(Array.isArray(ae))return ae.map(ge=>P[ge])})})}).then(void 0,z=>{if(!(0,g.$4)(z))return r.$setError(O,z),Promise.reject(z)})}$onItemSelected(D){this.c?.(D)}showInput(D,F=E.CancellationToken.None){return this.d=D?.validateInput,r.$input(D,typeof this.d=="function",F).then(void 0,p=>{if(!(0,g.$4)(p))return Promise.reject(p)})}async $validateInput(D){if(!this.d)return;const F=await this.d(D);if(!F||typeof F=="string")return F;let p;switch(F.severity){case m.InputBoxValidationSeverity.Info:p=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=F.message?R.default.Error:R.default.Ignore;break}return{content:F.message,severity:p}}async showWorkspaceFolderPick(D,F=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!p)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(k=>k.uri.toString()===p.uri.toString())}createQuickPick(D){const F=new d(D,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}createInputBox(D){const F=new b(D,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}$onDidChangeValue(D,F){this.e.get(D)?._fireDidChangeValue(F)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,F){const p=this.e.get(D);p instanceof d&&p._fireDidChangeActive(F)}$onDidChangeSelection(D,F){const p=this.e.get(D);p instanceof d&&p._fireDidChangeSelection(F)}$onDidTriggerButton(D,F){this.e.get(D)?._fireDidTriggerButton(F)}$onDidTriggerItemButton(D,F,p){const y=this.e.get(D);y instanceof d&&y._fireDidTriggerItemButton(F,p)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class c{static{this.a=1}constructor(D,F){this.x=D,this.y=F,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((F,p)=>{const y=F===m.$0L.Back?-1:p;this.o.set(y,F)}),this.z({buttons:D.map((F,p)=>({...u(F.iconPath),tooltip:F.tooltip,handle:F===m.$0L.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const F=this.o.get(D);F&&this.r.fire(F)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(D){if(!this.v){for(const F of Object.keys(D)){const p=D[F];this.u[F]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof m.$JL)return{id:f.id};const D=s(f),F=i(f);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof F=="string"?A.URI.file(F):F}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const D=h(f);let F,p;return"id"in D?p=S.ThemeIcon.asClassName(D):F=D,{iconPath:F,iconClass:p}}class d extends c{constructor(D,F){super(D.identifier,F),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((y,k)=>{this.C.set(k,y),this.D.set(y,k)});const F=(0,l.$jF)(this.O,"quickPickItemTooltip"),p=[];for(let y=0;y<D.length;y++){const k=D[y];if(k.kind===m.QuickPickItemKind.Separator)p.push({type:"separator",label:k.label});else{k.tooltip&&!F&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const O=k.iconPath?u(k.iconPath):void 0;p.push({handle:y,label:k.label,iconPath:O?.iconPath,iconClass:O?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:F?$.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((K,U)=>({...u(K.iconPath),tooltip:K.tooltip,handle:U}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(F=>this.D.has(F)),this.z({activeItems:this.J.map(F=>this.D.get(F))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(F=>this.D.has(F)),this.z({selectedItems:this.L.map(F=>this.D.get(F))})}_fireDidChangeActive(D){const F=(0,w.$Hb)(D.map(p=>this.C.get(p)));this.J=F,this.K.fire(F)}_fireDidChangeSelection(D){const F=(0,w.$Hb)(D.map(p=>this.C.get(p)));this.L=F,this.M.fire(F)}_fireDidTriggerItemButton(D,F){const p=this.C.get(D);if(!p||!p.buttons||!p.buttons.length)return;const y=p.buttons[F];y&&this.N.fire({button:y,item:p})}}class b extends c{constructor(D,F){super(D.identifier,F),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new a(o,t)}e.$Ogc=v}),define(Pe[263],Ae([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13,21]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;function r(U){return U instanceof E.URI}function a(U,L){return U.scheme===n.Schemas.file&&L.scheme===n.Schemas.file&&o.$k?U.toString()===L.toString():U.toString().toLowerCase()===L.toString().toLowerCase()}function c(U){if(U)return typeof U.iconPath=="string"?E.URI.file(U.iconPath):E.URI.isUri(U.iconPath)||l.ThemeIcon.isThemeIcon(U.iconPath)?U.iconPath:void 0}function h(U){if(U?.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const L=U.icon;return{light:L.light,dark:L.dark}}}else return}function i(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const L=U.icon;return{light:L.light,dark:L.dark}}}else return}function s(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if(l.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const L=U.icon;return{light:L.light,dark:L.dark}}}else return}function u(U,L){if(!U.iconPath&&!L.iconPath)return 0;if(U.iconPath){if(!L.iconPath)return 1}else return-1;const z=typeof U.iconPath=="string"?U.iconPath:E.URI.isUri(U.iconPath)?U.iconPath.fsPath:U.iconPath.id,C=typeof L.iconPath=="string"?L.iconPath:E.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,w.$Eq)(z,C)}function d(U,L){let z=0;if(U.strikeThrough!==L.strikeThrough)return U.strikeThrough?1:-1;if(U.faded!==L.faded)return U.faded?1:-1;if(U.tooltip!==L.tooltip)return(U.tooltip||"").localeCompare(L.tooltip||"");if(z=u(U,L),z!==0)return z;if(U.light&&L.light)z=u(U.light,L.light);else{if(U.light)return 1;if(L.light)return-1}if(z!==0)return z;if(U.dark&&L.dark)z=u(U.dark,L.dark);else{if(U.dark)return 1;if(L.dark)return-1}return z}function b(U,L){if(U.command!==L.command)return U.command<L.command?-1:1;if(U.title!==L.title)return U.title<L.title?-1:1;if(U.tooltip!==L.tooltip){if(U.tooltip!==void 0&&L.tooltip!==void 0)return U.tooltip<L.tooltip?-1:1;if(U.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(U.arguments===L.arguments)return 0;if(U.arguments)if(L.arguments){if(U.arguments.length!==L.arguments.length)return U.arguments.length-L.arguments.length}else return 1;else return-1;for(let z=0;z<U.arguments.length;z++){const C=U.arguments[z],P=L.arguments[z];if(C!==P&&!(r(C)&&r(P)&&a(C,P)))return C<P?-1:1}return 0}function f(U,L){let z=(0,w.$Eq)(U.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(z!==0)return z;if(U.command&&L.command)z=b(U.command,L.command);else{if(U.command)return 1;if(L.command)return-1}if(z!==0)return z;if(U.decorations&&L.decorations)z=d(U.decorations,L.decorations);else{if(U.decorations)return 1;if(L.decorations)return-1}return z}function D(U,L){for(let z=0;z<U.length;z++)if(U[z]!==L[z])return!1;return!0}function F(U,L){return U.command===L.command&&U.title===L.title&&U.tooltip===L.tooltip&&(U.arguments&&L.arguments?D(U.arguments,L.arguments):U.arguments===L.arguments)}function p(U,L){return(0,g.$ub)(U,L,F)}class y{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.o,L),this.q(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.o,L),this.f=L}get validateInput(){return(0,v.$kF)(this.m,"scmValidation"),this.g}set validateInput(L){if((0,v.$kF)(this.m,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.o,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.o,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.o,L))}get actionButton(){return(0,v.$kF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(L){(0,v.$kF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Rc,this.k=L;const z=L!==void 0?{command:this.n.converter.toInternal(L.command,this.l.value),icon:h(L),enabled:L.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,z??null)}get document(){return(0,v.$kF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(L,z,C,P,Y,ae){this.m=L,this.n=z,this.o=Y,this.p=ae,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Tc,this.#t=C,this.#e=P}showValidationMessage(L,z){(0,v.$kF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,L,z)}$onInputBoxValueChange(L){this.q(L)}q(L){this.d=L,this.e.fire(L)}}e.$Pgc=y;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(L){this.v=L,this.q.$updateGroupLabel(this.t,this.handle,L)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(L){this.p=L,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,z,C,P,Y){this.q=L,this.s=z,this.t=C,this.u=P,this.v=Y,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,z){const C=this.h.get(L);return C?(0,A.$Ug)(()=>this.s.executeCommand(C.command,...C.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(f),C=(0,g.$Db)(this.o,L,f).map(ae=>{const ge=ae.toInsert.map(ve=>{const De=this.e++;this.g.set(De,ve);const de=ve.resourceUri;let he;if(ve.command)if(ve.command.command==="vscode.open"||ve.command.command==="vscode.diff"||ve.command.command==="vscode.changes"){const ce=new M.$Rc;he=this.s.converter.toInternal(ve.command,ce),this.j.set(De,ce)}else this.h.set(De,ve.command);const te=c(ve.decorations),Se=ve.decorations&&c(ve.decorations.light)||te,oe=ve.decorations&&c(ve.decorations.dark)||te,X=[Se,oe],V=ve.decorations&&ve.decorations.tooltip||"",ne=ve.decorations&&!!ve.decorations.strikeThrough,Ie=ve.decorations&&!!ve.decorations.faded,Me=ve.contextValue||"";return{rawResource:[De,de,X,V,ne,Ie,Me,he],handle:De}});return{start:ae.start,deleteCount:ae.deleteCount,toInsert:ge}}),P=C.map(({start:ae,deleteCount:ge,toInsert:ve})=>[ae,ge,ve.map(De=>De.rawResource)]),Y=C.reverse();for(const{start:ae,deleteCount:ge,toInsert:ve}of Y){const De=ve.map(he=>he.handle),de=this.n.splice(ae,ge,...De);for(const he of de)this.g.delete(he),this.h.delete(he),this.j.get(he)?.dispose(),this.j.delete(he)}return this.o=L,P}dispose(){this.l=!0,this.m.fire()}}class O{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let z;(0,v.$jF)(this.y,"quickDiffProvider")&&(z=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:z})}get historyProvider(){return(0,v.$kF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,v.$kF)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new M.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&(this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.l=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(L.onDidChangeActionButton(()=>{(0,v.$kF)(this.y,"scmActionButton"),this.m.value=new M.$Rc;const z=L.actionButton!==void 0?{command:this.z.converter.toInternal(L.actionButton.command,this.m.value),description:L.actionButton.description,enabled:L.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,z??null)})))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new M.$Rc,this.p=L;const z=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:z})}get actionButton(){return(0,v.$kF)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,v.$kF)(this.y,"scmActionButton"),this.q.value=new M.$Rc,this.s=L;const z=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(C=>C.map(P=>this.z.converter.toInternal(P,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:z??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&p(this.u,L))return;this.t.value=new M.$Rc,this.u=L;const z=(L||[]).map(C=>this.z.converter.toInternal(C,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:z})}get selected(){return this.v}constructor(L,z,C,P,Y,ae,ge){this.y=L,this.z=P,this.A=Y,this.B=ae,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Tc,this.m=new M.$Tc,this.n=void 0,this.o=new M.$Tc,this.p=void 0,this.q=new M.$Tc,this.t=new M.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Sd,this.onDidChangeSelection=this.w.event,this.x=O.d++,this.D=new Map,this.E=new Set,this.#e=C;const ve=E.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${Y}/scm${this.x}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new y(L,P,z,this.#e,this.x,ve),this.#e.$registerSourceControl(this.x,Y,ae,ge,ve)}createResourceGroup(L,z){const C=new k(this.#e,this.z,this.x,L,z),P=T.Event.once(C.onDidDispose)(()=>this.D.delete(C));return this.D.set(C,P),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const L=[],z=[];for(const[C,P]of this.D){P.dispose();const Y=C.onDidUpdateResourceStates(()=>{this.E.add(C),this.eventuallyUpdateResourceStates()});T.Event.once(C.onDidDispose)(()=>{this.E.delete(C),Y.dispose(),this.e.delete(C.handle),this.#e.$unregisterGroup(this.x,C.handle)}),L.push([C.handle,C.id,C.label,C.features]);const ae=C._takeResourceStateSnapshot();ae.length>0&&z.push([C.handle,ae]),this.e.set(C.handle,C)}this.#e.$registerGroups(this.x,L,z),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(z=>{const C=z._takeResourceStateSnapshot();C.length!==0&&L.push([z.handle,C])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ge([(0,I.$uh)(100)],O.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$uh)(100)],O.prototype,"eventuallyUpdateResourceStates",null);let K=class{static{t=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(L,z,C,P){this.n=z,this.o=C,this.p=P,this.h=new Map,this.j=new S.$im,this.k=new T.$Sd,this.l=new Map,this.f=L.getProxy(m.$MK.MainThreadSCM),this.g=L.getProxy(m.$MK.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:Y=>{if(Y&&Y.$mid===3){const ae=this.h.get(Y.sourceControlHandle);if(!ae)return Y;const ge=ae.getResourceGroup(Y.groupHandle);return ge?ge.getResourceState(Y.handle):Y}else if(Y&&Y.$mid===4){const ae=this.h.get(Y.sourceControlHandle);return ae?ae.getResourceGroup(Y.groupHandle):Y}else if(Y&&Y.$mid===5){const ae=this.h.get(Y.handle);return ae||Y}return Y}})}createSourceControl(L,z,C,P){this.p.trace("ExtHostSCM#createSourceControl",L.identifier.value,z,C,P),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const Y=t.d++,ae=new O(L,this.o,this.f,this.n,z,C,P);this.h.set(Y,ae);const ge=this.j.get(L.identifier)||[];return ge.push(ae),this.j.set(L.identifier,ge),ae}registerSourceControlInputBoxValueProvider(L,z,C){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",L.identifier.value,C.label);const P=t.e++;return this.l.set(P,C),this.f.$registerSourceControlInputBoxValueProvider(P,z,C.label,s(C)),(0,M.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(P),this.l.delete(P)})}async $provideInputBoxValue(L,z,C,P){const Y=this.l.get(L);if(Y)return await Y.provideValue(E.URI.revive(z),C,P)??void 0}getLastInputBox(L){this.p.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const z=this.j.get(L.identifier),C=z&&z[z.length-1];return C&&C.inputBox}$provideOriginalResource(L,z,C){const P=E.URI.revive(z);this.p.trace("ExtHostSCM#$provideOriginalResource",L,P.toString());const Y=this.h.get(L);return!Y||!Y.quickDiffProvider||!Y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Ug)(()=>Y.quickDiffProvider.provideOriginalResource(P,C)).then(ae=>ae||null)}$onInputBoxValueChange(L,z){this.p.trace("ExtHostSCM#$onInputBoxValueChange",L);const C=this.h.get(L);return C&&C.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(L,z,C,P){this.p.trace("ExtHostSCM#$executeResourceCommand",L,z,C);const Y=this.h.get(L);if(!Y)return Promise.resolve(void 0);const ae=Y.getResourceGroup(z);return ae?ae.$executeResourceCommand(C,P):Promise.resolve(void 0)}$validateInput(L,z,C){this.p.trace("ExtHostSCM#$validateInput",L);const P=this.h.get(L);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Ug)(()=>P.inputBox.validateInput(z,C)).then(Y=>{if(!Y)return Promise.resolve(void 0);const ae=$.MarkdownString.fromStrict(Y.message);return ae?Promise.resolve([ae,Y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.h.get(L)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(L,z,C){return await this.h.get(L)?.historyProvider?.resolveHistoryItemGroupBase(z,C)??void 0}async $resolveHistoryItemGroupCommonAncestor(L,z,C,P){return await this.h.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,C,P)??void 0}async $provideHistoryItems(L,z,C,P){return(await this.h.get(L)?.historyProvider?.provideHistoryItems(z,C,P))?.map(ge=>({...ge,icon:i(ge)}))??void 0}async $provideHistoryItemChanges(L,z,C){return await this.h.get(L)?.historyProvider?.provideHistoryItemChanges(z,C)??void 0}};e.$Qgc=K,e.$Qgc=K=t=Ge([Ke(3,R.$jj)],K)}),define(Pe[84],Ae([1,0,3,5,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class M{constructor(m){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(E.$MK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,w){return this.a.$setPassword(m,g,w)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Wfc=M,e.$Xfc=(0,I.$2h)("IExtHostSecretState")}),define(Pe[264],Ae([1,0,3,8,2]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class M{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(E.$MK.MainThreadShare)}async $provideShare(m,g,w){return await this.c.get(m)?.provideShare({selection:T.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider(m,g){const w=M.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Rgc=M}),define(Pe[265],Ae([1,0,20,6,3]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class M{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$MK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const w=this.c.get(m);if(!w)return;const R=new T.$Rc,S=new E.$3d;this.d.set(g,S);const l=R.add(w.provideSpeechToTextSession(S.token));R.add(l.onDidChange($=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,$)})),R.add(S.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,w){const R=M.a++;return this.c.set(R,w),this.b.$registerProvider(R,g,{extension:m,displayName:m.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Sgc=M}),define(Pe[266],Ae([1,0,7,3,164,6,8,16]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$KL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$KL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,v,n,o,t=E.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Rc,this.#e=l,this.#t=$,o&&n){this.c=(0,E.$nL)(n.identifier,o);const a=v.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,r=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=n,this.f=o,this.g=t,this.h=this.u(r)}u(l){if((0,m.$If)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,I.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=g.b.get(this.o.id));const n=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,n,this.r?.internal,v,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Tgc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new E.$OK(()=>{const v=this.b.indexOf($);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,$){this.e=new Map,this.a=l.getProxy(T.$MK.MainThreadStatusBar),this.b=$,this.c=new w(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,v,n){return new g(this.a,this.b,this.e,l,$,v,n)}setStatusBarMessage(l,$){const v=this.c.setMessage(l);let n;return typeof $=="number"?n=setTimeout(()=>v.dispose(),$):typeof $<"u"&&$.then(()=>v.dispose(),()=>v.dispose()),new E.$OK(()=>{v.dispose(),clearTimeout(n)})}}e.$Ugc=R}),define(Pe[85],Ae([1,0,3,5,4]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0;class M{constructor(m,g){this.c=g,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(E.$MK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,w){const R=await this.a.$initializeExtensionStorage(m,g);let S;return R&&(S=this.d(m,g,R)),S||w}setValue(m,g,w){return this.a.$setValue(m,g,w)}$acceptValue(m,g,w){const R=this.d(m,g,w);R&&this.b.fire({shared:m,key:g,value:R})}d(m,g,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${R}`)}}}e.$Ofc=M,e.$Pfc=(0,I.$2h)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=void 0,e.$xfc=(0,E.$2h)("IExtensionStoragePaths");let m=class{constructor(w,R,S){this.d=R,this.f=S,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$yfc=m,e.$yfc=m=Ge([Ke(0,T.$7M),Ke(1,I.$jj),Ke(2,M.$wfc)],m)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,20,33,195,45,14,8,32]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=e.$Tfc=e.$Sfc=void 0,e.$Sfc=(0,I.$2h)("IExtHostTerminalService");class a{constructor(p,y,k,O){this.l=p,this._id=y,this.m=k,this.n=O,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const K=this;this.value={get name(){return K.n||""},get processId(){return K.b},get creationOptions(){return K.m},get exitStatus(){return K.h},get state(){return K.j},get selection(){return K.k},sendText(U,L=!0){K.q(),K.l.$sendText(K._id,U,L)},show(U){K.q(),K.l.$show(K._id,U)},hide(){K.q(),K.l.$hide(K._id)},dispose(){K.a||(K.a=!0,K.l.$dispose(K._id))},get dimensions(){if(!(K.d===void 0||K.g===void 0))return{columns:K.d,rows:K.g}}}}async create(p,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??y?.cwd??void 0,env:p.env??void 0,icon:b(p.iconPath)??void 0,color:n.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(p.location,y?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,y,k,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:n.ThemeColor.isThemeColor(O)?O.id:void 0,location:this.o(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,y){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in p?{viewColumn:t.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,y){this.h=Object.freeze({code:p,reason:y})}setDimensions(p,y){return p===this.d&&y===this.g||p===0||y===0?!1:(this.d=p,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(y=>{y!==p&&(this.b=Promise.resolve(p))})}}e.$Tfc=a;class c{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,y){this.g.setDimensions?.({columns:p,rows:y})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,y,k){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$MK.MainThreadTerminalService),this.y=new v.$trb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:O=>{const K=U=>{const L=U;return this.W(L.instanceId)?.value};switch(O?.$mid){case 15:return K(O);default:{if(Array.isArray(O))for(let U=0;U<O.length&&O[U].$mid===15;U++)O[U]=K(O[U]);return O}}}}),this.B({dispose:()=>{for(const[O,K]of this.g)K.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,y){const k=new a(this.a,(0,$.$mg)(),p,p.name),O=new c(p.pty);return k.createExtensionTerminal(p.location,this.R(p,y).resolvedExtHostIdentifier,b(p.iconPath),f(p.color)).then(K=>{const U=this.S(K,O);this.h[K]=U}),this.f.push(k),k.value}R(p,y){if(y=y||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const k=p.location.parentTerminal;if(k){const O=this.f.find(K=>K.value===k);O&&(y.resolvedExtHostIdentifier=O._id)}}else p.location&&typeof p.location!="object"?y.location=p.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(p,y){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const O=new c(y),K=this.S(p,O);this.h[p]=K}async $acceptActiveTerminalChanged(p){const y=this.b;if(p===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const k=this.W(p);k&&(this.b=k,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,y){const k=this.W(p);k&&this.O.fire({terminal:k.value,data:y})}async $acceptTerminalDimensions(p,y,k){const O=this.W(p);O&&O.setDimensions(y,k)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(p,y){const k=this.W(p);k&&this.P.fire({terminal:k.value,...y})}async $acceptTerminalMaximumDimensions(p,y,k){this.g.get(p)?.resize(y,k)}async $acceptTerminalTitleChange(p,y){const k=this.W(p);k&&(k.name=y)}async $acceptTerminalClosed(p,y,k){const O=this.Y(this.f,p);if(O!==null){const K=this.f.splice(O,1)[0];K.setExitStatus(y,k),this.H.fire(K.value)}}$acceptTerminalOpened(p,y,k,O){if(y){const L=this.Y(this.f,y);if(L!==null){this.f[L]._id=p,this.I.fire(this.terminals[L]),this.f[L].isOpen=!0;return}}const K={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:M.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},U=new a(this.a,p,K,k);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(p,y){this.W(p)?._setProcessId(y)}async $startExtensionTerminal(p,y){const k=this.W(p);if(!k)return{message:(0,w.localize)(0,null,p)};k.isOpen||await new Promise(K=>{const U=this.onDidOpenTerminal(async L=>{L===k.value&&(U.dispose(),K())})});const O=this.g.get(p);O?O.startSendingEvents(y):this.j[p]={initialDimensions:y}}S(p,y){const k=new m.$Rc;k.add(y.onProcessReady(K=>this.a.$sendProcessReady(p,K.pid,K.cwd,K.windowsPty))),k.add(y.onDidChangeProperty(K=>this.a.$sendProcessProperty(p,K))),this.y.startBuffering(p,y.onProcessData),k.add(y.onProcessExit(K=>this.U(p,K))),this.g.set(p,y);const O=this.j[p];return O&&y instanceof c&&(y.startSendingEvents(O.initialDimensions),delete this.j[p]),k}$acceptProcessAckDataEvent(p,y){this.g.get(p)?.acknowledgeDataEvent(y)}$acceptProcessInput(p,y){this.g.get(p)?.input(y)}$acceptTerminalInteraction(p){const y=this.W(p);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(p,y){this.W(p)?.setSelection(y)}$acceptProcessResize(p,y,k){try{this.g.get(p)?.resize(y,k)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(p,y){this.g.get(p)?.shutdown(y)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(y=>this.a.$sendProcessProperty(p,{type:"cwd",value:y}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new g.$OK(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,y,k){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,k),this.a.$registerProfileProvider(y,p.identifier.value),new g.$OK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(p,y,k){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,k),this.a.$registerQuickFixProvider(p,y),new g.$OK(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,y){const k=new l.$3d().token;if(k.isCancellationRequested)return;const O=this.D.get(p);if(!O)return;const K=await O.provideTerminalQuickFixes(y,k);if(K===null||Array.isArray(K)&&K.length===0)return;const U=new m.$Rc;if(this.w.value=U,!Array.isArray(K))return K?t.TerminalQuickFix.from(K,this.Q.converter,U):void 0;const L=[];for(const z of K){const C=t.TerminalQuickFix.from(z,this.Q.converter,U);C&&L.push(C)}return L}async $createContributedProfileTerminal(p,y){const k=new l.$3d().token;let O=await this.C.get(p)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,y);return}this.createTerminalFromOptions(O.options,y)}}async $provideLinks(p,y){const k=this.W(p);if(!k)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const K=new l.$3d;this.G.set(p,K);const U=[],L={terminal:k.value,line:y},z=[];for(const Y of this.z)z.push(o.Promises.withAsyncBody(async ae=>{K.token.onCancellationRequested(()=>ae({provider:Y,links:[]}));const ge=await Y.provideTerminalLinks(L,K.token)||[];K.token.isCancellationRequested||ae({provider:Y,links:ge})}));const C=await Promise.all(z);if(K.token.isCancellationRequested)return[];const P=new Map;for(const Y of C)Y&&Y.links.length>0&&U.push(...Y.links.map(ae=>{const ge={id:h++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return P.set(ge.id,{provider:Y.provider,link:ae}),ge}));return this.F.set(p,P),U}$activateLink(p,y){const k=this.F.get(p)?.get(y);k&&k.provider.handleTerminalLink(k.link)}U(p,y){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const k=this.h[p];k&&(k.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,y)}W(p){return this.X(this.f,p)}X(p,y){const k=this.Y(p,y);return k!==null?p[k]:null}Y(p,y){const k=p.findIndex(O=>O._id===y);return k===-1?null:k}getEnvironmentVariableCollection(p){let y=this.n.get(p.identifier.value);return y||(y=new s,this.$(p.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(p,y){const k=(0,S.$xr)(y.map),O=(0,S.$yr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(p,y.persistent,k.length===0?void 0:k,O)}$initEnvironmentVariableCollections(p){p.forEach(y=>{const k=y[0],O=new s(y[1]);this.$(k,O)})}$acceptDefaultProfile(p,y){const k=this.s;this.s=p,this.u=y,k?.path!==p.path&&this.N.fire(p.path)}$(p,y){this.n.set(p,y),y.onDidChangeCollection(()=>{this.Z(p,y)})}};e.$Ufc=i,e.$Ufc=i=Ge([Ke(1,r.$aN),Ke(2,A.$QM)],i);class s{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const y=this.h(p);let k=this.a.get(y);return k||(k=new u(this,p),this.a.set(y,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(p,y,k,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:O})}append(p,y,k,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:O})}prepend(p,y,k,O){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:O})}f(p,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(p,y.scope),O=this.map.get(k),K=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==y.value||O.type!==y.type||O.options?.applyAtProcessCreation!==K.applyAtProcessCreation||O.options?.applyAtShellIntegration!==K.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const U=this.g(p,y.scope),L={variable:p,...y,options:K};this.map.set(U,L),this.d.fire()}}get(p,y){const k=this.g(p,y),O=this.map.get(k);return O?D(O):void 0}g(p,y){const k=this.h(y);return k.length?`${p}:::${k}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const y=new Map;for(const[k,O]of this.map)this.h(O.scope)===this.h(p)&&y.set(O.variable,D(O));return y}delete(p,y){const k=this.g(p,y);this.map.delete(k),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[y,k]of this.map)k.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(y);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,y){const k=this.h(y),O=this.descriptionMap.get(k);if(!O||O.description!==p){let K;typeof p=="string"?K=p:K=p?.value.split(`

`)[0];const U={description:K,scope:y};this.descriptionMap.set(k,U),this.d.fire()}}getDescription(p){const y=this.h(p);return this.descriptionMap.get(y)?.description}k(p){const y=this.h(p);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,y){this.b=p,this.d=y,this.a=new E.$Sd}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,y,k){this.b.replace(p,y,k,this.d)}append(p,y,k){this.b.append(p,y,k,this.d)}prepend(p,y,k){this.b.prepend(p,y,k,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,y){this.b.getVariableMap(this.d).forEach((k,O)=>p.call(y,O,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(p,y){super(!1,p,y)}createTerminal(p,y,k){throw new R.$_}createTerminalFromOptions(p,y){throw new R.$_}};e.$Vfc=d,e.$Vfc=d=Ge([Ke(0,r.$aN),Ke(1,A.$QM)],d);function b(F){if(!(!F||typeof F=="string"))return"id"in F?{id:F.id,color:F.color}:F}function f(F){return n.ThemeColor.isThemeColor(F)?F:void 0}function D(F){const p={...F};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Pe[267],Ae([1,0,14,24,20,5,219,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=e.$Zgc=e.$Ygc=void 0;let h=class extends g.$Sc{constructor(U,L,z){super(),this.u=z,this.f=this.B(new M.$Sd),this.g=new Map,this.s=this.B(new M.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(l.$MK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),L.registerArgumentProcessor({processArgument:C=>{switch(C?.$mid){case 16:{const P=C,Y=P.tests[P.tests.length-1].item.extId;return this.g.get(t.$EJ.root(Y))?.collection.tree.get(Y)?.actual??(0,v.$3M)(C)}case 18:{const{extId:P,message:Y}=C;return{test:this.g.get(t.$EJ.root(P))?.collection.tree.get(P)?.actual,message:n.TestMessage.to(Y)}}default:return C}}}),L.registerCommand(!1,"testing.getExplorerSelection",async()=>{const C=await L.executeCommand("_testing.getExplorerSelection"),P=Y=>{const ae=this.g.get(t.$EJ.root(Y));if(ae)return t.$EJ.isRoot(Y)?ae.controller:ae.collection.tree.get(Y)?.actual};return{include:C?.include.map(P).filter(R.$Mf)||[],exclude:C?.exclude.map(P).filter(R.$Mf)||[]}})}createTestController(U,L,z,C){if(this.g.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const P=new g.$Rc,Y=P.add(new v.$6M(L,z,this.u));Y.root.label=z;const ae=new Map,ge=new Set,ve=this.h,De={items:Y.root.children,get label(){return z},set label(he){z=he,Y.root.label=he,ve.$updateController(L,{label:z})},get refreshHandler(){return C},set refreshHandler(he){C=he,ve.$updateController(L,{canRefresh:!!he})},get id(){return L},createRunProfile:(he,te,Se,oe,X,V)=>{let ne=(0,m.$Pi)(he);for(;ae.has(ne);)ne++;return new k(this.h,ae,U,ge,this.s.event,L,ne,he,te,Se,oe,X,V)},createTestItem(he,te,Se){return new v.$4M(L,he,te,Se)},createTestRun:(he,te,Se=!0)=>this.j.createTestRun(U,L,Y,he,te,Se),invalidateTestResults:he=>{if(he===void 0)this.h.$markTestRetired(void 0);else{const te=he instanceof Array?he:[he];this.h.$markTestRetired(te.map(Se=>t.$EJ.fromExtHostTestItem(Se,L).toString()))}},set resolveHandler(he){Y.resolveHandler=he},get resolveHandler(){return Y.resolveHandler},dispose:()=>{P.dispose()}};ve.$registerTestController(L,z,!!C),P.add((0,g.$Qc)(()=>ve.$unregisterTestController(L)));const de={controller:De,collection:Y,profiles:ae,extension:U,activeProfiles:ge};return this.g.set(L,de),P.add((0,g.$Qc)(()=>this.g.delete(L))),P.add(Y.onDidGenerateDiff(he=>ve.$publishDiff(L,he.map(a.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(U,L=I.CancellationToken.None){const z=b(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(z.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(P=>t.$EJ.fromExtHostTestItem(P,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:O[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(P=>P.id)},L)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,L,z){return await this.j.getCoverageReport(U,L)?.provideFileCoverage(z)??[]}async $resolveFileCoverage(U,L,z,C){return await this.j.getCoverageReport(U,L)?.resolveFileCoverage(z,C)??[]}$configureRunProfile(U,L){this.g.get(U)?.profiles.get(L)?.configureHandler?.()}$setActiveRunProfiles(U){const L=new Map;for(const[z,C]of Object.entries(U)){const P=this.g.get(z);if(!P)continue;const Y=new Map,ae=C.filter(ve=>!P.activeProfiles.has(ve)),ge=[...P.activeProfiles].filter(ve=>!C.includes(ve));for(const ve of ae)Y.set(ve,!0),P.activeProfiles.add(ve);for(const ve of ge)Y.set(ve,!1),P.activeProfiles.delete(ve);Y.size&&L.set(z,Y)}this.s.fire(L)}async $refreshTests(U,L){await this.g.get(U)?.controller.refreshHandler?.(L)}$publishTestResults(U){this.results=Object.freeze(U.map(L=>(0,w.$in)(n.TestResults.to(L))).concat(this.results).sort((L,z)=>z.completedAt-L.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,L){const z=this.g.get(t.$EJ.fromString(U).controllerId)?.collection;z&&(await z.expand(U,L<0?1/0:L),z.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(a.TestsDiffOp.deserialize))}async $runControllerTests(U,L){return Promise.all(U.map(z=>this.w(z,!1,L)))}async $startContinuousRun(U,L){const z=new I.$3d(L),C=await Promise.all(U.map(P=>this.w(P,!0,z.token)));return!L.isCancellationRequested&&!C.some(P=>P.error)&&await new Promise(P=>L.onCancellationRequested(P)),z.dispose(!0),C}async w(U,L,z){const C=this.g.get(U.controllerId);if(!C)return{};const{collection:P,profiles:Y,extension:ae}=C,ge=Y.get(U.profileId);if(!ge)return{};const ve=U.testIds.map(te=>P.tree.get(te)).filter(R.$Mf),De=U.excludeExtIds.map(te=>C.collection.tree.get(te)).filter(R.$Mf).filter(te=>ve.some(Se=>Se.fullId.compare(te.fullId)===2));if(!ve.length)return{};const de=new o.$lM(ve.some(te=>te.actual instanceof v.$5M)?void 0:ve.map(te=>te.actual),De.map(te=>te.actual),ge,L),he=(0,a.$GJ)(U)&&this.j.prepareForMainThreadTestRun(de,f.fromInternal(U,C.collection),ae,z);try{return await ge.runHandler(de,z),{}}catch(te){return{error:String(te)}}finally{he&&(he.hasRunningTasks&&!z.isCancellationRequested&&await M.Event.toPromise(he.onEnd),he.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Ygc=h,e.$Ygc=h=Ge([Ke(0,$.$QM)],h);const i=1e4;var s;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(s||(s={}));class u extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,L,z,C){super(),this.s=U,this.u=L,this.w=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Sd),this.m=this.B(new M.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(C));const P=this.B(new E.$bh(()=>this.y(),i));this.B(this.h.token.onCancellationRequested(()=>P.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(U){const L=this.s.id,z=this.s.controllerId,C=(0,S.$mg)(),P=this.w,Y=this.m;let ae;const ge=he=>(te,...Se)=>{if(De){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.C(te),he(te,...Se))},ve=(he,te)=>{const Se=te instanceof Array?te.map(n.TestMessage.from):[n.TestMessage.from(te)];if(he.uri&&he.range){const oe={range:n.Range.from(he.range),uri:he.uri};for(const X of Se)X.location=X.location||oe}this.u.$appendTestMessagesInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),Se)};let De=!1;const de={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ae?.provider},set coverageProvider(he){(0,c.$kF)(P,"testCoverage"),ae=he&&new D(he),Y.fire({taskId:C,runId:L,coverage:ae})},enqueued:ge(he=>{this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),1)}),skipped:ge(he=>{this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),5)}),started:ge(he=>{this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),2)}),errored:ge((he,te,Se)=>{ve(he,te),this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),6,Se)}),failed:ge((he,te,Se)=>{ve(he,te),this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,z).toString(),4,Se)}),passed:ge((he,te)=>{this.u.$updateTestStateInRun(L,C,t.$EJ.fromExtHostTestItem(he,this.s.controllerId).toString(),3,te)}),appendOutput:(he,te,Se)=>{De||(Se&&(this.s.isIncluded(Se)?this.C(Se):Se=void 0),this.u.$appendOutputToRun(L,C,T.$ge.fromString(he),te&&n.location.from(te),Se&&t.$EJ.fromExtHostTestItem(Se,z).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(L,C),this.f.delete(C),this.f.size||this.z())}};return this.f.set(C,{run:de}),this.u.$startedTestRunTask(L,{id:C,name:U,running:!0}),de}y(){for(const{run:U}of this.f.values())U.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(U){if(!(U instanceof v.$4M))throw new r.$IM(U.id);if(this.g.has(t.$EJ.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const L=[],z=this.s.colllection.root;for(;;){const C=n.TestItem.from(U);if(L.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),U===z))break;U=U.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,L)}dispose(){this.z(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(U){this.f=U,this.c=new Map,this.d=[]}getCoverageReport(U,L){return this.d.find(z=>z.runId===U)?.coverage.get(L)}prepareForMainThreadTestRun(U,L,z,C){return this.g(U,L,z,C)}cancelRunById(U){for(const L of this.c.values())if(L.id===U){L.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,L,z,C,P,Y){const ae=this.c.get(C);if(ae)return ae.createRun(P);const ge=f.fromPublic(L,z,C,Y),ve=b(C);this.f.$startedExtensionTestRun({controllerId:L,continuous:!!C.continuous,profile:ve&&{group:O[ve.kind],id:ve.profileId},exclude:C.exclude?.map(de=>t.$EJ.fromExtHostTestItem(de,z.root.id).toString())??[],id:ge.id,include:C.include?.map(de=>t.$EJ.fromExtHostTestItem(de,z.root.id).toString())??[z.root.id],persist:Y});const De=this.g(C,ge,U);return M.Event.once(De.onEnd)(()=>{this.f.$finishedExtensionTestRun(ge.id),De.dispose()}),De.createRun(P)}g(U,L,z,C){const P=new u(L,this.f,z,C);this.c.set(U,P);let Y;const ae=P.onDidCoverage(({runId:ge,taskId:ve,coverage:De})=>{Y||(Y={runId:ge,coverage:new Map},this.d.unshift(Y),this.d.length>a.$LJ&&this.d.pop()),Y.coverage.set(ve,De),this.f.$signalCoverageAvailable(ge,ve,!!De)});return M.Event.once(P.onEnd)(()=>{this.c.delete(U),ae.dispose()}),P}}e.$Zgc=d;const b=K=>{if(K.profile){if(!(K.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class f{static fromPublic(U,L,z,C){return new f(U,(0,S.$mg)(),z.include?.map(P=>t.$EJ.fromExtHostTestItem(P,U).toString())??[U],z.exclude?.map(P=>t.$EJ.fromExtHostTestItem(P,U).toString())??[],C,L)}static fromInternal(U,L){return new f(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,L)}constructor(U,L,z,C,P,Y){this.controllerId=U,this.id=L,this.isPersisted=P,this.colllection=Y,this.c=z.map(ae=>ae+"\0"),this.d=C.map(ae=>ae+"\0")}isIncluded(U){const L=t.$EJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.d)if(L===z||L.startsWith(z))return!1;for(const z of this.c)if(L===z||L.startsWith(z))return!0;return!1}}e.$1gc=f;class D{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(n.TestCoverage.fromFile)??[]}catch(L){throw this.c=void 0,L}}async resolveFileCoverage(U,L){const z=await this.c;let C=z?.[U];return!this.provider||!z||!C?[]:(C.detailedCoverage||(C=z[U]=await this.provider.resolveFileCoverage?.(C,L)??C),C.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const L=t.$EJ.parentId(U.item.extId);if(L&&this.g.has(L.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:L,f:z}=this;return{get added(){return[...U].map(C=>C.revived)},get updated(){return[...L].map(C=>C.revived)},get removed(){return[...z].map(C=>C.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends a.$MJ{constructor(){super(...arguments),this.q=new M.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,L){return{...U,revived:n.TestItem.toPlain(U.item),depth:L?L.depth+1:0,children:new Set}}o(){return new F(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(L=>L.revived)},dispose:(0,A.$db)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class k{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,c.$kF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$kF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,U=>U.map(L=>L.get(this.controllerId)?.get(this.profileId)).filter(R.$Mf))}constructor(U,L,z,C,P,Y,ae,ge,ve,De,de=!1,he=void 0,te=!1){this.controllerId=Y,this.profileId=ae,this.d=ge,this.kind=ve,this.runHandler=De,this.f=de,this._tag=he,this.g=te,this.#e=U,this.#r=L,this.#t=z,this.#i=C,this.#o=P,L.set(ae,this);const Se=O[ve];if(typeof Se!="number")throw new Error(`Unknown TestRunProfile.group ${ve}`);this.#e.$publishTestRunProfile({profileId:ae,controllerId:Y,tag:he?n.TestTag.namespace(this.controllerId,he.id):null,label:ge,group:Se,isDefault:de,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$2gc=k;const O={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[268],Ae([1,0,18,11,5,3,109,8,7]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class w{constructor(S,l){this.i=l,this.a=new I.$Sd({onListenerError:T.$2}),this.b=new I.$Sd({onListenerError:T.$2}),this.c=new I.$Sd({onListenerError:T.$2}),this.d=new I.$Sd({onListenerError:T.$2}),this.f=new I.$Sd({onListenerError:T.$2}),this.g=new I.$Sd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$MK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const l=this.i.allEditors();return S?l:l.map($=>$.value)}async showTextDocument(S,l,$){let v;typeof l=="number"?v={position:m.ViewColumn.from(l),preserveFocus:$}:typeof l=="object"?v={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const n=await this.h.$tryShowTextDocument(S.uri,v),o=n&&this.i.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,l){return new A.$XM(this.h,S,l).value}$acceptEditorPropertiesChanged(S,l){const $=this.i.getEditor(S);if(!$)throw new Error("unknown text editor");if(l.options&&$._acceptOptions(l.options),l.selections){const v=l.selections.selections.map(m.Selection.to);$._acceptSelections(v)}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));$._acceptVisibleRanges(v)}if(l.options&&this.b.fire({textEditor:$.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),n=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:$.value,selections:n,kind:v})}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:$.value,visibleRanges:v})}}$acceptEditorPositionData(S){for(const l in S){const $=this.i.getEditor(l);if(!$)throw new Error("Unknown text editor");const v=m.ViewColumn.to(S[l]);$.value.viewColumn!==v&&($._acceptViewColumn(v),this.d.fire({textEditor:$.value,viewColumn:v}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$lfc=w}),define(Pe[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=void 0,e.$4gc=(0,T.$2h)("IExtHostTimeline");class R{constructor($,v){this.b=new Map,this.c=new Map,this.a=$.getProxy(I.$MK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&g.$gm.equals(o,this.b.get(n.source)?.extension)){const t=n.uri===void 0?void 0:E.URI.revive(n.uri);return this.c.get(n.source)?.get(S(t))?.get(n.handle)}else return;return n}})}async $getTimeline($,v,n,o){return this.b.get($)?.provider.provideTimeline(E.URI.revive(v),n,o)}registerTimelineProvider($,v,n,o){const t=new M.$Rc,r=this.d(v.id,o,t).bind(this);let a;v.onDidChange&&(a=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const c=this.c;return this.f({...v,scheme:$,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(v.id)?.clear());const u=await v.provideTimeline(h,i,s);if(u==null)return;const d=r(h,i);return{...u,source:v.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(v.id)?.clear();a?.dispose(),t.dispose()}},n)}d($,v,n){return(o,t)=>{let r;if(t?.cacheResults){let a=this.c.get($);a===void 0&&(a=new Map,this.c.set($,a));const c=S(o);r=a.get(c),r===void 0&&(r=new Map,a.set(c,r))}return a=>{const{iconPath:c,...h}=a,i=`${$}|${a.id??a.timestamp}`;r?.set(i,a);let s,u,d;a.iconPath&&(c instanceof A.$JL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let b;return A.$dL.isMarkdownString(h.tooltip)?b=m.MarkdownString.from(h.tooltip):(0,w.$Ef)(h.tooltip)?b=h.tooltip:A.$dL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=m.MarkdownString.from(h.detail)):(0,w.$Ef)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:i,source:$,command:a.command?v.toInternal(a.command,n):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:b,accessibilityInformation:a.accessibilityInformation}}}}f($,v){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:v}),(0,M.$Qc)(()=>{for(const o of this.c.values())o.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$5gc=R;function S(l){return l?.toString()}}),define(Pe[87],Ae([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0xb=e.$9xb=e.TunnelDtoConverter=void 0;class $ extends g.$uv{}var v;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function r(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$9xb=(0,A.$2h)("IExtHostTunnelService");let n=class extends I.$Sc{constructor(t,r,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$MK.MainThreadTunnelService)}async openTunnel(t,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const a=await this.a.$openTunnel(r,t.displayName);if(a){const c=new $(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,r){const a=this.u();return this.r.set(a,{selector:t,provider:r}),this.a.$registerPortsAttributesProvider(t,a),new l.$OK(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,r,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(r.map(async b=>{let f;try{f=await d.provider.providePortAttributes({port:b,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(b,a,c,h)}return{providedAttributes:f,port:b}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const a=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,r){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(r?this.w(r):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,r){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(r&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const r=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$0xb=n,e.$0xb=n=Ge([Ke(0,S.$QM),Ke(1,R.$7M),Ke(2,m.$jj)],n)}),define(Pe[270],Ae([1,0,6,13,2,3]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(M.$MK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,R,S){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=S.schemes.find($=>!A.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,S.schemes,g,S.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(w);return S.canOpenExternalUri(l,R)}async $openUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener id: '${g}'`);return S.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},R)}}e.$7gc=A}),define(Pe[271],Ae([1,0,3,2,6,11,22]),function(me,e,E,T,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class m{static{this.a=0}constructor(w){this.c=new A.$hm,this.d=new Map,this.b=w.getProxy(E.$MK.MainThreadUrls)}registerUriHandler(w,R){const S=w.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=m.a++;return this.c.add(S),this.d.set(l,R),this.b.$registerUriHandler(l,S,w.displayName||w.name),(0,I.$Qc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,R){const S=this.d.get(w);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(R))}catch(l){(0,M.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$8gc=m}),define(Pe[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=e.$Bfc=e.$Afc=e.$zfc=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=$(d),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$fvb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$evb}return w.$evb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$ln(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$Wkb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,b,f,D)=>{const F=A.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$fvb)(F,{isRemote:h,authority:i}).toString();return`${u}${p}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,b,f,D)=>{const F=A.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$fvb)(F,{isRemote:h,authority:i}).toString();return`${u}${p}${D}`})}}e.$zfc=S;function l(a){try{const c=(0,m.$1o)((0,m.$Zo)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Afc=l;function $(a){try{const c=(0,m.$1o)((0,m.$Zo)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class v extends T.$Sc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(R.$MK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$Xkb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new S(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Bfc=v;function n(a){return{id:a.identifier,location:a.extensionLocation}}e.$Cfc=n;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(a,c)}}e.$Dfc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>A.URI.from(c))}}function r(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Pe[272],Ae([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class ${constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new R.$5ec("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,A.$Dg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class v{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const b=this.b(s,u.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new $(u,d);return this.a.set(b,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var n;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,b){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:b}),new l.$OK(()=>this.a.delete(u))}}class t{constructor(s,u,d,b,f){this.d=u,this.f=d,this.g=b,this.h=f,this.b=new o,this.c=new v,this.a=s.getProxy(S.$MK.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,b){const f=new I.$Rc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$Cfc)(s),u,b.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$Afc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),r(d)&&f.add(d.onDidChangeCustomDocument(D=>{const F=this.i(u,D.document.uri);if(c(D)){const p=F.addEdit(D);this.a.$onDidEdit(D.document.uri,u,p,D.label)}else this.a.$onContentChange(D.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$Cfc)(s),u,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,w.$Afc)(s))),l.$OK.from(f,new l.$OK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,b,f){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${u}'`);const F=m.URI.revive(s),p=await D.provider.openCustomDocument(F,{backupId:d,untitledDocumentData:b?.buffer},f);let y;return r(D.provider)&&this.f&&(y=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(u,p,y),{editable:r(D.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const b=m.URI.revive(s),{document:f}=this.i(u,b);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,b,f,D){const F=this.b.get(d);if(!F)throw new Error(`No provider found for '${d}'`);const p=g.ViewColumn.to(f),y=this.g.createNewWebview(u,b.contentOptions,F.extension),k=this.h.createNewWebviewPanel(u,d,b.title,p,b.options,y,b.active),O=m.URI.revive(s);switch(F.type){case 1:{const{document:K}=this.i(d,O);return F.provider.resolveCustomEditor(K,k,D)}case 0:{const K=this.d.getDocument(O);return F.provider.resolveCustomTextEditor(K,k,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const b=this.b.get(d);if(!b)throw new Error(`No provider found for '${d}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const D=m.URI.revive(u),F=this.d.getDocument(D);await b.provider.moveCustomTextEditor(F,f,E.CancellationToken.None)}async $undo(s,u,d,b){return this.i(u,s).undo(d,b)}async $redo(s,u,d,b){return this.i(u,s).redo(d,b)}async $revert(s,u,d){const b=this.i(u,s);await this.j(u).revertCustomDocument(b.document,d),b.disposeBackup()}async $onSave(s,u,d){const b=this.i(u,s);await this.j(u).saveCustomDocument(b.document,d),b.disposeBackup()}async $onSaveAs(s,u,d,b){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,m.URI.revive(d),b)}async $backup(s,u,d){const b=this.i(u,s),D=await this.j(u).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},d);return b.updateBackup(D),D.id}i(s,u){const d=this.c.get(s,m.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$Ffc=t;function r(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Pi)(s)+""}}),define(Pe[273],Ae([1,0,5,6,2,33,8,65,3,7]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class R extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,n,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=n,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,I.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:A.ViewColumn.from(v),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Sc{static c(){return(0,M.$mg)()}constructor(v,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=v.getProxy(g.$MK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,n,o,t,r={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:A.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,m.$Afc)(v),i=S.c();this.f.$createWebviewPanel((0,m.$Cfc)(v),i,n,{title:o,panelOptions:l(r),webviewOptions:(0,m.$Dfc)(v,this.m,r),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,r,v);return this.createNewWebviewPanel(i,n,o,a,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const n=Object.keys(v);n.sort((o,t)=>{const r=v[o],a=v[t];return r.active?1:a.active?-1:+r.visible-+a.visible});for(const o of n){const t=this.getWebviewPanel(o);if(!t)continue;const r=v[o];t._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:v}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,m.$Afc)(v)}),new w.$OK(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(v,n,o,t){const r=this.h.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:a,extension:c}=r,h=this.j.createNewWebview(v,o.webviewOptions,c),i=this.createNewWebviewPanel(v,n,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(v,n,o,t,r,a,c){const h=new R(v,this.f,a,{viewType:n,title:o,viewColumn:t,panelOptions:r,active:c});return this.g.set(v,h),h}getWebviewPanel(v){return this.g.get(v)}}e.$Efc=S;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Pe[274],Ae([1,0,5,6,65,8,3,7]),function(me,e,E,T,I,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class g extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,$,v,n,o){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=v,this.#e=S,this.#t=l,this.#o=n,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$MK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,$,v){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:S}),this.a.$registerWebviewViewProvider((0,I.$Cfc)(S),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Afc)(S)}),new m.$OK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,$,v,n){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:r}=o,a=this.d.createNewWebview(S,{},r),c=new g(S,this.a,l,$,a,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:v},n)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$9gc=w}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(me,e,E,T,I,M,A,m,g,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0;let S=class{static{R=this}static{this.a={focused:!0,active:!0}}getState($){const v=this.d;return{get focused(){return v.focused},get active(){return(0,w.$kF)($,"windowActivity"),v.active}}}constructor($){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=$.getProxy(T.$MK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:n})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,v){v!==this.d[$]&&(this.d={...this.d,[$]:v},this.c.fire(this.d))}openUri($,v){let n;if(typeof $=="string"){n=$;try{$=I.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,A.$Ge)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,n,v)}async asExternalUri($,v){if((0,A.$Ge)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri($,v);return I.URI.from(n)}};e.$0gc=S,e.$0gc=S=R=Ge([Ke(0,g.$QM)],S),e.$$gc=(0,m.$2h)("IExtHostWindow")}),define(Pe[275],Ae([1,0,241,27,17]),function(me,e,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;let M=class extends E.$bhc{constructor(m,g){super(m,g)}f(m,g,w){g.apply(console,w)}};e.$jjc=M,e.$jjc=M=Ge([Ke(0,I.$QM),Ke(1,T.$7M)],M)}),define(Pe[276],Ae([1,0,14,24,20,11,5,6,139,230,49]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=e.ResponsiveState=e.RequestInitiator=e.$l7b=e.$k7b=void 0;function l(k,O){try{return JSON.stringify(k,O)}catch{return"null"}}const $="$$ref$$",v={[$]:-1};class n{constructor(O,K){this.jsonString=O,this.referencedBuffers=K}}function o(k,O=null,K=!1){const U=[];return{jsonString:(K?l:JSON.stringify)(k,(z,C)=>{if(typeof C>"u")return v;if(typeof C=="object"){if(C instanceof T.$ge){const P=U.push(C)-1;return{[$]:P}}if(O)return O(z,C)}return C}),referencedBuffers:U}}e.$k7b=o;function t(k,O,K){return JSON.parse(k,(U,L)=>{if(L){const z=L[$];if(typeof z=="number")return O[z];if(K&&L.$mid===1)return K.transformIncoming(L)}return L})}e.$l7b=t;function r(k,O){return JSON.stringify(k,O)}function a(k){return k?(O,K)=>K&&K.$mid===1?k.transformOutgoing(K):K:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends m.$Sc{static{S=s}static{this.a=3*1e3}constructor(O,K=null,U=null){super(),this[S]=!0,this.b=this.B(new A.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=K,this.g=U,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let L=0,z=R.$Bv.count;L<z;L++)this.m[L]=null,this.s[L]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$bh(()=>this.H(),1e3)),this.c.onMessage(L=>this.L(L))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const K=this.w[O];delete this.w[O],K.resolveErr(M.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,g.$2m)(O,this.g):O}getProxy(O){const{nid:K,sid:U}=O;return this.s[K]||(this.s[K]=this.J(K,U)),this.s[K]}J(O,K){const U={get:(L,z)=>(typeof z=="string"&&!L[z]&&z.charCodeAt(0)===36&&(L[z]=(...C)=>this.U(O,z,C)),z===u?K:L[z])};return new Proxy(Object.create(null),U)}set(O,K){return this.m[O.nid]=K,K}assertRegistered(O){for(let K=0,U=O.length;K<U;K++){const L=O[K];if(!this.m[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}L(O){if(this.j)return;const K=O.byteLength,U=f.read(O,0),L=U.readUInt8(),z=U.readUInt32();switch(L){case 1:case 2:{let{rpcId:C,method:P,args:Y}=F.deserializeRequestJSONArgs(U);this.g&&(Y=(0,g.$2m)(Y,this.g)),this.M(K,z,C,P,Y,L===2);break}case 3:case 4:{let{rpcId:C,method:P,args:Y}=F.deserializeRequestMixedArgs(U);this.g&&(Y=(0,g.$2m)(Y,this.g)),this.M(K,z,C,P,Y,L===4);break}case 5:{this.f?.logIncoming(K,z,0,"ack"),this.G(z);break}case 6:{this.N(K,z);break}case 7:{this.O(K,z,void 0);break}case 9:{let C=F.deserializeReplyOKJSON(U);this.g&&(C=(0,g.$2m)(C,this.g)),this.O(K,z,C);break}case 10:{const C=F.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(K,z,C);break}case 8:{const C=F.deserializeReplyOKVSBuffer(U);this.O(K,z,C);break}case 11:{let C=F.deserializeReplyErrError(U);this.g&&(C=(0,g.$2m)(C,this.g)),this.P(K,z,C);break}case 12:{this.P(K,z,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,K,U,L,z,C){this.f?.logIncoming(O,K,1,`receiveRequest ${(0,R.$Dv)(U)}.${L}(`,z);const P=String(K);let Y,ae;if(C){const ve=new I.$3d;z.push(ve.token),Y=this.Q(U,L,z),ae=()=>ve.cancel()}else Y=this.Q(U,L,z),ae=i;this.u[P]=ae;const ge=F.serializeAcknowledged(K);this.f?.logOutgoing(ge.byteLength,K,1,"ack"),this.c.send(ge),Y.then(ve=>{delete this.u[P];const De=F.serializeReplyOK(K,ve,this.h);this.f?.logOutgoing(De.byteLength,K,1,"reply:",ve),this.c.send(De)},ve=>{delete this.u[P];const De=F.serializeReplyErr(K,ve);this.f?.logOutgoing(De.byteLength,K,1,"replyErr:",ve),this.c.send(De)})}N(O,K){this.f?.logIncoming(O,K,1,"receiveCancel");const U=String(K);this.u[U]?.()}O(O,K,U){this.f?.logIncoming(O,K,0,"receiveReply:",U);const L=String(K);if(!this.w.hasOwnProperty(L))return;const z=this.w[L];delete this.w[L],z.resolveOk(U)}P(O,K,U){this.f?.logIncoming(O,K,0,"receiveReplyErr:",U);const L=String(K);if(!this.w.hasOwnProperty(L))return;const z=this.w[L];delete this.w[L];let C;U&&(U.$isError?(C=new Error,C.name=U.name,C.message=U.message,C.stack=U.stack):C=U),z.resolveErr(C)}Q(O,K,U){try{return Promise.resolve(this.S(O,K,U))}catch(L){return Promise.reject(L)}}S(O,K,U){const L=this.m[O];if(!L)throw new Error("Unknown actor "+(0,R.$Dv)(O));const z=L[K];if(typeof z!="function")throw new Error("Unknown method "+K+" on actor "+(0,R.$Dv)(O));return z.apply(L,U)}U(O,K,U){if(this.j)return new w.$j7b;let L=null;if(U.length>0&&I.CancellationToken.isCancellationToken(U[U.length-1])&&(L=U.pop()),L&&L.isCancellationRequested)return Promise.reject(M.$6());const z=F.serializeRequestArguments(U,this.h),C=++this.t,P=String(C),Y=new w.$i7b,ae=new m.$Rc;L&&ae.add(L.onCancellationRequested(()=>{const ve=F.serializeCancel(C);this.f?.logOutgoing(ve.byteLength,C,0,"cancel"),this.c.send(F.serializeCancel(C))})),this.w[P]=new b(Y,ae),this.F(C);const ge=F.serializeRequest(C,O,K,z,!!L);return this.f?.logOutgoing(ge.byteLength,C,0,`request: ${(0,R.$Dv)(O)}.${K}(`,U),this.c.send(ge),Y}}e.$m7b=d;class b{constructor(O,K){this.a=O,this.b=K}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class f{static alloc(O,K,U){const L=new f(T.$ge.alloc(U+1+4),0);return L.writeUInt8(O),L.writeUInt32(K),L}static read(O,K){return new f(O,K)}get buffer(){return this.a}constructor(O,K){this.a=O,this.b=K}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+O).toString();return this.b+=O,U}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+O).toString();return this.b+=O,U}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+O);return this.b+=O,K}static sizeMixedArray(O){let K=0;K+=1;for(let U=0,L=O.length;U<L;U++){const z=O[U];switch(K+=1,z.type){case 1:K+=this.sizeLongString(z.value);break;case 2:K+=this.sizeVSBuffer(z.value);break;case 3:K+=this.sizeUInt32,K+=this.sizeLongString(z.value);for(let C=0;C<z.buffers.length;++C)K+=this.sizeVSBuffer(z.buffers[C]);break;case 4:break}}return K}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let K=0,U=O.length;K<U;K++){const L=O[K];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let z=0;z<L.buffers.length;++z)this.writeBuffer(L.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const K=new Array(O);for(let U=0;U<O;U++)switch(this.readUInt8()){case 1:K[U]=this.readLongString();break;case 2:K[U]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),C=this.readLongString(),P=[];for(let Y=0;Y<z;++Y)P.push(this.readVSBuffer());K[U]=new R.$Ev(t(C,P,null));break}case 4:K[U]=void 0;break}return K}}var D;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(D||(D={}));class F{static a(O){for(let K=0,U=O.length;K<U;K++)if(O[K]instanceof T.$ge||O[K]instanceof R.$Ev||typeof O[K]>"u")return!0;return!1}static serializeRequestArguments(O,K){if(this.a(O)){const U=[];for(let L=0,z=O.length;L<z;L++){const C=O[L];if(C instanceof T.$ge)U[L]={type:2,value:C};else if(typeof C>"u")U[L]={type:4};else if(C instanceof R.$Ev){const{jsonString:P,referencedBuffers:Y}=o(C.value,K);U[L]={type:3,value:T.$ge.fromString(P),buffers:Y}}else U[L]={type:1,value:T.$ge.fromString(r(C,K))}}return{type:1,args:U}}return{type:0,args:r(O,K)}}static serializeRequest(O,K,U,L,z){switch(L.type){case 0:return this.b(O,K,U,L.args,z);case 1:return this.c(O,K,U,L.args,z)}}static b(O,K,U,L,z){const C=T.$ge.fromString(U),P=T.$ge.fromString(L);let Y=0;Y+=f.sizeUInt8(),Y+=f.sizeShortString(C),Y+=f.sizeLongString(P);const ae=f.alloc(z?2:1,O,Y);return ae.writeUInt8(K),ae.writeShortString(C),ae.writeLongString(P),ae.buffer}static deserializeRequestJSONArgs(O){const K=O.readUInt8(),U=O.readShortString(),L=O.readLongString();return{rpcId:K,method:U,args:JSON.parse(L)}}static c(O,K,U,L,z){const C=T.$ge.fromString(U);let P=0;P+=f.sizeUInt8(),P+=f.sizeShortString(C),P+=f.sizeMixedArray(L);const Y=f.alloc(z?4:3,O,P);return Y.writeUInt8(K),Y.writeShortString(C),Y.writeMixedArray(L),Y.buffer}static deserializeRequestMixedArgs(O){const K=O.readUInt8(),U=O.readShortString(),L=O.readMixedArray(),z=new Array(L.length);for(let C=0,P=L.length;C<P;C++){const Y=L[C];typeof Y=="string"?z[C]=JSON.parse(Y):z[C]=Y}return{rpcId:K,method:U,args:z}}static serializeAcknowledged(O){return f.alloc(5,O,0).buffer}static serializeCancel(O){return f.alloc(6,O,0).buffer}static serializeReplyOK(O,K,U){if(typeof K>"u")return this.d(O);if(K instanceof T.$ge)return this.e(O,K);if(K instanceof R.$Ev){const{jsonString:L,referencedBuffers:z}=o(K.value,U,!0);return this.g(O,L,z)}else return this.f(O,l(K,U))}static d(O){return f.alloc(7,O,0).buffer}static e(O,K){let U=0;U+=f.sizeVSBuffer(K);const L=f.alloc(8,O,U);return L.writeVSBuffer(K),L.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,K){const U=T.$ge.fromString(K);let L=0;L+=f.sizeLongString(U);const z=f.alloc(9,O,L);return z.writeLongString(U),z.buffer}static g(O,K,U){const L=T.$ge.fromString(K);let z=0;z+=f.sizeUInt32,z+=f.sizeLongString(L);for(const P of U)z+=f.sizeVSBuffer(P);const C=f.alloc(10,O,z);C.writeUInt32(U.length),C.writeLongString(L);for(const P of U)C.writeBuffer(P);return C.buffer}static deserializeReplyOKJSON(O){const K=O.readLongString();return JSON.parse(K)}static deserializeReplyOKJSONWithBuffers(O,K){const U=O.readUInt32(),L=O.readLongString(),z=[];for(let C=0;C<U;++C)z.push(O.readVSBuffer());return new R.$Ev(t(L,z,K))}static serializeReplyErr(O,K){const U=K?l(M.$3(K),null):void 0;if(typeof U!="string")return this.h(O);const L=T.$ge.fromString(U);let z=0;z+=f.sizeLongString(L);const C=f.alloc(11,O,z);return C.writeLongString(L),C.buffer}static deserializeReplyErrError(O){const K=O.readLongString();return JSON.parse(K)}static h(O){return f.alloc(12,O,0).buffer}}var p;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var y;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[277],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;const E=function(M){const A=m=>{globalThis.removeEventListener("message",A);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,R){g.postMessage(w,R)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(M,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${A}'))`,w=new Blob([g],{type:"application/javascript"}),R=URL.createObjectURL(w),S=new MessageChannel,l=R,$={type:"_newWorker",id:l,port:S.port2,url:R,options:m};M($,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(v){S.port1.onmessage=v}},onmessageerror:{get(){return S.port1.onmessageerror},set(v){S.port1.onmessageerror=v}}}),S.port1.addEventListener("messageerror",v=>{const n=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(n)}),S.port1.addEventListener("message",v=>{const n=new MessageEvent("message",{data:v.data});this.dispatchEvent(n)}),S.port1.start()}}e.$ljc=T}),define(Pe[278],Ae([1,0,5,30,35,4]),function(me,e,E,T,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.OutputChannelUpdateMode=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=void 0,e.$XJ="text/x-code-output",e.$YJ="output",e.$ZJ="Log",e.$1J="text/x-code-log-output",e.$2J="log",e.$3J="workbench.panel.output",e.$4J=new I.$gj("inOutput",!1),e.$5J=new I.$gj("activeLogOutput",!1),e.$6J=new I.$gj("outputView.scrollLock",!1),e.$7J=(0,M.$2h)("outputService");var A;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$8J={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$tn.add(e.$8J.OutputChannels,new m),e.$9J=new I.$gj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,278,63,27,43,136,24,16,42,5,6]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class t extends A.$pj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,A.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,b){this.i=i,this.j=s,this.k=u,this.l=d,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$MK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$rm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,$.$Ef)(i)?i:void 0;if((0,$.$Ef)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const f=this.i.environment.extensionLogLevel?.find(([F])=>M.$gm.equals(s.identifier,F))?.[1];f&&(b=(0,A.$zj)(f));const D=u?this.o(h,b,s):this.n(h,d,s);return D.then(F=>{this.g.set(F.id,F),F.visible=F.id===this.h}),u?this.r(h,b??this.m.getLevel(),D):this.q(h,D)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,b,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,D=this.l.createLogger(b,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new r(f,h,D,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,v.$Bk)(u)!==v.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(b=>b.append(d))},appendLine(d){u(),i.then(b=>b.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(b=>b.replace(d))},show(d,b){u(),i.then(f=>f.show(d,b))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},b=u.add(new n.$Sd);function f(D){i=D,b.fire(D)}return s.then(D=>{u.add(D),D.logLevel!==i&&f(D.logLevel),u.add(D.onDidChangeLogLevel(F=>f(F)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(D,...F){d(),s.then(p=>p.trace(D,...F))},debug(D,...F){d(),s.then(p=>p.debug(D,...F))},info(D,...F){d(),s.then(p=>p.info(D,...F))},warn(D,...F){d(),s.then(p=>p.warn(D,...F))},error(D,...F){d(),s.then(p=>p.error(D,...F))},dispose(){u.dispose()}}}};e.$Jgc=a,e.$Jgc=a=Ge([Ke(0,I.$QM),Ke(1,w.$7M),Ke(2,g.$wfc),Ke(3,R.$9ec),Ke(4,A.$kj),Ke(5,A.$jj)],a),e.$Kgc=(0,T.$2h)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=(0,E.$2h)("remoteAgentService"),e.$Hm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await I.getRoundTripTime();if(g===void 0)return;M=Math.min(M,g/2),await(0,T.$3g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Ae([1,0,170,54,30,47,41,6,5,113,21,26]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=void 0,e.$zH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$AH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$BH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$CH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const $=new l;I.$tn.add(e.$CH.ConfigurationMigration,$);let v=class extends m.$Sc{constructor(t,r){super(),this.a=t,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const r of this.b.getWorkspace().folders)await this.f(r,t)}async f(t,r){await Promise.all([r.map(a=>this.g(a,t?.uri))])}async g(t,r){const a=this.a.inspect(t.key,{resource:r}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const b=await this.h(t,{resource:r,overrideIdentifier:d},h);for(const f of b??[]){let D=s.find(([[F,p]])=>F===f[0]&&(0,S.$ln)(p.value,f[1].value));D||s.push(D=[f,[]]),D[1].push(d)}}const u=await this.h(t,{resource:r},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,b],f])=>this.a.updateValue(d,b.value,{resource:r,overrideIdentifiers:f},i)))}}async h(t,r,a,c){const h=d=>i(this.a.inspect(d,r)),i=d=>{const b=d[a];return r.overrideIdentifier?b?.override:b?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$DH=v,e.$DH=v=Ge([Ke(0,A.$vi),Ke(1,M.$$h)],v);let n=class extends m.$Sc{constructor(t){super(),(async()=>{if(!R.$i&&(await t.getEnvironment())?.os!==1)return;I.$tn.as(T.$yn.Configuration).registerConfiguration({...e.$BH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$EH=n,e.$EH=n=Ge([Ke(0,w.$Gm)],n)}),define(Pe[280],Ae([1,0,34,13,19,25,178,279,54,4,30]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cb=e.$4cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$3cb=e.$2cb=void 0,e.$2cb=(0,w.$2h)("editorResolverService"),e.$3cb="workbench.editorAssociations";const S=R.$tn.as(g.$yn.Configuration),l={...m.$AH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var $;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})($||(e.RegisteredEditorPriority=$={}));var v;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function n(t){switch(t){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$4cb=n;function o(t,r){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$Ag)(r);return E.$Hj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$5cb=o}),define(Pe[281],Ae([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(me,e,E,T,I,M,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=void 0,e.$oK=(0,g.$2h)("pathService");let v=$=class{constructor(o,t,r,a){this.d=o,this.e=t,this.f=r,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,r){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,r)}h(o,t,r){return o.scheme===T.Schemas.file||o.scheme===T.Schemas.vscodeRemote?(0,E.$2f)(r??(0,A.$Ag)(o),t===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,w.$lK)(t.getWorkspace());if(r)return r;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$pK=v,e.$pK=v=$=Ge([Ke(1,l.$Gm),Ke(2,S.$0J),Ke(3,R.$$h)],v)}),define(Pe[114],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$4I=e.$3I=void 0;class E{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new E(0,0)}with(A){return new E(0,0)}}e.$3I=E;class T{constructor(A,m,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(A,m),this.end=new E(g,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$4I=T;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[44],Ae([1,0,18,34,26,46,12,4,19,11,114,14]),function(me,e,E,T,I,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.SearchErrorCode=e.$gJ=e.$fJ=e.SearchSortOrder=e.ViewMode=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.SearchCompletionExitCode=e.$aJ=e.$_I=e.$$I=e.QueryType=e.SearchProviderType=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$5I="workbench.view.search",e.$6I="workbench.panel.search",e.$7I="workbench.view.search",e.$8I="search-result",e.$9I="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",v=(l.length+$.length+5)*2;e.$0I=(0,m.$2h)("searchService");var n;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(n||(e.SearchProviderType=n={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(o||(e.QueryType=o={}));function t(de){return!!de.preview}e.$$I=t;function r(de){return!!de.resource}e.$_I=r;function a(de){return!!de.message}e.$aJ=a;var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(he){this.resource=he,this.results=[]}}e.$bJ=h;class i{constructor(he,te,Se,oe){this.ranges=te,this.webviewIndex=oe;const X=Array.isArray(te)?te:[te];if(Se&&Se.matchLines===1&&s(X)){he=(0,A.$xf)(he,Se.matchLines);let V="",ne=0,Ie=0;const Me=Math.floor(Se.charsPerLine/5),Ce=[];for(const ce of X){const ie=Math.max(ce.startColumn-Me,0),Q=ce.startColumn+Se.charsPerLine;if(ie>Ie+Me+v){const ee=l+(ie-Ie)+$;V+=ee+he.slice(ie,Q),ne+=ie-(Ie+ee.length)}else V+=he.slice(Ie,Q);Ce.push(new d(0,ce.startColumn-ne,ce.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:he,matches:(0,E.$2b)(te,ne=>new u(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$cJ=i;function s(de){const he=de[0].startLineNumber;for(const te of de)if(te.startLineNumber!==he||te.endLineNumber!==he)return!1;return!0}class u{constructor(he,te,Se,oe){this.startLineNumber=he,this.startColumn=te,this.endLineNumber=Se,this.endColumn=oe}}e.$dJ=u;class d extends u{constructor(he,te,Se){super(he,te,he,Se)}}e.$eJ=d;var b;(function(de){de.List="list",de.Tree="tree"})(b||(e.ViewMode=b={}));var f;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function D(de,he=!0){const te=de&&de.files&&de.files.exclude,Se=he&&de&&de.search&&de.search.exclude;if(!te&&!Se)return;if(!te||!Se)return te||Se;let oe=Object.create(null);return oe=I.$kn(oe,I.$hn(te)),oe=I.$kn(oe,I.$hn(Se),!0),oe}e.$fJ=D;function F(de,he){return de.excludePattern&&T.$Hj(de.excludePattern,he)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&T.$Hj(de.includePattern,he)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(te=>{const Se=te.folder.fsPath;if(M.$4f(he,Se)){const oe=g.$lc(Se,he);return!te.includePattern||!!T.$Hj(te.includePattern,oe)}else return!1}):!1:!0}e.$gJ=F;var p;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class y extends Error{constructor(he,te){super(he),this.code=te}}e.$hJ=y;function k(de){const he=de.message;if((0,w.$4)(de))return new y(he,p.canceled);try{const te=JSON.parse(he);return new y(te.message,te.code)}catch{return new y(he,p.other)}}e.$iJ=k;function O(de){const he={message:de.message,code:de.code};return new Error(JSON.stringify(he))}e.$jJ=O;function K(de){return de.type==="error"?!0:de.type==="success"}e.$kJ=K;function U(de){return de.type==="success"}e.$lJ=U;function L(de){return!!de.path}e.$mJ=L;function z(de,he){const te=de.searchPath?de.searchPath:de.relativePath;return(0,A.$uf)(te,he)}e.$nJ=z;class C{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$oJ=C;function P(de,he){const te={...de||{},...he||{}};return Object.keys(te).filter(Se=>{const oe=te[Se];return typeof oe=="boolean"&&oe})}e.$pJ=P;class Y{constructor(he,te){this.c=null,this.a={...he.excludePattern||{},...te.excludePattern||{}},this.b=T.$Ij(this.a);let Se=he.includePattern;te.includePattern&&(Se?Se={...Se,...te.includePattern}:Se=te.includePattern),Se&&(this.c=T.$Ij(Se))}matchesExcludesSync(he,te,Se){return!!(this.b&&this.b(he,te,Se))}includedInQuerySync(he,te,Se){return!(this.b&&this.b(he,te,Se)||this.c&&!this.c(he,te,Se))}includedInQuery(he,te,Se){const oe=this.b(he,te,Se),X=()=>this.c?!!this.c(he,te,Se):!0;return(0,S.$Og)(oe)?oe.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return ae(this.a)}}e.$qJ=Y;function ae(de){for(const he in de)if(typeof de[he]!="boolean")return!0;return!1}function ge(de){if(!de)return;let he;return te=>(he||(he=(de()||Promise.resolve([])).then(Se=>Se?De(Se):{})),he.then(Se=>!!Se[te]))}e.$rJ=ge;function ve(de){if(!de)return;let he;return te=>{if(!he){const Se=de();he=Se?De(Se):{}}return!!he[te]}}e.$sJ=ve;function De(de){const he={};for(const te of de)he[te]=!0;return he}}),define(Pe[36],Ae([1,0,18,14,20,5,6,50,13,122,25,12,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0;function f(U,L,z){return new R.$sg(C=>y(C,z)).isEqual(U,L)}function D(U,L,z){return f(U.uri,L.uri,z)?0:(0,S.$1e)(U.uri.toString(),L.uri.toString())}function F(U,L,z){return U.index!==L.index?U.index<L.index?-1:1:f(U.uri,L.uri,z)?(0,S.$1e)(U.name,L.name):(0,S.$1e)(U.uri.toString(),L.uri.toString())}function p(U,L,z,C){const P=U.slice(0).sort((ae,ge)=>z(ae,ge,C)),Y=L.slice(0).sort((ae,ge)=>z(ae,ge,C));return(0,E.$Eb)(P,Y,(ae,ge)=>z(ae,ge,C))}function y(U,L){const z=L.getCapabilities(U.scheme);return!(z&&z&1024)}class k extends t.$ii{static toExtHostWorkspace(L,z,C,P){if(!L)return{workspace:null,added:[],removed:[]};const{id:Y,name:ae,folders:ge,configuration:ve,transient:De,isUntitled:de}=L,he=[],te=z;z?ge.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Me=k.o(C||z,Ie,P);Me?(Me.name=V.name,Me.index=V.index,he.push(Me)):he.push({uri:Ie,name:V.name,index:ne})}):he.push(...ge.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),he.sort((V,ne)=>V.index<ne.index?-1:1);const Se=new k(Y,ae,he,!!De,ve?l.URI.revive(ve):null,!!de,V=>y(V,P)),{added:oe,removed:X}=p(te?te.workspaceFolders:[],Se.workspaceFolders,D,P);return{workspace:Se,added:oe,removed:X}}static o(L,z,C){for(let P=0;P<L.folders.length;P++){const Y=L.workspaceFolders[P];if(f(Y.uri,z,C))return Y}}constructor(L,z,C,P,Y,ae,ge){super(L,C.map(ve=>new t.$ji(ve)),P,Y,ge),this.t=z,this.u=ae,this.q=[],this.s=m.$8h.forUris(ge),C.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(L,z){return z&&this.s.get(L)&&(L=(0,R.$Cg)(L)),this.s.findSubstr(L)}resolveWorkspaceFolder(L){return this.s.get(L)}}let O=class{constructor(L,z,C,P,Y){this.c=new M.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Ud,this.B=new Map,this.h=P,this.s=C,this.t=Y,this.j=new w.$4l,this.k=new T.$1g,this.o=L.getProxy(d.$MK.MainThreadWorkspace),this.q=L.getProxy(d.$MK.MainThreadMessageService);const ae=z.workspace;this.l=ae?new k(ae.id,ae.name,[],!!ae.transient,ae.configuration?l.URI.revive(ae.configuration):null,!!ae.isUntitled,ge=>y(ge,C)):void 0}$initializeWorkspace(L,z){this.v=z,this.$acceptWorkspaceData(L),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,R.$Ag)((0,R.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(L,z,C,...P){const Y=[];if(Array.isArray(P)&&P.forEach(de=>{l.URI.isUri(de.uri)&&!Y.some(he=>f(he.uri,de.uri,this.s))&&Y.push({uri:de.uri,name:de.name||(0,R.$zg)(de.uri)})}),this.n||[z,C].some(de=>typeof de!="number"||de<0)||C===0&&Y.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(z+C>ae.length)return!1;const ge=ae.slice(0);ge.splice(z,C,...Y.map(de=>({uri:de.uri,name:de.name||(0,R.$zg)(de.uri),index:void 0})));for(let de=0;de<ge.length;de++){const he=ge[de];if(ge.some((te,Se)=>Se!==de&&f(he.uri,te.uri,this.s)))return!1}ge.forEach((de,he)=>de.index=he);const{added:ve,removed:De}=p(ae,ge,F,this.s);if(ve.length===0&&De.length===0)return!1;if(this.o){const de=L.displayName||L.name;this.o.$updateWorkspaceFolders(de,z,C,Y).then(void 0,he=>{this.n=void 0;const te={source:{identifier:L.identifier,label:L.displayName||L.name}};this.q.$showMessage(o.Severity.Error,(0,$.localize)(0,null,de,he.toString()),te,[])})}return this.y(ge),!0}getWorkspaceFolder(L,z){if(this.x)return this.x.getWorkspaceFolder(L,z)}async getWorkspaceFolder2(L,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(L,z)}async resolveWorkspaceFolder(L){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(L)}getPath(){if(!this.x)return;const{folders:L}=this.x;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,z){let C,P="";if(typeof L=="string"?(C=l.URI.file(L),P=L):typeof L<"u"&&(C=L,P=L.fsPath),!C)return P;const Y=this.getWorkspaceFolder(C,!0);if(!Y)return P;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ae=(0,R.$Fg)(Y.uri,C);return z&&Y.name&&(ae=`${Y.name}/${ae}`),ae}y(L){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:L,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:z,added:C,removed:P}=k.toExtHostWorkspace(L,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:P}))}findFiles(L,z,C,P,Y=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${P.value}, entryPoint: findFiles`);let ae;if(z===null?ae=!1:z&&(typeof z=="string"?ae=z:ae=z.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:ge,folder:ve}=K(h.GlobPattern.from(L));return this.o.$startFileSearch(ge??null,ve??null,ae??null,C??null,Y).then(De=>Array.isArray(De)?De.map(de=>l.URI.revive(de)):[])}async findTextInFiles(L,z,C,P,Y=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${P.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),ge=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ve,folder:De}=K(h.GlobPattern.from(z.include)),de=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,he={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ge,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ve,excludePattern:de},te=!1;if(this.u[ae]=Se=>{if(te)return;const oe=l.URI.revive(Se.resource);Se.results.forEach(X=>{const V=(0,b.$yh)(X);(0,u.$$I)(V)?C({uri:oe,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ne=>new i.$QK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(V.ranges,ne=>new i.$QK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:oe,text:V.text,lineNumber:V.lineNumber})})},Y.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(L,De??null,he,ae,Y);return delete this.u[ae],Se||{}}catch(Se){throw delete this.u[ae],Se}}$handleTextSearchResult(L,z){this.u[z]?.(L)}async save(L){const z=await this.o.$save(L,{saveAs:!1});return l.URI.revive(z)}async saveAs(L){const z=await this.o.$save(L,{saveAs:!0});return l.URI.revive(z)}saveAll(L){return this.o.$saveAll(L)}resolveProxy(L){return this.o.$resolveProxy(L)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(L){return this.o.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(L,z){if(this.w.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this.w.set(L,z);const C=this.t.transformOutgoingScheme(L),P=this.z++;return this.o.$registerEditSessionIdentityProvider(P,C),(0,A.$Qc)(()=>{this.w.delete(L),this.o.$unregisterEditSessionIdentityProvider(P)})}async $getEditSessionIdentifier(L,z){this.h.info("Getting edit session identifier for workspaceFolder",L);const C=await this.resolveWorkspaceFolder(l.URI.revive(L));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const P=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!P),!P)return;const Y=await P.provideEditSessionIdentity(C,z);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(L,z,C,P){this.h.info("Getting edit session identifier for workspaceFolder",L);const Y=await this.resolveWorkspaceFolder(l.URI.revive(L));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const ae=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!ae),!ae)return;const ge=await ae.provideEditSessionIdentityMatch?.(z,C,P);if(this.h.info("Provider returned edit session identifier match result: ",ge),!!ge)return ge}getOnWillCreateEditSessionIdentityEvent(L){return(z,C,P)=>{const Y=function(ge){z.call(C,ge)};return Y.extension=L,this.A.event(Y,void 0,P)}}async $onWillCreateEditSessionIdentity(L,z,C){const P=await this.resolveWorkspaceFolder(l.URI.revive(L));if(P===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:P},z,async(Y,ae)=>{const ge=Date.now();await Promise.resolve(Y),Date.now()-ge>C&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(L,z){if(this.B.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this.B.set(L,z);const C=this.t.transformOutgoingScheme(L),P=this.z++;return this.o.$registerCanonicalUriProvider(P,C),(0,A.$Qc)(()=>{this.B.delete(L),this.o.$unregisterCanonicalUriProvider(P)})}async provideCanonicalUri(L,z,C){const P=this.B.get(L.scheme);if(!P)return;const Y=await P.provideCanonicalUri?.(l.URI.revive(L),z,C);if(Y)return Y}async $provideCanonicalUri(L,z,C){return this.provideCanonicalUri(l.URI.revive(L),{targetScheme:z},C)}};e.$qfc=O,e.$qfc=O=Ge([Ke(0,c.$QM),Ke(1,a.$7M),Ke(2,r.$9ec),Ke(3,n.$jj),Ke(4,s.$ofc)],O),e.$rfc=(0,v.$2h)("IExtHostWorkspace");function K(U){let L,z;return U&&(typeof U=="string"?L=U:(L=U.pattern,z=l.URI.revive(U.baseUri))),{includePattern:L,folder:z}}}),define(Pe[37],Ae([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=e.$sfc=void 0;function n(s,u){if(u){const d=u.split(".");let b=s;for(let f=0;b&&f<d.length;f++)b=b[d[f]];return b}}function o(s){return s instanceof v.URI}function t(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,b){this.a=u.getProxy(M.$MK.MainThreadConfiguration),this.c=d,this.b=b,this.d=new R.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(u,d))}};e.$sfc=h,e.$sfc=h=Ge([Ke(0,l.$QM),Ke(1,I.$rfc),Ke(2,$.$jj)],h);class i{constructor(u,d,b,f){this.a=new T.$Sd,this.b=u,this.f=f,this.c=d,this.e=m.$Rn.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Rn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,b))}getConfiguration(u,d,b){const f=c(d)||{},D=this.g(u?n(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,b?.identifier);function F(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(y){return typeof n(D,y)<"u"},get:(y,k)=>{this.h(u?`${u}.${y}`:y,f,b?.identifier);let O=n(D,y);if(typeof O>"u")O=k;else{let K;const U=(L,z)=>{if((0,w.$Gf)(L)){let C;const P=()=>{K=K||(0,E.$hn)(D),C=C||n(K,z)};return new Proxy(L,{get:(Y,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return P(),()=>C;if(K)return C=C||n(K,z),C[ae];const ge=Y[ae];return typeof ae=="string"?U(ge,`${z}.${ae}`):ge},set:(Y,ae,ge)=>(P(),C&&(C[ae]=ge),!0),deleteProperty:(Y,ae)=>(P(),C&&delete C[ae],!0),defineProperty:(Y,ae,ge)=>(P(),C&&Object.defineProperty(C,ae,ge),!0)})}return Array.isArray(L)?(0,E.$hn)(L):L};O=U(O,y)}return O},update:(y,k,O,K)=>{y=u?`${u}.${y}`:y;const U=F(O);return k!==void 0?this.b.$updateConfigurationOption(U,y,k,f,K):this.b.$removeConfigurationOption(U,y,f,K)},inspect:y=>{y=u?`${u}.${y}`:y;const k=this.e.inspect(y,f,this.c.workspace);if(k)return{key:y,defaultValue:(0,E.$hn)(k.policy?.value??k.default?.value),globalValue:(0,E.$hn)(k.user?.value??k.application?.value),workspaceValue:(0,E.$hn)(k.workspace?.value),workspaceFolderValue:(0,E.$hn)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$hn)(k.default?.override),globalLanguageValue:(0,E.$hn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$hn)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$hn)(k.workspaceFolder?.override),languageIds:(0,E.$hn)(k.overrideIdentifiers)}}};return typeof D=="object"&&(0,E.$kn)(p,D,!1),Object.freeze(p)}g(u){const d=b=>(0,w.$Gf)(b)?new Proxy(b,{get:(f,D)=>d(f[D]),set:(f,D,F)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(f,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(f,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return d(u)}h(u,d,b){const f=g.$In.test(u)?4:this.d.get(u),D=b?`[${b.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const b=new m.$Tn(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,D)=>b.affectsConfiguration(f,c(D))})}k(u){return u.reduce((d,b)=>(d.set(b[0],b[1]),d),new Map)}}e.$tfc=i,e.$ufc=(0,S.$2h)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,229,11]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=e.$Vgc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(U){function L(C){if(C!=null)return C}U.from=L;function z(C){if(C!=null)return C}U.to=z})(h||(h={}));var i;(function(U){function L(C){if(C!=null)return C}U.from=L;function z(C){if(C!=null)return C}U.to=z})(i||(i={}));var s;(function(U){function L(C){if(C!=null)return C}U.from=L;function z(C){if(C!=null)return C}U.to=z})(s||(s={}));var u;(function(U){function L(P){if(P){const Y=P;return Y&&!!Y.process}else return!1}U.is=L;function z(P){if(P==null)return;const Y={process:P.process,args:P.args};return P.options&&(Y.options=s.from(P.options)),Y}U.from=z;function C(P){if(P!=null)return new A.$xL(P.process,P.args,P.options)}U.to=C})(u||(u={}));var d;(function(U){function L(C){if(C!=null)return C}U.from=L;function z(C){if(C!=null)return C}U.to=z})(d||(d={}));var b;(function(U){function L(P){if(P){const Y=P;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}U.is=L;function z(P){if(P==null)return;const Y={};return P.commandLine!==void 0?Y.commandLine=P.commandLine:(Y.command=P.command,Y.args=P.args),P.options&&(Y.options=d.from(P.options)),Y}U.from=z;function C(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new A.$yL(P.commandLine,P.options):new A.$yL(P.command,P.args?P.args:[],P.options)}U.to=C})(b||(b={}));var f;(function(U){function L(P){if(P){const Y=P;return Y&&Y.customExecution==="customExecution"}else return!1}U.is=L;function z(P){return{customExecution:"customExecution"}}U.from=z;function C(P,Y){return Y.get(P)}U.to=C})(f||(e.CustomExecutionDTO=f={}));var D;(function(U){function L(z,C){let P;return z.scope!==void 0&&typeof z.scope!="number"?P=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&C&&C.workspaceFile?P=C.workspaceFile:P=a.$gG),{id:z._id,workspaceFolder:P}}U.from=L})(D||(e.TaskHandleDTO=D={}));var F;(function(U){function L(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}U.from=L})(F||(F={}));var p;(function(U){function L(P,Y){if(P==null)return[];const ae=[];for(const ge of P){const ve=z(ge,Y);ve&&ae.push(ve)}return ae}U.fromMany=L;function z(P,Y){if(P==null)return;let ae;P.execution instanceof A.$xL?ae=u.from(P.execution):P.execution instanceof A.$yL?ae=b.from(P.execution):P.execution&&P.execution instanceof A.$zL&&(ae=f.from(P.execution));const ge=h.from(P.definition);let ve;return P.scope?typeof P.scope=="number"?ve=P.scope:ve=P.scope.uri:ve=A.TaskScope.Workspace,!ge||!ve?void 0:{_id:P._id,definition:ge,name:P.name,source:{extensionId:Y.identifier.value,label:P.source,scope:ve},execution:ae,isBackground:P.isBackground,group:F.from(P.group),presentationOptions:i.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}U.from=z;async function C(P,Y,ae){if(P==null)return;let ge;u.is(P.execution)?ge=u.to(P.execution):b.is(P.execution)?ge=b.to(P.execution):f.is(P.execution)&&(ge=f.to(P._id,ae));const ve=h.to(P.definition);let De;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?De=P.source.scope:De=await Y.resolveWorkspaceFolder(E.URI.revive(P.source.scope)):De=A.TaskScope.Workspace),!ve||!De)return;const de=new A.$AL(ve,De,P.name,P.source.label,ge,P.problemMatchers);return P.isBackground!==void 0&&(de.isBackground=P.isBackground),P.group!==void 0&&(de.group=A.$wL.from(P.group._id),de.group&&P.group.isDefault&&(de.group=new A.$wL(de.group.id,de.group.label),P.group.isDefault===!0&&(de.group.isDefault=P.group.isDefault))),P.presentationOptions&&(de.presentationOptions=i.to(P.presentationOptions)),P._id&&(de._id=P._id),P.detail&&(de.detail=P.detail),de}U.to=C})(p||(e.TaskDTO=p={}));var y;(function(U){function L(C){return C}U.from=L;function z(C){if(C)return Object.assign(Object.create(null),C)}U.to=z})(y||(y={}));class k{#e;constructor(L,z,C){this._id=z,this.a=C,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let O=class{constructor(L,z,C,P,Y,ae,ge,ve){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.t=new I.$Sd,this.a=L.getProxy(M.$MK.MainThreadTask),this.b=C,this.c=P,this.d=Y,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,z,C){if(!C)return new A.$OK(()=>{});const P=this.w();return this.j.set(P,{type:z,provider:C,extension:L}),this.a.$registerTaskProvider(P,z),new A.$OK(()=>{this.j.delete(P),this.a.$unregisterTaskProvider(P)})}registerTaskSystem(L,z){this.a.$registerTaskSystem(L,z)}fetchTasks(L){return this.a.$fetchTasks(y.from(L)).then(async z=>{const C=[];for(const P of z){const Y=await p.to(P,this.b,this.m);Y&&C.push(Y)}return C})}get taskExecutions(){const L=[];return this.k.forEach(z=>L.push(z)),L}terminateTask(L){if(!(L instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,z,C){const P=this.m.get(L.id);P&&(this.o.set(L.id,P),this.e.attachPtyToTerminal(z,await P.callback(C))),this.p=L.id,this.q.fire({execution:await this.y(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){const z=await this.y(L);this.l.delete(L.id),this.k.delete(L.id),this.A(L),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const z=await this.y(L.id);this.s.fire({execution:z,processId:L.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(L){const z=await this.y(L.id);this.t.fire({execution:z,exitCode:L.exitCode})}$provideTasks(L,z){const C=this.j.get(L);if(!C)return Promise.reject(new Error("no handler found"));const P=[],Y=(0,T.$Ug)(()=>C.provider.provideTasks(R.CancellationToken.None)).then(ae=>this.u(z,P,C,ae));return new Promise(ae=>{Y.then(ge=>{Promise.all(P).then(()=>{ae(ge)})})})}async $resolveTask(L,z){const C=this.j.get(L);if(!C)return Promise.reject(new Error("no handler found"));if(z.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${C.type}].`);const P=await p.to(z,this.b,this.m);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const Y=await C.provider.resolveTask(P,R.CancellationToken.None);if(!Y)return;this.z(Y,C);const ae=p.from(Y,C.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.x(ae,Y,!0),await this.v(ae)}w(){return this.h++}async x(L,z,C){const P=await this.a.$createTaskId(L);!C&&!this.m.has(P)&&(this.n.add(P),this.o.set(P,z.execution)),this.m.set(P,z.execution)}async y(L,z){if(typeof L=="string"){const Y=this.l.get(L);if(!Y)throw new c.$bb("Unexpected: The specified task is missing an execution");return Y}const C=this.l.get(L.id);if(C)return C;const P=new Promise((Y,ae)=>{function ge(ve,De,de){de?Y(new k(ve,De.id,de)):ae("Unexpected: Task does not exist.")}z?ge(this,L,z):p.to(L.task,this.b,this.m).then(ve=>ge(this,L,ve))});return this.l.set(L.id,P),P.then(Y=>(this.k.set(L.id,Y),Y),Y=>Promise.reject(Y))}z(L,z){L._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const C=this.n.values();let P=C.next();for(;!P.done;)!this.o.has(P.value)&&this.p!==P.value&&(this.m.delete(P.value),this.n.delete(P.value)),P=C.next()}};e.$Vgc=O,e.$Vgc=O=Ge([Ke(0,l.$QM),Ke(1,$.$7M),Ke(2,m.$rfc),Ke(3,g.$2M),Ke(4,w.$ufc),Ke(5,S.$Sfc),Ke(6,t.$jj),Ke(7,r.$_ec)],O);let K=class extends O{constructor(L,z,C,P,Y,ae,ge,ve){super(L,z,C,P,Y,ae,ge,ve),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(L,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const C=p.from(z,L);if(C===void 0)throw new Error("Task is not valid");if(f.is(C.execution))await this.x(C,z,!1);else throw new c.$_;const P=await this.y(await this.a.$getTaskExecution(C),z);return this.a.$executeTask(C).catch(Y=>{throw new Error(Y)}),P}u(L,z,C,P){const Y=[];if(P)for(const ae of P){if(this.z(ae,C),!ae.definition||!L[ae.definition.type]){const ve=ae.source?ae.source:"No task source";this.f.warn(`The task [${ve}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=p.from(ae,C.extension);ge&&f.is(ge.execution)?(Y.push(ge),z.push(this.x(ge,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:C.extension}}async v(L){if(f.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,z,C){}};e.$Wgc=K,e.$Wgc=K=Ge([Ke(0,l.$QM),Ke(1,$.$7M),Ke(2,m.$rfc),Ke(3,g.$2M),Ke(4,w.$ufc),Ke(5,S.$Sfc),Ke(6,t.$jj),Ke(7,r.$_ec)],K),e.$Xgc=(0,v.$2h)("IExtHostTask")}),define(Pe[282],Ae([1,0,44,29]),function(me,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.$zJ=e.$yJ=void 0;function I(A){return"cellResults"in A}e.$yJ=I,e.$zJ="rawCell#";function M(A,m){let g=-1;const w=[];let R=[];return A.forEach(l=>{l.range.startLineNumber!==g&&R.length>0&&(w.push([...R]),R=[]),R.push(l),g=l.range.endLineNumber}),R.length>0&&w.push([...R]),w.map(l=>{const $=[],v=l[0].range.startLineNumber,n=l[l.length-1].range.endLineNumber;for(let o=v;o<=n;o++)$.push(m.getLineContent(o));return new E.$cJ($.join(`
`)+`
`,l.map(o=>new T.$Gs(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$AJ=M}),define(Pe[283],Ae([1,0,162,24,5,6,28,12,16,2,42,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,D,F,p,y,k){this.q=F,this.r=p,this.s=y,this.t=k,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new I.$Sd({onListenerError:a.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd({onListenerError:a.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd({onListenerError:a.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd({onListenerError:a.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$5ec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(l.$MK.MainThreadNotebook),this.c=f.getProxy(l.$MK.MainThreadNotebookDocuments),this.d=f.getProxy(l.$MK.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===13){const K=O.notebookEditor?.notebookUri,U=O.cell.handle,z=this.g.get(K)?.getCell(U);if(z)return z.apiCell}if(O&&O.$mid===14){const K=O.uri,U=this.g.get(K);if(U)return U.apiNotebook}return O}}),d.B(D)}getEditorById(f){const D=this.h.get(f);if(!D)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(f){for(const[D,F]of this.h)if(F.apiEditor===f)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,D){const F=this.g.get(f);if(!F&&!D)throw new Error(`NO notebook document for '${f}'`);return F}static u(f,D){if(!D)return;const F=D.filenamePattern.map(p=>v.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(D.filenamePattern&&!F){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:D.displayName,filenamePattern:F,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,D,F){const p=d.a++,y=typeof F.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(p,F),this.b.$registerNotebookCellStatusBarItemProvider(p,y,D);let k;return y!==void 0&&(k=F.onDidChangeCellStatusBarItems(O=>this.b.$emitCellStatusBarEvent(y))),new n.$OK(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,y),k?.dispose()})}async createNotebookDocument(f){const D=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return w.URI.revive(D)}async openNotebookDocument(f){const D=this.g.get(f);if(D)return D.apiNotebook;const F=await this.c.$tryOpenNotebook(f),p=this.g.get(w.URI.revive(F));return(0,g.$Pf)(p?.apiNotebook)}async showNotebookDocument(f,D){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let F;typeof D=="object"?F={position:v.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(v.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:F={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,F),y=p&&this.h.get(p)?.apiEditor;if(y)return y;throw p?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,D,F,p){const y=this.f.get(f),k=w.URI.revive(D),O=this.g.get(k);if(!O||!y)return;const K=O.getCellFromIndex(F);if(!K)return;const U=await y.provideCellStatusBarItems(K.apiCell,p);if(!U)return;const L=new M.$Rc,z=this.p.add([L]),P=(Array.isArray(U)?U:[U]).map(Y=>v.NotebookStatusBarItem.from(Y,this.i,L));return{cacheId:z,items:P}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,D,F,p,y){if((0,m.$Ge)(D))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:D,serializer:F,options:p}),this.b.$registerNotebookSerializer(k,{id:f.identifier,location:f.extensionLocation},D,v.NotebookDocumentContentOptions.from(p),d.u(f,y)),(0,M.$Qc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(f,D,F){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.deserializeNotebook(D.buffer,F);return new o.$Ev(v.NotebookData.from(y))}async $notebookToData(f,D,F){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.serializeNotebook(v.NotebookData.to(D.value),F);return T.$ge.wrap(y)}async $saveNotebook(f,D,F,p,y){const k=w.URI.revive(D),O=this.x.get(f);if(!O)throw new Error("NO serializer found");const K=this.g.get(k);if(!K)throw new Error("Document NOT found");if(K.versionId!==F)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new R.$Gk((0,E.localize)(0,null,this.z(k)),6);await this.y(k,p);const U={metadata:(0,c.$pn)(K.apiNotebook.metadata,Y=>!(O.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of K.apiNotebook.getCells()){const ae=new n.$bM(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,O.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);ae.metadata=(0,c.$pn)(Y.metadata,ge=>!(O.options?.transientCellMetadata??{})[ge]),U.cells.push(ae)}const L=await O.serializer.serializeNotebook(U,y);await this.s.value.writeFile(k,L);const z=this.s.getFileSystemProviderExtUri(k.scheme),C=await this.s.value.stat(k);return{name:z.basename(k),isFile:(C.type&R.FileType.File)!==0,isDirectory:(C.type&R.FileType.Directory)!==0,isSymbolicLink:(C.type&R.FileType.SymbolicLink)!==0,mtime:C.mtime,ctime:C.ctime,size:C.size,readonly:!!((C.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((C.permissions??0)&R.FilePermission.Locked),etag:R.$Rk({mtime:C.mtime,size:C.size}),children:void 0}}async $searchInNotebooks(f,D,F,p,y){const k=this.x.get(f)?.serializer;if(!k)return{limitHit:!1,results:[]};const O=new A.$Bc;await(async(C,P,Y)=>{await Promise.all(C.map(async ae=>await Promise.all(ae.filenamePatterns.map(ge=>{const ve={...Y,type:1,filePattern:ge};return this.t.doInternalFileSearchWithCustomCallback(ve,P,De=>{De.forEach(de=>{O.has(de)||p.some(te=>ae.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(Se=>(0,u.$5cb)(Se,de)))||O.add(de)})})}))))})(F,y,D);const U=new A.$Ac;let L=!1;const z=Array.from(O).map(async C=>{const P=[];try{if(y.isCancellationRequested)return;if(D.maxResults&&[...U.values()].reduce((ve,De)=>ve+De.cellResults.length,0)>D.maxResults){L=!0;return}const Y=[],ae=this.g.get(C);if(ae)ae.apiNotebook.getCells().forEach(De=>Y.push({input:De.document.getText(),outputs:De.outputs.flatMap(de=>de.items.map(he=>he.data.toString()))}));else{const ve=await this.s.value.readFile(C),De=T.$ge.fromString(ve.toString()),de=await k.deserializeNotebook(De.buffer,y);if(y.isCancellationRequested)return;v.NotebookData.from(de).cells.forEach(te=>Y.push({input:te.source,outputs:te.outputs.flatMap(Se=>Se.items.map(oe=>oe.valueBytes.toString()))}))}if(y.isCancellationRequested)return;Y.forEach((ve,De)=>{const de=D.contentPattern.pattern,he=new i.$4Pb(ve.input,void 0,ve.outputs),te=he.findInInputs(de),Se=he.findInOutputs(de),oe=Se.flatMap(X=>(0,s.$AJ)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(te.length>0||Se.length>0){const X={index:De,contentResults:(0,s.$AJ)(te,he.inputTextBuffer),webviewResults:oe};P.push(X)}});const ge={resource:C,cellResults:P};U.set(C,ge);return}catch{return}});return await Promise.all(z),{limitHit:L,results:[...U.values()]}}async y(f,D){const F=await this.s.value.stat(f);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==R.$Qk&&typeof F.mtime=="number"&&typeof F.size=="number"&&D.mtime<F.mtime&&D.etag!==R.$Rk({mtime:D.mtime,size:F.size}))throw new R.$Gk((0,E.localize)(1,null),3,D)}z(f){return f.scheme===h.Schemas.file?f.fsPath:f.toString()}A(f,D,F){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const p=new r.$ogc(D,this.d,f,F.visibleRanges.map(v.NotebookRange.to),F.selections.map(v.NotebookRange.to),typeof F.viewColumn=="number"?v.ViewColumn.to(F.viewColumn):void 0);this.h.set(D,p)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const F of f.value.removedDocuments){const p=w.URI.revive(F),y=this.g.get(p);y&&(y.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(y.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===p.toString()&&this.h.delete(k.id)}if(f.value.addedDocuments){const F=[];for(const p of f.value.addedDocuments){const y=w.URI.revive(p.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const k=new t.$ngc(this.c,this.q,this.r,y,p);F.push(...p.cells.map(O=>t.$mgc.asModelAddData(k.apiNotebook,O))),this.g.get(y)?.dispose(),this.g.set(y,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this.m.fire(k.apiNotebook)}}if(f.value.addedEditors)for(const F of f.value.addedEditors){if(this.h.has(F.id))return;const p=w.URI.revive(F.documentUri),y=this.g.get(p);y&&this.A(y,F.id,F)}const D=[];if(f.value.removedEditors)for(const F of f.value.removedEditors){const p=this.h.get(F);p&&(this.h.delete(F),this.k?.id===p.id&&(this.k=void 0),D.push(p))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const F=new Set;this.l.forEach(p=>F.add(p.id));for(const p of this.h.values()){const y=F.has(p.id);p._acceptVisibility(y)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const D=$.$cN.String.with("notebookType","A notebook type"),F=new $.$eN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new $.$cN("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$ge.wrap(y))],new $.$dN("Notebook Data",y=>v.NotebookData.to(y.value))),p=new $.$eN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new $.$cN("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new o.$Ev(v.NotebookData.from(y)))],new $.$dN("Bytes",y=>y.buffer));f.registerApiCommand(F),f.registerApiCommand(p)}}e.$xgc=d}),define(Pe[284],Ae([1,0,19,20,40,34,25,60,44]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class w{constructor(l,$,v){this.k=l,this.l=$,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Ij(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Ij(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((v,n)=>{const o=t=>{this.f++,l(t)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const r=t.toString(),a=E.$nc(r);this.j&&this.j(r,a)||this.v(o,{base:t,basename:a})}),Promise.all($.map(t=>this.p(t,o))).then(t=>{v({limitHit:this.e,stats:t[0]||void 0})},t=>{n(new Error((0,I.$Mi)(t)))})})}async p(l,$){const v=new T.$3d,n=this.q(l),o=this.r(),t=new g.$qJ(this.k,l),r=!t.hasSiblingExcludeClauses();let a;try{this.h.add(v),a=m.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,v.token),h=a.elapsed(),i=m.$Od.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(r){const d=E.$nc(s.path);this.v($,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,$)}),this.g&&!this.e)?null:(this.u(o,t,$),{providerTime:h,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const $=(0,g.$pJ)(this.k.includePattern,l.includePattern),v=(0,g.$pJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,v,n){if(v===this.a){const t=E.$nc(this.a);this.v(n,{base:$,relativePath:this.a,basename:t})}function o(t){const r=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:$,relativePath:t,basename:r})}o(v)}u({rootEntries:l,pathToEntries:$},v,n){const o=this,t=this.a;function r(a){const c=(0,g.$sJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(v.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const b=$[u];if(b)r(b);else{if(u===t)continue;o.v(n,s)}if(o.e)break}}r(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,v,n){const o=this.c(l.cacheKey),t=new w(l,$,o&&o.token);let r=0;const a=c=>{r+=c.length,v(c.map(h=>this.d(h)))};return this.e(t,R.a,a,n).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:A.$Dg(l.base,l.relativePath)}:{resource:l.base}}e(l,$,v,n){const o=n.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(r.push(a),$>0&&r.length>=$&&(v(r),r=[]))};let r=[];return l.search(t).then(a=>(r.length&&v(r),o.dispose(),a),a=>(r.length&&v(r),o.dispose(),Promise.reject(a)))}}e.$pgc=R}),define(Pe[285],Ae([1,0,18,246,34,95,28,13,19,25,12,16,2,94,180,41,15,47,105,281,44]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=void 0;let h=class{constructor(y,k,O,K,U){this.a=y,this.b=k,this.c=O,this.d=K,this.e=U}text(y,k,O={}){y=this.f(y,O);const K=this.a.getValue(),U=k&&k.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(k?.map(t.$ki),O),type:2,contentPattern:y,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:K.search.usePCRE2||U||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(y,k){const O=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const K={...y,wordSeparators:O.editor.wordSeparators};return this.j(y,k)&&(K.isCaseSensitive=!0),this.k(y)&&(K.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(K.notebookInfo||(K.notebookInfo={}),K.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),K}file(y,k={}){return{...this.h(y,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(y,k){return y?(y=Array.isArray(y)?y.map(b):b(y),k?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],k={}){const O=this.g(k.includePattern,k.expandPatterns),K=this.g(k.excludePattern,k.expandPatterns),U=y.length>1,L=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(P=>this.q(P,k,K)):y.map(P=>this.r(P,k,K,U))).filter(P=>!!P),z={_reason:k._reason,folderQueries:L,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:K.pattern,includePattern:O.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const P=E.$Hb(E.$Rb(this.c.groups.map(ge=>ge.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const Y=P.filter(ge=>(0,c.$gJ)(z,ge.fsPath)),ae=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...z,...ae}}const C=k.extraFileResources&&k.extraFileResources.filter(P=>(0,c.$gJ)(z,P.fsPath));return z.extraFileResources=C&&C.length?C:void 0,z}i(y){const k=[],O=new A.$Ac,K={};let U=!1;return y.forEach(L=>{if(L.scheme===m.Schemas.walkThrough)return;if((0,w.$Hg)(L)){const C=this.b.getWorkspaceFolder(L)?.uri??L.with({path:g.$mc(L.fsPath)});let P=O.get(C);P||(U=!0,P={folder:C,includePattern:{}},k.push(P),O.set(C,P));const Y=g.$lc(C.fsPath,L.fsPath);(0,S.$Pf)(P.includePattern)[Y.replace(/\\/g,"/")]=!0}else L.fsPath&&(U=!0,K[L.fsPath]=!0)}),{folderQueries:k,includePattern:K,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(y,k){if(k.isSmartCase){if(y.isRegExp){if(R.$vf(y.pattern,!0))return!0}else if(R.$vf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,$.$LB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const k=ae=>g.$ic(ae)||/^\.\.?([\/\\]|$)/.test(ae),K=(Array.isArray(y)?y:u(y)).map(ae=>{const ge=this.e.resolvedUserHome;return ge?(0,M.$Jv)(ae,ge.scheme===m.Schemas.file?ge.fsPath:ge.path):ae}),U=T.$K(K,ae=>k(ae)?"searchPaths":"exprSegments"),L=(U.exprSegments||[]).map(ae=>R.$Qe(ae,"/")).map(ae=>R.$Qe(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),d(ae))),z={},C=this.m(U.searchPaths||[]);C&&C.length&&(z.searchPaths=C);const P=E.$Rb(L),Y=s(...P);return Y&&(z.pattern=Y),z}l(y,k){return k.disregardExcludeSettings?void 0:(0,c.$fJ)(y,!k.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const k=y.flatMap(K=>{let{pathPortion:U,globPortion:L}=i(K);return L&&(L=f(L)),this.n(U).flatMap(C=>this.o(C,L))}),O=new Map;return k.forEach(K=>{const U=K.searchPath.toString(),L=O.get(U);L?K.pattern&&(L.pattern=L.pattern||{},L.pattern[K.pattern]=!0):O.set(U,{searchPath:K.searchPath,pattern:K.pattern?s(K.pattern):void 0})}),Array.from(O.values())}n(y){if(g.$ic(y)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==m.Schemas.file?[{searchPath:k[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(y=b(y),y.startsWith("../")||y===".."){const K=g.$gc.resolve(k.path,y);return[{searchPath:k.with({path:K})}]}const O=f(y);return[{searchPath:k,pattern:O}]}else{if(y==="./"||y===".\\")return[];{const k=y.replace(/^\.[\/\\]/,""),K=this.b.getWorkspace().folders.map(U=>{const L=k.match(new RegExp(`^${R.$Ke(U.name)}(?:/(.*)|$)`));return L?{match:L,folder:U}:null}).filter(S.$Mf);if(K.length)return K.map(U=>{const L=U.match[1];return{searchPath:U.folder.uri,pattern:L&&f(L)}});{const U=y.match(/\.[\/\\](.+)[\/\\]?/),L=U?U[1]:y,z=v.localize(0,null,L);throw new Error(z)}}}}o(y,k){const O=y.pattern&&k?`${y.pattern}/${k}`:y.pattern||k,K=[{searchPath:y.searchPath,pattern:O}];return O&&!O.endsWith("**")&&K.push({searchPath:y.searchPath,pattern:O+"/**"}),K}q(y,k,O){const K=this.r((0,t.$ki)(y.searchPath),k,O,!1);return K?{...K,includePattern:y.pattern}:null}r(y,k,O,K){let U;const L=l.URI.isUri(y)?y:y.uri;if(O.searchPaths){const ae=O.searchPaths.filter(ge=>(0,w.$wg)(ge.searchPath,L))[0];if(ae&&!ae.pattern)return null;ae&&(U=ae.pattern)}const z=this.a.getValue({resource:L}),P={...this.l(z,k)||{},...U||{}},Y=l.URI.isUri(y)?(0,w.$Ag)(y):y.name;return{folder:L,folderName:K?Y:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!z.search.followSymlinks}}};e.$qK=h,e.$qK=h=Ge([Ke(0,n.$vi),Ke(1,t.$$h),Ke(2,r.$QC),Ke(3,o.$jj),Ke(4,a.$oK)],h);function i(p){const y=p.match(/[\*\{\}\(\)\[\]\?]/);if(y){const k=y.index,O=p.substr(0,k).match(/[/|\\][^/\\]*$/);if(O){let K=p.substr(0,O.index);return K.match(/[/\\]/)||(K+="/"),{pathPortion:K,globPortion:p.substr((O.index||0)+1)}}}return{pathPortion:p}}function s(...p){return p.length?p.reduce((y,k)=>(y[k]=!0,y),Object.create(null)):void 0}function u(p){return I.$Gj(p,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(p){return[`**/${p}/**`,`**/${p}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function b(p){return p.replace(/\\/g,"/")}function f(p){return b(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(p){return p.replace(/([?*[\]])/g,"[$1]")}function F(p,y){p=E.$Mb(p,K=>K.toString());const k=[],O=y.getWorkspace();return p&&p.forEach(K=>{let U;if(y.getWorkbenchState()===2)U=(0,w.$Fg)(O.folders[0].uri,K),U&&U!=="."&&(U="./"+U);else{const L=y.getWorkspaceFolder(K);if(L){const z=L.name;if(O.folders.filter(P=>P.name===z).length===1){const P=(0,w.$Fg)(L.uri,K);P===""?U=`./${L.name}`:U=`./${L.name}/${P}`}else U=K.fsPath}}U&&k.push(D(U))}),k}e.$rK=F}),define(Pe[286],Ae([1,0,25,2,20,11,4,285,44,47]),function(me,e,E,T,I,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asb=e.$_rb=void 0;const R=7e3;function S(n,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const r=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const b=d.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||n.forceUsingSearch?a.push(b):r.push(b)}if(r.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,b)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(r.map(d=>l(n,d,i))).then(()=>{}),u=$(n,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$_rb=S;async function l(n,o,t){for(const r of n.folders)if(await n.exists(E.$Dg(T.URI.revive(r),o))){t(`workspaceContains:${o}`);return}}async function $(n,o,t,r){if(t.length===0)return Promise.resolve(void 0);const a=new I.$3d,c=n.checkExists(n.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),n.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},R);let i=!1;try{i=await c}catch(s){M.$4(s)||M.$1(s)}a.dispose(),clearTimeout(h),i&&r(`workspaceContains:${t.join(",")}`)}function v(n,o,t,r){const a=n.get(A.$1h),c=n.get(g.$0I),i=a.createInstance(m.$qK).file(o.map(s=>(0,w.$ki)(T.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,r).then(s=>!!s.limitHit,s=>M.$4(s)?!1:Promise.reject(s))}e.$asb=v}),define(Pe[38],Ae([1,0,159,19,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b,f,D,F,p,y,k,O,K,U,L,z,C,P){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc=(0,u.$2h)("IHostUtils");let ae=Y=class extends m.$Sc{constructor(X,V,ne,Ie,Me,Ce,ce,ie,Q,ee,$e,be){super(),this.X=be,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ce,this.j=Ie,this.m=Me,this.s=Ce,this.t=Q,this.u=ee,this.w=$e,this.y=this.g.getProxy(S.$MK.MainThreadWorkspace),this.z=this.g.getProxy(S.$MK.MainThreadTelemetry),this.C=this.g.getProxy(S.$MK.MainThreadExtensionService),this.D=new A.$1g,this.F=new A.$1g,this.G=new A.$1g,this.H=new A.$1g,this.I=new Se(this.f.extensions.activationEvents),this.L=new t.$e7b(this.I,this.f.extensions.allExtensions);const Le=new a.$hm(this.f.extensions.myExtensions);this.J=new t.$e7b(this.I,he(this.L,Le)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new v.$Ofc(this.g,this.s),this.N=new O.$Wfc(this.g),this.O=ie,this.h=X.createChild(new D.$Zh([v.$Pfc,this.M],[O.$Xfc,this.N])),this.P=this.B(new $.$Nfc(this.J,this.L,{onExtensionActivationError:(le,we,N)=>{this.C.$onExtensionActivationError(le,r.$3(we),N)},actualActivateExtension:async(le,we)=>{if(t.$e7b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,we),new $.$Mfc;const N=this.J.getExtensionDescription(le);return this.db(N,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){r.$1(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Me=>Me.identifier).filter(Me=>this.isActivated(Me)).map(Me=>this.cb(Me))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,A.$3g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new a.$gm(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(X,V){return this.P.activateByEvent(X,V)}$(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.$(X,V).then(()=>{const ne=this.P.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===U.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(X.fsPath);return w.URI.file(V)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new te(X))),this.Q}async bb(X){const V=g.$8h.forUris(ne=>M.$ug.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const ne=this.P.getActivatedExtension(X);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Ie)}try{(0,m.$Nc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Ie)}return V}async db(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(X,V,"success",Ie),ne},ne=>{throw this.eb(X,V,"failure"),ne})}eb(X,V,ne,Ie){const Me=ve(X,V);this.z.$publicLog2("extensionActivationTimes",{...Me,...Ie||{},outcome:ne})}fb(X,V){const ne=ve(X,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(X);if(!Ie)return Promise.resolve(new $.$Lfc($.$Ifc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Me=new $.$Jfc(V.startup);return Promise.all([this.vb(X,(0,M.$Dg)(X.extensionLocation,Ie),Me),this.gb(X)]).then(Ce=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Y.hb(this.s,X.identifier,Ce[0],Ce[1],Me))).then(Ce=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Ce))}gb(X){const V=new h.$Rfc(X,this.M),ne=new h.$Qfc(X.identifier.value,!1,this.M),Ie=new K.$Yfc(X,this.N),Me=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ie,Q;const ee=(0,o.$jF)(X,"ipc")?this.f.messagePorts?.get(a.$gm.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath($e){return T.$jc(X.extensionLocation.fsPath,$e)},get storagePath(){return ce.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return ce.O.globalValue(X).fsPath},get logPath(){return T.$jc(ce.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return w.URI.joinPath(ce.f.logsLocation,X.identifier.value)},get storageUri(){return ce.O.workspaceValue(X)},get globalStorageUri(){return ce.O.globalValue(X)},get extensionMode(){return Me},get extension(){return ie===void 0&&(ie=new de(ce,X.identifier,X,Ce,!1)),ie},get extensionRuntime(){return(0,o.$kF)(X,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!Q){if(!ee)return;const $e=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",be=>be.data));ee.start(),Q={onDidReceiveMessage:$e,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(X,V,ne,Ie,Me){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(X,V,ne,Ie,Me).then(Ce=>new $.$Kfc(!1,null,Me.build(),ne,Ce,Ie.subscriptions))}static ib(X,V,ne,Ie,Me){if(typeof ne.activate=="function")try{Me.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,ce=ne.activate.apply(Ce,[Ie]);return Me.activateCallStop(),Me.activateResolveStart(),Promise.resolve(ce).then(ie=>(Me.activateResolveStop(),ie))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(X,V){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(X,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Me=V;Me<X.length;Me+=1){const Ce=X[Me];for(const ce of Ce.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.kb(X,Me);break}else this.jb(Ce,ce)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Me of Ie.activationEvents)Me==="onStartupFinished"&&this.jb(Ie,Me)})}mb(){const X=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Me=Promise.all([Ie,X,ne]).then(()=>{});return Promise.race([Me,(0,A.$3g)(1e4)]).then(()=>{this.lb()}),Me}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(X,V))).then(()=>{})}async ob(X,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:X.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,ce,ie)=>this.y.$checkExists(Ce,ce,ie)},Me=await(0,k.$_rb)(Ie,V);if(Me)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Me.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(E.localize(0,null));const ne=await this.vb(null,V,new $.$Jfc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Me)=>{const Ce=(Q,ee)=>{Q?(C.$t&&this.s.error("Test runner called back with error",Q),Me(Q)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ce=(0,M.$rg)(V),ie=ne.run(ce,Ce);ie&&ie.then&&ie.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{C.$t&&this.s.error("Test runner finished with error",Q),Me(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.R[X]=V,(0,m.$Qc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.sb(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const V=X.indexOf("+");if(V===-1)throw new i.$UK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(X,V){const ne=z.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$7k)(X)},${V})][${ne.elapsed()}ms] `,Me=H=>this.s.info(`${Ie()}${H}`),Ce=H=>this.s.warn(`${Ie()}${H}`),ce=(H,B=void 0)=>this.s.error(`${Ie()}${H}`,B),ie=H=>{if(H instanceof i.$UK)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},Q=async H=>{Me(`activating resolver for ${H}...`);const{resolver:B,authorityPrefix:J}=await this.sb(H);if(!B)throw ce(`no resolver for ${J}`),new i.$UK(`No remote extension installed to resolve ${J}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:J,remoteAuthority:H}},ee=X.split(/@|%40/g).reverse();Me(`activating remote resolvers ${ee.join(" -> ")}`);let $e;try{$e=await Promise.all(ee.map(Q)).catch(async H=>{if(!(H instanceof i.$UK)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Ce(`resolving nested authorities failed: ${H.message}`),[await Q(X)]})}catch(H){return ie(H)}const be=new A.$ah;be.cancelAndSet(()=>Me("waiting..."),1e3);let Le,le;for(const[H,{authorityPrefix:B,resolver:J,remoteAuthority:_}]of $e.entries())try{if(H===$e.length-1)Me("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${B}`),Le=await J.resolve(_,{resolveAttempt:V,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${B}`),Me("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,i.$TK.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Me(`invoking resolveExecServer() for ${_}`),I.mark(`code/extHost/willResolveExecServer/${B}`),le=await J.resolveExecServer?.(_,{resolveAttempt:V,execServer:le}),!le)throw new i.$UK(`Exec server was not available for ${_}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(ye){return I.mark(`code/extHost/didResolveAuthorityError/${B}`),ce("returned an error",ye),be.dispose(),ie(ye)}be.dispose();const we={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures},N={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Me(`returned ${i.$TK.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let q;if(i.$TK.isManagedResolvedAuthority(Le)){const H=V;this.X.setFactory(H,Le.makeConnection),q={authority:X,connectTo:new s.$4k(H),connectionToken:Le.connectionToken}}else q={authority:X,connectTo:new s.$5k(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:q,options:N,tunnelInformation:we}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$7k)(X)})`);const{resolver:ne}=await this.sb(X);if(!ne)return null;const Ie=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Me=await(0,A.$Ug)(()=>ne.getCanonicalURI(Ie));return Me||Ie}$startExtensionHost(X){X.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ge(this.I,this.L,this.J,X);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(X,V){return V===1?this.D.wait().then(ne=>this.Z(X,!1)):this.G.wait().then(ne=>this.Z(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ge(this.I,this.L,this.J,X),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=c.$ge.alloc(X),ne=Math.random()%256;for(let Ie=0;Ie<X;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$5fc=ae,e.$5fc=ae=Y=Ge([Ke(0,u.$1h),Ke(1,e.$4fc),Ke(2,f.$QM),Ke(3,n.$rfc),Ke(4,l.$ufc),Ke(5,R.$jj),Ke(6,d.$7M),Ke(7,b.$xfc),Ke(8,F.$9xb),Ke(9,p.$Sfc),Ke(10,L.$1fc),Ke(11,P.$2fc)],ae);function ge(oe,X,V,ne){oe.addActivationEvents(ne.addActivationEvents);const Ie=new t.$e7b(oe,X.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Me=new a.$hm(V.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Me.delete(ce);for(const ce of ne.myToAdd)Me.add(ce);const Ce=he(Ie,Me);return{globalRegistry:Ie,myExtensions:Ce}}function ve(oe,X){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function De(oe){return oe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$6fc=(0,u.$2h)("IExtHostExtensionService");class de{#e;#t;#i;constructor(X,V,ne,Ie,Me){this.#e=X,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,M.$rg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Me}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$7fc=de;function he(oe,X){return oe.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class te{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$8fc=te;class Se{constructor(X){this.a=new a.$im,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Pe[287],Ae([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;let n=class{constructor(c,h,i,s,u,d,b){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$dhc=n,e.$dhc=n=Ge([Ke(2,R.$1h),Ke(3,M.$ufc),Ke(4,S.$6fc),Ke(5,w.$7M),Ke(6,l.$jj)],n);let o=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&v.a.size){const h=(0,$.$Ke)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=v.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=v=Ge([Ke(0,w.$7M)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new m.$im}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$eF,this.e,this.f)}return this.b}}let r=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$MK.MainThreadTelemetry);const s=i.getProxy(I.$MK.MainThreadWindow);this.c=(u,d)=>{const b=T.URI.parse(u);return d?this.g(u,d):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,u,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ge([Ke(2,g.$QM)],r)}),define(Pe[116],Ae([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0,e.$9fc=(0,A.$2h)("IExtHostVariableResolverProvider");class v extends l.$RN{constructor(t,r,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const b=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof R.$vM||b.input instanceof R.$AM)return b.input.modified;if(b.input instanceof R.$uM||b.input instanceof R.$zM||b.input instanceof R.$xM)return b.input.uri}}}super({getFolderUri:d=>{const b=i.folders.filter(f=>f.name===d);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,b)=>h.getConfiguration(void 0,d).get(b),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=u();if(d){const b=r.getWorkspaceFolder(d);if(b)return I.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let n=class extends T.$Sc{constructor(t,r,a,c,h){super(),this.b=t,this.c=r,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$0fc=n,e.$0fc=n=Ge([Ke(0,w.$6fc),Ke(1,S.$rfc),Ke(2,m.$2M),Ke(3,$.$ufc),Ke(4,g.$Gfc)],n)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.$_fc=e.$$fc=void 0,e.$$fc=(0,M.$2h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,b,f,D){this.E=u,this.F=d,this.G=b,this.H=f,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=s.getProxy(A.$MK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(F=>{F.onDidChange(p=>{this.J(F)}),this.J(F)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let b=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(b+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),b+=`${f}ref=${d.sourceReference}`,I.URI.parse(b)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const b=d.contributes.debuggers;if(b&&b.length>0)for(const f of b)(0,$.$VF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const D=f.id;return this.w.has(D)?!1:(this.w.set(D,f),!0)});this.U(u,[],[]);const d=[],b=new Map;for(const f of u)if(f instanceof R.$OL){let D=b.get(f.location.uri.toString());D||(D={type:"sourceMulti",uri:f.location.uri,lines:[]},b.set(f.location.uri.toString(),D),d.push(D)),D.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof R.$PL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(D=>this.w.delete(D.id));this.U([],u,[]);const d=u.filter(D=>D instanceof R.$OL).map(D=>D.id),b=u.filter(D=>D instanceof R.$PL).map(D=>D.id),f=u.filter(D=>D instanceof R.$QL).map(D=>D.id);return this.k.$unregisterBreakpoints(d,b,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new R.$OK(()=>{});const b=this.d++;return this.f.push({type:s,handle:b,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,b),new R.$OK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new R.$OK(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:u,handle:b,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,b),new R.$OK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new R.$OK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new R.$OK(()=>{this.j=this.j.filter(b=>b.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const b=await this.W(s);return b&&(d={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,b=await this.V(u);return this.S(this.N(b.type),b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const D=this.M(f),F=this.K(D,b);if(!F)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const p=F;return this.B.set(s,p),this.R(b).then(y=>(y&&this.C.set(s,y),p.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const O=k,K={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const U=await this.D.sign(O.arguments.value);K.body={signature:U},p.sendResponse(K)}else throw new Error("no signer")}catch(U){K.success=!1,K.message=U.message,p.sendResponse(K)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(k),k=(0,$.$1F)(k,!0),d.k.$acceptDAMessage(s,k)}),p.onError(k=>{y&&y.onError&&y.onError(k),this.k.$acceptDAError(s,k.name,k.message,k.stack)}),p.onExit(k=>{y&&y.onExit&&y.onExit(k??void 0,void 0),this.k.$acceptDAExit(s,k??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),p.startSession()))})}$sendDAMessage(s,u){u=(0,$.$ZF)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],b=[];if(s.added)for(const f of s.added){const D=f.id;if(D&&!this.w.has(D)){let F;if(f.type==="function")F=new R.$PL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")F=new R.$QL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const p=I.URI.revive(f.uri);F=new R.$OL(new R.$1K(p,new R.$PK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,R.$ML)(F,D),this.w.set(D,F),u.push(F)}}if(s.removed)for(const f of s.removed){const D=this.w.get(f);D&&(this.w.delete(f),d.push(D))}if(s.changed){for(const f of s.changed)if(f.id){const D=this.w.get(f.id);if(D){if(D instanceof R.$PL&&f.type==="function"){const F=D;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.functionName=f.functionName}else if(D instanceof R.$OL&&f.type==="source"){const F=D;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.location=new R.$1K(I.URI.revive(f.uri),new R.$PK(f.line,f.character))}b.push(D)}}}this.U(u,d,b)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new R.$WL(d,s.threadId):u=new R.$VL(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Ug)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return b.provideDebugConfigurations(f,d)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,u,d,b){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(u);return f.resolveDebugConfiguration(D,d,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,b){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(D,d,b)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(u);return this.S(d,b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const b={session:await this.V(s),event:u.event,body:u.body};this.u.fire(b)}M(s){if(s instanceof R.$RL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof R.$SL)return{type:"server",port:s.port,host:s.host};if(s instanceof R.$TL)return{type:"pipeServer",path:s.path};if(s instanceof R.$UL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const b of d)if(b.label&&b.type&&b.type===u)return!0}}return!1}R(s){const d=s.configuration.type,b=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Ug)(()=>f.factory.createDebugAdapterTracker(s)).then(D=>D,D=>null));return Promise.race([Promise.all(b).then(f=>{const D=f.filter(F=>!!F);if(D.length>0)return new a(D)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new R.$SL(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Ug)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(D=>{if(D)return D})}const b=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,b))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),b=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,b),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$_fc=o,e.$_fc=o=Ge([Ke(0,w.$QM),Ke(1,S.$rfc),Ke(2,g.$6fc),Ke(3,v.$ufc),Ke(4,m.$Gfc),Ke(5,n.$9fc)],o);class t{constructor(s,u,d,b,f,D,F){this.d=s,this.f=u,this.g=d,this.h=b,this.i=f,this.j=D,this.k=F}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$agc=t;class r{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$bgc=r;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$qlb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,b,f,D){super(s,u,d,b,f,D)}};e.$cgc=h,e.$cgc=h=Ge([Ke(0,w.$QM),Ke(1,S.$rfc),Ke(2,g.$6fc),Ke(3,v.$ufc),Ke(4,m.$Gfc),Ke(5,n.$9fc)],h)}),define(Pe[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get(m.$jj),i=a.get(l.$QM).getProxy(M.$MK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get(m.$jj),h=a.get(l.$QM),i=a.get(v.$6fc),s=a.get(n.$$M),u=h.getProxy(M.$MK.MainThreadExtensionService),d=h.getProxy(M.$MK.MainThreadErrors),b=await i.getExtensionPathIndex(),f=new WeakMap;function D(y,k){if(f.has(y))return f.get(y).stack;let O="",K,U;for(const z of k)O+=`
	at ${z.toString()}`,U=z.getFileName(),!K&&U&&(K=b.findSubstr(I.URI.file(U)));const L=`${y.name||"Error"}: ${y.message||""}${O}`;return f.set(y,{extensionIdentifier:K?.identifier,stack:L}),L}const F=Symbol("prepareStackTrace wrapped");let p=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(y){if(y===D||!y||y[F]){p=y||D;return}p=function(k,O){return D(k,O),y.call(Error,k,O)},Object.assign(p,{[F]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const k=E.$3(y),O=f.get(y);if(!O?.extensionIdentifier){d.$onUnexpectedError(k);return}u.$onExtensionRuntimeError(O.extensionIdentifier,k);const K=s.onExtensionError(O.extensionIdentifier,y);c.trace("forwarded error to extension?",K,O)})}}e.$ehc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new A.$m7b(a,null,i),c=t.e(c,this.b);const u=new w.$Zh(...(0,g.$Kr)());u.set(R.$7M,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$QM,new l.$RM(this.b)),u.set($.$ofc,new $.$pfc(i)),u.set(v.$4fc,h);const d=new S.$qq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(b=>b.get(m.$jj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(b=>b.get(v.$6fc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(M.$MK.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=I.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$fhc=t}),define(Pe[289],Ae([1,0,18,14,20,40,13,19,25,2,44]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=e.$qgc=void 0;class S{constructor(r,a,c,h){this.d=r,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,a){const c=this.d.folderQueries||[],h=new I.$3d(a);return new Promise((i,s)=>{this.a=new $(r);let u=!1;const d=(b,f)=>{if(!u&&!this.b){const D=this.h(b);n(b)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),b=this.j(b,this.d.maxResults-this.c));const F=this.h(b);this.c+=F,(F>0||!n(b))&&this.a.add(b,f)}};Promise.all(c.map((b,f)=>this.k(b,D=>d(D,f),h.token))).then(b=>{h.dispose(),this.a.flush();const f=b.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(b.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},b=>{h.dispose();const f=(0,M.$Mi)(b);s(new Error(f))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,a){const c=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:r.preview.text},uri:r.uri}}async k(r,a,c){const h=new R.$qJ(this.d,r),i=[],s={report:b=>{if(!this.l(b))return;const f=r.folder.scheme===A.Schemas.file?(0,R.$rJ)(()=>this.f.readdir(g.$Cg(b.uri))):void 0,D=g.$Fg(r.folder,b.uri);if(D){const F=h.includedInQuery(D,m.$nc(D),f);(0,T.$Og)(F)?i.push(F.then(p=>{p&&a(b)})):F&&a(b)}}},u=this.n(r),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const a=(0,R.$pJ)(this.d.includePattern,r.includePattern),c=(0,R.$pJ)(this.d.excludePattern,r.excludePattern),h={folder:w.URI.from(r.folder),excludes:c,includes:a,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$qgc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class ${constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(r,a){this.d&&(this.b!==a||!g.$wg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$rgc=$;function v(t){return n(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function n(t){return!!t.preview}e.$sgc=n;class o{static{this.a=4e3}static{this.b=50}constructor(r,a){this.g=r,this.h=a,this.c=0,this.d=[],this.e=0}addItem(r,a){r&&this.j(r,a)}addItems(r,a){r&&this.k(r,a)}j(r,a){this.d.push(r),this.e+=a,this.l()}k(r,a){this.d=this.d.concat(r),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$tgc=o}),define(Pe[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=e.$ugc=void 0,e.$ugc=(0,I.$2h)("IExtHostSearch");let S=class{constructor(n,o,t){this.k=n,this.l=o,this.n=t,this.c=this.k.getProxy(T.$MK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$pgc}o(n){return this.l.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(n)),(0,E.$Qc)(()=>{this.g.delete(n),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(n,o){if(this.i.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.i.add(n);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(n)),(0,E.$Qc)(()=>{this.i.delete(n),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,r){const a=l(t),c=this.h.get(n);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(n,o,h.map(i=>i.resource))},r);throw new Error("unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,t){return{messages:[]}}$clearCache(n){return this.j.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,t,r){const a=this.e.get(n);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(n,o,i),r)}$enableExtensionHostSearch(){}q(n,o){return new R.$qgc(n,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$vgc=S,e.$vgc=S=Ge([Ke(0,A.$QM),Ke(1,m.$ofc),Ke(2,g.$jj)],S);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map($),extraFileResources:v.extraFileResources&&v.extraFileResources.map(n=>w.URI.revive(n))}}e.$wgc=l;function $(v){return{...v,folder:w.URI.revive(v.folder)}}}),define(Pe[290],Ae([1,0,20,11,5,6,13,31,2,146,142,130,93,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b,f,D,F,p,y,k,O,K,U,L,z,C,P,Y,ae,ge,ve,De,de,he,te,Se,oe,X,V,ne,Ie,Me,Ce,ce,ie,Q,ee,$e,be,Le,le,we,N,q,H,B,J,_,ye,Te,We,He,Ye,rt,it,et,ot,at,ze,pt,Z,x,pe,Ue,Qe,tt,nt,Ne,It,Lt,Kt,Bt,wt,qt,Ft,Qt,Ot,Ct,Xe,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;function Gt(ut){const mt=ut.get(X.$7M),jt=ut.get(oe.$9ec),Ut=ut.get(te.$wfc),Et=ut.get(de.$6fc),ht=ut.get(Qt.$rfc),Pt=ut.get(ze.$$M),Xt=ut.get(O.$ufc),kt=ut.get(Lt.$ofc),qe=ut.get(ye.$QM),Rt=ut.get(et.$Pfc),Wt=ut.get(ot.$xfc),Jt=ut.get(n.$kj),ft=ut.get(n.$jj),Mt=ut.get(tt.$9xb),Ee=ut.get(i.$_ec),Fe=ut.get(Ft.$$gc),fe=ut.get(He.$Xfc),G=ut.get(ve.$Gfc),Re=ut.get(Q.$2fc);qe.set(a.$NK.ExtHostFileSystemInfo,jt),qe.set(a.$NK.ExtHostLogLevelServiceShape,Jt),qe.set(a.$NK.ExtHostWorkspace,ht),qe.set(a.$NK.ExtHostConfiguration,Xt),qe.set(a.$NK.ExtHostExtensionService,Et),qe.set(a.$NK.ExtHostStorage,Rt),qe.set(a.$NK.ExtHostTunnelService,Mt),qe.set(a.$NK.ExtHostWindow,Fe),qe.set(a.$NK.ExtHostSecretState,fe),qe.set(a.$NK.ExtHostTelemetry,Pt),qe.set(a.$NK.ExtHostEditorTabs,G),qe.set(a.$NK.ExtHostManagedSockets,Re);const Be=qe.set(a.$NK.ExtHostDecorations,ut.get(L.$egc)),Ze=qe.set(a.$NK.ExtHostDocumentsAndEditors,ut.get(ge.$2M)),Ve=qe.set(a.$NK.ExtHostCommands,ut.get(y.$aN)),_e=qe.set(a.$NK.ExtHostTerminalService,ut.get(pt.$Sfc)),gt=qe.set(a.$NK.ExtHostDebugService,ut.get(U.$$fc)),zt=qe.set(a.$NK.ExtHostSearch,ut.get(We.$ugc)),yt=qe.set(a.$NK.ExtHostTask,ut.get(at.$Xgc)),Dt=qe.set(a.$NK.ExtHostOutputService,ut.get(q.$Kgc)),bt=qe.set(a.$NK.ExtHostLocalization,ut.get(ie.$1fc)),mi=qe.set(a.$NK.ExtHostUrls,new Kt.$8gc(qe)),At=qe.set(a.$NK.ExtHostDocuments,new ae.$7ec(qe,Ze)),Di=qe.set(a.$NK.ExtHostDocumentContentProviders,new P.$ggc(qe,Ze,ft)),Vi=qe.set(a.$NK.ExtHostDocumentSaveParticipant,new Y.$hgc(ft,At,qe.getProxy(a.$MK.MainThreadBulkEdits))),St=qe.set(a.$NK.ExtHostNotebook,new $e.$xgc(qe,Ve,Ze,At,Ut,zt)),ni=qe.set(a.$NK.ExtHostNotebookDocuments,new Le.$Egc(St)),$i=qe.set(a.$NK.ExtHostNotebookEditors,new le.$Fgc(ft,St)),ai=qe.set(a.$NK.ExtHostNotebookKernels,new we.$Ggc(qe,mt,St,Ve,ft)),Si=qe.set(a.$NK.ExtHostNotebookRenderers,new N.$Igc(qe,St)),Ii=qe.set(a.$NK.ExtHostNotebookDocumentSaveParticipant,new be.$Dgc(ft,St,qe.getProxy(a.$MK.MainThreadBulkEdits))),Tt=qe.set(a.$NK.ExtHostEditors,new x.$lfc(qe,Ze)),pi=qe.set(a.$NK.ExtHostTreeViews,new Qe.$6gc(qe.getProxy(a.$MK.MainThreadTreeViews),Ve,ft)),Ci=qe.set(a.$NK.ExtHostEditorInsets,new p.$mfc(qe.getProxy(a.$MK.MainThreadEditorInsets),Tt,mt.remote)),ci=qe.set(a.$NK.ExtHostDiagnostics,new z.$$ec(qe,ft,jt,Ze)),ui=qe.set(a.$NK.ExtHostLanguages,new ce.$Bgc(qe,At,Ve.converter,kt)),lt=qe.set(a.$NK.ExtHostLanguageFeatures,new Ce.$cfc(qe,kt,At,Ve,ci,ft,Ee,Pt)),qi=qe.set(a.$NK.ExtHostFileSystem,new he.$jgc(qe,lt)),xt=qe.set(a.$NK.ExtHostFileSystemEventService,new Se.$kgc(qe,ft,Ze)),ri=qe.set(a.$NK.ExtHostQuickOpen,(0,_.$Ogc)(qe,ht,Ve)),di=qe.set(a.$NK.ExtHostSCM,new Te.$Qgc(qe,Ve,At,ft)),Pi=qe.set(a.$NK.ExtHostQuickDiff,new J.$Ngc(qe,kt)),Ki=qe.set(a.$NK.ExtHostShare,new Ye.$Rgc(qe,kt)),Ai=qe.set(a.$NK.ExtHostComments,(0,k.$nfc)(qe,Ve,At)),vi=qe.set(a.$NK.ExtHostProgress,new B.$Mgc(qe.getProxy(a.$MK.MainThreadProgress))),Hi=qe.set(a.$NK.ExtHosLabelService,new Me.$Agc(qe)),Ri=qe.set(a.$NK.ExtHostTheming,new pe.$3gc(qe)),li=qe.set(a.$NK.ExtHostAuthentication,new s.$efc(qe)),Gi=qe.set(a.$NK.ExtHostTimeline,new Ue.$5gc(qe,Ve)),bi=qe.set(a.$NK.ExtHostWebviews,new Bt.$Bfc(qe,mt.remote,ht,ft,Ee)),Mi=qe.set(a.$NK.ExtHostWebviewPanels,new wt.$Efc(qe,bi,ht)),cn=qe.set(a.$NK.ExtHostCustomEditors,new K.$Ffc(qe,At,Wt,bi,Mi)),Li=qe.set(a.$NK.ExtHostWebviewViews,new qt.$9gc(qe,bi)),si=qe.set(a.$NK.ExtHostTesting,new Z.$Ygc(qe,Ve,Ze)),un=qe.set(a.$NK.ExtHostUriOpeners,new It.$7gc(qe)),ln=qe.set(a.$NK.ExtHostProfileContentHandlers,new H.$Lgc(qe));qe.set(a.$NK.ExtHostInteractive,new ne.$ygc(qe,St,Ze,Ve,ft));const Ji=qe.set(a.$NK.ExtHostInlineChat,new V.$lgc(qe,Ve,At,ft)),fi=qe.set(a.$NK.ExtHostChatProvider,new f.$hfc(qe,ft)),Qi=qe.set(a.$NK.ExtHostChatAgents2,new b.$ifc(qe,fi,ft)),Zi=qe.set(a.$NK.ExtHostChatVariables,new D.$jfc(qe)),gi=qe.set(a.$NK.ExtHostChat,new d.$gfc(qe)),Yi=qe.set(a.$NK.ExtHostAiRelatedInformation,new c.$6ec(qe)),Fi=qe.set(a.$NK.ExtHostAiEmbeddingVector,new De.$igc(qe)),Ti=qe.set(a.$NK.ExtHostIssueReporter,new Ie.$zgc(qe)),_t=qe.set(a.$NK.ExtHostStatusBar,new it.$Ugc(qe,Ve.converter)),wi=qe.set(a.$NK.ExtHostSpeech,new rt.$Sgc(qe)),hn=Object.values(a.$NK);qe.assertRegistered(hn);const Zt=new u.$ffc(qe,Ze),yi=new F.$kfc(qe),Ei=new ee.$Cgc(qe,ft),Ni=new C.$fgc(qe);return h.$dfc.register(Ve),function(je,ei,Xi){const $t=function(){let re=!je.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ue();else{const vt=st;typeof vt.scheme>"u"&&ue(),typeof vt.exclusive=="boolean"&&(0,Xe.$kF)(je,"documentFiltersExclusive")}return st}}(),xi={getSession(re,ue,Oe){return li.getSession(je,re,ue,Oe)},getSessions(re,ue){return(0,Xe.$kF)(je,"authGetSessions"),li.getSessions(je,re,ue)},async hasSession(re,ue){return(0,Xe.$kF)(je,"authSession"),!!await li.getSession(je,re,ue,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(re,ue,Oe,st){return li.registerAuthenticationProvider(re,ue,Oe,st)}},dn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,je)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...st)=>{const vt=Tt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return vt.edit(Nt=>{ue.apply(Oe,[vt,Nt,...st])}).then(Nt=>{Nt||ft.warn("Edits from command "+re+" were not applied.")},Nt=>{ft.warn("An error occurred while running command "+re,Nt)})},void 0,void 0,je)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Xe.$kF)(je,"diffCommand"),Ve.registerCommand(!0,re,async(...st)=>{const vt=Ze.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Nt=await Tt.getDiffInformation(vt.id);ue.apply(Oe,[Nt,...st])},void 0,void 0,je)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},_i={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return _e.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.$kF)(je,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$kF)(je,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ze.$0M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return ze.$9M.validateSender(re),Pt.instantiateLogger(je,re,ue)},openExternal(re,ue){return Fe.openUri(re,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===mt.environment.appUriScheme)return mi.createAppUri(re);try{return await Fe.asExternalUri(re,{allowTunneling:!!mt.remote.authority})}catch(ue){if((0,A.$ag)(re,A.Schemas.http)||(0,A.$ag)(re,A.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$9k)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$kF)(je,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,Xe.$kF)(je,"handleIssueUri"),Ti.registerIssueUriRequestHandler(je,re)},registerIssueDataProvider(re){return(0,Xe.$kF)(je,"handleIssueUri"),Ti.registerIssueDataProvider(je,re)},get appQuality(){return(0,Xe.$kF)(je,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$kF)(je,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(re,ue,Oe){return si.createTestController(je,re,ue,Oe)},createTestObserver(){return(0,Xe.$kF)(je,"testObserver"),si.createTestObserver()},runTests(re){return(0,Xe.$kF)(je,"testObserver"),si.runTests(re)},get onDidChangeTestResults(){return(0,Xe.$kF)(je,"testObserver"),si.onResultsChanged},get testResults(){return(0,Xe.$kF)(je,"testObserver"),si.results}},hi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,ue){(0,Xe.$jF)(je,"extensionsAny")||(ue=!1);const Oe=ei.mine.getExtensionDescription(re);if(Oe)return new de.$7fc(Et,je.identifier,Oe,hi,!1);if(ue){const st=ei.all.getExtensionDescription(re);if(st)return new de.$7fc(Et,je.identifier,st,hi,!0)}},get all(){const re=[];for(const ue of ei.mine.getAllExtensionDescriptions())re.push(new de.$7fc(Et,je.identifier,ue,hi,!1));return re},get allAcrossExtensionHosts(){(0,Xe.$kF)(je,"extensionsAny");const re=new $.$hm(ei.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ei.all.getAllExtensionDescriptions()){const st=!re.has(Oe.identifier);ue.push(new de.$7fc(Et,je.identifier,Oe,hi,st))}return ue},get onDidChange(){return(0,Xe.$jF)(je,"extensionsAny")?I.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(re){return ci.createDiagnosticCollection(je.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(re,ue){return ui.changeLanguage(re.uri,ue)},match(re,ue){const Oe=At.getDocumentData(ue.uri)?.notebook;return(0,R.$nt)(nt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return lt.registerCodeActionProvider(je,$t(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Xe.$kF)(je,"documentPaste"),lt.registerDocumentPasteEditProvider(je,$t(re),ue,Oe)},registerCodeLensProvider(re,ue){return lt.registerCodeLensProvider(je,$t(re),ue)},registerDefinitionProvider(re,ue){return lt.registerDefinitionProvider(je,$t(re),ue)},registerDeclarationProvider(re,ue){return lt.registerDeclarationProvider(je,$t(re),ue)},registerImplementationProvider(re,ue){return lt.registerImplementationProvider(je,$t(re),ue)},registerTypeDefinitionProvider(re,ue){return lt.registerTypeDefinitionProvider(je,$t(re),ue)},registerHoverProvider(re,ue){return lt.registerHoverProvider(je,$t(re),ue,je.identifier)},registerEvaluatableExpressionProvider(re,ue){return lt.registerEvaluatableExpressionProvider(je,$t(re),ue,je.identifier)},registerInlineValuesProvider(re,ue){return lt.registerInlineValuesProvider(je,$t(re),ue,je.identifier)},registerDocumentHighlightProvider(re,ue){return lt.registerDocumentHighlightProvider(je,$t(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return lt.registerMultiDocumentHighlightProvider(je,$t(re),ue)},registerLinkedEditingRangeProvider(re,ue){return lt.registerLinkedEditingRangeProvider(je,$t(re),ue)},registerReferenceProvider(re,ue){return lt.registerReferenceProvider(je,$t(re),ue)},registerRenameProvider(re,ue){return lt.registerRenameProvider(je,$t(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return lt.registerDocumentSymbolProvider(je,$t(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(je,re)},registerDocumentFormattingEditProvider(re,ue){return lt.registerDocumentFormattingEditProvider(je,$t(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return lt.registerDocumentRangeFormattingEditProvider(je,$t(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...st){return lt.registerOnTypeFormattingEditProvider(je,$t(re),ue,[Oe].concat(st))},registerDocumentSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentSemanticTokensProvider(je,$t(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentRangeSemanticTokensProvider(je,$t(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(je,$t(re),ue,Oe):lt.registerSignatureHelpProvider(je,$t(re),ue,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(re,ue,...Oe){return lt.registerCompletionItemProvider(je,$t(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Xe.$kF)(je,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$kF)(je,"inlineCompletionsAdditions"),Oe&&(0,Xe.$kF)(je,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(je,$t(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return lt.registerDocumentLinkProvider(je,$t(re),ue)},registerColorProvider(re,ue){return lt.registerColorProvider(je,$t(re),ue)},registerFoldingRangeProvider(re,ue){return lt.registerFoldingRangeProvider(je,$t(re),ue)},registerSelectionRangeProvider(re,ue){return lt.registerSelectionRangeProvider(je,re,ue)},registerCallHierarchyProvider(re,ue){return lt.registerCallHierarchyProvider(je,re,ue)},registerTypeHierarchyProvider(re,ue){return lt.registerTypeHierarchyProvider(je,re,ue)},setLanguageConfiguration:(re,ue)=>lt.setLanguageConfiguration(je,re,ue),getTokenInformationAtPosition(re,ue){return(0,Xe.$kF)(je,"tokenInformation"),ui.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return lt.registerInlayHintsProvider(je,re,ue)},createLanguageStatusItem(re,ue){return ui.createLanguageStatusItem(je,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return lt.registerDocumentOnDropEditProvider(je,re,ue,(0,Xe.$jF)(je,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const st=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Tt.showTextDocument(st,ue,Oe)},createTextEditorDecorationType(re){return Tt.createTextEditorDecorationType(je,re)},onDidChangeActiveTextEditor(re,ue,Oe){return Tt.onDidChangeActiveTextEditor(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return Tt.onDidChangeVisibleTextEditors(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return Tt.onDidChangeTextEditorSelection(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return Tt.onDidChangeTextEditorOptions(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return Tt.onDidChangeTextEditorVisibleRanges(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return Tt.onDidChangeTextEditorViewColumn(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return _e.onDidCloseTerminal(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return _e.onDidOpenTerminal(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return _e.onDidChangeActiveTerminal(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Xe.$kF)(je,"terminalDimensions"),_e.onDidChangeTerminalDimensions(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return _e.onDidChangeTerminalState(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Xe.$kF)(je,"terminalDataWriteEvent"),_e.onDidWriteTerminalData(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Xe.$kF)(je,"terminalExecuteCommandEvent"),_e.onDidExecuteTerminalCommand(re,ue,Oe)},get state(){return Fe.getState(je)},onDidChangeWindowState(re,ue,Oe){return Fe.onDidChangeWindowState(re,ue,Oe)},showInformationMessage(re,...ue){return Ei.showMessage(je,m.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Ei.showMessage(je,m.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Ei.showMessage(je,m.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return ri.showQuickPick(je,re,ue,Oe)},showWorkspaceFolderPick(re){return ri.showWorkspaceFolderPick(re)},showInputBox(re,ue){return ri.showInput(re,ue)},showOpenDialog(re){return Ni.showOpenDialog(je,re)},showSaveDialog(re){return Ni.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let st,vt,Nt;return typeof re=="string"?(st=re,vt=ue,Nt=Oe):(vt=re,Nt=ue),_t.createStatusBarEntry(je,st,vt,Nt)},setStatusBarMessage(re,ue){return _t.setStatusBarMessage(re,ue)},withScmProgress(re){return Ee.report("window.withScmProgress",je,"Use 'withProgress' instead."),vi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(st){}}))},withProgress(re,ue){return vi.withProgress(je,re,ue)},createOutputChannel(re,ue){return Dt.createOutputChannel(re,ue,je)},createWebviewPanel(re,ue,Oe,st){return Mi.createWebviewPanel(je,re,ue,Oe,st)},createWebviewTextEditorInset(re,ue,Oe,st){return(0,Xe.$kF)(je,"editorInsets"),Ci.createWebviewEditorInset(re,ue,Oe,st,je)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(je,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Xe.$kF)(je,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,je.identifier.value,ue)},registerTreeDataProvider(re,ue){return pi.registerTreeDataProvider(re,ue,je)},createTreeView(re,ue){return pi.createTreeView(re,ue,je)},registerWebviewPanelSerializer:(re,ue)=>Mi.registerWebviewPanelSerializer(je,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>cn.registerCustomEditorProvider(je,re,ue,Oe),registerFileDecorationProvider(re){return Be.registerFileDecorationProvider(re,je)},registerUriHandler(re){return mi.registerUriHandler(je,re)},createQuickPick(){return ri.createQuickPick(je)},createInputBox(){return ri.createInputBox(je)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return Ri.onDidChangeActiveColorTheme(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Li.registerWebviewViewProvider(je,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return St.onDidChangeActiveNotebookEditor(re,ue,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ue,Oe){return $i.onDidChangeNotebookEditorSelection(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(re,ue,Oe)},showNotebookDocument(re,ue){return St.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Xe.$kF)(je,"externalUriOpener"),un.registerExternalUriOpener(je.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Xe.$kF)(je,"profileContentHandlers"),ln.registrProfileContentHandler(je,re,ue)},registerQuickDiffProvider(re,ue,Oe,st){return(0,Xe.$kF)(je,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(re),ue,Oe,st)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Xe.$kF)(je,"shareProvider"),Ki.registerShareProvider($t(re),ue)}},sn={get rootPath(){return Ee.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw new T.$9("rootPath")},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw new T.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>ht.updateWorkspaceFolders(je,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return ht.onDidChangeWorkspace(re,ue,Oe)},asRelativePath:(re,ue)=>ht.getRelativePath(re,ue),findFiles:(re,ue,Oe,st)=>ht.findFiles(re,ue,Oe,je.identifier,st),findTextInFiles:(re,ue,Oe,st)=>{(0,Xe.$kF)(je,"findTextInFiles");let vt,Nt;return typeof ue=="object"?(vt=ue,Nt=Oe):(vt={},Nt=ue,st=Oe),ht.findTextInFiles(re,vt||{},Nt,je.identifier,st)},save:re=>((0,Xe.$kF)(je,"saveEditor"),ht.save(re)),saveAs:re=>((0,Xe.$kF)(je,"saveEditor"),ht.saveAs(re)),saveAll:re=>ht.saveAll(re),applyEdit(re,ue){return Zt.applyWorkspaceEdit(re,je,ue)},createFileSystemWatcher:(re,ue,Oe,st)=>{let vt;return typeof ue=="boolean"?vt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st,correlate:!1}:ue&&((0,Xe.$kF)(je,"createFileSystemWatcher"),vt={...ue,correlate:!0}),xt.createFileSystemWatcher(ht,je,re,vt)},get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new T.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=At.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>At.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(re,ue,Oe)=>At.onDidAddDocument(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>At.onDidRemoveDocument(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>At.onDidChangeDocument(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>At.onDidSaveDocument(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>Vi.getOnWillSaveTextDocumentEvent(je)(re,ue,Oe),get notebookDocuments(){return St.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await St.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await St.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return ni.onDidSaveNotebookDocument(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return ni.onDidChangeNotebookDocument(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(je)(re,ue,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(re,ue,Oe,st){return St.registerNotebookSerializer(je,re,ue,Oe,(0,Xe.$jF)(je,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>Xi.onDidChangeConfiguration(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,Xi.getConfiguration(re,ue,je)},registerTextDocumentContentProvider(re,ue){return Di.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Ee.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(je,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,M.$Pc)(qi.registerFileSystemProvider(je,re,ue,Oe),Ut.addFileSystemProvider(re,ue,Oe))},get fs(){return Ut.value},registerFileSearchProvider:(re,ue)=>((0,Xe.$kF)(je,"fileSearchProvider"),zt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Xe.$kF)(je,"textSearchProvider"),zt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Xe.$kF)(je,"resolvers"),Et.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Xe.$kF)(je,"resolvers"),Hi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Xe.$kF)(je,"resolvers"),Et.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>xt.onDidCreateFile(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>xt.onDidDeleteFile(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>xt.onDidRenameFile(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>xt.getOnWillCreateFileEvent(je)(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>xt.getOnWillDeleteFileEvent(je)(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>xt.getOnWillRenameFileEvent(je)(re,ue,Oe),openTunnel:re=>((0,Xe.$kF)(je,"tunnels"),Mt.openTunnel(je,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Xe.$kF)(je,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Xe.$kF)(je,"tunnels"),Mt.onDidChangeTunnels(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Xe.$kF)(je,"portsAttributes"),Mt.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Xe.$kF)(je,"tunnelFactory"),Mt.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Xe.$kF)(je,"timeline"),Gi.registerTimelineProvider(re,ue,je.identifier,Ve.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Xe.$kF)(je,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>ht.onDidGrantWorkspaceTrust(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Xe.$kF)(je,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Xe.$kF)(je,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(je)(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Xe.$kF)(je,"canonicalUriProvider"),ht.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Xe.$kF)(je,"canonicalUriProvider"),ht.provideCanonicalUri(re,ue,Oe))},fn={get inputBox(){return Ee.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(je)},createSourceControl(re,ue,Oe){return di.createSourceControl(je,re,ue,Oe)},registerSourceControlInputBoxValueProvider(re,ue){return(0,Xe.$kF)(je,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(je,re,ue)}},on={createCommentController(re,ue){return Ai.createCommentController(je,re,ue)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return gt.onDidStartDebugSession(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return gt.onDidTerminateDebugSession(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return gt.onDidChangeActiveDebugSession(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return gt.onDidReceiveDebugSessionCustomEvent(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return gt.onDidChangeBreakpoints(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Xe.$kF)(je,"debugFocus"),gt.onDidChangeStackFrameFocus(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return gt.registerDebugConfigurationProvider(re,ue,Oe||Ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return gt.registerDebugAdapterDescriptorFactory(je,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return gt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?gt.startDebugging(re,ue,{parentSession:Oe}):gt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return gt.asDebugSourceUri(re,ue)}},Oi={registerTaskProvider:(re,ue)=>yt.registerTaskProvider(je,re,ue),fetchTasks:re=>yt.fetchTasks(re),executeTask:re=>yt.executeTask(je,re),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(re,ue,Oe)=>yt.onDidStartTask(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>yt.onDidEndTask(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>yt.onDidStartTaskProcess(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>yt.onDidEndTaskProcess(re,ue,Oe)},ji={createNotebookController(re,ue,Oe,st,vt){return ai.createNotebookController(je,re,ue,Oe,st,(0,Xe.$jF)(je,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>St.registerNotebookCellStatusBarItemProvider(je,re,ue),createRendererMessaging(re){return Si.createRendererMessaging(je,re)},createNotebookControllerDetectionTask(re){return(0,Xe.$kF)(je,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(je,re)},registerKernelSourceActionProvider(re,ue){return(0,Xe.$kF)(je,"notebookKernelSource"),ai.registerKernelSourceActionProvider(je,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Xe.$kF)(je,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(re,ue,Oe)}},zi={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(je.identifier.value,{message:ue,args:Oe})}return bt.getMessage(je.identifier.value,re[0])},get bundle(){return bt.getBundle(je.identifier.value)},get uri(){return bt.getBundleUri(je.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Xe.$kF)(je,"interactive"),Ji.registerProvider(je,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Xe.$kF)(je,"interactive"),gi.registerChatProvider(je,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Xe.$kF)(je,"interactive"),gi.sendInteractiveRequestToProvider(re,ue)},get onDidPerformUserAction(){return(0,Xe.$kF)(je,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(re,ue){return(0,Xe.$kF)(je,"interactive"),gi.transferChatSession(re,ue)}},Bi={getRelatedInformation(re,ue){return(0,Xe.$kF)(je,"aiRelatedInformation"),Yi.getRelatedInformation(je,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Xe.$kF)(je,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(je,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Xe.$kF)(je,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(je,re,ue)}},gn={registerChatResponseProvider(re,ue,Oe){return(0,Xe.$kF)(je,"chatProvider"),fi.registerProvider(je.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Xe.$kF)(je,"chatRequestAccess"),fi.requestChatResponseProvider(je.identifier,re)},registerVariable(re,ue,Oe){return(0,Xe.$kF)(je,"chatVariables"),Zi.registerVariableResolver(je,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Xe.$kF)(je,"mappedEditsProvider"),lt.registerMappedEditsProvider(je,re,ue)},createChatAgent(re,ue){return(0,Xe.$kF)(je,"chatAgents2"),Qi.createChatAgent(je,re,ue)}},mn={registerSpeechProvider(re,ue){return(0,Xe.$kF)(je,"speech"),wi.registerProvider(je.identifier,re,ue)}};return{version:mt.version,ai:Bi,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:ki,l10n:zi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Oi,tests:en,window:rn,workspace:sn,Breakpoint:Ne.$NL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$FM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$EM,CallHierarchyIncomingCall:Ne.$aL,CallHierarchyItem:Ne.$_K,CallHierarchyOutgoingCall:Ne.$bL,CancellationError:T.$5,CancellationTokenSource:E.$3d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$9K,CodeActionKind:Ne.$0K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$cL,Color:Ne.$pL,ColorInformation:Ne.$qL,ColorPresentation:Ne.$rL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$jL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$kL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$zL,DebugAdapterExecutable:Ne.$RL,DebugAdapterInlineImplementation:Ne.$UL,DebugAdapterNamedPipeServer:Ne.$TL,DebugAdapterServer:Ne.$SL,DebugConfigurationProviderTriggerKind:Ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$3K,DiagnosticRelatedInformation:Ne.$2K,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$OK,DocumentHighlight:Ne.$5K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$6K,DocumentLink:Ne.$oL,DocumentSymbol:Ne.$8K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$XL,InlineValueText:Ne.$YL,InlineValueVariableLookup:Ne.$ZL,InlineValueEvaluatableExpression:Ne.$1L,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$$L,FileDecoration2:Ne.$$L,FileSystemError:Ne.$3L,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$4L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$PL,InlineCompletionItem:Ne.$lL,InlineCompletionList:Ne.$mL,Hover:Ne.$4K,IndentAction:S.IndentAction,Location:Ne.$1K,MarkdownString:Ne.$dL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$eL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$PK,ProcessExecution:Ne.$xL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$0L,Range:Ne.$QK,RelativePattern:Ne.$LL,Selection:Ne.$RK,SelectionRange:Ne.$$K,SemanticTokens:Ne.$7L,SemanticTokensBuilder:Ne.$6L,SemanticTokensEdit:Ne.$8L,SemanticTokensEdits:Ne.$9L,SemanticTokensLegend:Ne.$5L,ShellExecution:Ne.$yL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$gL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$fL,SnippetString:Ne.$ZK,SourceBreakpoint:Ne.$OL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$7K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$AL,TaskGroup:Ne.$wL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$sL,TerminalQuickFixTerminalCommand:Ne.$uL,TerminalQuickFixOpener:Ne.$tL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$vL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$VK,SnippetTextEdit:Ne.$XK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$KL,ThemeIcon:Ne.$JL,TreeItem:Ne.$BL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$tM,UIKind:Ct.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$YK,DocumentDropEdit:Ne.$HL,DocumentPasteEdit:Ne.$IL,InlayHint:Ne.$iL,InlayHintLabelPart:Ne.$hL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$UK,ResolvedAuthority:Ne.$SK,ManagedResolvedAuthority:Ne.$TK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$iM,NotebookRange:Ne.$aM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$bM,NotebookData:Ne.$cM,NotebookRendererScript:Ne.$gM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$eM,NotebookCellOutputItem:Ne.$dM,NotebookCellStatusBarItem:Ne.$fM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$WK,NotebookKernelSourceAction:Ne.$hM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$kM,LinkedEditingRanges:Ne.$jM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$lM,TestMessage:Ne.$mM,TestMessage2:Ne.$mM,TestTag:Ne.$nM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Ne.$GL,DataTransferItem:Ne.$CL,CoveredCount:Ne.$oM,FileCoverage:Ne.$pM,StatementCoverage:Ne.$qM,BranchCoverage:Ne.$rM,FunctionCoverage:Ne.$sM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$uM,TabInputTextDiff:Ne.$vM,TabInputTextMerge:Ne.$wM,TabInputCustom:Ne.$xM,TabInputNotebook:Ne.$zM,TabInputNotebookDiff:Ne.$AM,TabInputWebview:Ne.$yM,TabInputTerminal:Ne.$BM,TabInputInteractiveWindow:Ne.$CM,TabInputChat:Ne.$DM,TelemetryTrustedValue:t.$wo,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$VL,ThreadFocus:Ne.$WL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$_gc=Gt}),define(Pe[291],Ae([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(me,e,E,T,I,M,A,m,g,w,R,S,l,$,v,n,o,t,r,a,c,h,i,s,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Jr)(d.$1fc,d.$Zfc,1),(0,E.$Jr)(s.$kj,i.$ahc,1),(0,E.$Jr)(n.$_ec,n.$afc,1),(0,E.$Jr)(m.$aN,m.$_M,0),(0,E.$Jr)(A.$ufc,A.$sfc,0),(0,E.$Jr)(t.$wfc,t.$vfc,0),(0,E.$Jr)(S.$$fc,S.$cgc,0),(0,E.$Jr)(M.$egc,M.$dgc,0),(0,E.$Jr)(g.$2M,g.$1M,0),(0,E.$Jr)(b.$2fc,b.$3fc,0),(0,E.$Jr)(r.$9ec,r.$8ec,0),(0,E.$Jr)(T.$Kgc,T.$Jgc,1),(0,E.$Jr)(l.$ugc,l.$vgc,0),(0,E.$Jr)($.$Pfc,$.$Ofc,0),(0,E.$Jr)(R.$Xgc,R.$Wgc,0),(0,E.$Jr)(w.$Sfc,w.$Vfc,0),(0,E.$Jr)(v.$9xb,v.$0xb,0),(0,E.$Jr)(o.$$gc,o.$0gc,0),(0,E.$Jr)(I.$rfc,I.$qfc,0),(0,E.$Jr)(a.$Xfc,a.$Wfc,0),(0,E.$Jr)(c.$$M,c.$8M,0),(0,E.$Jr)(h.$Gfc,h.$Hfc,0),(0,E.$Jr)(u.$9fc,u.$0fc,0)}),define(Pe[292],Ae([1,0,290,38,2,287,7,14,275]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class w extends M.$dhc{j(){}getModule($,v){for(const n of this.b){const o=n($);if(o){$=o;break}}if(this.a.has($))return this.a.get($).load($,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.$5fc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$jjc);const $=this.h.invokeFunction(E.$_gc);this.r=this.h.createInstance(w,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,v,n){v=v.with({path:S(v.path,".js")});const o=$?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=I.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const a=await r.text(),c=`${v.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}$&&await this.w.initializeLocalizedMessages($);const s={},u={exports:s},d=b=>{const f=this.r.getModule(b,v);if(f===void 0)throw new Error(`Cannot load module '${b}'`);return f};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+$;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,m.$3g)(10)}}e.$kjc=R;function S(l,$){return l.endsWith($)?l:l+$}}),define(Pe[293],Ae([1,0,69,70,15,38,200,86,292]),function(me,e,E,T,I,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Jr)(I.$jj,new E.$Yh(A.$chc,[!0],!0)),(0,T.$Jr)(M.$6fc,g.$kjc,0),(0,T.$Jr)(m.$xfc,m.$yfc,0)}),define(Pe[298],Ae([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(me,e,E,T,I,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(i){return/^(file|vscode-remote):/i.test(i)}const v=fetch.bind(self);function n(i){self.fetch=async function(s,u){return s instanceof Request||$(String(s))&&(s=(await i(R.URI.parse(String(s)))).toString(!0)),v(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,b,f){(async()=>($(u.toString())&&(u=(await i(R.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,b,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$kg.uriToBrowserUri(R.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(p){function y(K){return typeof K=="string"||K instanceof URL?String(K).replace(/^file:\/\//i,"vscode-file://vscode-app"):K}const k=fetch.bind(self);self.fetch=function(K,U){return K instanceof Request?k(K,U):k(y(K),U)},self.XMLHttpRequest=class extends XMLHttpRequest{open(K,U,L,z,C){return super.open(K,y(U),L??!0,z,C)}};const O=importScripts.bind(self);self.importScripts=(...K)=>{O(...K.map(y))},O(p)}.toString()}('${s}'))`;u=u||{},u.name=u.name||m.$nc(s.toString());const f=new Blob([b],{type:"application/javascript"}),D=URL.createObjectURL(f);return new i(D,u)}}else self.Worker=class extends A.$ljc{constructor(i,s){super(l,i,{name:m.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const s=new MessageChannel,u=new T.$Sd;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=b=>{const{data:f}=b;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const D=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$pm)(D,2)){d=!0,a("received terminate message from renderer");return}u.fire(D)},this.protocol={onMessage:u.event,send:b=>{if(!d){const f=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function r(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const b=JSON.parse(d.toString());i.send((0,I.$om)(0)),s({protocol:i,initData:b})});i.send((0,I.$om)(1))})}let a=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&r(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new M.$fhc(u.protocol,u.initData,o,null,s.data);n(b=>d.asBrowserUri(b)),a=b=>d.terminate(b)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4ded39cfd580476a8f97303ce24848a7710b3427/core/vs/workbench/api/worker/extensionHostWorker.js.map
